/*===========================================================================*/
/*   (Ast/shrinkify.scm)                                                     */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/shrinkify.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_forzd2eachzd2globalz12z12zzast_envz00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2conditi1259z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt);
	static obj_t BGl_z62shrinkzd2nodez12zd2funcall1251z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t);
	static obj_t BGl_methodzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2sync1245z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2boxzd2ref1267za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2fail1261z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkifyz12z70zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2variablez121232za2zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2makezd2bo1265za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2app1247z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2letzd2fun1272za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t
		BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt);
	static obj_t BGl_z62shrinkzd2nodez121234za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2appzd2ly1249za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2select1263z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 = BUNSPEC;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_z62shrinkzd2nodez12zd2extern1253z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_genericzd2initzd2zzast_shrinkifyz00();
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2kwote1241z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2setzd2exzd21276z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2cast1255z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2setq1257z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2letzd2var1274za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t
		BGl_z62shrinkzd2nodez12zd2boxzd2set1270za2zzast_shrinkifyz00(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t BGl_z62shrinkzd2nodez12zd2sequenc1243z70zzast_shrinkifyz00(obj_t,
		obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2var1239z70zzast_shrinkifyz00(obj_t,
		obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t
		BGl_z62shrinkzd2nodez12zd2jumpzd2ex1278za2zzast_shrinkifyz00(obj_t, obj_t);
	static obj_t BGl_z62shrinkzd2nodez12zd2atom1237z70zzast_shrinkifyz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[1];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_shrinkifyz12zd2envzc0zzast_shrinkifyz00,
		BgL_bgl_za762shrinkifyza712za71822za7,
		BGl_z62shrinkifyz12z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1817z00zzast_shrinkifyz00,
		BgL_bgl_string1817za700za7za7a1823za7, "ast_shrinkify", 13);
	      DEFINE_STRING(BGl_string1818z00zzast_shrinkifyz00,
		BgL_bgl_string1818za700za7za7a1824za7, "shrink-node!1234 ", 17);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2vari1825z00,
		BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1790z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2vari1826z00,
		BGl_z62shrinkzd2variablez121232za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1792z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1827z00,
		BGl_z62shrinkzd2nodez121234za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1795z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1828z00,
		BGl_z62shrinkzd2nodez12zd2atom1237z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1797z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1829z00,
		BGl_z62shrinkzd2nodez12zd2var1239z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1798z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1830z00,
		BGl_z62shrinkzd2nodez12zd2kwote1241z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1799z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1831z00,
		BGl_z62shrinkzd2nodez12zd2sequenc1243z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1800z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1832z00,
		BGl_z62shrinkzd2nodez12zd2sync1245z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1801z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1833z00,
		BGl_z62shrinkzd2nodez12zd2app1247z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1802z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1834z00,
		BGl_z62shrinkzd2nodez12zd2appzd2ly1249za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1803z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1835z00,
		BGl_z62shrinkzd2nodez12zd2funcall1251z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1804z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1836z00,
		BGl_z62shrinkzd2nodez12zd2extern1253z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1805z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1837z00,
		BGl_z62shrinkzd2nodez12zd2cast1255z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1806z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1838z00,
		BGl_z62shrinkzd2nodez12zd2setq1257z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1807z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1839z00,
		BGl_z62shrinkzd2nodez12zd2conditi1259z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1808z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1840z00,
		BGl_z62shrinkzd2nodez12zd2fail1261z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1809z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1841z00,
		BGl_z62shrinkzd2nodez12zd2select1263z70zzast_shrinkifyz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1810z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1842z00,
		BGl_z62shrinkzd2nodez12zd2makezd2bo1265za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1811z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1843z00,
		BGl_z62shrinkzd2nodez12zd2boxzd2ref1267za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1812z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1844z00,
		BGl_z62shrinkzd2nodez12zd2boxzd2set1270za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1813z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1845z00,
		BGl_z62shrinkzd2nodez12zd2letzd2fun1272za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1814z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1846z00,
		BGl_z62shrinkzd2nodez12zd2letzd2var1274za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1815z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1847z00,
		BGl_z62shrinkzd2nodez12zd2setzd2exzd21276z70zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc1816z00zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1848z00,
		BGl_z62shrinkzd2nodez12zd2jumpzd2ex1278za2zzast_shrinkifyz00, 0L, BUNSPEC,
		1);
	      DEFINE_STRING(BGl_string1791z00zzast_shrinkifyz00,
		BgL_bgl_string1791za700za7za7a1849za7, "shrink-variable!1232", 20);
	      DEFINE_STRING(BGl_string1793z00zzast_shrinkifyz00,
		BgL_bgl_string1793za700za7za7a1850za7, "shrink-node!1234", 16);
	      DEFINE_STRING(BGl_string1794z00zzast_shrinkifyz00,
		BgL_bgl_string1794za700za7za7a1851za7, "No method for this object", 25);
	      DEFINE_STRING(BGl_string1796z00zzast_shrinkifyz00,
		BgL_bgl_string1796za700za7za7a1852za7, "shrink-node!", 12);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
		BgL_bgl_za762shrinkza7d2node1853z00,
		BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00, 0L, BUNSPEC, 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_shrinkifyz00(long
		BgL_checksumz00_1989, char *BgL_fromz00_1990)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_shrinkifyz00))
				{
					BGl_requirezd2initializa7ationz75zzast_shrinkifyz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_cnstzd2initzd2zzast_shrinkifyz00();
					BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00();
					BGl_genericzd2initzd2zzast_shrinkifyz00();
					BGl_methodzd2initzd2zzast_shrinkifyz00();
					return BGl_toplevelzd2initzd2zzast_shrinkifyz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_shrinkify");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_shrinkify");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			{	/* Ast/shrinkify.scm 15 */
				obj_t BgL_cportz00_1973;

				{	/* Ast/shrinkify.scm 15 */
					obj_t BgL_startz00_1982;

					BgL_startz00_1982 = BINT(((long) 0));
					{	/* Ast/shrinkify.scm 15 */
						obj_t BgL_endz00_1983;

						BgL_endz00_1983 =
							BINT(STRING_LENGTH(BGl_string1818z00zzast_shrinkifyz00));
						{	/* Ast/shrinkify.scm 15 */

							BgL_cportz00_1973 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string1818z00zzast_shrinkifyz00, BgL_startz00_1982,
								BgL_endz00_1983);
				}}}
				{
					long BgL_iz00_1974;

					BgL_iz00_1974 = ((long) 0);
				BgL_loopz00_1975:
					if ((BgL_iz00_1974 == ((long) -1)))
						{	/* Ast/shrinkify.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Ast/shrinkify.scm 15 */
							{	/* Ast/shrinkify.scm 15 */
								obj_t BgL_arg1820z00_1977;

								{	/* Ast/shrinkify.scm 15 */

									{	/* Ast/shrinkify.scm 15 */
										obj_t BgL_locationz00_1979;

										BgL_locationz00_1979 = BBOOL(((bool_t) 0));
										{	/* Ast/shrinkify.scm 15 */

											BgL_arg1820z00_1977 =
												BGl_readz00zz__readerz00(BgL_cportz00_1973,
												BgL_locationz00_1979);
										}
									}
								}
								{	/* Ast/shrinkify.scm 15 */
									int BgL_auxz00_2016;

									BgL_auxz00_2016 = (int) (BgL_iz00_1974);
									CNST_TABLE_SET(BgL_auxz00_2016, BgL_arg1820z00_1977);
							}}
							{	/* Ast/shrinkify.scm 15 */
								int BgL_auxz00_1980;

								BgL_auxz00_1980 = (int) ((BgL_iz00_1974 - ((long) 1)));
								{
									long BgL_iz00_2021;

									BgL_iz00_2021 = (long) (BgL_auxz00_1980);
									BgL_iz00_1974 = BgL_iz00_2021;
									goto BgL_loopz00_1975;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}
	}



/* shrinkify! */
	BGL_EXPORTED_DEF obj_t BGl_shrinkifyz12z12zzast_shrinkifyz00(obj_t
		BgL_globalsz00_3)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			BGl_forzd2eachzd2globalz12z12zzast_envz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00, BNIL);
			{
				obj_t BgL_l1216z00_1235;

				BgL_l1216z00_1235 = BgL_globalsz00_3;
			BgL_zc3anonymousza31318ze3z83_1236:
				if (PAIRP(BgL_l1216z00_1235))
					{	/* Ast/shrinkify.scm 27 */
						{	/* Ast/shrinkify.scm 28 */
							obj_t BgL_globalz00_1238;

							BgL_globalz00_1238 = CAR(BgL_l1216z00_1235);
							{	/* Ast/shrinkify.scm 28 */
								BgL_valuez00_bglt BgL_sfunz00_1239;

								BgL_sfunz00_1239 =
									(((BgL_variablez00_bglt) CREF(
											((BgL_variablez00_bglt)
												((BgL_globalz00_bglt) BgL_globalz00_1238))))->
									BgL_valuez00);
								{	/* Ast/shrinkify.scm 29 */
									obj_t BgL_g1215z00_1240;

									BgL_g1215z00_1240 =
										(((BgL_sfunz00_bglt) CREF(
												((BgL_sfunz00_bglt) BgL_sfunz00_1239)))->BgL_argsz00);
									{
										obj_t BgL_l1213z00_1242;

										BgL_l1213z00_1242 = BgL_g1215z00_1240;
									BgL_zc3anonymousza31320ze3z83_1243:
										if (PAIRP(BgL_l1213z00_1242))
											{	/* Ast/shrinkify.scm 29 */
												{	/* Ast/shrinkify.scm 29 */
													obj_t BgL_arg1328z00_1245;

													BgL_arg1328z00_1245 = CAR(BgL_l1213z00_1242);
													BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
														((BgL_variablez00_bglt) BgL_arg1328z00_1245));
												}
												{
													obj_t BgL_l1213z00_2037;

													BgL_l1213z00_2037 = CDR(BgL_l1213z00_1242);
													BgL_l1213z00_1242 = BgL_l1213z00_2037;
													goto BgL_zc3anonymousza31320ze3z83_1243;
												}
											}
										else
											{	/* Ast/shrinkify.scm 29 */
												((bool_t) 1);
											}
									}
								}
								{	/* Ast/shrinkify.scm 30 */
									obj_t BgL_arg1335z00_1248;

									BgL_arg1335z00_1248 =
										(((BgL_sfunz00_bglt) CREF(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) CREF(
																((BgL_variablez00_bglt)
																	((BgL_globalz00_bglt) BgL_globalz00_1238))))->
														BgL_valuez00))))->BgL_bodyz00);
									BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(((BgL_nodez00_bglt)
											BgL_arg1335z00_1248));
								}
							}
						}
						{
							obj_t BgL_l1216z00_2046;

							BgL_l1216z00_2046 = CDR(BgL_l1216z00_1235);
							BgL_l1216z00_1235 = BgL_l1216z00_2046;
							goto BgL_zc3anonymousza31318ze3z83_1236;
						}
					}
				else
					{	/* Ast/shrinkify.scm 27 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_3;
		}
	}



/* &shrinkify! */
	obj_t BGl_z62shrinkifyz12z70zzast_shrinkifyz00(obj_t BgL_envz00_1897,
		obj_t BgL_globalsz00_1898)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 25 */
			return BGl_shrinkifyz12z12zzast_shrinkifyz00(BgL_globalsz00_1898);
		}
	}



/* shrink-node*! */
	bool_t BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(obj_t BgL_nodeza2za2_27)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 230 */
			{
				obj_t BgL_l1230z00_1253;

				BgL_l1230z00_1253 = BgL_nodeza2za2_27;
			BgL_zc3anonymousza31361ze3z83_1254:
				if (PAIRP(BgL_l1230z00_1253))
					{	/* Ast/shrinkify.scm 231 */
						{	/* Ast/shrinkify.scm 231 */
							obj_t BgL_arg1366z00_1256;

							BgL_arg1366z00_1256 = CAR(BgL_l1230z00_1253);
							BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
								((BgL_nodez00_bglt) BgL_arg1366z00_1256));
						}
						{
							obj_t BgL_l1230z00_2054;

							BgL_l1230z00_2054 = CDR(BgL_l1230z00_1253);
							BgL_l1230z00_1253 = BgL_l1230z00_2054;
							goto BgL_zc3anonymousza31361ze3z83_1254;
						}
					}
				else
					{	/* Ast/shrinkify.scm 231 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
				BGl_proc1790z00zzast_shrinkifyz00, BGl_variablez00zzast_varz00,
				BGl_string1791z00zzast_shrinkifyz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_proc1792z00zzast_shrinkifyz00, BGl_nodez00zzast_nodez00,
				BGl_string1793z00zzast_shrinkifyz00);
		}
	}



/* &shrink-node!1234 */
	obj_t BGl_z62shrinkzd2nodez121234za2zzast_shrinkifyz00(obj_t BgL_envz00_1903,
		obj_t BgL_nodez00_1904)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			{
				BgL_nodez00_bglt BgL_nodez00_1275;

				BgL_nodez00_1275 = ((BgL_nodez00_bglt) BgL_nodez00_1904);
				return
					BGl_errorz00zz__errorz00(CNST_TABLE_REF(((long) 0)),
					BGl_string1794z00zzast_shrinkifyz00, ((obj_t) BgL_nodez00_1275));
		}}
	}



/* &shrink-variable!1232 */
	obj_t BGl_z62shrinkzd2variablez121232za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1905, obj_t BgL_variablez00_1906)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			{
				BgL_variablez00_bglt BgL_variablez00_1260;

				BgL_variablez00_1260 = ((BgL_variablez00_bglt) BgL_variablez00_1906);
				{	/* Ast/shrinkify.scm 38 */
					bool_t BgL_testz00_2062;

					{	/* Ast/shrinkify.scm 38 */
						bool_t BgL_testz00_2063;

						{	/* Ast/shrinkify.scm 38 */
							obj_t BgL_auxz00_2064;

							{	/* Ast/shrinkify.scm 38 */
								BgL_objectz00_bglt BgL_auxz00_2065;

								BgL_auxz00_2065 = ((BgL_objectz00_bglt) BgL_variablez00_1260);
								BgL_auxz00_2064 = BGL_OBJECT_WIDENING(BgL_auxz00_2065);
							}
							BgL_testz00_2063 = CBOOL(BgL_auxz00_2064);
						}
						if (BgL_testz00_2063)
							{	/* Ast/shrinkify.scm 38 */
								BgL_testz00_2062 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 38 */
								BgL_testz00_2062 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2062)
						{	/* Ast/shrinkify.scm 38 */
							{	/* Ast/shrinkify.scm 39 */
								long BgL_arg1374z00_1264;

								{	/* Ast/shrinkify.scm 39 */
									obj_t BgL_arg1378z00_1265;

									{	/* Ast/shrinkify.scm 39 */
										obj_t BgL_arg1379z00_1266;

										{	/* Ast/shrinkify.scm 39 */
											long BgL_arg1667z00_1636;

											{	/* Ast/shrinkify.scm 39 */
												long BgL_arg1668z00_1637;

												{	/* Ast/shrinkify.scm 39 */
													long BgL_res1737z00_1639;

													BgL_res1737z00_1639 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_variablez00_1260));
													BgL_arg1668z00_1637 = BgL_res1737z00_1639;
												}
												BgL_arg1667z00_1636 =
													(BgL_arg1668z00_1637 - OBJECT_TYPE);
											}
											BgL_arg1379z00_1266 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1636));
										}
										BgL_arg1378z00_1265 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1379z00_1266);
									}
									{	/* Ast/shrinkify.scm 39 */
										long BgL_res1739z00_1646;

										BgL_res1739z00_1646 = BGL_CLASS_INDEX(BgL_arg1378z00_1265);
										BgL_arg1374z00_1264 = BgL_res1739z00_1646;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_variablez00_1260),
									BgL_arg1374z00_1264);
							}
							{	/* Ast/shrinkify.scm 39 */
								BgL_objectz00_bglt BgL_auxz00_2078;

								BgL_auxz00_2078 = ((BgL_objectz00_bglt) BgL_variablez00_1260);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2078, BFALSE);
							}
							((obj_t) BgL_variablez00_1260);
						}
					else
						{	/* Ast/shrinkify.scm 38 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 40 */
					bool_t BgL_testz00_2082;

					{	/* Ast/shrinkify.scm 40 */
						bool_t BgL_testz00_2083;

						{	/* Ast/shrinkify.scm 40 */
							obj_t BgL_auxz00_2084;

							{	/* Ast/shrinkify.scm 40 */
								BgL_objectz00_bglt BgL_auxz00_2085;

								BgL_auxz00_2085 =
									((BgL_objectz00_bglt)
									(((BgL_variablez00_bglt) CREF(BgL_variablez00_1260))->
										BgL_valuez00));
								BgL_auxz00_2084 = BGL_OBJECT_WIDENING(BgL_auxz00_2085);
							}
							BgL_testz00_2083 = CBOOL(BgL_auxz00_2084);
						}
						if (BgL_testz00_2083)
							{	/* Ast/shrinkify.scm 40 */
								BgL_testz00_2082 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 40 */
								BgL_testz00_2082 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2082)
						{	/* Ast/shrinkify.scm 41 */
							BgL_valuez00_bglt BgL_o1096z00_1268;

							BgL_o1096z00_1268 =
								(((BgL_variablez00_bglt) CREF(BgL_variablez00_1260))->
								BgL_valuez00);
							{	/* Ast/shrinkify.scm 41 */
								long BgL_arg1385z00_1269;

								{	/* Ast/shrinkify.scm 41 */
									obj_t BgL_arg1386z00_1270;

									{	/* Ast/shrinkify.scm 41 */
										obj_t BgL_arg1398z00_1271;

										{	/* Ast/shrinkify.scm 41 */
											long BgL_arg1667z00_1655;

											{	/* Ast/shrinkify.scm 41 */
												long BgL_arg1668z00_1656;

												{	/* Ast/shrinkify.scm 41 */
													long BgL_res1741z00_1658;

													BgL_res1741z00_1658 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_o1096z00_1268));
													BgL_arg1668z00_1656 = BgL_res1741z00_1658;
												}
												BgL_arg1667z00_1655 =
													(BgL_arg1668z00_1656 - OBJECT_TYPE);
											}
											BgL_arg1398z00_1271 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1655));
										}
										BgL_arg1386z00_1270 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1398z00_1271);
									}
									{	/* Ast/shrinkify.scm 41 */
										long BgL_res1743z00_1665;

										BgL_res1743z00_1665 = BGL_CLASS_INDEX(BgL_arg1386z00_1270);
										BgL_arg1385z00_1269 = BgL_res1743z00_1665;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_o1096z00_1268),
									BgL_arg1385z00_1269);
							}
							{	/* Ast/shrinkify.scm 41 */
								BgL_objectz00_bglt BgL_auxz00_2100;

								BgL_auxz00_2100 = ((BgL_objectz00_bglt) BgL_o1096z00_1268);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2100, BFALSE);
							}
							return ((obj_t) BgL_o1096z00_1268);
						}
					else
						{	/* Ast/shrinkify.scm 40 */
							return BFALSE;
						}
				}
			}
		}
	}



/* shrink-variable! */
	obj_t BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(BgL_variablez00_bglt
		BgL_variablez00_4)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			{	/* Ast/shrinkify.scm 37 */
				obj_t BgL_method1233z00_1278;

				{	/* Ast/shrinkify.scm 37 */
					obj_t BgL_res1750z00_1696;

					{	/* Ast/shrinkify.scm 37 */
						long BgL_objzd2classzd2numz00_1669;

						{	/* Ast/shrinkify.scm 37 */
							long BgL_res1744z00_1672;

							BgL_res1744z00_1672 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_variablez00_4));
							BgL_objzd2classzd2numz00_1669 = BgL_res1744z00_1672;
						}
						{	/* Ast/shrinkify.scm 37 */
							obj_t BgL_arg1664z00_1670;

							BgL_arg1664z00_1670 =
								PROCEDURE_REF
								(BGl_shrinkzd2variablez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 37 */
								int BgL_offsetz00_1674;

								BgL_offsetz00_1674 = (int) (BgL_objzd2classzd2numz00_1669);
								{	/* Ast/shrinkify.scm 37 */
									long BgL_offsetz00_1675;

									BgL_offsetz00_1675 =
										((long) (BgL_offsetz00_1674) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 37 */
										long BgL_modz00_1676;

										{	/* Ast/shrinkify.scm 37 */
											int BgL_arg1666z00_1677;

											BgL_arg1666z00_1677 = (int) (((long) 16));
											{	/* Ast/shrinkify.scm 37 */
												long BgL_res1747z00_1687;

												{	/* Ast/shrinkify.scm 37 */
													long BgL_auxz00_2113;

													BgL_auxz00_2113 = (long) (BgL_arg1666z00_1677);
													BgL_res1747z00_1687 =
														(BgL_offsetz00_1675 / BgL_auxz00_2113);
												}
												BgL_modz00_1676 = BgL_res1747z00_1687;
										}}
										{	/* Ast/shrinkify.scm 37 */
											long BgL_restz00_1678;

											{	/* Ast/shrinkify.scm 37 */
												int BgL_arg1665z00_1679;

												BgL_arg1665z00_1679 = (int) (((long) 16));
												{	/* Ast/shrinkify.scm 37 */
													long BgL_res1749z00_1691;

													{	/* Ast/shrinkify.scm 37 */
														long BgL_auxz00_2117;

														BgL_auxz00_2117 = (long) (BgL_arg1665z00_1679);
														BgL_res1749z00_1691 =
															(BgL_offsetz00_1675 % BgL_auxz00_2117);
													}
													BgL_restz00_1678 = BgL_res1749z00_1691;
											}}
											{	/* Ast/shrinkify.scm 37 */

												BgL_res1750z00_1696 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_1670,
														(int) (BgL_modz00_1676)), (int) (BgL_restz00_1678));
					}}}}}}}
					BgL_method1233z00_1278 = BgL_res1750z00_1696;
				}
				return
					PROCEDURE_ENTRY(BgL_method1233z00_1278) (BgL_method1233z00_1278,
					((obj_t) BgL_variablez00_4), BEOA);
			}
		}
	}



/* &shrink-variable! */
	obj_t BGl_z62shrinkzd2variablez12za2zzast_shrinkifyz00(obj_t BgL_envz00_1899,
		obj_t BgL_variablez00_1900)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 37 */
			return
				BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
				((BgL_variablez00_bglt) BgL_variablez00_1900));
		}
	}



/* shrink-node! */
	obj_t BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			{	/* Ast/shrinkify.scm 46 */
				obj_t BgL_method1235z00_1279;

				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_res1757z00_1725;

					{	/* Ast/shrinkify.scm 46 */
						long BgL_objzd2classzd2numz00_1698;

						{	/* Ast/shrinkify.scm 46 */
							long BgL_res1751z00_1701;

							BgL_res1751z00_1701 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
							BgL_objzd2classzd2numz00_1698 = BgL_res1751z00_1701;
						}
						{	/* Ast/shrinkify.scm 46 */
							obj_t BgL_arg1664z00_1699;

							BgL_arg1664z00_1699 =
								PROCEDURE_REF(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
								(int) (((long) 1)));
							{	/* Ast/shrinkify.scm 46 */
								int BgL_offsetz00_1703;

								BgL_offsetz00_1703 = (int) (BgL_objzd2classzd2numz00_1698);
								{	/* Ast/shrinkify.scm 46 */
									long BgL_offsetz00_1704;

									BgL_offsetz00_1704 =
										((long) (BgL_offsetz00_1703) - OBJECT_TYPE);
									{	/* Ast/shrinkify.scm 46 */
										long BgL_modz00_1705;

										{	/* Ast/shrinkify.scm 46 */
											int BgL_arg1666z00_1706;

											BgL_arg1666z00_1706 = (int) (((long) 16));
											{	/* Ast/shrinkify.scm 46 */
												long BgL_res1754z00_1716;

												{	/* Ast/shrinkify.scm 46 */
													long BgL_auxz00_2139;

													BgL_auxz00_2139 = (long) (BgL_arg1666z00_1706);
													BgL_res1754z00_1716 =
														(BgL_offsetz00_1704 / BgL_auxz00_2139);
												}
												BgL_modz00_1705 = BgL_res1754z00_1716;
										}}
										{	/* Ast/shrinkify.scm 46 */
											long BgL_restz00_1707;

											{	/* Ast/shrinkify.scm 46 */
												int BgL_arg1665z00_1708;

												BgL_arg1665z00_1708 = (int) (((long) 16));
												{	/* Ast/shrinkify.scm 46 */
													long BgL_res1756z00_1720;

													{	/* Ast/shrinkify.scm 46 */
														long BgL_auxz00_2143;

														BgL_auxz00_2143 = (long) (BgL_arg1665z00_1708);
														BgL_res1756z00_1720 =
															(BgL_offsetz00_1704 % BgL_auxz00_2143);
													}
													BgL_restz00_1707 = BgL_res1756z00_1720;
											}}
											{	/* Ast/shrinkify.scm 46 */

												BgL_res1757z00_1725 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_1699,
														(int) (BgL_modz00_1705)), (int) (BgL_restz00_1707));
					}}}}}}}
					BgL_method1235z00_1279 = BgL_res1757z00_1725;
				}
				{	/* Ast/shrinkify.scm 46 */
					obj_t BgL_xz00_1972;

					BgL_xz00_1972 =
						PROCEDURE_ENTRY(BgL_method1235z00_1279) (BgL_method1235z00_1279,
						((obj_t) BgL_nodez00_5), BEOA);
					return BUNSPEC;
				}
			}
		}
	}



/* &shrink-node! */
	obj_t BGl_z62shrinkzd2nodez12za2zzast_shrinkifyz00(obj_t BgL_envz00_1907,
		obj_t BgL_nodez00_1908)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 46 */
			return
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
				((BgL_nodez00_bglt) BgL_nodez00_1908));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_atomz00zzast_nodez00, BGl_proc1795z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_varz00zzast_nodez00, BGl_proc1797z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_kwotez00zzast_nodez00, BGl_proc1798z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_sequencez00zzast_nodez00, BGl_proc1799z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_syncz00zzast_nodez00, BGl_proc1800z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appz00zzast_nodez00, BGl_proc1801z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc1802z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_funcallz00zzast_nodez00, BGl_proc1803z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_externz00zzast_nodez00, BGl_proc1804z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_castz00zzast_nodez00, BGl_proc1805z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setqz00zzast_nodez00, BGl_proc1806z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc1807z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_failz00zzast_nodez00, BGl_proc1808z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_selectz00zzast_nodez00, BGl_proc1809z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc1810z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc1811z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc1812z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc1813z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc1814z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc1815z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_shrinkzd2nodez12zd2envz12zzast_shrinkifyz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc1816z00zzast_shrinkifyz00,
				BGl_string1796z00zzast_shrinkifyz00);
		}
	}



/* &shrink-node!-jump-ex1278 */
	obj_t BGl_z62shrinkzd2nodez12zd2jumpzd2ex1278za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1930, obj_t BgL_nodez00_1931)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 222 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1463;

				BgL_nodez00_1463 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_1931);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1463))->BgL_exitz00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1463))->
						BgL_valuez00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-set-ex-1276 */
	obj_t BGl_z62shrinkzd2nodez12zd2setzd2exzd21276z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1932, obj_t BgL_nodez00_1933)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 213 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1456;

				BgL_nodez00_1456 = ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_1933);
				{	/* Ast/shrinkify.scm 215 */
					BgL_varz00_bglt BgL_arg1669z00_1460;

					BgL_arg1669z00_1460 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1456))->BgL_varz00);
					BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
						((BgL_nodez00_bglt) BgL_arg1669z00_1460));
				}
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1456))->BgL_bodyz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-let-var1274 */
	obj_t BGl_z62shrinkzd2nodez12zd2letzd2var1274za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1934, obj_t BgL_nodez00_1935)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 201 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1440;

				BgL_nodez00_1440 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_1935);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1440))->BgL_bodyz00));
				{	/* Ast/shrinkify.scm 204 */
					obj_t BgL_g1229z00_1445;

					BgL_g1229z00_1445 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1440))->BgL_bindingsz00);
					{
						obj_t BgL_l1227z00_1447;

						BgL_l1227z00_1447 = BgL_g1229z00_1445;
					BgL_zc3anonymousza31653ze3z83_1448:
						if (PAIRP(BgL_l1227z00_1447))
							{	/* Ast/shrinkify.scm 204 */
								{	/* Ast/shrinkify.scm 205 */
									obj_t BgL_bindingz00_1450;

									BgL_bindingz00_1450 = CAR(BgL_l1227z00_1447);
									{	/* Ast/shrinkify.scm 205 */
										obj_t BgL_arg1656z00_1451;

										BgL_arg1656z00_1451 = CAR(BgL_bindingz00_1450);
										BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
											((BgL_variablez00_bglt) BgL_arg1656z00_1451));
									}
									{	/* Ast/shrinkify.scm 206 */
										obj_t BgL_arg1657z00_1452;

										BgL_arg1657z00_1452 = CDR(BgL_bindingz00_1450);
										BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
											((BgL_nodez00_bglt) BgL_arg1657z00_1452));
									}
								}
								{
									obj_t BgL_l1227z00_2201;

									BgL_l1227z00_2201 = CDR(BgL_l1227z00_1447);
									BgL_l1227z00_1447 = BgL_l1227z00_2201;
									goto BgL_zc3anonymousza31653ze3z83_1448;
								}
							}
						else
							{	/* Ast/shrinkify.scm 204 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-let-fun1272 */
	obj_t BGl_z62shrinkzd2nodez12zd2letzd2fun1272za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1936, obj_t BgL_nodez00_1937)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 187 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1416;

				BgL_nodez00_1416 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_1937);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1416))->BgL_bodyz00));
				{	/* Ast/shrinkify.scm 190 */
					obj_t BgL_g1226z00_1421;

					BgL_g1226z00_1421 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1416))->BgL_localsz00);
					{
						obj_t BgL_l1224z00_1423;

						BgL_l1224z00_1423 = BgL_g1226z00_1421;
					BgL_zc3anonymousza31632ze3z83_1424:
						if (PAIRP(BgL_l1224z00_1423))
							{	/* Ast/shrinkify.scm 190 */
								{	/* Ast/shrinkify.scm 191 */
									obj_t BgL_localz00_1426;

									BgL_localz00_1426 = CAR(BgL_l1224z00_1423);
									{	/* Ast/shrinkify.scm 191 */
										BgL_valuez00_bglt BgL_sfunz00_1427;

										BgL_sfunz00_1427 =
											(((BgL_variablez00_bglt) CREF(
													((BgL_variablez00_bglt)
														((BgL_localz00_bglt) BgL_localz00_1426))))->
											BgL_valuez00);
										BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00((
												(BgL_variablez00_bglt) BgL_localz00_1426));
										{	/* Ast/shrinkify.scm 193 */
											obj_t BgL_g1223z00_1428;

											BgL_g1223z00_1428 =
												(((BgL_sfunz00_bglt) CREF(
														((BgL_sfunz00_bglt) BgL_sfunz00_1427)))->
												BgL_argsz00);
											{
												obj_t BgL_l1221z00_1430;

												BgL_l1221z00_1430 = BgL_g1223z00_1428;
											BgL_zc3anonymousza31635ze3z83_1431:
												if (PAIRP(BgL_l1221z00_1430))
													{	/* Ast/shrinkify.scm 193 */
														{	/* Ast/shrinkify.scm 193 */
															obj_t BgL_arg1643z00_1433;

															BgL_arg1643z00_1433 = CAR(BgL_l1221z00_1430);
															BGl_shrinkzd2variablez12zc0zzast_shrinkifyz00(
																((BgL_variablez00_bglt) BgL_arg1643z00_1433));
														}
														{
															obj_t BgL_l1221z00_2222;

															BgL_l1221z00_2222 = CDR(BgL_l1221z00_1430);
															BgL_l1221z00_1430 = BgL_l1221z00_2222;
															goto BgL_zc3anonymousza31635ze3z83_1431;
														}
													}
												else
													{	/* Ast/shrinkify.scm 193 */
														((bool_t) 1);
													}
											}
										}
										{	/* Ast/shrinkify.scm 194 */
											obj_t BgL_arg1647z00_1436;

											BgL_arg1647z00_1436 =
												(((BgL_sfunz00_bglt) CREF(
														((BgL_sfunz00_bglt) BgL_sfunz00_1427)))->
												BgL_bodyz00);
											BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00((
													(BgL_nodez00_bglt) BgL_arg1647z00_1436));
										}
									}
								}
								{
									obj_t BgL_l1224z00_2228;

									BgL_l1224z00_2228 = CDR(BgL_l1224z00_1423);
									BgL_l1224z00_1423 = BgL_l1224z00_2228;
									goto BgL_zc3anonymousza31632ze3z83_1424;
								}
							}
						else
							{	/* Ast/shrinkify.scm 190 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-box-set1270 */
	obj_t BGl_z62shrinkzd2nodez12zd2boxzd2set1270za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1938, obj_t BgL_nodez00_1939)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 178 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1405;

				BgL_nodez00_1405 = ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_1939);
				{	/* Ast/shrinkify.scm 179 */
					bool_t BgL_testz00_2231;

					{	/* Ast/shrinkify.scm 179 */
						bool_t BgL_testz00_2232;

						{	/* Ast/shrinkify.scm 179 */
							obj_t BgL_auxz00_2233;

							{	/* Ast/shrinkify.scm 179 */
								BgL_objectz00_bglt BgL_auxz00_2234;

								BgL_auxz00_2234 = ((BgL_objectz00_bglt) BgL_nodez00_1405);
								BgL_auxz00_2233 = BGL_OBJECT_WIDENING(BgL_auxz00_2234);
							}
							BgL_testz00_2232 = CBOOL(BgL_auxz00_2233);
						}
						if (BgL_testz00_2232)
							{	/* Ast/shrinkify.scm 179 */
								BgL_testz00_2231 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 179 */
								BgL_testz00_2231 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2231)
						{	/* Ast/shrinkify.scm 179 */
							{	/* Ast/shrinkify.scm 179 */
								long BgL_arg1619z00_1410;

								{	/* Ast/shrinkify.scm 179 */
									obj_t BgL_arg1620z00_1411;

									{	/* Ast/shrinkify.scm 179 */
										obj_t BgL_arg1623z00_1412;

										{	/* Ast/shrinkify.scm 179 */
											long BgL_arg1667z00_1863;

											{	/* Ast/shrinkify.scm 179 */
												long BgL_arg1668z00_1864;

												{	/* Ast/shrinkify.scm 179 */
													long BgL_res1784z00_1866;

													BgL_res1784z00_1866 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_nodez00_1405));
													BgL_arg1668z00_1864 = BgL_res1784z00_1866;
												}
												BgL_arg1667z00_1863 =
													(BgL_arg1668z00_1864 - OBJECT_TYPE);
											}
											BgL_arg1623z00_1412 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1863));
										}
										BgL_arg1620z00_1411 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1623z00_1412);
									}
									{	/* Ast/shrinkify.scm 179 */
										long BgL_res1786z00_1873;

										BgL_res1786z00_1873 = BGL_CLASS_INDEX(BgL_arg1620z00_1411);
										BgL_arg1619z00_1410 = BgL_res1786z00_1873;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_nodez00_1405), BgL_arg1619z00_1410);
							}
							{	/* Ast/shrinkify.scm 179 */
								BgL_objectz00_bglt BgL_auxz00_2247;

								BgL_auxz00_2247 = ((BgL_objectz00_bglt) BgL_nodez00_1405);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2247, BFALSE);
							}
							((obj_t) BgL_nodez00_1405);
						}
					else
						{	/* Ast/shrinkify.scm 179 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 180 */
					BgL_varz00_bglt BgL_arg1624z00_1413;

					BgL_arg1624z00_1413 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1405))->BgL_varz00);
					BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
						((BgL_nodez00_bglt) BgL_arg1624z00_1413));
				}
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1405))->BgL_valuez00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-box-ref1267 */
	obj_t BGl_z62shrinkzd2nodez12zd2boxzd2ref1267za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1940, obj_t BgL_nodez00_1941)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 170 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1395;

				BgL_nodez00_1395 = ((BgL_boxzd2refzd2_bglt) BgL_nodez00_1941);
				{	/* Ast/shrinkify.scm 171 */
					bool_t BgL_testz00_2257;

					{	/* Ast/shrinkify.scm 171 */
						bool_t BgL_testz00_2258;

						{	/* Ast/shrinkify.scm 171 */
							obj_t BgL_auxz00_2259;

							{	/* Ast/shrinkify.scm 171 */
								BgL_objectz00_bglt BgL_auxz00_2260;

								BgL_auxz00_2260 = ((BgL_objectz00_bglt) BgL_nodez00_1395);
								BgL_auxz00_2259 = BGL_OBJECT_WIDENING(BgL_auxz00_2260);
							}
							BgL_testz00_2258 = CBOOL(BgL_auxz00_2259);
						}
						if (BgL_testz00_2258)
							{	/* Ast/shrinkify.scm 171 */
								BgL_testz00_2257 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 171 */
								BgL_testz00_2257 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2257)
						{	/* Ast/shrinkify.scm 171 */
							{	/* Ast/shrinkify.scm 171 */
								long BgL_arg1610z00_1400;

								{	/* Ast/shrinkify.scm 171 */
									obj_t BgL_arg1611z00_1401;

									{	/* Ast/shrinkify.scm 171 */
										obj_t BgL_arg1613z00_1402;

										{	/* Ast/shrinkify.scm 171 */
											long BgL_arg1667z00_1845;

											{	/* Ast/shrinkify.scm 171 */
												long BgL_arg1668z00_1846;

												{	/* Ast/shrinkify.scm 171 */
													long BgL_res1780z00_1848;

													BgL_res1780z00_1848 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_nodez00_1395));
													BgL_arg1668z00_1846 = BgL_res1780z00_1848;
												}
												BgL_arg1667z00_1845 =
													(BgL_arg1668z00_1846 - OBJECT_TYPE);
											}
											BgL_arg1613z00_1402 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1845));
										}
										BgL_arg1611z00_1401 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1613z00_1402);
									}
									{	/* Ast/shrinkify.scm 171 */
										long BgL_res1782z00_1855;

										BgL_res1782z00_1855 = BGL_CLASS_INDEX(BgL_arg1611z00_1401);
										BgL_arg1610z00_1400 = BgL_res1782z00_1855;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_nodez00_1395), BgL_arg1610z00_1400);
							}
							{	/* Ast/shrinkify.scm 171 */
								BgL_objectz00_bglt BgL_auxz00_2273;

								BgL_auxz00_2273 = ((BgL_objectz00_bglt) BgL_nodez00_1395);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2273, BFALSE);
							}
							((obj_t) BgL_nodez00_1395);
						}
					else
						{	/* Ast/shrinkify.scm 171 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 172 */
					BgL_varz00_bglt BgL_arg1614z00_1403;

					BgL_arg1614z00_1403 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1395))->BgL_varz00);
					BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
						((BgL_nodez00_bglt) BgL_arg1614z00_1403));
				}
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-make-bo1265 */
	obj_t BGl_z62shrinkzd2nodez12zd2makezd2bo1265za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1942, obj_t BgL_nodez00_1943)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 162 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1385;

				BgL_nodez00_1385 = ((BgL_makezd2boxzd2_bglt) BgL_nodez00_1943);
				{	/* Ast/shrinkify.scm 163 */
					bool_t BgL_testz00_2281;

					{	/* Ast/shrinkify.scm 163 */
						bool_t BgL_testz00_2282;

						{	/* Ast/shrinkify.scm 163 */
							obj_t BgL_auxz00_2283;

							{	/* Ast/shrinkify.scm 163 */
								BgL_objectz00_bglt BgL_auxz00_2284;

								BgL_auxz00_2284 = ((BgL_objectz00_bglt) BgL_nodez00_1385);
								BgL_auxz00_2283 = BGL_OBJECT_WIDENING(BgL_auxz00_2284);
							}
							BgL_testz00_2282 = CBOOL(BgL_auxz00_2283);
						}
						if (BgL_testz00_2282)
							{	/* Ast/shrinkify.scm 163 */
								BgL_testz00_2281 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 163 */
								BgL_testz00_2281 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2281)
						{	/* Ast/shrinkify.scm 163 */
							{	/* Ast/shrinkify.scm 163 */
								long BgL_arg1587z00_1390;

								{	/* Ast/shrinkify.scm 163 */
									obj_t BgL_arg1591z00_1391;

									{	/* Ast/shrinkify.scm 163 */
										obj_t BgL_arg1595z00_1392;

										{	/* Ast/shrinkify.scm 163 */
											long BgL_arg1667z00_1827;

											{	/* Ast/shrinkify.scm 163 */
												long BgL_arg1668z00_1828;

												{	/* Ast/shrinkify.scm 163 */
													long BgL_res1776z00_1830;

													BgL_res1776z00_1830 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_nodez00_1385));
													BgL_arg1668z00_1828 = BgL_res1776z00_1830;
												}
												BgL_arg1667z00_1827 =
													(BgL_arg1668z00_1828 - OBJECT_TYPE);
											}
											BgL_arg1595z00_1392 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1827));
										}
										BgL_arg1591z00_1391 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1595z00_1392);
									}
									{	/* Ast/shrinkify.scm 163 */
										long BgL_res1778z00_1837;

										BgL_res1778z00_1837 = BGL_CLASS_INDEX(BgL_arg1591z00_1391);
										BgL_arg1587z00_1390 = BgL_res1778z00_1837;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_nodez00_1385), BgL_arg1587z00_1390);
							}
							{	/* Ast/shrinkify.scm 163 */
								BgL_objectz00_bglt BgL_auxz00_2297;

								BgL_auxz00_2297 = ((BgL_objectz00_bglt) BgL_nodez00_1385);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2297, BFALSE);
							}
							((obj_t) BgL_nodez00_1385);
						}
					else
						{	/* Ast/shrinkify.scm 163 */
							BFALSE;
						}
				}
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1385))->BgL_valuez00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-select1263 */
	obj_t BGl_z62shrinkzd2nodez12zd2select1263z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1944, obj_t BgL_nodez00_1945)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 152 */
			{
				BgL_selectz00_bglt BgL_nodez00_1371;

				BgL_nodez00_1371 = ((BgL_selectz00_bglt) BgL_nodez00_1945);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_selectz00_bglt) CREF(BgL_nodez00_1371))->BgL_testz00));
				{	/* Ast/shrinkify.scm 154 */
					obj_t BgL_g1220z00_1375;

					BgL_g1220z00_1375 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1371))->BgL_clausesz00);
					{
						obj_t BgL_l1218z00_1377;

						BgL_l1218z00_1377 = BgL_g1220z00_1375;
					BgL_zc3anonymousza31572ze3z83_1378:
						if (PAIRP(BgL_l1218z00_1377))
							{	/* Ast/shrinkify.scm 156 */
								{	/* Ast/shrinkify.scm 155 */
									obj_t BgL_clausez00_1380;

									BgL_clausez00_1380 = CAR(BgL_l1218z00_1377);
									{	/* Ast/shrinkify.scm 155 */
										obj_t BgL_arg1576z00_1381;

										BgL_arg1576z00_1381 = CDR(BgL_clausez00_1380);
										BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
											((BgL_nodez00_bglt) BgL_arg1576z00_1381));
									}
								}
								{
									obj_t BgL_l1218z00_2313;

									BgL_l1218z00_2313 = CDR(BgL_l1218z00_1377);
									BgL_l1218z00_1377 = BgL_l1218z00_2313;
									goto BgL_zc3anonymousza31572ze3z83_1378;
								}
							}
						else
							{	/* Ast/shrinkify.scm 156 */
								((bool_t) 1);
							}
					}
				}
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-fail1261 */
	obj_t BGl_z62shrinkzd2nodez12zd2fail1261z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1946, obj_t BgL_nodez00_1947)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 143 */
			{
				BgL_failz00_bglt BgL_nodez00_1364;

				BgL_nodez00_1364 = ((BgL_failz00_bglt) BgL_nodez00_1947);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1364))->BgL_procz00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1364))->BgL_msgz00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1364))->BgL_objz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-conditi1259 */
	obj_t BGl_z62shrinkzd2nodez12zd2conditi1259z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1948, obj_t BgL_nodez00_1949)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 134 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1357;

				BgL_nodez00_1357 = ((BgL_conditionalz00_bglt) BgL_nodez00_1949);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1357))->BgL_testz00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1357))->BgL_truez00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1357))->BgL_falsez00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-setq1257 */
	obj_t BGl_z62shrinkzd2nodez12zd2setq1257z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1950, obj_t BgL_nodez00_1951)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 127 */
			{
				BgL_setqz00_bglt BgL_nodez00_1352;

				BgL_nodez00_1352 = ((BgL_setqz00_bglt) BgL_nodez00_1951);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_setqz00_bglt) CREF(BgL_nodez00_1352))->BgL_valuez00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-cast1255 */
	obj_t BGl_z62shrinkzd2nodez12zd2cast1255z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1952, obj_t BgL_nodez00_1953)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 120 */
			{
				BgL_castz00_bglt BgL_nodez00_1347;

				BgL_nodez00_1347 = ((BgL_castz00_bglt) BgL_nodez00_1953);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_castz00_bglt) CREF(BgL_nodez00_1347))->BgL_argz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-extern1253 */
	obj_t BGl_z62shrinkzd2nodez12zd2extern1253z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1954, obj_t BgL_nodez00_1955)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 112 */
			{
				BgL_externz00_bglt BgL_nodez00_1337;

				BgL_nodez00_1337 = ((BgL_externz00_bglt) BgL_nodez00_1955);
				{	/* Ast/shrinkify.scm 113 */
					bool_t BgL_testz00_2336;

					{	/* Ast/shrinkify.scm 113 */
						bool_t BgL_testz00_2337;

						{	/* Ast/shrinkify.scm 113 */
							obj_t BgL_auxz00_2338;

							{	/* Ast/shrinkify.scm 113 */
								BgL_objectz00_bglt BgL_auxz00_2339;

								BgL_auxz00_2339 = ((BgL_objectz00_bglt) BgL_nodez00_1337);
								BgL_auxz00_2338 = BGL_OBJECT_WIDENING(BgL_auxz00_2339);
							}
							BgL_testz00_2337 = CBOOL(BgL_auxz00_2338);
						}
						if (BgL_testz00_2337)
							{	/* Ast/shrinkify.scm 113 */
								BgL_testz00_2336 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 113 */
								BgL_testz00_2336 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2336)
						{	/* Ast/shrinkify.scm 113 */
							{	/* Ast/shrinkify.scm 113 */
								long BgL_arg1516z00_1342;

								{	/* Ast/shrinkify.scm 113 */
									obj_t BgL_arg1519z00_1343;

									{	/* Ast/shrinkify.scm 113 */
										obj_t BgL_arg1526z00_1344;

										{	/* Ast/shrinkify.scm 113 */
											long BgL_arg1667z00_1792;

											{	/* Ast/shrinkify.scm 113 */
												long BgL_arg1668z00_1793;

												{	/* Ast/shrinkify.scm 113 */
													long BgL_res1771z00_1795;

													BgL_res1771z00_1795 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_nodez00_1337));
													BgL_arg1668z00_1793 = BgL_res1771z00_1795;
												}
												BgL_arg1667z00_1792 =
													(BgL_arg1668z00_1793 - OBJECT_TYPE);
											}
											BgL_arg1526z00_1344 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1792));
										}
										BgL_arg1519z00_1343 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1526z00_1344);
									}
									{	/* Ast/shrinkify.scm 113 */
										long BgL_res1773z00_1802;

										BgL_res1773z00_1802 = BGL_CLASS_INDEX(BgL_arg1519z00_1343);
										BgL_arg1516z00_1342 = BgL_res1773z00_1802;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_nodez00_1337), BgL_arg1516z00_1342);
							}
							{	/* Ast/shrinkify.scm 113 */
								BgL_objectz00_bglt BgL_auxz00_2352;

								BgL_auxz00_2352 = ((BgL_objectz00_bglt) BgL_nodez00_1337);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2352, BFALSE);
							}
							((obj_t) BgL_nodez00_1337);
						}
					else
						{	/* Ast/shrinkify.scm 113 */
							BFALSE;
						}
				}
				BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
					(((BgL_externz00_bglt) CREF(BgL_nodez00_1337))->BgL_exprza2za2));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-funcall1251 */
	obj_t BGl_z62shrinkzd2nodez12zd2funcall1251z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1956, obj_t BgL_nodez00_1957)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 103 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1326;

				BgL_nodez00_1326 = ((BgL_funcallz00_bglt) BgL_nodez00_1957);
				{	/* Ast/shrinkify.scm 104 */
					bool_t BgL_testz00_2359;

					{	/* Ast/shrinkify.scm 104 */
						bool_t BgL_testz00_2360;

						{	/* Ast/shrinkify.scm 104 */
							obj_t BgL_auxz00_2361;

							{	/* Ast/shrinkify.scm 104 */
								BgL_objectz00_bglt BgL_auxz00_2362;

								BgL_auxz00_2362 = ((BgL_objectz00_bglt) BgL_nodez00_1326);
								BgL_auxz00_2361 = BGL_OBJECT_WIDENING(BgL_auxz00_2362);
							}
							BgL_testz00_2360 = CBOOL(BgL_auxz00_2361);
						}
						if (BgL_testz00_2360)
							{	/* Ast/shrinkify.scm 104 */
								BgL_testz00_2359 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 104 */
								BgL_testz00_2359 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2359)
						{	/* Ast/shrinkify.scm 104 */
							{	/* Ast/shrinkify.scm 104 */
								long BgL_arg1496z00_1331;

								{	/* Ast/shrinkify.scm 104 */
									obj_t BgL_arg1500z00_1332;

									{	/* Ast/shrinkify.scm 104 */
										obj_t BgL_arg1505z00_1333;

										{	/* Ast/shrinkify.scm 104 */
											long BgL_arg1667z00_1773;

											{	/* Ast/shrinkify.scm 104 */
												long BgL_arg1668z00_1774;

												{	/* Ast/shrinkify.scm 104 */
													long BgL_res1767z00_1776;

													BgL_res1767z00_1776 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_nodez00_1326));
													BgL_arg1668z00_1774 = BgL_res1767z00_1776;
												}
												BgL_arg1667z00_1773 =
													(BgL_arg1668z00_1774 - OBJECT_TYPE);
											}
											BgL_arg1505z00_1333 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1773));
										}
										BgL_arg1500z00_1332 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1505z00_1333);
									}
									{	/* Ast/shrinkify.scm 104 */
										long BgL_res1769z00_1783;

										BgL_res1769z00_1783 = BGL_CLASS_INDEX(BgL_arg1500z00_1332);
										BgL_arg1496z00_1331 = BgL_res1769z00_1783;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_nodez00_1326), BgL_arg1496z00_1331);
							}
							{	/* Ast/shrinkify.scm 104 */
								BgL_objectz00_bglt BgL_auxz00_2375;

								BgL_auxz00_2375 = ((BgL_objectz00_bglt) BgL_nodez00_1326);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2375, BFALSE);
							}
							((obj_t) BgL_nodez00_1326);
						}
					else
						{	/* Ast/shrinkify.scm 104 */
							BFALSE;
						}
				}
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1326))->BgL_funz00));
				BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
					(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1326))->BgL_argsz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-app-ly1249 */
	obj_t BGl_z62shrinkzd2nodez12zd2appzd2ly1249za2zzast_shrinkifyz00(obj_t
		BgL_envz00_1958, obj_t BgL_nodez00_1959)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 94 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1315;

				BgL_nodez00_1315 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_1959);
				{	/* Ast/shrinkify.scm 95 */
					bool_t BgL_testz00_2384;

					{	/* Ast/shrinkify.scm 95 */
						bool_t BgL_testz00_2385;

						{	/* Ast/shrinkify.scm 95 */
							obj_t BgL_auxz00_2386;

							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_2387;

								BgL_auxz00_2387 = ((BgL_objectz00_bglt) BgL_nodez00_1315);
								BgL_auxz00_2386 = BGL_OBJECT_WIDENING(BgL_auxz00_2387);
							}
							BgL_testz00_2385 = CBOOL(BgL_auxz00_2386);
						}
						if (BgL_testz00_2385)
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_2384 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 95 */
								BgL_testz00_2384 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2384)
						{	/* Ast/shrinkify.scm 95 */
							{	/* Ast/shrinkify.scm 95 */
								long BgL_arg1482z00_1320;

								{	/* Ast/shrinkify.scm 95 */
									obj_t BgL_arg1484z00_1321;

									{	/* Ast/shrinkify.scm 95 */
										obj_t BgL_arg1485z00_1322;

										{	/* Ast/shrinkify.scm 95 */
											long BgL_arg1667z00_1754;

											{	/* Ast/shrinkify.scm 95 */
												long BgL_arg1668z00_1755;

												{	/* Ast/shrinkify.scm 95 */
													long BgL_res1763z00_1757;

													BgL_res1763z00_1757 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_nodez00_1315));
													BgL_arg1668z00_1755 = BgL_res1763z00_1757;
												}
												BgL_arg1667z00_1754 =
													(BgL_arg1668z00_1755 - OBJECT_TYPE);
											}
											BgL_arg1485z00_1322 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1754));
										}
										BgL_arg1484z00_1321 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1485z00_1322);
									}
									{	/* Ast/shrinkify.scm 95 */
										long BgL_res1765z00_1764;

										BgL_res1765z00_1764 = BGL_CLASS_INDEX(BgL_arg1484z00_1321);
										BgL_arg1482z00_1320 = BgL_res1765z00_1764;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_nodez00_1315), BgL_arg1482z00_1320);
							}
							{	/* Ast/shrinkify.scm 95 */
								BgL_objectz00_bglt BgL_auxz00_2400;

								BgL_auxz00_2400 = ((BgL_objectz00_bglt) BgL_nodez00_1315);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2400, BFALSE);
							}
							((obj_t) BgL_nodez00_1315);
						}
					else
						{	/* Ast/shrinkify.scm 95 */
							BFALSE;
						}
				}
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1315))->BgL_funz00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1315))->BgL_argz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-app1247 */
	obj_t BGl_z62shrinkzd2nodez12zd2app1247z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1960, obj_t BgL_nodez00_1961)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 85 */
			{
				BgL_appz00_bglt BgL_nodez00_1304;

				BgL_nodez00_1304 = ((BgL_appz00_bglt) BgL_nodez00_1961);
				{	/* Ast/shrinkify.scm 86 */
					bool_t BgL_testz00_2409;

					{	/* Ast/shrinkify.scm 86 */
						bool_t BgL_testz00_2410;

						{	/* Ast/shrinkify.scm 86 */
							obj_t BgL_auxz00_2411;

							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_2412;

								BgL_auxz00_2412 = ((BgL_objectz00_bglt) BgL_nodez00_1304);
								BgL_auxz00_2411 = BGL_OBJECT_WIDENING(BgL_auxz00_2412);
							}
							BgL_testz00_2410 = CBOOL(BgL_auxz00_2411);
						}
						if (BgL_testz00_2410)
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_2409 = ((bool_t) 1);
							}
						else
							{	/* Ast/shrinkify.scm 86 */
								BgL_testz00_2409 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_2409)
						{	/* Ast/shrinkify.scm 86 */
							{	/* Ast/shrinkify.scm 86 */
								long BgL_arg1459z00_1309;

								{	/* Ast/shrinkify.scm 86 */
									obj_t BgL_arg1460z00_1310;

									{	/* Ast/shrinkify.scm 86 */
										obj_t BgL_arg1467z00_1311;

										{	/* Ast/shrinkify.scm 86 */
											long BgL_arg1667z00_1735;

											{	/* Ast/shrinkify.scm 86 */
												long BgL_arg1668z00_1736;

												{	/* Ast/shrinkify.scm 86 */
													long BgL_res1759z00_1738;

													BgL_res1759z00_1738 =
														BGL_OBJECT_CLASS_NUM(
														((BgL_objectz00_bglt) BgL_nodez00_1304));
													BgL_arg1668z00_1736 = BgL_res1759z00_1738;
												}
												BgL_arg1667z00_1735 =
													(BgL_arg1668z00_1736 - OBJECT_TYPE);
											}
											BgL_arg1467z00_1311 =
												VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
												(int) (BgL_arg1667z00_1735));
										}
										BgL_arg1460z00_1310 =
											BGl_classzd2superzd2zz__objectz00(BgL_arg1467z00_1311);
									}
									{	/* Ast/shrinkify.scm 86 */
										long BgL_res1761z00_1745;

										BgL_res1761z00_1745 = BGL_CLASS_INDEX(BgL_arg1460z00_1310);
										BgL_arg1459z00_1309 = BgL_res1761z00_1745;
								}}
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_nodez00_1304), BgL_arg1459z00_1309);
							}
							{	/* Ast/shrinkify.scm 86 */
								BgL_objectz00_bglt BgL_auxz00_2425;

								BgL_auxz00_2425 = ((BgL_objectz00_bglt) BgL_nodez00_1304);
								BGL_OBJECT_WIDENING_SET(BgL_auxz00_2425, BFALSE);
							}
							((obj_t) BgL_nodez00_1304);
						}
					else
						{	/* Ast/shrinkify.scm 86 */
							BFALSE;
						}
				}
				{	/* Ast/shrinkify.scm 87 */
					BgL_varz00_bglt BgL_arg1468z00_1312;

					BgL_arg1468z00_1312 =
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1304))->BgL_funz00);
					BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
						((BgL_nodez00_bglt) BgL_arg1468z00_1312));
				}
				BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
					(((BgL_appz00_bglt) CREF(BgL_nodez00_1304))->BgL_argsz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-sync1245 */
	obj_t BGl_z62shrinkzd2nodez12zd2sync1245z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1962, obj_t BgL_nodez00_1963)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 76 */
			{
				BgL_syncz00_bglt BgL_nodez00_1297;

				BgL_nodez00_1297 = ((BgL_syncz00_bglt) BgL_nodez00_1963);
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1297))->BgL_mutexz00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1297))->BgL_prelockz00));
				BGl_shrinkzd2nodez12zc0zzast_shrinkifyz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1297))->BgL_bodyz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-sequenc1243 */
	obj_t BGl_z62shrinkzd2nodez12zd2sequenc1243z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1964, obj_t BgL_nodez00_1965)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 69 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1292;

				BgL_nodez00_1292 = ((BgL_sequencez00_bglt) BgL_nodez00_1965);
				BGl_shrinkzd2nodeza2z12z62zzast_shrinkifyz00(
					(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1292))->BgL_nodesz00));
				return BUNSPEC;
			}
		}
	}



/* &shrink-node!-kwote1241 */
	obj_t BGl_z62shrinkzd2nodez12zd2kwote1241z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1966, obj_t BgL_nodez00_1967)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 63 */
			return BUNSPEC;
		}
	}



/* &shrink-node!-var1239 */
	obj_t BGl_z62shrinkzd2nodez12zd2var1239z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1968, obj_t BgL_nodez00_1969)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 57 */
			return BUNSPEC;
		}
	}



/* &shrink-node!-atom1237 */
	obj_t BGl_z62shrinkzd2nodez12zd2atom1237z70zzast_shrinkifyz00(obj_t
		BgL_envz00_1970, obj_t BgL_nodez00_1971)
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 51 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_shrinkifyz00()
	{
		AN_OBJECT;
		{	/* Ast/shrinkify.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string1817z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string1817z00zzast_shrinkifyz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string1817z00zzast_shrinkifyz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string1817z00zzast_shrinkifyz00));
		}
	}

#ifdef __cplusplus
}
#endif
