/*===========================================================================*/
/*   (Cfa/arithmetic.scm)                                                    */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/arithmetic.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_cfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_argszd2typezd2;
		bool_t BgL_macrozf3zf3;
		bool_t BgL_infixzf3zf3;
		obj_t BgL_methodz00;
	}              *BgL_cfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
		obj_t BgL_dupz00;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_prezd2arithmeticzd2appz00_bgl
	{
		obj_t BgL_speczd2typeszd2;
	}                                *BgL_prezd2arithmeticzd2appz00_bglt;

	typedef struct BgL_arithmeticzd2appzd2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_speczd2typeszd2;
	}                          *BgL_arithmeticzd2appzd2_bglt;


	static obj_t
		BGl_z62cleanupzd2nodez12zd2funcal1555z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_sfunz00zzast_varz00;
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00();
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2select1537z70zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static obj_t
		BGl_z62nodezd2setupz12zd2prezd2arit1559za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2setzd2ex1543za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	extern obj_t BGl_nodezd2setupza2z12z62zzcfa_setupz00(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2longza2z00zztype_cachez00;
	static obj_t BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(BgL_nodez00_bglt);
	static obj_t BGl_z62cleanupzd2nodez12zd2app1557z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2boxzd2se1551za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BUNSPEC;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2sequen1527z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setupz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_iteratez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_loosez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
	extern BgL_approxz00_bglt
		BGl_makezd2typezd2approxz00zzcfa_approxz00(BgL_typez00_bglt);
	extern obj_t BGl_prezd2arithmeticzd2appz00zzcfa_info2z00;
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	static obj_t BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t);
	extern obj_t BGl_continuezd2cfaz12zc0zzcfa_iteratez00(obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2makezd2b1547za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2jumpzd2e1545za2zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_z62cleanupzd2nodez121523za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_cfunz00zzast_varz00;
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62cleanupzd2nodez12zd2setq1531z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2letzd2fu1539za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern BgL_approxz00_bglt BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
	static obj_t
		BGl_z62cleanupzd2nodez12zd2letzd2va1541za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_z62cleanupzd2nodez12zd2appzd2ly1553za2zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_za2intza2z00zztype_cachez00;
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 = BUNSPEC;
	static obj_t
		BGl_z62cleanupzd2nodez12zd2condit1533z70zzcfa_arithmeticz00(obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	static obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
	static obj_t
		BGl_z62cleanupzd2nodez12zd2boxzd2re1549za2zzcfa_arithmeticz00(obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00();
	extern obj_t BGl_arithmeticzd2appzd2zzcfa_info2z00;
	extern obj_t BGl_typez00zztype_typez00;
	extern BgL_approxz00_bglt BGl_loosez12z12zzcfa_loosez00(BgL_approxz00_bglt,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	extern obj_t BGl_appz00zzast_nodez00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00();
	static obj_t BGl_z62cleanupzd2nodez12zd2fail1535z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
	static obj_t BGl_z62cleanupzd2nodez12zd2sync1529z70zzcfa_arithmeticz00(obj_t,
		obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static BgL_approxz00_bglt
		BGl_z62cfaz12zd2arithmeticzd2app1561z70zzcfa_arithmeticz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	extern obj_t BGl_approxzd2setzd2typez12z12zzcfa_approxz00(BgL_approxz00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t __cnst[3];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2038z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2067z00,
		BGl_z62cleanupzd2nodez121523za2zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2040z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2068z00,
		BGl_z62cleanupzd2nodez12zd2sequen1527z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2042z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2069z00,
		BGl_z62cleanupzd2nodez12zd2sync1529z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2043z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2070z00,
		BGl_z62cleanupzd2nodez12zd2setq1531z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2044z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2071z00,
		BGl_z62cleanupzd2nodez12zd2condit1533z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2045z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2072z00,
		BGl_z62cleanupzd2nodez12zd2fail1535z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2046z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2073z00,
		BGl_z62cleanupzd2nodez12zd2select1537z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2047z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2074z00,
		BGl_z62cleanupzd2nodez12zd2letzd2fu1539za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2048z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2075z00,
		BGl_z62cleanupzd2nodez12zd2letzd2va1541za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2049z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2076z00,
		BGl_z62cleanupzd2nodez12zd2setzd2ex1543za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2050z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2077z00,
		BGl_z62cleanupzd2nodez12zd2jumpzd2e1545za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2051z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2078z00,
		BGl_z62cleanupzd2nodez12zd2makezd2b1547za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2052z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2079z00,
		BGl_z62cleanupzd2nodez12zd2boxzd2re1549za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2053z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2080z00,
		BGl_z62cleanupzd2nodez12zd2boxzd2se1551za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2054z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2081z00,
		BGl_z62cleanupzd2nodez12zd2appzd2ly1553za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2055z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2082z00,
		BGl_z62cleanupzd2nodez12zd2funcal1555z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2056z00zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2083z00,
		BGl_z62cleanupzd2nodez12zd2app1557z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2057z00zzcfa_arithmeticz00,
		BgL_bgl_za762nodeza7d2setupza72084za7,
		BGl_z62nodezd2setupz12zd2prezd2arit1559za2zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2059z00zzcfa_arithmeticz00,
		BgL_bgl_za762cfaza712za7d2arit2085za7,
		BGl_z62cfaz12zd2arithmeticzd2app1561z70zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2nod2086z00,
		BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00, 0L, BUNSPEC, 1);
	extern obj_t BGl_cfaz12zd2envzc0zzcfa_cfaz00;
	   
		 
		DEFINE_STRING(BGl_string2039z00zzcfa_arithmeticz00,
		BgL_bgl_string2039za700za7za7c2087za7, "cleanup-node!1523", 17);
	extern obj_t BGl_nodezd2setupz12zd2envz12zzcfa_setupz00;
	   
		 
		DEFINE_STRING(BGl_string2041z00zzcfa_arithmeticz00,
		BgL_bgl_string2041za700za7za7c2088za7, "cleanup-node!", 13);
	      DEFINE_STRING(BGl_string2058z00zzcfa_arithmeticz00,
		BgL_bgl_string2058za700za7za7c2089za7, "node-setup!", 11);
	      DEFINE_STRING(BGl_string2060z00zzcfa_arithmeticz00,
		BgL_bgl_string2060za700za7za7c2090za7, "cfa!::approx", 12);
	      DEFINE_STRING(BGl_string2061z00zzcfa_arithmeticz00,
		BgL_bgl_string2061za700za7za7c2091za7, "Illegal arithmetic node", 23);
	      DEFINE_STRING(BGl_string2062z00zzcfa_arithmeticz00,
		BgL_bgl_string2062za700za7za7c2092za7, "cfa_arithmetic", 14);
	      DEFINE_STRING(BGl_string2063z00zzcfa_arithmeticz00,
		BgL_bgl_string2063za700za7za7c2093za7, "all c-eq? arithmetic-app ", 25);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_cleanupzd2arithmeticzd2nodesz12zd2envzc0zzcfa_arithmeticz00,
		BgL_bgl_za762cleanupza7d2ari2094z00,
		BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00, 0L, BUNSPEC,
		1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t
		BGl_modulezd2initializa7ationz75zzcfa_arithmeticz00(long
		BgL_checksumz00_3801, char *BgL_fromz00_3802)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_arithmeticz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_cnstzd2initzd2zzcfa_arithmeticz00();
					BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00();
					BGl_genericzd2initzd2zzcfa_arithmeticz00();
					BGl_methodzd2initzd2zzcfa_arithmeticz00();
					return BGl_toplevelzd2initzd2zzcfa_arithmeticz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"cfa_arithmetic");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"cfa_arithmetic");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			{	/* Cfa/arithmetic.scm 28 */
				obj_t BgL_cportz00_3787;

				{	/* Cfa/arithmetic.scm 28 */
					obj_t BgL_startz00_3796;

					BgL_startz00_3796 = BINT(((long) 0));
					{	/* Cfa/arithmetic.scm 28 */
						obj_t BgL_endz00_3797;

						BgL_endz00_3797 =
							BINT(STRING_LENGTH(BGl_string2063z00zzcfa_arithmeticz00));
						{	/* Cfa/arithmetic.scm 28 */

							BgL_cportz00_3787 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string2063z00zzcfa_arithmeticz00, BgL_startz00_3796,
								BgL_endz00_3797);
				}}}
				{
					long BgL_iz00_3788;

					BgL_iz00_3788 = ((long) 2);
				BgL_loopz00_3789:
					if ((BgL_iz00_3788 == ((long) -1)))
						{	/* Cfa/arithmetic.scm 28 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/arithmetic.scm 28 */
							{	/* Cfa/arithmetic.scm 28 */
								obj_t BgL_arg2065z00_3791;

								{	/* Cfa/arithmetic.scm 28 */

									{	/* Cfa/arithmetic.scm 28 */
										obj_t BgL_locationz00_3793;

										BgL_locationz00_3793 = BBOOL(((bool_t) 0));
										{	/* Cfa/arithmetic.scm 28 */

											BgL_arg2065z00_3791 =
												BGl_readz00zz__readerz00(BgL_cportz00_3787,
												BgL_locationz00_3793);
										}
									}
								}
								{	/* Cfa/arithmetic.scm 28 */
									int BgL_auxz00_3828;

									BgL_auxz00_3828 = (int) (BgL_iz00_3788);
									CNST_TABLE_SET(BgL_auxz00_3828, BgL_arg2065z00_3791);
							}}
							{	/* Cfa/arithmetic.scm 28 */
								int BgL_auxz00_3794;

								BgL_auxz00_3794 = (int) ((BgL_iz00_3788 - ((long) 1)));
								{
									long BgL_iz00_3833;

									BgL_iz00_3833 = (long) (BgL_auxz00_3794);
									BgL_iz00_3788 = BgL_iz00_3833;
									goto BgL_loopz00_3789;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 = BNIL;
			return BUNSPEC;
		}
	}



/* cleanup-arithmetic-nodes! */
	BGL_EXPORTED_DEF obj_t
		BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00(obj_t
		BgL_globalsz00_3)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			{
				obj_t BgL_l1487z00_2637;

				BgL_l1487z00_2637 = BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00;
			BgL_zc3anonymousza31572ze3z83_2638:
				if (PAIRP(BgL_l1487z00_2637))
					{	/* Cfa/arithmetic.scm 63 */
						{	/* Cfa/arithmetic.scm 64 */
							obj_t BgL_nodez00_2640;

							BgL_nodez00_2640 = CAR(BgL_l1487z00_2637);
							{	/* Cfa/arithmetic.scm 65 */
								BgL_variablez00_bglt BgL_fz00_2642;

								BgL_fz00_2642 =
									(((BgL_varz00_bglt) CREF(
											(((BgL_appz00_bglt) CREF(
														((BgL_appz00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_2640))))->
												BgL_funz00)))->BgL_variablez00);
								{	/* Cfa/arithmetic.scm 65 */
									BgL_valuez00_bglt BgL_valz00_2643;

									BgL_valz00_2643 =
										(((BgL_variablez00_bglt) CREF(BgL_fz00_2642))->
										BgL_valuez00);
									{	/* Cfa/arithmetic.scm 66 */

										{	/* Cfa/arithmetic.scm 68 */
											bool_t BgL_testz00_3843;

											{	/* Cfa/arithmetic.scm 68 */
												BgL_typez00_bglt BgL_arg1576z00_2645;

												BgL_arg1576z00_2645 =
													(((BgL_variablez00_bglt) CREF(BgL_fz00_2642))->
													BgL_typez00);
												BgL_testz00_3843 =
													(((obj_t) BgL_arg1576z00_2645) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_testz00_3843)
												{	/* Cfa/arithmetic.scm 69 */
													BgL_typez00_bglt BgL_vz00_3492;

													BgL_vz00_3492 =
														((BgL_typez00_bglt)
														BGl_za2objza2z00zztype_cachez00);
													((((BgL_variablez00_bglt) CREF(BgL_fz00_2642))->
															BgL_typez00) =
														((BgL_typez00_bglt) BgL_vz00_3492), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 68 */
													BFALSE;
												}
										}
										{	/* Cfa/arithmetic.scm 70 */
											bool_t BgL_testz00_3849;

											{	/* Cfa/arithmetic.scm 70 */
												BgL_typez00_bglt BgL_arg1582z00_2647;

												BgL_arg1582z00_2647 =
													(((BgL_nodez00_bglt) CREF(
															((BgL_nodez00_bglt) BgL_nodez00_2640)))->
													BgL_typez00);
												BgL_testz00_3849 =
													(((obj_t) BgL_arg1582z00_2647) ==
													BGl_za2_za2z00zztype_cachez00);
											}
											if (BgL_testz00_3849)
												{	/* Cfa/arithmetic.scm 71 */
													BgL_typez00_bglt BgL_vz00_3495;

													BgL_vz00_3495 =
														((BgL_typez00_bglt)
														BGl_za2objza2z00zztype_cachez00);
													((((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
																		BgL_nodez00_2640)))->BgL_typez00) =
														((BgL_typez00_bglt) BgL_vz00_3495), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 70 */
													BFALSE;
												}
										}
										{	/* Cfa/arithmetic.scm 73 */
											bool_t BgL_testz00_3857;

											{	/* Cfa/arithmetic.scm 73 */
												bool_t BgL_res1993z00_3497;

												BgL_res1993z00_3497 =
													BGl_isazf3zf3zz__objectz00(
													((obj_t) BgL_valz00_2643), BGl_sfunz00zzast_varz00);
												BgL_testz00_3857 = BgL_res1993z00_3497;
											}
											if (BgL_testz00_3857)
												{	/* Cfa/arithmetic.scm 74 */
													obj_t BgL_arg1587z00_2649;

													{	/* Cfa/arithmetic.scm 74 */
														obj_t BgL_l1481z00_2650;

														BgL_l1481z00_2650 =
															(((BgL_sfunz00_bglt) CREF(
																	((BgL_sfunz00_bglt) BgL_valz00_2643)))->
															BgL_argsz00);
														if (NULLP(BgL_l1481z00_2650))
															{	/* Cfa/arithmetic.scm 74 */
																BgL_arg1587z00_2649 = BNIL;
															}
														else
															{	/* Cfa/arithmetic.scm 74 */
																obj_t BgL_head1483z00_2652;

																{	/* Cfa/arithmetic.scm 74 */
																	obj_t BgL_arg1610z00_2664;

																	BgL_arg1610z00_2664 =
																		BGl_cleanupzd2typezd2zzcfa_arithmeticz00(CAR
																		(BgL_l1481z00_2650));
																	{	/* Cfa/arithmetic.scm 74 */
																		obj_t BgL_res1995z00_3504;

																		BgL_res1995z00_3504 =
																			MAKE_PAIR(BgL_arg1610z00_2664, BNIL);
																		BgL_head1483z00_2652 = BgL_res1995z00_3504;
																	}
																}
																{	/* Cfa/arithmetic.scm 74 */
																	obj_t BgL_g1486z00_2653;

																	BgL_g1486z00_2653 = CDR(BgL_l1481z00_2650);
																	{
																		obj_t BgL_l1481z00_2655;
																		obj_t BgL_tail1484z00_2656;

																		BgL_l1481z00_2655 = BgL_g1486z00_2653;
																		BgL_tail1484z00_2656 = BgL_head1483z00_2652;
																	BgL_zc3anonymousza31589ze3z83_2657:
																		if (NULLP(BgL_l1481z00_2655))
																			{	/* Cfa/arithmetic.scm 74 */
																				BgL_arg1587z00_2649 =
																					BgL_head1483z00_2652;
																			}
																		else
																			{	/* Cfa/arithmetic.scm 74 */
																				obj_t BgL_newtail1485z00_2659;

																				{	/* Cfa/arithmetic.scm 74 */
																					obj_t BgL_arg1595z00_2661;

																					BgL_arg1595z00_2661 =
																						BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																						(CAR(BgL_l1481z00_2655));
																					{	/* Cfa/arithmetic.scm 74 */
																						obj_t BgL_res1997z00_3511;

																						BgL_res1997z00_3511 =
																							MAKE_PAIR(BgL_arg1595z00_2661,
																							BNIL);
																						BgL_newtail1485z00_2659 =
																							BgL_res1997z00_3511;
																					}
																				}
																				SET_CDR(BgL_tail1484z00_2656,
																					BgL_newtail1485z00_2659);
																				{
																					obj_t BgL_tail1484z00_3876;
																					obj_t BgL_l1481z00_3874;

																					BgL_l1481z00_3874 =
																						CDR(BgL_l1481z00_2655);
																					BgL_tail1484z00_3876 =
																						BgL_newtail1485z00_2659;
																					BgL_tail1484z00_2656 =
																						BgL_tail1484z00_3876;
																					BgL_l1481z00_2655 = BgL_l1481z00_3874;
																					goto
																						BgL_zc3anonymousza31589ze3z83_2657;
																				}
																			}
																	}
																}
															}
													}
													((((BgL_sfunz00_bglt) CREF(
																	((BgL_sfunz00_bglt) BgL_valz00_2643)))->
															BgL_argsz00) =
														((obj_t) BgL_arg1587z00_2649), BUNSPEC);
												}
											else
												{	/* Cfa/arithmetic.scm 75 */
													bool_t BgL_testz00_3879;

													{	/* Cfa/arithmetic.scm 75 */
														bool_t BgL_res1998z00_3518;

														BgL_res1998z00_3518 =
															BGl_isazf3zf3zz__objectz00(
															((obj_t) BgL_valz00_2643),
															BGl_cfunz00zzast_varz00);
														BgL_testz00_3879 = BgL_res1998z00_3518;
													}
													if (BgL_testz00_3879)
														{	/* Cfa/arithmetic.scm 76 */
															obj_t BgL_g1152z00_2667;

															BgL_g1152z00_2667 =
																(((BgL_cfunz00_bglt) CREF(
																		((BgL_cfunz00_bglt) BgL_valz00_2643)))->
																BgL_argszd2typezd2);
															{
																obj_t BgL_lz00_2669;

																{	/* Cfa/arithmetic.scm 76 */
																	bool_t BgL_auxz00_3884;

																	BgL_lz00_2669 = BgL_g1152z00_2667;
																BgL_zc3anonymousza31613ze3z83_2670:
																	if (PAIRP(BgL_lz00_2669))
																		{	/* Cfa/arithmetic.scm 77 */
																			{	/* Cfa/arithmetic.scm 79 */
																				obj_t BgL_auxz00_3887;

																				BgL_auxz00_3887 =
																					BGl_cleanupzd2typezd2zzcfa_arithmeticz00
																					(CAR(BgL_lz00_2669));
																				SET_CAR(BgL_lz00_2669, BgL_auxz00_3887);
																			}
																			{
																				obj_t BgL_lz00_3891;

																				BgL_lz00_3891 = CDR(BgL_lz00_2669);
																				BgL_lz00_2669 = BgL_lz00_3891;
																				goto BgL_zc3anonymousza31613ze3z83_2670;
																			}
																		}
																	else
																		{	/* Cfa/arithmetic.scm 77 */
																			BgL_auxz00_3884 = ((bool_t) 0);
																		}
																	BBOOL(BgL_auxz00_3884);
																}
															}
														}
													else
														{	/* Cfa/arithmetic.scm 75 */
															BFALSE;
														}
												}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1487z00_3894;

							BgL_l1487z00_3894 = CDR(BgL_l1487z00_2637);
							BgL_l1487z00_2637 = BgL_l1487z00_3894;
							goto BgL_zc3anonymousza31572ze3z83_2638;
						}
					}
				else
					{	/* Cfa/arithmetic.scm 63 */
						((bool_t) 1);
					}
			}
			{
				obj_t BgL_l1489z00_2680;

				BgL_l1489z00_2680 = BgL_globalsz00_3;
			BgL_zc3anonymousza31626ze3z83_2681:
				if (PAIRP(BgL_l1489z00_2680))
					{	/* Cfa/arithmetic.scm 83 */
						{	/* Cfa/arithmetic.scm 83 */
							obj_t BgL_arg1631z00_2683;

							BgL_arg1631z00_2683 = CAR(BgL_l1489z00_2680);
							{	/* Cfa/arithmetic.scm 90 */
								BgL_valuez00_bglt BgL_funz00_3531;

								BgL_funz00_3531 =
									(((BgL_variablez00_bglt) CREF(
											((BgL_variablez00_bglt) BgL_arg1631z00_2683)))->
									BgL_valuez00);
								{	/* Cfa/arithmetic.scm 90 */
									obj_t BgL_bodyz00_3532;

									BgL_bodyz00_3532 =
										(((BgL_sfunz00_bglt) CREF(
												((BgL_sfunz00_bglt) BgL_funz00_3531)))->BgL_bodyz00);
									{	/* Cfa/arithmetic.scm 91 */

										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_bodyz00_3532));
									}
								}
							}
						}
						{
							obj_t BgL_l1489z00_3905;

							BgL_l1489z00_3905 = CDR(BgL_l1489z00_2680);
							BgL_l1489z00_2680 = BgL_l1489z00_3905;
							goto BgL_zc3anonymousza31626ze3z83_2681;
						}
					}
				else
					{	/* Cfa/arithmetic.scm 83 */
						((bool_t) 1);
					}
			}
			return BgL_globalsz00_3;
		}
	}



/* cleanup-type */
	obj_t BGl_cleanupzd2typezd2zzcfa_arithmeticz00(obj_t BgL_tz00_2686)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 62 */
			if (BGl_isazf3zf3zz__objectz00(BgL_tz00_2686, BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 55 */
					if ((BgL_tz00_2686 == BGl_za2_za2z00zztype_cachez00))
						{	/* Cfa/arithmetic.scm 56 */
							return BGl_za2objza2z00zztype_cachez00;
						}
					else
						{	/* Cfa/arithmetic.scm 56 */
							return BgL_tz00_2686;
						}
				}
			else
				{	/* Cfa/arithmetic.scm 55 */
					if (BGl_isazf3zf3zz__objectz00(BgL_tz00_2686,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 57 */
							{	/* Cfa/arithmetic.scm 58 */
								bool_t BgL_testz00_3913;

								{	/* Cfa/arithmetic.scm 58 */
									BgL_typez00_bglt BgL_arg1643z00_2692;

									BgL_arg1643z00_2692 =
										(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_tz00_2686))))->BgL_typez00);
									BgL_testz00_3913 =
										(
										((obj_t) BgL_arg1643z00_2692) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL_testz00_3913)
									{	/* Cfa/arithmetic.scm 59 */
										BgL_typez00_bglt BgL_vz00_3484;

										BgL_vz00_3484 =
											((BgL_typez00_bglt) BGl_za2objza2z00zztype_cachez00);
										((((BgL_variablez00_bglt) CREF(
														((BgL_variablez00_bglt)
															((BgL_localz00_bglt) BgL_tz00_2686))))->
												BgL_typez00) =
											((BgL_typez00_bglt) BgL_vz00_3484), BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 58 */
										BFALSE;
									}
							}
							return BgL_tz00_2686;
						}
					else
						{	/* Cfa/arithmetic.scm 57 */
							return BgL_tz00_2686;
						}
				}
		}
	}



/* &cleanup-arithmetic-nodes! */
	obj_t BGl_z62cleanupzd2arithmeticzd2nodesz12z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3721, obj_t BgL_globalsz00_3722)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 52 */
			return
				BGl_cleanupzd2arithmeticzd2nodesz12z12zzcfa_arithmeticz00
				(BgL_globalsz00_3722);
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_proc2038z00zzcfa_arithmeticz00, BGl_nodez00zzast_nodez00,
				BGl_string2039z00zzcfa_arithmeticz00);
		}
	}



/* &cleanup-node!1523 */
	obj_t BGl_z62cleanupzd2nodez121523za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3724, obj_t BgL_nodez00_3725)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 97 */
			return BUNSPEC;
		}
	}



/* cleanup-node! */
	obj_t BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(BgL_nodez00_bglt
		BgL_nodez00_5)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 97 */
			{	/* Cfa/arithmetic.scm 97 */
				obj_t BgL_method1525z00_2700;

				{	/* Cfa/arithmetic.scm 97 */
					obj_t BgL_res2007z00_3568;

					{	/* Cfa/arithmetic.scm 97 */
						long BgL_objzd2classzd2numz00_3541;

						{	/* Cfa/arithmetic.scm 97 */
							long BgL_res2001z00_3544;

							BgL_res2001z00_3544 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_5));
							BgL_objzd2classzd2numz00_3541 = BgL_res2001z00_3544;
						}
						{	/* Cfa/arithmetic.scm 97 */
							obj_t BgL_arg1664z00_3542;

							BgL_arg1664z00_3542 =
								PROCEDURE_REF(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
								(int) (((long) 1)));
							{	/* Cfa/arithmetic.scm 97 */
								int BgL_offsetz00_3546;

								BgL_offsetz00_3546 = (int) (BgL_objzd2classzd2numz00_3541);
								{	/* Cfa/arithmetic.scm 97 */
									long BgL_offsetz00_3547;

									BgL_offsetz00_3547 =
										((long) (BgL_offsetz00_3546) - OBJECT_TYPE);
									{	/* Cfa/arithmetic.scm 97 */
										long BgL_modz00_3548;

										{	/* Cfa/arithmetic.scm 97 */
											int BgL_arg1666z00_3549;

											BgL_arg1666z00_3549 = (int) (((long) 16));
											{	/* Cfa/arithmetic.scm 97 */
												long BgL_res2004z00_3559;

												{	/* Cfa/arithmetic.scm 97 */
													long BgL_auxz00_3933;

													BgL_auxz00_3933 = (long) (BgL_arg1666z00_3549);
													BgL_res2004z00_3559 =
														(BgL_offsetz00_3547 / BgL_auxz00_3933);
												}
												BgL_modz00_3548 = BgL_res2004z00_3559;
										}}
										{	/* Cfa/arithmetic.scm 97 */
											long BgL_restz00_3550;

											{	/* Cfa/arithmetic.scm 97 */
												int BgL_arg1665z00_3551;

												BgL_arg1665z00_3551 = (int) (((long) 16));
												{	/* Cfa/arithmetic.scm 97 */
													long BgL_res2006z00_3563;

													{	/* Cfa/arithmetic.scm 97 */
														long BgL_auxz00_3937;

														BgL_auxz00_3937 = (long) (BgL_arg1665z00_3551);
														BgL_res2006z00_3563 =
															(BgL_offsetz00_3547 % BgL_auxz00_3937);
													}
													BgL_restz00_3550 = BgL_res2006z00_3563;
											}}
											{	/* Cfa/arithmetic.scm 97 */

												BgL_res2007z00_3568 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_3542,
														(int) (BgL_modz00_3548)), (int) (BgL_restz00_3550));
					}}}}}}}
					BgL_method1525z00_2700 = BgL_res2007z00_3568;
				}
				return
					PROCEDURE_ENTRY(BgL_method1525z00_2700) (BgL_method1525z00_2700,
					((obj_t) BgL_nodez00_5), BEOA);
			}
		}
	}



/* &cleanup-node! */
	obj_t BGl_z62cleanupzd2nodez12za2zzcfa_arithmeticz00(obj_t BgL_envz00_3726,
		obj_t BgL_nodez00_3727)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 97 */
			return
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
				((BgL_nodez00_bglt) BgL_nodez00_3727));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2040z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_syncz00zzast_nodez00, BGl_proc2042z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_setqz00zzast_nodez00, BGl_proc2043z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2044z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_failz00zzast_nodez00, BGl_proc2045z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_selectz00zzast_nodez00, BGl_proc2046z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2047z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2048z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2049z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2050z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2051z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2052z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2053z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2054z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2055z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cleanupzd2nodez12zd2envz12zzcfa_arithmeticz00,
				BGl_appz00zzast_nodez00, BGl_proc2056z00zzcfa_arithmeticz00,
				BGl_string2041z00zzcfa_arithmeticz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_nodezd2setupz12zd2envz12zzcfa_setupz00,
				BGl_prezd2arithmeticzd2appz00zzcfa_info2z00,
				BGl_proc2057z00zzcfa_arithmeticz00,
				BGl_string2058z00zzcfa_arithmeticz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_cfaz12zd2envzc0zzcfa_cfaz00, BGl_arithmeticzd2appzd2zzcfa_info2z00,
				BGl_proc2059z00zzcfa_arithmeticz00,
				BGl_string2060z00zzcfa_arithmeticz00);
		}
	}



/* &cfa!-arithmetic-app1561 */
	BgL_approxz00_bglt
		BGl_z62cfaz12zd2arithmeticzd2app1561z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3746, obj_t BgL_nodez00_3747)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 287 */
			{
				BgL_appz00_bglt BgL_nodez00_2931;

				BgL_nodez00_2931 = ((BgL_appz00_bglt) BgL_nodez00_3747);
				{
					obj_t BgL_argszd2approxzd2_3010;

					{
						obj_t BgL_argszd2approxzd2_2992;
						obj_t BgL_typez00_2993;
						obj_t BgL_speczd2typeszd2_2994;

						{
							obj_t BgL_argszd2approxzd2_2978;
							obj_t BgL_speczd2typeszd2_2979;

							{	/* Cfa/arithmetic.scm 328 */
								obj_t BgL_argszd2approxzd2_2939;

								{	/* Cfa/arithmetic.scm 328 */
									obj_t BgL_l1515z00_2962;

									BgL_l1515z00_2962 =
										(((BgL_appz00_bglt) CREF(
												((BgL_appz00_bglt) BgL_nodez00_2931)))->BgL_argsz00);
									if (NULLP(BgL_l1515z00_2962))
										{	/* Cfa/arithmetic.scm 328 */
											BgL_argszd2approxzd2_2939 = BNIL;
										}
									else
										{	/* Cfa/arithmetic.scm 328 */
											obj_t BgL_head1517z00_2964;

											{	/* Cfa/arithmetic.scm 328 */
												BgL_approxz00_bglt BgL_arg1793z00_2976;

												{	/* Cfa/arithmetic.scm 328 */
													obj_t BgL_arg1794z00_2977;

													BgL_arg1794z00_2977 = CAR(BgL_l1515z00_2962);
													BgL_arg1793z00_2976 =
														BGl_cfaz12z12zzcfa_cfaz00(
														((BgL_nodez00_bglt) BgL_arg1794z00_2977));
												}
												{	/* Cfa/arithmetic.scm 328 */
													obj_t BgL_res2032z00_3703;

													BgL_res2032z00_3703 =
														MAKE_PAIR(((obj_t) BgL_arg1793z00_2976), BNIL);
													BgL_head1517z00_2964 = BgL_res2032z00_3703;
												}
											}
											{	/* Cfa/arithmetic.scm 328 */
												obj_t BgL_g1520z00_2965;

												BgL_g1520z00_2965 = CDR(BgL_l1515z00_2962);
												{
													obj_t BgL_l1515z00_2967;
													obj_t BgL_tail1518z00_2968;

													BgL_l1515z00_2967 = BgL_g1520z00_2965;
													BgL_tail1518z00_2968 = BgL_head1517z00_2964;
												BgL_zc3anonymousza31788ze3z83_2969:
													if (NULLP(BgL_l1515z00_2967))
														{	/* Cfa/arithmetic.scm 328 */
															BgL_argszd2approxzd2_2939 = BgL_head1517z00_2964;
														}
													else
														{	/* Cfa/arithmetic.scm 328 */
															obj_t BgL_newtail1519z00_2971;

															{	/* Cfa/arithmetic.scm 328 */
																BgL_approxz00_bglt BgL_arg1791z00_2973;

																{	/* Cfa/arithmetic.scm 328 */
																	obj_t BgL_arg1792z00_2974;

																	BgL_arg1792z00_2974 = CAR(BgL_l1515z00_2967);
																	BgL_arg1791z00_2973 =
																		BGl_cfaz12z12zzcfa_cfaz00(
																		((BgL_nodez00_bglt) BgL_arg1792z00_2974));
																}
																{	/* Cfa/arithmetic.scm 328 */
																	obj_t BgL_res2034z00_3710;

																	BgL_res2034z00_3710 =
																		MAKE_PAIR(
																		((obj_t) BgL_arg1791z00_2973), BNIL);
																	BgL_newtail1519z00_2971 = BgL_res2034z00_3710;
																}
															}
															SET_CDR(BgL_tail1518z00_2968,
																BgL_newtail1519z00_2971);
															{
																obj_t BgL_tail1518z00_3989;
																obj_t BgL_l1515z00_3987;

																BgL_l1515z00_3987 = CDR(BgL_l1515z00_2967);
																BgL_tail1518z00_3989 = BgL_newtail1519z00_2971;
																BgL_tail1518z00_2968 = BgL_tail1518z00_3989;
																BgL_l1515z00_2967 = BgL_l1515z00_3987;
																goto BgL_zc3anonymousza31788ze3z83_2969;
															}
														}
												}
											}
										}
								}
								{	/* Cfa/arithmetic.scm 330 */
									obj_t BgL_tyz00_2940;

									BgL_argszd2approxzd2_3010 = BgL_argszd2approxzd2_2939;
									{
										obj_t BgL_argsz00_3013;

										BgL_argsz00_3013 = BgL_argszd2approxzd2_3010;
									BgL_zc3anonymousza31812ze3z83_3014:
										if (NULLP(BgL_argsz00_3013))
											{	/* Cfa/arithmetic.scm 296 */
												BgL_tyz00_2940 = BFALSE;
											}
										else
											{	/* Cfa/arithmetic.scm 298 */
												obj_t BgL_tz00_3016;

												{	/* Cfa/arithmetic.scm 298 */
													BgL_typez00_bglt BgL_arg1816z00_3019;

													BgL_arg1816z00_3019 =
														(((BgL_approxz00_bglt) CREF(
																((BgL_approxz00_bglt)
																	CAR(BgL_argsz00_3013))))->BgL_typez00);
													if (
														(((obj_t) BgL_arg1816z00_3019) ==
															BGl_za2intza2z00zztype_cachez00))
														{	/* Cfa/arithmetic.scm 290 */
															BgL_tz00_3016 = BGl_za2longza2z00zztype_cachez00;
														}
													else
														{	/* Cfa/arithmetic.scm 290 */
															BgL_tz00_3016 = ((obj_t) BgL_arg1816z00_3019);
														}
												}
												if ((BgL_tz00_3016 == BGl_za2_za2z00zztype_cachez00))
													{
														obj_t BgL_argsz00_4001;

														BgL_argsz00_4001 = CDR(BgL_argsz00_3013);
														BgL_argsz00_3013 = BgL_argsz00_4001;
														goto BgL_zc3anonymousza31812ze3z83_3014;
													}
												else
													{	/* Cfa/arithmetic.scm 299 */
														BgL_tyz00_2940 = BgL_tz00_3016;
													}
											}
									}
									{	/* Cfa/arithmetic.scm 336 */
										bool_t BgL_testz00_4003;

										{	/* Cfa/arithmetic.scm 336 */
											obj_t BgL_arg1786z00_2961;

											{
												BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4004;

												{
													obj_t BgL_auxz00_4005;

													{	/* Cfa/arithmetic.scm 336 */
														BgL_objectz00_bglt BgL_auxz00_4006;

														BgL_auxz00_4006 =
															((BgL_objectz00_bglt) BgL_nodez00_2931);
														BgL_auxz00_4005 =
															BGL_OBJECT_WIDENING(BgL_auxz00_4006);
													}
													BgL_auxz00_4004 =
														((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4005);
												}
												BgL_arg1786z00_2961 =
													(((BgL_arithmeticzd2appzd2_bglt)
														CREF(BgL_auxz00_4004))->BgL_speczd2typeszd2);
											}
											BgL_argszd2approxzd2_2992 = BgL_argszd2approxzd2_2939;
											BgL_typez00_2993 = BgL_tyz00_2940;
											BgL_speczd2typeszd2_2994 = BgL_arg1786z00_2961;
											{	/* Cfa/arithmetic.scm 305 */
												bool_t BgL__ortest_1176z00_2996;

												if (CBOOL(BgL_typez00_2993))
													{	/* Cfa/arithmetic.scm 305 */
														BgL__ortest_1176z00_2996 = ((bool_t) 0);
													}
												else
													{	/* Cfa/arithmetic.scm 305 */
														BgL__ortest_1176z00_2996 = ((bool_t) 1);
													}
												if (BgL__ortest_1176z00_2996)
													{	/* Cfa/arithmetic.scm 305 */
														BgL_testz00_4003 = BgL__ortest_1176z00_2996;
													}
												else
													{	/* Cfa/arithmetic.scm 306 */
														obj_t BgL__andtest_1177z00_2997;

														BgL__andtest_1177z00_2997 =
															BGl_memqz00zz__r4_pairs_and_lists_6_3z00
															(BgL_typez00_2993, BgL_speczd2typeszd2_2994);
														if (CBOOL(BgL__andtest_1177z00_2997))
															{
																obj_t BgL_argsz00_2999;

																BgL_argsz00_2999 = BgL_argszd2approxzd2_2992;
															BgL_zc3anonymousza31804ze3z83_3000:
																if (NULLP(BgL_argsz00_2999))
																	{	/* Cfa/arithmetic.scm 308 */
																		BgL_testz00_4003 = ((bool_t) 1);
																	}
																else
																	{	/* Cfa/arithmetic.scm 310 */
																		obj_t BgL_tz00_3002;

																		{	/* Cfa/arithmetic.scm 310 */
																			BgL_typez00_bglt BgL_arg1809z00_3006;

																			BgL_arg1809z00_3006 =
																				(((BgL_approxz00_bglt) CREF(
																						((BgL_approxz00_bglt)
																							CAR(BgL_argsz00_2999))))->
																				BgL_typez00);
																			if ((((obj_t) BgL_arg1809z00_3006) ==
																					BGl_za2intza2z00zztype_cachez00))
																				{	/* Cfa/arithmetic.scm 290 */
																					BgL_tz00_3002 =
																						BGl_za2longza2z00zztype_cachez00;
																				}
																			else
																				{	/* Cfa/arithmetic.scm 290 */
																					BgL_tz00_3002 =
																						((obj_t) BgL_arg1809z00_3006);
																				}
																		}
																		{	/* Cfa/arithmetic.scm 311 */
																			bool_t BgL_testz00_4026;

																			if ((BgL_tz00_3002 == BgL_typez00_2993))
																				{	/* Cfa/arithmetic.scm 311 */
																					BgL_testz00_4026 = ((bool_t) 1);
																				}
																			else
																				{	/* Cfa/arithmetic.scm 311 */
																					BgL_testz00_4026 =
																						(BgL_tz00_3002 ==
																						BGl_za2_za2z00zztype_cachez00);
																				}
																			if (BgL_testz00_4026)
																				{
																					obj_t BgL_argsz00_4030;

																					BgL_argsz00_4030 =
																						CDR(BgL_argsz00_2999);
																					BgL_argsz00_2999 = BgL_argsz00_4030;
																					goto
																						BgL_zc3anonymousza31804ze3z83_3000;
																				}
																			else
																				{	/* Cfa/arithmetic.scm 311 */
																					BgL_testz00_4003 = ((bool_t) 0);
																				}
																		}
																	}
															}
														else
															{	/* Cfa/arithmetic.scm 306 */
																BgL_testz00_4003 = ((bool_t) 0);
															}
													}
											}
										}
										if (BgL_testz00_4003)
											{	/* Cfa/arithmetic.scm 336 */
												{	/* Cfa/arithmetic.scm 339 */
													bool_t BgL_testz00_4032;

													{	/* Cfa/arithmetic.scm 339 */
														bool_t BgL_testz00_4033;

														{	/* Cfa/arithmetic.scm 339 */
															obj_t BgL_arg1775z00_2947;

															{
																BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4034;

																{
																	obj_t BgL_auxz00_4035;

																	{	/* Cfa/arithmetic.scm 339 */
																		BgL_objectz00_bglt BgL_auxz00_4036;

																		BgL_auxz00_4036 =
																			((BgL_objectz00_bglt) BgL_nodez00_2931);
																		BgL_auxz00_4035 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_4036);
																	}
																	BgL_auxz00_4034 =
																		((BgL_arithmeticzd2appzd2_bglt)
																		BgL_auxz00_4035);
																}
																BgL_arg1775z00_2947 =
																	(((BgL_arithmeticzd2appzd2_bglt)
																		CREF(BgL_auxz00_4034))->
																	BgL_speczd2typeszd2);
															}
															BgL_argszd2approxzd2_2978 =
																BgL_argszd2approxzd2_2939;
															BgL_speczd2typeszd2_2979 = BgL_arg1775z00_2947;
															{
																obj_t BgL_argsz00_2982;

																BgL_argsz00_2982 = BgL_argszd2approxzd2_2978;
															BgL_zc3anonymousza31796ze3z83_2983:
																if (NULLP(BgL_argsz00_2982))
																	{	/* Cfa/arithmetic.scm 318 */
																		BgL_testz00_4033 = ((bool_t) 1);
																	}
																else
																	{	/* Cfa/arithmetic.scm 320 */
																		bool_t BgL_testz00_4043;

																		{	/* Cfa/arithmetic.scm 320 */
																			obj_t BgL_arg1800z00_2987;

																			{	/* Cfa/arithmetic.scm 320 */
																				BgL_typez00_bglt BgL_arg1801z00_2988;

																				BgL_arg1801z00_2988 =
																					(((BgL_approxz00_bglt) CREF(
																							((BgL_approxz00_bglt)
																								CAR(BgL_argsz00_2982))))->
																					BgL_typez00);
																				if ((((obj_t) BgL_arg1801z00_2988) ==
																						BGl_za2intza2z00zztype_cachez00))
																					{	/* Cfa/arithmetic.scm 290 */
																						BgL_arg1800z00_2987 =
																							BGl_za2longza2z00zztype_cachez00;
																					}
																				else
																					{	/* Cfa/arithmetic.scm 290 */
																						BgL_arg1800z00_2987 =
																							((obj_t) BgL_arg1801z00_2988);
																					}
																			}
																			BgL_testz00_4043 =
																				CBOOL
																				(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
																				(BgL_arg1800z00_2987,
																					BgL_speczd2typeszd2_2979));
																		}
																		if (BgL_testz00_4043)
																			{
																				obj_t BgL_argsz00_4053;

																				BgL_argsz00_4053 =
																					CDR(BgL_argsz00_2982);
																				BgL_argsz00_2982 = BgL_argsz00_4053;
																				goto BgL_zc3anonymousza31796ze3z83_2983;
																			}
																		else
																			{	/* Cfa/arithmetic.scm 320 */
																				BgL_testz00_4033 = ((bool_t) 0);
																			}
																	}
															}
														}
														if (BgL_testz00_4033)
															{	/* Cfa/arithmetic.scm 340 */
																BgL_typez00_bglt BgL_arg1773z00_2945;

																{
																	BgL_approxz00_bglt BgL_auxz00_4055;

																	{
																		BgL_arithmeticzd2appzd2_bglt
																			BgL_auxz00_4056;
																		{
																			obj_t BgL_auxz00_4057;

																			{	/* Cfa/arithmetic.scm 340 */
																				BgL_objectz00_bglt BgL_auxz00_4058;

																				BgL_auxz00_4058 =
																					((BgL_objectz00_bglt)
																					BgL_nodez00_2931);
																				BgL_auxz00_4057 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_4058);
																			}
																			BgL_auxz00_4056 =
																				((BgL_arithmeticzd2appzd2_bglt)
																				BgL_auxz00_4057);
																		}
																		BgL_auxz00_4055 =
																			(((BgL_arithmeticzd2appzd2_bglt)
																				CREF(BgL_auxz00_4056))->BgL_approxz00);
																	}
																	BgL_arg1773z00_2945 =
																		(((BgL_approxz00_bglt)
																			CREF(BgL_auxz00_4055))->BgL_typez00);
																}
																BgL_testz00_4032 =
																	(
																	((obj_t) BgL_arg1773z00_2945) ==
																	BGl_za2_za2z00zztype_cachez00);
															}
														else
															{	/* Cfa/arithmetic.scm 339 */
																BgL_testz00_4032 = ((bool_t) 0);
															}
													}
													if (BgL_testz00_4032)
														{	/* Cfa/arithmetic.scm 339 */
															{	/* Cfa/arithmetic.scm 343 */
																BgL_approxz00_bglt BgL_arg1770z00_2943;

																{
																	BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4066;

																	{
																		obj_t BgL_auxz00_4067;

																		{	/* Cfa/arithmetic.scm 343 */
																			BgL_objectz00_bglt BgL_auxz00_4068;

																			BgL_auxz00_4068 =
																				((BgL_objectz00_bglt) BgL_nodez00_2931);
																			BgL_auxz00_4067 =
																				BGL_OBJECT_WIDENING(BgL_auxz00_4068);
																		}
																		BgL_auxz00_4066 =
																			((BgL_arithmeticzd2appzd2_bglt)
																			BgL_auxz00_4067);
																	}
																	BgL_arg1770z00_2943 =
																		(((BgL_arithmeticzd2appzd2_bglt)
																			CREF(BgL_auxz00_4066))->BgL_approxz00);
																}
																BGl_approxzd2setzd2typez12z12zzcfa_approxz00
																	(BgL_arg1770z00_2943,
																	((BgL_typez00_bglt) BgL_tyz00_2940));
															}
															BGl_continuezd2cfaz12zc0zzcfa_iteratez00
																(CNST_TABLE_REF(((long) 0)));
														}
													else
														{	/* Cfa/arithmetic.scm 339 */
															BFALSE;
														}
												}
											}
										else
											{	/* Cfa/arithmetic.scm 345 */
												bool_t BgL_testz00_4077;

												if (
													((((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt)
																		((BgL_globalz00_bglt)
																			(((BgL_varz00_bglt) CREF(
																						(((BgL_appz00_bglt) CREF(
																									((BgL_appz00_bglt)
																										BgL_nodez00_2931)))->
																							BgL_funz00)))->
																				BgL_variablez00)))))->BgL_idz00) ==
														CNST_TABLE_REF(((long) 1))))
													{	/* Cfa/arithmetic.scm 345 */
														BgL_testz00_4077 = ((bool_t) 0);
													}
												else
													{	/* Cfa/arithmetic.scm 345 */
														BgL_testz00_4077 = ((bool_t) 1);
													}
												if (BgL_testz00_4077)
													{	/* Cfa/arithmetic.scm 345 */
														{
															obj_t BgL_l1521z00_2950;

															BgL_l1521z00_2950 = BgL_argszd2approxzd2_2939;
														BgL_zc3anonymousza31777ze3z83_2951:
															if (PAIRP(BgL_l1521z00_2950))
																{	/* Cfa/arithmetic.scm 346 */
																	{	/* Cfa/arithmetic.scm 346 */
																		obj_t BgL_az00_2953;

																		BgL_az00_2953 = CAR(BgL_l1521z00_2950);
																		BGl_loosez12z12zzcfa_loosez00(
																			((BgL_approxz00_bglt) BgL_az00_2953),
																			CNST_TABLE_REF(((long) 2)));
																	}
																	{
																		obj_t BgL_l1521z00_4093;

																		BgL_l1521z00_4093 = CDR(BgL_l1521z00_2950);
																		BgL_l1521z00_2950 = BgL_l1521z00_4093;
																		goto BgL_zc3anonymousza31777ze3z83_2951;
																	}
																}
															else
																{	/* Cfa/arithmetic.scm 346 */
																	((bool_t) 1);
																}
														}
														{	/* Cfa/arithmetic.scm 347 */
															BgL_approxz00_bglt BgL_arg1780z00_2956;

															{
																BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4095;

																{
																	obj_t BgL_auxz00_4096;

																	{	/* Cfa/arithmetic.scm 347 */
																		BgL_objectz00_bglt BgL_auxz00_4097;

																		BgL_auxz00_4097 =
																			((BgL_objectz00_bglt) BgL_nodez00_2931);
																		BgL_auxz00_4096 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_4097);
																	}
																	BgL_auxz00_4095 =
																		((BgL_arithmeticzd2appzd2_bglt)
																		BgL_auxz00_4096);
																}
																BgL_arg1780z00_2956 =
																	(((BgL_arithmeticzd2appzd2_bglt)
																		CREF(BgL_auxz00_4095))->BgL_approxz00);
															}
															BGl_approxzd2setzd2typez12z12zzcfa_approxz00
																(BgL_arg1780z00_2956,
																((BgL_typez00_bglt)
																	BGl_za2objza2z00zztype_cachez00));
														}
													}
												else
													{	/* Cfa/arithmetic.scm 345 */
														BFALSE;
													}
											}
									}
								}
							}
							{
								BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4104;

								{
									obj_t BgL_auxz00_4105;

									{	/* Cfa/arithmetic.scm 350 */
										BgL_objectz00_bglt BgL_auxz00_4106;

										BgL_auxz00_4106 = ((BgL_objectz00_bglt) BgL_nodez00_2931);
										BgL_auxz00_4105 = BGL_OBJECT_WIDENING(BgL_auxz00_4106);
									}
									BgL_auxz00_4104 =
										((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4105);
								}
								return
									(((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_4104))->
									BgL_approxz00);
							}
						}
					}
				}
			}
		}
	}



/* &node-setup!-pre-arit1559 */
	obj_t BGl_z62nodezd2setupz12zd2prezd2arit1559za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3748, obj_t BgL_nodez00_3749)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 244 */
			{
				BgL_appz00_bglt BgL_nodez00_2872;

				BgL_nodez00_2872 = ((BgL_appz00_bglt) BgL_nodez00_3749);
				{	/* Cfa/arithmetic.scm 255 */
					BgL_variablez00_bglt BgL_fz00_2877;

					BgL_fz00_2877 =
						(((BgL_varz00_bglt) CREF(
								(((BgL_appz00_bglt) CREF(
											((BgL_appz00_bglt) BgL_nodez00_2872)))->BgL_funz00)))->
						BgL_variablez00);
					{	/* Cfa/arithmetic.scm 255 */
						BgL_valuez00_bglt BgL_valz00_2878;

						BgL_valz00_2878 =
							(((BgL_variablez00_bglt) CREF(BgL_fz00_2877))->BgL_valuez00);
						{	/* Cfa/arithmetic.scm 256 */

							{	/* Cfa/arithmetic.scm 258 */
								bool_t BgL_testz00_4116;

								{	/* Cfa/arithmetic.scm 258 */
									BgL_typez00_bglt BgL_arg1735z00_2880;

									BgL_arg1735z00_2880 =
										(((BgL_variablez00_bglt) CREF(BgL_fz00_2877))->BgL_typez00);
									BgL_testz00_4116 =
										(
										((obj_t) BgL_arg1735z00_2880) ==
										BGl_za2objza2z00zztype_cachez00);
								}
								if (BgL_testz00_4116)
									{	/* Cfa/arithmetic.scm 258 */
										{	/* Cfa/arithmetic.scm 261 */
											BgL_typez00_bglt BgL_vz00_3623;

											BgL_vz00_3623 =
												((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
											((((BgL_variablez00_bglt) CREF(BgL_fz00_2877))->
													BgL_typez00) =
												((BgL_typez00_bglt) BgL_vz00_3623), BUNSPEC);
										}
										{	/* Cfa/arithmetic.scm 262 */
											BgL_typez00_bglt BgL_vz00_3625;

											BgL_vz00_3625 =
												((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
											((((BgL_nodez00_bglt) CREF(
															((BgL_nodez00_bglt) BgL_nodez00_2872)))->
													BgL_typez00) =
												((BgL_typez00_bglt) BgL_vz00_3625), BUNSPEC);
										}
									}
								else
									{	/* Cfa/arithmetic.scm 258 */
										BFALSE;
									}
							}
							{	/* Cfa/arithmetic.scm 264 */
								bool_t BgL_testz00_4125;

								{	/* Cfa/arithmetic.scm 264 */
									bool_t BgL_res2017z00_3627;

									BgL_res2017z00_3627 =
										BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_valz00_2878), BGl_sfunz00zzast_varz00);
									BgL_testz00_4125 = BgL_res2017z00_3627;
								}
								if (BgL_testz00_4125)
									{	/* Cfa/arithmetic.scm 265 */
										obj_t BgL_arg1738z00_2882;

										{	/* Cfa/arithmetic.scm 265 */
											obj_t BgL_l1509z00_2883;

											BgL_l1509z00_2883 =
												(((BgL_sfunz00_bglt) CREF(
														((BgL_sfunz00_bglt) BgL_valz00_2878)))->
												BgL_argsz00);
											if (NULLP(BgL_l1509z00_2883))
												{	/* Cfa/arithmetic.scm 265 */
													BgL_arg1738z00_2882 = BNIL;
												}
											else
												{	/* Cfa/arithmetic.scm 265 */
													obj_t BgL_head1511z00_2885;

													{	/* Cfa/arithmetic.scm 265 */
														obj_t BgL_arg1747z00_2897;

														BgL_arg1747z00_2897 =
															BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(CAR
															(BgL_l1509z00_2883));
														{	/* Cfa/arithmetic.scm 265 */
															obj_t BgL_res2019z00_3634;

															BgL_res2019z00_3634 =
																MAKE_PAIR(BgL_arg1747z00_2897, BNIL);
															BgL_head1511z00_2885 = BgL_res2019z00_3634;
														}
													}
													{	/* Cfa/arithmetic.scm 265 */
														obj_t BgL_g1514z00_2886;

														BgL_g1514z00_2886 = CDR(BgL_l1509z00_2883);
														{
															obj_t BgL_l1509z00_2888;
															obj_t BgL_tail1512z00_2889;

															BgL_l1509z00_2888 = BgL_g1514z00_2886;
															BgL_tail1512z00_2889 = BgL_head1511z00_2885;
														BgL_zc3anonymousza31740ze3z83_2890:
															if (NULLP(BgL_l1509z00_2888))
																{	/* Cfa/arithmetic.scm 265 */
																	BgL_arg1738z00_2882 = BgL_head1511z00_2885;
																}
															else
																{	/* Cfa/arithmetic.scm 265 */
																	obj_t BgL_newtail1513z00_2892;

																	{	/* Cfa/arithmetic.scm 265 */
																		obj_t BgL_arg1744z00_2894;

																		BgL_arg1744z00_2894 =
																			BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00
																			(CAR(BgL_l1509z00_2888));
																		{	/* Cfa/arithmetic.scm 265 */
																			obj_t BgL_res2021z00_3641;

																			BgL_res2021z00_3641 =
																				MAKE_PAIR(BgL_arg1744z00_2894, BNIL);
																			BgL_newtail1513z00_2892 =
																				BgL_res2021z00_3641;
																		}
																	}
																	SET_CDR(BgL_tail1512z00_2889,
																		BgL_newtail1513z00_2892);
																	{
																		obj_t BgL_tail1512z00_4144;
																		obj_t BgL_l1509z00_4142;

																		BgL_l1509z00_4142 = CDR(BgL_l1509z00_2888);
																		BgL_tail1512z00_4144 =
																			BgL_newtail1513z00_2892;
																		BgL_tail1512z00_2889 = BgL_tail1512z00_4144;
																		BgL_l1509z00_2888 = BgL_l1509z00_4142;
																		goto BgL_zc3anonymousza31740ze3z83_2890;
																	}
																}
														}
													}
												}
										}
										((((BgL_sfunz00_bglt) CREF(
														((BgL_sfunz00_bglt) BgL_valz00_2878)))->
												BgL_argsz00) = ((obj_t) BgL_arg1738z00_2882), BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 266 */
										bool_t BgL_testz00_4147;

										{	/* Cfa/arithmetic.scm 266 */
											bool_t BgL_res2022z00_3648;

											BgL_res2022z00_3648 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_valz00_2878), BGl_cfunz00zzast_varz00);
											BgL_testz00_4147 = BgL_res2022z00_3648;
										}
										if (BgL_testz00_4147)
											{	/* Cfa/arithmetic.scm 267 */
												obj_t BgL_g1170z00_2900;

												BgL_g1170z00_2900 =
													(((BgL_cfunz00_bglt) CREF(
															((BgL_cfunz00_bglt) BgL_valz00_2878)))->
													BgL_argszd2typezd2);
												{
													obj_t BgL_lz00_2902;

													BgL_lz00_2902 = BgL_g1170z00_2900;
												BgL_zc3anonymousza31750ze3z83_2903:
													if (PAIRP(BgL_lz00_2902))
														{	/* Cfa/arithmetic.scm 269 */
															obj_t BgL_auxz00_4154;

															BgL_auxz00_4154 =
																BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(CAR
																(BgL_lz00_2902));
															SET_CAR(BgL_lz00_2902, BgL_auxz00_4154);
														}
													else
														{
															obj_t BgL_lz00_4158;

															BgL_lz00_4158 = CDR(BgL_lz00_2902);
															BgL_lz00_2902 = BgL_lz00_4158;
															goto BgL_zc3anonymousza31750ze3z83_2903;
														}
												}
											}
										else
											{	/* Cfa/arithmetic.scm 266 */
												BGl_errorz00zz__errorz00
													(BGl_string2058z00zzcfa_arithmeticz00,
													BGl_string2061z00zzcfa_arithmeticz00,
													((obj_t) BgL_nodez00_2872));
											}
									}
							}
							BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00 =
								MAKE_PAIR(
								((obj_t) BgL_nodez00_2872),
								BGl_za2arithmeticzd2nodesza2zd2zzcfa_arithmeticz00);
							{	/* Cfa/arithmetic.scm 275 */
								obj_t BgL_arg1756z00_2909;

								BgL_arg1756z00_2909 =
									(((BgL_appz00_bglt) CREF(
											((BgL_appz00_bglt) BgL_nodez00_2872)))->BgL_argsz00);
								BGl_nodezd2setupza2z12z62zzcfa_setupz00(BgL_arg1756z00_2909);
							}
							{	/* Cfa/arithmetic.scm 276 */
								obj_t BgL_speczd2typeszd2_2910;

								{
									BgL_prezd2arithmeticzd2appz00_bglt BgL_auxz00_4167;

									{
										obj_t BgL_auxz00_4168;

										{	/* Cfa/arithmetic.scm 276 */
											BgL_objectz00_bglt BgL_auxz00_4169;

											BgL_auxz00_4169 = ((BgL_objectz00_bglt) BgL_nodez00_2872);
											BgL_auxz00_4168 = BGL_OBJECT_WIDENING(BgL_auxz00_4169);
										}
										BgL_auxz00_4167 =
											((BgL_prezd2arithmeticzd2appz00_bglt) BgL_auxz00_4168);
									}
									BgL_speczd2typeszd2_2910 =
										(((BgL_prezd2arithmeticzd2appz00_bglt)
											CREF(BgL_auxz00_4167))->BgL_speczd2typeszd2);
								}
								{	/* Cfa/arithmetic.scm 276 */
									BgL_appz00_bglt BgL_nodez00_2911;

									{	/* Cfa/arithmetic.scm 277 */
										long BgL_arg1761z00_2921;

										{	/* Cfa/arithmetic.scm 277 */
											obj_t BgL_arg1762z00_2922;

											{	/* Cfa/arithmetic.scm 277 */
												obj_t BgL_arg1763z00_2923;

												{	/* Cfa/arithmetic.scm 277 */
													long BgL_arg1667z00_3657;

													{	/* Cfa/arithmetic.scm 277 */
														long BgL_arg1668z00_3658;

														{	/* Cfa/arithmetic.scm 277 */
															long BgL_res2024z00_3660;

															BgL_res2024z00_3660 =
																BGL_OBJECT_CLASS_NUM(
																((BgL_objectz00_bglt) BgL_nodez00_2872));
															BgL_arg1668z00_3658 = BgL_res2024z00_3660;
														}
														BgL_arg1667z00_3657 =
															(BgL_arg1668z00_3658 - OBJECT_TYPE);
													}
													BgL_arg1763z00_2923 =
														VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
														(int) (BgL_arg1667z00_3657));
												}
												BgL_arg1762z00_2922 =
													BGl_classzd2superzd2zz__objectz00
													(BgL_arg1763z00_2923);
											}
											{	/* Cfa/arithmetic.scm 277 */
												long BgL_res2026z00_3667;

												BgL_res2026z00_3667 =
													BGL_CLASS_INDEX(BgL_arg1762z00_2922);
												BgL_arg1761z00_2921 = BgL_res2026z00_3667;
										}}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_nodez00_2872),
											BgL_arg1761z00_2921);
									}
									{	/* Cfa/arithmetic.scm 277 */
										BgL_objectz00_bglt BgL_auxz00_4183;

										BgL_auxz00_4183 = ((BgL_objectz00_bglt) BgL_nodez00_2872);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_4183, BFALSE);
									}
									BgL_nodez00_2911 = BgL_nodez00_2872;
									{	/* Cfa/arithmetic.scm 277 */

										{	/* Cfa/arithmetic.scm 278 */
											BgL_arithmeticzd2appzd2_bglt BgL_wide1174z00_2914;

											BgL_wide1174z00_2914 =
												((BgL_arithmeticzd2appzd2_bglt)
												BREF(GC_MALLOC(sizeof(struct
															BgL_arithmeticzd2appzd2_bgl))));
											{	/* Cfa/arithmetic.scm 278 */
												obj_t BgL_auxz00_4191;
												BgL_objectz00_bglt BgL_auxz00_4187;

												BgL_auxz00_4191 = ((obj_t) BgL_wide1174z00_2914);
												BgL_auxz00_4187 =
													((BgL_objectz00_bglt)
													((BgL_appz00_bglt)
														((BgL_appz00_bglt) BgL_nodez00_2911)));
												BGL_OBJECT_WIDENING_SET(BgL_auxz00_4187,
													BgL_auxz00_4191);
											}
											{	/* Cfa/arithmetic.scm 278 */
												long BgL_arg1757z00_2915;

												{	/* Cfa/arithmetic.scm 278 */
													long BgL_res2027z00_3671;

													BgL_res2027z00_3671 =
														BGL_CLASS_INDEX
														(BGl_arithmeticzd2appzd2zzcfa_info2z00);
													BgL_arg1757z00_2915 = BgL_res2027z00_3671;
												}
												((BgL_appz00_bglt)
													BGL_OBJECT_CLASS_NUM_SET(
														((BgL_objectz00_bglt)
															((BgL_appz00_bglt)
																((BgL_appz00_bglt) BgL_nodez00_2911))),
														BgL_arg1757z00_2915));
											}
											((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2911));
										}
										{
											BgL_approxz00_bglt BgL_auxz00_4210;
											BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4202;

											{	/* Cfa/arithmetic.scm 280 */
												bool_t BgL_testz00_4211;

												{	/* Cfa/arithmetic.scm 280 */
													BgL_typez00_bglt BgL_arg1760z00_2919;

													BgL_arg1760z00_2919 =
														(((BgL_variablez00_bglt) CREF(BgL_fz00_2877))->
														BgL_typez00);
													BgL_testz00_4211 =
														(((obj_t) BgL_arg1760z00_2919) ==
														BGl_za2_za2z00zztype_cachez00);
												}
												if (BgL_testz00_4211)
													{	/* Cfa/arithmetic.scm 280 */
														BgL_auxz00_4210 =
															BGl_makezd2emptyzd2approxz00zzcfa_approxz00();
													}
												else
													{	/* Cfa/arithmetic.scm 282 */
														BgL_typez00_bglt BgL_arg1759z00_2918;

														BgL_arg1759z00_2918 =
															(((BgL_variablez00_bglt) CREF(BgL_fz00_2877))->
															BgL_typez00);
														BgL_auxz00_4210 =
															BGl_makezd2typezd2approxz00zzcfa_approxz00
															(BgL_arg1759z00_2918);
													}
											}
											{
												obj_t BgL_auxz00_4203;

												{	/* Cfa/arithmetic.scm 280 */
													BgL_objectz00_bglt BgL_auxz00_4204;

													BgL_auxz00_4204 =
														((BgL_objectz00_bglt)
														((BgL_appz00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_2911)));
													BgL_auxz00_4203 =
														BGL_OBJECT_WIDENING(BgL_auxz00_4204);
												}
												BgL_auxz00_4202 =
													((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4203);
											}
											((((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_4202))->
													BgL_approxz00) =
												((BgL_approxz00_bglt) BgL_auxz00_4210), BUNSPEC);
										}
										{
											BgL_arithmeticzd2appzd2_bglt BgL_auxz00_4219;

											{
												obj_t BgL_auxz00_4220;

												{	/* Cfa/arithmetic.scm 279 */
													BgL_objectz00_bglt BgL_auxz00_4221;

													BgL_auxz00_4221 =
														((BgL_objectz00_bglt)
														((BgL_appz00_bglt)
															((BgL_appz00_bglt) BgL_nodez00_2911)));
													BgL_auxz00_4220 =
														BGL_OBJECT_WIDENING(BgL_auxz00_4221);
												}
												BgL_auxz00_4219 =
													((BgL_arithmeticzd2appzd2_bglt) BgL_auxz00_4220);
											}
											((((BgL_arithmeticzd2appzd2_bglt) CREF(BgL_auxz00_4219))->
													BgL_speczd2typeszd2) =
												((obj_t) BgL_speczd2typeszd2_2910), BUNSPEC);
										}
										return
											((obj_t)
											((BgL_appz00_bglt) ((BgL_appz00_bglt) BgL_nodez00_2911)));
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* unspecified-type */
	obj_t BGl_unspecifiedzd2typezd2zzcfa_arithmeticz00(obj_t BgL_lz00_2925)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 253 */
			if (BGl_isazf3zf3zz__objectz00(BgL_lz00_2925, BGl_typez00zztype_typez00))
				{	/* Cfa/arithmetic.scm 247 */
					return BGl_za2_za2z00zztype_cachez00;
				}
			else
				{	/* Cfa/arithmetic.scm 247 */
					if (BGl_isazf3zf3zz__objectz00(BgL_lz00_2925,
							BGl_localz00zzast_varz00))
						{	/* Cfa/arithmetic.scm 249 */
							{	/* Cfa/arithmetic.scm 250 */
								BgL_typez00_bglt BgL_vz00_3618;

								BgL_vz00_3618 =
									((BgL_typez00_bglt) BGl_za2_za2z00zztype_cachez00);
								((((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt)
													((BgL_localz00_bglt) BgL_lz00_2925))))->BgL_typez00) =
									((BgL_typez00_bglt) BgL_vz00_3618), BUNSPEC);
							}
							return BgL_lz00_2925;
						}
					else
						{	/* Cfa/arithmetic.scm 249 */
							return BgL_lz00_2925;
						}
				}
		}
	}



/* &cleanup-node!-app1557 */
	obj_t BGl_z62cleanupzd2nodez12zd2app1557z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3750, obj_t BgL_nodez00_3751)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 231 */
			{
				BgL_appz00_bglt BgL_nodez00_2858;

				{	/* Cfa/arithmetic.scm 232 */
					bool_t BgL_auxz00_4240;

					BgL_nodez00_2858 = ((BgL_appz00_bglt) BgL_nodez00_3751);
					{	/* Cfa/arithmetic.scm 233 */
						BgL_varz00_bglt BgL_arg1728z00_2862;

						BgL_arg1728z00_2862 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_2858))->BgL_funz00);
						BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
							((BgL_nodez00_bglt) BgL_arg1728z00_2862));
					}
					{	/* Cfa/arithmetic.scm 234 */
						obj_t BgL_g1508z00_2863;

						BgL_g1508z00_2863 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_2858))->BgL_argsz00);
						{
							obj_t BgL_l1506z00_2865;

							BgL_l1506z00_2865 = BgL_g1508z00_2863;
						BgL_zc3anonymousza31729ze3z83_2866:
							if (PAIRP(BgL_l1506z00_2865))
								{	/* Cfa/arithmetic.scm 234 */
									{	/* Cfa/arithmetic.scm 234 */
										obj_t BgL_arg1731z00_2868;

										BgL_arg1731z00_2868 = CAR(BgL_l1506z00_2865);
										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_arg1731z00_2868));
									}
									{
										obj_t BgL_l1506z00_4250;

										BgL_l1506z00_4250 = CDR(BgL_l1506z00_2865);
										BgL_l1506z00_2865 = BgL_l1506z00_4250;
										goto BgL_zc3anonymousza31729ze3z83_2866;
									}
								}
							else
								{	/* Cfa/arithmetic.scm 234 */
									BgL_auxz00_4240 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_4240);
				}
			}
		}
	}



/* &cleanup-node!-funcal1555 */
	obj_t BGl_z62cleanupzd2nodez12zd2funcal1555z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3752, obj_t BgL_nodez00_3753)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 223 */
			{
				BgL_funcallz00_bglt BgL_nodez00_2844;

				{	/* Cfa/arithmetic.scm 224 */
					bool_t BgL_auxz00_4254;

					BgL_nodez00_2844 = ((BgL_funcallz00_bglt) BgL_nodez00_3753);
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_2844))->BgL_funz00));
					{	/* Cfa/arithmetic.scm 226 */
						obj_t BgL_g1505z00_2849;

						BgL_g1505z00_2849 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_2844))->BgL_argsz00);
						{
							obj_t BgL_l1503z00_2851;

							BgL_l1503z00_2851 = BgL_g1505z00_2849;
						BgL_zc3anonymousza31722ze3z83_2852:
							if (PAIRP(BgL_l1503z00_2851))
								{	/* Cfa/arithmetic.scm 226 */
									{	/* Cfa/arithmetic.scm 226 */
										obj_t BgL_arg1724z00_2854;

										BgL_arg1724z00_2854 = CAR(BgL_l1503z00_2851);
										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_arg1724z00_2854));
									}
									{
										obj_t BgL_l1503z00_4263;

										BgL_l1503z00_4263 = CDR(BgL_l1503z00_2851);
										BgL_l1503z00_2851 = BgL_l1503z00_4263;
										goto BgL_zc3anonymousza31722ze3z83_2852;
									}
								}
							else
								{	/* Cfa/arithmetic.scm 226 */
									BgL_auxz00_4254 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_4254);
				}
			}
		}
	}



/* &cleanup-node!-app-ly1553 */
	obj_t BGl_z62cleanupzd2nodez12zd2appzd2ly1553za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3754, obj_t BgL_nodez00_3755)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 215 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_2837;

				BgL_nodez00_2837 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_3755);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_2837))->BgL_funz00));
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_2837))->BgL_argz00));
			}
		}
	}



/* &cleanup-node!-box-se1551 */
	obj_t BGl_z62cleanupzd2nodez12zd2boxzd2se1551za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3756, obj_t BgL_nodez00_3757)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 207 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_2830;

				BgL_nodez00_2830 = ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3757);
				{	/* Cfa/arithmetic.scm 209 */
					BgL_varz00_bglt BgL_arg1716z00_2834;

					BgL_arg1716z00_2834 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_2830))->BgL_varz00);
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
						((BgL_nodez00_bglt) BgL_arg1716z00_2834));
				}
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_2830))->BgL_valuez00));
			}
		}
	}



/* &cleanup-node!-box-re1549 */
	obj_t BGl_z62cleanupzd2nodez12zd2boxzd2re1549za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3758, obj_t BgL_nodez00_3759)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 200 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_2824;

				BgL_nodez00_2824 = ((BgL_boxzd2refzd2_bglt) BgL_nodez00_3759);
				{	/* Cfa/arithmetic.scm 202 */
					BgL_varz00_bglt BgL_arg1715z00_3604;

					BgL_arg1715z00_3604 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_2824))->BgL_varz00);
					return
						BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
						((BgL_nodez00_bglt) BgL_arg1715z00_3604));
				}
			}
		}
	}



/* &cleanup-node!-make-b1547 */
	obj_t BGl_z62cleanupzd2nodez12zd2makezd2b1547za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3760, obj_t BgL_nodez00_3761)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 193 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_2818;

				BgL_nodez00_2818 = ((BgL_makezd2boxzd2_bglt) BgL_nodez00_3761);
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_2818))->BgL_valuez00));
			}
		}
	}



/* &cleanup-node!-jump-e1545 */
	obj_t BGl_z62cleanupzd2nodez12zd2jumpzd2e1545za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3762, obj_t BgL_nodez00_3763)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 185 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_2811;

				BgL_nodez00_2811 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3763);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_2811))->BgL_exitz00));
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_2811))->
						BgL_valuez00));
			}
		}
	}



/* &cleanup-node!-set-ex1543 */
	obj_t BGl_z62cleanupzd2nodez12zd2setzd2ex1543za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3764, obj_t BgL_nodez00_3765)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 177 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_2804;

				BgL_nodez00_2804 = ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3765);
				{	/* Cfa/arithmetic.scm 179 */
					BgL_varz00_bglt BgL_arg1709z00_2808;

					BgL_arg1709z00_2808 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_2804))->BgL_varz00);
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
						((BgL_nodez00_bglt) BgL_arg1709z00_2808));
				}
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_2804))->BgL_bodyz00));
			}
		}
	}



/* &cleanup-node!-let-va1541 */
	obj_t BGl_z62cleanupzd2nodez12zd2letzd2va1541za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3766, obj_t BgL_nodez00_3767)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 167 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_2786;

				BgL_nodez00_2786 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_3767);
				{	/* Cfa/arithmetic.scm 169 */
					obj_t BgL_g1502z00_2790;

					BgL_g1502z00_2790 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2786))->BgL_bindingsz00);
					{
						obj_t BgL_l1500z00_2792;

						BgL_l1500z00_2792 = BgL_g1502z00_2790;
					BgL_zc3anonymousza31699ze3z83_2793:
						if (PAIRP(BgL_l1500z00_2792))
							{	/* Cfa/arithmetic.scm 169 */
								{	/* Cfa/arithmetic.scm 169 */
									obj_t BgL_bz00_2795;

									BgL_bz00_2795 = CAR(BgL_l1500z00_2792);
									{	/* Cfa/arithmetic.scm 169 */
										obj_t BgL_arg1702z00_2796;

										BgL_arg1702z00_2796 = CDR(BgL_bz00_2795);
										BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
											((BgL_nodez00_bglt) BgL_arg1702z00_2796));
									}
								}
								{
									obj_t BgL_l1500z00_4303;

									BgL_l1500z00_4303 = CDR(BgL_l1500z00_2792);
									BgL_l1500z00_2792 = BgL_l1500z00_4303;
									goto BgL_zc3anonymousza31699ze3z83_2793;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 169 */
								((bool_t) 1);
							}
					}
				}
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2786))->BgL_bodyz00));
				{	/* Cfa/arithmetic.scm 171 */
					bool_t BgL_testz00_4307;

					{	/* Cfa/arithmetic.scm 171 */
						BgL_typez00_bglt BgL_arg1708z00_2802;

						BgL_arg1708z00_2802 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_2786)))->BgL_typez00);
						BgL_testz00_4307 =
							(((obj_t) BgL_arg1708z00_2802) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_4307)
						{	/* Cfa/arithmetic.scm 171 */
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_2786)))->BgL_typez00) =
								((BgL_typez00_bglt) (((BgL_nodez00_bglt)
											CREF((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2786))->
													BgL_bodyz00)))->BgL_typez00)), BUNSPEC);
						}
					else
						{	/* Cfa/arithmetic.scm 171 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &cleanup-node!-let-fu1539 */
	obj_t BGl_z62cleanupzd2nodez12zd2letzd2fu1539za2zzcfa_arithmeticz00(obj_t
		BgL_envz00_3768, obj_t BgL_nodez00_3769)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 157 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_2769;

				BgL_nodez00_2769 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_3769);
				{	/* Cfa/arithmetic.scm 159 */
					obj_t BgL_g1499z00_2773;

					BgL_g1499z00_2773 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_2769))->BgL_localsz00);
					{
						obj_t BgL_l1497z00_2775;

						BgL_l1497z00_2775 = BgL_g1499z00_2773;
					BgL_zc3anonymousza31690ze3z83_2776:
						if (PAIRP(BgL_l1497z00_2775))
							{	/* Cfa/arithmetic.scm 159 */
								{	/* Cfa/arithmetic.scm 159 */
									obj_t BgL_arg1692z00_2778;

									BgL_arg1692z00_2778 = CAR(BgL_l1497z00_2775);
									{	/* Cfa/arithmetic.scm 90 */
										BgL_valuez00_bglt BgL_funz00_3589;

										BgL_funz00_3589 =
											(((BgL_variablez00_bglt) CREF(
													((BgL_variablez00_bglt) BgL_arg1692z00_2778)))->
											BgL_valuez00);
										{	/* Cfa/arithmetic.scm 90 */
											obj_t BgL_bodyz00_3590;

											BgL_bodyz00_3590 =
												(((BgL_sfunz00_bglt) CREF(
														((BgL_sfunz00_bglt) BgL_funz00_3589)))->
												BgL_bodyz00);
											{	/* Cfa/arithmetic.scm 91 */

												BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
													((BgL_nodez00_bglt) BgL_bodyz00_3590));
											}
										}
									}
								}
								{
									obj_t BgL_l1497z00_4327;

									BgL_l1497z00_4327 = CDR(BgL_l1497z00_2775);
									BgL_l1497z00_2775 = BgL_l1497z00_4327;
									goto BgL_zc3anonymousza31690ze3z83_2776;
								}
							}
						else
							{	/* Cfa/arithmetic.scm 159 */
								((bool_t) 1);
							}
					}
				}
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_2769))->BgL_bodyz00));
				{	/* Cfa/arithmetic.scm 161 */
					bool_t BgL_testz00_4331;

					{	/* Cfa/arithmetic.scm 161 */
						BgL_typez00_bglt BgL_arg1698z00_2784;

						BgL_arg1698z00_2784 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_2769)))->BgL_typez00);
						BgL_testz00_4331 =
							(((obj_t) BgL_arg1698z00_2784) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_4331)
						{	/* Cfa/arithmetic.scm 161 */
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_2769)))->BgL_typez00) =
								((BgL_typez00_bglt) (((BgL_nodez00_bglt)
											CREF((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_2769))->
													BgL_bodyz00)))->BgL_typez00)), BUNSPEC);
						}
					else
						{	/* Cfa/arithmetic.scm 161 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &cleanup-node!-select1537 */
	obj_t BGl_z62cleanupzd2nodez12zd2select1537z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3770, obj_t BgL_nodez00_3771)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 149 */
			{
				BgL_selectz00_bglt BgL_nodez00_2754;

				{	/* Cfa/arithmetic.scm 150 */
					bool_t BgL_auxz00_4341;

					BgL_nodez00_2754 = ((BgL_selectz00_bglt) BgL_nodez00_3771);
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_2754))->BgL_testz00));
					{	/* Cfa/arithmetic.scm 152 */
						obj_t BgL_g1496z00_2759;

						BgL_g1496z00_2759 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_2754))->BgL_clausesz00);
						{
							obj_t BgL_l1494z00_2761;

							BgL_l1494z00_2761 = BgL_g1496z00_2759;
						BgL_zc3anonymousza31686ze3z83_2762:
							if (PAIRP(BgL_l1494z00_2761))
								{	/* Cfa/arithmetic.scm 152 */
									{	/* Cfa/arithmetic.scm 152 */
										obj_t BgL_clausez00_2764;

										BgL_clausez00_2764 = CAR(BgL_l1494z00_2761);
										{	/* Cfa/arithmetic.scm 152 */
											obj_t BgL_arg1688z00_2765;

											BgL_arg1688z00_2765 = CDR(BgL_clausez00_2764);
											BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
												((BgL_nodez00_bglt) BgL_arg1688z00_2765));
										}
									}
									{
										obj_t BgL_l1494z00_4351;

										BgL_l1494z00_4351 = CDR(BgL_l1494z00_2761);
										BgL_l1494z00_2761 = BgL_l1494z00_4351;
										goto BgL_zc3anonymousza31686ze3z83_2762;
									}
								}
							else
								{	/* Cfa/arithmetic.scm 152 */
									BgL_auxz00_4341 = ((bool_t) 1);
								}
						}
					}
					return BBOOL(BgL_auxz00_4341);
				}
			}
		}
	}



/* &cleanup-node!-fail1535 */
	obj_t BGl_z62cleanupzd2nodez12zd2fail1535z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3772, obj_t BgL_nodez00_3773)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 140 */
			{
				BgL_failz00_bglt BgL_nodez00_2746;

				BgL_nodez00_2746 = ((BgL_failz00_bglt) BgL_nodez00_3773);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_2746))->BgL_procz00));
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_2746))->BgL_msgz00));
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_2746))->BgL_objz00));
			}
		}
	}



/* &cleanup-node!-condit1533 */
	obj_t BGl_z62cleanupzd2nodez12zd2condit1533z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3774, obj_t BgL_nodez00_3775)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 131 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_2738;

				BgL_nodez00_2738 = ((BgL_conditionalz00_bglt) BgL_nodez00_3775);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2738))->BgL_testz00));
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2738))->BgL_truez00));
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2738))->BgL_falsez00));
			}
		}
	}



/* &cleanup-node!-setq1531 */
	obj_t BGl_z62cleanupzd2nodez12zd2setq1531z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3776, obj_t BgL_nodez00_3777)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 124 */
			{
				BgL_setqz00_bglt BgL_nodez00_2732;

				BgL_nodez00_2732 = ((BgL_setqz00_bglt) BgL_nodez00_3777);
				return
					BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_setqz00_bglt) CREF(BgL_nodez00_2732))->BgL_valuez00));
			}
		}
	}



/* &cleanup-node!-sync1529 */
	obj_t BGl_z62cleanupzd2nodez12zd2sync1529z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3778, obj_t BgL_nodez00_3779)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 113 */
			{
				BgL_syncz00_bglt BgL_nodez00_2721;

				BgL_nodez00_2721 = ((BgL_syncz00_bglt) BgL_nodez00_3779);
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_2721))->BgL_mutexz00));
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_2721))->BgL_prelockz00));
				BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_2721))->BgL_bodyz00));
				{	/* Cfa/arithmetic.scm 118 */
					bool_t BgL_testz00_4378;

					{	/* Cfa/arithmetic.scm 118 */
						BgL_typez00_bglt BgL_arg1676z00_2730;

						BgL_arg1676z00_2730 =
							(((BgL_nodez00_bglt) CREF(
									((BgL_nodez00_bglt) BgL_nodez00_2721)))->BgL_typez00);
						BgL_testz00_4378 =
							(((obj_t) BgL_arg1676z00_2730) == BGl_za2_za2z00zztype_cachez00);
					}
					if (BgL_testz00_4378)
						{	/* Cfa/arithmetic.scm 118 */
							return
								((((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_nodez00_2721)))->BgL_typez00) =
								((BgL_typez00_bglt) (((BgL_nodez00_bglt)
											CREF((((BgL_syncz00_bglt) CREF(BgL_nodez00_2721))->
													BgL_bodyz00)))->BgL_typez00)), BUNSPEC);
						}
					else
						{	/* Cfa/arithmetic.scm 118 */
							return BFALSE;
						}
				}
			}
		}
	}



/* &cleanup-node!-sequen1527 */
	obj_t BGl_z62cleanupzd2nodez12zd2sequen1527z70zzcfa_arithmeticz00(obj_t
		BgL_envz00_3780, obj_t BgL_nodez00_3781)
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 103 */
			{
				BgL_sequencez00_bglt BgL_nodez00_2701;

				BgL_nodez00_2701 = ((BgL_sequencez00_bglt) BgL_nodez00_3781);
				{	/* Cfa/arithmetic.scm 105 */
					bool_t BgL_testz00_4388;

					{	/* Cfa/arithmetic.scm 105 */
						obj_t BgL_auxz00_4389;

						BgL_auxz00_4389 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_2701))->BgL_nodesz00);
						BgL_testz00_4388 = PAIRP(BgL_auxz00_4389);
					}
					if (BgL_testz00_4388)
						{	/* Cfa/arithmetic.scm 105 */
							{	/* Cfa/arithmetic.scm 106 */
								obj_t BgL_g1493z00_2706;

								BgL_g1493z00_2706 =
									(((BgL_sequencez00_bglt) CREF(BgL_nodez00_2701))->
									BgL_nodesz00);
								{
									obj_t BgL_l1491z00_2708;

									BgL_l1491z00_2708 = BgL_g1493z00_2706;
								BgL_zc3anonymousza31646ze3z83_2709:
									if (PAIRP(BgL_l1491z00_2708))
										{	/* Cfa/arithmetic.scm 106 */
											{	/* Cfa/arithmetic.scm 106 */
												obj_t BgL_arg1651z00_2711;

												BgL_arg1651z00_2711 = CAR(BgL_l1491z00_2708);
												BGl_cleanupzd2nodez12zc0zzcfa_arithmeticz00(
													((BgL_nodez00_bglt) BgL_arg1651z00_2711));
											}
											{
												obj_t BgL_l1491z00_4398;

												BgL_l1491z00_4398 = CDR(BgL_l1491z00_2708);
												BgL_l1491z00_2708 = BgL_l1491z00_4398;
												goto BgL_zc3anonymousza31646ze3z83_2709;
											}
										}
									else
										{	/* Cfa/arithmetic.scm 106 */
											((bool_t) 1);
										}
								}
							}
							{	/* Cfa/arithmetic.scm 107 */
								bool_t BgL_testz00_4400;

								{	/* Cfa/arithmetic.scm 107 */
									BgL_typez00_bglt BgL_arg1669z00_2718;

									BgL_arg1669z00_2718 =
										(((BgL_nodez00_bglt) CREF(
												((BgL_nodez00_bglt) BgL_nodez00_2701)))->BgL_typez00);
									BgL_testz00_4400 =
										(
										((obj_t) BgL_arg1669z00_2718) ==
										BGl_za2_za2z00zztype_cachez00);
								}
								if (BgL_testz00_4400)
									{	/* Cfa/arithmetic.scm 107 */
										return
											((((BgL_nodez00_bglt) CREF(
														((BgL_nodez00_bglt) BgL_nodez00_2701)))->
												BgL_typez00) =
											((BgL_typez00_bglt) (((BgL_nodez00_bglt)
														CREF(((BgL_nodez00_bglt)
																CAR
																(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
																	((((BgL_sequencez00_bglt)
																				CREF(BgL_nodez00_2701))->
																			BgL_nodesz00))))))->BgL_typez00)),
											BUNSPEC);
									}
								else
									{	/* Cfa/arithmetic.scm 107 */
										return BFALSE;
									}
							}
						}
					else
						{	/* Cfa/arithmetic.scm 105 */
							return BFALSE;
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_arithmeticz00()
	{
		AN_OBJECT;
		{	/* Cfa/arithmetic.scm 28 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 216926614),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 125571606),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_loosez00(((long) 471177480),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_iteratez00(((long) 131412063),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 400853817),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_setupz00(((long) 168272122),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 468997863),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_tvectorz00(((long) 324810626),
				BSTRING_TO_STRING(BGl_string2062z00zzcfa_arithmeticz00));
		}
	}

#ifdef __cplusplus
}
#endif
