/*===========================================================================*/
/*   (Cfa/closure.scm)                                                       */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Cfa/closure.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_svarz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
	}              *BgL_svarz00_bglt;

	typedef struct BgL_scnstz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_nodez00;
		obj_t BgL_classz00;
		obj_t BgL_locz00;
	}               *BgL_scnstz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_approxz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_typez00_bgl *BgL_typez00;
		bool_t BgL_typezd2lockedzf3z21;
		obj_t BgL_allocsz00;
		bool_t BgL_topzf3zf3;
		long BgL_lostzd2stampzd2;
		obj_t BgL_dupz00;
	}                *BgL_approxz00_bglt;

	typedef struct BgL_svarzf2cinfozf2_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		bool_t BgL_clozd2envzf3z21;
		long BgL_stampz00;
	}                      *BgL_svarzf2cinfozf2_bglt;

	typedef struct BgL_makezd2procedurezd2appz00_bgl
	{
		struct BgL_approxz00_bgl *BgL_approxz00;
		obj_t BgL_valueszd2approxzd2;
		long BgL_lostzd2stampzd2;
		bool_t BgL_xzd2tzf3z21;
		bool_t BgL_xz00;
		bool_t BgL_tz00;
		struct BgL_variablez00_bgl *BgL_ownerz00;
		obj_t BgL_stackzd2stampzd2;
	}                                *BgL_makezd2procedurezd2appz00_bglt;


	static bool_t BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00();
	extern obj_t BGl_setzd2lengthzd2zzcfa_setz00(obj_t);
	static bool_t BGl_mergezd2appzd2typesz12z12zzcfa_closurez00(obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(BgL_nodez00_bglt);
	static obj_t BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00(obj_t);
	static obj_t BGl_objectzd2initzd2zzcfa_closurez00();
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2funcallz12zc0zzcfa_closurez00(BgL_nodez00_bglt);
	extern obj_t BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00(obj_t,
		BgL_approxz00_bglt);
	static obj_t BGl_methodzd2initzd2zzcfa_closurez00();
	extern BgL_typez00_bglt
		BGl_getzd2bigloozd2typez00zztype_cachez00(BgL_typez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_typezd2closuresz12zc0zzcfa_closurez00();
	extern obj_t
		BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(BgL_nodez00_bglt);
	BGL_EXPORTED_DECL obj_t BGl_getzd2procedurezd2listz00zzcfa_closurez00();
	extern obj_t BGl_lightzd2typez12zc0zzcfa_ltypez00(obj_t);
	static obj_t BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00(obj_t,
		obj_t);
	static obj_t BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00(obj_t);
	extern obj_t BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
	static obj_t BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00(obj_t, obj_t);
	static bool_t BGl_lightzd2funcallz12zc0zzcfa_closurez00();
	extern obj_t BGl_makezd2procedurezd2appz00zzcfa_info2z00;
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	static obj_t BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BUNSPEC;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern obj_t BGl_za2optimza2z00zzengine_paramz00;
	static obj_t BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BUNSPEC;
	extern obj_t BGl_getzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_showzd2Xzd2Tz00zzcfa_closurez00(obj_t);
	static obj_t BGl_z62typezd2closuresz12za2zzcfa_closurez00(obj_t);
	extern obj_t BGl_shapez00zztools_shapez00(obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 = BUNSPEC;
	static bool_t BGl_Xz12z12zzcfa_closurez00(obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	static obj_t BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00(obj_t);
	extern obj_t BGl_za2procedureza2z00zztype_cachez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzcfa_closurez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_ltypez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_setz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_approxz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_cfaz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_info2z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzcfa_infoz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	static obj_t BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 = BUNSPEC;
	static bool_t BGl_lightzd2accessz12zc0zzcfa_closurez00();
	static obj_t BGl_importedzd2moduleszd2initz00zzcfa_closurez00();
	static obj_t BGl_startzd2closurezd2cachez00zzcfa_closurez00();
	static obj_t BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BUNSPEC;
	extern BgL_approxz00_bglt BGl_cfaz12z12zzcfa_cfaz00(BgL_nodez00_bglt);
	extern obj_t BGl_getzd2approxzd2typez00zzcfa_typez00(BgL_approxz00_bglt,
		obj_t);
	static bool_t BGl_showz00zzcfa_closurez00(obj_t, obj_t);
	static obj_t BGl_z62getzd2procedurezd2listz62zzcfa_closurez00(obj_t);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00();
	extern obj_t
		BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static obj_t BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_stopzd2closurezd2cachez00zzcfa_closurez00();
	static obj_t BGl_z62addzd2funcallz12za2zzcfa_closurez00(obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzcfa_closurez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(BgL_nodez00_bglt);
	static obj_t BGl_toplevelzd2initzd2zzcfa_closurez00();
	extern obj_t BGl_setzd2ze3listz31zzcfa_setz00(obj_t);
	static obj_t BGl_genericzd2initzd2zzcfa_closurez00();
	static obj_t BGl_z62zc3anonymousza31620ze3ze1zzcfa_closurez00(obj_t, obj_t);
	static obj_t BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_EXPORTED_DECL bool_t
		BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(BgL_approxz00_bglt);
	static obj_t BGl_z62zc3anonymousza31625ze3ze1zzcfa_closurez00(obj_t, obj_t);
	static obj_t BGl_zc3anonymousza31764ze3z83zzcfa_closurez00(obj_t);
	static obj_t BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_cnstzd2initzd2zzcfa_closurez00();
	static obj_t BGl_libraryzd2moduleszd2initz00zzcfa_closurez00();
	extern obj_t BGl_scnstz00zzast_varz00;
	static obj_t BGl_za2funcallzd2listza2zd2zzcfa_closurez00 = BUNSPEC;
	static obj_t BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00(obj_t,
		obj_t);
	extern obj_t BGl_za2procedurezd2elza2zd2zztype_cachez00;
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t __cnst[20];


	   
		 
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_addzd2makezd2procedurez12zd2envzc0zzcfa_closurez00,
		BgL_bgl_za762addza7d2makeza7d22122za7,
		BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_addzd2funcallz12zd2envz12zzcfa_closurez00,
		BgL_bgl_za762addza7d2funcall2123z00,
		BGl_z62addzd2funcallz12za2zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2111z00zzcfa_closurez00,
		BgL_bgl_za762za7c3anonymousza72124za7,
		BGl_z62zc3anonymousza31620ze3ze1zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2112z00zzcfa_closurez00,
		BgL_bgl_za762za7c3anonymousza72125za7,
		BGl_z62zc3anonymousza31625ze3ze1zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_addzd2procedurezd2refz12zd2envzc0zzcfa_closurez00,
		BgL_bgl_za762addza7d2procedu2126z00,
		BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE(BGl_typezd2closuresz12zd2envz12zzcfa_closurez00,
		BgL_bgl_za762typeza7d2closur2127z00,
		BGl_z62typezd2closuresz12za2zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_closurezd2optimiza7ationzf3zd2envz54zzcfa_closurez00,
		BgL_bgl_za762closureza7d2opt2128z00,
		BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_closurezd2optimiza7ationz12zd2envzb5zzcfa_closurez00,
		BgL_bgl_za762closureza7d2opt2129z00,
		BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2procedurezd2listzd2envzd2zzcfa_closurez00,
		BgL_bgl_za762getza7d2procedu2130z00,
		BGl_z62getzd2procedurezd2listz62zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_stopzd2closurezd2cachezd2envzd2zzcfa_closurez00,
		BgL_bgl_za762stopza7d2closur2131z00,
		BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00, 0L, BUNSPEC, 0);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_approxzd2procedurezd2elzf3zd2envz21zzcfa_closurez00,
		BgL_bgl_za762approxza7d2proc2132z00,
		BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2110z00zzcfa_closurez00,
		BgL_bgl_string2110za700za7za7c2133za7, "   . Light closures", 19);
	      DEFINE_STRING(BGl_string2113z00zzcfa_closurez00,
		BgL_bgl_string2113za700za7za7c2134za7, ": ", 2);
	      DEFINE_STRING(BGl_string2114z00zzcfa_closurez00,
		BgL_bgl_string2114za700za7za7c2135za7, "      ", 6);
	      DEFINE_STRING(BGl_string2115z00zzcfa_closurez00,
		BgL_bgl_string2115za700za7za7c2136za7, "        ", 8);
	      DEFINE_STRING(BGl_string2116z00zzcfa_closurez00,
		BgL_bgl_string2116za700za7za7c2137za7, "cfa_closure", 11);
	      DEFINE_STRING(BGl_string2117z00zzcfa_closurez00,
		BgL_bgl_string2117za700za7za7c2138za7,
		"make-l-procedure make-el-procedure procedure-el-set! procedure-el-ref procedure-l-set! procedure-l-ref procedure-set! foreign procedure-ref T X nothing-to-do slfun selfun done ok \077\077? light elight static ",
		203);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzcfa_closurez00(long
		BgL_checksumz00_3911, char *BgL_fromz00_3912)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzcfa_closurez00))
				{
					BGl_requirezd2initializa7ationz75zzcfa_closurez00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzcfa_closurez00();
					BGl_cnstzd2initzd2zzcfa_closurez00();
					BGl_importedzd2moduleszd2initz00zzcfa_closurez00();
					return BGl_toplevelzd2initzd2zzcfa_closurez00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 25 */
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "cfa_closure");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"cfa_closure");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"cfa_closure");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 25 */
			{	/* Cfa/closure.scm 25 */
				obj_t BgL_cportz00_3898;

				{	/* Cfa/closure.scm 25 */
					obj_t BgL_startz00_3907;

					BgL_startz00_3907 = BINT(((long) 0));
					{	/* Cfa/closure.scm 25 */
						obj_t BgL_endz00_3908;

						BgL_endz00_3908 =
							BINT(STRING_LENGTH(BGl_string2117z00zzcfa_closurez00));
						{	/* Cfa/closure.scm 25 */

							BgL_cportz00_3898 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string2117z00zzcfa_closurez00, BgL_startz00_3907,
								BgL_endz00_3908);
				}}}
				{
					long BgL_iz00_3899;

					BgL_iz00_3899 = ((long) 19);
				BgL_loopz00_3900:
					if ((BgL_iz00_3899 == ((long) -1)))
						{	/* Cfa/closure.scm 25 */
							return BUNSPEC;
						}
					else
						{	/* Cfa/closure.scm 25 */
							{	/* Cfa/closure.scm 25 */
								obj_t BgL_arg2120z00_3902;

								{	/* Cfa/closure.scm 25 */

									{	/* Cfa/closure.scm 25 */
										obj_t BgL_locationz00_3904;

										BgL_locationz00_3904 = BBOOL(((bool_t) 0));
										{	/* Cfa/closure.scm 25 */

											BgL_arg2120z00_3902 =
												BGl_readz00zz__readerz00(BgL_cportz00_3898,
												BgL_locationz00_3904);
										}
									}
								}
								{	/* Cfa/closure.scm 25 */
									int BgL_auxz00_3935;

									BgL_auxz00_3935 = (int) (BgL_iz00_3899);
									CNST_TABLE_SET(BgL_auxz00_3935, BgL_arg2120z00_3902);
							}}
							{	/* Cfa/closure.scm 25 */
								int BgL_auxz00_3905;

								BgL_auxz00_3905 = (int) ((BgL_iz00_3899 - ((long) 1)));
								{
									long BgL_iz00_3940;

									BgL_iz00_3940 = (long) (BgL_auxz00_3905);
									BgL_iz00_3899 = BgL_iz00_3940;
									goto BgL_loopz00_3900;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 25 */
			BGl_za2funcallzd2listza2zd2zzcfa_closurez00 = BNIL;
			BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 = BNIL;
			BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 = BNIL;
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BFALSE;
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BFALSE, BUNSPEC);
		}
	}



/* closure-optimization? */
	BGL_EXPORTED_DEF obj_t BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 55 */
			{	/* Cfa/closure.scm 56 */
				long BgL_n1z00_3517;

				BgL_n1z00_3517 = (long) CINT(BGl_za2optimza2z00zzengine_paramz00);
				return BBOOL((BgL_n1z00_3517 >= ((long) 2)));
		}}
	}



/* &closure-optimization? */
	obj_t BGl_z62closurezd2optimiza7ationzf3ze4zzcfa_closurez00(obj_t
		BgL_envz00_3878)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 55 */
			return BGl_closurezd2optimiza7ationzf3z86zzcfa_closurez00();
		}
	}



/* closure-optimization! */
	BGL_EXPORTED_DEF obj_t
		BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(obj_t BgL_globalsz00_3)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 61 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 62 */
					{	/* Cfa/closure.scm 63 */
						obj_t BgL_list1530z00_2626;

						{	/* Cfa/closure.scm 63 */
							obj_t BgL_arg1547z00_2627;

							BgL_arg1547z00_2627 =
								MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
							BgL_list1530z00_2626 =
								MAKE_PAIR(BGl_string2110z00zzcfa_closurez00,
								BgL_arg1547z00_2627);
						}
						BGl_verbosez00zztools_speekz00(BINT(((long) 1)),
							BgL_list1530z00_2626);
					}
					BGl_startzd2closurezd2cachez00zzcfa_closurez00();
					{
						obj_t BgL_l1484z00_2629;

						BgL_l1484z00_2629 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
					BgL_zc3anonymousza31548ze3z83_2630:
						if (PAIRP(BgL_l1484z00_2629))
							{	/* Cfa/closure.scm 72 */
								{	/* Cfa/closure.scm 74 */
									obj_t BgL_appz00_2632;

									BgL_appz00_2632 = CAR(BgL_l1484z00_2629);
									{	/* Cfa/closure.scm 75 */
										BgL_variablez00_bglt BgL_funz00_2634;

										{
											BgL_varz00_bglt BgL_auxz00_3958;

											{	/* Cfa/closure.scm 75 */
												obj_t BgL_pairz00_3526;

												BgL_pairz00_3526 =
													(((BgL_appz00_bglt) CREF(
															((BgL_appz00_bglt)
																((BgL_appz00_bglt) BgL_appz00_2632))))->
													BgL_argsz00);
												BgL_auxz00_3958 =
													((BgL_varz00_bglt) CAR(BgL_pairz00_3526));
											}
											BgL_funz00_2634 =
												(((BgL_varz00_bglt) CREF(BgL_auxz00_3958))->
												BgL_variablez00);
										}
										{	/* Cfa/closure.scm 75 */
											obj_t BgL_cloz00_2635;

											BgL_cloz00_2635 =
												(((BgL_funz00_bglt) CREF(
														((BgL_funz00_bglt)
															((BgL_sfunz00_bglt)
																(((BgL_variablez00_bglt) CREF(
																			((BgL_variablez00_bglt)
																				((BgL_globalz00_bglt)
																					BgL_funz00_2634))))->
																	BgL_valuez00)))))->BgL_thezd2closurezd2);
											{	/* Cfa/closure.scm 76 */
												bool_t BgL_lostzf3zf3_2636;

												{	/* Cfa/closure.scm 77 */
													long BgL_auxz00_3971;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_3972;

														{
															obj_t BgL_auxz00_3973;

															{	/* Cfa/closure.scm 77 */
																BgL_objectz00_bglt BgL_auxz00_3974;

																BgL_auxz00_3974 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_appz00_2632));
																BgL_auxz00_3973 =
																	BGL_OBJECT_WIDENING(BgL_auxz00_3974);
															}
															BgL_auxz00_3972 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_3973);
														}
														BgL_auxz00_3971 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																CREF(BgL_auxz00_3972))->BgL_lostzd2stampzd2);
													}
													BgL_lostzf3zf3_2636 = (BgL_auxz00_3971 > ((long) -1));
												}
												{	/* Cfa/closure.scm 77 */
													obj_t BgL_siza7eza7_2637;

													{	/* Cfa/closure.scm 78 */
														obj_t BgL_arg1571z00_2647;

														{	/* Cfa/closure.scm 78 */
															obj_t BgL_pairz00_3533;

															BgL_pairz00_3533 =
																(((BgL_appz00_bglt) CREF(
																		((BgL_appz00_bglt)
																			((BgL_appz00_bglt) BgL_appz00_2632))))->
																BgL_argsz00);
															BgL_arg1571z00_2647 =
																CAR(CDR(CDR(BgL_pairz00_3533)));
														}
														BgL_siza7eza7_2637 =
															BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
															((BgL_nodez00_bglt) BgL_arg1571z00_2647));
													}
													{	/* Cfa/closure.scm 78 */

														{	/* Cfa/closure.scm 80 */
															bool_t BgL_testz00_3989;

															if (BgL_lostzf3zf3_2636)
																{	/* Cfa/closure.scm 80 */
																	BgL_testz00_3989 = ((bool_t) 1);
																}
															else
																{	/* Cfa/closure.scm 81 */
																	bool_t BgL_testz00_3991;

																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_3992;
																		{
																			obj_t BgL_auxz00_3993;

																			{	/* Cfa/closure.scm 81 */
																				BgL_objectz00_bglt BgL_auxz00_3994;

																				BgL_auxz00_3994 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2632));
																				BgL_auxz00_3993 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_3994);
																			}
																			BgL_auxz00_3992 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_3993);
																		}
																		BgL_testz00_3991 =
																			(((BgL_makezd2procedurezd2appz00_bglt)
																				CREF(BgL_auxz00_3992))->
																			BgL_xzd2tzf3z21);
																	}
																	if (BgL_testz00_3991)
																		{	/* Cfa/closure.scm 81 */
																			if (
																				((((BgL_funz00_bglt) CREF(
																								((BgL_funz00_bglt)
																									((BgL_sfunz00_bglt)
																										(((BgL_variablez00_bglt)
																												CREF((
																														(BgL_variablez00_bglt)
																														((BgL_globalz00_bglt) BgL_funz00_2634))))->BgL_valuez00)))))->BgL_arityz00) < ((long) 0)))
																				{	/* Cfa/closure.scm 82 */
																					BgL_testz00_3989 = ((bool_t) 1);
																				}
																			else
																				{	/* Cfa/closure.scm 82 */
																					if (INTEGERP(BgL_siza7eza7_2637))
																						{	/* Cfa/closure.scm 83 */
																							if (BGl_isazf3zf3zz__objectz00
																								(BgL_cloz00_2635,
																									BGl_globalz00zzast_varz00))
																								{	/* Cfa/closure.scm 84 */
																									if (
																										((((BgL_globalz00_bglt)
																													CREF((
																															(BgL_globalz00_bglt)
																															BgL_cloz00_2635)))->
																												BgL_importz00) ==
																											CNST_TABLE_REF(((long)
																													0))))
																										{	/* Cfa/closure.scm 85 */
																											BgL_testz00_3989 =
																												((bool_t) 0);
																										}
																									else
																										{	/* Cfa/closure.scm 85 */
																											BgL_testz00_3989 =
																												((bool_t) 1);
																										}
																								}
																							else
																								{	/* Cfa/closure.scm 84 */
																									BgL_testz00_3989 =
																										((bool_t) 0);
																								}
																						}
																					else
																						{	/* Cfa/closure.scm 83 */
																							BgL_testz00_3989 = ((bool_t) 1);
																						}
																				}
																		}
																	else
																		{	/* Cfa/closure.scm 81 */
																			BgL_testz00_3989 = ((bool_t) 1);
																		}
																}
															if (BgL_testz00_3989)
																{	/* Cfa/closure.scm 80 */
																	BNIL;
																}
															else
																{	/* Cfa/closure.scm 80 */
																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4017;
																		{
																			obj_t BgL_auxz00_4018;

																			{	/* Cfa/closure.scm 102 */
																				BgL_objectz00_bglt BgL_auxz00_4019;

																				BgL_auxz00_4019 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2632));
																				BgL_auxz00_4018 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_4019);
																			}
																			BgL_auxz00_4017 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4018);
																		}
																		((((BgL_makezd2procedurezd2appz00_bglt)
																					CREF(BgL_auxz00_4017))->BgL_xz00) =
																			((bool_t) ((bool_t) 1)), BUNSPEC);
																	}
																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4025;
																		{
																			obj_t BgL_auxz00_4026;

																			{	/* Cfa/closure.scm 103 */
																				BgL_objectz00_bglt BgL_auxz00_4027;

																				BgL_auxz00_4027 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt) BgL_appz00_2632));
																				BgL_auxz00_4026 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_4027);
																			}
																			BgL_auxz00_4025 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4026);
																		}
																		((((BgL_makezd2procedurezd2appz00_bglt)
																					CREF(BgL_auxz00_4025))->BgL_tz00) =
																			((bool_t) ((bool_t) 1)), BUNSPEC);
																	}
																}
														}
													}
												}
											}
										}
									}
								}
								{
									obj_t BgL_l1484z00_4033;

									BgL_l1484z00_4033 = CDR(BgL_l1484z00_2629);
									BgL_l1484z00_2629 = BgL_l1484z00_4033;
									goto BgL_zc3anonymousza31548ze3z83_2630;
								}
							}
						else
							{	/* Cfa/closure.scm 72 */
								((bool_t) 1);
							}
					}
					BGl_Xz12z12zzcfa_closurez00
						(BGl_za2funcallzd2listza2zd2zzcfa_closurez00);
					BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00
						(BGl_za2funcallzd2listza2zd2zzcfa_closurez00);
					{
						obj_t BgL_l1486z00_2656;

						BgL_l1486z00_2656 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
					BgL_zc3anonymousza31592ze3z83_2657:
						if (PAIRP(BgL_l1486z00_2656))
							{	/* Cfa/closure.scm 110 */
								{	/* Cfa/closure.scm 111 */
									obj_t BgL_allocz00_2659;

									BgL_allocz00_2659 = CAR(BgL_l1486z00_2656);
									{	/* Cfa/closure.scm 112 */
										BgL_valuez00_bglt BgL_fz00_2661;

										{
											BgL_variablez00_bglt BgL_auxz00_4040;

											{
												BgL_varz00_bglt BgL_auxz00_4041;

												{	/* Cfa/closure.scm 112 */
													obj_t BgL_pairz00_3553;

													BgL_pairz00_3553 =
														(((BgL_appz00_bglt) CREF(
																((BgL_appz00_bglt)
																	((BgL_appz00_bglt) BgL_allocz00_2659))))->
														BgL_argsz00);
													BgL_auxz00_4041 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3553));
												}
												BgL_auxz00_4040 =
													(((BgL_varz00_bglt) CREF(BgL_auxz00_4041))->
													BgL_variablez00);
											}
											BgL_fz00_2661 =
												(((BgL_variablez00_bglt) CREF(BgL_auxz00_4040))->
												BgL_valuez00);
										}
										{	/* Cfa/closure.scm 114 */
											bool_t BgL_testz00_4049;

											{
												BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4050;

												{
													obj_t BgL_auxz00_4051;

													{	/* Cfa/closure.scm 114 */
														BgL_objectz00_bglt BgL_auxz00_4052;

														BgL_auxz00_4052 =
															((BgL_objectz00_bglt)
															((BgL_appz00_bglt) BgL_allocz00_2659));
														BgL_auxz00_4051 =
															BGL_OBJECT_WIDENING(BgL_auxz00_4052);
													}
													BgL_auxz00_4050 =
														((BgL_makezd2procedurezd2appz00_bglt)
														BgL_auxz00_4051);
												}
												BgL_testz00_4049 =
													(((BgL_makezd2procedurezd2appz00_bglt)
														CREF(BgL_auxz00_4050))->BgL_xz00);
											}
											if (BgL_testz00_4049)
												{	/* Cfa/closure.scm 114 */
													obj_t BgL_vz00_3557;

													BgL_vz00_3557 = CNST_TABLE_REF(((long) 1));
													((((BgL_sfunz00_bglt) CREF(
																	((BgL_sfunz00_bglt) BgL_fz00_2661)))->
															BgL_strengthz00) =
														((obj_t) BgL_vz00_3557), BUNSPEC);
												}
											else
												{	/* Cfa/closure.scm 115 */
													bool_t BgL_testz00_4061;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4062;

														{
															obj_t BgL_auxz00_4063;

															{	/* Cfa/closure.scm 115 */
																BgL_objectz00_bglt BgL_auxz00_4064;

																BgL_auxz00_4064 =
																	((BgL_objectz00_bglt)
																	((BgL_appz00_bglt) BgL_allocz00_2659));
																BgL_auxz00_4063 =
																	BGL_OBJECT_WIDENING(BgL_auxz00_4064);
															}
															BgL_auxz00_4062 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4063);
														}
														BgL_testz00_4061 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																CREF(BgL_auxz00_4062))->BgL_tz00);
													}
													if (BgL_testz00_4061)
														{	/* Cfa/closure.scm 115 */
															obj_t BgL_vz00_3559;

															BgL_vz00_3559 = CNST_TABLE_REF(((long) 2));
															((((BgL_sfunz00_bglt) CREF(
																			((BgL_sfunz00_bglt) BgL_fz00_2661)))->
																	BgL_strengthz00) =
																((obj_t) BgL_vz00_3559), BUNSPEC);
														}
													else
														{	/* Cfa/closure.scm 116 */
															obj_t BgL_vz00_3561;

															BgL_vz00_3561 = CNST_TABLE_REF(((long) 3));
															((((BgL_sfunz00_bglt) CREF(
																			((BgL_sfunz00_bglt) BgL_fz00_2661)))->
																	BgL_strengthz00) =
																((obj_t) BgL_vz00_3561), BUNSPEC);
								}}}}}
								{
									obj_t BgL_l1486z00_4076;

									BgL_l1486z00_4076 = CDR(BgL_l1486z00_2656);
									BgL_l1486z00_2656 = BgL_l1486z00_4076;
									goto BgL_zc3anonymousza31592ze3z83_2657;
								}
							}
						else
							{	/* Cfa/closure.scm 110 */
								((bool_t) 1);
							}
					}
					BGl_showzd2Xzd2Tz00zzcfa_closurez00
						(BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00);
					BGl_lightzd2funcallz12zc0zzcfa_closurez00();
					BGl_lightzd2accessz12zc0zzcfa_closurez00();
					BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00();
					return BGl_lightzd2typez12zc0zzcfa_ltypez00(BgL_globalsz00_3);
				}
			else
				{	/* Cfa/closure.scm 62 */
					return BFALSE;
				}
		}
	}



/* &closure-optimization! */
	obj_t BGl_z62closurezd2optimiza7ationz12z05zzcfa_closurez00(obj_t
		BgL_envz00_3879, obj_t BgL_globalsz00_3880)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 61 */
			return
				BGl_closurezd2optimiza7ationz12z67zzcfa_closurez00(BgL_globalsz00_3880);
		}
	}



/* X! */
	bool_t BGl_Xz12z12zzcfa_closurez00(obj_t BgL_funcallzd2listzd2_4)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 132 */
			{
				obj_t BgL_l1488z00_2670;

				BgL_l1488z00_2670 = BgL_funcallzd2listzd2_4;
			BgL_zc3anonymousza31614ze3z83_2671:
				if (PAIRP(BgL_l1488z00_2670))
					{	/* Cfa/closure.scm 134 */
						{	/* Cfa/closure.scm 135 */
							BgL_funcallz00_bglt BgL_appz00_2673;

							BgL_appz00_2673 = ((BgL_funcallz00_bglt) CAR(BgL_l1488z00_2670));
							{	/* Cfa/closure.scm 136 */
								BgL_nodez00_bglt BgL_funz00_2674;

								BgL_funz00_2674 =
									(((BgL_funcallz00_bglt) CREF(BgL_appz00_2673))->BgL_funz00);
								{	/* Cfa/closure.scm 136 */
									BgL_approxz00_bglt BgL_approxz00_2675;

									BgL_approxz00_2675 =
										BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2674);
									{	/* Cfa/closure.scm 137 */
										obj_t BgL_allocz00_2676;

										BgL_allocz00_2676 =
											(((BgL_approxz00_bglt) CREF(BgL_approxz00_2675))->
											BgL_allocsz00);
										{	/* Cfa/closure.scm 138 */
											BgL_typez00_bglt BgL_typez00_2677;

											BgL_typez00_2677 =
												(((BgL_approxz00_bglt) CREF(BgL_approxz00_2675))->
												BgL_typez00);
											{	/* Cfa/closure.scm 139 */
												bool_t BgL_topzf3zf3_2678;

												BgL_topzf3zf3_2678 =
													(((BgL_approxz00_bglt) CREF(BgL_approxz00_2675))->
													BgL_topzf3zf3);
												{	/* Cfa/closure.scm 140 */

													if (BgL_topzf3zf3_2678)
														{	/* Cfa/closure.scm 142 */
															BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00
																(BGl_proc2111z00zzcfa_closurez00,
																BgL_approxz00_2675);
														}
													else
														{	/* Cfa/closure.scm 153 */
															bool_t BgL_testz00_4095;

															{	/* Cfa/closure.scm 153 */
																obj_t BgL_arg1633z00_2694;

																BgL_arg1633z00_2694 =
																	BGl_setzd2lengthzd2zzcfa_setz00
																	(BgL_allocz00_2676);
																BgL_testz00_4095 =
																	((long) CINT(BgL_arg1633z00_2694) ==
																	((long) 0));
															}
															if (BgL_testz00_4095)
																{	/* Cfa/closure.scm 153 */
																	CNST_TABLE_REF(((long) 4));
																}
															else
																{	/* Cfa/closure.scm 156 */
																	bool_t BgL_testz00_4100;

																	{	/* Cfa/closure.scm 156 */
																		bool_t BgL_testz00_4101;

																		{	/* Cfa/closure.scm 156 */
																			obj_t BgL_arg1631z00_2693;

																			BgL_arg1631z00_2693 =
																				BGl_setzd2lengthzd2zzcfa_setz00
																				(BgL_allocz00_2676);
																			BgL_testz00_4101 =
																				((long) CINT(BgL_arg1631z00_2693) ==
																				((long) 1));
																		}
																		if (BgL_testz00_4101)
																			{	/* Cfa/closure.scm 157 */
																				obj_t BgL__ortest_1154z00_2692;

																				BgL__ortest_1154z00_2692 =
																					BGl_za2unsafezd2typeza2zd2zzengine_paramz00;
																				if (CBOOL(BgL__ortest_1154z00_2692))
																					{	/* Cfa/closure.scm 157 */
																						BgL_testz00_4100 =
																							CBOOL(BgL__ortest_1154z00_2692);
																					}
																				else
																					{	/* Cfa/closure.scm 157 */
																						BgL_testz00_4100 =
																							(
																							((obj_t) BgL_typez00_2677) ==
																							BGl_za2procedureza2z00zztype_cachez00);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 156 */
																				BgL_testz00_4100 = ((bool_t) 0);
																			}
																	}
																	if (BgL_testz00_4100)
																		{	/* Cfa/closure.scm 156 */
																			CNST_TABLE_REF(((long) 4));
																		}
																	else
																		{	/* Cfa/closure.scm 156 */
																			BGl_forzd2eachzd2approxzd2alloczd2zzcfa_approxz00
																				(BGl_proc2112z00zzcfa_closurez00,
																				BgL_approxz00_2675);
																		}
																}
														}
												}
											}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1488z00_4112;

							BgL_l1488z00_4112 = CDR(BgL_l1488z00_2670);
							BgL_l1488z00_2670 = BgL_l1488z00_4112;
							goto BgL_zc3anonymousza31614ze3z83_2671;
						}
					}
				else
					{	/* Cfa/closure.scm 134 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* &<anonymous:1620> */
	obj_t BGl_z62zc3anonymousza31620ze3ze1zzcfa_closurez00(obj_t BgL_envz00_3883,
		obj_t BgL_allocz00_3884)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 145 */
			{
				obj_t BgL_allocz00_2680;

				BgL_allocz00_2680 = BgL_allocz00_3884;
				if (BGl_isazf3zf3zz__objectz00(BgL_allocz00_2680,
						BGl_makezd2procedurezd2appz00zzcfa_info2z00))
					{	/* Cfa/closure.scm 146 */
						{
							BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4116;

							{
								obj_t BgL_auxz00_4117;

								{	/* Cfa/closure.scm 150 */
									BgL_objectz00_bglt BgL_auxz00_4118;

									BgL_auxz00_4118 =
										((BgL_objectz00_bglt)
										((BgL_appz00_bglt) BgL_allocz00_2680));
									BgL_auxz00_4117 = BGL_OBJECT_WIDENING(BgL_auxz00_4118);
								}
								BgL_auxz00_4116 =
									((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4117);
							}
							((((BgL_makezd2procedurezd2appz00_bglt) CREF(BgL_auxz00_4116))->
									BgL_tz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						}
						{
							BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4124;

							{
								obj_t BgL_auxz00_4125;

								{	/* Cfa/closure.scm 151 */
									BgL_objectz00_bglt BgL_auxz00_4126;

									BgL_auxz00_4126 =
										((BgL_objectz00_bglt)
										((BgL_appz00_bglt) BgL_allocz00_2680));
									BgL_auxz00_4125 = BGL_OBJECT_WIDENING(BgL_auxz00_4126);
								}
								BgL_auxz00_4124 =
									((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4125);
							}
							return
								((((BgL_makezd2procedurezd2appz00_bglt) CREF(BgL_auxz00_4124))->
									BgL_xz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						}
					}
				else
					{	/* Cfa/closure.scm 146 */
						return BFALSE;
					}
			}
		}
	}



/* &<anonymous:1625> */
	obj_t BGl_z62zc3anonymousza31625ze3ze1zzcfa_closurez00(obj_t BgL_envz00_3885,
		obj_t BgL_allocz00_3886)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 164 */
			{
				obj_t BgL_allocz00_2687;

				BgL_allocz00_2687 = BgL_allocz00_3886;
				if (BGl_isazf3zf3zz__objectz00(BgL_allocz00_2687,
						BGl_makezd2procedurezd2appz00zzcfa_info2z00))
					{	/* Cfa/closure.scm 165 */
						{
							BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4134;

							{
								obj_t BgL_auxz00_4135;

								{	/* Cfa/closure.scm 169 */
									BgL_objectz00_bglt BgL_auxz00_4136;

									BgL_auxz00_4136 =
										((BgL_objectz00_bglt)
										((BgL_appz00_bglt) BgL_allocz00_2687));
									BgL_auxz00_4135 = BGL_OBJECT_WIDENING(BgL_auxz00_4136);
								}
								BgL_auxz00_4134 =
									((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4135);
							}
							return
								((((BgL_makezd2procedurezd2appz00_bglt) CREF(BgL_auxz00_4134))->
									BgL_xz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
						}
					}
				else
					{	/* Cfa/closure.scm 165 */
						return BFALSE;
					}
			}
		}
	}



/* T-fix-point! */
	obj_t BGl_Tzd2fixzd2pointz12z12zzcfa_closurez00(obj_t BgL_funcallzd2listzd2_5)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 182 */
			{
				bool_t BgL_continuezf3zf3_2698;

				BgL_continuezf3zf3_2698 = ((bool_t) 1);
			BgL_zc3anonymousza31635ze3z83_2699:
				if (BgL_continuezf3zf3_2698)
					{	/* Cfa/closure.scm 187 */
						bool_t BgL_continuezf3zf3_2700;

						BgL_continuezf3zf3_2700 = ((bool_t) 0);
						{
							obj_t BgL_l1492z00_2702;

							BgL_l1492z00_2702 = BgL_funcallzd2listzd2_5;
						BgL_zc3anonymousza31636ze3z83_2703:
							if (PAIRP(BgL_l1492z00_2702))
								{	/* Cfa/closure.scm 188 */
									{	/* Cfa/closure.scm 190 */
										obj_t BgL_appz00_2705;

										BgL_appz00_2705 = CAR(BgL_l1492z00_2702);
										{	/* Cfa/closure.scm 191 */
											BgL_nodez00_bglt BgL_funz00_2706;

											BgL_funz00_2706 =
												(((BgL_funcallz00_bglt) CREF(
														((BgL_funcallz00_bglt) BgL_appz00_2705)))->
												BgL_funz00);
											{	/* Cfa/closure.scm 191 */
												BgL_approxz00_bglt BgL_approxz00_2707;

												BgL_approxz00_2707 =
													BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2706);
												{	/* Cfa/closure.scm 192 */
													obj_t BgL_allocz00_2708;

													BgL_allocz00_2708 =
														BGl_setzd2ze3listz31zzcfa_setz00(
														(((BgL_approxz00_bglt) CREF(BgL_approxz00_2707))->
															BgL_allocsz00));
													{	/* Cfa/closure.scm 193 */
														BgL_typez00_bglt BgL_typez00_2709;

														BgL_typez00_2709 =
															(((BgL_approxz00_bglt) CREF(BgL_approxz00_2707))->
															BgL_typez00);
														{	/* Cfa/closure.scm 194 */
															bool_t BgL_tzd2initzf3z21_2710;

															{	/* Cfa/closure.scm 195 */
																bool_t BgL__ortest_1155z00_2733;

																BgL__ortest_1155z00_2733 =
																	(((BgL_approxz00_bglt)
																		CREF(BgL_approxz00_2707))->BgL_topzf3zf3);
																if (BgL__ortest_1155z00_2733)
																	{	/* Cfa/closure.scm 195 */
																		BgL_tzd2initzf3z21_2710 =
																			BgL__ortest_1155z00_2733;
																	}
																else
																	{	/* Cfa/closure.scm 196 */
																		bool_t BgL_testz00_4154;

																		if (
																			(((obj_t) BgL_typez00_2709) ==
																				BGl_za2procedureza2z00zztype_cachez00))
																			{	/* Cfa/closure.scm 196 */
																				BgL_testz00_4154 = ((bool_t) 1);
																			}
																		else
																			{	/* Cfa/closure.scm 196 */
																				BgL_testz00_4154 =
																					CBOOL
																					(BGl_za2unsafezd2typeza2zd2zzengine_paramz00);
																			}
																		if (BgL_testz00_4154)
																			{	/* Cfa/closure.scm 196 */
																				BgL_tzd2initzf3z21_2710 = ((bool_t) 0);
																			}
																		else
																			{	/* Cfa/closure.scm 196 */
																				BgL_tzd2initzf3z21_2710 = ((bool_t) 1);
																			}
																	}
															}
															{	/* Cfa/closure.scm 195 */

																{
																	bool_t BgL_onezd2nonzd2tzf3zf3_2712;
																	obj_t BgL_allocsz00_2713;

																	BgL_onezd2nonzd2tzf3zf3_2712 =
																		BgL_tzd2initzf3z21_2710;
																	BgL_allocsz00_2713 = BgL_allocz00_2708;
																BgL_zc3anonymousza31638ze3z83_2714:
																	if (NULLP(BgL_allocsz00_2713))
																		{	/* Cfa/closure.scm 204 */
																			CNST_TABLE_REF(((long) 5));
																		}
																	else
																		{	/* Cfa/closure.scm 204 */
																			if (BgL_onezd2nonzd2tzf3zf3_2712)
																				{
																					obj_t BgL_l1490z00_2717;

																					{	/* Cfa/closure.scm 207 */
																						bool_t BgL_auxz00_4163;

																						BgL_l1490z00_2717 =
																							BgL_allocz00_2708;
																					BgL_zc3anonymousza31640ze3z83_2718:
																						if (PAIRP(BgL_l1490z00_2717))
																							{	/* Cfa/closure.scm 207 */
																								{	/* Cfa/closure.scm 209 */
																									obj_t BgL_allocz00_2720;

																									BgL_allocz00_2720 =
																										CAR(BgL_l1490z00_2717);
																									if (BGl_isazf3zf3zz__objectz00
																										(BgL_allocz00_2720,
																											BGl_makezd2procedurezd2appz00zzcfa_info2z00))
																										{	/* Cfa/closure.scm 211 */
																											bool_t BgL_testz00_4169;

																											{
																												BgL_makezd2procedurezd2appz00_bglt
																													BgL_auxz00_4170;
																												{
																													obj_t BgL_auxz00_4171;

																													{	/* Cfa/closure.scm 211 */
																														BgL_objectz00_bglt
																															BgL_auxz00_4172;
																														BgL_auxz00_4172 =
																															(
																															(BgL_objectz00_bglt)
																															((BgL_appz00_bglt)
																																BgL_allocz00_2720));
																														BgL_auxz00_4171 =
																															BGL_OBJECT_WIDENING
																															(BgL_auxz00_4172);
																													}
																													BgL_auxz00_4170 =
																														(
																														(BgL_makezd2procedurezd2appz00_bglt)
																														BgL_auxz00_4171);
																												}
																												BgL_testz00_4169 =
																													(((BgL_makezd2procedurezd2appz00_bglt) CREF(BgL_auxz00_4170))->BgL_tz00);
																											}
																											if (BgL_testz00_4169)
																												{	/* Cfa/closure.scm 211 */
																													{
																														BgL_makezd2procedurezd2appz00_bglt
																															BgL_auxz00_4178;
																														{
																															obj_t
																																BgL_auxz00_4179;
																															{	/* Cfa/closure.scm 213 */
																																BgL_objectz00_bglt
																																	BgL_auxz00_4180;
																																BgL_auxz00_4180
																																	=
																																	(
																																	(BgL_objectz00_bglt)
																																	((BgL_appz00_bglt) BgL_allocz00_2720));
																																BgL_auxz00_4179
																																	=
																																	BGL_OBJECT_WIDENING
																																	(BgL_auxz00_4180);
																															}
																															BgL_auxz00_4178 =
																																(
																																(BgL_makezd2procedurezd2appz00_bglt)
																																BgL_auxz00_4179);
																														}
																														((((BgL_makezd2procedurezd2appz00_bglt) CREF(BgL_auxz00_4178))->BgL_tz00) = ((bool_t) ((bool_t) 0)), BUNSPEC);
																													}
																													BgL_continuezf3zf3_2700
																														= ((bool_t) 1);
																												}
																											else
																												{	/* Cfa/closure.scm 211 */
																													BFALSE;
																												}
																										}
																									else
																										{	/* Cfa/closure.scm 209 */
																											BFALSE;
																										}
																								}
																								{
																									obj_t BgL_l1490z00_4186;

																									BgL_l1490z00_4186 =
																										CDR(BgL_l1490z00_2717);
																									BgL_l1490z00_2717 =
																										BgL_l1490z00_4186;
																									goto
																										BgL_zc3anonymousza31640ze3z83_2718;
																								}
																							}
																						else
																							{	/* Cfa/closure.scm 207 */
																								BgL_auxz00_4163 = ((bool_t) 1);
																							}
																						BBOOL(BgL_auxz00_4163);
																					}
																				}
																			else
																				{	/* Cfa/closure.scm 216 */
																					bool_t BgL_testz00_4189;

																					{	/* Cfa/closure.scm 216 */
																						obj_t BgL_arg1652z00_2731;

																						BgL_arg1652z00_2731 =
																							CAR(BgL_allocsz00_2713);
																						BgL_testz00_4189 =
																							BGl_isazf3zf3zz__objectz00
																							(BgL_arg1652z00_2731,
																							BGl_makezd2procedurezd2appz00zzcfa_info2z00);
																					}
																					if (BgL_testz00_4189)
																						{	/* Cfa/closure.scm 217 */
																							BgL_appz00_bglt BgL_i1157z00_2727;

																							BgL_i1157z00_2727 =
																								((BgL_appz00_bglt)
																								CAR(BgL_allocsz00_2713));
																							{	/* Cfa/closure.scm 218 */
																								bool_t BgL_testz00_4194;

																								{
																									BgL_makezd2procedurezd2appz00_bglt
																										BgL_auxz00_4195;
																									{
																										obj_t BgL_auxz00_4196;

																										{	/* Cfa/closure.scm 218 */
																											BgL_objectz00_bglt
																												BgL_auxz00_4197;
																											BgL_auxz00_4197 =
																												((BgL_objectz00_bglt)
																												BgL_i1157z00_2727);
																											BgL_auxz00_4196 =
																												BGL_OBJECT_WIDENING
																												(BgL_auxz00_4197);
																										}
																										BgL_auxz00_4195 =
																											(
																											(BgL_makezd2procedurezd2appz00_bglt)
																											BgL_auxz00_4196);
																									}
																									BgL_testz00_4194 =
																										(((BgL_makezd2procedurezd2appz00_bglt) CREF(BgL_auxz00_4195))->BgL_tz00);
																								}
																								if (BgL_testz00_4194)
																									{
																										obj_t BgL_allocsz00_4202;

																										BgL_allocsz00_4202 =
																											CDR(BgL_allocsz00_2713);
																										BgL_allocsz00_2713 =
																											BgL_allocsz00_4202;
																										goto
																											BgL_zc3anonymousza31638ze3z83_2714;
																									}
																								else
																									{
																										bool_t
																											BgL_onezd2nonzd2tzf3zf3_4204;
																										BgL_onezd2nonzd2tzf3zf3_4204
																											= ((bool_t) 1);
																										BgL_onezd2nonzd2tzf3zf3_2712
																											=
																											BgL_onezd2nonzd2tzf3zf3_4204;
																										goto
																											BgL_zc3anonymousza31638ze3z83_2714;
																									}
																							}
																						}
																					else
																						{	/* Cfa/closure.scm 216 */
																							if (CBOOL
																								(BGl_za2unsafezd2typeza2zd2zzengine_paramz00))
																								{
																									obj_t BgL_allocsz00_4207;

																									BgL_allocsz00_4207 =
																										CDR(BgL_allocsz00_2713);
																									BgL_allocsz00_2713 =
																										BgL_allocsz00_4207;
																									goto
																										BgL_zc3anonymousza31638ze3z83_2714;
																								}
																							else
																								{
																									bool_t
																										BgL_onezd2nonzd2tzf3zf3_4209;
																									BgL_onezd2nonzd2tzf3zf3_4209 =
																										((bool_t) 1);
																									BgL_onezd2nonzd2tzf3zf3_2712 =
																										BgL_onezd2nonzd2tzf3zf3_4209;
																									goto
																										BgL_zc3anonymousza31638ze3z83_2714;
																								}
																						}
																				}
																		}
																}
															}
														}
													}
												}
											}
										}
									}
									{
										obj_t BgL_l1492z00_4210;

										BgL_l1492z00_4210 = CDR(BgL_l1492z00_2702);
										BgL_l1492z00_2702 = BgL_l1492z00_4210;
										goto BgL_zc3anonymousza31636ze3z83_2703;
									}
								}
							else
								{	/* Cfa/closure.scm 188 */
									((bool_t) 1);
								}
						}
						{
							bool_t BgL_continuezf3zf3_4212;

							BgL_continuezf3zf3_4212 = BgL_continuezf3zf3_2700;
							BgL_continuezf3zf3_2698 = BgL_continuezf3zf3_4212;
							goto BgL_zc3anonymousza31635ze3z83_2699;
						}
					}
				else
					{	/* Cfa/closure.scm 185 */
						return BUNSPEC;
					}
			}
		}
	}



/* light-make-procedure! */
	bool_t BGl_lightzd2makezd2procedurez12z12zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 252 */
			{
				obj_t BgL_appz00_2779;

				{
					obj_t BgL_appz00_2755;

					{
						obj_t BgL_l1494z00_2746;

						BgL_l1494z00_2746 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
					BgL_zc3anonymousza31670ze3z83_2747:
						if (PAIRP(BgL_l1494z00_2746))
							{	/* Cfa/closure.scm 294 */
								{	/* Cfa/closure.scm 295 */
									obj_t BgL_appz00_2749;

									BgL_appz00_2749 = CAR(BgL_l1494z00_2746);
									{	/* Cfa/closure.scm 297 */
										bool_t BgL_testz00_4216;

										{
											BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4217;

											{
												obj_t BgL_auxz00_4218;

												{	/* Cfa/closure.scm 297 */
													BgL_objectz00_bglt BgL_auxz00_4219;

													BgL_auxz00_4219 =
														((BgL_objectz00_bglt)
														((BgL_appz00_bglt) BgL_appz00_2749));
													BgL_auxz00_4218 =
														BGL_OBJECT_WIDENING(BgL_auxz00_4219);
												}
												BgL_auxz00_4217 =
													((BgL_makezd2procedurezd2appz00_bglt)
													BgL_auxz00_4218);
											}
											BgL_testz00_4216 =
												(((BgL_makezd2procedurezd2appz00_bglt)
													CREF(BgL_auxz00_4217))->BgL_xz00);
										}
										if (BgL_testz00_4216)
											{	/* Cfa/closure.scm 297 */
												BgL_appz00_2779 = BgL_appz00_2749;
												{	/* Cfa/closure.scm 256 */
													obj_t BgL_siza7eza7_2782;

													{	/* Cfa/closure.scm 256 */
														obj_t BgL_arg1714z00_2800;

														{	/* Cfa/closure.scm 256 */
															obj_t BgL_pairz00_3610;

															BgL_pairz00_3610 =
																(((BgL_appz00_bglt) CREF(
																		((BgL_appz00_bglt)
																			((BgL_appz00_bglt) BgL_appz00_2779))))->
																BgL_argsz00);
															BgL_arg1714z00_2800 =
																CAR(CDR(CDR(BgL_pairz00_3610)));
														}
														BgL_siza7eza7_2782 =
															BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00(
															((BgL_nodez00_bglt) BgL_arg1714z00_2800));
													}
													{	/* Cfa/closure.scm 256 */
														BgL_variablez00_bglt BgL_ffunz00_2783;

														{
															BgL_varz00_bglt BgL_auxz00_4233;

															{	/* Cfa/closure.scm 257 */
																obj_t BgL_pairz00_3616;

																BgL_pairz00_3616 =
																	(((BgL_appz00_bglt) CREF(
																			((BgL_appz00_bglt)
																				((BgL_appz00_bglt) BgL_appz00_2779))))->
																	BgL_argsz00);
																BgL_auxz00_4233 =
																	((BgL_varz00_bglt) CAR(BgL_pairz00_3616));
															}
															BgL_ffunz00_2783 =
																(((BgL_varz00_bglt) CREF(BgL_auxz00_4233))->
																BgL_variablez00);
														}
														{	/* Cfa/closure.scm 257 */
															BgL_valuez00_bglt BgL_sfunz00_2784;

															BgL_sfunz00_2784 =
																(((BgL_variablez00_bglt)
																	CREF(BgL_ffunz00_2783))->BgL_valuez00);
															{	/* Cfa/closure.scm 258 */

																if (
																	((long) CINT(BgL_siza7eza7_2782) <
																		((long) 1)))
																	{	/* Cfa/closure.scm 260 */
																		{	/* Cfa/closure.scm 261 */
																			bool_t BgL_testz00_4244;

																			{	/* Cfa/closure.scm 261 */
																				bool_t BgL_testz00_4245;

																				{	/* Cfa/closure.scm 261 */
																					bool_t BgL_res2071z00_3623;

																					BgL_res2071z00_3623 =
																						BGl_isazf3zf3zz__objectz00(
																						((obj_t) BgL_ffunz00_2783),
																						BGl_globalz00zzast_varz00);
																					BgL_testz00_4245 =
																						BgL_res2071z00_3623;
																				}
																				if (BgL_testz00_4245)
																					{	/* Cfa/closure.scm 262 */
																						bool_t BgL_testz00_4248;

																						{	/* Cfa/closure.scm 262 */
																							obj_t BgL_arg1705z00_2793;

																							BgL_arg1705z00_2793 =
																								(((BgL_funz00_bglt) CREF(
																										((BgL_funz00_bglt)
																											((BgL_sfunz00_bglt)
																												BgL_sfunz00_2784))))->
																								BgL_thezd2closurezd2);
																							BgL_testz00_4248 =
																								BGl_isazf3zf3zz__objectz00
																								(BgL_arg1705z00_2793,
																								BGl_globalz00zzast_varz00);
																						}
																						if (BgL_testz00_4248)
																							{	/* Cfa/closure.scm 263 */
																								BgL_valuez00_bglt
																									BgL_arg1702z00_2791;
																								BgL_arg1702z00_2791 =
																									(((BgL_variablez00_bglt)
																										CREF(((BgL_variablez00_bglt)
																												((BgL_globalz00_bglt) ((
																															(BgL_funz00_bglt)
																															CREF((
																																	(BgL_funz00_bglt)
																																	((BgL_sfunz00_bglt) BgL_sfunz00_2784))))->BgL_thezd2closurezd2)))))->BgL_valuez00);
																								{	/* Cfa/closure.scm 263 */
																									bool_t BgL_res2073z00_3630;

																									BgL_res2073z00_3630 =
																										BGl_isazf3zf3zz__objectz00(
																										((obj_t)
																											BgL_arg1702z00_2791),
																										BGl_scnstz00zzast_varz00);
																									BgL_testz00_4244 =
																										BgL_res2073z00_3630;
																								}
																							}
																						else
																							{	/* Cfa/closure.scm 262 */
																								BgL_testz00_4244 = ((bool_t) 0);
																							}
																					}
																				else
																					{	/* Cfa/closure.scm 261 */
																						BgL_testz00_4244 = ((bool_t) 0);
																					}
																			}
																			if (BgL_testz00_4244)
																				{	/* Cfa/closure.scm 264 */
																					BgL_valuez00_bglt BgL_arg1698z00_2787;

																					BgL_arg1698z00_2787 =
																						(((BgL_variablez00_bglt) CREF(
																								((BgL_variablez00_bglt)
																									((BgL_globalz00_bglt)
																										(((BgL_funz00_bglt) CREF(
																													((BgL_funz00_bglt)
																														((BgL_sfunz00_bglt)
																															BgL_sfunz00_2784))))->
																											BgL_thezd2closurezd2)))))->
																						BgL_valuez00);
																					{	/* Cfa/closure.scm 264 */
																						obj_t BgL_vz00_3634;

																						BgL_vz00_3634 =
																							CNST_TABLE_REF(((long) 6));
																						((((BgL_scnstz00_bglt) CREF(
																										((BgL_scnstz00_bglt)
																											BgL_arg1698z00_2787)))->
																								BgL_classz00) =
																							((obj_t) BgL_vz00_3634), BUNSPEC);
																				}}
																			else
																				{	/* Cfa/closure.scm 261 */
																					BFALSE;
																				}
																		}
																		{	/* Cfa/closure.scm 266 */
																			BgL_varz00_bglt BgL_arg1707z00_2794;

																			BgL_arg1707z00_2794 =
																				(((BgL_appz00_bglt) CREF(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2779))))->
																				BgL_funz00);
																			{	/* Cfa/closure.scm 266 */
																				BgL_variablez00_bglt BgL_vz00_3636;

																				BgL_vz00_3636 =
																					((BgL_variablez00_bglt)
																					BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							CREF(BgL_arg1707z00_2794))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_3636), BUNSPEC);
																			}
																		}
																		{	/* Cfa/closure.scm 267 */
																			BgL_varz00_bglt BgL_arg1708z00_2795;

																			BgL_arg1708z00_2795 =
																				(((BgL_appz00_bglt) CREF(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2779))))->
																				BgL_funz00);
																			{	/* Cfa/closure.scm 267 */
																				BgL_typez00_bglt BgL_vz00_3638;

																				BgL_vz00_3638 =
																					((BgL_typez00_bglt)
																					BGl_za2procedurezd2elza2zd2zztype_cachez00);
																				((((BgL_nodez00_bglt)
																							CREF(((BgL_nodez00_bglt)
																									BgL_arg1708z00_2795)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_vz00_3638),
																					BUNSPEC);
																			}
																		}
																		((((BgL_nodez00_bglt) CREF(
																						((BgL_nodez00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2779))))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) ((BgL_typez00_bglt)
																					BGl_za2procedurezd2elza2zd2zztype_cachez00)),
																			BUNSPEC);
																	}
																else
																	{	/* Cfa/closure.scm 260 */
																		{	/* Cfa/closure.scm 270 */
																			BgL_varz00_bglt BgL_arg1709z00_2796;

																			BgL_arg1709z00_2796 =
																				(((BgL_appz00_bglt) CREF(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2779))))->
																				BgL_funz00);
																			{	/* Cfa/closure.scm 270 */
																				BgL_variablez00_bglt BgL_vz00_3640;

																				BgL_vz00_3640 =
																					((BgL_variablez00_bglt)
																					BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							CREF(BgL_arg1709z00_2796))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_3640), BUNSPEC);
																			}
																		}
																		{	/* Cfa/closure.scm 271 */
																			BgL_varz00_bglt BgL_arg1710z00_2797;

																			BgL_arg1710z00_2797 =
																				(((BgL_appz00_bglt) CREF(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2779))))->
																				BgL_funz00);
																			{	/* Cfa/closure.scm 271 */
																				BgL_typez00_bglt BgL_vz00_3642;

																				BgL_vz00_3642 =
																					((BgL_typez00_bglt)
																					BGl_za2procedurezd2elza2zd2zztype_cachez00);
																				((((BgL_nodez00_bglt)
																							CREF(((BgL_nodez00_bglt)
																									BgL_arg1710z00_2797)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_vz00_3642),
																					BUNSPEC);
																			}
																		}
																		((((BgL_nodez00_bglt) CREF(
																						((BgL_nodez00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2779))))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) ((BgL_typez00_bglt)
																					BGl_za2procedurezd2elza2zd2zztype_cachez00)),
																			BUNSPEC);
																	}
															}
														}
													}
												}
												{
													obj_t BgL_auxz00_4300;

													{	/* Cfa/closure.scm 273 */
														obj_t BgL_pairz00_3643;

														BgL_pairz00_3643 =
															(((BgL_appz00_bglt) CREF(
																	((BgL_appz00_bglt)
																		((BgL_appz00_bglt) BgL_appz00_2779))))->
															BgL_argsz00);
														{	/* Cfa/closure.scm 273 */
															obj_t BgL_pairz00_3646;

															BgL_pairz00_3646 = CDR(BgL_pairz00_3643);
															BgL_auxz00_4300 = CDR(BgL_pairz00_3646);
														}
													}
													((((BgL_appz00_bglt) CREF(
																	((BgL_appz00_bglt)
																		((BgL_appz00_bglt) BgL_appz00_2779))))->
															BgL_argsz00) =
														((obj_t) BgL_auxz00_4300), BUNSPEC);
												}
												BgL_appz00_2779;
											}
										else
											{	/* Cfa/closure.scm 298 */
												bool_t BgL_testz00_4309;

												{
													BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4310;

													{
														obj_t BgL_auxz00_4311;

														{	/* Cfa/closure.scm 298 */
															BgL_objectz00_bglt BgL_auxz00_4312;

															BgL_auxz00_4312 =
																((BgL_objectz00_bglt)
																((BgL_appz00_bglt) BgL_appz00_2749));
															BgL_auxz00_4311 =
																BGL_OBJECT_WIDENING(BgL_auxz00_4312);
														}
														BgL_auxz00_4310 =
															((BgL_makezd2procedurezd2appz00_bglt)
															BgL_auxz00_4311);
													}
													BgL_testz00_4309 =
														(((BgL_makezd2procedurezd2appz00_bglt)
															CREF(BgL_auxz00_4310))->BgL_tz00);
												}
												if (BgL_testz00_4309)
													{	/* Cfa/closure.scm 298 */
														BgL_appz00_2755 = BgL_appz00_2749;
														{	/* Cfa/closure.scm 278 */
															obj_t BgL_siza7eza7_2758;

															{	/* Cfa/closure.scm 278 */
																obj_t BgL_arg1692z00_2776;

																{	/* Cfa/closure.scm 278 */
																	obj_t BgL_pairz00_3647;

																	BgL_pairz00_3647 =
																		(((BgL_appz00_bglt) CREF(
																				((BgL_appz00_bglt)
																					((BgL_appz00_bglt)
																						BgL_appz00_2755))))->BgL_argsz00);
																	BgL_arg1692z00_2776 =
																		CAR(CDR(CDR(BgL_pairz00_3647)));
																}
																BgL_siza7eza7_2758 =
																	BGl_getzd2nodezd2atomzd2valuezd2zzcfa_approxz00
																	(((BgL_nodez00_bglt) BgL_arg1692z00_2776));
															}
															{	/* Cfa/closure.scm 278 */
																BgL_variablez00_bglt BgL_ffunz00_2759;

																{
																	BgL_varz00_bglt BgL_auxz00_4326;

																	{	/* Cfa/closure.scm 279 */
																		obj_t BgL_pairz00_3653;

																		BgL_pairz00_3653 =
																			(((BgL_appz00_bglt) CREF(
																					((BgL_appz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_appz00_2755))))->BgL_argsz00);
																		BgL_auxz00_4326 =
																			((BgL_varz00_bglt) CAR(BgL_pairz00_3653));
																	}
																	BgL_ffunz00_2759 =
																		(((BgL_varz00_bglt) CREF(BgL_auxz00_4326))->
																		BgL_variablez00);
																}
																{	/* Cfa/closure.scm 279 */
																	BgL_valuez00_bglt BgL_sfunz00_2760;

																	BgL_sfunz00_2760 =
																		(((BgL_variablez00_bglt)
																			CREF(BgL_ffunz00_2759))->BgL_valuez00);
																	{	/* Cfa/closure.scm 280 */

																		{	/* Cfa/closure.scm 281 */
																			bool_t BgL_testz00_4334;

																			{	/* Cfa/closure.scm 281 */
																				bool_t BgL_testz00_4335;

																				{	/* Cfa/closure.scm 281 */
																					bool_t BgL_res2074z00_3657;

																					BgL_res2074z00_3657 =
																						BGl_isazf3zf3zz__objectz00(
																						((obj_t) BgL_ffunz00_2759),
																						BGl_globalz00zzast_varz00);
																					BgL_testz00_4335 =
																						BgL_res2074z00_3657;
																				}
																				if (BgL_testz00_4335)
																					{	/* Cfa/closure.scm 282 */
																						bool_t BgL_testz00_4338;

																						{	/* Cfa/closure.scm 282 */
																							obj_t BgL_arg1684z00_2768;

																							BgL_arg1684z00_2768 =
																								(((BgL_funz00_bglt) CREF(
																										((BgL_funz00_bglt)
																											((BgL_sfunz00_bglt)
																												BgL_sfunz00_2760))))->
																								BgL_thezd2closurezd2);
																							BgL_testz00_4338 =
																								BGl_isazf3zf3zz__objectz00
																								(BgL_arg1684z00_2768,
																								BGl_globalz00zzast_varz00);
																						}
																						if (BgL_testz00_4338)
																							{	/* Cfa/closure.scm 283 */
																								BgL_valuez00_bglt
																									BgL_arg1682z00_2766;
																								BgL_arg1682z00_2766 =
																									(((BgL_variablez00_bglt)
																										CREF(((BgL_variablez00_bglt)
																												((BgL_globalz00_bglt) ((
																															(BgL_funz00_bglt)
																															CREF((
																																	(BgL_funz00_bglt)
																																	((BgL_sfunz00_bglt) BgL_sfunz00_2760))))->BgL_thezd2closurezd2)))))->BgL_valuez00);
																								{	/* Cfa/closure.scm 283 */
																									bool_t BgL_res2076z00_3664;

																									BgL_res2076z00_3664 =
																										BGl_isazf3zf3zz__objectz00(
																										((obj_t)
																											BgL_arg1682z00_2766),
																										BGl_scnstz00zzast_varz00);
																									BgL_testz00_4334 =
																										BgL_res2076z00_3664;
																								}
																							}
																						else
																							{	/* Cfa/closure.scm 282 */
																								BgL_testz00_4334 = ((bool_t) 0);
																							}
																					}
																				else
																					{	/* Cfa/closure.scm 281 */
																						BgL_testz00_4334 = ((bool_t) 0);
																					}
																			}
																			if (BgL_testz00_4334)
																				{	/* Cfa/closure.scm 284 */
																					BgL_valuez00_bglt BgL_arg1678z00_2762;

																					BgL_arg1678z00_2762 =
																						(((BgL_variablez00_bglt) CREF(
																								((BgL_variablez00_bglt)
																									((BgL_globalz00_bglt)
																										(((BgL_funz00_bglt) CREF(
																													((BgL_funz00_bglt)
																														((BgL_sfunz00_bglt)
																															BgL_sfunz00_2760))))->
																											BgL_thezd2closurezd2)))))->
																						BgL_valuez00);
																					{	/* Cfa/closure.scm 284 */
																						obj_t BgL_vz00_3668;

																						BgL_vz00_3668 =
																							CNST_TABLE_REF(((long) 7));
																						((((BgL_scnstz00_bglt) CREF(
																										((BgL_scnstz00_bglt)
																											BgL_arg1678z00_2762)))->
																								BgL_classz00) =
																							((obj_t) BgL_vz00_3668), BUNSPEC);
																				}}
																			else
																				{	/* Cfa/closure.scm 281 */
																					BFALSE;
																				}
																		}
																		{	/* Cfa/closure.scm 286 */
																			BgL_varz00_bglt BgL_arg1685z00_2769;

																			BgL_arg1685z00_2769 =
																				(((BgL_appz00_bglt) CREF(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2755))))->
																				BgL_funz00);
																			{	/* Cfa/closure.scm 286 */
																				BgL_variablez00_bglt BgL_vz00_3670;

																				BgL_vz00_3670 =
																					((BgL_variablez00_bglt)
																					BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							CREF(BgL_arg1685z00_2769))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_3670), BUNSPEC);
																			}
																		}
																		{	/* Cfa/closure.scm 288 */
																			BgL_varz00_bglt BgL_arg1686z00_2770;

																			BgL_arg1686z00_2770 =
																				(((BgL_appz00_bglt) CREF(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2755))))->
																				BgL_funz00);
																			{	/* Cfa/closure.scm 288 */
																				BgL_typez00_bglt BgL_vz00_3672;

																				BgL_vz00_3672 =
																					((BgL_typez00_bglt)
																					BGl_za2procedureza2z00zztype_cachez00);
																				((((BgL_nodez00_bglt)
																							CREF(((BgL_nodez00_bglt)
																									BgL_arg1686z00_2770)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_vz00_3672),
																					BUNSPEC);
																			}
																		}
																		((((BgL_nodez00_bglt) CREF(
																						((BgL_nodez00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2755))))->
																				BgL_typez00) =
																			((BgL_typez00_bglt) ((BgL_typez00_bglt)
																					BGl_za2procedureza2z00zztype_cachez00)),
																			BUNSPEC);
																		{	/* Cfa/closure.scm 290 */
																			obj_t BgL_arg1687z00_2771;
																			obj_t BgL_arg1688z00_2772;

																			BgL_arg1687z00_2771 =
																				(((BgL_appz00_bglt) CREF(
																						((BgL_appz00_bglt)
																							((BgL_appz00_bglt)
																								BgL_appz00_2755))))->
																				BgL_argsz00);
																			{	/* Cfa/closure.scm 290 */
																				obj_t BgL_pairz00_3673;

																				BgL_pairz00_3673 =
																					(((BgL_appz00_bglt) CREF(
																							((BgL_appz00_bglt)
																								((BgL_appz00_bglt)
																									BgL_appz00_2755))))->
																					BgL_argsz00);
																				BgL_arg1688z00_2772 =
																					CDR(CDR(BgL_pairz00_3673));
																			}
																			SET_CDR(BgL_arg1687z00_2771,
																				BgL_arg1688z00_2772);
																		}
																		BgL_appz00_2755;
																	}
																}
															}
														}
													}
												else
													{	/* Cfa/closure.scm 298 */
														BFALSE;
													}
											}
									}
								}
								{
									obj_t BgL_l1494z00_4384;

									BgL_l1494z00_4384 = CDR(BgL_l1494z00_2746);
									BgL_l1494z00_2746 = BgL_l1494z00_4384;
									goto BgL_zc3anonymousza31670ze3z83_2747;
								}
							}
						else
							{	/* Cfa/closure.scm 294 */
								return ((bool_t) 1);
							}
					}
				}
			}
		}
	}



/* light-funcall! */
	bool_t BGl_lightzd2funcallz12zc0zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 304 */
			{
				obj_t BgL_l1501z00_2805;

				BgL_l1501z00_2805 = BGl_za2funcallzd2listza2zd2zzcfa_closurez00;
			BgL_zc3anonymousza31717ze3z83_2806:
				if (PAIRP(BgL_l1501z00_2805))
					{	/* Cfa/closure.scm 305 */
						{	/* Cfa/closure.scm 306 */
							BgL_funcallz00_bglt BgL_appz00_2808;

							BgL_appz00_2808 = ((BgL_funcallz00_bglt) CAR(BgL_l1501z00_2805));
							{	/* Cfa/closure.scm 307 */
								BgL_nodez00_bglt BgL_funz00_2809;

								BgL_funz00_2809 =
									(((BgL_funcallz00_bglt) CREF(BgL_appz00_2808))->BgL_funz00);
								{	/* Cfa/closure.scm 307 */
									BgL_approxz00_bglt BgL_approxz00_2810;

									BgL_approxz00_2810 =
										BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2809);
									{	/* Cfa/closure.scm 308 */
										obj_t BgL_alloczd2listzd2_2811;

										BgL_alloczd2listzd2_2811 =
											BGl_setzd2ze3listz31zzcfa_setz00(
											(((BgL_approxz00_bglt) CREF(BgL_approxz00_2810))->
												BgL_allocsz00));
										{	/* Cfa/closure.scm 309 */

											{	/* Cfa/closure.scm 310 */
												bool_t BgL_testz00_4394;

												if (PAIRP(BgL_alloczd2listzd2_2811))
													{	/* Cfa/closure.scm 311 */
														bool_t BgL_testz00_4397;

														{	/* Cfa/closure.scm 311 */
															obj_t BgL_arg1752z00_2851;

															BgL_arg1752z00_2851 =
																CAR(BgL_alloczd2listzd2_2811);
															BgL_testz00_4397 =
																BGl_isazf3zf3zz__objectz00(BgL_arg1752z00_2851,
																BGl_makezd2procedurezd2appz00zzcfa_info2z00);
														}
														if (BgL_testz00_4397)
															{	/* Cfa/closure.scm 311 */
																BgL_testz00_4394 = ((bool_t) 0);
															}
														else
															{	/* Cfa/closure.scm 311 */
																BgL_testz00_4394 = ((bool_t) 1);
															}
													}
												else
													{	/* Cfa/closure.scm 310 */
														BgL_testz00_4394 = ((bool_t) 1);
													}
												if (BgL_testz00_4394)
													{	/* Cfa/closure.scm 310 */
														CNST_TABLE_REF(((long) 8));
													}
												else
													{	/* Cfa/closure.scm 315 */
														BgL_appz00_bglt BgL_allocz00_2813;

														BgL_allocz00_2813 =
															((BgL_appz00_bglt) CAR(BgL_alloczd2listzd2_2811));
														{	/* Cfa/closure.scm 318 */
															bool_t BgL_testz00_4403;

															{
																BgL_makezd2procedurezd2appz00_bglt
																	BgL_auxz00_4404;
																{
																	obj_t BgL_auxz00_4405;

																	{	/* Cfa/closure.scm 318 */
																		BgL_objectz00_bglt BgL_auxz00_4406;

																		BgL_auxz00_4406 =
																			((BgL_objectz00_bglt)
																			((BgL_appz00_bglt) BgL_allocz00_2813));
																		BgL_auxz00_4405 =
																			BGL_OBJECT_WIDENING(BgL_auxz00_4406);
																	}
																	BgL_auxz00_4404 =
																		((BgL_makezd2procedurezd2appz00_bglt)
																		BgL_auxz00_4405);
																}
																BgL_testz00_4403 =
																	(((BgL_makezd2procedurezd2appz00_bglt)
																		CREF(BgL_auxz00_4404))->BgL_xz00);
															}
															if (BgL_testz00_4403)
																{	/* Cfa/closure.scm 318 */
																	{	/* Cfa/closure.scm 323 */
																		BgL_varz00_bglt BgL_arg1721z00_2816;

																		{	/* Cfa/closure.scm 323 */
																			BgL_varz00_bglt
																				BgL_duplicated1164z00_2817;
																			BgL_varz00_bglt BgL_new1163z00_2818;

																			{	/* Cfa/closure.scm 323 */
																				obj_t BgL_pairz00_3694;

																				BgL_pairz00_3694 =
																					(((BgL_appz00_bglt) CREF(
																							((BgL_appz00_bglt)
																								((BgL_appz00_bglt)
																									BgL_allocz00_2813))))->
																					BgL_argsz00);
																				BgL_duplicated1164z00_2817 =
																					((BgL_varz00_bglt)
																					CAR(BgL_pairz00_3694));
																			}
																			{	/* Cfa/closure.scm 324 */
																				BgL_varz00_bglt BgL_new1165z00_2827;

																				BgL_new1165z00_2827 =
																					((BgL_varz00_bglt)
																					BREF(GC_MALLOC(sizeof(struct
																								BgL_varz00_bgl))));
																				{	/* Cfa/closure.scm 324 */
																					long BgL_arg1736z00_2828;

																					{	/* Cfa/closure.scm 324 */
																						long BgL_res2081z00_3696;

																						BgL_res2081z00_3696 =
																							BGL_CLASS_INDEX
																							(BGl_varz00zzast_nodez00);
																						BgL_arg1736z00_2828 =
																							BgL_res2081z00_3696;
																					}
																					BGL_OBJECT_CLASS_NUM_SET(
																						((BgL_objectz00_bglt)
																							BgL_new1165z00_2827),
																						BgL_arg1736z00_2828);
																				}
																				{	/* Cfa/closure.scm 324 */
																					BgL_objectz00_bglt BgL_auxz00_4421;

																					BgL_auxz00_4421 =
																						((BgL_objectz00_bglt)
																						BgL_new1165z00_2827);
																					BGL_OBJECT_WIDENING_SET
																						(BgL_auxz00_4421, BFALSE);
																				}
																				BgL_new1163z00_2818 =
																					BgL_new1165z00_2827;
																			}
																			((((BgL_nodez00_bglt) CREF(
																							((BgL_nodez00_bglt)
																								BgL_new1163z00_2818)))->
																					BgL_locz00) =
																				((obj_t) (((BgL_nodez00_bglt)
																							CREF(((BgL_nodez00_bglt)
																									BgL_duplicated1164z00_2817)))->
																						BgL_locz00)), BUNSPEC);
																			{
																				BgL_typez00_bglt BgL_auxz00_4428;

																				{	/* Cfa/closure.scm 325 */
																					obj_t BgL_arg1723z00_2819;
																					BgL_typez00_bglt BgL_arg1724z00_2820;

																					{	/* Cfa/closure.scm 325 */
																						BgL_approxz00_bglt
																							BgL_arg1727z00_2821;
																						obj_t BgL_arg1728z00_2822;

																						{
																							BgL_makezd2procedurezd2appz00_bglt
																								BgL_auxz00_4430;
																							{
																								obj_t BgL_auxz00_4431;

																								{	/* Cfa/closure.scm 325 */
																									BgL_objectz00_bglt
																										BgL_auxz00_4432;
																									BgL_auxz00_4432 =
																										((BgL_objectz00_bglt) (
																											(BgL_appz00_bglt)
																											BgL_allocz00_2813));
																									BgL_auxz00_4431 =
																										BGL_OBJECT_WIDENING
																										(BgL_auxz00_4432);
																								}
																								BgL_auxz00_4430 =
																									(
																									(BgL_makezd2procedurezd2appz00_bglt)
																									BgL_auxz00_4431);
																							}
																							BgL_arg1727z00_2821 =
																								(((BgL_makezd2procedurezd2appz00_bglt) CREF(BgL_auxz00_4430))->BgL_approxz00);
																						}
																						{	/* Cfa/closure.scm 325 */
																							obj_t BgL_pairz00_3699;

																							BgL_pairz00_3699 =
																								(((BgL_appz00_bglt) CREF(
																										((BgL_appz00_bglt)
																											((BgL_appz00_bglt)
																												BgL_allocz00_2813))))->
																								BgL_argsz00);
																							BgL_arg1728z00_2822 =
																								CAR(BgL_pairz00_3699);
																						}
																						BgL_arg1723z00_2819 =
																							BGl_getzd2approxzd2typez00zzcfa_typez00
																							(BgL_arg1727z00_2821,
																							BgL_arg1728z00_2822);
																					}
																					{
																						BgL_nodez00_bglt BgL_auxz00_4443;

																						{
																							BgL_varz00_bglt BgL_auxz00_4444;

																							{	/* Cfa/closure.scm 326 */
																								obj_t BgL_pairz00_3700;

																								BgL_pairz00_3700 =
																									(((BgL_appz00_bglt) CREF(
																											((BgL_appz00_bglt)
																												((BgL_appz00_bglt)
																													BgL_allocz00_2813))))->
																									BgL_argsz00);
																								BgL_auxz00_4444 =
																									((BgL_varz00_bglt)
																									CAR(BgL_pairz00_3700));
																							}
																							BgL_auxz00_4443 =
																								((BgL_nodez00_bglt)
																								BgL_auxz00_4444);
																						}
																						BgL_arg1724z00_2820 =
																							(((BgL_nodez00_bglt)
																								CREF(BgL_auxz00_4443))->
																							BgL_typez00);
																					}
																					BgL_auxz00_4428 =
																						BGl_strictzd2nodezd2typez00zzast_nodez00
																						(((BgL_typez00_bglt)
																							BgL_arg1723z00_2819),
																						BgL_arg1724z00_2820);
																				}
																				((((BgL_nodez00_bglt) CREF(
																								((BgL_nodez00_bglt)
																									BgL_new1163z00_2818)))->
																						BgL_typez00) =
																					((BgL_typez00_bglt) BgL_auxz00_4428),
																					BUNSPEC);
																			}
																			((((BgL_varz00_bglt)
																						CREF(BgL_new1163z00_2818))->
																					BgL_variablez00) =
																				((BgL_variablez00_bglt) ((
																							(BgL_varz00_bglt)
																							CREF
																							(BgL_duplicated1164z00_2817))->
																						BgL_variablez00)), BUNSPEC);
																			BgL_arg1721z00_2816 = BgL_new1163z00_2818;
																		}
																		((((BgL_funcallz00_bglt)
																					CREF(BgL_appz00_2808))->BgL_funz00) =
																			((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
																					BgL_arg1721z00_2816)), BUNSPEC);
																	}
																	{	/* Cfa/closure.scm 327 */
																		obj_t BgL_arg1738z00_2829;

																		{	/* Cfa/closure.scm 327 */
																			obj_t BgL_arg1739z00_2830;

																			{	/* Cfa/closure.scm 327 */
																				obj_t BgL_pairz00_3704;

																				BgL_pairz00_3704 =
																					(((BgL_appz00_bglt) CREF(
																							((BgL_appz00_bglt)
																								((BgL_appz00_bglt)
																									BgL_allocz00_2813))))->
																					BgL_argsz00);
																				BgL_arg1739z00_2830 =
																					CAR(BgL_pairz00_3704);
																			}
																			{	/* Cfa/closure.scm 327 */
																				obj_t BgL_list1740z00_2831;

																				BgL_list1740z00_2831 =
																					MAKE_PAIR(BgL_arg1739z00_2830, BNIL);
																				BgL_arg1738z00_2829 =
																					BgL_list1740z00_2831;
																		}}
																		((((BgL_funcallz00_bglt)
																					CREF(BgL_appz00_2808))->
																				BgL_functionsz00) =
																			((obj_t) BgL_arg1738z00_2829), BUNSPEC);
																	}
																	{	/* Cfa/closure.scm 328 */
																		obj_t BgL_vz00_3710;

																		BgL_vz00_3710 = CNST_TABLE_REF(((long) 1));
																		((((BgL_funcallz00_bglt)
																					CREF(BgL_appz00_2808))->
																				BgL_strengthz00) =
																			((obj_t) BgL_vz00_3710), BUNSPEC);
																}}
															else
																{	/* Cfa/closure.scm 329 */
																	bool_t BgL_testz00_4467;

																	{
																		BgL_makezd2procedurezd2appz00_bglt
																			BgL_auxz00_4468;
																		{
																			obj_t BgL_auxz00_4469;

																			{	/* Cfa/closure.scm 329 */
																				BgL_objectz00_bglt BgL_auxz00_4470;

																				BgL_auxz00_4470 =
																					((BgL_objectz00_bglt)
																					((BgL_appz00_bglt)
																						BgL_allocz00_2813));
																				BgL_auxz00_4469 =
																					BGL_OBJECT_WIDENING(BgL_auxz00_4470);
																			}
																			BgL_auxz00_4468 =
																				((BgL_makezd2procedurezd2appz00_bglt)
																				BgL_auxz00_4469);
																		}
																		BgL_testz00_4467 =
																			(((BgL_makezd2procedurezd2appz00_bglt)
																				CREF(BgL_auxz00_4468))->BgL_tz00);
																	}
																	if (BgL_testz00_4467)
																		{	/* Cfa/closure.scm 329 */
																			{	/* Cfa/closure.scm 332 */
																				obj_t BgL_fz00_2834;

																				if (NULLP(BgL_alloczd2listzd2_2811))
																					{	/* Cfa/closure.scm 332 */
																						BgL_fz00_2834 = BNIL;
																					}
																				else
																					{	/* Cfa/closure.scm 332 */
																						obj_t BgL_head1498z00_2837;

																						{	/* Cfa/closure.scm 332 */
																							obj_t BgL_res2084z00_3715;

																							BgL_res2084z00_3715 =
																								MAKE_PAIR(BNIL, BNIL);
																							BgL_head1498z00_2837 =
																								BgL_res2084z00_3715;
																						}
																						{
																							obj_t BgL_l1496z00_2839;
																							obj_t BgL_tail1499z00_2840;

																							BgL_l1496z00_2839 =
																								BgL_alloczd2listzd2_2811;
																							BgL_tail1499z00_2840 =
																								BgL_head1498z00_2837;
																						BgL_zc3anonymousza31744ze3z83_2841:
																							if (NULLP(BgL_l1496z00_2839))
																								{	/* Cfa/closure.scm 332 */
																									BgL_fz00_2834 =
																										CDR(BgL_head1498z00_2837);
																								}
																							else
																								{	/* Cfa/closure.scm 332 */
																									obj_t BgL_newtail1500z00_2843;

																									{	/* Cfa/closure.scm 332 */
																										obj_t BgL_arg1748z00_2845;

																										{	/* Cfa/closure.scm 333 */
																											obj_t BgL_pairz00_3721;

																											BgL_pairz00_3721 =
																												(((BgL_appz00_bglt)
																													CREF((
																															(BgL_appz00_bglt)
																															((BgL_appz00_bglt)
																																CAR
																																(BgL_l1496z00_2839)))))->
																												BgL_argsz00);
																											BgL_arg1748z00_2845 =
																												CAR(BgL_pairz00_3721);
																										}
																										{	/* Cfa/closure.scm 332 */
																											obj_t BgL_res2086z00_3724;

																											BgL_res2086z00_3724 =
																												MAKE_PAIR
																												(BgL_arg1748z00_2845,
																												BNIL);
																											BgL_newtail1500z00_2843 =
																												BgL_res2086z00_3724;
																										}
																									}
																									SET_CDR(BgL_tail1499z00_2840,
																										BgL_newtail1500z00_2843);
																									{
																										obj_t BgL_tail1499z00_4491;
																										obj_t BgL_l1496z00_4489;

																										BgL_l1496z00_4489 =
																											CDR(BgL_l1496z00_2839);
																										BgL_tail1499z00_4491 =
																											BgL_newtail1500z00_2843;
																										BgL_tail1499z00_2840 =
																											BgL_tail1499z00_4491;
																										BgL_l1496z00_2839 =
																											BgL_l1496z00_4489;
																										goto
																											BgL_zc3anonymousza31744ze3z83_2841;
																									}
																								}
																						}
																					}
																				((((BgL_funcallz00_bglt)
																							CREF(BgL_appz00_2808))->
																						BgL_functionsz00) =
																					((obj_t) BgL_fz00_2834), BUNSPEC);
																				{	/* Cfa/closure.scm 336 */
																					obj_t BgL_vz00_3731;

																					BgL_vz00_3731 =
																						CNST_TABLE_REF(((long) 2));
																					((((BgL_funcallz00_bglt)
																								CREF(BgL_appz00_2808))->
																							BgL_strengthz00) =
																						((obj_t) BgL_vz00_3731), BUNSPEC);
																		}}}
																	else
																		{	/* Cfa/closure.scm 329 */
																			CNST_TABLE_REF(((long) 8));
						}}}}}}}}}}
						{
							obj_t BgL_l1501z00_4496;

							BgL_l1501z00_4496 = CDR(BgL_l1501z00_2805);
							BgL_l1501z00_2805 = BgL_l1501z00_4496;
							goto BgL_zc3anonymousza31717ze3z83_2806;
						}
					}
				else
					{	/* Cfa/closure.scm 305 */
						((bool_t) 1);
					}
			}
			if (CBOOL
				(BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00))
				{	/* Cfa/closure.scm 344 */
					obj_t BgL_funcallzd2lzd2_2855;

					BgL_funcallzd2lzd2_2855 =
						BGl_zc3anonymousza31764ze3z83zzcfa_closurez00
						(BGl_za2funcallzd2listza2zd2zzcfa_closurez00);
					{

					BgL_zc3anonymousza31756ze3z83_2857:
						{	/* Cfa/closure.scm 348 */
							bool_t BgL_contz00_2858;

							BgL_contz00_2858 = ((bool_t) 0);
							{
								obj_t BgL_l1508z00_2860;

								BgL_l1508z00_2860 = BgL_funcallzd2lzd2_2855;
							BgL_zc3anonymousza31757ze3z83_2861:
								if (PAIRP(BgL_l1508z00_2860))
									{	/* Cfa/closure.scm 349 */
										{	/* Cfa/closure.scm 350 */
											BgL_funcallz00_bglt BgL_appz00_2863;

											BgL_appz00_2863 =
												((BgL_funcallz00_bglt) CAR(BgL_l1508z00_2860));
											{	/* Cfa/closure.scm 350 */
												BgL_nodez00_bglt BgL_funz00_2864;

												BgL_funz00_2864 =
													(((BgL_funcallz00_bglt) CREF(BgL_appz00_2863))->
													BgL_funz00);
												{	/* Cfa/closure.scm 350 */
													BgL_approxz00_bglt BgL_approxz00_2865;

													BgL_approxz00_2865 =
														BGl_cfaz12z12zzcfa_cfaz00(BgL_funz00_2864);
													{	/* Cfa/closure.scm 351 */
														obj_t BgL_appsz00_2866;

														BgL_appsz00_2866 =
															BGl_setzd2ze3listz31zzcfa_setz00(
															(((BgL_approxz00_bglt) CREF(BgL_approxz00_2865))->
																BgL_allocsz00));
														{	/* Cfa/closure.scm 352 */

															{	/* Cfa/closure.scm 353 */
																bool_t BgL_testz00_4509;

																if (PAIRP(BgL_appsz00_2866))
																	{	/* Cfa/closure.scm 353 */
																		obj_t BgL_auxz00_4512;

																		BgL_auxz00_4512 = CDR(BgL_appsz00_2866);
																		BgL_testz00_4509 = PAIRP(BgL_auxz00_4512);
																	}
																else
																	{	/* Cfa/closure.scm 353 */
																		BgL_testz00_4509 = ((bool_t) 0);
																	}
																if (BgL_testz00_4509)
																	{	/* Cfa/closure.scm 355 */
																		bool_t BgL__ortest_1166z00_2868;

																		BgL__ortest_1166z00_2868 =
																			BGl_mergezd2appzd2typesz12z12zzcfa_closurez00
																			(BgL_appsz00_2866);
																		if (BgL__ortest_1166z00_2868)
																			{	/* Cfa/closure.scm 355 */
																				BgL_contz00_2858 =
																					BgL__ortest_1166z00_2868;
																			}
																		else
																			{	/* Cfa/closure.scm 355 */
																				BgL_contz00_2858 = BgL_contz00_2858;
																			}
																	}
																else
																	{	/* Cfa/closure.scm 353 */
																		BFALSE;
																	}
															}
														}
													}
												}
											}
										}
										{
											obj_t BgL_l1508z00_4517;

											BgL_l1508z00_4517 = CDR(BgL_l1508z00_2860);
											BgL_l1508z00_2860 = BgL_l1508z00_4517;
											goto BgL_zc3anonymousza31757ze3z83_2861;
										}
									}
								else
									{	/* Cfa/closure.scm 349 */
										((bool_t) 1);
									}
							}
							if (BgL_contz00_2858)
								{	/* Cfa/closure.scm 357 */
									goto BgL_zc3anonymousza31756ze3z83_2857;
								}
							else
								{	/* Cfa/closure.scm 357 */
									return ((bool_t) 0);
								}
						}
					}
				}
			else
				{	/* Cfa/closure.scm 341 */
					return ((bool_t) 0);
				}
		}
	}



/* <anonymous:1764> */
	obj_t BGl_zc3anonymousza31764ze3z83zzcfa_closurez00(obj_t BgL_lis1504z00_2876)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 344 */
		BGl_zc3anonymousza31764ze3z83zzcfa_closurez00:
			if (NULLP(BgL_lis1504z00_2876))
				{	/* Cfa/closure.scm 344 */
					return BgL_lis1504z00_2876;
				}
			else
				{	/* Cfa/closure.scm 344 */
					obj_t BgL_head1505z00_2879;
					obj_t BgL_tail1506z00_2880;

					BgL_head1505z00_2879 = CAR(BgL_lis1504z00_2876);
					BgL_tail1506z00_2880 = CDR(BgL_lis1504z00_2876);
					if (
						((((BgL_funcallz00_bglt) CREF(
										((BgL_funcallz00_bglt) BgL_head1505z00_2879)))->
								BgL_strengthz00) == CNST_TABLE_REF(((long) 2))))
						{	/* Cfa/closure.scm 344 */
							obj_t BgL_newzd2tail1507zd2_2882;

							BgL_newzd2tail1507zd2_2882 =
								BGl_zc3anonymousza31764ze3z83zzcfa_closurez00
								(BgL_tail1506z00_2880);
							if ((BgL_tail1506z00_2880 == BgL_newzd2tail1507zd2_2882))
								{	/* Cfa/closure.scm 344 */
									return BgL_lis1504z00_2876;
								}
							else
								{	/* Cfa/closure.scm 344 */
									obj_t BgL_res2089z00_3743;

									BgL_res2089z00_3743 =
										MAKE_PAIR(BgL_head1505z00_2879, BgL_newzd2tail1507zd2_2882);
									return BgL_res2089z00_3743;
								}
						}
					else
						{
							obj_t BgL_lis1504z00_4533;

							BgL_lis1504z00_4533 = BgL_tail1506z00_2880;
							BgL_lis1504z00_2876 = BgL_lis1504z00_4533;
							goto BGl_zc3anonymousza31764ze3z83zzcfa_closurez00;
						}
				}
		}
	}



/* merge-app-types! */
	bool_t BGl_mergezd2appzd2typesz12z12zzcfa_closurez00(obj_t BgL_apps0z00_8)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 363 */
			{
				BgL_appz00_bglt BgL_app0z00_2900;
				BgL_appz00_bglt BgL_app1z00_2901;

				{	/* Cfa/closure.scm 415 */
					obj_t BgL_g1170z00_2888;

					BgL_g1170z00_2888 = CDR(BgL_apps0z00_8);
					{
						obj_t BgL_appsz00_2890;
						bool_t BgL_contz00_2891;

						BgL_appsz00_2890 = BgL_g1170z00_2888;
						BgL_contz00_2891 = ((bool_t) 0);
					BgL_zc3anonymousza31770ze3z83_2892:
						if (NULLP(BgL_appsz00_2890))
							{	/* Cfa/closure.scm 417 */
								return BgL_contz00_2891;
							}
						else
							{	/* Cfa/closure.scm 421 */
								obj_t BgL_arg1773z00_2894;
								bool_t BgL_arg1774z00_2895;

								BgL_arg1773z00_2894 = CDR(BgL_appsz00_2890);
								{	/* Cfa/closure.scm 421 */
									bool_t BgL__ortest_1171z00_2896;

									{	/* Cfa/closure.scm 421 */
										obj_t BgL_arg1775z00_2897;
										obj_t BgL_arg1776z00_2898;

										BgL_arg1775z00_2897 = CAR(BgL_apps0z00_8);
										BgL_arg1776z00_2898 = CAR(BgL_appsz00_2890);
										BgL_app0z00_2900 = ((BgL_appz00_bglt) BgL_arg1775z00_2897);
										BgL_app1z00_2901 = ((BgL_appz00_bglt) BgL_arg1776z00_2898);
										{	/* Cfa/closure.scm 366 */
											BgL_variablez00_bglt BgL_f0z00_2903;

											{
												BgL_varz00_bglt BgL_auxz00_4540;

												{	/* Cfa/closure.scm 366 */
													obj_t BgL_pairz00_3756;

													BgL_pairz00_3756 =
														(((BgL_appz00_bglt) CREF(
																((BgL_appz00_bglt) BgL_app0z00_2900)))->
														BgL_argsz00);
													BgL_auxz00_4540 =
														((BgL_varz00_bglt) CAR(BgL_pairz00_3756));
												}
												BgL_f0z00_2903 =
													(((BgL_varz00_bglt) CREF(BgL_auxz00_4540))->
													BgL_variablez00);
											}
											{	/* Cfa/closure.scm 366 */
												BgL_variablez00_bglt BgL_f1z00_2904;

												{
													BgL_varz00_bglt BgL_auxz00_4546;

													{	/* Cfa/closure.scm 367 */
														obj_t BgL_pairz00_3759;

														BgL_pairz00_3759 =
															(((BgL_appz00_bglt) CREF(
																	((BgL_appz00_bglt) BgL_app1z00_2901)))->
															BgL_argsz00);
														BgL_auxz00_4546 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_3759));
													}
													BgL_f1z00_2904 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_4546))->
														BgL_variablez00);
												}
												{	/* Cfa/closure.scm 367 */

													{	/* Cfa/closure.scm 368 */
														obj_t BgL_g1167z00_2905;
														obj_t BgL_g1168z00_2906;

														{	/* Cfa/closure.scm 368 */
															obj_t BgL_pairz00_3763;

															BgL_pairz00_3763 =
																(((BgL_sfunz00_bglt) CREF(
																		((BgL_sfunz00_bglt)
																			(((BgL_variablez00_bglt)
																					CREF(BgL_f0z00_2903))->
																				BgL_valuez00))))->BgL_argsz00);
															BgL_g1167z00_2905 = CDR(BgL_pairz00_3763);
														}
														{	/* Cfa/closure.scm 369 */
															obj_t BgL_pairz00_3766;

															BgL_pairz00_3766 =
																(((BgL_sfunz00_bglt) CREF(
																		((BgL_sfunz00_bglt)
																			(((BgL_variablez00_bglt)
																					CREF(BgL_f1z00_2904))->
																				BgL_valuez00))))->BgL_argsz00);
															BgL_g1168z00_2906 = CDR(BgL_pairz00_3766);
														}
														{
															obj_t BgL_a0z00_2908;
															obj_t BgL_a1z00_2909;
															bool_t BgL_contz00_2910;

															BgL_a0z00_2908 = BgL_g1167z00_2905;
															BgL_a1z00_2909 = BgL_g1168z00_2906;
															BgL_contz00_2910 = ((bool_t) 0);
														BgL_zc3anonymousza31778ze3z83_2911:
															{	/* Cfa/closure.scm 371 */
																bool_t BgL_testz00_4560;

																if (PAIRP(BgL_a0z00_2908))
																	{	/* Cfa/closure.scm 371 */
																		BgL_testz00_4560 = PAIRP(BgL_a1z00_2909);
																	}
																else
																	{	/* Cfa/closure.scm 371 */
																		BgL_testz00_4560 = ((bool_t) 0);
																	}
																if (BgL_testz00_4560)
																	{	/* Cfa/closure.scm 372 */
																		BgL_approxz00_bglt BgL_p0z00_2913;

																		{
																			BgL_svarzf2cinfozf2_bglt BgL_auxz00_4564;

																			{
																				obj_t BgL_auxz00_4565;

																				{	/* Cfa/closure.scm 372 */
																					BgL_objectz00_bglt BgL_auxz00_4566;

																					BgL_auxz00_4566 =
																						((BgL_objectz00_bglt)
																						((BgL_svarz00_bglt)
																							(((BgL_variablez00_bglt) CREF(
																										((BgL_variablez00_bglt)
																											CAR(BgL_a0z00_2908))))->
																								BgL_valuez00)));
																					BgL_auxz00_4565 =
																						BGL_OBJECT_WIDENING
																						(BgL_auxz00_4566);
																				}
																				BgL_auxz00_4564 =
																					((BgL_svarzf2cinfozf2_bglt)
																					BgL_auxz00_4565);
																			}
																			BgL_p0z00_2913 =
																				(((BgL_svarzf2cinfozf2_bglt)
																					CREF(BgL_auxz00_4564))->
																				BgL_approxz00);
																		}
																		{	/* Cfa/closure.scm 372 */
																			BgL_approxz00_bglt BgL_p1z00_2914;

																			{
																				BgL_svarzf2cinfozf2_bglt
																					BgL_auxz00_4575;
																				{
																					obj_t BgL_auxz00_4576;

																					{	/* Cfa/closure.scm 373 */
																						BgL_objectz00_bglt BgL_auxz00_4577;

																						BgL_auxz00_4577 =
																							((BgL_objectz00_bglt)
																							((BgL_svarz00_bglt)
																								(((BgL_variablez00_bglt) CREF(
																											((BgL_variablez00_bglt)
																												CAR(BgL_a1z00_2909))))->
																									BgL_valuez00)));
																						BgL_auxz00_4576 =
																							BGL_OBJECT_WIDENING
																							(BgL_auxz00_4577);
																					}
																					BgL_auxz00_4575 =
																						((BgL_svarzf2cinfozf2_bglt)
																						BgL_auxz00_4576);
																				}
																				BgL_p1z00_2914 =
																					(((BgL_svarzf2cinfozf2_bglt)
																						CREF(BgL_auxz00_4575))->
																					BgL_approxz00);
																			}
																			{	/* Cfa/closure.scm 373 */
																				BgL_typez00_bglt BgL_t0z00_2915;

																				BgL_t0z00_2915 =
																					(((BgL_approxz00_bglt)
																						CREF(BgL_p0z00_2913))->BgL_typez00);
																				{	/* Cfa/closure.scm 374 */
																					BgL_typez00_bglt BgL_t1z00_2916;

																					BgL_t1z00_2916 =
																						(((BgL_approxz00_bglt)
																							CREF(BgL_p1z00_2914))->
																						BgL_typez00);
																					{	/* Cfa/closure.scm 375 */

																						{	/* Cfa/closure.scm 376 */
																							bool_t BgL_testz00_4588;

																							if (
																								(((obj_t) BgL_t0z00_2915) ==
																									((obj_t) BgL_t1z00_2916)))
																								{	/* Cfa/closure.scm 376 */
																									BgL_testz00_4588 =
																										((bool_t) 1);
																								}
																							else
																								{	/* Cfa/closure.scm 376 */
																									if (BGl_bigloozd2typezf3z21zztype_typez00(BgL_t0z00_2915))
																										{	/* Cfa/closure.scm 376 */
																											BgL_testz00_4588 =
																												BGl_bigloozd2typezf3z21zztype_typez00
																												(BgL_t1z00_2916);
																										}
																									else
																										{	/* Cfa/closure.scm 376 */
																											BgL_testz00_4588 =
																												((bool_t) 0);
																										}
																								}
																							if (BgL_testz00_4588)
																								{
																									obj_t BgL_a1z00_4598;
																									obj_t BgL_a0z00_4596;

																									BgL_a0z00_4596 =
																										CDR(BgL_a0z00_2908);
																									BgL_a1z00_4598 =
																										CDR(BgL_a1z00_2909);
																									BgL_a1z00_2909 =
																										BgL_a1z00_4598;
																									BgL_a0z00_2908 =
																										BgL_a0z00_4596;
																									goto
																										BgL_zc3anonymousza31778ze3z83_2911;
																								}
																							else
																								{	/* Cfa/closure.scm 399 */
																									BgL_typez00_bglt
																										BgL_bt0z00_2920;
																									BgL_typez00_bglt
																										BgL_bt1z00_2921;
																									bool_t BgL_contz00_2922;

																									BgL_bt0z00_2920 =
																										BGl_getzd2bigloozd2typez00zztype_cachez00
																										(BgL_t0z00_2915);
																									BgL_bt1z00_2921 =
																										BGl_getzd2bigloozd2typez00zztype_cachez00
																										(BgL_t1z00_2916);
																									BgL_contz00_2922 =
																										((bool_t) 0);
																									if ((((obj_t) ((
																														(BgL_variablez00_bglt)
																														CREF((
																																(BgL_variablez00_bglt)
																																CAR
																																(BgL_a0z00_2908))))->
																													BgL_typez00)) ==
																											((obj_t)
																												BgL_bt0z00_2920)))
																										{	/* Cfa/closure.scm 402 */
																											BFALSE;
																										}
																									else
																										{	/* Cfa/closure.scm 402 */
																											{	/* Cfa/closure.scm 403 */
																												obj_t
																													BgL_arg1784z00_2924;
																												BgL_arg1784z00_2924 =
																													CAR(BgL_a0z00_2908);
																												((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt) BgL_arg1784z00_2924)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_bt0z00_2920), BUNSPEC);
																											}
																											BgL_contz00_2922 =
																												((bool_t) 1);
																										}
																									if (
																										(((obj_t)
																												(((BgL_variablez00_bglt)
																														CREF((
																																(BgL_variablez00_bglt)
																																CAR
																																(BgL_a1z00_2909))))->
																													BgL_typez00)) ==
																											((obj_t)
																												BgL_bt1z00_2921)))
																										{	/* Cfa/closure.scm 405 */
																											BFALSE;
																										}
																									else
																										{	/* Cfa/closure.scm 405 */
																											{	/* Cfa/closure.scm 406 */
																												obj_t
																													BgL_arg1789z00_2928;
																												BgL_arg1789z00_2928 =
																													CAR(BgL_a1z00_2909);
																												((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt) BgL_arg1789z00_2928)))->BgL_typez00) = ((BgL_typez00_bglt) BgL_bt1z00_2921), BUNSPEC);
																											}
																											BgL_contz00_2922 =
																												((bool_t) 1);
																										}
																									{	/* Cfa/closure.scm 410 */
																										obj_t BgL_arg1792z00_2931;
																										obj_t BgL_arg1793z00_2932;

																										BgL_arg1792z00_2931 =
																											CDR(BgL_a0z00_2908);
																										BgL_arg1793z00_2932 =
																											CDR(BgL_a1z00_2909);
																										{
																											bool_t BgL_contz00_4626;
																											obj_t BgL_a1z00_4625;
																											obj_t BgL_a0z00_4624;

																											BgL_a0z00_4624 =
																												BgL_arg1792z00_2931;
																											BgL_a1z00_4625 =
																												BgL_arg1793z00_2932;
																											BgL_contz00_4626 =
																												BgL_contz00_2922;
																											BgL_contz00_2910 =
																												BgL_contz00_4626;
																											BgL_a1z00_2909 =
																												BgL_a1z00_4625;
																											BgL_a0z00_2908 =
																												BgL_a0z00_4624;
																											goto
																												BgL_zc3anonymousza31778ze3z83_2911;
																										}
																									}
																								}
																						}
																					}
																				}
																			}
																		}
																	}
																else
																	{	/* Cfa/closure.scm 371 */
																		BgL__ortest_1171z00_2896 = BgL_contz00_2910;
																	}
															}
														}
													}
												}
											}
										}
									}
									if (BgL__ortest_1171z00_2896)
										{	/* Cfa/closure.scm 421 */
											BgL_arg1774z00_2895 = BgL__ortest_1171z00_2896;
										}
									else
										{	/* Cfa/closure.scm 421 */
											BgL_arg1774z00_2895 = BgL_contz00_2891;
										}
								}
								{
									bool_t BgL_contz00_4631;
									obj_t BgL_appsz00_4630;

									BgL_appsz00_4630 = BgL_arg1773z00_2894;
									BgL_contz00_4631 = BgL_arg1774z00_2895;
									BgL_contz00_2891 = BgL_contz00_4631;
									BgL_appsz00_2890 = BgL_appsz00_4630;
									goto BgL_zc3anonymousza31770ze3z83_2892;
								}
							}
					}
				}
			}
		}
	}



/* type-closures! */
	BGL_EXPORTED_DEF obj_t BGl_typezd2closuresz12zc0zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 426 */
			{
				BgL_appz00_bglt BgL_appz00_2959;

				if (CBOOL
					(BGl_za2optimzd2cfazd2unboxzd2closurezd2argsza2z00zzengine_paramz00))
					{	/* Cfa/closure.scm 441 */
						obj_t BgL_g1515z00_2951;

						BgL_g1515z00_2951 =
							BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
						{
							obj_t BgL_l1513z00_2953;

							{	/* Cfa/closure.scm 441 */
								bool_t BgL_auxz00_4634;

								BgL_l1513z00_2953 = BgL_g1515z00_2951;
							BgL_zc3anonymousza31809ze3z83_2954:
								if (PAIRP(BgL_l1513z00_2953))
									{	/* Cfa/closure.scm 441 */
										{	/* Cfa/closure.scm 441 */
											obj_t BgL_arg1811z00_2956;

											BgL_arg1811z00_2956 = CAR(BgL_l1513z00_2953);
											BgL_appz00_2959 = ((BgL_appz00_bglt) BgL_arg1811z00_2956);
											{	/* Cfa/closure.scm 430 */
												bool_t BgL_testz00_4638;

												{	/* Cfa/closure.scm 430 */
													bool_t BgL_testz00_4639;

													{
														BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4640;

														{
															obj_t BgL_auxz00_4641;

															{	/* Cfa/closure.scm 430 */
																BgL_objectz00_bglt BgL_auxz00_4642;

																BgL_auxz00_4642 =
																	((BgL_objectz00_bglt) BgL_appz00_2959);
																BgL_auxz00_4641 =
																	BGL_OBJECT_WIDENING(BgL_auxz00_4642);
															}
															BgL_auxz00_4640 =
																((BgL_makezd2procedurezd2appz00_bglt)
																BgL_auxz00_4641);
														}
														BgL_testz00_4639 =
															(((BgL_makezd2procedurezd2appz00_bglt)
																CREF(BgL_auxz00_4640))->BgL_xz00);
													}
													if (BgL_testz00_4639)
														{	/* Cfa/closure.scm 430 */
															BgL_testz00_4638 = ((bool_t) 1);
														}
													else
														{
															BgL_makezd2procedurezd2appz00_bglt
																BgL_auxz00_4647;
															{
																obj_t BgL_auxz00_4648;

																{	/* Cfa/closure.scm 430 */
																	BgL_objectz00_bglt BgL_auxz00_4649;

																	BgL_auxz00_4649 =
																		((BgL_objectz00_bglt) BgL_appz00_2959);
																	BgL_auxz00_4648 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_4649);
																}
																BgL_auxz00_4647 =
																	((BgL_makezd2procedurezd2appz00_bglt)
																	BgL_auxz00_4648);
															}
															BgL_testz00_4638 =
																(((BgL_makezd2procedurezd2appz00_bglt)
																	CREF(BgL_auxz00_4647))->BgL_tz00);
														}
												}
												if (BgL_testz00_4638)
													{	/* Cfa/closure.scm 430 */
														((bool_t) 0);
													}
												else
													{	/* Cfa/closure.scm 432 */
														BgL_variablez00_bglt BgL_varz00_2963;

														{
															BgL_varz00_bglt BgL_auxz00_4654;

															{	/* Cfa/closure.scm 432 */
																obj_t BgL_pairz00_3799;

																BgL_pairz00_3799 =
																	(((BgL_appz00_bglt) CREF(
																			((BgL_appz00_bglt) BgL_appz00_2959)))->
																	BgL_argsz00);
																BgL_auxz00_4654 =
																	((BgL_varz00_bglt) CAR(BgL_pairz00_3799));
															}
															BgL_varz00_2963 =
																(((BgL_varz00_bglt) CREF(BgL_auxz00_4654))->
																BgL_variablez00);
														}
														{	/* Cfa/closure.scm 432 */
															BgL_valuez00_bglt BgL_sfunz00_2964;

															BgL_sfunz00_2964 =
																(((BgL_variablez00_bglt)
																	CREF(BgL_varz00_2963))->BgL_valuez00);
															{	/* Cfa/closure.scm 433 */

																{	/* Cfa/closure.scm 434 */
																	obj_t BgL_g1512z00_2965;

																	{	/* Cfa/closure.scm 438 */
																		obj_t BgL_pairz00_3803;

																		BgL_pairz00_3803 =
																			(((BgL_sfunz00_bglt) CREF(
																					((BgL_sfunz00_bglt)
																						BgL_sfunz00_2964)))->BgL_argsz00);
																		BgL_g1512z00_2965 = CDR(BgL_pairz00_3803);
																	}
																	{
																		obj_t BgL_l1510z00_2967;

																		BgL_l1510z00_2967 = BgL_g1512z00_2965;
																	BgL_zc3anonymousza31815ze3z83_2968:
																		if (PAIRP(BgL_l1510z00_2967))
																			{	/* Cfa/closure.scm 438 */
																				{	/* Cfa/closure.scm 435 */
																					obj_t BgL_az00_2970;

																					BgL_az00_2970 =
																						CAR(BgL_l1510z00_2967);
																					{	/* Cfa/closure.scm 435 */
																						BgL_approxz00_bglt BgL_pz00_2971;

																						{
																							BgL_svarzf2cinfozf2_bglt
																								BgL_auxz00_4667;
																							{
																								obj_t BgL_auxz00_4668;

																								{	/* Cfa/closure.scm 435 */
																									BgL_objectz00_bglt
																										BgL_auxz00_4669;
																									BgL_auxz00_4669 =
																										((BgL_objectz00_bglt) (
																											(BgL_svarz00_bglt) ((
																													(BgL_variablez00_bglt)
																													CREF((
																															(BgL_variablez00_bglt)
																															BgL_az00_2970)))->
																												BgL_valuez00)));
																									BgL_auxz00_4668 =
																										BGL_OBJECT_WIDENING
																										(BgL_auxz00_4669);
																								}
																								BgL_auxz00_4667 =
																									((BgL_svarzf2cinfozf2_bglt)
																									BgL_auxz00_4668);
																							}
																							BgL_pz00_2971 =
																								(((BgL_svarzf2cinfozf2_bglt)
																									CREF(BgL_auxz00_4667))->
																								BgL_approxz00);
																						}
																						{	/* Cfa/closure.scm 435 */
																							BgL_typez00_bglt BgL_tz00_2972;

																							BgL_tz00_2972 =
																								(((BgL_approxz00_bglt)
																									CREF(BgL_pz00_2971))->
																								BgL_typez00);
																							{	/* Cfa/closure.scm 436 */

																								{	/* Cfa/closure.scm 437 */
																									BgL_typez00_bglt
																										BgL_arg1817z00_2973;
																									BgL_arg1817z00_2973 =
																										BGl_getzd2bigloozd2typez00zztype_cachez00
																										(BgL_tz00_2972);
																									((((BgL_variablez00_bglt)
																												CREF((
																														(BgL_variablez00_bglt)
																														BgL_az00_2970)))->
																											BgL_typez00) =
																										((BgL_typez00_bglt)
																											BgL_arg1817z00_2973),
																										BUNSPEC);
																								}
																							}
																						}
																					}
																				}
																				{
																					obj_t BgL_l1510z00_4681;

																					BgL_l1510z00_4681 =
																						CDR(BgL_l1510z00_2967);
																					BgL_l1510z00_2967 = BgL_l1510z00_4681;
																					goto
																						BgL_zc3anonymousza31815ze3z83_2968;
																				}
																			}
																		else
																			{	/* Cfa/closure.scm 438 */
																				((bool_t) 1);
																			}
																	}
																}
															}
														}
													}
											}
										}
										{
											obj_t BgL_l1513z00_4684;

											BgL_l1513z00_4684 = CDR(BgL_l1513z00_2953);
											BgL_l1513z00_2953 = BgL_l1513z00_4684;
											goto BgL_zc3anonymousza31809ze3z83_2954;
										}
									}
								else
									{	/* Cfa/closure.scm 441 */
										BgL_auxz00_4634 = ((bool_t) 1);
									}
								return BBOOL(BgL_auxz00_4634);
							}
						}
					}
				else
					{	/* Cfa/closure.scm 440 */
						return BFALSE;
					}
			}
		}
	}



/* &type-closures! */
	obj_t BGl_z62typezd2closuresz12za2zzcfa_closurez00(obj_t BgL_envz00_3887)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 426 */
			return BGl_typezd2closuresz12zc0zzcfa_closurez00();
		}
	}



/* light-access! */
	bool_t BGl_lightzd2accessz12zc0zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 446 */
			{
				obj_t BgL_l1516z00_2983;

				BgL_l1516z00_2983 = BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00;
			BgL_zc3anonymousza31824ze3z83_2984:
				if (PAIRP(BgL_l1516z00_2983))
					{	/* Cfa/closure.scm 447 */
						{	/* Cfa/closure.scm 449 */
							obj_t BgL_appz00_2986;

							BgL_appz00_2986 = CAR(BgL_l1516z00_2983);
							{	/* Cfa/closure.scm 449 */
								BgL_approxz00_bglt BgL_approxz00_2988;

								{	/* Cfa/closure.scm 450 */
									obj_t BgL_arg1835z00_3003;

									{	/* Cfa/closure.scm 450 */
										obj_t BgL_pairz00_3823;

										BgL_pairz00_3823 =
											(((BgL_appz00_bglt) CREF(
													((BgL_appz00_bglt) BgL_appz00_2986)))->BgL_argsz00);
										BgL_arg1835z00_3003 = CAR(BgL_pairz00_3823);
									}
									BgL_approxz00_2988 =
										BGl_cfaz12z12zzcfa_cfaz00(
										((BgL_nodez00_bglt) BgL_arg1835z00_3003));
								}
								{	/* Cfa/closure.scm 450 */
									obj_t BgL_alloczd2listzd2_2989;

									BgL_alloczd2listzd2_2989 =
										BGl_setzd2ze3listz31zzcfa_setz00(
										(((BgL_approxz00_bglt) CREF(BgL_approxz00_2988))->
											BgL_allocsz00));
									{	/* Cfa/closure.scm 451 */
										BgL_varz00_bglt BgL_funz00_2990;

										BgL_funz00_2990 =
											(((BgL_appz00_bglt) CREF(
													((BgL_appz00_bglt) BgL_appz00_2986)))->BgL_funz00);
										{	/* Cfa/closure.scm 452 */
											BgL_variablez00_bglt BgL_vfunz00_2991;

											BgL_vfunz00_2991 =
												(((BgL_varz00_bglt) CREF(BgL_funz00_2990))->
												BgL_variablez00);
											{	/* Cfa/closure.scm 453 */

												{	/* Cfa/closure.scm 454 */
													bool_t BgL_testz00_4701;

													if (PAIRP(BgL_alloczd2listzd2_2989))
														{	/* Cfa/closure.scm 455 */
															bool_t BgL_testz00_4704;

															{	/* Cfa/closure.scm 455 */
																obj_t BgL_arg1833z00_3001;

																BgL_arg1833z00_3001 =
																	CAR(BgL_alloczd2listzd2_2989);
																BgL_testz00_4704 =
																	BGl_isazf3zf3zz__objectz00
																	(BgL_arg1833z00_3001,
																	BGl_makezd2procedurezd2appz00zzcfa_info2z00);
															}
															if (BgL_testz00_4704)
																{	/* Cfa/closure.scm 455 */
																	BgL_testz00_4701 = ((bool_t) 0);
																}
															else
																{	/* Cfa/closure.scm 455 */
																	BgL_testz00_4701 = ((bool_t) 1);
																}
														}
													else
														{	/* Cfa/closure.scm 454 */
															BgL_testz00_4701 = ((bool_t) 1);
														}
													if (BgL_testz00_4701)
														{	/* Cfa/closure.scm 454 */
															CNST_TABLE_REF(((long) 8));
														}
													else
														{	/* Cfa/closure.scm 457 */
															BgL_appz00_bglt BgL_allocz00_2993;

															BgL_allocz00_2993 =
																((BgL_appz00_bglt)
																CAR(BgL_alloczd2listzd2_2989));
															{	/* Cfa/closure.scm 460 */
																bool_t BgL_testz00_4710;

																{
																	BgL_makezd2procedurezd2appz00_bglt
																		BgL_auxz00_4711;
																	{
																		obj_t BgL_auxz00_4712;

																		{	/* Cfa/closure.scm 460 */
																			BgL_objectz00_bglt BgL_auxz00_4713;

																			BgL_auxz00_4713 =
																				((BgL_objectz00_bglt)
																				((BgL_appz00_bglt) BgL_allocz00_2993));
																			BgL_auxz00_4712 =
																				BGL_OBJECT_WIDENING(BgL_auxz00_4713);
																		}
																		BgL_auxz00_4711 =
																			((BgL_makezd2procedurezd2appz00_bglt)
																			BgL_auxz00_4712);
																	}
																	BgL_testz00_4710 =
																		(((BgL_makezd2procedurezd2appz00_bglt)
																			CREF(BgL_auxz00_4711))->BgL_xz00);
																}
																if (BgL_testz00_4710)
																	{	/* Cfa/closure.scm 460 */
																		if (
																			(((obj_t) BgL_vfunz00_2991) ==
																				BGl_za2procedurezd2refza2zd2zzcfa_closurez00))
																			{	/* Cfa/closure.scm 462 */
																				BgL_variablez00_bglt BgL_vz00_3834;

																				BgL_vz00_3834 =
																					((BgL_variablez00_bglt)
																					BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							CREF(BgL_funz00_2990))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_3834), BUNSPEC);
																			}
																		else
																			{	/* Cfa/closure.scm 463 */
																				BgL_variablez00_bglt BgL_vz00_3836;

																				BgL_vz00_3836 =
																					((BgL_variablez00_bglt)
																					BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00);
																				((((BgL_varz00_bglt)
																							CREF(BgL_funz00_2990))->
																						BgL_variablez00) =
																					((BgL_variablez00_bglt)
																						BgL_vz00_3836), BUNSPEC);
																			}
																	}
																else
																	{	/* Cfa/closure.scm 464 */
																		bool_t BgL_testz00_4726;

																		{
																			BgL_makezd2procedurezd2appz00_bglt
																				BgL_auxz00_4727;
																			{
																				obj_t BgL_auxz00_4728;

																				{	/* Cfa/closure.scm 464 */
																					BgL_objectz00_bglt BgL_auxz00_4729;

																					BgL_auxz00_4729 =
																						((BgL_objectz00_bglt)
																						((BgL_appz00_bglt)
																							BgL_allocz00_2993));
																					BgL_auxz00_4728 =
																						BGL_OBJECT_WIDENING
																						(BgL_auxz00_4729);
																				}
																				BgL_auxz00_4727 =
																					((BgL_makezd2procedurezd2appz00_bglt)
																					BgL_auxz00_4728);
																			}
																			BgL_testz00_4726 =
																				(((BgL_makezd2procedurezd2appz00_bglt)
																					CREF(BgL_auxz00_4727))->BgL_tz00);
																		}
																		if (BgL_testz00_4726)
																			{	/* Cfa/closure.scm 464 */
																				if (
																					(((obj_t) BgL_vfunz00_2991) ==
																						BGl_za2procedurezd2refza2zd2zzcfa_closurez00))
																					{	/* Cfa/closure.scm 466 */
																						BgL_variablez00_bglt BgL_vz00_3838;

																						BgL_vz00_3838 =
																							((BgL_variablez00_bglt)
																							BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00);
																						((((BgL_varz00_bglt)
																									CREF(BgL_funz00_2990))->
																								BgL_variablez00) =
																							((BgL_variablez00_bglt)
																								BgL_vz00_3838), BUNSPEC);
																					}
																				else
																					{	/* Cfa/closure.scm 467 */
																						BgL_variablez00_bglt BgL_vz00_3840;

																						BgL_vz00_3840 =
																							((BgL_variablez00_bglt)
																							BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00);
																						((((BgL_varz00_bglt)
																									CREF(BgL_funz00_2990))->
																								BgL_variablez00) =
																							((BgL_variablez00_bglt)
																								BgL_vz00_3840), BUNSPEC);
																					}
																			}
																		else
																			{	/* Cfa/closure.scm 464 */
																				BFALSE;
																			}
																	}
															}
														}
												}
											}
										}
									}
								}
							}
						}
						{
							obj_t BgL_l1516z00_4742;

							BgL_l1516z00_4742 = CDR(BgL_l1516z00_2983);
							BgL_l1516z00_2983 = BgL_l1516z00_4742;
							goto BgL_zc3anonymousza31824ze3z83_2984;
						}
					}
				else
					{	/* Cfa/closure.scm 447 */
						return ((bool_t) 1);
					}
			}
		}
	}



/* show-X-T */
	obj_t BGl_showzd2Xzd2Tz00zzcfa_closurez00(obj_t BgL_allocsz00_9)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 473 */
			{
				obj_t BgL_xpz00_3011;
				obj_t BgL_tpz00_3012;
				obj_t BgL_allocsz00_3013;

				BgL_xpz00_3011 = BNIL;
				BgL_tpz00_3012 = BNIL;
				BgL_allocsz00_3013 = BgL_allocsz00_9;
			BgL_zc3anonymousza31838ze3z83_3014:
				if (NULLP(BgL_allocsz00_3013))
					{	/* Cfa/closure.scm 484 */
						BGl_showz00zzcfa_closurez00(CNST_TABLE_REF(((long) 9)),
							BgL_xpz00_3011);
						BGl_showz00zzcfa_closurez00(CNST_TABLE_REF(((long) 10)),
							BgL_tpz00_3012);
						return BUNSPEC;
					}
				else
					{	/* Cfa/closure.scm 489 */
						BgL_appz00_bglt BgL_i1176z00_3016;

						BgL_i1176z00_3016 = ((BgL_appz00_bglt) CAR(BgL_allocsz00_3013));
						{	/* Cfa/closure.scm 491 */
							bool_t BgL_testz00_4752;

							{
								BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4753;

								{
									obj_t BgL_auxz00_4754;

									{	/* Cfa/closure.scm 491 */
										BgL_objectz00_bglt BgL_auxz00_4755;

										BgL_auxz00_4755 = ((BgL_objectz00_bglt) BgL_i1176z00_3016);
										BgL_auxz00_4754 = BGL_OBJECT_WIDENING(BgL_auxz00_4755);
									}
									BgL_auxz00_4753 =
										((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4754);
								}
								BgL_testz00_4752 =
									(((BgL_makezd2procedurezd2appz00_bglt)
										CREF(BgL_auxz00_4753))->BgL_xz00);
							}
							if (BgL_testz00_4752)
								{	/* Cfa/closure.scm 492 */
									obj_t BgL_arg1841z00_3018;
									obj_t BgL_arg1842z00_3019;

									{	/* Cfa/closure.scm 492 */
										BgL_variablez00_bglt BgL_arg1843z00_3020;

										{
											BgL_varz00_bglt BgL_auxz00_4760;

											{	/* Cfa/closure.scm 492 */
												obj_t BgL_pairz00_3853;

												BgL_pairz00_3853 =
													(((BgL_appz00_bglt) CREF(
															((BgL_appz00_bglt) BgL_i1176z00_3016)))->
													BgL_argsz00);
												BgL_auxz00_4760 =
													((BgL_varz00_bglt) CAR(BgL_pairz00_3853));
											}
											BgL_arg1843z00_3020 =
												(((BgL_varz00_bglt) CREF(BgL_auxz00_4760))->
												BgL_variablez00);
										}
										BgL_arg1841z00_3018 =
											MAKE_PAIR(((obj_t) BgL_arg1843z00_3020), BgL_xpz00_3011);
									}
									BgL_arg1842z00_3019 = CDR(BgL_allocsz00_3013);
									{
										obj_t BgL_allocsz00_4770;
										obj_t BgL_xpz00_4769;

										BgL_xpz00_4769 = BgL_arg1841z00_3018;
										BgL_allocsz00_4770 = BgL_arg1842z00_3019;
										BgL_allocsz00_3013 = BgL_allocsz00_4770;
										BgL_xpz00_3011 = BgL_xpz00_4769;
										goto BgL_zc3anonymousza31838ze3z83_3014;
									}
								}
							else
								{	/* Cfa/closure.scm 493 */
									bool_t BgL_testz00_4771;

									{
										BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4772;

										{
											obj_t BgL_auxz00_4773;

											{	/* Cfa/closure.scm 493 */
												BgL_objectz00_bglt BgL_auxz00_4774;

												BgL_auxz00_4774 =
													((BgL_objectz00_bglt) BgL_i1176z00_3016);
												BgL_auxz00_4773 = BGL_OBJECT_WIDENING(BgL_auxz00_4774);
											}
											BgL_auxz00_4772 =
												((BgL_makezd2procedurezd2appz00_bglt) BgL_auxz00_4773);
										}
										BgL_testz00_4771 =
											(((BgL_makezd2procedurezd2appz00_bglt)
												CREF(BgL_auxz00_4772))->BgL_tz00);
									}
									if (BgL_testz00_4771)
										{	/* Cfa/closure.scm 494 */
											obj_t BgL_arg1848z00_3024;
											obj_t BgL_arg1849z00_3025;

											{	/* Cfa/closure.scm 494 */
												BgL_variablez00_bglt BgL_arg1850z00_3026;

												{
													BgL_varz00_bglt BgL_auxz00_4779;

													{	/* Cfa/closure.scm 494 */
														obj_t BgL_pairz00_3856;

														BgL_pairz00_3856 =
															(((BgL_appz00_bglt) CREF(
																	((BgL_appz00_bglt) BgL_i1176z00_3016)))->
															BgL_argsz00);
														BgL_auxz00_4779 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_3856));
													}
													BgL_arg1850z00_3026 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_4779))->
														BgL_variablez00);
												}
												BgL_arg1848z00_3024 =
													MAKE_PAIR(
													((obj_t) BgL_arg1850z00_3026), BgL_tpz00_3012);
											}
											BgL_arg1849z00_3025 = CDR(BgL_allocsz00_3013);
											{
												obj_t BgL_allocsz00_4789;
												obj_t BgL_tpz00_4788;

												BgL_tpz00_4788 = BgL_arg1848z00_3024;
												BgL_allocsz00_4789 = BgL_arg1849z00_3025;
												BgL_allocsz00_3013 = BgL_allocsz00_4789;
												BgL_tpz00_3012 = BgL_tpz00_4788;
												goto BgL_zc3anonymousza31838ze3z83_3014;
											}
										}
									else
										{
											obj_t BgL_allocsz00_4790;

											BgL_allocsz00_4790 = CDR(BgL_allocsz00_3013);
											BgL_allocsz00_3013 = BgL_allocsz00_4790;
											goto BgL_zc3anonymousza31838ze3z83_3014;
										}
								}
						}
					}
			}
		}
	}



/* show */
	bool_t BGl_showz00zzcfa_closurez00(obj_t BgL_propz00_3031,
		obj_t BgL_lz00_3032)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 480 */
			if (NULLP(BgL_lz00_3032))
				{	/* Cfa/closure.scm 475 */
					return ((bool_t) 0);
				}
			else
				{	/* Cfa/closure.scm 475 */
					{	/* Cfa/closure.scm 477 */
						obj_t BgL_arg1857z00_3035;

						BgL_arg1857z00_3035 =
							BGl_shapez00zztools_shapez00(CAR(BgL_lz00_3032));
						{	/* Cfa/closure.scm 477 */
							obj_t BgL_list1858z00_3036;

							{	/* Cfa/closure.scm 477 */
								obj_t BgL_arg1859z00_3037;

								{	/* Cfa/closure.scm 477 */
									obj_t BgL_arg1860z00_3038;

									{	/* Cfa/closure.scm 477 */
										obj_t BgL_arg1861z00_3039;

										{	/* Cfa/closure.scm 477 */
											obj_t BgL_arg1862z00_3040;

											BgL_arg1862z00_3040 =
												MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
											BgL_arg1861z00_3039 =
												MAKE_PAIR(BgL_arg1857z00_3035, BgL_arg1862z00_3040);
										}
										BgL_arg1860z00_3038 =
											MAKE_PAIR(BGl_string2113z00zzcfa_closurez00,
											BgL_arg1861z00_3039);
									}
									BgL_arg1859z00_3037 =
										MAKE_PAIR(BgL_propz00_3031, BgL_arg1860z00_3038);
								}
								BgL_list1858z00_3036 =
									MAKE_PAIR(BGl_string2114z00zzcfa_closurez00,
									BgL_arg1859z00_3037);
							}
							BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
								BgL_list1858z00_3036);
					}}
					{	/* Cfa/closure.scm 478 */
						obj_t BgL_g1520z00_3042;

						BgL_g1520z00_3042 = CDR(BgL_lz00_3032);
						{
							obj_t BgL_l1518z00_3044;

							BgL_l1518z00_3044 = BgL_g1520z00_3042;
						BgL_zc3anonymousza31864ze3z83_3045:
							if (PAIRP(BgL_l1518z00_3044))
								{	/* Cfa/closure.scm 480 */
									{	/* Cfa/closure.scm 479 */
										obj_t BgL_xz00_3047;

										BgL_xz00_3047 = CAR(BgL_l1518z00_3044);
										{	/* Cfa/closure.scm 479 */
											obj_t BgL_arg1866z00_3048;

											BgL_arg1866z00_3048 =
												BGl_shapez00zztools_shapez00(BgL_xz00_3047);
											{	/* Cfa/closure.scm 479 */
												obj_t BgL_list1867z00_3049;

												{	/* Cfa/closure.scm 479 */
													obj_t BgL_arg1868z00_3050;

													{	/* Cfa/closure.scm 479 */
														obj_t BgL_arg1869z00_3051;

														BgL_arg1869z00_3051 =
															MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
														BgL_arg1868z00_3050 =
															MAKE_PAIR(BgL_arg1866z00_3048,
															BgL_arg1869z00_3051);
													}
													BgL_list1867z00_3049 =
														MAKE_PAIR(BGl_string2115z00zzcfa_closurez00,
														BgL_arg1868z00_3050);
												}
												BGl_verbosez00zztools_speekz00(BINT(((long) 2)),
													BgL_list1867z00_3049);
									}}}
									{
										obj_t BgL_l1518z00_4815;

										BgL_l1518z00_4815 = CDR(BgL_l1518z00_3044);
										BgL_l1518z00_3044 = BgL_l1518z00_4815;
										goto BgL_zc3anonymousza31864ze3z83_3045;
									}
								}
							else
								{	/* Cfa/closure.scm 480 */
									return ((bool_t) 1);
								}
						}
					}
				}
		}
	}



/* get-procedure-list */
	BGL_EXPORTED_DEF obj_t BGl_getzd2procedurezd2listz00zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 508 */
			return BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
		}
	}



/* &get-procedure-list */
	obj_t BGl_z62getzd2procedurezd2listz62zzcfa_closurez00(obj_t BgL_envz00_3888)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 508 */
			return BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00;
		}
	}



/* add-funcall! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2funcallz12zc0zzcfa_closurez00(BgL_nodez00_bglt BgL_astz00_10)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 514 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 515 */
					return (BGl_za2funcallzd2listza2zd2zzcfa_closurez00 =
						MAKE_PAIR(
							((obj_t) BgL_astz00_10),
							BGl_za2funcallzd2listza2zd2zzcfa_closurez00), BUNSPEC);
				}
			else
				{	/* Cfa/closure.scm 515 */
					return BFALSE;
				}
		}
	}



/* &add-funcall! */
	obj_t BGl_z62addzd2funcallz12za2zzcfa_closurez00(obj_t BgL_envz00_3889,
		obj_t BgL_astz00_3890)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 514 */
			return
				BGl_addzd2funcallz12zc0zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_3890));
		}
	}



/* add-make-procedure! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(BgL_nodez00_bglt
		BgL_astz00_11)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 521 */
			return (BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00 =
				MAKE_PAIR(
					((obj_t) BgL_astz00_11),
					BGl_za2makezd2procedurezd2listza2z00zzcfa_closurez00), BUNSPEC);
		}
	}



/* &add-make-procedure! */
	obj_t BGl_z62addzd2makezd2procedurez12z70zzcfa_closurez00(obj_t
		BgL_envz00_3891, obj_t BgL_astz00_3892)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 521 */
			return
				BGl_addzd2makezd2procedurez12z12zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_3892));
		}
	}



/* add-procedure-ref! */
	BGL_EXPORTED_DEF obj_t
		BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(BgL_nodez00_bglt
		BgL_astz00_12)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 527 */
			if (((long) CINT(BGl_za2optimza2z00zzengine_paramz00) >= ((long) 2)))
				{	/* Cfa/closure.scm 528 */
					return (BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00 =
						MAKE_PAIR(
							((obj_t) BgL_astz00_12),
							BGl_za2procedurezd2refzd2listza2z00zzcfa_closurez00), BUNSPEC);
				}
			else
				{	/* Cfa/closure.scm 528 */
					return BFALSE;
				}
		}
	}



/* &add-procedure-ref! */
	obj_t BGl_z62addzd2procedurezd2refz12z70zzcfa_closurez00(obj_t
		BgL_envz00_3893, obj_t BgL_astz00_3894)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 527 */
			return
				BGl_addzd2procedurezd2refz12z12zzcfa_closurez00(
				((BgL_nodez00_bglt) BgL_astz00_3894));
		}
	}



/* approx-procedure-el? */
	BGL_EXPORTED_DEF bool_t
		BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(BgL_approxz00_bglt
		BgL_approxz00_13)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 534 */
			{	/* Cfa/closure.scm 535 */
				BgL_typez00_bglt BgL_typez00_3057;
				obj_t BgL_alloczd2listzd2_3058;

				BgL_typez00_3057 =
					(((BgL_approxz00_bglt) CREF(BgL_approxz00_13))->BgL_typez00);
				BgL_alloczd2listzd2_3058 =
					BGl_setzd2ze3listz31zzcfa_setz00(
					(((BgL_approxz00_bglt) CREF(BgL_approxz00_13))->BgL_allocsz00));
				if (
					(((obj_t) BgL_typez00_3057) == BGl_za2procedureza2z00zztype_cachez00))
					{	/* Cfa/closure.scm 537 */
						if (PAIRP(BgL_alloczd2listzd2_3058))
							{	/* Cfa/closure.scm 538 */
								if (NULLP(CDR(BgL_alloczd2listzd2_3058)))
									{	/* Cfa/closure.scm 540 */
										bool_t BgL_testz00_4846;

										{	/* Cfa/closure.scm 540 */
											obj_t BgL_arg1874z00_3064;

											BgL_arg1874z00_3064 = CAR(BgL_alloczd2listzd2_3058);
											BgL_testz00_4846 =
												BGl_isazf3zf3zz__objectz00(BgL_arg1874z00_3064,
												BGl_makezd2procedurezd2appz00zzcfa_info2z00);
										}
										if (BgL_testz00_4846)
											{
												BgL_makezd2procedurezd2appz00_bglt BgL_auxz00_4849;

												{
													obj_t BgL_auxz00_4850;

													{	/* Cfa/closure.scm 541 */
														BgL_objectz00_bglt BgL_auxz00_4851;

														BgL_auxz00_4851 =
															((BgL_objectz00_bglt)
															((BgL_appz00_bglt)
																CAR(BgL_alloczd2listzd2_3058)));
														BgL_auxz00_4850 =
															BGL_OBJECT_WIDENING(BgL_auxz00_4851);
													}
													BgL_auxz00_4849 =
														((BgL_makezd2procedurezd2appz00_bglt)
														BgL_auxz00_4850);
												}
												return
													(((BgL_makezd2procedurezd2appz00_bglt)
														CREF(BgL_auxz00_4849))->BgL_xz00);
											}
										else
											{	/* Cfa/closure.scm 540 */
												return ((bool_t) 0);
											}
									}
								else
									{	/* Cfa/closure.scm 539 */
										return ((bool_t) 0);
									}
							}
						else
							{	/* Cfa/closure.scm 538 */
								return ((bool_t) 0);
							}
					}
				else
					{	/* Cfa/closure.scm 537 */
						return ((bool_t) 0);
					}
			}
		}
	}



/* &approx-procedure-el? */
	obj_t BGl_z62approxzd2procedurezd2elzf3z91zzcfa_closurez00(obj_t
		BgL_envz00_3895, obj_t BgL_approxz00_3896)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 534 */
			return
				BBOOL(BGl_approxzd2procedurezd2elzf3zf3zzcfa_closurez00(
					((BgL_approxz00_bglt) BgL_approxz00_3896)));
		}
	}



/* start-closure-cache */
	obj_t BGl_startzd2closurezd2cachez00zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 558 */
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 11)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 13)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 14)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 15)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 16)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 17)),
				CNST_TABLE_REF(((long) 12)));
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 18)),
				CNST_TABLE_REF(((long) 12)));
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BGl_getzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 19)),
					CNST_TABLE_REF(((long) 12))), BUNSPEC);
		}
	}



/* stop-closure-cache */
	BGL_EXPORTED_DEF obj_t BGl_stopzd2closurezd2cachez00zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 571 */
			BGl_za2procedurezd2refza2zd2zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2setz12za2zc0zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2lzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2refza2z00zzcfa_closurez00 = BFALSE;
			BGl_za2procedurezd2elzd2setz12za2z12zzcfa_closurez00 = BFALSE;
			BGl_za2makezd2elzd2procedureza2z00zzcfa_closurez00 = BFALSE;
			return (BGl_za2makezd2lzd2procedureza2z00zzcfa_closurez00 =
				BFALSE, BUNSPEC);
		}
	}



/* &stop-closure-cache */
	obj_t BGl_z62stopzd2closurezd2cachez62zzcfa_closurez00(obj_t BgL_envz00_3897)
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 571 */
			return BGl_stopzd2closurezd2cachez00zzcfa_closurez00();
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 25 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzcfa_closurez00()
	{
		AN_OBJECT;
		{	/* Cfa/closure.scm 25 */
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 122361728),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 216926614),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_infoz00(((long) 125571606),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_info2z00(((long) 0),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_cfaz00(((long) 400853817),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_approxz00(((long) 468997863),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_setz00(((long) 21528182),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			BGl_modulezd2initializa7ationz75zzcfa_ltypez00(((long) 315872512),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
			return
				BGl_modulezd2initializa7ationz75zzcfa_typez00(((long) 93933605),
				BSTRING_TO_STRING(BGl_string2116z00zzcfa_closurez00));
		}
	}

#ifdef __cplusplus
}
#endif
