/*===========================================================================*/
/*   (Ast/walk.scm)                                                          */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Ast/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;


	static obj_t BGl_z62walk2zd2jumpzd2exzd2it1895zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2appzd2ly1697z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2conditional1828z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32108ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk3za2zd2setzd2exzd2it1881z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2setq1810za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33313ze3z83zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_z62walk2zd2cast1773zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2boxzd2setz121974zd2zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2conditional1839za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2node1624zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32423ze3z83zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32142ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62zc3anonymousza32126ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk0za2zd2funcall1729z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2conditional1818zb0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2sequence1652zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk21597z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t BGl_z62walk2zd2fail1847zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2letzd2var2075zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32262ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32246ze3z83zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2sync2003z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32190ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2sequence1658z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2setzd2exzd2it1885za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza33065ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk1z12zd2extern1763za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33333ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2setq1798zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33228ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32175ze3z83zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2jumpzd2exzd2it1913za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2boxzd2ref1939z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_z62walk3za2zd2node1638z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_objectzd2initzd2zzast_walkz00();
	BGL_IMPORT obj_t BGl_appendz00zz__r4_pairs_and_lists_6_3z00(obj_t);
	static obj_t BGl_z62walk0za21603zc0zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2boxzd2ref1962z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk31599z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2extern1755z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2app1675zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32147ze3ze1zzast_walkz00(obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk2z12zd2appzd2ly1717z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2setzd2exzd2it1869zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33174ze3z83zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2node1632z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32091ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk1za2zd2sync1998z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3zd2makezd2box1921z62zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2makezd2box1933z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2letzd2fun2037z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2sync2009za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2select2035za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2fun2059z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32446ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2cast1781z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2appzd2ly1709zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2boxzd2ref1947zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza32374ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32358ze3z83zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2cast1775zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_appendzd221011zd2zzast_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2var2081z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzast_walkz00();
	static obj_t BGl_z62walk1zd2funcall1723zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2node1626zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zd2select2027z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2fail1855z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62walk1za2zd2jumpzd2exzd2it1901z12zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2extern1747zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za21605zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2fail1849zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2node1644za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2select2013zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2letzd2fun2045zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3zd2boxzd2setz121970z70zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2boxzd2setz121982z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32096ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk3zd2select2019zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2cast1787za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2makezd2box1923zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2app1677zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_errorz00zz__errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2setq1808z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2sequence1654zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2sequence1667za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2funcall1731z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2setzd2exzd2it1879z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t bgl_append2(obj_t, obj_t);
	static obj_t BGl_z62walk1zd2jumpzd2exzd2it1893zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2extern1765za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za21607zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2fail1861za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2setq1802z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2conditional1830z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2boxzd2ref1941z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2extern1757z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2app1689za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2conditional1820zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2boxzd2setz121972zd2zzast_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2conditional1841za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2appzd2ly1719z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2node1628zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2jumpzd2exzd2it1907za2zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2letzd2fun2039z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2setq1814za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2setzd2exzd2it1883za2zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za21609zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2sequence1656z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk4z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2appzd2ly1711zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2boxzd2ref1949zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2zd2funcall1725zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2funcall1737za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3zd2app1679zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2letzd2var2061z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2var2083z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2sync1988zb0zzast_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_writezd2circlezd2zz__pp_circlez00(obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2makezd2box1929zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2appzd2ly1703z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2sync2001z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2letzd2fun2047zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2setzd2exzd2it1867zb0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2makezd2box1931z70zzast_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2letzd2var2069zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0za2zd2app1681z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2jumpzd2exzd2it1903z12zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk4za21611zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32112ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk2za2zd2node1636z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk3z12zd2extern1767za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2app1691za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2funcall1733z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2boxzd2setz121978zd2zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_selectz00zzast_nodez00;
	static obj_t BGl_z62walk3zd2node1630zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32130ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk0za2zd2sync1996z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2boxzd2ref1943z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2sync2007za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2boxzd2ref1956z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2cast1779z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2boxzd2setz121980z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2extern1759z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk0z12zd2conditional1834za2zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2makezd2box1915z62zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0zd2extern1745zb0zzast_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk0z12z70zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2sequence1662z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2fail1853z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32117ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk0za2zc0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zzast_walkz00 = BUNSPEC;
	static obj_t BGl_z62walk1za2zd2setzd2exzd2it1877z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2jumpzd2exzd2it1891zb0zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2letzd2fun2041z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2fun2053z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2sequence1665za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2sync1990zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza32431ze3z83zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2node1642za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza33055ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32134ze3ze1zzast_walkz00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2setzd2exzd2it1889za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2extern1751zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2select2017zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62walk3za2zd2conditional1832z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2jumpzd2exzd2it1899z12zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33323ze3z83zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32254ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza33218ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3zd2funcall1727zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32238ze3z83zzast_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk41601z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0z121613z70zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2cast1791za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2conditional1822zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2letzd2var2063z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2select2029za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32182ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zzast_walkz00();
	static BgL_nodez00_bglt BGl_z62walk1z12zd2funcall1739za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32152ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk1za2zd2app1683z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2cast1785za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2jumpzd2exzd2it1909za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2makezd2box1937z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2boxzd2ref1952zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2fail1865za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2setzd2exzd2it1873zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2boxzd2setz121964z70zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2setq1806z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk4z12z70zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32167ze3z83zzast_walkz00(obj_t, obj_t);
	static obj_t BGl_z62walk4za2zc0zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzast_walkz00();
	static BgL_nodez00_bglt BGl_z62walk0z12zd2fail1859za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2app1693za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32138ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk3zd2setq1800zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2select2021z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2letzd2fun2049zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33343ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_castz00zzast_nodez00;
	static obj_t BGl_z62walk0zd2sequence1648zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1z121615z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2letzd2var2071zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32349ze3z83zzast_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk3z12zd2boxzd2setz121986z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza32366ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza32439ze3z83zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3za2zd2funcall1735z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2boxzd2ref1945z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2setq1812za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2appzd2ly1699z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2za2zd2makezd2box1927zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2sync1992zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2jumpzd2exzd2it1905z12zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2boxzd2ref1958z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33186ze3z83zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2sequence1671za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2app1685z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2z121617z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2makezd2box1917z62zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk3zd2letzd2fun2043z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2appzd2ly1701z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0zd2cast1769zb0zzast_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2fun2055z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2jumpzd2exzd2it1897zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2conditional1826z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2app1695za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2appzd2ly1713z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2boxzd2setz121976zd2zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2letzd2var2065z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2var2077z70zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk1z12zd2conditional1836za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2select2031za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2fail1843zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2appzd2ly1705zc0zzast_walkz00(obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk0z00zzast_walkz00(BgL_nodez00_bglt, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk1z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk2z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk3z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_walk4z00zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2boxzd2ref1954zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2funcall1741za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2boxzd2setz121966z70zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2node1634z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk0za2zd2setzd2exzd2it1875z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk3z121619z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zzast_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__pp_circlez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62walk0zd2setq1793zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2sequence1660z12zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2select2023z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2setzd2exzd2it1887za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2sync2011za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2conditional1824zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2cast1783z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2sync1994zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2sync2005za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2cast1777z12zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3za2zd2letzd2fun2051zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	static obj_t BGl_z62walk3za2zd2fail1857z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2jumpzd2exzd2it1911za2zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1zd2sequence1650zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzast_walkz00();
	static obj_t BGl_z62walk2za2zd2letzd2var2073zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_importedzd2moduleszd2initz00zzast_walkz00();
	static BgL_nodez00_bglt BGl_z62walk3z12zd2node1646za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t
		BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00(obj_t);
	static obj_t BGl_z62walk3za2zd2app1687z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2makezd2box1935z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk2zd2extern1749zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk0z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t);
	static obj_t BGl_z62walk2zd2setzd2exzd2it1871zb0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2fail1851z12zzast_walkz00(obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk0za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t);
	static obj_t BGl_z62walk1zd2select2015zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk1z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33021ze3z83zzast_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2node1640za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62zc3anonymousza32100ze3ze1zzast_walkz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk1za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t);
	static obj_t BGl_z62walk1zd2cast1771zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk4z121621z70zzast_walkz00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk0z12zd2extern1761za2zzast_walkz00(obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2cast1789za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk2z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk2za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2boxzd2ref1960z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	static obj_t BGl_z62walk1zd2fail1845zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk3z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk3za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk01593z62zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2makezd2box1919z62zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0za2zd2extern1753z12zzast_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2fail1863za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL BgL_nodez00_bglt
		BGl_walk4z12z12zzast_walkz00(BgL_nodez00_bglt, obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62walk1za2zd2setq1804z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	BGL_EXPORTED_DECL obj_t BGl_walk4za2za2zzast_walkz00(BgL_nodez00_bglt, obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62walk2z12zd2boxzd2setz121984z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2appzd2ly1715z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2fun2057z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk3zd2letzd2var2067z62zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_zc3anonymousza33041ze3z83zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1zd2setq1795zb0zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62zc3anonymousza32104ze3ze1zzast_walkz00(obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2select2033za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2var2079z70zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2makezd2box1925zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62walk1za2zd2appzd2ly1707zc0zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk2z12zd2sequence1669za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_z62zc3anonymousza32122ze3ze1zzast_walkz00(obj_t);
	static obj_t BGl_z62walk11595z62zzast_walkz00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2funcall1721zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2setq1816za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk0zd2app1673zb0zzast_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2za2zd2select2025z12zzast_walkz00(obj_t, obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt BGl_z62walk3z12zd2funcall1743za2zzast_walkz00(obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62walk2zd2boxzd2setz121968z70zzast_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_EXPORT_BGL_GENERIC(BGl_walk2za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7c0za7za73940za7, BGl_z62walk2za2zc0zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk3za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7c0za7za73941za7, BGl_z62walk3za2zc0zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk0zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk0za762za7za7ast3942z00, BGl_z62walk0z62zzast_walkz00, 0L,
		BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk4za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk4za7a2za7c0za7za73943za7, BGl_z62walk4za2zc0zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3707z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2node13944z00,
		BGl_z62walk0zd2node1624zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3708z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2node13945z00,
		BGl_z62walk1zd2node1626zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3709z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2node13946z00,
		BGl_z62walk2zd2node1628zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3710z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2node13947z00,
		BGl_z62walk3zd2node1630zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3711z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2no3948za7,
		BGl_z62walk0za2zd2node1632z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3712z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2no3949za7,
		BGl_z62walk1za2zd2node1634z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3713z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2no3950za7,
		BGl_z62walk2za2zd2node1636z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3714z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2no3951za7,
		BGl_z62walk3za2zd2node1638z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3715z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2no3952za7,
		BGl_z62walk0z12zd2node1640za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3716z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2no3953za7,
		BGl_z62walk1z12zd2node1642za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3717z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2no3954za7,
		BGl_z62walk2z12zd2node1644za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3718z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2no3955za7,
		BGl_z62walk3z12zd2node1646za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3719z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2seque3956z00,
		BGl_z62walk0zd2sequence1648zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3720z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2seque3957z00,
		BGl_z62walk1zd2sequence1650zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3721z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2seque3958z00,
		BGl_z62walk2zd2sequence1652zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3722z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2seque3959z00,
		BGl_z62walk3zd2sequence1654zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3723z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2se3960za7,
		BGl_z62walk0za2zd2sequence1656z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3724z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2se3961za7,
		BGl_z62walk1za2zd2sequence1658z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3725z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2se3962za7,
		BGl_z62walk2za2zd2sequence1660z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3726z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2se3963za7,
		BGl_z62walk3za2zd2sequence1662z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3727z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2se3964za7,
		BGl_z62walk0z12zd2sequence1665za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3728z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2se3965za7,
		BGl_z62walk1z12zd2sequence1667za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3729z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2se3966za7,
		BGl_z62walk2z12zd2sequence1669za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk1zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk1za762za7za7ast3967z00, BGl_z62walk1z62zzast_walkz00, 0L,
		BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3730z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2se3968za7,
		BGl_z62walk3z12zd2sequence1671za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3731z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2app163969z00, BGl_z62walk0zd2app1673zb0zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3732z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2app163970z00, BGl_z62walk1zd2app1675zb0zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3733z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2app163971z00, BGl_z62walk2zd2app1677zb0zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3734z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2app163972z00, BGl_z62walk3zd2app1679zb0zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3735z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ap3973za7,
		BGl_z62walk0za2zd2app1681z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3736z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ap3974za7,
		BGl_z62walk1za2zd2app1683z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3737z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ap3975za7,
		BGl_z62walk2za2zd2app1685z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3738z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ap3976za7,
		BGl_z62walk3za2zd2app1687z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3663z00zzast_walkz00,
		BgL_bgl_string3663za700za7za7a3977za7, "walk01593", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3739z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ap3978za7,
		BGl_z62walk0z12zd2app1689za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3665z00zzast_walkz00,
		BgL_bgl_string3665za700za7za7a3979za7, "walk11595", 9);
	      DEFINE_STRING(BGl_string3667z00zzast_walkz00,
		BgL_bgl_string3667za700za7za7a3980za7, "walk21597", 9);
	      DEFINE_STRING(BGl_string3669z00zzast_walkz00,
		BgL_bgl_string3669za700za7za7a3981za7, "walk31599", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3900z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2selec3982z00,
		BGl_z62walk1zd2select2015zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3901z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2selec3983z00,
		BGl_z62walk2zd2select2017zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3902z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2selec3984z00,
		BGl_z62walk3zd2select2019zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3740z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ap3985za7,
		BGl_z62walk1z12zd2app1691za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3903z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2se3986za7,
		BGl_z62walk0za2zd2select2021z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3741z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ap3987za7,
		BGl_z62walk2z12zd2app1693za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3904z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2se3988za7,
		BGl_z62walk1za2zd2select2023z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3742z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ap3989za7,
		BGl_z62walk3z12zd2app1695za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3905z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2se3990za7,
		BGl_z62walk2za2zd2select2025z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3743z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2appza7d3991za7,
		BGl_z62walk0zd2appzd2ly1697z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3906z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2se3992za7,
		BGl_z62walk3za2zd2select2027z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3744z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2appza7d3993za7,
		BGl_z62walk1zd2appzd2ly1699z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3907z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2se3994za7,
		BGl_z62walk0z12zd2select2029za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3745z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2appza7d3995za7,
		BGl_z62walk2zd2appzd2ly1701z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3908z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2se3996za7,
		BGl_z62walk1z12zd2select2031za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3746z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2appza7d3997za7,
		BGl_z62walk3zd2appzd2ly1703z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3671z00zzast_walkz00,
		BgL_bgl_string3671za700za7za7a3998za7, "walk41601", 9);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3909z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2se3999za7,
		BGl_z62walk2z12zd2select2033za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3747z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ap4000za7,
		BGl_z62walk0za2zd2appzd2ly1705zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3748z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ap4001za7,
		BGl_z62walk1za2zd2appzd2ly1707zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3673z00zzast_walkz00,
		BgL_bgl_string3673za700za7za7a4002za7, "walk0*1603", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3749z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ap4003za7,
		BGl_z62walk2za2zd2appzd2ly1709zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3675z00zzast_walkz00,
		BgL_bgl_string3675za700za7za7a4004za7, "walk1*1605", 10);
	      DEFINE_STRING(BGl_string3677z00zzast_walkz00,
		BgL_bgl_string3677za700za7za7a4005za7, "walk2*1607", 10);
	      DEFINE_STRING(BGl_string3679z00zzast_walkz00,
		BgL_bgl_string3679za700za7za7a4006za7, "walk3*1609", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3910z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2se4007za7,
		BGl_z62walk3z12zd2select2035za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3911z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2letza7d4008za7,
		BGl_z62walk0zd2letzd2fun2037z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3912z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2letza7d4009za7,
		BGl_z62walk1zd2letzd2fun2039z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3750z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ap4010za7,
		BGl_z62walk3za2zd2appzd2ly1711zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3913z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2letza7d4011za7,
		BGl_z62walk2zd2letzd2fun2041z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3751z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ap4012za7,
		BGl_z62walk0z12zd2appzd2ly1713z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3914z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2letza7d4013za7,
		BGl_z62walk3zd2letzd2fun2043z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3752z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ap4014za7,
		BGl_z62walk1z12zd2appzd2ly1715z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3915z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2le4015za7,
		BGl_z62walk0za2zd2letzd2fun2045zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3753z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ap4016za7,
		BGl_z62walk2z12zd2appzd2ly1717z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3916z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2le4017za7,
		BGl_z62walk1za2zd2letzd2fun2047zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3754z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ap4018za7,
		BGl_z62walk3z12zd2appzd2ly1719z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3917z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2le4019za7,
		BGl_z62walk2za2zd2letzd2fun2049zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3755z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2funca4020z00,
		BGl_z62walk0zd2funcall1721zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3918z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2le4021za7,
		BGl_z62walk3za2zd2letzd2fun2051zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3756z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2funca4022z00,
		BGl_z62walk1zd2funcall1723zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3681z00zzast_walkz00,
		BgL_bgl_string3681za700za7za7a4023za7, "walk4*1611", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3919z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2le4024za7,
		BGl_z62walk0z12zd2letzd2fun2053z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3757z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2funca4025z00,
		BGl_z62walk2zd2funcall1725zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3758z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2funca4026z00,
		BGl_z62walk3zd2funcall1727zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3683z00zzast_walkz00,
		BgL_bgl_string3683za700za7za7a4027za7, "walk0!1613", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3759z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2fu4028za7,
		BGl_z62walk0za2zd2funcall1729z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3685z00zzast_walkz00,
		BgL_bgl_string3685za700za7za7a4029za7, "walk1!1615", 10);
	      DEFINE_STRING(BGl_string3687z00zzast_walkz00,
		BgL_bgl_string3687za700za7za7a4030za7, "walk2!1617", 10);
	      DEFINE_STRING(BGl_string3689z00zzast_walkz00,
		BgL_bgl_string3689za700za7za7a4031za7, "walk3!1619", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3920z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2le4032za7,
		BGl_z62walk1z12zd2letzd2fun2055z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3921z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2le4033za7,
		BGl_z62walk2z12zd2letzd2fun2057z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3922z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2le4034za7,
		BGl_z62walk3z12zd2letzd2fun2059z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3760z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2fu4035za7,
		BGl_z62walk1za2zd2funcall1731z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3923z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2letza7d4036za7,
		BGl_z62walk0zd2letzd2var2061z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3761z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2fu4037za7,
		BGl_z62walk2za2zd2funcall1733z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3924z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2letza7d4038za7,
		BGl_z62walk1zd2letzd2var2063z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3762z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2fu4039za7,
		BGl_z62walk3za2zd2funcall1735z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3925z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2letza7d4040za7,
		BGl_z62walk2zd2letzd2var2065z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3763z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2fu4041za7,
		BGl_z62walk0z12zd2funcall1737za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3926z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2letza7d4042za7,
		BGl_z62walk3zd2letzd2var2067z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3764z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2fu4043za7,
		BGl_z62walk1z12zd2funcall1739za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3927z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2le4044za7,
		BGl_z62walk0za2zd2letzd2var2069zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3765z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2fu4045za7,
		BGl_z62walk2z12zd2funcall1741za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3928z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2le4046za7,
		BGl_z62walk1za2zd2letzd2var2071zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3766z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2fu4047za7,
		BGl_z62walk3z12zd2funcall1743za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STRING(BGl_string3691z00zzast_walkz00,
		BgL_bgl_string3691za700za7za7a4048za7, "walk4!1621", 10);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3929z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2le4049za7,
		BGl_z62walk2za2zd2letzd2var2073zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3767z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2exter4050z00,
		BGl_z62walk0zd2extern1745zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3692z00zzast_walkz00,
		BgL_bgl_string3692za700za7za7a4051za7, "walk4!", 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3768z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2exter4052z00,
		BGl_z62walk1zd2extern1747zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3693z00zzast_walkz00,
		BgL_bgl_string3693za700za7za7a4053za7, "Internal Error: forgot Node type",
		32);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3769z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2exter4054z00,
		BGl_z62walk2zd2extern1749zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STRING(BGl_string3694z00zzast_walkz00,
		BgL_bgl_string3694za700za7za7a4055za7, "walk3!", 6);
	      DEFINE_STRING(BGl_string3695z00zzast_walkz00,
		BgL_bgl_string3695za700za7za7a4056za7, "walk2!", 6);
	      DEFINE_STRING(BGl_string3696z00zzast_walkz00,
		BgL_bgl_string3696za700za7za7a4057za7, "walk1!", 6);
	      DEFINE_STRING(BGl_string3697z00zzast_walkz00,
		BgL_bgl_string3697za700za7za7a4058za7, "walk0!", 6);
	      DEFINE_STRING(BGl_string3698z00zzast_walkz00,
		BgL_bgl_string3698za700za7za7a4059za7, "walk3*", 6);
	      DEFINE_STRING(BGl_string3699z00zzast_walkz00,
		BgL_bgl_string3699za700za7za7a4060za7, "walk2*", 6);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk2zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk2za762za7za7ast4061z00, BGl_z62walk2z62zzast_walkz00, 0L,
		BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3930z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2le4062za7,
		BGl_z62walk3za2zd2letzd2var2075zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3931z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2le4063za7,
		BGl_z62walk0z12zd2letzd2var2077z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3932z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2le4064za7,
		BGl_z62walk1z12zd2letzd2var2079z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3770z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2exter4065z00,
		BGl_z62walk3zd2extern1751zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3933z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2le4066za7,
		BGl_z62walk2z12zd2letzd2var2081z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3771z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ex4067za7,
		BGl_z62walk0za2zd2extern1753z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3934z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2le4068za7,
		BGl_z62walk3z12zd2letzd2var2083z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3772z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ex4069za7,
		BGl_z62walk1za2zd2extern1755z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3773z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ex4070za7,
		BGl_z62walk2za2zd2extern1757z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3774z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ex4071za7,
		BGl_z62walk3za2zd2extern1759z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3775z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ex4072za7,
		BGl_z62walk0z12zd2extern1761za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3776z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ex4073za7,
		BGl_z62walk1z12zd2extern1763za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3777z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ex4074za7,
		BGl_z62walk2z12zd2extern1765za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3778z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ex4075za7,
		BGl_z62walk3z12zd2extern1767za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3779z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2cast14076z00,
		BGl_z62walk0zd2cast1769zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk0z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk0za712za770za7za74077za7, BGl_z62walk0z12z70zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3780z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2cast14078z00,
		BGl_z62walk1zd2cast1771zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3781z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2cast14079z00,
		BGl_z62walk2zd2cast1773zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3782z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2cast14080z00,
		BGl_z62walk3zd2cast1775zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3783z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ca4081za7,
		BGl_z62walk0za2zd2cast1777z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3784z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ca4082za7,
		BGl_z62walk1za2zd2cast1779z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3785z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ca4083za7,
		BGl_z62walk2za2zd2cast1781z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3786z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ca4084za7,
		BGl_z62walk3za2zd2cast1783z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3787z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ca4085za7,
		BGl_z62walk0z12zd2cast1785za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3788z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ca4086za7,
		BGl_z62walk1z12zd2cast1787za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3789z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ca4087za7,
		BGl_z62walk2z12zd2cast1789za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3790z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ca4088za7,
		BGl_z62walk3z12zd2cast1791za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3791z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2setq14089z00,
		BGl_z62walk0zd2setq1793zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3792z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2setq14090z00,
		BGl_z62walk1zd2setq1795zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3793z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2setq14091z00,
		BGl_z62walk2zd2setq1798zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3794z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2setq14092z00,
		BGl_z62walk3zd2setq1800zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3795z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2se4093za7,
		BGl_z62walk0za2zd2setq1802z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3796z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2se4094za7,
		BGl_z62walk1za2zd2setq1804z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3797z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2se4095za7,
		BGl_z62walk2za2zd2setq1806z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3798z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2se4096za7,
		BGl_z62walk3za2zd2setq1808z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3799z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2se4097za7,
		BGl_z62walk0z12zd2setq1810za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk3zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk3za762za7za7ast4098z00, BGl_z62walk3z62zzast_walkz00, 0L,
		BUNSPEC, 5);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk1z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk1za712za770za7za74099za7, BGl_z62walk1z12z70zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk4zd2envzd2zzast_walkz00,
		BgL_bgl_za762walk4za762za7za7ast4100z00, BGl_z62walk4z62zzast_walkz00, 0L,
		BUNSPEC, 6);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk2z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk2za712za770za7za74101za7, BGl_z62walk2z12z70zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk3z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk3za712za770za7za74102za7, BGl_z62walk3z12z70zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk4z12zd2envzc0zzast_walkz00,
		BgL_bgl_za762walk4za712za770za7za74103za7, BGl_z62walk4z12z70zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_STRING(BGl_string3700z00zzast_walkz00,
		BgL_bgl_string3700za700za7za7a4104za7, "walk1*", 6);
	      DEFINE_STRING(BGl_string3701z00zzast_walkz00,
		BgL_bgl_string3701za700za7za7a4105za7, "walk0*", 6);
	      DEFINE_STRING(BGl_string3702z00zzast_walkz00,
		BgL_bgl_string3702za700za7za7a4106za7, "walk4", 5);
	      DEFINE_STRING(BGl_string3703z00zzast_walkz00,
		BgL_bgl_string3703za700za7za7a4107za7, "walk3", 5);
	      DEFINE_STRING(BGl_string3704z00zzast_walkz00,
		BgL_bgl_string3704za700za7za7a4108za7, "walk2", 5);
	      DEFINE_STRING(BGl_string3705z00zzast_walkz00,
		BgL_bgl_string3705za700za7za7a4109za7, "walk1", 5);
	      DEFINE_STRING(BGl_string3706z00zzast_walkz00,
		BgL_bgl_string3706za700za7za7a4110za7, "walk0", 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3800z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2se4111za7,
		BGl_z62walk1z12zd2setq1812za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3801z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2se4112za7,
		BGl_z62walk2z12zd2setq1814za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3802z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2se4113za7,
		BGl_z62walk3z12zd2setq1816za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3803z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2condi4114z00,
		BGl_z62walk0zd2conditional1818zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3804z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2condi4115z00,
		BGl_z62walk1zd2conditional1820zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3805z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2condi4116z00,
		BGl_z62walk2zd2conditional1822zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3806z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2condi4117z00,
		BGl_z62walk3zd2conditional1824zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3807z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2co4118za7,
		BGl_z62walk0za2zd2conditional1826z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3808z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2co4119za7,
		BGl_z62walk1za2zd2conditional1828z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3809z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2co4120za7,
		BGl_z62walk2za2zd2conditional1830z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3810z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2co4121za7,
		BGl_z62walk3za2zd2conditional1832z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3811z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2co4122za7,
		BGl_z62walk0z12zd2conditional1834za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3812z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2co4123za7,
		BGl_z62walk1z12zd2conditional1836za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3813z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2co4124za7,
		BGl_z62walk2z12zd2conditional1839za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3814z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2co4125za7,
		BGl_z62walk3z12zd2conditional1841za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3815z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2fail14126z00,
		BGl_z62walk0zd2fail1843zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3816z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2fail14127z00,
		BGl_z62walk1zd2fail1845zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3817z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2fail14128z00,
		BGl_z62walk2zd2fail1847zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3818z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2fail14129z00,
		BGl_z62walk3zd2fail1849zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3819z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2fa4130za7,
		BGl_z62walk0za2zd2fail1851z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3820z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2fa4131za7,
		BGl_z62walk1za2zd2fail1853z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3821z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2fa4132za7,
		BGl_z62walk2za2zd2fail1855z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3822z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2fa4133za7,
		BGl_z62walk3za2zd2fail1857z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3823z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2fa4134za7,
		BGl_z62walk0z12zd2fail1859za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3824z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2fa4135za7,
		BGl_z62walk1z12zd2fail1861za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3662z00zzast_walkz00,
		BgL_bgl_za762walk01593za762za74136za7, BGl_z62walk01593z62zzast_walkz00, 0L,
		BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3825z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2fa4137za7,
		BGl_z62walk2z12zd2fail1863za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3826z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2fa4138za7,
		BGl_z62walk3z12zd2fail1865za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3664z00zzast_walkz00,
		BgL_bgl_za762walk11595za762za74139za7, BGl_z62walk11595z62zzast_walkz00, 0L,
		BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3827z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2setza7d4140za7,
		BGl_z62walk0zd2setzd2exzd2it1867zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3828z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2setza7d4141za7,
		BGl_z62walk1zd2setzd2exzd2it1869zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3666z00zzast_walkz00,
		BgL_bgl_za762walk21597za762za74142za7, BGl_z62walk21597z62zzast_walkz00, 0L,
		BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3829z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2setza7d4143za7,
		BGl_z62walk2zd2setzd2exzd2it1871zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3668z00zzast_walkz00,
		BgL_bgl_za762walk31599za762za74144za7, BGl_z62walk31599z62zzast_walkz00, 0L,
		BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3830z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2setza7d4145za7,
		BGl_z62walk3zd2setzd2exzd2it1873zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3831z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2se4146za7,
		BGl_z62walk0za2zd2setzd2exzd2it1875z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3832z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2se4147za7,
		BGl_z62walk1za2zd2setzd2exzd2it1877z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3670z00zzast_walkz00,
		BgL_bgl_za762walk41601za762za74148za7, BGl_z62walk41601z62zzast_walkz00, 0L,
		BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3833z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2se4149za7,
		BGl_z62walk2za2zd2setzd2exzd2it1879z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3834z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2se4150za7,
		BGl_z62walk3za2zd2setzd2exzd2it1881z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3672z00zzast_walkz00,
		BgL_bgl_za762walk0za7a21603za74151za7, BGl_z62walk0za21603zc0zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3835z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2se4152za7,
		BGl_z62walk0z12zd2setzd2exzd2it1883za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3836z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2se4153za7,
		BGl_z62walk1z12zd2setzd2exzd2it1885za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3674z00zzast_walkz00,
		BgL_bgl_za762walk1za7a21605za74154za7, BGl_z62walk1za21605zc0zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3837z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2se4155za7,
		BGl_z62walk2z12zd2setzd2exzd2it1887za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3838z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2se4156za7,
		BGl_z62walk3z12zd2setzd2exzd2it1889za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3676z00zzast_walkz00,
		BgL_bgl_za762walk2za7a21607za74157za7, BGl_z62walk2za21607zc0zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3839z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2jumpza74158za7,
		BGl_z62walk0zd2jumpzd2exzd2it1891zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3678z00zzast_walkz00,
		BgL_bgl_za762walk3za7a21609za74159za7, BGl_z62walk3za21609zc0zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3840z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2jumpza74160za7,
		BGl_z62walk1zd2jumpzd2exzd2it1893zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3841z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2jumpza74161za7,
		BGl_z62walk2zd2jumpzd2exzd2it1895zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3842z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2jumpza74162za7,
		BGl_z62walk3zd2jumpzd2exzd2it1897zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3680z00zzast_walkz00,
		BgL_bgl_za762walk4za7a21611za74163za7, BGl_z62walk4za21611zc0zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3843z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ju4164za7,
		BGl_z62walk0za2zd2jumpzd2exzd2it1899z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3844z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ju4165za7,
		BGl_z62walk1za2zd2jumpzd2exzd2it1901z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3682z00zzast_walkz00,
		BgL_bgl_za762walk0za7121613za74166za7, BGl_z62walk0z121613z70zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3845z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ju4167za7,
		BGl_z62walk2za2zd2jumpzd2exzd2it1903z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3846z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ju4168za7,
		BGl_z62walk3za2zd2jumpzd2exzd2it1905z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3684z00zzast_walkz00,
		BgL_bgl_za762walk1za7121615za74169za7, BGl_z62walk1z121615z70zzast_walkz00,
		0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3847z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ju4170za7,
		BGl_z62walk0z12zd2jumpzd2exzd2it1907za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string3935z00zzast_walkz00,
		BgL_bgl_string3935za700za7za7a4171za7, "ast_walk", 8);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3848z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ju4172za7,
		BGl_z62walk1z12zd2jumpzd2exzd2it1909za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3686z00zzast_walkz00,
		BgL_bgl_za762walk2za7121617za74173za7, BGl_z62walk2z121617z70zzast_walkz00,
		0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3849z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ju4174za7,
		BGl_z62walk2z12zd2jumpzd2exzd2it1911za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3688z00zzast_walkz00,
		BgL_bgl_za762walk3za7121619za74175za7, BGl_z62walk3z121619z70zzast_walkz00,
		0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3850z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ju4176za7,
		BGl_z62walk3z12zd2jumpzd2exzd2it1913za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3851z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2makeza74177za7,
		BGl_z62walk0zd2makezd2box1915z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3852z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2makeza74178za7,
		BGl_z62walk1zd2makezd2box1917z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3690z00zzast_walkz00,
		BgL_bgl_za762walk4za7121621za74179za7, BGl_z62walk4z121621z70zzast_walkz00,
		0L, BUNSPEC, 6);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3853z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2makeza74180za7,
		BGl_z62walk2zd2makezd2box1919z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3854z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2makeza74181za7,
		BGl_z62walk3zd2makezd2box1921z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3855z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2ma4182za7,
		BGl_z62walk0za2zd2makezd2box1923zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3856z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2ma4183za7,
		BGl_z62walk1za2zd2makezd2box1925zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3857z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2ma4184za7,
		BGl_z62walk2za2zd2makezd2box1927zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3858z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2ma4185za7,
		BGl_z62walk3za2zd2makezd2box1929zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3859z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2ma4186za7,
		BGl_z62walk0z12zd2makezd2box1931z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3860z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2ma4187za7,
		BGl_z62walk1z12zd2makezd2box1933z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3861z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2ma4188za7,
		BGl_z62walk2z12zd2makezd2box1935z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3862z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2ma4189za7,
		BGl_z62walk3z12zd2makezd2box1937z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3863z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2boxza7d4190za7,
		BGl_z62walk0zd2boxzd2ref1939z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3864z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2boxza7d4191za7,
		BGl_z62walk1zd2boxzd2ref1941z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3865z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2boxza7d4192za7,
		BGl_z62walk2zd2boxzd2ref1943z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3866z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2boxza7d4193za7,
		BGl_z62walk3zd2boxzd2ref1945z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3867z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2bo4194za7,
		BGl_z62walk0za2zd2boxzd2ref1947zc0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3868z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2bo4195za7,
		BGl_z62walk1za2zd2boxzd2ref1949zc0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3869z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2bo4196za7,
		BGl_z62walk2za2zd2boxzd2ref1952zc0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3870z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2bo4197za7,
		BGl_z62walk3za2zd2boxzd2ref1954zc0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3871z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2bo4198za7,
		BGl_z62walk0z12zd2boxzd2ref1956z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3872z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2bo4199za7,
		BGl_z62walk1z12zd2boxzd2ref1958z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3873z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2bo4200za7,
		BGl_z62walk2z12zd2boxzd2ref1960z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3874z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2bo4201za7,
		BGl_z62walk3z12zd2boxzd2ref1962z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3875z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2boxza7d4202za7,
		BGl_z62walk0zd2boxzd2setz121964z70zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3876z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2boxza7d4203za7,
		BGl_z62walk1zd2boxzd2setz121966z70zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3877z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2boxza7d4204za7,
		BGl_z62walk2zd2boxzd2setz121968z70zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3878z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2boxza7d4205za7,
		BGl_z62walk3zd2boxzd2setz121970z70zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3879z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2bo4206za7,
		BGl_z62walk0za2zd2boxzd2setz121972zd2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3880z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2bo4207za7,
		BGl_z62walk1za2zd2boxzd2setz121974zd2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3881z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2bo4208za7,
		BGl_z62walk2za2zd2boxzd2setz121976zd2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3882z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2bo4209za7,
		BGl_z62walk3za2zd2boxzd2setz121978zd2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3883z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2bo4210za7,
		BGl_z62walk0z12zd2boxzd2setz121980z62zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3884z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2bo4211za7,
		BGl_z62walk1z12zd2boxzd2setz121982z62zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3885z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2bo4212za7,
		BGl_z62walk2z12zd2boxzd2setz121984z62zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3886z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2bo4213za7,
		BGl_z62walk3z12zd2boxzd2setz121986z62zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3887z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2sync14214z00,
		BGl_z62walk0zd2sync1988zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3888z00zzast_walkz00,
		BgL_bgl_za762walk1za7d2sync14215z00,
		BGl_z62walk1zd2sync1990zb0zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3889z00zzast_walkz00,
		BgL_bgl_za762walk2za7d2sync14216z00,
		BGl_z62walk2zd2sync1992zb0zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3890z00zzast_walkz00,
		BgL_bgl_za762walk3za7d2sync14217z00,
		BGl_z62walk3zd2sync1994zb0zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3891z00zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7d2sy4218za7,
		BGl_z62walk0za2zd2sync1996z12zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3892z00zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7d2sy4219za7,
		BGl_z62walk1za2zd2sync1998z12zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3893z00zzast_walkz00,
		BgL_bgl_za762walk2za7a2za7d2sy4220za7,
		BGl_z62walk2za2zd2sync2001z12zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3894z00zzast_walkz00,
		BgL_bgl_za762walk3za7a2za7d2sy4221za7,
		BGl_z62walk3za2zd2sync2003z12zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3895z00zzast_walkz00,
		BgL_bgl_za762walk0za712za7d2sy4222za7,
		BGl_z62walk0z12zd2sync2005za2zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3896z00zzast_walkz00,
		BgL_bgl_za762walk1za712za7d2sy4223za7,
		BGl_z62walk1z12zd2sync2007za2zzast_walkz00, 0L, BUNSPEC, 3);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3897z00zzast_walkz00,
		BgL_bgl_za762walk2za712za7d2sy4224za7,
		BGl_z62walk2z12zd2sync2009za2zzast_walkz00, 0L, BUNSPEC, 4);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3898z00zzast_walkz00,
		BgL_bgl_za762walk3za712za7d2sy4225za7,
		BGl_z62walk3z12zd2sync2011za2zzast_walkz00, 0L, BUNSPEC, 5);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc3899z00zzast_walkz00,
		BgL_bgl_za762walk0za7d2selec4226z00,
		BGl_z62walk0zd2select2013zb0zzast_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk0za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk0za7a2za7c0za7za74227za7, BGl_z62walk0za2zc0zzast_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_EXPORT_BGL_GENERIC(BGl_walk1za2zd2envz70zzast_walkz00,
		BgL_bgl_za762walk1za7a2za7c0za7za74228za7, BGl_z62walk1za2zc0zzast_walkz00,
		0L, BUNSPEC, 3);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzast_walkz00(long
		BgL_checksumz00_8237, char *BgL_fromz00_8238)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzast_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzast_walkz00 = BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzast_walkz00();
					BGl_importedzd2moduleszd2initz00zzast_walkz00();
					BGl_genericzd2initzd2zzast_walkz00();
					BGl_methodzd2initzd2zzast_walkz00();
					return BGl_toplevelzd2initzd2zzast_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzast_walkz00()
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "ast_walk");
			BGl_modulezd2initializa7ationz75zz__pp_circlez00(((long) 0), "ast_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "ast_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"ast_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "ast_walk");
			return BUNSPEC;
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzast_walkz00()
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 15 */
			return BUNSPEC;
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzast_walkz00(obj_t BgL_l1z00_1, obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_2058;

				BgL_headz00_2058 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_2059;
					obj_t BgL_tailz00_2060;

					BgL_prevz00_2059 = BgL_headz00_2058;
					BgL_tailz00_2060 = BgL_l1z00_1;
				BgL_loopz00_2061:
					if (PAIRP(BgL_tailz00_2060))
						{
							obj_t BgL_newzd2prevzd2_2063;

							BgL_newzd2prevzd2_2063 =
								MAKE_PAIR(CAR(BgL_tailz00_2060), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_2059, BgL_newzd2prevzd2_2063);
							{
								obj_t BgL_tailz00_8262;
								obj_t BgL_prevz00_8261;

								BgL_prevz00_8261 = BgL_newzd2prevzd2_2063;
								BgL_tailz00_8262 = CDR(BgL_tailz00_2060);
								BgL_tailz00_2060 = BgL_tailz00_8262;
								BgL_prevz00_2059 = BgL_prevz00_8261;
								goto BgL_loopz00_2061;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_2058);
				}
			}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzast_walkz00()
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzast_walkz00()
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk0zd2envzd2zzast_walkz00,
				BGl_proc3662z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3663z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk1zd2envzd2zzast_walkz00,
				BGl_proc3664z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3665z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk2zd2envzd2zzast_walkz00,
				BGl_proc3666z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3667z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk3zd2envzd2zzast_walkz00,
				BGl_proc3668z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3669z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00(BGl_walk4zd2envzd2zzast_walkz00,
				BGl_proc3670z00zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string3671z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_proc3672z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3673z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_proc3674z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3675z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_proc3676z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3677z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_proc3678z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3679z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk4za2zd2envz70zzast_walkz00, BGl_proc3680z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3681z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_proc3682z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3683z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_proc3684z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3685z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_proc3686z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3687z00zzast_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_proc3688z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3689z00zzast_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_walk4z12zd2envzc0zzast_walkz00, BGl_proc3690z00zzast_walkz00,
				BGl_nodez00zzast_nodez00, BGl_string3691z00zzast_walkz00);
		}
	}



/* &walk4!1621 */
	obj_t BGl_z62walk4z121621z70zzast_walkz00(obj_t BgL_envz00_6687,
		obj_t BgL_nz00_6688, obj_t BgL_pz00_6689, obj_t BgL_arg0z00_6690,
		obj_t BgL_arg1z00_6691, obj_t BgL_arg2z00_6692, obj_t BgL_arg3z00_6693)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 160 */
			{
				BgL_nodez00_bglt BgL_nz00_2247;
				obj_t BgL_pz00_2248;
				obj_t BgL_arg0z00_2249;
				obj_t BgL_arg1z00_2250;
				obj_t BgL_arg2z00_2251;
				obj_t BgL_arg3z00_2252;

				BgL_nz00_2247 = ((BgL_nodez00_bglt) BgL_nz00_6688);
				BgL_pz00_2248 = BgL_pz00_6689;
				BgL_arg0z00_2249 = BgL_arg0z00_6690;
				BgL_arg1z00_2250 = BgL_arg1z00_6691;
				BgL_arg2z00_2251 = BgL_arg2z00_6692;
				BgL_arg3z00_2252 = BgL_arg3z00_6693;
				{	/* Ast/walk.scm 162 */
					obj_t BgL_arg2150z00_5532;

					{	/* Ast/walk.scm 162 */
						obj_t BgL_zc3anonymousza32152ze3z83_6657;

						BgL_zc3anonymousza32152ze3z83_6657 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32152ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32152ze3z83_6657,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2247));
						BgL_arg2150z00_5532 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32152ze3z83_6657);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3692z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2150z00_5532);
				}
			}
		}
	}



/* &<anonymous:2152> */
	obj_t BGl_z62zc3anonymousza32152ze3ze1zzast_walkz00(obj_t BgL_envz00_6694)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 162 */
			{	/* Ast/walk.scm 162 */
				BgL_nodez00_bglt BgL_nz00_6695;

				BgL_nz00_6695 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6694, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 162 */
						obj_t BgL_portz00_5535;

						{	/* Ast/walk.scm 162 */
							obj_t BgL_res3472z00_5537;

							{	/* Ast/walk.scm 162 */
								obj_t BgL_auxz00_8292;

								BgL_auxz00_8292 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3472z00_5537 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8292);
							}
							BgL_portz00_5535 = BgL_res3472z00_5537;
						}
						{	/* Ast/walk.scm 162 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6695), BgL_portz00_5535);
						}
					}
				}
			}
		}
	}



/* &walk3!1619 */
	obj_t BGl_z62walk3z121619z70zzast_walkz00(obj_t BgL_envz00_6696,
		obj_t BgL_nz00_6697, obj_t BgL_pz00_6698, obj_t BgL_arg0z00_6699,
		obj_t BgL_arg1z00_6700, obj_t BgL_arg2z00_6701)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 157 */
			{
				BgL_nodez00_bglt BgL_nz00_2233;
				obj_t BgL_pz00_2234;
				obj_t BgL_arg0z00_2235;
				obj_t BgL_arg1z00_2236;
				obj_t BgL_arg2z00_2237;

				BgL_nz00_2233 = ((BgL_nodez00_bglt) BgL_nz00_6697);
				BgL_pz00_2234 = BgL_pz00_6698;
				BgL_arg0z00_2235 = BgL_arg0z00_6699;
				BgL_arg1z00_2236 = BgL_arg1z00_6700;
				BgL_arg2z00_2237 = BgL_arg2z00_6701;
				{	/* Ast/walk.scm 159 */
					obj_t BgL_arg2145z00_5526;

					{	/* Ast/walk.scm 159 */
						obj_t BgL_zc3anonymousza32147ze3z83_6659;

						BgL_zc3anonymousza32147ze3z83_6659 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32147ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32147ze3z83_6659,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2233));
						BgL_arg2145z00_5526 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32147ze3z83_6659);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3694z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2145z00_5526);
				}
			}
		}
	}



/* &<anonymous:2147> */
	obj_t BGl_z62zc3anonymousza32147ze3ze1zzast_walkz00(obj_t BgL_envz00_6702)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 159 */
			{	/* Ast/walk.scm 159 */
				BgL_nodez00_bglt BgL_nz00_6703;

				BgL_nz00_6703 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6702, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 159 */
						obj_t BgL_portz00_5529;

						{	/* Ast/walk.scm 159 */
							obj_t BgL_res3471z00_5531;

							{	/* Ast/walk.scm 159 */
								obj_t BgL_auxz00_8309;

								BgL_auxz00_8309 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3471z00_5531 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8309);
							}
							BgL_portz00_5529 = BgL_res3471z00_5531;
						}
						{	/* Ast/walk.scm 159 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6703), BgL_portz00_5529);
						}
					}
				}
			}
		}
	}



/* &walk2!1617 */
	obj_t BGl_z62walk2z121617z70zzast_walkz00(obj_t BgL_envz00_6704,
		obj_t BgL_nz00_6705, obj_t BgL_pz00_6706, obj_t BgL_arg0z00_6707,
		obj_t BgL_arg1z00_6708)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 154 */
			{
				BgL_nodez00_bglt BgL_nz00_2220;
				obj_t BgL_pz00_2221;
				obj_t BgL_arg0z00_2222;
				obj_t BgL_arg1z00_2223;

				BgL_nz00_2220 = ((BgL_nodez00_bglt) BgL_nz00_6705);
				BgL_pz00_2221 = BgL_pz00_6706;
				BgL_arg0z00_2222 = BgL_arg0z00_6707;
				BgL_arg1z00_2223 = BgL_arg1z00_6708;
				{	/* Ast/walk.scm 156 */
					obj_t BgL_arg2140z00_5520;

					{	/* Ast/walk.scm 156 */
						obj_t BgL_zc3anonymousza32142ze3z83_6661;

						BgL_zc3anonymousza32142ze3z83_6661 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32142ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32142ze3z83_6661,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2220));
						BgL_arg2140z00_5520 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32142ze3z83_6661);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3695z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2140z00_5520);
				}
			}
		}
	}



/* &<anonymous:2142> */
	obj_t BGl_z62zc3anonymousza32142ze3ze1zzast_walkz00(obj_t BgL_envz00_6709)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 156 */
			{	/* Ast/walk.scm 156 */
				BgL_nodez00_bglt BgL_nz00_6710;

				BgL_nz00_6710 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6709, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 156 */
						obj_t BgL_portz00_5523;

						{	/* Ast/walk.scm 156 */
							obj_t BgL_res3470z00_5525;

							{	/* Ast/walk.scm 156 */
								obj_t BgL_auxz00_8326;

								BgL_auxz00_8326 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3470z00_5525 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8326);
							}
							BgL_portz00_5523 = BgL_res3470z00_5525;
						}
						{	/* Ast/walk.scm 156 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6710), BgL_portz00_5523);
						}
					}
				}
			}
		}
	}



/* &walk1!1615 */
	obj_t BGl_z62walk1z121615z70zzast_walkz00(obj_t BgL_envz00_6711,
		obj_t BgL_nz00_6712, obj_t BgL_pz00_6713, obj_t BgL_arg0z00_6714)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 151 */
			{
				BgL_nodez00_bglt BgL_nz00_2208;
				obj_t BgL_pz00_2209;
				obj_t BgL_arg0z00_2210;

				BgL_nz00_2208 = ((BgL_nodez00_bglt) BgL_nz00_6712);
				BgL_pz00_2209 = BgL_pz00_6713;
				BgL_arg0z00_2210 = BgL_arg0z00_6714;
				{	/* Ast/walk.scm 153 */
					obj_t BgL_arg2136z00_5514;

					{	/* Ast/walk.scm 153 */
						obj_t BgL_zc3anonymousza32138ze3z83_6663;

						BgL_zc3anonymousza32138ze3z83_6663 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32138ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32138ze3z83_6663,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2208));
						BgL_arg2136z00_5514 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32138ze3z83_6663);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3696z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2136z00_5514);
				}
			}
		}
	}



/* &<anonymous:2138> */
	obj_t BGl_z62zc3anonymousza32138ze3ze1zzast_walkz00(obj_t BgL_envz00_6715)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 153 */
			{	/* Ast/walk.scm 153 */
				BgL_nodez00_bglt BgL_nz00_6716;

				BgL_nz00_6716 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6715, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 153 */
						obj_t BgL_portz00_5517;

						{	/* Ast/walk.scm 153 */
							obj_t BgL_res3469z00_5519;

							{	/* Ast/walk.scm 153 */
								obj_t BgL_auxz00_8343;

								BgL_auxz00_8343 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3469z00_5519 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8343);
							}
							BgL_portz00_5517 = BgL_res3469z00_5519;
						}
						{	/* Ast/walk.scm 153 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6716), BgL_portz00_5517);
						}
					}
				}
			}
		}
	}



/* &walk0!1613 */
	obj_t BGl_z62walk0z121613z70zzast_walkz00(obj_t BgL_envz00_6717,
		obj_t BgL_nz00_6718, obj_t BgL_pz00_6719)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 148 */
			{
				BgL_nodez00_bglt BgL_nz00_2197;
				obj_t BgL_pz00_2198;

				BgL_nz00_2197 = ((BgL_nodez00_bglt) BgL_nz00_6718);
				BgL_pz00_2198 = BgL_pz00_6719;
				{	/* Ast/walk.scm 150 */
					obj_t BgL_arg2132z00_2200;

					{	/* Ast/walk.scm 150 */
						obj_t BgL_zc3anonymousza32134ze3z83_6665;

						BgL_zc3anonymousza32134ze3z83_6665 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32134ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32134ze3z83_6665,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2197));
						BgL_arg2132z00_2200 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32134ze3z83_6665);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3697z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2132z00_2200);
				}
			}
		}
	}



/* &<anonymous:2134> */
	obj_t BGl_z62zc3anonymousza32134ze3ze1zzast_walkz00(obj_t BgL_envz00_6720)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 150 */
			{	/* Ast/walk.scm 150 */
				BgL_nodez00_bglt BgL_nz00_6721;

				BgL_nz00_6721 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6720, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 150 */
						obj_t BgL_portz00_2204;

						{	/* Ast/walk.scm 150 */
							obj_t BgL_res3468z00_5513;

							{	/* Ast/walk.scm 150 */
								obj_t BgL_auxz00_8360;

								BgL_auxz00_8360 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3468z00_5513 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8360);
							}
							BgL_portz00_2204 = BgL_res3468z00_5513;
						}
						{	/* Ast/walk.scm 150 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6721), BgL_portz00_2204);
						}
					}
				}
			}
		}
	}



/* &walk4*1611 */
	obj_t BGl_z62walk4za21611zc0zzast_walkz00(obj_t BgL_envz00_6722,
		obj_t BgL_nz00_6723, obj_t BgL_pz00_6724, obj_t BgL_arg0z00_6725,
		obj_t BgL_arg1z00_6726, obj_t BgL_arg2z00_6727, obj_t BgL_arg3z00_6728)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 144 */
			{
				BgL_nodez00_bglt BgL_nz00_2182;
				obj_t BgL_pz00_2183;
				obj_t BgL_arg0z00_2184;
				obj_t BgL_arg1z00_2185;
				obj_t BgL_arg2z00_2186;
				obj_t BgL_arg3z00_2187;

				BgL_nz00_2182 = ((BgL_nodez00_bglt) BgL_nz00_6723);
				BgL_pz00_2183 = BgL_pz00_6724;
				BgL_arg0z00_2184 = BgL_arg0z00_6725;
				BgL_arg1z00_2185 = BgL_arg1z00_6726;
				BgL_arg2z00_2186 = BgL_arg2z00_6727;
				BgL_arg3z00_2187 = BgL_arg3z00_6728;
				{	/* Ast/walk.scm 146 */
					obj_t BgL_arg2128z00_5506;

					{	/* Ast/walk.scm 146 */
						obj_t BgL_zc3anonymousza32130ze3z83_6667;

						BgL_zc3anonymousza32130ze3z83_6667 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32130ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32130ze3z83_6667,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2182));
						BgL_arg2128z00_5506 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32130ze3z83_6667);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3692z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2128z00_5506);
				}
			}
		}
	}



/* &<anonymous:2130> */
	obj_t BGl_z62zc3anonymousza32130ze3ze1zzast_walkz00(obj_t BgL_envz00_6729)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 146 */
			{	/* Ast/walk.scm 146 */
				BgL_nodez00_bglt BgL_nz00_6730;

				BgL_nz00_6730 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6729, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 146 */
						obj_t BgL_portz00_5509;

						{	/* Ast/walk.scm 146 */
							obj_t BgL_res3467z00_5511;

							{	/* Ast/walk.scm 146 */
								obj_t BgL_auxz00_8377;

								BgL_auxz00_8377 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3467z00_5511 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8377);
							}
							BgL_portz00_5509 = BgL_res3467z00_5511;
						}
						{	/* Ast/walk.scm 146 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6730), BgL_portz00_5509);
						}
					}
				}
			}
		}
	}



/* &walk3*1609 */
	obj_t BGl_z62walk3za21609zc0zzast_walkz00(obj_t BgL_envz00_6731,
		obj_t BgL_nz00_6732, obj_t BgL_pz00_6733, obj_t BgL_arg0z00_6734,
		obj_t BgL_arg1z00_6735, obj_t BgL_arg2z00_6736)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 141 */
			{
				BgL_nodez00_bglt BgL_nz00_2168;
				obj_t BgL_pz00_2169;
				obj_t BgL_arg0z00_2170;
				obj_t BgL_arg1z00_2171;
				obj_t BgL_arg2z00_2172;

				BgL_nz00_2168 = ((BgL_nodez00_bglt) BgL_nz00_6732);
				BgL_pz00_2169 = BgL_pz00_6733;
				BgL_arg0z00_2170 = BgL_arg0z00_6734;
				BgL_arg1z00_2171 = BgL_arg1z00_6735;
				BgL_arg2z00_2172 = BgL_arg2z00_6736;
				{	/* Ast/walk.scm 143 */
					obj_t BgL_arg2124z00_5500;

					{	/* Ast/walk.scm 143 */
						obj_t BgL_zc3anonymousza32126ze3z83_6669;

						BgL_zc3anonymousza32126ze3z83_6669 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32126ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32126ze3z83_6669,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2168));
						BgL_arg2124z00_5500 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32126ze3z83_6669);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3698z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2124z00_5500);
				}
			}
		}
	}



/* &<anonymous:2126> */
	obj_t BGl_z62zc3anonymousza32126ze3ze1zzast_walkz00(obj_t BgL_envz00_6737)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 143 */
			{	/* Ast/walk.scm 143 */
				BgL_nodez00_bglt BgL_nz00_6738;

				BgL_nz00_6738 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6737, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 143 */
						obj_t BgL_portz00_5503;

						{	/* Ast/walk.scm 143 */
							obj_t BgL_res3466z00_5505;

							{	/* Ast/walk.scm 143 */
								obj_t BgL_auxz00_8394;

								BgL_auxz00_8394 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3466z00_5505 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8394);
							}
							BgL_portz00_5503 = BgL_res3466z00_5505;
						}
						{	/* Ast/walk.scm 143 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6738), BgL_portz00_5503);
						}
					}
				}
			}
		}
	}



/* &walk2*1607 */
	obj_t BGl_z62walk2za21607zc0zzast_walkz00(obj_t BgL_envz00_6739,
		obj_t BgL_nz00_6740, obj_t BgL_pz00_6741, obj_t BgL_arg0z00_6742,
		obj_t BgL_arg1z00_6743)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 138 */
			{
				BgL_nodez00_bglt BgL_nz00_2155;
				obj_t BgL_pz00_2156;
				obj_t BgL_arg0z00_2157;
				obj_t BgL_arg1z00_2158;

				BgL_nz00_2155 = ((BgL_nodez00_bglt) BgL_nz00_6740);
				BgL_pz00_2156 = BgL_pz00_6741;
				BgL_arg0z00_2157 = BgL_arg0z00_6742;
				BgL_arg1z00_2158 = BgL_arg1z00_6743;
				{	/* Ast/walk.scm 140 */
					obj_t BgL_arg2120z00_5494;

					{	/* Ast/walk.scm 140 */
						obj_t BgL_zc3anonymousza32122ze3z83_6671;

						BgL_zc3anonymousza32122ze3z83_6671 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32122ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32122ze3z83_6671,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2155));
						BgL_arg2120z00_5494 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32122ze3z83_6671);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3699z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2120z00_5494);
				}
			}
		}
	}



/* &<anonymous:2122> */
	obj_t BGl_z62zc3anonymousza32122ze3ze1zzast_walkz00(obj_t BgL_envz00_6744)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 140 */
			{	/* Ast/walk.scm 140 */
				BgL_nodez00_bglt BgL_nz00_6745;

				BgL_nz00_6745 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6744, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 140 */
						obj_t BgL_portz00_5497;

						{	/* Ast/walk.scm 140 */
							obj_t BgL_res3465z00_5499;

							{	/* Ast/walk.scm 140 */
								obj_t BgL_auxz00_8411;

								BgL_auxz00_8411 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3465z00_5499 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8411);
							}
							BgL_portz00_5497 = BgL_res3465z00_5499;
						}
						{	/* Ast/walk.scm 140 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6745), BgL_portz00_5497);
						}
					}
				}
			}
		}
	}



/* &walk1*1605 */
	obj_t BGl_z62walk1za21605zc0zzast_walkz00(obj_t BgL_envz00_6746,
		obj_t BgL_nz00_6747, obj_t BgL_pz00_6748, obj_t BgL_arg0z00_6749)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 135 */
			{
				BgL_nodez00_bglt BgL_nz00_2143;
				obj_t BgL_pz00_2144;
				obj_t BgL_arg0z00_2145;

				BgL_nz00_2143 = ((BgL_nodez00_bglt) BgL_nz00_6747);
				BgL_pz00_2144 = BgL_pz00_6748;
				BgL_arg0z00_2145 = BgL_arg0z00_6749;
				{	/* Ast/walk.scm 137 */
					obj_t BgL_arg2114z00_5488;

					{	/* Ast/walk.scm 137 */
						obj_t BgL_zc3anonymousza32117ze3z83_6673;

						BgL_zc3anonymousza32117ze3z83_6673 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32117ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32117ze3z83_6673,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2143));
						BgL_arg2114z00_5488 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32117ze3z83_6673);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3700z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2114z00_5488);
				}
			}
		}
	}



/* &<anonymous:2117> */
	obj_t BGl_z62zc3anonymousza32117ze3ze1zzast_walkz00(obj_t BgL_envz00_6750)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 137 */
			{	/* Ast/walk.scm 137 */
				BgL_nodez00_bglt BgL_nz00_6751;

				BgL_nz00_6751 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6750, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 137 */
						obj_t BgL_portz00_5491;

						{	/* Ast/walk.scm 137 */
							obj_t BgL_res3464z00_5493;

							{	/* Ast/walk.scm 137 */
								obj_t BgL_auxz00_8428;

								BgL_auxz00_8428 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3464z00_5493 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8428);
							}
							BgL_portz00_5491 = BgL_res3464z00_5493;
						}
						{	/* Ast/walk.scm 137 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6751), BgL_portz00_5491);
						}
					}
				}
			}
		}
	}



/* &walk0*1603 */
	obj_t BGl_z62walk0za21603zc0zzast_walkz00(obj_t BgL_envz00_6752,
		obj_t BgL_nz00_6753, obj_t BgL_pz00_6754)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 132 */
			{
				BgL_nodez00_bglt BgL_nz00_2132;
				obj_t BgL_pz00_2133;

				BgL_nz00_2132 = ((BgL_nodez00_bglt) BgL_nz00_6753);
				BgL_pz00_2133 = BgL_pz00_6754;
				{	/* Ast/walk.scm 134 */
					obj_t BgL_arg2110z00_2135;

					{	/* Ast/walk.scm 134 */
						obj_t BgL_zc3anonymousza32112ze3z83_6675;

						BgL_zc3anonymousza32112ze3z83_6675 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32112ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32112ze3z83_6675,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2132));
						BgL_arg2110z00_2135 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32112ze3z83_6675);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3701z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2110z00_2135);
				}
			}
		}
	}



/* &<anonymous:2112> */
	obj_t BGl_z62zc3anonymousza32112ze3ze1zzast_walkz00(obj_t BgL_envz00_6755)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 134 */
			{	/* Ast/walk.scm 134 */
				BgL_nodez00_bglt BgL_nz00_6756;

				BgL_nz00_6756 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6755, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 134 */
						obj_t BgL_portz00_2139;

						{	/* Ast/walk.scm 134 */
							obj_t BgL_res3463z00_5487;

							{	/* Ast/walk.scm 134 */
								obj_t BgL_auxz00_8445;

								BgL_auxz00_8445 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3463z00_5487 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8445);
							}
							BgL_portz00_2139 = BgL_res3463z00_5487;
						}
						{	/* Ast/walk.scm 134 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6756), BgL_portz00_2139);
						}
					}
				}
			}
		}
	}



/* &walk41601 */
	obj_t BGl_z62walk41601z62zzast_walkz00(obj_t BgL_envz00_6757,
		obj_t BgL_nz00_6758, obj_t BgL_pz00_6759, obj_t BgL_arg0z00_6760,
		obj_t BgL_arg1z00_6761, obj_t BgL_arg2z00_6762, obj_t BgL_arg3z00_6763)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 128 */
			{
				BgL_nodez00_bglt BgL_nz00_2117;
				obj_t BgL_pz00_2118;
				obj_t BgL_arg0z00_2119;
				obj_t BgL_arg1z00_2120;
				obj_t BgL_arg2z00_2121;
				obj_t BgL_arg3z00_2122;

				BgL_nz00_2117 = ((BgL_nodez00_bglt) BgL_nz00_6758);
				BgL_pz00_2118 = BgL_pz00_6759;
				BgL_arg0z00_2119 = BgL_arg0z00_6760;
				BgL_arg1z00_2120 = BgL_arg1z00_6761;
				BgL_arg2z00_2121 = BgL_arg2z00_6762;
				BgL_arg3z00_2122 = BgL_arg3z00_6763;
				{	/* Ast/walk.scm 130 */
					obj_t BgL_arg2106z00_5480;

					{	/* Ast/walk.scm 130 */
						obj_t BgL_zc3anonymousza32108ze3z83_6677;

						BgL_zc3anonymousza32108ze3z83_6677 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32108ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32108ze3z83_6677,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2117));
						BgL_arg2106z00_5480 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32108ze3z83_6677);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3702z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2106z00_5480);
				}
			}
		}
	}



/* &<anonymous:2108> */
	obj_t BGl_z62zc3anonymousza32108ze3ze1zzast_walkz00(obj_t BgL_envz00_6764)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 130 */
			{	/* Ast/walk.scm 130 */
				BgL_nodez00_bglt BgL_nz00_6765;

				BgL_nz00_6765 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6764, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 130 */
						obj_t BgL_portz00_5483;

						{	/* Ast/walk.scm 130 */
							obj_t BgL_res3462z00_5485;

							{	/* Ast/walk.scm 130 */
								obj_t BgL_auxz00_8462;

								BgL_auxz00_8462 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3462z00_5485 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8462);
							}
							BgL_portz00_5483 = BgL_res3462z00_5485;
						}
						{	/* Ast/walk.scm 130 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6765), BgL_portz00_5483);
						}
					}
				}
			}
		}
	}



/* &walk31599 */
	obj_t BGl_z62walk31599z62zzast_walkz00(obj_t BgL_envz00_6766,
		obj_t BgL_nz00_6767, obj_t BgL_pz00_6768, obj_t BgL_arg0z00_6769,
		obj_t BgL_arg1z00_6770, obj_t BgL_arg2z00_6771)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 125 */
			{
				BgL_nodez00_bglt BgL_nz00_2103;
				obj_t BgL_pz00_2104;
				obj_t BgL_arg0z00_2105;
				obj_t BgL_arg1z00_2106;
				obj_t BgL_arg2z00_2107;

				BgL_nz00_2103 = ((BgL_nodez00_bglt) BgL_nz00_6767);
				BgL_pz00_2104 = BgL_pz00_6768;
				BgL_arg0z00_2105 = BgL_arg0z00_6769;
				BgL_arg1z00_2106 = BgL_arg1z00_6770;
				BgL_arg2z00_2107 = BgL_arg2z00_6771;
				{	/* Ast/walk.scm 127 */
					obj_t BgL_arg2102z00_5474;

					{	/* Ast/walk.scm 127 */
						obj_t BgL_zc3anonymousza32104ze3z83_6679;

						BgL_zc3anonymousza32104ze3z83_6679 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32104ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32104ze3z83_6679,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2103));
						BgL_arg2102z00_5474 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32104ze3z83_6679);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3703z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2102z00_5474);
				}
			}
		}
	}



/* &<anonymous:2104> */
	obj_t BGl_z62zc3anonymousza32104ze3ze1zzast_walkz00(obj_t BgL_envz00_6772)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 127 */
			{	/* Ast/walk.scm 127 */
				BgL_nodez00_bglt BgL_nz00_6773;

				BgL_nz00_6773 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6772, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 127 */
						obj_t BgL_portz00_5477;

						{	/* Ast/walk.scm 127 */
							obj_t BgL_res3461z00_5479;

							{	/* Ast/walk.scm 127 */
								obj_t BgL_auxz00_8479;

								BgL_auxz00_8479 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3461z00_5479 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8479);
							}
							BgL_portz00_5477 = BgL_res3461z00_5479;
						}
						{	/* Ast/walk.scm 127 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6773), BgL_portz00_5477);
						}
					}
				}
			}
		}
	}



/* &walk21597 */
	obj_t BGl_z62walk21597z62zzast_walkz00(obj_t BgL_envz00_6774,
		obj_t BgL_nz00_6775, obj_t BgL_pz00_6776, obj_t BgL_arg0z00_6777,
		obj_t BgL_arg1z00_6778)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 122 */
			{
				BgL_nodez00_bglt BgL_nz00_2090;
				obj_t BgL_pz00_2091;
				obj_t BgL_arg0z00_2092;
				obj_t BgL_arg1z00_2093;

				BgL_nz00_2090 = ((BgL_nodez00_bglt) BgL_nz00_6775);
				BgL_pz00_2091 = BgL_pz00_6776;
				BgL_arg0z00_2092 = BgL_arg0z00_6777;
				BgL_arg1z00_2093 = BgL_arg1z00_6778;
				{	/* Ast/walk.scm 124 */
					obj_t BgL_arg2098z00_5468;

					{	/* Ast/walk.scm 124 */
						obj_t BgL_zc3anonymousza32100ze3z83_6681;

						BgL_zc3anonymousza32100ze3z83_6681 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32100ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32100ze3z83_6681,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2090));
						BgL_arg2098z00_5468 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32100ze3z83_6681);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3704z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2098z00_5468);
				}
			}
		}
	}



/* &<anonymous:2100> */
	obj_t BGl_z62zc3anonymousza32100ze3ze1zzast_walkz00(obj_t BgL_envz00_6779)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 124 */
			{	/* Ast/walk.scm 124 */
				BgL_nodez00_bglt BgL_nz00_6780;

				BgL_nz00_6780 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6779, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 124 */
						obj_t BgL_portz00_5471;

						{	/* Ast/walk.scm 124 */
							obj_t BgL_res3460z00_5473;

							{	/* Ast/walk.scm 124 */
								obj_t BgL_auxz00_8496;

								BgL_auxz00_8496 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3460z00_5473 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8496);
							}
							BgL_portz00_5471 = BgL_res3460z00_5473;
						}
						{	/* Ast/walk.scm 124 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6780), BgL_portz00_5471);
						}
					}
				}
			}
		}
	}



/* &walk11595 */
	obj_t BGl_z62walk11595z62zzast_walkz00(obj_t BgL_envz00_6781,
		obj_t BgL_nz00_6782, obj_t BgL_pz00_6783, obj_t BgL_arg0z00_6784)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 119 */
			{
				BgL_nodez00_bglt BgL_nz00_2078;
				obj_t BgL_pz00_2079;
				obj_t BgL_arg0z00_2080;

				BgL_nz00_2078 = ((BgL_nodez00_bglt) BgL_nz00_6782);
				BgL_pz00_2079 = BgL_pz00_6783;
				BgL_arg0z00_2080 = BgL_arg0z00_6784;
				{	/* Ast/walk.scm 121 */
					obj_t BgL_arg2093z00_5462;

					{	/* Ast/walk.scm 121 */
						obj_t BgL_zc3anonymousza32096ze3z83_6683;

						BgL_zc3anonymousza32096ze3z83_6683 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32096ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32096ze3z83_6683,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2078));
						BgL_arg2093z00_5462 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32096ze3z83_6683);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3705z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2093z00_5462);
				}
			}
		}
	}



/* &<anonymous:2096> */
	obj_t BGl_z62zc3anonymousza32096ze3ze1zzast_walkz00(obj_t BgL_envz00_6785)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 121 */
			{	/* Ast/walk.scm 121 */
				BgL_nodez00_bglt BgL_nz00_6786;

				BgL_nz00_6786 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6785, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 121 */
						obj_t BgL_portz00_5465;

						{	/* Ast/walk.scm 121 */
							obj_t BgL_res3459z00_5467;

							{	/* Ast/walk.scm 121 */
								obj_t BgL_auxz00_8513;

								BgL_auxz00_8513 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3459z00_5467 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8513);
							}
							BgL_portz00_5465 = BgL_res3459z00_5467;
						}
						{	/* Ast/walk.scm 121 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6786), BgL_portz00_5465);
						}
					}
				}
			}
		}
	}



/* &walk01593 */
	obj_t BGl_z62walk01593z62zzast_walkz00(obj_t BgL_envz00_6787,
		obj_t BgL_nz00_6788, obj_t BgL_pz00_6789)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 116 */
			{
				BgL_nodez00_bglt BgL_nz00_2067;
				obj_t BgL_pz00_2068;

				BgL_nz00_2067 = ((BgL_nodez00_bglt) BgL_nz00_6788);
				BgL_pz00_2068 = BgL_pz00_6789;
				{	/* Ast/walk.scm 118 */
					obj_t BgL_arg2089z00_2070;

					{	/* Ast/walk.scm 118 */
						obj_t BgL_zc3anonymousza32091ze3z83_6685;

						BgL_zc3anonymousza32091ze3z83_6685 =
							MAKE_FX_PROCEDURE(BGl_z62zc3anonymousza32091ze3ze1zzast_walkz00,
							(int) (((long) 0)), (int) (((long) 1)));
						PROCEDURE_SET(BgL_zc3anonymousza32091ze3z83_6685,
							(int) (((long) 0)), ((obj_t) BgL_nz00_2067));
						BgL_arg2089z00_2070 =
							BGl_withzd2outputzd2tozd2stringzd2zz__r4_ports_6_10_1z00
							(BgL_zc3anonymousza32091ze3z83_6685);
					}
					return
						BGl_errorz00zz__errorz00(BGl_string3706z00zzast_walkz00,
						BGl_string3693z00zzast_walkz00, BgL_arg2089z00_2070);
				}
			}
		}
	}



/* &<anonymous:2091> */
	obj_t BGl_z62zc3anonymousza32091ze3ze1zzast_walkz00(obj_t BgL_envz00_6790)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 118 */
			{	/* Ast/walk.scm 118 */
				BgL_nodez00_bglt BgL_nz00_6791;

				BgL_nz00_6791 =
					((BgL_nodez00_bglt)
					PROCEDURE_REF(BgL_envz00_6790, (int) (((long) 0))));
				{

					{	/* Ast/walk.scm 118 */
						obj_t BgL_portz00_2074;

						{	/* Ast/walk.scm 118 */
							obj_t BgL_res3458z00_5461;

							{	/* Ast/walk.scm 118 */
								obj_t BgL_auxz00_8530;

								BgL_auxz00_8530 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res3458z00_5461 =
									BGL_ENV_CURRENT_OUTPUT_PORT(BgL_auxz00_8530);
							}
							BgL_portz00_2074 = BgL_res3458z00_5461;
						}
						{	/* Ast/walk.scm 118 */

							return
								BGl_writezd2circlezd2zz__pp_circlez00(
								((obj_t) BgL_nz00_6791), BgL_portz00_2074);
						}
					}
				}
			}
		}
	}



/* walk0 */
	BGL_EXPORTED_DEF obj_t BGl_walk0z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_3,
		obj_t BgL_pz00_4)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 116 */
			{	/* Ast/walk.scm 116 */
				obj_t BgL_method1594z00_2261;

				{	/* Ast/walk.scm 116 */
					obj_t BgL_res3479z00_5566;

					{	/* Ast/walk.scm 116 */
						long BgL_objzd2classzd2numz00_5539;

						{	/* Ast/walk.scm 116 */
							long BgL_res3473z00_5542;

							BgL_res3473z00_5542 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_3));
							BgL_objzd2classzd2numz00_5539 = BgL_res3473z00_5542;
						}
						{	/* Ast/walk.scm 116 */
							obj_t BgL_arg1664z00_5540;

							BgL_arg1664z00_5540 =
								PROCEDURE_REF(BGl_walk0zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 116 */
								int BgL_offsetz00_5544;

								BgL_offsetz00_5544 = (int) (BgL_objzd2classzd2numz00_5539);
								{	/* Ast/walk.scm 116 */
									long BgL_offsetz00_5545;

									BgL_offsetz00_5545 =
										((long) (BgL_offsetz00_5544) - OBJECT_TYPE);
									{	/* Ast/walk.scm 116 */
										long BgL_modz00_5546;

										{	/* Ast/walk.scm 116 */
											int BgL_arg1666z00_5547;

											BgL_arg1666z00_5547 = (int) (((long) 16));
											{	/* Ast/walk.scm 116 */
												long BgL_res3476z00_5557;

												{	/* Ast/walk.scm 116 */
													long BgL_auxz00_8543;

													BgL_auxz00_8543 = (long) (BgL_arg1666z00_5547);
													BgL_res3476z00_5557 =
														(BgL_offsetz00_5545 / BgL_auxz00_8543);
												}
												BgL_modz00_5546 = BgL_res3476z00_5557;
										}}
										{	/* Ast/walk.scm 116 */
											long BgL_restz00_5548;

											{	/* Ast/walk.scm 116 */
												int BgL_arg1665z00_5549;

												BgL_arg1665z00_5549 = (int) (((long) 16));
												{	/* Ast/walk.scm 116 */
													long BgL_res3478z00_5561;

													{	/* Ast/walk.scm 116 */
														long BgL_auxz00_8547;

														BgL_auxz00_8547 = (long) (BgL_arg1665z00_5549);
														BgL_res3478z00_5561 =
															(BgL_offsetz00_5545 % BgL_auxz00_8547);
													}
													BgL_restz00_5548 = BgL_res3478z00_5561;
											}}
											{	/* Ast/walk.scm 116 */

												BgL_res3479z00_5566 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5540,
														(int) (BgL_modz00_5546)), (int) (BgL_restz00_5548));
					}}}}}}}
					BgL_method1594z00_2261 = BgL_res3479z00_5566;
				}
				return
					PROCEDURE_ENTRY(BgL_method1594z00_2261) (BgL_method1594z00_2261,
					((obj_t) BgL_nz00_3), BgL_pz00_4, BEOA);
			}
		}
	}



/* &walk0 */
	obj_t BGl_z62walk0z62zzast_walkz00(obj_t BgL_envz00_6792, obj_t BgL_nz00_6793,
		obj_t BgL_pz00_6794)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 116 */
			return
				BGl_walk0z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6793), BgL_pz00_6794);
		}
	}



/* walk1 */
	BGL_EXPORTED_DEF obj_t BGl_walk1z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_5,
		obj_t BgL_pz00_6, obj_t BgL_arg0z00_7)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 119 */
			{	/* Ast/walk.scm 119 */
				obj_t BgL_method1596z00_2262;

				{	/* Ast/walk.scm 119 */
					obj_t BgL_res3486z00_5595;

					{	/* Ast/walk.scm 119 */
						long BgL_objzd2classzd2numz00_5568;

						{	/* Ast/walk.scm 119 */
							long BgL_res3480z00_5571;

							BgL_res3480z00_5571 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_5));
							BgL_objzd2classzd2numz00_5568 = BgL_res3480z00_5571;
						}
						{	/* Ast/walk.scm 119 */
							obj_t BgL_arg1664z00_5569;

							BgL_arg1664z00_5569 =
								PROCEDURE_REF(BGl_walk1zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 119 */
								int BgL_offsetz00_5573;

								BgL_offsetz00_5573 = (int) (BgL_objzd2classzd2numz00_5568);
								{	/* Ast/walk.scm 119 */
									long BgL_offsetz00_5574;

									BgL_offsetz00_5574 =
										((long) (BgL_offsetz00_5573) - OBJECT_TYPE);
									{	/* Ast/walk.scm 119 */
										long BgL_modz00_5575;

										{	/* Ast/walk.scm 119 */
											int BgL_arg1666z00_5576;

											BgL_arg1666z00_5576 = (int) (((long) 16));
											{	/* Ast/walk.scm 119 */
												long BgL_res3483z00_5586;

												{	/* Ast/walk.scm 119 */
													long BgL_auxz00_8570;

													BgL_auxz00_8570 = (long) (BgL_arg1666z00_5576);
													BgL_res3483z00_5586 =
														(BgL_offsetz00_5574 / BgL_auxz00_8570);
												}
												BgL_modz00_5575 = BgL_res3483z00_5586;
										}}
										{	/* Ast/walk.scm 119 */
											long BgL_restz00_5577;

											{	/* Ast/walk.scm 119 */
												int BgL_arg1665z00_5578;

												BgL_arg1665z00_5578 = (int) (((long) 16));
												{	/* Ast/walk.scm 119 */
													long BgL_res3485z00_5590;

													{	/* Ast/walk.scm 119 */
														long BgL_auxz00_8574;

														BgL_auxz00_8574 = (long) (BgL_arg1665z00_5578);
														BgL_res3485z00_5590 =
															(BgL_offsetz00_5574 % BgL_auxz00_8574);
													}
													BgL_restz00_5577 = BgL_res3485z00_5590;
											}}
											{	/* Ast/walk.scm 119 */

												BgL_res3486z00_5595 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5569,
														(int) (BgL_modz00_5575)), (int) (BgL_restz00_5577));
					}}}}}}}
					BgL_method1596z00_2262 = BgL_res3486z00_5595;
				}
				return
					PROCEDURE_ENTRY(BgL_method1596z00_2262) (BgL_method1596z00_2262,
					((obj_t) BgL_nz00_5), BgL_pz00_6, BgL_arg0z00_7, BEOA);
			}
		}
	}



/* &walk1 */
	obj_t BGl_z62walk1z62zzast_walkz00(obj_t BgL_envz00_6795, obj_t BgL_nz00_6796,
		obj_t BgL_pz00_6797, obj_t BgL_arg0z00_6798)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 119 */
			return
				BGl_walk1z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6796), BgL_pz00_6797, BgL_arg0z00_6798);
		}
	}



/* walk2 */
	BGL_EXPORTED_DEF obj_t BGl_walk2z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_8,
		obj_t BgL_pz00_9, obj_t BgL_arg0z00_10, obj_t BgL_arg1z00_11)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 122 */
			{	/* Ast/walk.scm 122 */
				obj_t BgL_method1598z00_2263;

				{	/* Ast/walk.scm 122 */
					obj_t BgL_res3493z00_5624;

					{	/* Ast/walk.scm 122 */
						long BgL_objzd2classzd2numz00_5597;

						{	/* Ast/walk.scm 122 */
							long BgL_res3487z00_5600;

							BgL_res3487z00_5600 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_8));
							BgL_objzd2classzd2numz00_5597 = BgL_res3487z00_5600;
						}
						{	/* Ast/walk.scm 122 */
							obj_t BgL_arg1664z00_5598;

							BgL_arg1664z00_5598 =
								PROCEDURE_REF(BGl_walk2zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 122 */
								int BgL_offsetz00_5602;

								BgL_offsetz00_5602 = (int) (BgL_objzd2classzd2numz00_5597);
								{	/* Ast/walk.scm 122 */
									long BgL_offsetz00_5603;

									BgL_offsetz00_5603 =
										((long) (BgL_offsetz00_5602) - OBJECT_TYPE);
									{	/* Ast/walk.scm 122 */
										long BgL_modz00_5604;

										{	/* Ast/walk.scm 122 */
											int BgL_arg1666z00_5605;

											BgL_arg1666z00_5605 = (int) (((long) 16));
											{	/* Ast/walk.scm 122 */
												long BgL_res3490z00_5615;

												{	/* Ast/walk.scm 122 */
													long BgL_auxz00_8598;

													BgL_auxz00_8598 = (long) (BgL_arg1666z00_5605);
													BgL_res3490z00_5615 =
														(BgL_offsetz00_5603 / BgL_auxz00_8598);
												}
												BgL_modz00_5604 = BgL_res3490z00_5615;
										}}
										{	/* Ast/walk.scm 122 */
											long BgL_restz00_5606;

											{	/* Ast/walk.scm 122 */
												int BgL_arg1665z00_5607;

												BgL_arg1665z00_5607 = (int) (((long) 16));
												{	/* Ast/walk.scm 122 */
													long BgL_res3492z00_5619;

													{	/* Ast/walk.scm 122 */
														long BgL_auxz00_8602;

														BgL_auxz00_8602 = (long) (BgL_arg1665z00_5607);
														BgL_res3492z00_5619 =
															(BgL_offsetz00_5603 % BgL_auxz00_8602);
													}
													BgL_restz00_5606 = BgL_res3492z00_5619;
											}}
											{	/* Ast/walk.scm 122 */

												BgL_res3493z00_5624 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5598,
														(int) (BgL_modz00_5604)), (int) (BgL_restz00_5606));
					}}}}}}}
					BgL_method1598z00_2263 = BgL_res3493z00_5624;
				}
				return
					PROCEDURE_ENTRY(BgL_method1598z00_2263) (BgL_method1598z00_2263,
					((obj_t) BgL_nz00_8), BgL_pz00_9, BgL_arg0z00_10, BgL_arg1z00_11,
					BEOA);
			}
		}
	}



/* &walk2 */
	obj_t BGl_z62walk2z62zzast_walkz00(obj_t BgL_envz00_6799, obj_t BgL_nz00_6800,
		obj_t BgL_pz00_6801, obj_t BgL_arg0z00_6802, obj_t BgL_arg1z00_6803)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 122 */
			return
				BGl_walk2z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6800), BgL_pz00_6801, BgL_arg0z00_6802,
				BgL_arg1z00_6803);
		}
	}



/* walk3 */
	BGL_EXPORTED_DEF obj_t BGl_walk3z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_12,
		obj_t BgL_pz00_13, obj_t BgL_arg0z00_14, obj_t BgL_arg1z00_15,
		obj_t BgL_arg2z00_16)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 125 */
			{	/* Ast/walk.scm 125 */
				obj_t BgL_method1600z00_2264;

				{	/* Ast/walk.scm 125 */
					obj_t BgL_res3500z00_5653;

					{	/* Ast/walk.scm 125 */
						long BgL_objzd2classzd2numz00_5626;

						{	/* Ast/walk.scm 125 */
							long BgL_res3494z00_5629;

							BgL_res3494z00_5629 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_12));
							BgL_objzd2classzd2numz00_5626 = BgL_res3494z00_5629;
						}
						{	/* Ast/walk.scm 125 */
							obj_t BgL_arg1664z00_5627;

							BgL_arg1664z00_5627 =
								PROCEDURE_REF(BGl_walk3zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 125 */
								int BgL_offsetz00_5631;

								BgL_offsetz00_5631 = (int) (BgL_objzd2classzd2numz00_5626);
								{	/* Ast/walk.scm 125 */
									long BgL_offsetz00_5632;

									BgL_offsetz00_5632 =
										((long) (BgL_offsetz00_5631) - OBJECT_TYPE);
									{	/* Ast/walk.scm 125 */
										long BgL_modz00_5633;

										{	/* Ast/walk.scm 125 */
											int BgL_arg1666z00_5634;

											BgL_arg1666z00_5634 = (int) (((long) 16));
											{	/* Ast/walk.scm 125 */
												long BgL_res3497z00_5644;

												{	/* Ast/walk.scm 125 */
													long BgL_auxz00_8627;

													BgL_auxz00_8627 = (long) (BgL_arg1666z00_5634);
													BgL_res3497z00_5644 =
														(BgL_offsetz00_5632 / BgL_auxz00_8627);
												}
												BgL_modz00_5633 = BgL_res3497z00_5644;
										}}
										{	/* Ast/walk.scm 125 */
											long BgL_restz00_5635;

											{	/* Ast/walk.scm 125 */
												int BgL_arg1665z00_5636;

												BgL_arg1665z00_5636 = (int) (((long) 16));
												{	/* Ast/walk.scm 125 */
													long BgL_res3499z00_5648;

													{	/* Ast/walk.scm 125 */
														long BgL_auxz00_8631;

														BgL_auxz00_8631 = (long) (BgL_arg1665z00_5636);
														BgL_res3499z00_5648 =
															(BgL_offsetz00_5632 % BgL_auxz00_8631);
													}
													BgL_restz00_5635 = BgL_res3499z00_5648;
											}}
											{	/* Ast/walk.scm 125 */

												BgL_res3500z00_5653 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5627,
														(int) (BgL_modz00_5633)), (int) (BgL_restz00_5635));
					}}}}}}}
					BgL_method1600z00_2264 = BgL_res3500z00_5653;
				}
				return
					PROCEDURE_ENTRY(BgL_method1600z00_2264) (BgL_method1600z00_2264,
					((obj_t) BgL_nz00_12), BgL_pz00_13, BgL_arg0z00_14, BgL_arg1z00_15,
					BgL_arg2z00_16, BEOA);
			}
		}
	}



/* &walk3 */
	obj_t BGl_z62walk3z62zzast_walkz00(obj_t BgL_envz00_6804, obj_t BgL_nz00_6805,
		obj_t BgL_pz00_6806, obj_t BgL_arg0z00_6807, obj_t BgL_arg1z00_6808,
		obj_t BgL_arg2z00_6809)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 125 */
			return
				BGl_walk3z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6805), BgL_pz00_6806, BgL_arg0z00_6807,
				BgL_arg1z00_6808, BgL_arg2z00_6809);
		}
	}



/* walk4 */
	BGL_EXPORTED_DEF obj_t BGl_walk4z00zzast_walkz00(BgL_nodez00_bglt BgL_nz00_17,
		obj_t BgL_pz00_18, obj_t BgL_arg0z00_19, obj_t BgL_arg1z00_20,
		obj_t BgL_arg2z00_21, obj_t BgL_arg3z00_22)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 128 */
			{	/* Ast/walk.scm 128 */
				obj_t BgL_method1602z00_2265;

				{	/* Ast/walk.scm 128 */
					obj_t BgL_res3507z00_5682;

					{	/* Ast/walk.scm 128 */
						long BgL_objzd2classzd2numz00_5655;

						{	/* Ast/walk.scm 128 */
							long BgL_res3501z00_5658;

							BgL_res3501z00_5658 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_17));
							BgL_objzd2classzd2numz00_5655 = BgL_res3501z00_5658;
						}
						{	/* Ast/walk.scm 128 */
							obj_t BgL_arg1664z00_5656;

							BgL_arg1664z00_5656 =
								PROCEDURE_REF(BGl_walk4zd2envzd2zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 128 */
								int BgL_offsetz00_5660;

								BgL_offsetz00_5660 = (int) (BgL_objzd2classzd2numz00_5655);
								{	/* Ast/walk.scm 128 */
									long BgL_offsetz00_5661;

									BgL_offsetz00_5661 =
										((long) (BgL_offsetz00_5660) - OBJECT_TYPE);
									{	/* Ast/walk.scm 128 */
										long BgL_modz00_5662;

										{	/* Ast/walk.scm 128 */
											int BgL_arg1666z00_5663;

											BgL_arg1666z00_5663 = (int) (((long) 16));
											{	/* Ast/walk.scm 128 */
												long BgL_res3504z00_5673;

												{	/* Ast/walk.scm 128 */
													long BgL_auxz00_8657;

													BgL_auxz00_8657 = (long) (BgL_arg1666z00_5663);
													BgL_res3504z00_5673 =
														(BgL_offsetz00_5661 / BgL_auxz00_8657);
												}
												BgL_modz00_5662 = BgL_res3504z00_5673;
										}}
										{	/* Ast/walk.scm 128 */
											long BgL_restz00_5664;

											{	/* Ast/walk.scm 128 */
												int BgL_arg1665z00_5665;

												BgL_arg1665z00_5665 = (int) (((long) 16));
												{	/* Ast/walk.scm 128 */
													long BgL_res3506z00_5677;

													{	/* Ast/walk.scm 128 */
														long BgL_auxz00_8661;

														BgL_auxz00_8661 = (long) (BgL_arg1665z00_5665);
														BgL_res3506z00_5677 =
															(BgL_offsetz00_5661 % BgL_auxz00_8661);
													}
													BgL_restz00_5664 = BgL_res3506z00_5677;
											}}
											{	/* Ast/walk.scm 128 */

												BgL_res3507z00_5682 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5656,
														(int) (BgL_modz00_5662)), (int) (BgL_restz00_5664));
					}}}}}}}
					BgL_method1602z00_2265 = BgL_res3507z00_5682;
				}
				return
					PROCEDURE_ENTRY(BgL_method1602z00_2265) (BgL_method1602z00_2265,
					((obj_t) BgL_nz00_17), BgL_pz00_18, BgL_arg0z00_19, BgL_arg1z00_20,
					BgL_arg2z00_21, BgL_arg3z00_22, BEOA);
			}
		}
	}



/* &walk4 */
	obj_t BGl_z62walk4z62zzast_walkz00(obj_t BgL_envz00_6810, obj_t BgL_nz00_6811,
		obj_t BgL_pz00_6812, obj_t BgL_arg0z00_6813, obj_t BgL_arg1z00_6814,
		obj_t BgL_arg2z00_6815, obj_t BgL_arg3z00_6816)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 128 */
			return
				BGl_walk4z00zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6811), BgL_pz00_6812, BgL_arg0z00_6813,
				BgL_arg1z00_6814, BgL_arg2z00_6815, BgL_arg3z00_6816);
		}
	}



/* walk0* */
	BGL_EXPORTED_DEF obj_t BGl_walk0za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_23, obj_t BgL_pz00_24)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 132 */
			{	/* Ast/walk.scm 132 */
				obj_t BgL_method1604z00_2266;

				{	/* Ast/walk.scm 132 */
					obj_t BgL_res3514z00_5711;

					{	/* Ast/walk.scm 132 */
						long BgL_objzd2classzd2numz00_5684;

						{	/* Ast/walk.scm 132 */
							long BgL_res3508z00_5687;

							BgL_res3508z00_5687 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_23));
							BgL_objzd2classzd2numz00_5684 = BgL_res3508z00_5687;
						}
						{	/* Ast/walk.scm 132 */
							obj_t BgL_arg1664z00_5685;

							BgL_arg1664z00_5685 =
								PROCEDURE_REF(BGl_walk0za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 132 */
								int BgL_offsetz00_5689;

								BgL_offsetz00_5689 = (int) (BgL_objzd2classzd2numz00_5684);
								{	/* Ast/walk.scm 132 */
									long BgL_offsetz00_5690;

									BgL_offsetz00_5690 =
										((long) (BgL_offsetz00_5689) - OBJECT_TYPE);
									{	/* Ast/walk.scm 132 */
										long BgL_modz00_5691;

										{	/* Ast/walk.scm 132 */
											int BgL_arg1666z00_5692;

											BgL_arg1666z00_5692 = (int) (((long) 16));
											{	/* Ast/walk.scm 132 */
												long BgL_res3511z00_5702;

												{	/* Ast/walk.scm 132 */
													long BgL_auxz00_8688;

													BgL_auxz00_8688 = (long) (BgL_arg1666z00_5692);
													BgL_res3511z00_5702 =
														(BgL_offsetz00_5690 / BgL_auxz00_8688);
												}
												BgL_modz00_5691 = BgL_res3511z00_5702;
										}}
										{	/* Ast/walk.scm 132 */
											long BgL_restz00_5693;

											{	/* Ast/walk.scm 132 */
												int BgL_arg1665z00_5694;

												BgL_arg1665z00_5694 = (int) (((long) 16));
												{	/* Ast/walk.scm 132 */
													long BgL_res3513z00_5706;

													{	/* Ast/walk.scm 132 */
														long BgL_auxz00_8692;

														BgL_auxz00_8692 = (long) (BgL_arg1665z00_5694);
														BgL_res3513z00_5706 =
															(BgL_offsetz00_5690 % BgL_auxz00_8692);
													}
													BgL_restz00_5693 = BgL_res3513z00_5706;
											}}
											{	/* Ast/walk.scm 132 */

												BgL_res3514z00_5711 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5685,
														(int) (BgL_modz00_5691)), (int) (BgL_restz00_5693));
					}}}}}}}
					BgL_method1604z00_2266 = BgL_res3514z00_5711;
				}
				return
					PROCEDURE_ENTRY(BgL_method1604z00_2266) (BgL_method1604z00_2266,
					((obj_t) BgL_nz00_23), BgL_pz00_24, BEOA);
			}
		}
	}



/* &walk0* */
	obj_t BGl_z62walk0za2zc0zzast_walkz00(obj_t BgL_envz00_6817,
		obj_t BgL_nz00_6818, obj_t BgL_pz00_6819)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 132 */
			return
				BGl_walk0za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6818), BgL_pz00_6819);
		}
	}



/* walk1* */
	BGL_EXPORTED_DEF obj_t BGl_walk1za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_25, obj_t BgL_pz00_26, obj_t BgL_arg0z00_27)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 135 */
			{	/* Ast/walk.scm 135 */
				obj_t BgL_method1606z00_2267;

				{	/* Ast/walk.scm 135 */
					obj_t BgL_res3521z00_5740;

					{	/* Ast/walk.scm 135 */
						long BgL_objzd2classzd2numz00_5713;

						{	/* Ast/walk.scm 135 */
							long BgL_res3515z00_5716;

							BgL_res3515z00_5716 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_25));
							BgL_objzd2classzd2numz00_5713 = BgL_res3515z00_5716;
						}
						{	/* Ast/walk.scm 135 */
							obj_t BgL_arg1664z00_5714;

							BgL_arg1664z00_5714 =
								PROCEDURE_REF(BGl_walk1za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 135 */
								int BgL_offsetz00_5718;

								BgL_offsetz00_5718 = (int) (BgL_objzd2classzd2numz00_5713);
								{	/* Ast/walk.scm 135 */
									long BgL_offsetz00_5719;

									BgL_offsetz00_5719 =
										((long) (BgL_offsetz00_5718) - OBJECT_TYPE);
									{	/* Ast/walk.scm 135 */
										long BgL_modz00_5720;

										{	/* Ast/walk.scm 135 */
											int BgL_arg1666z00_5721;

											BgL_arg1666z00_5721 = (int) (((long) 16));
											{	/* Ast/walk.scm 135 */
												long BgL_res3518z00_5731;

												{	/* Ast/walk.scm 135 */
													long BgL_auxz00_8715;

													BgL_auxz00_8715 = (long) (BgL_arg1666z00_5721);
													BgL_res3518z00_5731 =
														(BgL_offsetz00_5719 / BgL_auxz00_8715);
												}
												BgL_modz00_5720 = BgL_res3518z00_5731;
										}}
										{	/* Ast/walk.scm 135 */
											long BgL_restz00_5722;

											{	/* Ast/walk.scm 135 */
												int BgL_arg1665z00_5723;

												BgL_arg1665z00_5723 = (int) (((long) 16));
												{	/* Ast/walk.scm 135 */
													long BgL_res3520z00_5735;

													{	/* Ast/walk.scm 135 */
														long BgL_auxz00_8719;

														BgL_auxz00_8719 = (long) (BgL_arg1665z00_5723);
														BgL_res3520z00_5735 =
															(BgL_offsetz00_5719 % BgL_auxz00_8719);
													}
													BgL_restz00_5722 = BgL_res3520z00_5735;
											}}
											{	/* Ast/walk.scm 135 */

												BgL_res3521z00_5740 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5714,
														(int) (BgL_modz00_5720)), (int) (BgL_restz00_5722));
					}}}}}}}
					BgL_method1606z00_2267 = BgL_res3521z00_5740;
				}
				return
					PROCEDURE_ENTRY(BgL_method1606z00_2267) (BgL_method1606z00_2267,
					((obj_t) BgL_nz00_25), BgL_pz00_26, BgL_arg0z00_27, BEOA);
			}
		}
	}



/* &walk1* */
	obj_t BGl_z62walk1za2zc0zzast_walkz00(obj_t BgL_envz00_6820,
		obj_t BgL_nz00_6821, obj_t BgL_pz00_6822, obj_t BgL_arg0z00_6823)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 135 */
			return
				BGl_walk1za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6821), BgL_pz00_6822, BgL_arg0z00_6823);
		}
	}



/* walk2* */
	BGL_EXPORTED_DEF obj_t BGl_walk2za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_28, obj_t BgL_pz00_29, obj_t BgL_arg0z00_30, obj_t BgL_arg1z00_31)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 138 */
			{	/* Ast/walk.scm 138 */
				obj_t BgL_method1608z00_2268;

				{	/* Ast/walk.scm 138 */
					obj_t BgL_res3528z00_5769;

					{	/* Ast/walk.scm 138 */
						long BgL_objzd2classzd2numz00_5742;

						{	/* Ast/walk.scm 138 */
							long BgL_res3522z00_5745;

							BgL_res3522z00_5745 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_28));
							BgL_objzd2classzd2numz00_5742 = BgL_res3522z00_5745;
						}
						{	/* Ast/walk.scm 138 */
							obj_t BgL_arg1664z00_5743;

							BgL_arg1664z00_5743 =
								PROCEDURE_REF(BGl_walk2za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 138 */
								int BgL_offsetz00_5747;

								BgL_offsetz00_5747 = (int) (BgL_objzd2classzd2numz00_5742);
								{	/* Ast/walk.scm 138 */
									long BgL_offsetz00_5748;

									BgL_offsetz00_5748 =
										((long) (BgL_offsetz00_5747) - OBJECT_TYPE);
									{	/* Ast/walk.scm 138 */
										long BgL_modz00_5749;

										{	/* Ast/walk.scm 138 */
											int BgL_arg1666z00_5750;

											BgL_arg1666z00_5750 = (int) (((long) 16));
											{	/* Ast/walk.scm 138 */
												long BgL_res3525z00_5760;

												{	/* Ast/walk.scm 138 */
													long BgL_auxz00_8743;

													BgL_auxz00_8743 = (long) (BgL_arg1666z00_5750);
													BgL_res3525z00_5760 =
														(BgL_offsetz00_5748 / BgL_auxz00_8743);
												}
												BgL_modz00_5749 = BgL_res3525z00_5760;
										}}
										{	/* Ast/walk.scm 138 */
											long BgL_restz00_5751;

											{	/* Ast/walk.scm 138 */
												int BgL_arg1665z00_5752;

												BgL_arg1665z00_5752 = (int) (((long) 16));
												{	/* Ast/walk.scm 138 */
													long BgL_res3527z00_5764;

													{	/* Ast/walk.scm 138 */
														long BgL_auxz00_8747;

														BgL_auxz00_8747 = (long) (BgL_arg1665z00_5752);
														BgL_res3527z00_5764 =
															(BgL_offsetz00_5748 % BgL_auxz00_8747);
													}
													BgL_restz00_5751 = BgL_res3527z00_5764;
											}}
											{	/* Ast/walk.scm 138 */

												BgL_res3528z00_5769 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5743,
														(int) (BgL_modz00_5749)), (int) (BgL_restz00_5751));
					}}}}}}}
					BgL_method1608z00_2268 = BgL_res3528z00_5769;
				}
				return
					PROCEDURE_ENTRY(BgL_method1608z00_2268) (BgL_method1608z00_2268,
					((obj_t) BgL_nz00_28), BgL_pz00_29, BgL_arg0z00_30, BgL_arg1z00_31,
					BEOA);
			}
		}
	}



/* &walk2* */
	obj_t BGl_z62walk2za2zc0zzast_walkz00(obj_t BgL_envz00_6824,
		obj_t BgL_nz00_6825, obj_t BgL_pz00_6826, obj_t BgL_arg0z00_6827,
		obj_t BgL_arg1z00_6828)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 138 */
			return
				BGl_walk2za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6825), BgL_pz00_6826, BgL_arg0z00_6827,
				BgL_arg1z00_6828);
		}
	}



/* walk3* */
	BGL_EXPORTED_DEF obj_t BGl_walk3za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_32, obj_t BgL_pz00_33, obj_t BgL_arg0z00_34, obj_t BgL_arg1z00_35,
		obj_t BgL_arg2z00_36)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 141 */
			{	/* Ast/walk.scm 141 */
				obj_t BgL_method1610z00_2269;

				{	/* Ast/walk.scm 141 */
					obj_t BgL_res3535z00_5798;

					{	/* Ast/walk.scm 141 */
						long BgL_objzd2classzd2numz00_5771;

						{	/* Ast/walk.scm 141 */
							long BgL_res3529z00_5774;

							BgL_res3529z00_5774 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_32));
							BgL_objzd2classzd2numz00_5771 = BgL_res3529z00_5774;
						}
						{	/* Ast/walk.scm 141 */
							obj_t BgL_arg1664z00_5772;

							BgL_arg1664z00_5772 =
								PROCEDURE_REF(BGl_walk3za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 141 */
								int BgL_offsetz00_5776;

								BgL_offsetz00_5776 = (int) (BgL_objzd2classzd2numz00_5771);
								{	/* Ast/walk.scm 141 */
									long BgL_offsetz00_5777;

									BgL_offsetz00_5777 =
										((long) (BgL_offsetz00_5776) - OBJECT_TYPE);
									{	/* Ast/walk.scm 141 */
										long BgL_modz00_5778;

										{	/* Ast/walk.scm 141 */
											int BgL_arg1666z00_5779;

											BgL_arg1666z00_5779 = (int) (((long) 16));
											{	/* Ast/walk.scm 141 */
												long BgL_res3532z00_5789;

												{	/* Ast/walk.scm 141 */
													long BgL_auxz00_8772;

													BgL_auxz00_8772 = (long) (BgL_arg1666z00_5779);
													BgL_res3532z00_5789 =
														(BgL_offsetz00_5777 / BgL_auxz00_8772);
												}
												BgL_modz00_5778 = BgL_res3532z00_5789;
										}}
										{	/* Ast/walk.scm 141 */
											long BgL_restz00_5780;

											{	/* Ast/walk.scm 141 */
												int BgL_arg1665z00_5781;

												BgL_arg1665z00_5781 = (int) (((long) 16));
												{	/* Ast/walk.scm 141 */
													long BgL_res3534z00_5793;

													{	/* Ast/walk.scm 141 */
														long BgL_auxz00_8776;

														BgL_auxz00_8776 = (long) (BgL_arg1665z00_5781);
														BgL_res3534z00_5793 =
															(BgL_offsetz00_5777 % BgL_auxz00_8776);
													}
													BgL_restz00_5780 = BgL_res3534z00_5793;
											}}
											{	/* Ast/walk.scm 141 */

												BgL_res3535z00_5798 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5772,
														(int) (BgL_modz00_5778)), (int) (BgL_restz00_5780));
					}}}}}}}
					BgL_method1610z00_2269 = BgL_res3535z00_5798;
				}
				return
					PROCEDURE_ENTRY(BgL_method1610z00_2269) (BgL_method1610z00_2269,
					((obj_t) BgL_nz00_32), BgL_pz00_33, BgL_arg0z00_34, BgL_arg1z00_35,
					BgL_arg2z00_36, BEOA);
			}
		}
	}



/* &walk3* */
	obj_t BGl_z62walk3za2zc0zzast_walkz00(obj_t BgL_envz00_6829,
		obj_t BgL_nz00_6830, obj_t BgL_pz00_6831, obj_t BgL_arg0z00_6832,
		obj_t BgL_arg1z00_6833, obj_t BgL_arg2z00_6834)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 141 */
			return
				BGl_walk3za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6830), BgL_pz00_6831, BgL_arg0z00_6832,
				BgL_arg1z00_6833, BgL_arg2z00_6834);
		}
	}



/* walk4* */
	BGL_EXPORTED_DEF obj_t BGl_walk4za2za2zzast_walkz00(BgL_nodez00_bglt
		BgL_nz00_37, obj_t BgL_pz00_38, obj_t BgL_arg0z00_39, obj_t BgL_arg1z00_40,
		obj_t BgL_arg2z00_41, obj_t BgL_arg3z00_42)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 144 */
			{	/* Ast/walk.scm 144 */
				obj_t BgL_method1612z00_2270;

				{	/* Ast/walk.scm 144 */
					obj_t BgL_res3542z00_5827;

					{	/* Ast/walk.scm 144 */
						long BgL_objzd2classzd2numz00_5800;

						{	/* Ast/walk.scm 144 */
							long BgL_res3536z00_5803;

							BgL_res3536z00_5803 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_37));
							BgL_objzd2classzd2numz00_5800 = BgL_res3536z00_5803;
						}
						{	/* Ast/walk.scm 144 */
							obj_t BgL_arg1664z00_5801;

							BgL_arg1664z00_5801 =
								PROCEDURE_REF(BGl_walk4za2zd2envz70zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 144 */
								int BgL_offsetz00_5805;

								BgL_offsetz00_5805 = (int) (BgL_objzd2classzd2numz00_5800);
								{	/* Ast/walk.scm 144 */
									long BgL_offsetz00_5806;

									BgL_offsetz00_5806 =
										((long) (BgL_offsetz00_5805) - OBJECT_TYPE);
									{	/* Ast/walk.scm 144 */
										long BgL_modz00_5807;

										{	/* Ast/walk.scm 144 */
											int BgL_arg1666z00_5808;

											BgL_arg1666z00_5808 = (int) (((long) 16));
											{	/* Ast/walk.scm 144 */
												long BgL_res3539z00_5818;

												{	/* Ast/walk.scm 144 */
													long BgL_auxz00_8802;

													BgL_auxz00_8802 = (long) (BgL_arg1666z00_5808);
													BgL_res3539z00_5818 =
														(BgL_offsetz00_5806 / BgL_auxz00_8802);
												}
												BgL_modz00_5807 = BgL_res3539z00_5818;
										}}
										{	/* Ast/walk.scm 144 */
											long BgL_restz00_5809;

											{	/* Ast/walk.scm 144 */
												int BgL_arg1665z00_5810;

												BgL_arg1665z00_5810 = (int) (((long) 16));
												{	/* Ast/walk.scm 144 */
													long BgL_res3541z00_5822;

													{	/* Ast/walk.scm 144 */
														long BgL_auxz00_8806;

														BgL_auxz00_8806 = (long) (BgL_arg1665z00_5810);
														BgL_res3541z00_5822 =
															(BgL_offsetz00_5806 % BgL_auxz00_8806);
													}
													BgL_restz00_5809 = BgL_res3541z00_5822;
											}}
											{	/* Ast/walk.scm 144 */

												BgL_res3542z00_5827 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5801,
														(int) (BgL_modz00_5807)), (int) (BgL_restz00_5809));
					}}}}}}}
					BgL_method1612z00_2270 = BgL_res3542z00_5827;
				}
				return
					PROCEDURE_ENTRY(BgL_method1612z00_2270) (BgL_method1612z00_2270,
					((obj_t) BgL_nz00_37), BgL_pz00_38, BgL_arg0z00_39, BgL_arg1z00_40,
					BgL_arg2z00_41, BgL_arg3z00_42, BEOA);
			}
		}
	}



/* &walk4* */
	obj_t BGl_z62walk4za2zc0zzast_walkz00(obj_t BgL_envz00_6835,
		obj_t BgL_nz00_6836, obj_t BgL_pz00_6837, obj_t BgL_arg0z00_6838,
		obj_t BgL_arg1z00_6839, obj_t BgL_arg2z00_6840, obj_t BgL_arg3z00_6841)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 144 */
			return
				BGl_walk4za2za2zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6836), BgL_pz00_6837, BgL_arg0z00_6838,
				BgL_arg1z00_6839, BgL_arg2z00_6840, BgL_arg3z00_6841);
		}
	}



/* walk0! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk0z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_43,
		obj_t BgL_pz00_44)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 148 */
			{	/* Ast/walk.scm 148 */
				obj_t BgL_method1614z00_2271;

				{	/* Ast/walk.scm 148 */
					obj_t BgL_res3549z00_5856;

					{	/* Ast/walk.scm 148 */
						long BgL_objzd2classzd2numz00_5829;

						{	/* Ast/walk.scm 148 */
							long BgL_res3543z00_5832;

							BgL_res3543z00_5832 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_43));
							BgL_objzd2classzd2numz00_5829 = BgL_res3543z00_5832;
						}
						{	/* Ast/walk.scm 148 */
							obj_t BgL_arg1664z00_5830;

							BgL_arg1664z00_5830 =
								PROCEDURE_REF(BGl_walk0z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 148 */
								int BgL_offsetz00_5834;

								BgL_offsetz00_5834 = (int) (BgL_objzd2classzd2numz00_5829);
								{	/* Ast/walk.scm 148 */
									long BgL_offsetz00_5835;

									BgL_offsetz00_5835 =
										((long) (BgL_offsetz00_5834) - OBJECT_TYPE);
									{	/* Ast/walk.scm 148 */
										long BgL_modz00_5836;

										{	/* Ast/walk.scm 148 */
											int BgL_arg1666z00_5837;

											BgL_arg1666z00_5837 = (int) (((long) 16));
											{	/* Ast/walk.scm 148 */
												long BgL_res3546z00_5847;

												{	/* Ast/walk.scm 148 */
													long BgL_auxz00_8833;

													BgL_auxz00_8833 = (long) (BgL_arg1666z00_5837);
													BgL_res3546z00_5847 =
														(BgL_offsetz00_5835 / BgL_auxz00_8833);
												}
												BgL_modz00_5836 = BgL_res3546z00_5847;
										}}
										{	/* Ast/walk.scm 148 */
											long BgL_restz00_5838;

											{	/* Ast/walk.scm 148 */
												int BgL_arg1665z00_5839;

												BgL_arg1665z00_5839 = (int) (((long) 16));
												{	/* Ast/walk.scm 148 */
													long BgL_res3548z00_5851;

													{	/* Ast/walk.scm 148 */
														long BgL_auxz00_8837;

														BgL_auxz00_8837 = (long) (BgL_arg1665z00_5839);
														BgL_res3548z00_5851 =
															(BgL_offsetz00_5835 % BgL_auxz00_8837);
													}
													BgL_restz00_5838 = BgL_res3548z00_5851;
											}}
											{	/* Ast/walk.scm 148 */

												BgL_res3549z00_5856 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5830,
														(int) (BgL_modz00_5836)), (int) (BgL_restz00_5838));
					}}}}}}}
					BgL_method1614z00_2271 = BgL_res3549z00_5856;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1614z00_2271) (BgL_method1614z00_2271,
						((obj_t) BgL_nz00_43), BgL_pz00_44, BEOA));
			}
		}
	}



/* &walk0! */
	BgL_nodez00_bglt BGl_z62walk0z12z70zzast_walkz00(obj_t BgL_envz00_6842,
		obj_t BgL_nz00_6843, obj_t BgL_pz00_6844)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 148 */
			return
				BGl_walk0z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6843), BgL_pz00_6844);
		}
	}



/* walk1! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk1z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_45,
		obj_t BgL_pz00_46, obj_t BgL_arg0z00_47)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 151 */
			{	/* Ast/walk.scm 151 */
				obj_t BgL_method1616z00_2272;

				{	/* Ast/walk.scm 151 */
					obj_t BgL_res3556z00_5885;

					{	/* Ast/walk.scm 151 */
						long BgL_objzd2classzd2numz00_5858;

						{	/* Ast/walk.scm 151 */
							long BgL_res3550z00_5861;

							BgL_res3550z00_5861 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_45));
							BgL_objzd2classzd2numz00_5858 = BgL_res3550z00_5861;
						}
						{	/* Ast/walk.scm 151 */
							obj_t BgL_arg1664z00_5859;

							BgL_arg1664z00_5859 =
								PROCEDURE_REF(BGl_walk1z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 151 */
								int BgL_offsetz00_5863;

								BgL_offsetz00_5863 = (int) (BgL_objzd2classzd2numz00_5858);
								{	/* Ast/walk.scm 151 */
									long BgL_offsetz00_5864;

									BgL_offsetz00_5864 =
										((long) (BgL_offsetz00_5863) - OBJECT_TYPE);
									{	/* Ast/walk.scm 151 */
										long BgL_modz00_5865;

										{	/* Ast/walk.scm 151 */
											int BgL_arg1666z00_5866;

											BgL_arg1666z00_5866 = (int) (((long) 16));
											{	/* Ast/walk.scm 151 */
												long BgL_res3553z00_5876;

												{	/* Ast/walk.scm 151 */
													long BgL_auxz00_8861;

													BgL_auxz00_8861 = (long) (BgL_arg1666z00_5866);
													BgL_res3553z00_5876 =
														(BgL_offsetz00_5864 / BgL_auxz00_8861);
												}
												BgL_modz00_5865 = BgL_res3553z00_5876;
										}}
										{	/* Ast/walk.scm 151 */
											long BgL_restz00_5867;

											{	/* Ast/walk.scm 151 */
												int BgL_arg1665z00_5868;

												BgL_arg1665z00_5868 = (int) (((long) 16));
												{	/* Ast/walk.scm 151 */
													long BgL_res3555z00_5880;

													{	/* Ast/walk.scm 151 */
														long BgL_auxz00_8865;

														BgL_auxz00_8865 = (long) (BgL_arg1665z00_5868);
														BgL_res3555z00_5880 =
															(BgL_offsetz00_5864 % BgL_auxz00_8865);
													}
													BgL_restz00_5867 = BgL_res3555z00_5880;
											}}
											{	/* Ast/walk.scm 151 */

												BgL_res3556z00_5885 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5859,
														(int) (BgL_modz00_5865)), (int) (BgL_restz00_5867));
					}}}}}}}
					BgL_method1616z00_2272 = BgL_res3556z00_5885;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1616z00_2272) (BgL_method1616z00_2272,
						((obj_t) BgL_nz00_45), BgL_pz00_46, BgL_arg0z00_47, BEOA));
			}
		}
	}



/* &walk1! */
	BgL_nodez00_bglt BGl_z62walk1z12z70zzast_walkz00(obj_t BgL_envz00_6845,
		obj_t BgL_nz00_6846, obj_t BgL_pz00_6847, obj_t BgL_arg0z00_6848)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 151 */
			return
				BGl_walk1z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6846), BgL_pz00_6847, BgL_arg0z00_6848);
		}
	}



/* walk2! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk2z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_48,
		obj_t BgL_pz00_49, obj_t BgL_arg0z00_50, obj_t BgL_arg1z00_51)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 154 */
			{	/* Ast/walk.scm 154 */
				obj_t BgL_method1618z00_2273;

				{	/* Ast/walk.scm 154 */
					obj_t BgL_res3563z00_5914;

					{	/* Ast/walk.scm 154 */
						long BgL_objzd2classzd2numz00_5887;

						{	/* Ast/walk.scm 154 */
							long BgL_res3557z00_5890;

							BgL_res3557z00_5890 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_48));
							BgL_objzd2classzd2numz00_5887 = BgL_res3557z00_5890;
						}
						{	/* Ast/walk.scm 154 */
							obj_t BgL_arg1664z00_5888;

							BgL_arg1664z00_5888 =
								PROCEDURE_REF(BGl_walk2z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 154 */
								int BgL_offsetz00_5892;

								BgL_offsetz00_5892 = (int) (BgL_objzd2classzd2numz00_5887);
								{	/* Ast/walk.scm 154 */
									long BgL_offsetz00_5893;

									BgL_offsetz00_5893 =
										((long) (BgL_offsetz00_5892) - OBJECT_TYPE);
									{	/* Ast/walk.scm 154 */
										long BgL_modz00_5894;

										{	/* Ast/walk.scm 154 */
											int BgL_arg1666z00_5895;

											BgL_arg1666z00_5895 = (int) (((long) 16));
											{	/* Ast/walk.scm 154 */
												long BgL_res3560z00_5905;

												{	/* Ast/walk.scm 154 */
													long BgL_auxz00_8890;

													BgL_auxz00_8890 = (long) (BgL_arg1666z00_5895);
													BgL_res3560z00_5905 =
														(BgL_offsetz00_5893 / BgL_auxz00_8890);
												}
												BgL_modz00_5894 = BgL_res3560z00_5905;
										}}
										{	/* Ast/walk.scm 154 */
											long BgL_restz00_5896;

											{	/* Ast/walk.scm 154 */
												int BgL_arg1665z00_5897;

												BgL_arg1665z00_5897 = (int) (((long) 16));
												{	/* Ast/walk.scm 154 */
													long BgL_res3562z00_5909;

													{	/* Ast/walk.scm 154 */
														long BgL_auxz00_8894;

														BgL_auxz00_8894 = (long) (BgL_arg1665z00_5897);
														BgL_res3562z00_5909 =
															(BgL_offsetz00_5893 % BgL_auxz00_8894);
													}
													BgL_restz00_5896 = BgL_res3562z00_5909;
											}}
											{	/* Ast/walk.scm 154 */

												BgL_res3563z00_5914 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5888,
														(int) (BgL_modz00_5894)), (int) (BgL_restz00_5896));
					}}}}}}}
					BgL_method1618z00_2273 = BgL_res3563z00_5914;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1618z00_2273) (BgL_method1618z00_2273,
						((obj_t) BgL_nz00_48), BgL_pz00_49, BgL_arg0z00_50, BgL_arg1z00_51,
						BEOA));
			}
		}
	}



/* &walk2! */
	BgL_nodez00_bglt BGl_z62walk2z12z70zzast_walkz00(obj_t BgL_envz00_6849,
		obj_t BgL_nz00_6850, obj_t BgL_pz00_6851, obj_t BgL_arg0z00_6852,
		obj_t BgL_arg1z00_6853)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 154 */
			return
				BGl_walk2z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6850), BgL_pz00_6851, BgL_arg0z00_6852,
				BgL_arg1z00_6853);
		}
	}



/* walk3! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk3z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_52,
		obj_t BgL_pz00_53, obj_t BgL_arg0z00_54, obj_t BgL_arg1z00_55,
		obj_t BgL_arg2z00_56)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 157 */
			{	/* Ast/walk.scm 157 */
				obj_t BgL_method1620z00_2274;

				{	/* Ast/walk.scm 157 */
					obj_t BgL_res3570z00_5943;

					{	/* Ast/walk.scm 157 */
						long BgL_objzd2classzd2numz00_5916;

						{	/* Ast/walk.scm 157 */
							long BgL_res3564z00_5919;

							BgL_res3564z00_5919 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_52));
							BgL_objzd2classzd2numz00_5916 = BgL_res3564z00_5919;
						}
						{	/* Ast/walk.scm 157 */
							obj_t BgL_arg1664z00_5917;

							BgL_arg1664z00_5917 =
								PROCEDURE_REF(BGl_walk3z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 157 */
								int BgL_offsetz00_5921;

								BgL_offsetz00_5921 = (int) (BgL_objzd2classzd2numz00_5916);
								{	/* Ast/walk.scm 157 */
									long BgL_offsetz00_5922;

									BgL_offsetz00_5922 =
										((long) (BgL_offsetz00_5921) - OBJECT_TYPE);
									{	/* Ast/walk.scm 157 */
										long BgL_modz00_5923;

										{	/* Ast/walk.scm 157 */
											int BgL_arg1666z00_5924;

											BgL_arg1666z00_5924 = (int) (((long) 16));
											{	/* Ast/walk.scm 157 */
												long BgL_res3567z00_5934;

												{	/* Ast/walk.scm 157 */
													long BgL_auxz00_8920;

													BgL_auxz00_8920 = (long) (BgL_arg1666z00_5924);
													BgL_res3567z00_5934 =
														(BgL_offsetz00_5922 / BgL_auxz00_8920);
												}
												BgL_modz00_5923 = BgL_res3567z00_5934;
										}}
										{	/* Ast/walk.scm 157 */
											long BgL_restz00_5925;

											{	/* Ast/walk.scm 157 */
												int BgL_arg1665z00_5926;

												BgL_arg1665z00_5926 = (int) (((long) 16));
												{	/* Ast/walk.scm 157 */
													long BgL_res3569z00_5938;

													{	/* Ast/walk.scm 157 */
														long BgL_auxz00_8924;

														BgL_auxz00_8924 = (long) (BgL_arg1665z00_5926);
														BgL_res3569z00_5938 =
															(BgL_offsetz00_5922 % BgL_auxz00_8924);
													}
													BgL_restz00_5925 = BgL_res3569z00_5938;
											}}
											{	/* Ast/walk.scm 157 */

												BgL_res3570z00_5943 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5917,
														(int) (BgL_modz00_5923)), (int) (BgL_restz00_5925));
					}}}}}}}
					BgL_method1620z00_2274 = BgL_res3570z00_5943;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1620z00_2274) (BgL_method1620z00_2274,
						((obj_t) BgL_nz00_52), BgL_pz00_53, BgL_arg0z00_54, BgL_arg1z00_55,
						BgL_arg2z00_56, BEOA));
			}
		}
	}



/* &walk3! */
	BgL_nodez00_bglt BGl_z62walk3z12z70zzast_walkz00(obj_t BgL_envz00_6854,
		obj_t BgL_nz00_6855, obj_t BgL_pz00_6856, obj_t BgL_arg0z00_6857,
		obj_t BgL_arg1z00_6858, obj_t BgL_arg2z00_6859)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 157 */
			return
				BGl_walk3z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6855), BgL_pz00_6856, BgL_arg0z00_6857,
				BgL_arg1z00_6858, BgL_arg2z00_6859);
		}
	}



/* walk4! */
	BGL_EXPORTED_DEF BgL_nodez00_bglt
		BGl_walk4z12z12zzast_walkz00(BgL_nodez00_bglt BgL_nz00_57,
		obj_t BgL_pz00_58, obj_t BgL_arg0z00_59, obj_t BgL_arg1z00_60,
		obj_t BgL_arg2z00_61, obj_t BgL_arg3z00_62)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 160 */
			{	/* Ast/walk.scm 160 */
				obj_t BgL_method1622z00_2275;

				{	/* Ast/walk.scm 160 */
					obj_t BgL_res3577z00_5972;

					{	/* Ast/walk.scm 160 */
						long BgL_objzd2classzd2numz00_5945;

						{	/* Ast/walk.scm 160 */
							long BgL_res3571z00_5948;

							BgL_res3571z00_5948 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nz00_57));
							BgL_objzd2classzd2numz00_5945 = BgL_res3571z00_5948;
						}
						{	/* Ast/walk.scm 160 */
							obj_t BgL_arg1664z00_5946;

							BgL_arg1664z00_5946 =
								PROCEDURE_REF(BGl_walk4z12zd2envzc0zzast_walkz00,
								(int) (((long) 1)));
							{	/* Ast/walk.scm 160 */
								int BgL_offsetz00_5950;

								BgL_offsetz00_5950 = (int) (BgL_objzd2classzd2numz00_5945);
								{	/* Ast/walk.scm 160 */
									long BgL_offsetz00_5951;

									BgL_offsetz00_5951 =
										((long) (BgL_offsetz00_5950) - OBJECT_TYPE);
									{	/* Ast/walk.scm 160 */
										long BgL_modz00_5952;

										{	/* Ast/walk.scm 160 */
											int BgL_arg1666z00_5953;

											BgL_arg1666z00_5953 = (int) (((long) 16));
											{	/* Ast/walk.scm 160 */
												long BgL_res3574z00_5963;

												{	/* Ast/walk.scm 160 */
													long BgL_auxz00_8951;

													BgL_auxz00_8951 = (long) (BgL_arg1666z00_5953);
													BgL_res3574z00_5963 =
														(BgL_offsetz00_5951 / BgL_auxz00_8951);
												}
												BgL_modz00_5952 = BgL_res3574z00_5963;
										}}
										{	/* Ast/walk.scm 160 */
											long BgL_restz00_5954;

											{	/* Ast/walk.scm 160 */
												int BgL_arg1665z00_5955;

												BgL_arg1665z00_5955 = (int) (((long) 16));
												{	/* Ast/walk.scm 160 */
													long BgL_res3576z00_5967;

													{	/* Ast/walk.scm 160 */
														long BgL_auxz00_8955;

														BgL_auxz00_8955 = (long) (BgL_arg1665z00_5955);
														BgL_res3576z00_5967 =
															(BgL_offsetz00_5951 % BgL_auxz00_8955);
													}
													BgL_restz00_5954 = BgL_res3576z00_5967;
											}}
											{	/* Ast/walk.scm 160 */

												BgL_res3577z00_5972 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_5946,
														(int) (BgL_modz00_5952)), (int) (BgL_restz00_5954));
					}}}}}}}
					BgL_method1622z00_2275 = BgL_res3577z00_5972;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1622z00_2275) (BgL_method1622z00_2275,
						((obj_t) BgL_nz00_57), BgL_pz00_58, BgL_arg0z00_59, BgL_arg1z00_60,
						BgL_arg2z00_61, BgL_arg3z00_62, BEOA));
			}
		}
	}



/* &walk4! */
	BgL_nodez00_bglt BGl_z62walk4z12z70zzast_walkz00(obj_t BgL_envz00_6860,
		obj_t BgL_nz00_6861, obj_t BgL_pz00_6862, obj_t BgL_arg0z00_6863,
		obj_t BgL_arg1z00_6864, obj_t BgL_arg2z00_6865, obj_t BgL_arg3z00_6866)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 160 */
			return
				BGl_walk4z12z12zzast_walkz00(
				((BgL_nodez00_bglt) BgL_nz00_6861), BgL_pz00_6862, BgL_arg0z00_6863,
				BgL_arg1z00_6864, BgL_arg2z00_6865, BgL_arg3z00_6866);
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzast_walkz00()
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3707z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3708z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3709z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3710z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3711z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3712z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3713z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3714z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3715z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3716z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3717z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_nodez00zzast_nodez00,
				BGl_proc3718z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3719z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3720z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3721z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3722z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3723z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3724z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3725z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3726z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3727z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3728z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3729z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc3730z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3731z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3732z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3733z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3734z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3735z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3736z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3737z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3738z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3739z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3740z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3741z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc3742z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3743z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3744z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3745z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3746z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3747z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3748z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3749z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3750z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3751z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3752z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3753z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc3754z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3755z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3756z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3757z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3758z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3759z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3760z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3761z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3762z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3763z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3764z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3765z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc3766z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3767z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3768z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3769z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3770z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3771z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3772z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3773z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3774z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3775z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3776z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3777z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc3778z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3779z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3780z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3781z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3782z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3783z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3784z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3785z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3786z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3787z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3788z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3789z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc3790z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3791z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3792z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3793z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3794z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3795z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3796z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3797z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3798z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3799z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3800z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3801z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc3802z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3803z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3804z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3805z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3806z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3807z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3808z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3809z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3810z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3811z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3812z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3813z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_conditionalz00zzast_nodez00,
				BGl_proc3814z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3815z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3816z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3817z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3818z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3819z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3820z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3821z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3822z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3823z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3824z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3825z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc3826z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3827z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3828z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3829z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3830z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3831z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3832z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3833z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3834z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3835z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3836z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3837z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_setzd2exzd2itz00zzast_nodez00,
				BGl_proc3838z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3839z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3840z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3841z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3842z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3843z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3844z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3845z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3846z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3847z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3848z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3849z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_jumpzd2exzd2itz00zzast_nodez00,
				BGl_proc3850z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3851z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3852z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3853z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3854z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3855z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3856z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3857z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3858z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3859z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3860z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3861z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_makezd2boxzd2zzast_nodez00,
				BGl_proc3862z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3863z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3864z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3865z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3866z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3867z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3868z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3869z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3870z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3871z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3872z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3873z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_boxzd2refzd2zzast_nodez00,
				BGl_proc3874z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3875z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3876z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3877z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3878z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3879z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3880z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3881z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3882z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3883z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3884z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3885z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_boxzd2setz12zc0zzast_nodez00,
				BGl_proc3886z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3887z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3888z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3889z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3890z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3891z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3892z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3893z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3894z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3895z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3896z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3897z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc3898z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3899z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3900z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3901z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3902z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3903z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3904z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3905z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3906z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3907z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3908z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3909z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc3910z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3911z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3912z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3913z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3914z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3915z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3916z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3917z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3918z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3919z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3920z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3921z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc3922z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3923z00zzast_walkz00, BGl_string3706z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3924z00zzast_walkz00, BGl_string3705z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3925z00zzast_walkz00, BGl_string3704z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3zd2envzd2zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3926z00zzast_walkz00, BGl_string3703z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3927z00zzast_walkz00, BGl_string3701z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3928z00zzast_walkz00, BGl_string3700z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3929z00zzast_walkz00, BGl_string3699z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3za2zd2envz70zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3930z00zzast_walkz00, BGl_string3698z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk0z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3931z00zzast_walkz00, BGl_string3697z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk1z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3932z00zzast_walkz00, BGl_string3696z00zzast_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk2z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3933z00zzast_walkz00, BGl_string3695z00zzast_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_walk3z12zd2envzc0zzast_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc3934z00zzast_walkz00, BGl_string3694z00zzast_walkz00);
		}
	}



/* &walk3!-let-var2083 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2var2083z70zzast_walkz00(obj_t
		BgL_envz00_7095, obj_t BgL_nz00_7096, obj_t BgL_pz00_7097,
		obj_t BgL_arg0z00_7098, obj_t BgL_arg1z00_7099, obj_t BgL_arg2z00_7100)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5285;
				obj_t BgL_pz00_5286;
				obj_t BgL_arg0z00_5287;
				obj_t BgL_arg1z00_5288;
				obj_t BgL_arg2z00_5289;

				BgL_nz00_5285 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7096);
				BgL_pz00_5286 = BgL_pz00_7097;
				BgL_arg0z00_5287 = BgL_arg0z00_7098;
				BgL_arg1z00_5288 = BgL_arg1z00_7099;
				BgL_arg2z00_5289 = BgL_arg2z00_7100;
				{
					obj_t BgL_fieldsz00_5295;

					BgL_fieldsz00_5295 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5285))->BgL_bindingsz00);
				BgL_zc3anonymousza33386ze3z83_5296:
					if (NULLP(BgL_fieldsz00_5295))
						{	/* Ast/walk.scm 318 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 318 */
							{	/* Ast/walk.scm 318 */
								obj_t BgL_arg3388z00_5298;
								obj_t BgL_arg3389z00_5299;

								BgL_arg3388z00_5298 = CAR(BgL_fieldsz00_5295);
								{	/* Ast/walk.scm 318 */
									obj_t BgL_arg3390z00_5300;

									BgL_arg3390z00_5300 = CDR(CAR(BgL_fieldsz00_5295));
									BgL_arg3389z00_5299 =
										PROCEDURE_ENTRY(BgL_pz00_5286) (BgL_pz00_5286,
										BgL_arg3390z00_5300, BgL_arg0z00_5287, BgL_arg1z00_5288,
										BgL_arg2z00_5289, BEOA);
								}
								SET_CDR(BgL_arg3388z00_5298, BgL_arg3389z00_5299);
							}
							{
								obj_t BgL_fieldsz00_9216;

								BgL_fieldsz00_9216 = CDR(BgL_fieldsz00_5295);
								BgL_fieldsz00_5295 = BgL_fieldsz00_9216;
								goto BgL_zc3anonymousza33386ze3z83_5296;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9219;

					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3393z00_5304;

						BgL_arg3393z00_5304 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5285))->BgL_bodyz00);
						BgL_auxz00_9219 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_5286) (BgL_pz00_5286,
								((obj_t) BgL_arg3393z00_5304), BgL_arg0z00_5287,
								BgL_arg1z00_5288, BgL_arg2z00_5289, BEOA));
					}
					((((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5285))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9219), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_5285);
			}
		}
	}



/* &walk2!-let-var2081 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2var2081z70zzast_walkz00(obj_t
		BgL_envz00_7101, obj_t BgL_nz00_7102, obj_t BgL_pz00_7103,
		obj_t BgL_arg0z00_7104, obj_t BgL_arg1z00_7105)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5265;
				obj_t BgL_pz00_5266;
				obj_t BgL_arg0z00_5267;
				obj_t BgL_arg1z00_5268;

				BgL_nz00_5265 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7102);
				BgL_pz00_5266 = BgL_pz00_7103;
				BgL_arg0z00_5267 = BgL_arg0z00_7104;
				BgL_arg1z00_5268 = BgL_arg1z00_7105;
				{
					obj_t BgL_fieldsz00_5274;

					BgL_fieldsz00_5274 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5265))->BgL_bindingsz00);
				BgL_zc3anonymousza33375ze3z83_5275:
					if (NULLP(BgL_fieldsz00_5274))
						{	/* Ast/walk.scm 318 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 318 */
							{	/* Ast/walk.scm 318 */
								obj_t BgL_arg3377z00_5277;
								obj_t BgL_arg3379z00_5278;

								BgL_arg3377z00_5277 = CAR(BgL_fieldsz00_5274);
								{	/* Ast/walk.scm 318 */
									obj_t BgL_arg3380z00_5279;

									BgL_arg3380z00_5279 = CDR(CAR(BgL_fieldsz00_5274));
									BgL_arg3379z00_5278 =
										PROCEDURE_ENTRY(BgL_pz00_5266) (BgL_pz00_5266,
										BgL_arg3380z00_5279, BgL_arg0z00_5267, BgL_arg1z00_5268,
										BEOA);
								}
								SET_CDR(BgL_arg3377z00_5277, BgL_arg3379z00_5278);
							}
							{
								obj_t BgL_fieldsz00_9245;

								BgL_fieldsz00_9245 = CDR(BgL_fieldsz00_5274);
								BgL_fieldsz00_5274 = BgL_fieldsz00_9245;
								goto BgL_zc3anonymousza33375ze3z83_5275;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9248;

					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3383z00_5283;

						BgL_arg3383z00_5283 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5265))->BgL_bodyz00);
						BgL_auxz00_9248 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_5266) (BgL_pz00_5266,
								((obj_t) BgL_arg3383z00_5283), BgL_arg0z00_5267,
								BgL_arg1z00_5268, BEOA));
					}
					((((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5265))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9248), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_5265);
			}
		}
	}



/* &walk1!-let-var2079 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2var2079z70zzast_walkz00(obj_t
		BgL_envz00_7106, obj_t BgL_nz00_7107, obj_t BgL_pz00_7108,
		obj_t BgL_arg0z00_7109)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5246;
				obj_t BgL_pz00_5247;
				obj_t BgL_arg0z00_5248;

				BgL_nz00_5246 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7107);
				BgL_pz00_5247 = BgL_pz00_7108;
				BgL_arg0z00_5248 = BgL_arg0z00_7109;
				{
					obj_t BgL_fieldsz00_5254;

					BgL_fieldsz00_5254 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5246))->BgL_bindingsz00);
				BgL_zc3anonymousza33364ze3z83_5255:
					if (NULLP(BgL_fieldsz00_5254))
						{	/* Ast/walk.scm 318 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 318 */
							{	/* Ast/walk.scm 318 */
								obj_t BgL_arg3366z00_5257;
								obj_t BgL_arg3368z00_5258;

								BgL_arg3366z00_5257 = CAR(BgL_fieldsz00_5254);
								{	/* Ast/walk.scm 318 */
									obj_t BgL_arg3369z00_5259;

									BgL_arg3369z00_5259 = CDR(CAR(BgL_fieldsz00_5254));
									BgL_arg3368z00_5258 =
										PROCEDURE_ENTRY(BgL_pz00_5247) (BgL_pz00_5247,
										BgL_arg3369z00_5259, BgL_arg0z00_5248, BEOA);
								}
								SET_CDR(BgL_arg3366z00_5257, BgL_arg3368z00_5258);
							}
							{
								obj_t BgL_fieldsz00_9272;

								BgL_fieldsz00_9272 = CDR(BgL_fieldsz00_5254);
								BgL_fieldsz00_5254 = BgL_fieldsz00_9272;
								goto BgL_zc3anonymousza33364ze3z83_5255;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9275;

					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3372z00_5263;

						BgL_arg3372z00_5263 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5246))->BgL_bodyz00);
						BgL_auxz00_9275 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_5247) (BgL_pz00_5247,
								((obj_t) BgL_arg3372z00_5263), BgL_arg0z00_5248, BEOA));
					}
					((((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5246))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9275), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_5246);
			}
		}
	}



/* &walk0!-let-var2077 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2var2077z70zzast_walkz00(obj_t
		BgL_envz00_7110, obj_t BgL_nz00_7111, obj_t BgL_pz00_7112)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5228;
				obj_t BgL_pz00_5229;

				BgL_nz00_5228 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7111);
				BgL_pz00_5229 = BgL_pz00_7112;
				{
					obj_t BgL_fieldsz00_5235;

					BgL_fieldsz00_5235 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5228))->BgL_bindingsz00);
				BgL_zc3anonymousza33353ze3z83_5236:
					if (NULLP(BgL_fieldsz00_5235))
						{	/* Ast/walk.scm 318 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 318 */
							{	/* Ast/walk.scm 318 */
								obj_t BgL_arg3355z00_5238;
								obj_t BgL_arg3357z00_5239;

								BgL_arg3355z00_5238 = CAR(BgL_fieldsz00_5235);
								{	/* Ast/walk.scm 318 */
									obj_t BgL_arg3358z00_5240;

									BgL_arg3358z00_5240 = CDR(CAR(BgL_fieldsz00_5235));
									BgL_arg3357z00_5239 =
										PROCEDURE_ENTRY(BgL_pz00_5229) (BgL_pz00_5229,
										BgL_arg3358z00_5240, BEOA);
								}
								SET_CDR(BgL_arg3355z00_5238, BgL_arg3357z00_5239);
							}
							{
								obj_t BgL_fieldsz00_9297;

								BgL_fieldsz00_9297 = CDR(BgL_fieldsz00_5235);
								BgL_fieldsz00_5235 = BgL_fieldsz00_9297;
								goto BgL_zc3anonymousza33353ze3z83_5236;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9300;

					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3361z00_5244;

						BgL_arg3361z00_5244 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5228))->BgL_bodyz00);
						BgL_auxz00_9300 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_5229) (BgL_pz00_5229,
								((obj_t) BgL_arg3361z00_5244), BEOA));
					}
					((((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5228))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9300), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_5228);
			}
		}
	}



/* &walk3*-let-var2075 */
	obj_t BGl_z62walk3za2zd2letzd2var2075zc0zzast_walkz00(obj_t BgL_envz00_7113,
		obj_t BgL_nz00_7114, obj_t BgL_pz00_7115, obj_t BgL_arg0z00_7116,
		obj_t BgL_arg1z00_7117, obj_t BgL_arg2z00_7118)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5205;
				obj_t BgL_pz00_5206;
				obj_t BgL_arg0z00_5207;
				obj_t BgL_arg1z00_5208;
				obj_t BgL_arg2z00_5209;

				BgL_nz00_5205 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7114);
				BgL_pz00_5206 = BgL_pz00_7115;
				BgL_arg0z00_5207 = BgL_arg0z00_7116;
				BgL_arg1z00_5208 = BgL_arg1z00_7117;
				BgL_arg2z00_5209 = BgL_arg2z00_7118;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3341z00_5213;
					obj_t BgL_arg3342z00_5214;

					BgL_arg3341z00_5213 =
						BGl_zc3anonymousza33343ze3z83zzast_walkz00(BgL_arg2z00_5209,
						BgL_arg1z00_5208, BgL_arg0z00_5207, BgL_pz00_5206,
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5205))->BgL_bindingsz00));
					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3351z00_5226;

						BgL_arg3351z00_5226 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5205))->BgL_bodyz00);
						BgL_arg3342z00_5214 =
							PROCEDURE_ENTRY(BgL_pz00_5206) (BgL_pz00_5206,
							((obj_t) BgL_arg3351z00_5226), BgL_arg0z00_5207, BgL_arg1z00_5208,
							BgL_arg2z00_5209, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3341z00_5213,
						BgL_arg3342z00_5214);
				}
			}
		}
	}



/* <anonymous:3343> */
	obj_t BGl_zc3anonymousza33343ze3z83zzast_walkz00(obj_t BgL_arg2z00_8190,
		obj_t BgL_arg1z00_8189, obj_t BgL_arg0z00_8188, obj_t BgL_pz00_8187,
		obj_t BgL_l1591z00_5217)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			if (NULLP(BgL_l1591z00_5217))
				{	/* Ast/walk.scm 318 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3346z00_5220;
					obj_t BgL_arg3347z00_5221;

					{	/* Ast/walk.scm 318 */
						obj_t BgL_fz00_5222;

						BgL_fz00_5222 = CAR(BgL_l1591z00_5217);
						{	/* Ast/walk.scm 318 */
							obj_t BgL_arg3348z00_5223;

							BgL_arg3348z00_5223 = CDR(BgL_fz00_5222);
							BgL_arg3346z00_5220 =
								PROCEDURE_ENTRY(BgL_pz00_8187) (BgL_pz00_8187,
								BgL_arg3348z00_5223, BgL_arg0z00_8188, BgL_arg1z00_8189,
								BgL_arg2z00_8190, BEOA);
						}
					}
					BgL_arg3347z00_5221 =
						BGl_zc3anonymousza33343ze3z83zzast_walkz00(BgL_arg2z00_8190,
						BgL_arg1z00_8189, BgL_arg0z00_8188, BgL_pz00_8187,
						CDR(BgL_l1591z00_5217));
					return bgl_append2(BgL_arg3346z00_5220, BgL_arg3347z00_5221);
				}
		}
	}



/* &walk2*-let-var2073 */
	obj_t BGl_z62walk2za2zd2letzd2var2073zc0zzast_walkz00(obj_t BgL_envz00_7119,
		obj_t BgL_nz00_7120, obj_t BgL_pz00_7121, obj_t BgL_arg0z00_7122,
		obj_t BgL_arg1z00_7123)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5183;
				obj_t BgL_pz00_5184;
				obj_t BgL_arg0z00_5185;
				obj_t BgL_arg1z00_5186;

				BgL_nz00_5183 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7120);
				BgL_pz00_5184 = BgL_pz00_7121;
				BgL_arg0z00_5185 = BgL_arg0z00_7122;
				BgL_arg1z00_5186 = BgL_arg1z00_7123;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3331z00_5190;
					obj_t BgL_arg3332z00_5191;

					BgL_arg3331z00_5190 =
						BGl_zc3anonymousza33333ze3z83zzast_walkz00(BgL_arg1z00_5186,
						BgL_arg0z00_5185, BgL_pz00_5184,
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5183))->BgL_bindingsz00));
					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3340z00_5203;

						BgL_arg3340z00_5203 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5183))->BgL_bodyz00);
						BgL_arg3332z00_5191 =
							PROCEDURE_ENTRY(BgL_pz00_5184) (BgL_pz00_5184,
							((obj_t) BgL_arg3340z00_5203), BgL_arg0z00_5185, BgL_arg1z00_5186,
							BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3331z00_5190,
						BgL_arg3332z00_5191);
				}
			}
		}
	}



/* <anonymous:3333> */
	obj_t BGl_zc3anonymousza33333ze3z83zzast_walkz00(obj_t BgL_arg1z00_8186,
		obj_t BgL_arg0z00_8185, obj_t BgL_pz00_8184, obj_t BgL_l1588z00_5194)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			if (NULLP(BgL_l1588z00_5194))
				{	/* Ast/walk.scm 318 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3335z00_5197;
					obj_t BgL_arg3336z00_5198;

					{	/* Ast/walk.scm 318 */
						obj_t BgL_fz00_5199;

						BgL_fz00_5199 = CAR(BgL_l1588z00_5194);
						{	/* Ast/walk.scm 318 */
							obj_t BgL_arg3337z00_5200;

							BgL_arg3337z00_5200 = CDR(BgL_fz00_5199);
							BgL_arg3335z00_5197 =
								PROCEDURE_ENTRY(BgL_pz00_8184) (BgL_pz00_8184,
								BgL_arg3337z00_5200, BgL_arg0z00_8185, BgL_arg1z00_8186, BEOA);
						}
					}
					BgL_arg3336z00_5198 =
						BGl_zc3anonymousza33333ze3z83zzast_walkz00(BgL_arg1z00_8186,
						BgL_arg0z00_8185, BgL_pz00_8184, CDR(BgL_l1588z00_5194));
					return bgl_append2(BgL_arg3335z00_5197, BgL_arg3336z00_5198);
				}
		}
	}



/* &walk1*-let-var2071 */
	obj_t BGl_z62walk1za2zd2letzd2var2071zc0zzast_walkz00(obj_t BgL_envz00_7124,
		obj_t BgL_nz00_7125, obj_t BgL_pz00_7126, obj_t BgL_arg0z00_7127)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5162;
				obj_t BgL_pz00_5163;
				obj_t BgL_arg0z00_5164;

				BgL_nz00_5162 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7125);
				BgL_pz00_5163 = BgL_pz00_7126;
				BgL_arg0z00_5164 = BgL_arg0z00_7127;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3321z00_5168;
					obj_t BgL_arg3322z00_5169;

					BgL_arg3321z00_5168 =
						BGl_zc3anonymousza33323ze3z83zzast_walkz00(BgL_arg0z00_5164,
						BgL_pz00_5163,
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5162))->BgL_bindingsz00));
					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3330z00_5181;

						BgL_arg3330z00_5181 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5162))->BgL_bodyz00);
						BgL_arg3322z00_5169 =
							PROCEDURE_ENTRY(BgL_pz00_5163) (BgL_pz00_5163,
							((obj_t) BgL_arg3330z00_5181), BgL_arg0z00_5164, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3321z00_5168,
						BgL_arg3322z00_5169);
				}
			}
		}
	}



/* <anonymous:3323> */
	obj_t BGl_zc3anonymousza33323ze3z83zzast_walkz00(obj_t BgL_arg0z00_8183,
		obj_t BgL_pz00_8182, obj_t BgL_l1585z00_5172)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			if (NULLP(BgL_l1585z00_5172))
				{	/* Ast/walk.scm 318 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3325z00_5175;
					obj_t BgL_arg3327z00_5176;

					{	/* Ast/walk.scm 318 */
						obj_t BgL_fz00_5177;

						BgL_fz00_5177 = CAR(BgL_l1585z00_5172);
						{	/* Ast/walk.scm 318 */
							obj_t BgL_arg3328z00_5178;

							BgL_arg3328z00_5178 = CDR(BgL_fz00_5177);
							BgL_arg3325z00_5175 =
								PROCEDURE_ENTRY(BgL_pz00_8182) (BgL_pz00_8182,
								BgL_arg3328z00_5178, BgL_arg0z00_8183, BEOA);
						}
					}
					BgL_arg3327z00_5176 =
						BGl_zc3anonymousza33323ze3z83zzast_walkz00(BgL_arg0z00_8183,
						BgL_pz00_8182, CDR(BgL_l1585z00_5172));
					return bgl_append2(BgL_arg3325z00_5175, BgL_arg3327z00_5176);
				}
		}
	}



/* &walk0*-let-var2069 */
	obj_t BGl_z62walk0za2zd2letzd2var2069zc0zzast_walkz00(obj_t BgL_envz00_7128,
		obj_t BgL_nz00_7129, obj_t BgL_pz00_7130)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5142;
				obj_t BgL_pz00_5143;

				BgL_nz00_5142 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7129);
				BgL_pz00_5143 = BgL_pz00_7130;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3310z00_5147;
					obj_t BgL_arg3312z00_5148;

					BgL_arg3310z00_5147 =
						BGl_zc3anonymousza33313ze3z83zzast_walkz00(BgL_pz00_5143,
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5142))->BgL_bindingsz00));
					{	/* Ast/walk.scm 318 */
						BgL_nodez00_bglt BgL_arg3320z00_5160;

						BgL_arg3320z00_5160 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5142))->BgL_bodyz00);
						BgL_arg3312z00_5148 =
							PROCEDURE_ENTRY(BgL_pz00_5143) (BgL_pz00_5143,
							((obj_t) BgL_arg3320z00_5160), BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3310z00_5147,
						BgL_arg3312z00_5148);
				}
			}
		}
	}



/* <anonymous:3313> */
	obj_t BGl_zc3anonymousza33313ze3z83zzast_walkz00(obj_t BgL_pz00_8181,
		obj_t BgL_l1582z00_5151)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			if (NULLP(BgL_l1582z00_5151))
				{	/* Ast/walk.scm 318 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 318 */
					obj_t BgL_arg3315z00_5154;
					obj_t BgL_arg3316z00_5155;

					{	/* Ast/walk.scm 318 */
						obj_t BgL_fz00_5156;

						BgL_fz00_5156 = CAR(BgL_l1582z00_5151);
						{	/* Ast/walk.scm 318 */
							obj_t BgL_arg3318z00_5157;

							BgL_arg3318z00_5157 = CDR(BgL_fz00_5156);
							BgL_arg3315z00_5154 =
								PROCEDURE_ENTRY(BgL_pz00_8181) (BgL_pz00_8181,
								BgL_arg3318z00_5157, BEOA);
						}
					}
					BgL_arg3316z00_5155 =
						BGl_zc3anonymousza33313ze3z83zzast_walkz00(BgL_pz00_8181,
						CDR(BgL_l1582z00_5151));
					return bgl_append2(BgL_arg3315z00_5154, BgL_arg3316z00_5155);
				}
		}
	}



/* &walk3-let-var2067 */
	obj_t BGl_z62walk3zd2letzd2var2067z62zzast_walkz00(obj_t BgL_envz00_7131,
		obj_t BgL_nz00_7132, obj_t BgL_pz00_7133, obj_t BgL_arg0z00_7134,
		obj_t BgL_arg1z00_7135, obj_t BgL_arg2z00_7136)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5123;
				obj_t BgL_pz00_5124;
				obj_t BgL_arg0z00_5125;
				obj_t BgL_arg1z00_5126;
				obj_t BgL_arg2z00_5127;

				BgL_nz00_5123 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7132);
				BgL_pz00_5124 = BgL_pz00_7133;
				BgL_arg0z00_5125 = BgL_arg0z00_7134;
				BgL_arg1z00_5126 = BgL_arg1z00_7135;
				BgL_arg2z00_5127 = BgL_arg2z00_7136;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_g1580z00_5131;

					BgL_g1580z00_5131 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5123))->BgL_bindingsz00);
					{
						obj_t BgL_l1578z00_5133;

						BgL_l1578z00_5133 = BgL_g1580z00_5131;
					BgL_zc3anonymousza33298ze3z83_5134:
						if (PAIRP(BgL_l1578z00_5133))
							{	/* Ast/walk.scm 318 */
								{	/* Ast/walk.scm 318 */
									obj_t BgL_fz00_5136;

									BgL_fz00_5136 = CAR(BgL_l1578z00_5133);
									{	/* Ast/walk.scm 318 */
										obj_t BgL_arg3307z00_5137;

										BgL_arg3307z00_5137 = CDR(BgL_fz00_5136);
										PROCEDURE_ENTRY(BgL_pz00_5124) (BgL_pz00_5124,
											BgL_arg3307z00_5137, BgL_arg0z00_5125, BgL_arg1z00_5126,
											BgL_arg2z00_5127, BEOA);
									}
								}
								{
									obj_t BgL_l1578z00_9419;

									BgL_l1578z00_9419 = CDR(BgL_l1578z00_5133);
									BgL_l1578z00_5133 = BgL_l1578z00_9419;
									goto BgL_zc3anonymousza33298ze3z83_5134;
								}
							}
						else
							{	/* Ast/walk.scm 318 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 318 */
					BgL_nodez00_bglt BgL_arg3309z00_5140;

					BgL_arg3309z00_5140 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5123))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_5124) (BgL_pz00_5124,
						((obj_t) BgL_arg3309z00_5140), BgL_arg0z00_5125, BgL_arg1z00_5126,
						BgL_arg2z00_5127, BEOA);
				}
			}
		}
	}



/* &walk2-let-var2065 */
	obj_t BGl_z62walk2zd2letzd2var2065z62zzast_walkz00(obj_t BgL_envz00_7137,
		obj_t BgL_nz00_7138, obj_t BgL_pz00_7139, obj_t BgL_arg0z00_7140,
		obj_t BgL_arg1z00_7141)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5105;
				obj_t BgL_pz00_5106;
				obj_t BgL_arg0z00_5107;
				obj_t BgL_arg1z00_5108;

				BgL_nz00_5105 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7138);
				BgL_pz00_5106 = BgL_pz00_7139;
				BgL_arg0z00_5107 = BgL_arg0z00_7140;
				BgL_arg1z00_5108 = BgL_arg1z00_7141;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_g1577z00_5112;

					BgL_g1577z00_5112 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5105))->BgL_bindingsz00);
					{
						obj_t BgL_l1575z00_5114;

						BgL_l1575z00_5114 = BgL_g1577z00_5112;
					BgL_zc3anonymousza33285ze3z83_5115:
						if (PAIRP(BgL_l1575z00_5114))
							{	/* Ast/walk.scm 318 */
								{	/* Ast/walk.scm 318 */
									obj_t BgL_fz00_5117;

									BgL_fz00_5117 = CAR(BgL_l1575z00_5114);
									{	/* Ast/walk.scm 318 */
										obj_t BgL_arg3287z00_5118;

										BgL_arg3287z00_5118 = CDR(BgL_fz00_5117);
										PROCEDURE_ENTRY(BgL_pz00_5106) (BgL_pz00_5106,
											BgL_arg3287z00_5118, BgL_arg0z00_5107, BgL_arg1z00_5108,
											BEOA);
									}
								}
								{
									obj_t BgL_l1575z00_9442;

									BgL_l1575z00_9442 = CDR(BgL_l1575z00_5114);
									BgL_l1575z00_5114 = BgL_l1575z00_9442;
									goto BgL_zc3anonymousza33285ze3z83_5115;
								}
							}
						else
							{	/* Ast/walk.scm 318 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 318 */
					BgL_nodez00_bglt BgL_arg3297z00_5121;

					BgL_arg3297z00_5121 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5105))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_5106) (BgL_pz00_5106,
						((obj_t) BgL_arg3297z00_5121), BgL_arg0z00_5107, BgL_arg1z00_5108,
						BEOA);
				}
			}
		}
	}



/* &walk1-let-var2063 */
	obj_t BGl_z62walk1zd2letzd2var2063z62zzast_walkz00(obj_t BgL_envz00_7142,
		obj_t BgL_nz00_7143, obj_t BgL_pz00_7144, obj_t BgL_arg0z00_7145)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5088;
				obj_t BgL_pz00_5089;
				obj_t BgL_arg0z00_5090;

				BgL_nz00_5088 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7143);
				BgL_pz00_5089 = BgL_pz00_7144;
				BgL_arg0z00_5090 = BgL_arg0z00_7145;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_g1574z00_5094;

					BgL_g1574z00_5094 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5088))->BgL_bindingsz00);
					{
						obj_t BgL_l1572z00_5096;

						BgL_l1572z00_5096 = BgL_g1574z00_5094;
					BgL_zc3anonymousza33280ze3z83_5097:
						if (PAIRP(BgL_l1572z00_5096))
							{	/* Ast/walk.scm 318 */
								{	/* Ast/walk.scm 318 */
									obj_t BgL_fz00_5099;

									BgL_fz00_5099 = CAR(BgL_l1572z00_5096);
									{	/* Ast/walk.scm 318 */
										obj_t BgL_arg3282z00_5100;

										BgL_arg3282z00_5100 = CDR(BgL_fz00_5099);
										PROCEDURE_ENTRY(BgL_pz00_5089) (BgL_pz00_5089,
											BgL_arg3282z00_5100, BgL_arg0z00_5090, BEOA);
									}
								}
								{
									obj_t BgL_l1572z00_9463;

									BgL_l1572z00_9463 = CDR(BgL_l1572z00_5096);
									BgL_l1572z00_5096 = BgL_l1572z00_9463;
									goto BgL_zc3anonymousza33280ze3z83_5097;
								}
							}
						else
							{	/* Ast/walk.scm 318 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 318 */
					BgL_nodez00_bglt BgL_arg3284z00_5103;

					BgL_arg3284z00_5103 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5088))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_5089) (BgL_pz00_5089,
						((obj_t) BgL_arg3284z00_5103), BgL_arg0z00_5090, BEOA);
				}
			}
		}
	}



/* &walk0-let-var2061 */
	obj_t BGl_z62walk0zd2letzd2var2061z62zzast_walkz00(obj_t BgL_envz00_7146,
		obj_t BgL_nz00_7147, obj_t BgL_pz00_7148)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 318 */
			{
				BgL_letzd2varzd2_bglt BgL_nz00_5072;
				obj_t BgL_pz00_5073;

				BgL_nz00_5072 = ((BgL_letzd2varzd2_bglt) BgL_nz00_7147);
				BgL_pz00_5073 = BgL_pz00_7148;
				{	/* Ast/walk.scm 318 */
					obj_t BgL_g1571z00_5077;

					BgL_g1571z00_5077 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5072))->BgL_bindingsz00);
					{
						obj_t BgL_l1569z00_5079;

						BgL_l1569z00_5079 = BgL_g1571z00_5077;
					BgL_zc3anonymousza33273ze3z83_5080:
						if (PAIRP(BgL_l1569z00_5079))
							{	/* Ast/walk.scm 318 */
								{	/* Ast/walk.scm 318 */
									obj_t BgL_fz00_5082;

									BgL_fz00_5082 = CAR(BgL_l1569z00_5079);
									{	/* Ast/walk.scm 318 */
										obj_t BgL_arg3275z00_5083;

										BgL_arg3275z00_5083 = CDR(BgL_fz00_5082);
										PROCEDURE_ENTRY(BgL_pz00_5073) (BgL_pz00_5073,
											BgL_arg3275z00_5083, BEOA);
									}
								}
								{
									obj_t BgL_l1569z00_9482;

									BgL_l1569z00_9482 = CDR(BgL_l1569z00_5079);
									BgL_l1569z00_5079 = BgL_l1569z00_9482;
									goto BgL_zc3anonymousza33273ze3z83_5080;
								}
							}
						else
							{	/* Ast/walk.scm 318 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 318 */
					BgL_nodez00_bglt BgL_arg3279z00_5086;

					BgL_arg3279z00_5086 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nz00_5072))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_5073) (BgL_pz00_5073,
						((obj_t) BgL_arg3279z00_5086), BEOA);
				}
			}
		}
	}



/* &walk3!-let-fun2059 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2letzd2fun2059z70zzast_walkz00(obj_t
		BgL_envz00_7149, obj_t BgL_nz00_7150, obj_t BgL_pz00_7151,
		obj_t BgL_arg0z00_7152, obj_t BgL_arg1z00_7153, obj_t BgL_arg2z00_7154)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_5049;
				obj_t BgL_pz00_5050;
				obj_t BgL_arg0z00_5051;
				obj_t BgL_arg1z00_5052;
				obj_t BgL_arg2z00_5053;

				BgL_nz00_5049 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7150);
				BgL_pz00_5050 = BgL_pz00_7151;
				BgL_arg0z00_5051 = BgL_arg0z00_7152;
				BgL_arg1z00_5052 = BgL_arg1z00_7153;
				BgL_arg2z00_5053 = BgL_arg2z00_7154;
				{
					obj_t BgL_fieldsz00_5059;

					BgL_fieldsz00_5059 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5049))->BgL_localsz00);
				BgL_zc3anonymousza33266ze3z83_5060:
					if (NULLP(BgL_fieldsz00_5059))
						{	/* Ast/walk.scm 313 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 313 */
							{	/* Ast/walk.scm 313 */
								obj_t BgL_vz00_5062;
								obj_t BgL_bz00_5063;

								BgL_vz00_5062 = CAR(BgL_fieldsz00_5059);
								{	/* Ast/walk.scm 313 */
									obj_t BgL_arg3269z00_5065;

									BgL_arg3269z00_5065 =
										(((BgL_sfunz00_bglt) CREF(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) CREF(
																((BgL_variablez00_bglt)
																	CAR(BgL_fieldsz00_5059))))->BgL_valuez00))))->
										BgL_bodyz00);
									BgL_bz00_5063 =
										PROCEDURE_ENTRY(BgL_pz00_5050) (BgL_pz00_5050,
										BgL_arg3269z00_5065, BgL_arg0z00_5051, BgL_arg1z00_5052,
										BgL_arg2z00_5053, BEOA);
								}
								{	/* Ast/walk.scm 315 */
									BgL_valuez00_bglt BgL_arg3268z00_5064;

									BgL_arg3268z00_5064 =
										(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt) BgL_vz00_5062)))->BgL_valuez00);
									((((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt) BgL_arg3268z00_5064)))->
											BgL_bodyz00) = ((obj_t) BgL_bz00_5063), BUNSPEC);
								}
							}
							{
								obj_t BgL_fieldsz00_9510;

								BgL_fieldsz00_9510 = CDR(BgL_fieldsz00_5059);
								BgL_fieldsz00_5059 = BgL_fieldsz00_9510;
								goto BgL_zc3anonymousza33266ze3z83_5060;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9513;

					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3272z00_5070;

						BgL_arg3272z00_5070 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5049))->BgL_bodyz00);
						BgL_auxz00_9513 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_5050) (BgL_pz00_5050,
								((obj_t) BgL_arg3272z00_5070), BgL_arg0z00_5051,
								BgL_arg1z00_5052, BgL_arg2z00_5053, BEOA));
					}
					((((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5049))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9513), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_5049);
			}
		}
	}



/* &walk2!-let-fun2057 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2letzd2fun2057z70zzast_walkz00(obj_t
		BgL_envz00_7155, obj_t BgL_nz00_7156, obj_t BgL_pz00_7157,
		obj_t BgL_arg0z00_7158, obj_t BgL_arg1z00_7159)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_5027;
				obj_t BgL_pz00_5028;
				obj_t BgL_arg0z00_5029;
				obj_t BgL_arg1z00_5030;

				BgL_nz00_5027 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7156);
				BgL_pz00_5028 = BgL_pz00_7157;
				BgL_arg0z00_5029 = BgL_arg0z00_7158;
				BgL_arg1z00_5030 = BgL_arg1z00_7159;
				{
					obj_t BgL_fieldsz00_5036;

					BgL_fieldsz00_5036 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5027))->BgL_localsz00);
				BgL_zc3anonymousza33258ze3z83_5037:
					if (NULLP(BgL_fieldsz00_5036))
						{	/* Ast/walk.scm 313 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 313 */
							{	/* Ast/walk.scm 313 */
								obj_t BgL_vz00_5039;
								obj_t BgL_bz00_5040;

								BgL_vz00_5039 = CAR(BgL_fieldsz00_5036);
								{	/* Ast/walk.scm 313 */
									obj_t BgL_arg3261z00_5042;

									BgL_arg3261z00_5042 =
										(((BgL_sfunz00_bglt) CREF(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) CREF(
																((BgL_variablez00_bglt)
																	CAR(BgL_fieldsz00_5036))))->BgL_valuez00))))->
										BgL_bodyz00);
									BgL_bz00_5040 =
										PROCEDURE_ENTRY(BgL_pz00_5028) (BgL_pz00_5028,
										BgL_arg3261z00_5042, BgL_arg0z00_5029, BgL_arg1z00_5030,
										BEOA);
								}
								{	/* Ast/walk.scm 315 */
									BgL_valuez00_bglt BgL_arg3260z00_5041;

									BgL_arg3260z00_5041 =
										(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt) BgL_vz00_5039)))->BgL_valuez00);
									((((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt) BgL_arg3260z00_5041)))->
											BgL_bodyz00) = ((obj_t) BgL_bz00_5040), BUNSPEC);
								}
							}
							{
								obj_t BgL_fieldsz00_9545;

								BgL_fieldsz00_9545 = CDR(BgL_fieldsz00_5036);
								BgL_fieldsz00_5036 = BgL_fieldsz00_9545;
								goto BgL_zc3anonymousza33258ze3z83_5037;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9548;

					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3264z00_5047;

						BgL_arg3264z00_5047 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5027))->BgL_bodyz00);
						BgL_auxz00_9548 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_5028) (BgL_pz00_5028,
								((obj_t) BgL_arg3264z00_5047), BgL_arg0z00_5029,
								BgL_arg1z00_5030, BEOA));
					}
					((((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5027))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9548), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_5027);
			}
		}
	}



/* &walk1!-let-fun2055 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2letzd2fun2055z70zzast_walkz00(obj_t
		BgL_envz00_7160, obj_t BgL_nz00_7161, obj_t BgL_pz00_7162,
		obj_t BgL_arg0z00_7163)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_5006;
				obj_t BgL_pz00_5007;
				obj_t BgL_arg0z00_5008;

				BgL_nz00_5006 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7161);
				BgL_pz00_5007 = BgL_pz00_7162;
				BgL_arg0z00_5008 = BgL_arg0z00_7163;
				{
					obj_t BgL_fieldsz00_5014;

					BgL_fieldsz00_5014 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5006))->BgL_localsz00);
				BgL_zc3anonymousza33250ze3z83_5015:
					if (NULLP(BgL_fieldsz00_5014))
						{	/* Ast/walk.scm 313 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 313 */
							{	/* Ast/walk.scm 313 */
								obj_t BgL_vz00_5017;
								obj_t BgL_bz00_5018;

								BgL_vz00_5017 = CAR(BgL_fieldsz00_5014);
								{	/* Ast/walk.scm 313 */
									obj_t BgL_arg3253z00_5020;

									BgL_arg3253z00_5020 =
										(((BgL_sfunz00_bglt) CREF(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) CREF(
																((BgL_variablez00_bglt)
																	CAR(BgL_fieldsz00_5014))))->BgL_valuez00))))->
										BgL_bodyz00);
									BgL_bz00_5018 =
										PROCEDURE_ENTRY(BgL_pz00_5007) (BgL_pz00_5007,
										BgL_arg3253z00_5020, BgL_arg0z00_5008, BEOA);
								}
								{	/* Ast/walk.scm 315 */
									BgL_valuez00_bglt BgL_arg3252z00_5019;

									BgL_arg3252z00_5019 =
										(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt) BgL_vz00_5017)))->BgL_valuez00);
									((((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt) BgL_arg3252z00_5019)))->
											BgL_bodyz00) = ((obj_t) BgL_bz00_5018), BUNSPEC);
								}
							}
							{
								obj_t BgL_fieldsz00_9578;

								BgL_fieldsz00_9578 = CDR(BgL_fieldsz00_5014);
								BgL_fieldsz00_5014 = BgL_fieldsz00_9578;
								goto BgL_zc3anonymousza33250ze3z83_5015;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9581;

					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3256z00_5025;

						BgL_arg3256z00_5025 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5006))->BgL_bodyz00);
						BgL_auxz00_9581 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_5007) (BgL_pz00_5007,
								((obj_t) BgL_arg3256z00_5025), BgL_arg0z00_5008, BEOA));
					}
					((((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_5006))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9581), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_5006);
			}
		}
	}



/* &walk0!-let-fun2053 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2letzd2fun2053z70zzast_walkz00(obj_t
		BgL_envz00_7164, obj_t BgL_nz00_7165, obj_t BgL_pz00_7166)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4986;
				obj_t BgL_pz00_4987;

				BgL_nz00_4986 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7165);
				BgL_pz00_4987 = BgL_pz00_7166;
				{
					obj_t BgL_fieldsz00_4993;

					BgL_fieldsz00_4993 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4986))->BgL_localsz00);
				BgL_zc3anonymousza33239ze3z83_4994:
					if (NULLP(BgL_fieldsz00_4993))
						{	/* Ast/walk.scm 313 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 313 */
							{	/* Ast/walk.scm 313 */
								obj_t BgL_vz00_4996;
								obj_t BgL_bz00_4997;

								BgL_vz00_4996 = CAR(BgL_fieldsz00_4993);
								{	/* Ast/walk.scm 313 */
									obj_t BgL_arg3242z00_4999;

									BgL_arg3242z00_4999 =
										(((BgL_sfunz00_bglt) CREF(
												((BgL_sfunz00_bglt)
													(((BgL_variablez00_bglt) CREF(
																((BgL_variablez00_bglt)
																	CAR(BgL_fieldsz00_4993))))->BgL_valuez00))))->
										BgL_bodyz00);
									BgL_bz00_4997 =
										PROCEDURE_ENTRY(BgL_pz00_4987) (BgL_pz00_4987,
										BgL_arg3242z00_4999, BEOA);
								}
								{	/* Ast/walk.scm 315 */
									BgL_valuez00_bglt BgL_arg3241z00_4998;

									BgL_arg3241z00_4998 =
										(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt) BgL_vz00_4996)))->BgL_valuez00);
									((((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt) BgL_arg3241z00_4998)))->
											BgL_bodyz00) = ((obj_t) BgL_bz00_4997), BUNSPEC);
								}
							}
							{
								obj_t BgL_fieldsz00_9609;

								BgL_fieldsz00_9609 = CDR(BgL_fieldsz00_4993);
								BgL_fieldsz00_4993 = BgL_fieldsz00_9609;
								goto BgL_zc3anonymousza33239ze3z83_4994;
							}
						}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_9612;

					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3246z00_5004;

						BgL_arg3246z00_5004 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4986))->BgL_bodyz00);
						BgL_auxz00_9612 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4987) (BgL_pz00_4987,
								((obj_t) BgL_arg3246z00_5004), BEOA));
					}
					((((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4986))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9612), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4986);
			}
		}
	}



/* &walk3*-let-fun2051 */
	obj_t BGl_z62walk3za2zd2letzd2fun2051zc0zzast_walkz00(obj_t BgL_envz00_7167,
		obj_t BgL_nz00_7168, obj_t BgL_pz00_7169, obj_t BgL_arg0z00_7170,
		obj_t BgL_arg1z00_7171, obj_t BgL_arg2z00_7172)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4961;
				obj_t BgL_pz00_4962;
				obj_t BgL_arg0z00_4963;
				obj_t BgL_arg1z00_4964;
				obj_t BgL_arg2z00_4965;

				BgL_nz00_4961 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7168);
				BgL_pz00_4962 = BgL_pz00_7169;
				BgL_arg0z00_4963 = BgL_arg0z00_7170;
				BgL_arg1z00_4964 = BgL_arg1z00_7171;
				BgL_arg2z00_4965 = BgL_arg2z00_7172;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3226z00_4969;
					obj_t BgL_arg3227z00_4970;

					BgL_arg3226z00_4969 =
						BGl_zc3anonymousza33228ze3z83zzast_walkz00(BgL_arg2z00_4965,
						BgL_arg1z00_4964, BgL_arg0z00_4963, BgL_pz00_4962,
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4961))->BgL_localsz00));
					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3237z00_4984;

						BgL_arg3237z00_4984 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4961))->BgL_bodyz00);
						BgL_arg3227z00_4970 =
							PROCEDURE_ENTRY(BgL_pz00_4962) (BgL_pz00_4962,
							((obj_t) BgL_arg3237z00_4984), BgL_arg0z00_4963, BgL_arg1z00_4964,
							BgL_arg2z00_4965, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3226z00_4969,
						BgL_arg3227z00_4970);
				}
			}
		}
	}



/* <anonymous:3228> */
	obj_t BGl_zc3anonymousza33228ze3z83zzast_walkz00(obj_t BgL_arg2z00_8180,
		obj_t BgL_arg1z00_8179, obj_t BgL_arg0z00_8178, obj_t BgL_pz00_8177,
		obj_t BgL_l1567z00_4973)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			if (NULLP(BgL_l1567z00_4973))
				{	/* Ast/walk.scm 313 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3230z00_4976;
					obj_t BgL_arg3232z00_4977;

					{	/* Ast/walk.scm 313 */
						obj_t BgL_fz00_4978;

						BgL_fz00_4978 = CAR(BgL_l1567z00_4973);
						{	/* Ast/walk.scm 314 */
							obj_t BgL_arg3234z00_4979;

							BgL_arg3234z00_4979 =
								(((BgL_sfunz00_bglt) CREF(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) CREF(
														((BgL_variablez00_bglt) BgL_fz00_4978)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3230z00_4976 =
								PROCEDURE_ENTRY(BgL_pz00_8177) (BgL_pz00_8177,
								BgL_arg3234z00_4979, BgL_arg0z00_8178, BgL_arg1z00_8179,
								BgL_arg2z00_8180, BEOA);
						}
					}
					BgL_arg3232z00_4977 =
						BGl_zc3anonymousza33228ze3z83zzast_walkz00(BgL_arg2z00_8180,
						BgL_arg1z00_8179, BgL_arg0z00_8178, BgL_pz00_8177,
						CDR(BgL_l1567z00_4973));
					return bgl_append2(BgL_arg3230z00_4976, BgL_arg3232z00_4977);
				}
		}
	}



/* &walk2*-let-fun2049 */
	obj_t BGl_z62walk2za2zd2letzd2fun2049zc0zzast_walkz00(obj_t BgL_envz00_7173,
		obj_t BgL_nz00_7174, obj_t BgL_pz00_7175, obj_t BgL_arg0z00_7176,
		obj_t BgL_arg1z00_7177)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4937;
				obj_t BgL_pz00_4938;
				obj_t BgL_arg0z00_4939;
				obj_t BgL_arg1z00_4940;

				BgL_nz00_4937 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7174);
				BgL_pz00_4938 = BgL_pz00_7175;
				BgL_arg0z00_4939 = BgL_arg0z00_7176;
				BgL_arg1z00_4940 = BgL_arg1z00_7177;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3216z00_4944;
					obj_t BgL_arg3217z00_4945;

					BgL_arg3216z00_4944 =
						BGl_zc3anonymousza33218ze3z83zzast_walkz00(BgL_arg1z00_4940,
						BgL_arg0z00_4939, BgL_pz00_4938,
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4937))->BgL_localsz00));
					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3225z00_4959;

						BgL_arg3225z00_4959 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4937))->BgL_bodyz00);
						BgL_arg3217z00_4945 =
							PROCEDURE_ENTRY(BgL_pz00_4938) (BgL_pz00_4938,
							((obj_t) BgL_arg3225z00_4959), BgL_arg0z00_4939, BgL_arg1z00_4940,
							BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3216z00_4944,
						BgL_arg3217z00_4945);
				}
			}
		}
	}



/* <anonymous:3218> */
	obj_t BGl_zc3anonymousza33218ze3z83zzast_walkz00(obj_t BgL_arg1z00_8176,
		obj_t BgL_arg0z00_8175, obj_t BgL_pz00_8174, obj_t BgL_l1564z00_4948)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			if (NULLP(BgL_l1564z00_4948))
				{	/* Ast/walk.scm 313 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3220z00_4951;
					obj_t BgL_arg3221z00_4952;

					{	/* Ast/walk.scm 313 */
						obj_t BgL_fz00_4953;

						BgL_fz00_4953 = CAR(BgL_l1564z00_4948);
						{	/* Ast/walk.scm 314 */
							obj_t BgL_arg3222z00_4954;

							BgL_arg3222z00_4954 =
								(((BgL_sfunz00_bglt) CREF(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) CREF(
														((BgL_variablez00_bglt) BgL_fz00_4953)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3220z00_4951 =
								PROCEDURE_ENTRY(BgL_pz00_8174) (BgL_pz00_8174,
								BgL_arg3222z00_4954, BgL_arg0z00_8175, BgL_arg1z00_8176, BEOA);
						}
					}
					BgL_arg3221z00_4952 =
						BGl_zc3anonymousza33218ze3z83zzast_walkz00(BgL_arg1z00_8176,
						BgL_arg0z00_8175, BgL_pz00_8174, CDR(BgL_l1564z00_4948));
					return bgl_append2(BgL_arg3220z00_4951, BgL_arg3221z00_4952);
				}
		}
	}



/* &walk1*-let-fun2047 */
	obj_t BGl_z62walk1za2zd2letzd2fun2047zc0zzast_walkz00(obj_t BgL_envz00_7178,
		obj_t BgL_nz00_7179, obj_t BgL_pz00_7180, obj_t BgL_arg0z00_7181)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4914;
				obj_t BgL_pz00_4915;
				obj_t BgL_arg0z00_4916;

				BgL_nz00_4914 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7179);
				BgL_pz00_4915 = BgL_pz00_7180;
				BgL_arg0z00_4916 = BgL_arg0z00_7181;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3184z00_4920;
					obj_t BgL_arg3185z00_4921;

					BgL_arg3184z00_4920 =
						BGl_zc3anonymousza33186ze3z83zzast_walkz00(BgL_arg0z00_4916,
						BgL_pz00_4915,
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4914))->BgL_localsz00));
					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3215z00_4935;

						BgL_arg3215z00_4935 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4914))->BgL_bodyz00);
						BgL_arg3185z00_4921 =
							PROCEDURE_ENTRY(BgL_pz00_4915) (BgL_pz00_4915,
							((obj_t) BgL_arg3215z00_4935), BgL_arg0z00_4916, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3184z00_4920,
						BgL_arg3185z00_4921);
				}
			}
		}
	}



/* <anonymous:3186> */
	obj_t BGl_zc3anonymousza33186ze3z83zzast_walkz00(obj_t BgL_arg0z00_8173,
		obj_t BgL_pz00_8172, obj_t BgL_l1560z00_4924)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			if (NULLP(BgL_l1560z00_4924))
				{	/* Ast/walk.scm 313 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3189z00_4927;
					obj_t BgL_arg3197z00_4928;

					{	/* Ast/walk.scm 313 */
						obj_t BgL_fz00_4929;

						BgL_fz00_4929 = CAR(BgL_l1560z00_4924);
						{	/* Ast/walk.scm 314 */
							obj_t BgL_arg3211z00_4930;

							BgL_arg3211z00_4930 =
								(((BgL_sfunz00_bglt) CREF(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) CREF(
														((BgL_variablez00_bglt) BgL_fz00_4929)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3189z00_4927 =
								PROCEDURE_ENTRY(BgL_pz00_8172) (BgL_pz00_8172,
								BgL_arg3211z00_4930, BgL_arg0z00_8173, BEOA);
						}
					}
					BgL_arg3197z00_4928 =
						BGl_zc3anonymousza33186ze3z83zzast_walkz00(BgL_arg0z00_8173,
						BgL_pz00_8172, CDR(BgL_l1560z00_4924));
					return bgl_append2(BgL_arg3189z00_4927, BgL_arg3197z00_4928);
				}
		}
	}



/* &walk0*-let-fun2045 */
	obj_t BGl_z62walk0za2zd2letzd2fun2045zc0zzast_walkz00(obj_t BgL_envz00_7182,
		obj_t BgL_nz00_7183, obj_t BgL_pz00_7184)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4892;
				obj_t BgL_pz00_4893;

				BgL_nz00_4892 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7183);
				BgL_pz00_4893 = BgL_pz00_7184;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3172z00_4897;
					obj_t BgL_arg3173z00_4898;

					BgL_arg3172z00_4897 =
						BGl_zc3anonymousza33174ze3z83zzast_walkz00(BgL_pz00_4893,
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4892))->BgL_localsz00));
					{	/* Ast/walk.scm 313 */
						BgL_nodez00_bglt BgL_arg3183z00_4912;

						BgL_arg3183z00_4912 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4892))->BgL_bodyz00);
						BgL_arg3173z00_4898 =
							PROCEDURE_ENTRY(BgL_pz00_4893) (BgL_pz00_4893,
							((obj_t) BgL_arg3183z00_4912), BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3172z00_4897,
						BgL_arg3173z00_4898);
				}
			}
		}
	}



/* <anonymous:3174> */
	obj_t BGl_zc3anonymousza33174ze3z83zzast_walkz00(obj_t BgL_pz00_8171,
		obj_t BgL_l1557z00_4901)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			if (NULLP(BgL_l1557z00_4901))
				{	/* Ast/walk.scm 313 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 313 */
					obj_t BgL_arg3176z00_4904;
					obj_t BgL_arg3177z00_4905;

					{	/* Ast/walk.scm 313 */
						obj_t BgL_fz00_4906;

						BgL_fz00_4906 = CAR(BgL_l1557z00_4901);
						{	/* Ast/walk.scm 314 */
							obj_t BgL_arg3179z00_4907;

							BgL_arg3179z00_4907 =
								(((BgL_sfunz00_bglt) CREF(
										((BgL_sfunz00_bglt)
											(((BgL_variablez00_bglt) CREF(
														((BgL_variablez00_bglt) BgL_fz00_4906)))->
												BgL_valuez00))))->BgL_bodyz00);
							BgL_arg3176z00_4904 =
								PROCEDURE_ENTRY(BgL_pz00_8171) (BgL_pz00_8171,
								BgL_arg3179z00_4907, BEOA);
						}
					}
					BgL_arg3177z00_4905 =
						BGl_zc3anonymousza33174ze3z83zzast_walkz00(BgL_pz00_8171,
						CDR(BgL_l1557z00_4901));
					return bgl_append2(BgL_arg3176z00_4904, BgL_arg3177z00_4905);
				}
		}
	}



/* &walk3-let-fun2043 */
	obj_t BGl_z62walk3zd2letzd2fun2043z62zzast_walkz00(obj_t BgL_envz00_7185,
		obj_t BgL_nz00_7186, obj_t BgL_pz00_7187, obj_t BgL_arg0z00_7188,
		obj_t BgL_arg1z00_7189, obj_t BgL_arg2z00_7190)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4871;
				obj_t BgL_pz00_4872;
				obj_t BgL_arg0z00_4873;
				obj_t BgL_arg1z00_4874;
				obj_t BgL_arg2z00_4875;

				BgL_nz00_4871 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7186);
				BgL_pz00_4872 = BgL_pz00_7187;
				BgL_arg0z00_4873 = BgL_arg0z00_7188;
				BgL_arg1z00_4874 = BgL_arg1z00_7189;
				BgL_arg2z00_4875 = BgL_arg2z00_7190;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_g1555z00_4879;

					BgL_g1555z00_4879 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4871))->BgL_localsz00);
					{
						obj_t BgL_l1553z00_4881;

						BgL_l1553z00_4881 = BgL_g1555z00_4879;
					BgL_zc3anonymousza33162ze3z83_4882:
						if (PAIRP(BgL_l1553z00_4881))
							{	/* Ast/walk.scm 313 */
								{	/* Ast/walk.scm 313 */
									obj_t BgL_fz00_4884;

									BgL_fz00_4884 = CAR(BgL_l1553z00_4881);
									{	/* Ast/walk.scm 314 */
										obj_t BgL_arg3164z00_4885;

										BgL_arg3164z00_4885 =
											(((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt)
														(((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt) BgL_fz00_4884)))->
															BgL_valuez00))))->BgL_bodyz00);
										PROCEDURE_ENTRY(BgL_pz00_4872) (BgL_pz00_4872,
											BgL_arg3164z00_4885, BgL_arg0z00_4873, BgL_arg1z00_4874,
											BgL_arg2z00_4875, BEOA);
									}
								}
								{
									obj_t BgL_l1553z00_9746;

									BgL_l1553z00_9746 = CDR(BgL_l1553z00_4881);
									BgL_l1553z00_4881 = BgL_l1553z00_9746;
									goto BgL_zc3anonymousza33162ze3z83_4882;
								}
							}
						else
							{	/* Ast/walk.scm 313 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 313 */
					BgL_nodez00_bglt BgL_arg3169z00_4890;

					BgL_arg3169z00_4890 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4871))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4872) (BgL_pz00_4872,
						((obj_t) BgL_arg3169z00_4890), BgL_arg0z00_4873, BgL_arg1z00_4874,
						BgL_arg2z00_4875, BEOA);
				}
			}
		}
	}



/* &walk2-let-fun2041 */
	obj_t BGl_z62walk2zd2letzd2fun2041z62zzast_walkz00(obj_t BgL_envz00_7191,
		obj_t BgL_nz00_7192, obj_t BgL_pz00_7193, obj_t BgL_arg0z00_7194,
		obj_t BgL_arg1z00_7195)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4851;
				obj_t BgL_pz00_4852;
				obj_t BgL_arg0z00_4853;
				obj_t BgL_arg1z00_4854;

				BgL_nz00_4851 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7192);
				BgL_pz00_4852 = BgL_pz00_7193;
				BgL_arg0z00_4853 = BgL_arg0z00_7194;
				BgL_arg1z00_4854 = BgL_arg1z00_7195;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_g1552z00_4858;

					BgL_g1552z00_4858 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4851))->BgL_localsz00);
					{
						obj_t BgL_l1550z00_4860;

						BgL_l1550z00_4860 = BgL_g1552z00_4858;
					BgL_zc3anonymousza33155ze3z83_4861:
						if (PAIRP(BgL_l1550z00_4860))
							{	/* Ast/walk.scm 313 */
								{	/* Ast/walk.scm 313 */
									obj_t BgL_fz00_4863;

									BgL_fz00_4863 = CAR(BgL_l1550z00_4860);
									{	/* Ast/walk.scm 314 */
										obj_t BgL_arg3157z00_4864;

										BgL_arg3157z00_4864 =
											(((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt)
														(((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt) BgL_fz00_4863)))->
															BgL_valuez00))))->BgL_bodyz00);
										PROCEDURE_ENTRY(BgL_pz00_4852) (BgL_pz00_4852,
											BgL_arg3157z00_4864, BgL_arg0z00_4853, BgL_arg1z00_4854,
											BEOA);
									}
								}
								{
									obj_t BgL_l1550z00_9772;

									BgL_l1550z00_9772 = CDR(BgL_l1550z00_4860);
									BgL_l1550z00_4860 = BgL_l1550z00_9772;
									goto BgL_zc3anonymousza33155ze3z83_4861;
								}
							}
						else
							{	/* Ast/walk.scm 313 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 313 */
					BgL_nodez00_bglt BgL_arg3161z00_4869;

					BgL_arg3161z00_4869 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4851))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4852) (BgL_pz00_4852,
						((obj_t) BgL_arg3161z00_4869), BgL_arg0z00_4853, BgL_arg1z00_4854,
						BEOA);
				}
			}
		}
	}



/* &walk1-let-fun2039 */
	obj_t BGl_z62walk1zd2letzd2fun2039z62zzast_walkz00(obj_t BgL_envz00_7196,
		obj_t BgL_nz00_7197, obj_t BgL_pz00_7198, obj_t BgL_arg0z00_7199)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4832;
				obj_t BgL_pz00_4833;
				obj_t BgL_arg0z00_4834;

				BgL_nz00_4832 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7197);
				BgL_pz00_4833 = BgL_pz00_7198;
				BgL_arg0z00_4834 = BgL_arg0z00_7199;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_g1549z00_4838;

					BgL_g1549z00_4838 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4832))->BgL_localsz00);
					{
						obj_t BgL_l1547z00_4840;

						BgL_l1547z00_4840 = BgL_g1549z00_4838;
					BgL_zc3anonymousza33149ze3z83_4841:
						if (PAIRP(BgL_l1547z00_4840))
							{	/* Ast/walk.scm 313 */
								{	/* Ast/walk.scm 313 */
									obj_t BgL_fz00_4843;

									BgL_fz00_4843 = CAR(BgL_l1547z00_4840);
									{	/* Ast/walk.scm 314 */
										obj_t BgL_arg3151z00_4844;

										BgL_arg3151z00_4844 =
											(((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt)
														(((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt) BgL_fz00_4843)))->
															BgL_valuez00))))->BgL_bodyz00);
										PROCEDURE_ENTRY(BgL_pz00_4833) (BgL_pz00_4833,
											BgL_arg3151z00_4844, BgL_arg0z00_4834, BEOA);
									}
								}
								{
									obj_t BgL_l1547z00_9796;

									BgL_l1547z00_9796 = CDR(BgL_l1547z00_4840);
									BgL_l1547z00_4840 = BgL_l1547z00_9796;
									goto BgL_zc3anonymousza33149ze3z83_4841;
								}
							}
						else
							{	/* Ast/walk.scm 313 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 313 */
					BgL_nodez00_bglt BgL_arg3154z00_4849;

					BgL_arg3154z00_4849 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4832))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4833) (BgL_pz00_4833,
						((obj_t) BgL_arg3154z00_4849), BgL_arg0z00_4834, BEOA);
				}
			}
		}
	}



/* &walk0-let-fun2037 */
	obj_t BGl_z62walk0zd2letzd2fun2037z62zzast_walkz00(obj_t BgL_envz00_7200,
		obj_t BgL_nz00_7201, obj_t BgL_pz00_7202)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 313 */
			{
				BgL_letzd2funzd2_bglt BgL_nz00_4814;
				obj_t BgL_pz00_4815;

				BgL_nz00_4814 = ((BgL_letzd2funzd2_bglt) BgL_nz00_7201);
				BgL_pz00_4815 = BgL_pz00_7202;
				{	/* Ast/walk.scm 313 */
					obj_t BgL_g1546z00_4819;

					BgL_g1546z00_4819 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4814))->BgL_localsz00);
					{
						obj_t BgL_l1544z00_4821;

						BgL_l1544z00_4821 = BgL_g1546z00_4819;
					BgL_zc3anonymousza33143ze3z83_4822:
						if (PAIRP(BgL_l1544z00_4821))
							{	/* Ast/walk.scm 313 */
								{	/* Ast/walk.scm 313 */
									obj_t BgL_fz00_4824;

									BgL_fz00_4824 = CAR(BgL_l1544z00_4821);
									{	/* Ast/walk.scm 314 */
										obj_t BgL_arg3145z00_4825;

										BgL_arg3145z00_4825 =
											(((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt)
														(((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt) BgL_fz00_4824)))->
															BgL_valuez00))))->BgL_bodyz00);
										PROCEDURE_ENTRY(BgL_pz00_4815) (BgL_pz00_4815,
											BgL_arg3145z00_4825, BEOA);
									}
								}
								{
									obj_t BgL_l1544z00_9818;

									BgL_l1544z00_9818 = CDR(BgL_l1544z00_4821);
									BgL_l1544z00_4821 = BgL_l1544z00_9818;
									goto BgL_zc3anonymousza33143ze3z83_4822;
								}
							}
						else
							{	/* Ast/walk.scm 313 */
								((bool_t) 1);
							}
					}
				}
				{	/* Ast/walk.scm 313 */
					BgL_nodez00_bglt BgL_arg3148z00_4830;

					BgL_arg3148z00_4830 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nz00_4814))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4815) (BgL_pz00_4815,
						((obj_t) BgL_arg3148z00_4830), BEOA);
				}
			}
		}
	}



/* &walk3!-select2035 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2select2035za2zzast_walkz00(obj_t
		BgL_envz00_7203, obj_t BgL_nz00_7204, obj_t BgL_pz00_7205,
		obj_t BgL_arg0z00_7206, obj_t BgL_arg1z00_7207, obj_t BgL_arg2z00_7208)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4793;
				obj_t BgL_pz00_4794;
				obj_t BgL_arg0z00_4795;
				obj_t BgL_arg1z00_4796;
				obj_t BgL_arg2z00_4797;

				BgL_nz00_4793 = ((BgL_selectz00_bglt) BgL_nz00_7204);
				BgL_pz00_4794 = BgL_pz00_7205;
				BgL_arg0z00_4795 = BgL_arg0z00_7206;
				BgL_arg1z00_4796 = BgL_arg1z00_7207;
				BgL_arg2z00_4797 = BgL_arg2z00_7208;
				{
					BgL_nodez00_bglt BgL_auxz00_9827;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3124z00_4801;

						BgL_arg3124z00_4801 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4793))->BgL_testz00);
						BgL_auxz00_9827 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4794) (BgL_pz00_4794,
								((obj_t) BgL_arg3124z00_4801), BgL_arg0z00_4795,
								BgL_arg1z00_4796, BgL_arg2z00_4797, BEOA));
					}
					((((BgL_selectz00_bglt) CREF(BgL_nz00_4793))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9827), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_4804;

					BgL_fieldsz00_4804 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4793))->BgL_clausesz00);
				BgL_zc3anonymousza33127ze3z83_4805:
					if (NULLP(BgL_fieldsz00_4804))
						{	/* Ast/walk.scm 310 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 310 */
							{	/* Ast/walk.scm 310 */
								obj_t BgL_arg3130z00_4807;
								obj_t BgL_arg3131z00_4808;

								BgL_arg3130z00_4807 = CAR(BgL_fieldsz00_4804);
								{	/* Ast/walk.scm 310 */
									obj_t BgL_arg3138z00_4809;

									BgL_arg3138z00_4809 = CDR(CAR(BgL_fieldsz00_4804));
									BgL_arg3131z00_4808 =
										PROCEDURE_ENTRY(BgL_pz00_4794) (BgL_pz00_4794,
										BgL_arg3138z00_4809, BgL_arg0z00_4795, BgL_arg1z00_4796,
										BgL_arg2z00_4797, BEOA);
								}
								SET_CDR(BgL_arg3130z00_4807, BgL_arg3131z00_4808);
							}
							{
								obj_t BgL_fieldsz00_9852;

								BgL_fieldsz00_9852 = CDR(BgL_fieldsz00_4804);
								BgL_fieldsz00_4804 = BgL_fieldsz00_9852;
								goto BgL_zc3anonymousza33127ze3z83_4805;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4793);
			}
		}
	}



/* &walk2!-select2033 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2select2033za2zzast_walkz00(obj_t
		BgL_envz00_7209, obj_t BgL_nz00_7210, obj_t BgL_pz00_7211,
		obj_t BgL_arg0z00_7212, obj_t BgL_arg1z00_7213)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4773;
				obj_t BgL_pz00_4774;
				obj_t BgL_arg0z00_4775;
				obj_t BgL_arg1z00_4776;

				BgL_nz00_4773 = ((BgL_selectz00_bglt) BgL_nz00_7210);
				BgL_pz00_4774 = BgL_pz00_7211;
				BgL_arg0z00_4775 = BgL_arg0z00_7212;
				BgL_arg1z00_4776 = BgL_arg1z00_7213;
				{
					BgL_nodez00_bglt BgL_auxz00_9857;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3105z00_4780;

						BgL_arg3105z00_4780 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4773))->BgL_testz00);
						BgL_auxz00_9857 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4774) (BgL_pz00_4774,
								((obj_t) BgL_arg3105z00_4780), BgL_arg0z00_4775,
								BgL_arg1z00_4776, BEOA));
					}
					((((BgL_selectz00_bglt) CREF(BgL_nz00_4773))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9857), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_4783;

					BgL_fieldsz00_4783 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4773))->BgL_clausesz00);
				BgL_zc3anonymousza33107ze3z83_4784:
					if (NULLP(BgL_fieldsz00_4783))
						{	/* Ast/walk.scm 310 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 310 */
							{	/* Ast/walk.scm 310 */
								obj_t BgL_arg3113z00_4786;
								obj_t BgL_arg3114z00_4787;

								BgL_arg3113z00_4786 = CAR(BgL_fieldsz00_4783);
								{	/* Ast/walk.scm 310 */
									obj_t BgL_arg3120z00_4788;

									BgL_arg3120z00_4788 = CDR(CAR(BgL_fieldsz00_4783));
									BgL_arg3114z00_4787 =
										PROCEDURE_ENTRY(BgL_pz00_4774) (BgL_pz00_4774,
										BgL_arg3120z00_4788, BgL_arg0z00_4775, BgL_arg1z00_4776,
										BEOA);
								}
								SET_CDR(BgL_arg3113z00_4786, BgL_arg3114z00_4787);
							}
							{
								obj_t BgL_fieldsz00_9880;

								BgL_fieldsz00_9880 = CDR(BgL_fieldsz00_4783);
								BgL_fieldsz00_4783 = BgL_fieldsz00_9880;
								goto BgL_zc3anonymousza33107ze3z83_4784;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4773);
			}
		}
	}



/* &walk1!-select2031 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2select2031za2zzast_walkz00(obj_t
		BgL_envz00_7214, obj_t BgL_nz00_7215, obj_t BgL_pz00_7216,
		obj_t BgL_arg0z00_7217)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4754;
				obj_t BgL_pz00_4755;
				obj_t BgL_arg0z00_4756;

				BgL_nz00_4754 = ((BgL_selectz00_bglt) BgL_nz00_7215);
				BgL_pz00_4755 = BgL_pz00_7216;
				BgL_arg0z00_4756 = BgL_arg0z00_7217;
				{
					BgL_nodez00_bglt BgL_auxz00_9885;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3095z00_4760;

						BgL_arg3095z00_4760 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4754))->BgL_testz00);
						BgL_auxz00_9885 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4755) (BgL_pz00_4755,
								((obj_t) BgL_arg3095z00_4760), BgL_arg0z00_4756, BEOA));
					}
					((((BgL_selectz00_bglt) CREF(BgL_nz00_4754))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9885), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_4763;

					BgL_fieldsz00_4763 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4754))->BgL_clausesz00);
				BgL_zc3anonymousza33097ze3z83_4764:
					if (NULLP(BgL_fieldsz00_4763))
						{	/* Ast/walk.scm 310 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 310 */
							{	/* Ast/walk.scm 310 */
								obj_t BgL_arg3099z00_4766;
								obj_t BgL_arg3100z00_4767;

								BgL_arg3099z00_4766 = CAR(BgL_fieldsz00_4763);
								{	/* Ast/walk.scm 310 */
									obj_t BgL_arg3101z00_4768;

									BgL_arg3101z00_4768 = CDR(CAR(BgL_fieldsz00_4763));
									BgL_arg3100z00_4767 =
										PROCEDURE_ENTRY(BgL_pz00_4755) (BgL_pz00_4755,
										BgL_arg3101z00_4768, BgL_arg0z00_4756, BEOA);
								}
								SET_CDR(BgL_arg3099z00_4766, BgL_arg3100z00_4767);
							}
							{
								obj_t BgL_fieldsz00_9906;

								BgL_fieldsz00_9906 = CDR(BgL_fieldsz00_4763);
								BgL_fieldsz00_4763 = BgL_fieldsz00_9906;
								goto BgL_zc3anonymousza33097ze3z83_4764;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4754);
			}
		}
	}



/* &walk0!-select2029 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2select2029za2zzast_walkz00(obj_t
		BgL_envz00_7218, obj_t BgL_nz00_7219, obj_t BgL_pz00_7220)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4736;
				obj_t BgL_pz00_4737;

				BgL_nz00_4736 = ((BgL_selectz00_bglt) BgL_nz00_7219);
				BgL_pz00_4737 = BgL_pz00_7220;
				{
					BgL_nodez00_bglt BgL_auxz00_9911;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3073z00_4741;

						BgL_arg3073z00_4741 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4736))->BgL_testz00);
						BgL_auxz00_9911 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4737) (BgL_pz00_4737,
								((obj_t) BgL_arg3073z00_4741), BEOA));
					}
					((((BgL_selectz00_bglt) CREF(BgL_nz00_4736))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_9911), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_4744;

					BgL_fieldsz00_4744 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4736))->BgL_clausesz00);
				BgL_zc3anonymousza33078ze3z83_4745:
					if (NULLP(BgL_fieldsz00_4744))
						{	/* Ast/walk.scm 310 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 310 */
							{	/* Ast/walk.scm 310 */
								obj_t BgL_arg3080z00_4747;
								obj_t BgL_arg3090z00_4748;

								BgL_arg3080z00_4747 = CAR(BgL_fieldsz00_4744);
								{	/* Ast/walk.scm 310 */
									obj_t BgL_arg3091z00_4749;

									BgL_arg3091z00_4749 = CDR(CAR(BgL_fieldsz00_4744));
									BgL_arg3090z00_4748 =
										PROCEDURE_ENTRY(BgL_pz00_4737) (BgL_pz00_4737,
										BgL_arg3091z00_4749, BEOA);
								}
								SET_CDR(BgL_arg3080z00_4747, BgL_arg3090z00_4748);
							}
							{
								obj_t BgL_fieldsz00_9930;

								BgL_fieldsz00_9930 = CDR(BgL_fieldsz00_4744);
								BgL_fieldsz00_4744 = BgL_fieldsz00_9930;
								goto BgL_zc3anonymousza33078ze3z83_4745;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4736);
			}
		}
	}



/* &walk3*-select2027 */
	obj_t BGl_z62walk3za2zd2select2027z12zzast_walkz00(obj_t BgL_envz00_7221,
		obj_t BgL_nz00_7222, obj_t BgL_pz00_7223, obj_t BgL_arg0z00_7224,
		obj_t BgL_arg1z00_7225, obj_t BgL_arg2z00_7226)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4713;
				obj_t BgL_pz00_4714;
				obj_t BgL_arg0z00_4715;
				obj_t BgL_arg1z00_4716;
				obj_t BgL_arg2z00_4717;

				BgL_nz00_4713 = ((BgL_selectz00_bglt) BgL_nz00_7222);
				BgL_pz00_4714 = BgL_pz00_7223;
				BgL_arg0z00_4715 = BgL_arg0z00_7224;
				BgL_arg1z00_4716 = BgL_arg1z00_7225;
				BgL_arg2z00_4717 = BgL_arg2z00_7226;
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3062z00_4721;
					obj_t BgL_arg3063z00_4722;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3064z00_4723;

						BgL_arg3064z00_4723 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4713))->BgL_testz00);
						BgL_arg3062z00_4721 =
							PROCEDURE_ENTRY(BgL_pz00_4714) (BgL_pz00_4714,
							((obj_t) BgL_arg3064z00_4723), BgL_arg0z00_4715, BgL_arg1z00_4716,
							BgL_arg2z00_4717, BEOA);
					}
					BgL_arg3063z00_4722 =
						BGl_zc3anonymousza33065ze3z83zzast_walkz00(BgL_arg2z00_4717,
						BgL_arg1z00_4716, BgL_arg0z00_4715, BgL_pz00_4714,
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4713))->BgL_clausesz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg3062z00_4721,
						BgL_arg3063z00_4722);
				}
			}
		}
	}



/* <anonymous:3065> */
	obj_t BGl_zc3anonymousza33065ze3z83zzast_walkz00(obj_t BgL_arg2z00_8170,
		obj_t BgL_arg1z00_8169, obj_t BgL_arg0z00_8168, obj_t BgL_pz00_8167,
		obj_t BgL_l1542z00_4726)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			if (NULLP(BgL_l1542z00_4726))
				{	/* Ast/walk.scm 310 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3067z00_4729;
					obj_t BgL_arg3069z00_4730;

					{	/* Ast/walk.scm 310 */
						obj_t BgL_fz00_4731;

						BgL_fz00_4731 = CAR(BgL_l1542z00_4726);
						{	/* Ast/walk.scm 310 */
							obj_t BgL_arg3070z00_4732;

							BgL_arg3070z00_4732 = CDR(BgL_fz00_4731);
							BgL_arg3067z00_4729 =
								PROCEDURE_ENTRY(BgL_pz00_8167) (BgL_pz00_8167,
								BgL_arg3070z00_4732, BgL_arg0z00_8168, BgL_arg1z00_8169,
								BgL_arg2z00_8170, BEOA);
						}
					}
					BgL_arg3069z00_4730 =
						BGl_zc3anonymousza33065ze3z83zzast_walkz00(BgL_arg2z00_8170,
						BgL_arg1z00_8169, BgL_arg0z00_8168, BgL_pz00_8167,
						CDR(BgL_l1542z00_4726));
					return bgl_append2(BgL_arg3067z00_4729, BgL_arg3069z00_4730);
				}
		}
	}



/* &walk2*-select2025 */
	obj_t BGl_z62walk2za2zd2select2025z12zzast_walkz00(obj_t BgL_envz00_7227,
		obj_t BgL_nz00_7228, obj_t BgL_pz00_7229, obj_t BgL_arg0z00_7230,
		obj_t BgL_arg1z00_7231)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4691;
				obj_t BgL_pz00_4692;
				obj_t BgL_arg0z00_4693;
				obj_t BgL_arg1z00_4694;

				BgL_nz00_4691 = ((BgL_selectz00_bglt) BgL_nz00_7228);
				BgL_pz00_4692 = BgL_pz00_7229;
				BgL_arg0z00_4693 = BgL_arg0z00_7230;
				BgL_arg1z00_4694 = BgL_arg1z00_7231;
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3052z00_4698;
					obj_t BgL_arg3053z00_4699;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3054z00_4700;

						BgL_arg3054z00_4700 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4691))->BgL_testz00);
						BgL_arg3052z00_4698 =
							PROCEDURE_ENTRY(BgL_pz00_4692) (BgL_pz00_4692,
							((obj_t) BgL_arg3054z00_4700), BgL_arg0z00_4693, BgL_arg1z00_4694,
							BEOA);
					}
					BgL_arg3053z00_4699 =
						BGl_zc3anonymousza33055ze3z83zzast_walkz00(BgL_arg1z00_4694,
						BgL_arg0z00_4693, BgL_pz00_4692,
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4691))->BgL_clausesz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg3052z00_4698,
						BgL_arg3053z00_4699);
				}
			}
		}
	}



/* <anonymous:3055> */
	obj_t BGl_zc3anonymousza33055ze3z83zzast_walkz00(obj_t BgL_arg1z00_8166,
		obj_t BgL_arg0z00_8165, obj_t BgL_pz00_8164, obj_t BgL_l1539z00_4703)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			if (NULLP(BgL_l1539z00_4703))
				{	/* Ast/walk.scm 310 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3057z00_4706;
					obj_t BgL_arg3059z00_4707;

					{	/* Ast/walk.scm 310 */
						obj_t BgL_fz00_4708;

						BgL_fz00_4708 = CAR(BgL_l1539z00_4703);
						{	/* Ast/walk.scm 310 */
							obj_t BgL_arg3060z00_4709;

							BgL_arg3060z00_4709 = CDR(BgL_fz00_4708);
							BgL_arg3057z00_4706 =
								PROCEDURE_ENTRY(BgL_pz00_8164) (BgL_pz00_8164,
								BgL_arg3060z00_4709, BgL_arg0z00_8165, BgL_arg1z00_8166, BEOA);
						}
					}
					BgL_arg3059z00_4707 =
						BGl_zc3anonymousza33055ze3z83zzast_walkz00(BgL_arg1z00_8166,
						BgL_arg0z00_8165, BgL_pz00_8164, CDR(BgL_l1539z00_4703));
					return bgl_append2(BgL_arg3057z00_4706, BgL_arg3059z00_4707);
				}
		}
	}



/* &walk1*-select2023 */
	obj_t BGl_z62walk1za2zd2select2023z12zzast_walkz00(obj_t BgL_envz00_7232,
		obj_t BgL_nz00_7233, obj_t BgL_pz00_7234, obj_t BgL_arg0z00_7235)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4670;
				obj_t BgL_pz00_4671;
				obj_t BgL_arg0z00_4672;

				BgL_nz00_4670 = ((BgL_selectz00_bglt) BgL_nz00_7233);
				BgL_pz00_4671 = BgL_pz00_7234;
				BgL_arg0z00_4672 = BgL_arg0z00_7235;
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3038z00_4676;
					obj_t BgL_arg3039z00_4677;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3040z00_4678;

						BgL_arg3040z00_4678 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4670))->BgL_testz00);
						BgL_arg3038z00_4676 =
							PROCEDURE_ENTRY(BgL_pz00_4671) (BgL_pz00_4671,
							((obj_t) BgL_arg3040z00_4678), BgL_arg0z00_4672, BEOA);
					}
					BgL_arg3039z00_4677 =
						BGl_zc3anonymousza33041ze3z83zzast_walkz00(BgL_arg0z00_4672,
						BgL_pz00_4671,
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4670))->BgL_clausesz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg3038z00_4676,
						BgL_arg3039z00_4677);
				}
			}
		}
	}



/* <anonymous:3041> */
	obj_t BGl_zc3anonymousza33041ze3z83zzast_walkz00(obj_t BgL_arg0z00_8163,
		obj_t BgL_pz00_8162, obj_t BgL_l1536z00_4681)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			if (NULLP(BgL_l1536z00_4681))
				{	/* Ast/walk.scm 310 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3044z00_4684;
					obj_t BgL_arg3045z00_4685;

					{	/* Ast/walk.scm 310 */
						obj_t BgL_fz00_4686;

						BgL_fz00_4686 = CAR(BgL_l1536z00_4681);
						{	/* Ast/walk.scm 310 */
							obj_t BgL_arg3048z00_4687;

							BgL_arg3048z00_4687 = CDR(BgL_fz00_4686);
							BgL_arg3044z00_4684 =
								PROCEDURE_ENTRY(BgL_pz00_8162) (BgL_pz00_8162,
								BgL_arg3048z00_4687, BgL_arg0z00_8163, BEOA);
						}
					}
					BgL_arg3045z00_4685 =
						BGl_zc3anonymousza33041ze3z83zzast_walkz00(BgL_arg0z00_8163,
						BgL_pz00_8162, CDR(BgL_l1536z00_4681));
					return bgl_append2(BgL_arg3044z00_4684, BgL_arg3045z00_4685);
				}
		}
	}



/* &walk0*-select2021 */
	obj_t BGl_z62walk0za2zd2select2021z12zzast_walkz00(obj_t BgL_envz00_7236,
		obj_t BgL_nz00_7237, obj_t BgL_pz00_7238)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4650;
				obj_t BgL_pz00_4651;

				BgL_nz00_4650 = ((BgL_selectz00_bglt) BgL_nz00_7237);
				BgL_pz00_4651 = BgL_pz00_7238;
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3017z00_4655;
					obj_t BgL_arg3018z00_4656;

					{	/* Ast/walk.scm 310 */
						BgL_nodez00_bglt BgL_arg3020z00_4657;

						BgL_arg3020z00_4657 =
							(((BgL_selectz00_bglt) CREF(BgL_nz00_4650))->BgL_testz00);
						BgL_arg3017z00_4655 =
							PROCEDURE_ENTRY(BgL_pz00_4651) (BgL_pz00_4651,
							((obj_t) BgL_arg3020z00_4657), BEOA);
					}
					BgL_arg3018z00_4656 =
						BGl_zc3anonymousza33021ze3z83zzast_walkz00(BgL_pz00_4651,
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4650))->BgL_clausesz00));
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg3017z00_4655,
						BgL_arg3018z00_4656);
				}
			}
		}
	}



/* <anonymous:3021> */
	obj_t BGl_zc3anonymousza33021ze3z83zzast_walkz00(obj_t BgL_pz00_8161,
		obj_t BgL_l1533z00_4660)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			if (NULLP(BgL_l1533z00_4660))
				{	/* Ast/walk.scm 310 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 310 */
					obj_t BgL_arg3023z00_4663;
					obj_t BgL_arg3033z00_4664;

					{	/* Ast/walk.scm 310 */
						obj_t BgL_fz00_4665;

						BgL_fz00_4665 = CAR(BgL_l1533z00_4660);
						{	/* Ast/walk.scm 310 */
							obj_t BgL_arg3035z00_4666;

							BgL_arg3035z00_4666 = CDR(BgL_fz00_4665);
							BgL_arg3023z00_4663 =
								PROCEDURE_ENTRY(BgL_pz00_8161) (BgL_pz00_8161,
								BgL_arg3035z00_4666, BEOA);
						}
					}
					BgL_arg3033z00_4664 =
						BGl_zc3anonymousza33021ze3z83zzast_walkz00(BgL_pz00_8161,
						CDR(BgL_l1533z00_4660));
					return bgl_append2(BgL_arg3023z00_4663, BgL_arg3033z00_4664);
				}
		}
	}



/* &walk3-select2019 */
	obj_t BGl_z62walk3zd2select2019zb0zzast_walkz00(obj_t BgL_envz00_7239,
		obj_t BgL_nz00_7240, obj_t BgL_pz00_7241, obj_t BgL_arg0z00_7242,
		obj_t BgL_arg1z00_7243, obj_t BgL_arg2z00_7244)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4631;
				obj_t BgL_pz00_4632;
				obj_t BgL_arg0z00_4633;
				obj_t BgL_arg1z00_4634;
				obj_t BgL_arg2z00_4635;

				BgL_nz00_4631 = ((BgL_selectz00_bglt) BgL_nz00_7240);
				BgL_pz00_4632 = BgL_pz00_7241;
				BgL_arg0z00_4633 = BgL_arg0z00_7242;
				BgL_arg1z00_4634 = BgL_arg1z00_7243;
				BgL_arg2z00_4635 = BgL_arg2z00_7244;
				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg3011z00_4639;

					BgL_arg3011z00_4639 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4631))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_4632) (BgL_pz00_4632,
						((obj_t) BgL_arg3011z00_4639), BgL_arg0z00_4633, BgL_arg1z00_4634,
						BgL_arg2z00_4635, BEOA);
				}
				{	/* Ast/walk.scm 310 */
					obj_t BgL_g1531z00_4640;

					BgL_g1531z00_4640 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4631))->BgL_clausesz00);
					{
						obj_t BgL_l1528z00_4642;

						{	/* Ast/walk.scm 310 */
							bool_t BgL_auxz00_10041;

							BgL_l1528z00_4642 = BgL_g1531z00_4640;
						BgL_zc3anonymousza33012ze3z83_4643:
							if (PAIRP(BgL_l1528z00_4642))
								{	/* Ast/walk.scm 310 */
									{	/* Ast/walk.scm 310 */
										obj_t BgL_fz00_4645;

										BgL_fz00_4645 = CAR(BgL_l1528z00_4642);
										{	/* Ast/walk.scm 310 */
											obj_t BgL_arg3014z00_4646;

											BgL_arg3014z00_4646 = CDR(BgL_fz00_4645);
											PROCEDURE_ENTRY(BgL_pz00_4632) (BgL_pz00_4632,
												BgL_arg3014z00_4646, BgL_arg0z00_4633, BgL_arg1z00_4634,
												BgL_arg2z00_4635, BEOA);
										}
									}
									{
										obj_t BgL_l1528z00_10053;

										BgL_l1528z00_10053 = CDR(BgL_l1528z00_4642);
										BgL_l1528z00_4642 = BgL_l1528z00_10053;
										goto BgL_zc3anonymousza33012ze3z83_4643;
									}
								}
							else
								{	/* Ast/walk.scm 310 */
									BgL_auxz00_10041 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_10041);
						}
					}
				}
			}
		}
	}



/* &walk2-select2017 */
	obj_t BGl_z62walk2zd2select2017zb0zzast_walkz00(obj_t BgL_envz00_7245,
		obj_t BgL_nz00_7246, obj_t BgL_pz00_7247, obj_t BgL_arg0z00_7248,
		obj_t BgL_arg1z00_7249)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4613;
				obj_t BgL_pz00_4614;
				obj_t BgL_arg0z00_4615;
				obj_t BgL_arg1z00_4616;

				BgL_nz00_4613 = ((BgL_selectz00_bglt) BgL_nz00_7246);
				BgL_pz00_4614 = BgL_pz00_7247;
				BgL_arg0z00_4615 = BgL_arg0z00_7248;
				BgL_arg1z00_4616 = BgL_arg1z00_7249;
				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg3002z00_4620;

					BgL_arg3002z00_4620 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4613))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_4614) (BgL_pz00_4614,
						((obj_t) BgL_arg3002z00_4620), BgL_arg0z00_4615, BgL_arg1z00_4616,
						BEOA);
				}
				{	/* Ast/walk.scm 310 */
					obj_t BgL_g1527z00_4621;

					BgL_g1527z00_4621 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4613))->BgL_clausesz00);
					{
						obj_t BgL_l1525z00_4623;

						{	/* Ast/walk.scm 310 */
							bool_t BgL_auxz00_10066;

							BgL_l1525z00_4623 = BgL_g1527z00_4621;
						BgL_zc3anonymousza33003ze3z83_4624:
							if (PAIRP(BgL_l1525z00_4623))
								{	/* Ast/walk.scm 310 */
									{	/* Ast/walk.scm 310 */
										obj_t BgL_fz00_4626;

										BgL_fz00_4626 = CAR(BgL_l1525z00_4623);
										{	/* Ast/walk.scm 310 */
											obj_t BgL_arg3007z00_4627;

											BgL_arg3007z00_4627 = CDR(BgL_fz00_4626);
											PROCEDURE_ENTRY(BgL_pz00_4614) (BgL_pz00_4614,
												BgL_arg3007z00_4627, BgL_arg0z00_4615, BgL_arg1z00_4616,
												BEOA);
										}
									}
									{
										obj_t BgL_l1525z00_10077;

										BgL_l1525z00_10077 = CDR(BgL_l1525z00_4623);
										BgL_l1525z00_4623 = BgL_l1525z00_10077;
										goto BgL_zc3anonymousza33003ze3z83_4624;
									}
								}
							else
								{	/* Ast/walk.scm 310 */
									BgL_auxz00_10066 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_10066);
						}
					}
				}
			}
		}
	}



/* &walk1-select2015 */
	obj_t BGl_z62walk1zd2select2015zb0zzast_walkz00(obj_t BgL_envz00_7250,
		obj_t BgL_nz00_7251, obj_t BgL_pz00_7252, obj_t BgL_arg0z00_7253)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4596;
				obj_t BgL_pz00_4597;
				obj_t BgL_arg0z00_4598;

				BgL_nz00_4596 = ((BgL_selectz00_bglt) BgL_nz00_7251);
				BgL_pz00_4597 = BgL_pz00_7252;
				BgL_arg0z00_4598 = BgL_arg0z00_7253;
				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg2989z00_4602;

					BgL_arg2989z00_4602 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4596))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_4597) (BgL_pz00_4597,
						((obj_t) BgL_arg2989z00_4602), BgL_arg0z00_4598, BEOA);
				}
				{	/* Ast/walk.scm 310 */
					obj_t BgL_g1524z00_4603;

					BgL_g1524z00_4603 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4596))->BgL_clausesz00);
					{
						obj_t BgL_l1522z00_4605;

						{	/* Ast/walk.scm 310 */
							bool_t BgL_auxz00_10089;

							BgL_l1522z00_4605 = BgL_g1524z00_4603;
						BgL_zc3anonymousza32990ze3z83_4606:
							if (PAIRP(BgL_l1522z00_4605))
								{	/* Ast/walk.scm 310 */
									{	/* Ast/walk.scm 310 */
										obj_t BgL_fz00_4608;

										BgL_fz00_4608 = CAR(BgL_l1522z00_4605);
										{	/* Ast/walk.scm 310 */
											obj_t BgL_arg2992z00_4609;

											BgL_arg2992z00_4609 = CDR(BgL_fz00_4608);
											PROCEDURE_ENTRY(BgL_pz00_4597) (BgL_pz00_4597,
												BgL_arg2992z00_4609, BgL_arg0z00_4598, BEOA);
										}
									}
									{
										obj_t BgL_l1522z00_10099;

										BgL_l1522z00_10099 = CDR(BgL_l1522z00_4605);
										BgL_l1522z00_4605 = BgL_l1522z00_10099;
										goto BgL_zc3anonymousza32990ze3z83_4606;
									}
								}
							else
								{	/* Ast/walk.scm 310 */
									BgL_auxz00_10089 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_10089);
						}
					}
				}
			}
		}
	}



/* &walk0-select2013 */
	obj_t BGl_z62walk0zd2select2013zb0zzast_walkz00(obj_t BgL_envz00_7254,
		obj_t BgL_nz00_7255, obj_t BgL_pz00_7256)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 310 */
			{
				BgL_selectz00_bglt BgL_nz00_4580;
				obj_t BgL_pz00_4581;

				BgL_nz00_4580 = ((BgL_selectz00_bglt) BgL_nz00_7255);
				BgL_pz00_4581 = BgL_pz00_7256;
				{	/* Ast/walk.scm 310 */
					BgL_nodez00_bglt BgL_arg2980z00_4585;

					BgL_arg2980z00_4585 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4580))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_4581) (BgL_pz00_4581,
						((obj_t) BgL_arg2980z00_4585), BEOA);
				}
				{	/* Ast/walk.scm 310 */
					obj_t BgL_g1521z00_4586;

					BgL_g1521z00_4586 =
						(((BgL_selectz00_bglt) CREF(BgL_nz00_4580))->BgL_clausesz00);
					{
						obj_t BgL_l1519z00_4588;

						{	/* Ast/walk.scm 310 */
							bool_t BgL_auxz00_10110;

							BgL_l1519z00_4588 = BgL_g1521z00_4586;
						BgL_zc3anonymousza32981ze3z83_4589:
							if (PAIRP(BgL_l1519z00_4588))
								{	/* Ast/walk.scm 310 */
									{	/* Ast/walk.scm 310 */
										obj_t BgL_fz00_4591;

										BgL_fz00_4591 = CAR(BgL_l1519z00_4588);
										{	/* Ast/walk.scm 310 */
											obj_t BgL_arg2983z00_4592;

											BgL_arg2983z00_4592 = CDR(BgL_fz00_4591);
											PROCEDURE_ENTRY(BgL_pz00_4581) (BgL_pz00_4581,
												BgL_arg2983z00_4592, BEOA);
										}
									}
									{
										obj_t BgL_l1519z00_10119;

										BgL_l1519z00_10119 = CDR(BgL_l1519z00_4588);
										BgL_l1519z00_4588 = BgL_l1519z00_10119;
										goto BgL_zc3anonymousza32981ze3z83_4589;
									}
								}
							else
								{	/* Ast/walk.scm 310 */
									BgL_auxz00_10110 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_10110);
						}
					}
				}
			}
		}
	}



/* &walk3!-sync2011 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2sync2011za2zzast_walkz00(obj_t
		BgL_envz00_7257, obj_t BgL_nz00_7258, obj_t BgL_pz00_7259,
		obj_t BgL_arg0z00_7260, obj_t BgL_arg1z00_7261, obj_t BgL_arg2z00_7262)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4568;
				obj_t BgL_pz00_4569;
				obj_t BgL_arg0z00_4570;
				obj_t BgL_arg1z00_4571;
				obj_t BgL_arg2z00_4572;

				BgL_nz00_4568 = ((BgL_syncz00_bglt) BgL_nz00_7258);
				BgL_pz00_4569 = BgL_pz00_7259;
				BgL_arg0z00_4570 = BgL_arg0z00_7260;
				BgL_arg1z00_4571 = BgL_arg1z00_7261;
				BgL_arg2z00_4572 = BgL_arg2z00_7262;
				{
					BgL_nodez00_bglt BgL_auxz00_10123;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2975z00_4576;

						BgL_arg2975z00_4576 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4568))->BgL_mutexz00);
						BgL_auxz00_10123 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4569) (BgL_pz00_4569,
								((obj_t) BgL_arg2975z00_4576), BgL_arg0z00_4570,
								BgL_arg1z00_4571, BgL_arg2z00_4572, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4568))->BgL_mutexz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10123), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10135;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2978z00_4577;

						BgL_arg2978z00_4577 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4568))->BgL_prelockz00);
						BgL_auxz00_10135 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4569) (BgL_pz00_4569,
								((obj_t) BgL_arg2978z00_4577), BgL_arg0z00_4570,
								BgL_arg1z00_4571, BgL_arg2z00_4572, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4568))->BgL_prelockz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10135), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10147;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2979z00_4578;

						BgL_arg2979z00_4578 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4568))->BgL_bodyz00);
						BgL_auxz00_10147 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4569) (BgL_pz00_4569,
								((obj_t) BgL_arg2979z00_4578), BgL_arg0z00_4570,
								BgL_arg1z00_4571, BgL_arg2z00_4572, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4568))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10147), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4568);
			}
		}
	}



/* &walk2!-sync2009 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2sync2009za2zzast_walkz00(obj_t
		BgL_envz00_7263, obj_t BgL_nz00_7264, obj_t BgL_pz00_7265,
		obj_t BgL_arg0z00_7266, obj_t BgL_arg1z00_7267)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4557;
				obj_t BgL_pz00_4558;
				obj_t BgL_arg0z00_4559;
				obj_t BgL_arg1z00_4560;

				BgL_nz00_4557 = ((BgL_syncz00_bglt) BgL_nz00_7264);
				BgL_pz00_4558 = BgL_pz00_7265;
				BgL_arg0z00_4559 = BgL_arg0z00_7266;
				BgL_arg1z00_4560 = BgL_arg1z00_7267;
				{
					BgL_nodez00_bglt BgL_auxz00_10161;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2971z00_4564;

						BgL_arg2971z00_4564 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4557))->BgL_mutexz00);
						BgL_auxz00_10161 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4558) (BgL_pz00_4558,
								((obj_t) BgL_arg2971z00_4564), BgL_arg0z00_4559,
								BgL_arg1z00_4560, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4557))->BgL_mutexz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10161), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10172;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2972z00_4565;

						BgL_arg2972z00_4565 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4557))->BgL_prelockz00);
						BgL_auxz00_10172 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4558) (BgL_pz00_4558,
								((obj_t) BgL_arg2972z00_4565), BgL_arg0z00_4559,
								BgL_arg1z00_4560, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4557))->BgL_prelockz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10172), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10183;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2973z00_4566;

						BgL_arg2973z00_4566 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4557))->BgL_bodyz00);
						BgL_auxz00_10183 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4558) (BgL_pz00_4558,
								((obj_t) BgL_arg2973z00_4566), BgL_arg0z00_4559,
								BgL_arg1z00_4560, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4557))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10183), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4557);
			}
		}
	}



/* &walk1!-sync2007 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2sync2007za2zzast_walkz00(obj_t
		BgL_envz00_7268, obj_t BgL_nz00_7269, obj_t BgL_pz00_7270,
		obj_t BgL_arg0z00_7271)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4547;
				obj_t BgL_pz00_4548;
				obj_t BgL_arg0z00_4549;

				BgL_nz00_4547 = ((BgL_syncz00_bglt) BgL_nz00_7269);
				BgL_pz00_4548 = BgL_pz00_7270;
				BgL_arg0z00_4549 = BgL_arg0z00_7271;
				{
					BgL_nodez00_bglt BgL_auxz00_10196;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2968z00_4553;

						BgL_arg2968z00_4553 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4547))->BgL_mutexz00);
						BgL_auxz00_10196 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4548) (BgL_pz00_4548,
								((obj_t) BgL_arg2968z00_4553), BgL_arg0z00_4549, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4547))->BgL_mutexz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10196), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10206;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2969z00_4554;

						BgL_arg2969z00_4554 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4547))->BgL_prelockz00);
						BgL_auxz00_10206 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4548) (BgL_pz00_4548,
								((obj_t) BgL_arg2969z00_4554), BgL_arg0z00_4549, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4547))->BgL_prelockz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10206), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10216;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2970z00_4555;

						BgL_arg2970z00_4555 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4547))->BgL_bodyz00);
						BgL_auxz00_10216 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4548) (BgL_pz00_4548,
								((obj_t) BgL_arg2970z00_4555), BgL_arg0z00_4549, BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4547))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10216), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4547);
			}
		}
	}



/* &walk0!-sync2005 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2sync2005za2zzast_walkz00(obj_t
		BgL_envz00_7272, obj_t BgL_nz00_7273, obj_t BgL_pz00_7274)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4538;
				obj_t BgL_pz00_4539;

				BgL_nz00_4538 = ((BgL_syncz00_bglt) BgL_nz00_7273);
				BgL_pz00_4539 = BgL_pz00_7274;
				{
					BgL_nodez00_bglt BgL_auxz00_10228;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2965z00_4543;

						BgL_arg2965z00_4543 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4538))->BgL_mutexz00);
						BgL_auxz00_10228 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4539) (BgL_pz00_4539,
								((obj_t) BgL_arg2965z00_4543), BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4538))->BgL_mutexz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10228), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10237;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2966z00_4544;

						BgL_arg2966z00_4544 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4538))->BgL_prelockz00);
						BgL_auxz00_10237 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4539) (BgL_pz00_4539,
								((obj_t) BgL_arg2966z00_4544), BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4538))->BgL_prelockz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10237), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10246;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2967z00_4545;

						BgL_arg2967z00_4545 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4538))->BgL_bodyz00);
						BgL_auxz00_10246 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4539) (BgL_pz00_4539,
								((obj_t) BgL_arg2967z00_4545), BEOA));
					}
					((((BgL_syncz00_bglt) CREF(BgL_nz00_4538))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10246), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4538);
			}
		}
	}



/* &walk3*-sync2003 */
	obj_t BGl_z62walk3za2zd2sync2003z12zzast_walkz00(obj_t BgL_envz00_7275,
		obj_t BgL_nz00_7276, obj_t BgL_pz00_7277, obj_t BgL_arg0z00_7278,
		obj_t BgL_arg1z00_7279, obj_t BgL_arg2z00_7280)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4520;
				obj_t BgL_pz00_4521;
				obj_t BgL_arg0z00_4522;
				obj_t BgL_arg1z00_4523;
				obj_t BgL_arg2z00_4524;

				BgL_nz00_4520 = ((BgL_syncz00_bglt) BgL_nz00_7276);
				BgL_pz00_4521 = BgL_pz00_7277;
				BgL_arg0z00_4522 = BgL_arg0z00_7278;
				BgL_arg1z00_4523 = BgL_arg1z00_7279;
				BgL_arg2z00_4524 = BgL_arg2z00_7280;
				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg2954z00_4528;
					obj_t BgL_arg2955z00_4529;
					obj_t BgL_arg2956z00_4530;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2962z00_4534;

						BgL_arg2962z00_4534 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4520))->BgL_mutexz00);
						BgL_arg2954z00_4528 =
							PROCEDURE_ENTRY(BgL_pz00_4521) (BgL_pz00_4521,
							((obj_t) BgL_arg2962z00_4534), BgL_arg0z00_4522, BgL_arg1z00_4523,
							BgL_arg2z00_4524, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2963z00_4535;

						BgL_arg2963z00_4535 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4520))->BgL_prelockz00);
						BgL_arg2955z00_4529 =
							PROCEDURE_ENTRY(BgL_pz00_4521) (BgL_pz00_4521,
							((obj_t) BgL_arg2963z00_4535), BgL_arg0z00_4522, BgL_arg1z00_4523,
							BgL_arg2z00_4524, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2964z00_4536;

						BgL_arg2964z00_4536 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4520))->BgL_bodyz00);
						BgL_arg2956z00_4530 =
							PROCEDURE_ENTRY(BgL_pz00_4521) (BgL_pz00_4521,
							((obj_t) BgL_arg2964z00_4536), BgL_arg0z00_4522, BgL_arg1z00_4523,
							BgL_arg2z00_4524, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list2957z00_4531;

						{	/* Ast/walk.scm 309 */
							obj_t BgL_arg2958z00_4532;

							{	/* Ast/walk.scm 309 */
								obj_t BgL_arg2959z00_4533;

								BgL_arg2959z00_4533 = MAKE_PAIR(BgL_arg2956z00_4530, BNIL);
								BgL_arg2958z00_4532 =
									MAKE_PAIR(BgL_arg2955z00_4529, BgL_arg2959z00_4533);
							}
							BgL_list2957z00_4531 =
								MAKE_PAIR(BgL_arg2954z00_4528, BgL_arg2958z00_4532);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2957z00_4531);
					}
				}
			}
		}
	}



/* &walk2*-sync2001 */
	obj_t BGl_z62walk2za2zd2sync2001z12zzast_walkz00(obj_t BgL_envz00_7281,
		obj_t BgL_nz00_7282, obj_t BgL_pz00_7283, obj_t BgL_arg0z00_7284,
		obj_t BgL_arg1z00_7285)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4503;
				obj_t BgL_pz00_4504;
				obj_t BgL_arg0z00_4505;
				obj_t BgL_arg1z00_4506;

				BgL_nz00_4503 = ((BgL_syncz00_bglt) BgL_nz00_7282);
				BgL_pz00_4504 = BgL_pz00_7283;
				BgL_arg0z00_4505 = BgL_arg0z00_7284;
				BgL_arg1z00_4506 = BgL_arg1z00_7285;
				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg2945z00_4510;
					obj_t BgL_arg2946z00_4511;
					obj_t BgL_arg2947z00_4512;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2951z00_4516;

						BgL_arg2951z00_4516 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4503))->BgL_mutexz00);
						BgL_arg2945z00_4510 =
							PROCEDURE_ENTRY(BgL_pz00_4504) (BgL_pz00_4504,
							((obj_t) BgL_arg2951z00_4516), BgL_arg0z00_4505, BgL_arg1z00_4506,
							BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2952z00_4517;

						BgL_arg2952z00_4517 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4503))->BgL_prelockz00);
						BgL_arg2946z00_4511 =
							PROCEDURE_ENTRY(BgL_pz00_4504) (BgL_pz00_4504,
							((obj_t) BgL_arg2952z00_4517), BgL_arg0z00_4505, BgL_arg1z00_4506,
							BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2953z00_4518;

						BgL_arg2953z00_4518 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4503))->BgL_bodyz00);
						BgL_arg2947z00_4512 =
							PROCEDURE_ENTRY(BgL_pz00_4504) (BgL_pz00_4504,
							((obj_t) BgL_arg2953z00_4518), BgL_arg0z00_4505, BgL_arg1z00_4506,
							BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list2948z00_4513;

						{	/* Ast/walk.scm 309 */
							obj_t BgL_arg2949z00_4514;

							{	/* Ast/walk.scm 309 */
								obj_t BgL_arg2950z00_4515;

								BgL_arg2950z00_4515 = MAKE_PAIR(BgL_arg2947z00_4512, BNIL);
								BgL_arg2949z00_4514 =
									MAKE_PAIR(BgL_arg2946z00_4511, BgL_arg2950z00_4515);
							}
							BgL_list2948z00_4513 =
								MAKE_PAIR(BgL_arg2945z00_4510, BgL_arg2949z00_4514);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2948z00_4513);
					}
				}
			}
		}
	}



/* &walk1*-sync1998 */
	obj_t BGl_z62walk1za2zd2sync1998z12zzast_walkz00(obj_t BgL_envz00_7286,
		obj_t BgL_nz00_7287, obj_t BgL_pz00_7288, obj_t BgL_arg0z00_7289)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4487;
				obj_t BgL_pz00_4488;
				obj_t BgL_arg0z00_4489;

				BgL_nz00_4487 = ((BgL_syncz00_bglt) BgL_nz00_7287);
				BgL_pz00_4488 = BgL_pz00_7288;
				BgL_arg0z00_4489 = BgL_arg0z00_7289;
				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg2935z00_4493;
					obj_t BgL_arg2936z00_4494;
					obj_t BgL_arg2937z00_4495;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2942z00_4499;

						BgL_arg2942z00_4499 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4487))->BgL_mutexz00);
						BgL_arg2935z00_4493 =
							PROCEDURE_ENTRY(BgL_pz00_4488) (BgL_pz00_4488,
							((obj_t) BgL_arg2942z00_4499), BgL_arg0z00_4489, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2943z00_4500;

						BgL_arg2943z00_4500 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4487))->BgL_prelockz00);
						BgL_arg2936z00_4494 =
							PROCEDURE_ENTRY(BgL_pz00_4488) (BgL_pz00_4488,
							((obj_t) BgL_arg2943z00_4500), BgL_arg0z00_4489, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2944z00_4501;

						BgL_arg2944z00_4501 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4487))->BgL_bodyz00);
						BgL_arg2937z00_4495 =
							PROCEDURE_ENTRY(BgL_pz00_4488) (BgL_pz00_4488,
							((obj_t) BgL_arg2944z00_4501), BgL_arg0z00_4489, BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list2938z00_4496;

						{	/* Ast/walk.scm 309 */
							obj_t BgL_arg2939z00_4497;

							{	/* Ast/walk.scm 309 */
								obj_t BgL_arg2941z00_4498;

								BgL_arg2941z00_4498 = MAKE_PAIR(BgL_arg2937z00_4495, BNIL);
								BgL_arg2939z00_4497 =
									MAKE_PAIR(BgL_arg2936z00_4494, BgL_arg2941z00_4498);
							}
							BgL_list2938z00_4496 =
								MAKE_PAIR(BgL_arg2935z00_4493, BgL_arg2939z00_4497);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2938z00_4496);
					}
				}
			}
		}
	}



/* &walk0*-sync1996 */
	obj_t BGl_z62walk0za2zd2sync1996z12zzast_walkz00(obj_t BgL_envz00_7290,
		obj_t BgL_nz00_7291, obj_t BgL_pz00_7292)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4472;
				obj_t BgL_pz00_4473;

				BgL_nz00_4472 = ((BgL_syncz00_bglt) BgL_nz00_7291);
				BgL_pz00_4473 = BgL_pz00_7292;
				{	/* Ast/walk.scm 309 */
					obj_t BgL_arg2911z00_4477;
					obj_t BgL_arg2912z00_4478;
					obj_t BgL_arg2925z00_4479;

					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2929z00_4483;

						BgL_arg2929z00_4483 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4472))->BgL_mutexz00);
						BgL_arg2911z00_4477 =
							PROCEDURE_ENTRY(BgL_pz00_4473) (BgL_pz00_4473,
							((obj_t) BgL_arg2929z00_4483), BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2930z00_4484;

						BgL_arg2930z00_4484 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4472))->BgL_prelockz00);
						BgL_arg2912z00_4478 =
							PROCEDURE_ENTRY(BgL_pz00_4473) (BgL_pz00_4473,
							((obj_t) BgL_arg2930z00_4484), BEOA);
					}
					{	/* Ast/walk.scm 309 */
						BgL_nodez00_bglt BgL_arg2934z00_4485;

						BgL_arg2934z00_4485 =
							(((BgL_syncz00_bglt) CREF(BgL_nz00_4472))->BgL_bodyz00);
						BgL_arg2925z00_4479 =
							PROCEDURE_ENTRY(BgL_pz00_4473) (BgL_pz00_4473,
							((obj_t) BgL_arg2934z00_4485), BEOA);
					}
					{	/* Ast/walk.scm 309 */
						obj_t BgL_list2926z00_4480;

						{	/* Ast/walk.scm 309 */
							obj_t BgL_arg2927z00_4481;

							{	/* Ast/walk.scm 309 */
								obj_t BgL_arg2928z00_4482;

								BgL_arg2928z00_4482 = MAKE_PAIR(BgL_arg2925z00_4479, BNIL);
								BgL_arg2927z00_4481 =
									MAKE_PAIR(BgL_arg2912z00_4478, BgL_arg2928z00_4482);
							}
							BgL_list2926z00_4480 =
								MAKE_PAIR(BgL_arg2911z00_4477, BgL_arg2927z00_4481);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2926z00_4480);
					}
				}
			}
		}
	}



/* &walk3-sync1994 */
	obj_t BGl_z62walk3zd2sync1994zb0zzast_walkz00(obj_t BgL_envz00_7293,
		obj_t BgL_nz00_7294, obj_t BgL_pz00_7295, obj_t BgL_arg0z00_7296,
		obj_t BgL_arg1z00_7297, obj_t BgL_arg2z00_7298)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4460;
				obj_t BgL_pz00_4461;
				obj_t BgL_arg0z00_4462;
				obj_t BgL_arg1z00_4463;
				obj_t BgL_arg2z00_4464;

				BgL_nz00_4460 = ((BgL_syncz00_bglt) BgL_nz00_7294);
				BgL_pz00_4461 = BgL_pz00_7295;
				BgL_arg0z00_4462 = BgL_arg0z00_7296;
				BgL_arg1z00_4463 = BgL_arg1z00_7297;
				BgL_arg2z00_4464 = BgL_arg2z00_7298;
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2899z00_4468;

					BgL_arg2899z00_4468 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4460))->BgL_mutexz00);
					PROCEDURE_ENTRY(BgL_pz00_4461) (BgL_pz00_4461,
						((obj_t) BgL_arg2899z00_4468), BgL_arg0z00_4462, BgL_arg1z00_4463,
						BgL_arg2z00_4464, BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2900z00_4469;

					BgL_arg2900z00_4469 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4460))->BgL_prelockz00);
					PROCEDURE_ENTRY(BgL_pz00_4461) (BgL_pz00_4461,
						((obj_t) BgL_arg2900z00_4469), BgL_arg0z00_4462, BgL_arg1z00_4463,
						BgL_arg2z00_4464, BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2910z00_4470;

					BgL_arg2910z00_4470 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4460))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4461) (BgL_pz00_4461,
						((obj_t) BgL_arg2910z00_4470), BgL_arg0z00_4462, BgL_arg1z00_4463,
						BgL_arg2z00_4464, BEOA);
				}
			}
		}
	}



/* &walk2-sync1992 */
	obj_t BGl_z62walk2zd2sync1992zb0zzast_walkz00(obj_t BgL_envz00_7299,
		obj_t BgL_nz00_7300, obj_t BgL_pz00_7301, obj_t BgL_arg0z00_7302,
		obj_t BgL_arg1z00_7303)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4449;
				obj_t BgL_pz00_4450;
				obj_t BgL_arg0z00_4451;
				obj_t BgL_arg1z00_4452;

				BgL_nz00_4449 = ((BgL_syncz00_bglt) BgL_nz00_7300);
				BgL_pz00_4450 = BgL_pz00_7301;
				BgL_arg0z00_4451 = BgL_arg0z00_7302;
				BgL_arg1z00_4452 = BgL_arg1z00_7303;
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2890z00_4456;

					BgL_arg2890z00_4456 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4449))->BgL_mutexz00);
					PROCEDURE_ENTRY(BgL_pz00_4450) (BgL_pz00_4450,
						((obj_t) BgL_arg2890z00_4456), BgL_arg0z00_4451, BgL_arg1z00_4452,
						BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2892z00_4457;

					BgL_arg2892z00_4457 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4449))->BgL_prelockz00);
					PROCEDURE_ENTRY(BgL_pz00_4450) (BgL_pz00_4450,
						((obj_t) BgL_arg2892z00_4457), BgL_arg0z00_4451, BgL_arg1z00_4452,
						BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2898z00_4458;

					BgL_arg2898z00_4458 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4449))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4450) (BgL_pz00_4450,
						((obj_t) BgL_arg2898z00_4458), BgL_arg0z00_4451, BgL_arg1z00_4452,
						BEOA);
				}
			}
		}
	}



/* &walk1-sync1990 */
	obj_t BGl_z62walk1zd2sync1990zb0zzast_walkz00(obj_t BgL_envz00_7304,
		obj_t BgL_nz00_7305, obj_t BgL_pz00_7306, obj_t BgL_arg0z00_7307)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4439;
				obj_t BgL_pz00_4440;
				obj_t BgL_arg0z00_4441;

				BgL_nz00_4439 = ((BgL_syncz00_bglt) BgL_nz00_7305);
				BgL_pz00_4440 = BgL_pz00_7306;
				BgL_arg0z00_4441 = BgL_arg0z00_7307;
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2886z00_4445;

					BgL_arg2886z00_4445 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4439))->BgL_mutexz00);
					PROCEDURE_ENTRY(BgL_pz00_4440) (BgL_pz00_4440,
						((obj_t) BgL_arg2886z00_4445), BgL_arg0z00_4441, BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2887z00_4446;

					BgL_arg2887z00_4446 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4439))->BgL_prelockz00);
					PROCEDURE_ENTRY(BgL_pz00_4440) (BgL_pz00_4440,
						((obj_t) BgL_arg2887z00_4446), BgL_arg0z00_4441, BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2888z00_4447;

					BgL_arg2888z00_4447 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4439))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4440) (BgL_pz00_4440,
						((obj_t) BgL_arg2888z00_4447), BgL_arg0z00_4441, BEOA);
				}
			}
		}
	}



/* &walk0-sync1988 */
	obj_t BGl_z62walk0zd2sync1988zb0zzast_walkz00(obj_t BgL_envz00_7308,
		obj_t BgL_nz00_7309, obj_t BgL_pz00_7310)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 309 */
			{
				BgL_syncz00_bglt BgL_nz00_4430;
				obj_t BgL_pz00_4431;

				BgL_nz00_4430 = ((BgL_syncz00_bglt) BgL_nz00_7309);
				BgL_pz00_4431 = BgL_pz00_7310;
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2883z00_4435;

					BgL_arg2883z00_4435 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4430))->BgL_mutexz00);
					PROCEDURE_ENTRY(BgL_pz00_4431) (BgL_pz00_4431,
						((obj_t) BgL_arg2883z00_4435), BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2884z00_4436;

					BgL_arg2884z00_4436 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4430))->BgL_prelockz00);
					PROCEDURE_ENTRY(BgL_pz00_4431) (BgL_pz00_4431,
						((obj_t) BgL_arg2884z00_4436), BEOA);
				}
				{	/* Ast/walk.scm 309 */
					BgL_nodez00_bglt BgL_arg2885z00_4437;

					BgL_arg2885z00_4437 =
						(((BgL_syncz00_bglt) CREF(BgL_nz00_4430))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4431) (BgL_pz00_4431,
						((obj_t) BgL_arg2885z00_4437), BEOA);
				}
			}
		}
	}



/* &walk3!-box-set!1986 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2boxzd2setz121986z62zzast_walkz00(obj_t
		BgL_envz00_7311, obj_t BgL_nz00_7312, obj_t BgL_pz00_7313,
		obj_t BgL_arg0z00_7314, obj_t BgL_arg1z00_7315, obj_t BgL_arg2z00_7316)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4419;
				obj_t BgL_pz00_4420;
				obj_t BgL_arg0z00_4421;
				obj_t BgL_arg1z00_4422;
				obj_t BgL_arg2z00_4423;

				BgL_nz00_4419 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7312);
				BgL_pz00_4420 = BgL_pz00_7313;
				BgL_arg0z00_4421 = BgL_arg0z00_7314;
				BgL_arg1z00_4422 = BgL_arg1z00_7315;
				BgL_arg2z00_4423 = BgL_arg2z00_7316;
				{
					BgL_varz00_bglt BgL_auxz00_10461;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2879z00_6423;

						BgL_arg2879z00_6423 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4419))->BgL_varz00);
						BgL_auxz00_10461 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4420) (BgL_pz00_4420,
								((obj_t) BgL_arg2879z00_6423), BgL_arg0z00_4421,
								BgL_arg1z00_4422, BgL_arg2z00_4423, BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4419))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10461), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10473;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2882z00_6424;

						BgL_arg2882z00_6424 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4419))->BgL_valuez00);
						BgL_auxz00_10473 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4420) (BgL_pz00_4420,
								((obj_t) BgL_arg2882z00_6424), BgL_arg0z00_4421,
								BgL_arg1z00_4422, BgL_arg2z00_4423, BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4419))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10473), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4419);
			}
		}
	}



/* &walk2!-box-set!1984 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2boxzd2setz121984z62zzast_walkz00(obj_t
		BgL_envz00_7317, obj_t BgL_nz00_7318, obj_t BgL_pz00_7319,
		obj_t BgL_arg0z00_7320, obj_t BgL_arg1z00_7321)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4409;
				obj_t BgL_pz00_4410;
				obj_t BgL_arg0z00_4411;
				obj_t BgL_arg1z00_4412;

				BgL_nz00_4409 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7318);
				BgL_pz00_4410 = BgL_pz00_7319;
				BgL_arg0z00_4411 = BgL_arg0z00_7320;
				BgL_arg1z00_4412 = BgL_arg1z00_7321;
				{
					BgL_varz00_bglt BgL_auxz00_10487;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2877z00_4416;

						BgL_arg2877z00_4416 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4409))->BgL_varz00);
						BgL_auxz00_10487 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4410) (BgL_pz00_4410,
								((obj_t) BgL_arg2877z00_4416), BgL_arg0z00_4411,
								BgL_arg1z00_4412, BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4409))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10487), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10498;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2878z00_4417;

						BgL_arg2878z00_4417 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4409))->BgL_valuez00);
						BgL_auxz00_10498 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4410) (BgL_pz00_4410,
								((obj_t) BgL_arg2878z00_4417), BgL_arg0z00_4411,
								BgL_arg1z00_4412, BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4409))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10498), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4409);
			}
		}
	}



/* &walk1!-box-set!1982 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2boxzd2setz121982z62zzast_walkz00(obj_t
		BgL_envz00_7322, obj_t BgL_nz00_7323, obj_t BgL_pz00_7324,
		obj_t BgL_arg0z00_7325)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4400;
				obj_t BgL_pz00_4401;
				obj_t BgL_arg0z00_4402;

				BgL_nz00_4400 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7323);
				BgL_pz00_4401 = BgL_pz00_7324;
				BgL_arg0z00_4402 = BgL_arg0z00_7325;
				{
					BgL_varz00_bglt BgL_auxz00_10511;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2875z00_4406;

						BgL_arg2875z00_4406 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4400))->BgL_varz00);
						BgL_auxz00_10511 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4401) (BgL_pz00_4401,
								((obj_t) BgL_arg2875z00_4406), BgL_arg0z00_4402, BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4400))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10511), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10521;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2876z00_4407;

						BgL_arg2876z00_4407 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4400))->BgL_valuez00);
						BgL_auxz00_10521 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4401) (BgL_pz00_4401,
								((obj_t) BgL_arg2876z00_4407), BgL_arg0z00_4402, BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4400))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10521), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4400);
			}
		}
	}



/* &walk0!-box-set!1980 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2boxzd2setz121980z62zzast_walkz00(obj_t
		BgL_envz00_7326, obj_t BgL_nz00_7327, obj_t BgL_pz00_7328)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4392;
				obj_t BgL_pz00_4393;

				BgL_nz00_4392 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7327);
				BgL_pz00_4393 = BgL_pz00_7328;
				{
					BgL_varz00_bglt BgL_auxz00_10533;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2873z00_4397;

						BgL_arg2873z00_4397 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4392))->BgL_varz00);
						BgL_auxz00_10533 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4393) (BgL_pz00_4393,
								((obj_t) BgL_arg2873z00_4397), BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4392))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10533), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10542;

					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2874z00_4398;

						BgL_arg2874z00_4398 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4392))->BgL_valuez00);
						BgL_auxz00_10542 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4393) (BgL_pz00_4393,
								((obj_t) BgL_arg2874z00_4398), BEOA));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4392))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10542), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4392);
			}
		}
	}



/* &walk3*-box-set!1978 */
	obj_t BGl_z62walk3za2zd2boxzd2setz121978zd2zzast_walkz00(obj_t
		BgL_envz00_7329, obj_t BgL_nz00_7330, obj_t BgL_pz00_7331,
		obj_t BgL_arg0z00_7332, obj_t BgL_arg1z00_7333, obj_t BgL_arg2z00_7334)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4379;
				obj_t BgL_pz00_4380;
				obj_t BgL_arg0z00_4381;
				obj_t BgL_arg1z00_4382;
				obj_t BgL_arg2z00_4383;

				BgL_nz00_4379 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7330);
				BgL_pz00_4380 = BgL_pz00_7331;
				BgL_arg0z00_4381 = BgL_arg0z00_7332;
				BgL_arg1z00_4382 = BgL_arg1z00_7333;
				BgL_arg2z00_4383 = BgL_arg2z00_7334;
				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2868z00_6418;
					obj_t BgL_arg2869z00_6419;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2870z00_6420;

						BgL_arg2870z00_6420 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4379))->BgL_varz00);
						BgL_arg2868z00_6418 =
							PROCEDURE_ENTRY(BgL_pz00_4380) (BgL_pz00_4380,
							((obj_t) BgL_arg2870z00_6420), BgL_arg0z00_4381, BgL_arg1z00_4382,
							BgL_arg2z00_4383, BEOA);
					}
					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2872z00_6421;

						BgL_arg2872z00_6421 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4379))->BgL_valuez00);
						BgL_arg2869z00_6419 =
							PROCEDURE_ENTRY(BgL_pz00_4380) (BgL_pz00_4380,
							((obj_t) BgL_arg2872z00_6421), BgL_arg0z00_4381, BgL_arg1z00_4382,
							BgL_arg2z00_4383, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2868z00_6418,
						BgL_arg2869z00_6419);
				}
			}
		}
	}



/* &walk2*-box-set!1976 */
	obj_t BGl_z62walk2za2zd2boxzd2setz121976zd2zzast_walkz00(obj_t
		BgL_envz00_7335, obj_t BgL_nz00_7336, obj_t BgL_pz00_7337,
		obj_t BgL_arg0z00_7338, obj_t BgL_arg1z00_7339)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4367;
				obj_t BgL_pz00_4368;
				obj_t BgL_arg0z00_4369;
				obj_t BgL_arg1z00_4370;

				BgL_nz00_4367 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7336);
				BgL_pz00_4368 = BgL_pz00_7337;
				BgL_arg0z00_4369 = BgL_arg0z00_7338;
				BgL_arg1z00_4370 = BgL_arg1z00_7339;
				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2864z00_6413;
					obj_t BgL_arg2865z00_6414;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2866z00_6415;

						BgL_arg2866z00_6415 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4367))->BgL_varz00);
						BgL_arg2864z00_6413 =
							PROCEDURE_ENTRY(BgL_pz00_4368) (BgL_pz00_4368,
							((obj_t) BgL_arg2866z00_6415), BgL_arg0z00_4369, BgL_arg1z00_4370,
							BEOA);
					}
					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2867z00_6416;

						BgL_arg2867z00_6416 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4367))->BgL_valuez00);
						BgL_arg2865z00_6414 =
							PROCEDURE_ENTRY(BgL_pz00_4368) (BgL_pz00_4368,
							((obj_t) BgL_arg2867z00_6416), BgL_arg0z00_4369, BgL_arg1z00_4370,
							BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2864z00_6413,
						BgL_arg2865z00_6414);
				}
			}
		}
	}



/* &walk1*-box-set!1974 */
	obj_t BGl_z62walk1za2zd2boxzd2setz121974zd2zzast_walkz00(obj_t
		BgL_envz00_7340, obj_t BgL_nz00_7341, obj_t BgL_pz00_7342,
		obj_t BgL_arg0z00_7343)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4356;
				obj_t BgL_pz00_4357;
				obj_t BgL_arg0z00_4358;

				BgL_nz00_4356 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7341);
				BgL_pz00_4357 = BgL_pz00_7342;
				BgL_arg0z00_4358 = BgL_arg0z00_7343;
				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2860z00_4362;
					obj_t BgL_arg2861z00_4363;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2862z00_4364;

						BgL_arg2862z00_4364 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4356))->BgL_varz00);
						BgL_arg2860z00_4362 =
							PROCEDURE_ENTRY(BgL_pz00_4357) (BgL_pz00_4357,
							((obj_t) BgL_arg2862z00_4364), BgL_arg0z00_4358, BEOA);
					}
					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2863z00_4365;

						BgL_arg2863z00_4365 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4356))->BgL_valuez00);
						BgL_arg2861z00_4363 =
							PROCEDURE_ENTRY(BgL_pz00_4357) (BgL_pz00_4357,
							((obj_t) BgL_arg2863z00_4365), BgL_arg0z00_4358, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2860z00_4362,
						BgL_arg2861z00_4363);
				}
			}
		}
	}



/* &walk0*-box-set!1972 */
	obj_t BGl_z62walk0za2zd2boxzd2setz121972zd2zzast_walkz00(obj_t
		BgL_envz00_7344, obj_t BgL_nz00_7345, obj_t BgL_pz00_7346)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4346;
				obj_t BgL_pz00_4347;

				BgL_nz00_4346 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7345);
				BgL_pz00_4347 = BgL_pz00_7346;
				{	/* Ast/walk.scm 308 */
					obj_t BgL_arg2856z00_4351;
					obj_t BgL_arg2857z00_4352;

					{	/* Ast/walk.scm 308 */
						BgL_varz00_bglt BgL_arg2858z00_4353;

						BgL_arg2858z00_4353 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4346))->BgL_varz00);
						BgL_arg2856z00_4351 =
							PROCEDURE_ENTRY(BgL_pz00_4347) (BgL_pz00_4347,
							((obj_t) BgL_arg2858z00_4353), BEOA);
					}
					{	/* Ast/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg2859z00_4354;

						BgL_arg2859z00_4354 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4346))->BgL_valuez00);
						BgL_arg2857z00_4352 =
							PROCEDURE_ENTRY(BgL_pz00_4347) (BgL_pz00_4347,
							((obj_t) BgL_arg2859z00_4354), BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2856z00_4351,
						BgL_arg2857z00_4352);
				}
			}
		}
	}



/* &walk3-box-set!1970 */
	obj_t BGl_z62walk3zd2boxzd2setz121970z70zzast_walkz00(obj_t BgL_envz00_7347,
		obj_t BgL_nz00_7348, obj_t BgL_pz00_7349, obj_t BgL_arg0z00_7350,
		obj_t BgL_arg1z00_7351, obj_t BgL_arg2z00_7352)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4335;
				obj_t BgL_pz00_4336;
				obj_t BgL_arg0z00_4337;
				obj_t BgL_arg1z00_4338;
				obj_t BgL_arg2z00_4339;

				BgL_nz00_4335 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7348);
				BgL_pz00_4336 = BgL_pz00_7349;
				BgL_arg0z00_4337 = BgL_arg0z00_7350;
				BgL_arg1z00_4338 = BgL_arg1z00_7351;
				BgL_arg2z00_4339 = BgL_arg2z00_7352;
				{	/* Ast/walk.scm 308 */
					BgL_varz00_bglt BgL_arg2854z00_6410;

					BgL_arg2854z00_6410 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4335))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_4336) (BgL_pz00_4336,
						((obj_t) BgL_arg2854z00_6410), BgL_arg0z00_4337, BgL_arg1z00_4338,
						BgL_arg2z00_4339, BEOA);
				}
				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2855z00_6411;

					BgL_arg2855z00_6411 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4335))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4336) (BgL_pz00_4336,
						((obj_t) BgL_arg2855z00_6411), BgL_arg0z00_4337, BgL_arg1z00_4338,
						BgL_arg2z00_4339, BEOA);
				}
			}
		}
	}



/* &walk2-box-set!1968 */
	obj_t BGl_z62walk2zd2boxzd2setz121968z70zzast_walkz00(obj_t BgL_envz00_7353,
		obj_t BgL_nz00_7354, obj_t BgL_pz00_7355, obj_t BgL_arg0z00_7356,
		obj_t BgL_arg1z00_7357)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4325;
				obj_t BgL_pz00_4326;
				obj_t BgL_arg0z00_4327;
				obj_t BgL_arg1z00_4328;

				BgL_nz00_4325 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7354);
				BgL_pz00_4326 = BgL_pz00_7355;
				BgL_arg0z00_4327 = BgL_arg0z00_7356;
				BgL_arg1z00_4328 = BgL_arg1z00_7357;
				{	/* Ast/walk.scm 308 */
					BgL_varz00_bglt BgL_arg2852z00_6407;

					BgL_arg2852z00_6407 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4325))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_4326) (BgL_pz00_4326,
						((obj_t) BgL_arg2852z00_6407), BgL_arg0z00_4327, BgL_arg1z00_4328,
						BEOA);
				}
				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2853z00_6408;

					BgL_arg2853z00_6408 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4325))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4326) (BgL_pz00_4326,
						((obj_t) BgL_arg2853z00_6408), BgL_arg0z00_4327, BgL_arg1z00_4328,
						BEOA);
				}
			}
		}
	}



/* &walk1-box-set!1966 */
	obj_t BGl_z62walk1zd2boxzd2setz121966z70zzast_walkz00(obj_t BgL_envz00_7358,
		obj_t BgL_nz00_7359, obj_t BgL_pz00_7360, obj_t BgL_arg0z00_7361)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4316;
				obj_t BgL_pz00_4317;
				obj_t BgL_arg0z00_4318;

				BgL_nz00_4316 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7359);
				BgL_pz00_4317 = BgL_pz00_7360;
				BgL_arg0z00_4318 = BgL_arg0z00_7361;
				{	/* Ast/walk.scm 308 */
					BgL_varz00_bglt BgL_arg2850z00_6404;

					BgL_arg2850z00_6404 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4316))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_4317) (BgL_pz00_4317,
						((obj_t) BgL_arg2850z00_6404), BgL_arg0z00_4318, BEOA);
				}
				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2851z00_6405;

					BgL_arg2851z00_6405 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4316))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4317) (BgL_pz00_4317,
						((obj_t) BgL_arg2851z00_6405), BgL_arg0z00_4318, BEOA);
				}
			}
		}
	}



/* &walk0-box-set!1964 */
	obj_t BGl_z62walk0zd2boxzd2setz121964z70zzast_walkz00(obj_t BgL_envz00_7362,
		obj_t BgL_nz00_7363, obj_t BgL_pz00_7364)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 308 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nz00_4308;
				obj_t BgL_pz00_4309;

				BgL_nz00_4308 = ((BgL_boxzd2setz12zc0_bglt) BgL_nz00_7363);
				BgL_pz00_4309 = BgL_pz00_7364;
				{	/* Ast/walk.scm 308 */
					BgL_varz00_bglt BgL_arg2845z00_6401;

					BgL_arg2845z00_6401 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4308))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_4309) (BgL_pz00_4309,
						((obj_t) BgL_arg2845z00_6401), BEOA);
				}
				{	/* Ast/walk.scm 308 */
					BgL_nodez00_bglt BgL_arg2846z00_6402;

					BgL_arg2846z00_6402 =
						(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nz00_4308))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4309) (BgL_pz00_4309,
						((obj_t) BgL_arg2846z00_6402), BEOA);
				}
			}
		}
	}



/* &walk3!-box-ref1962 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2boxzd2ref1962z70zzast_walkz00(obj_t
		BgL_envz00_7365, obj_t BgL_nz00_7366, obj_t BgL_pz00_7367,
		obj_t BgL_arg0z00_7368, obj_t BgL_arg1z00_7369, obj_t BgL_arg2z00_7370)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4298;
				obj_t BgL_pz00_4299;
				obj_t BgL_arg0z00_4300;
				obj_t BgL_arg1z00_4301;
				obj_t BgL_arg2z00_4302;

				BgL_nz00_4298 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7366);
				BgL_pz00_4299 = BgL_pz00_7367;
				BgL_arg0z00_4300 = BgL_arg0z00_7368;
				BgL_arg1z00_4301 = BgL_arg1z00_7369;
				BgL_arg2z00_4302 = BgL_arg2z00_7370;
				{
					BgL_varz00_bglt BgL_auxz00_10685;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2844z00_6399;

						BgL_arg2844z00_6399 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4298))->BgL_varz00);
						BgL_auxz00_10685 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4299) (BgL_pz00_4299,
								((obj_t) BgL_arg2844z00_6399), BgL_arg0z00_4300,
								BgL_arg1z00_4301, BgL_arg2z00_4302, BEOA));
					}
					((((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4298))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10685), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4298);
			}
		}
	}



/* &walk2!-box-ref1960 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2boxzd2ref1960z70zzast_walkz00(obj_t
		BgL_envz00_7371, obj_t BgL_nz00_7372, obj_t BgL_pz00_7373,
		obj_t BgL_arg0z00_7374, obj_t BgL_arg1z00_7375)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4289;
				obj_t BgL_pz00_4290;
				obj_t BgL_arg0z00_4291;
				obj_t BgL_arg1z00_4292;

				BgL_nz00_4289 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7372);
				BgL_pz00_4290 = BgL_pz00_7373;
				BgL_arg0z00_4291 = BgL_arg0z00_7374;
				BgL_arg1z00_4292 = BgL_arg1z00_7375;
				{
					BgL_varz00_bglt BgL_auxz00_10699;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2843z00_6397;

						BgL_arg2843z00_6397 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4289))->BgL_varz00);
						BgL_auxz00_10699 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4290) (BgL_pz00_4290,
								((obj_t) BgL_arg2843z00_6397), BgL_arg0z00_4291,
								BgL_arg1z00_4292, BEOA));
					}
					((((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4289))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10699), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4289);
			}
		}
	}



/* &walk1!-box-ref1958 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2boxzd2ref1958z70zzast_walkz00(obj_t
		BgL_envz00_7376, obj_t BgL_nz00_7377, obj_t BgL_pz00_7378,
		obj_t BgL_arg0z00_7379)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4281;
				obj_t BgL_pz00_4282;
				obj_t BgL_arg0z00_4283;

				BgL_nz00_4281 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7377);
				BgL_pz00_4282 = BgL_pz00_7378;
				BgL_arg0z00_4283 = BgL_arg0z00_7379;
				{
					BgL_varz00_bglt BgL_auxz00_10712;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2842z00_6395;

						BgL_arg2842z00_6395 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4281))->BgL_varz00);
						BgL_auxz00_10712 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4282) (BgL_pz00_4282,
								((obj_t) BgL_arg2842z00_6395), BgL_arg0z00_4283, BEOA));
					}
					((((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4281))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10712), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4281);
			}
		}
	}



/* &walk0!-box-ref1956 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2boxzd2ref1956z70zzast_walkz00(obj_t
		BgL_envz00_7380, obj_t BgL_nz00_7381, obj_t BgL_pz00_7382)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4274;
				obj_t BgL_pz00_4275;

				BgL_nz00_4274 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7381);
				BgL_pz00_4275 = BgL_pz00_7382;
				{
					BgL_varz00_bglt BgL_auxz00_10724;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2841z00_6393;

						BgL_arg2841z00_6393 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4274))->BgL_varz00);
						BgL_auxz00_10724 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4275) (BgL_pz00_4275,
								((obj_t) BgL_arg2841z00_6393), BEOA));
					}
					((((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4274))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_10724), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4274);
			}
		}
	}



/* &walk3*-box-ref1954 */
	obj_t BGl_z62walk3za2zd2boxzd2ref1954zc0zzast_walkz00(obj_t BgL_envz00_7383,
		obj_t BgL_nz00_7384, obj_t BgL_pz00_7385, obj_t BgL_arg0z00_7386,
		obj_t BgL_arg1z00_7387, obj_t BgL_arg2z00_7388)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4262;
				obj_t BgL_pz00_4263;
				obj_t BgL_arg0z00_4264;
				obj_t BgL_arg1z00_4265;
				obj_t BgL_arg2z00_4266;

				BgL_nz00_4262 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7384);
				BgL_pz00_4263 = BgL_pz00_7385;
				BgL_arg0z00_4264 = BgL_arg0z00_7386;
				BgL_arg1z00_4265 = BgL_arg1z00_7387;
				BgL_arg2z00_4266 = BgL_arg2z00_7388;
				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2838z00_6389;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2840z00_6390;

						BgL_arg2840z00_6390 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4262))->BgL_varz00);
						BgL_arg2838z00_6389 =
							PROCEDURE_ENTRY(BgL_pz00_4263) (BgL_pz00_4263,
							((obj_t) BgL_arg2840z00_6390), BgL_arg0z00_4264, BgL_arg1z00_4265,
							BgL_arg2z00_4266, BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2839z00_6391;

						BgL_list2839z00_6391 = MAKE_PAIR(BgL_arg2838z00_6389, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2839z00_6391);
					}
				}
			}
		}
	}



/* &walk2*-box-ref1952 */
	obj_t BGl_z62walk2za2zd2boxzd2ref1952zc0zzast_walkz00(obj_t BgL_envz00_7389,
		obj_t BgL_nz00_7390, obj_t BgL_pz00_7391, obj_t BgL_arg0z00_7392,
		obj_t BgL_arg1z00_7393)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4251;
				obj_t BgL_pz00_4252;
				obj_t BgL_arg0z00_4253;
				obj_t BgL_arg1z00_4254;

				BgL_nz00_4251 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7390);
				BgL_pz00_4252 = BgL_pz00_7391;
				BgL_arg0z00_4253 = BgL_arg0z00_7392;
				BgL_arg1z00_4254 = BgL_arg1z00_7393;
				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2832z00_6385;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2834z00_6386;

						BgL_arg2834z00_6386 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4251))->BgL_varz00);
						BgL_arg2832z00_6385 =
							PROCEDURE_ENTRY(BgL_pz00_4252) (BgL_pz00_4252,
							((obj_t) BgL_arg2834z00_6386), BgL_arg0z00_4253, BgL_arg1z00_4254,
							BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2833z00_6387;

						BgL_list2833z00_6387 = MAKE_PAIR(BgL_arg2832z00_6385, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2833z00_6387);
					}
				}
			}
		}
	}



/* &walk1*-box-ref1949 */
	obj_t BGl_z62walk1za2zd2boxzd2ref1949zc0zzast_walkz00(obj_t BgL_envz00_7394,
		obj_t BgL_nz00_7395, obj_t BgL_pz00_7396, obj_t BgL_arg0z00_7397)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4241;
				obj_t BgL_pz00_4242;
				obj_t BgL_arg0z00_4243;

				BgL_nz00_4241 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7395);
				BgL_pz00_4242 = BgL_pz00_7396;
				BgL_arg0z00_4243 = BgL_arg0z00_7397;
				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2829z00_6381;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2831z00_6382;

						BgL_arg2831z00_6382 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4241))->BgL_varz00);
						BgL_arg2829z00_6381 =
							PROCEDURE_ENTRY(BgL_pz00_4242) (BgL_pz00_4242,
							((obj_t) BgL_arg2831z00_6382), BgL_arg0z00_4243, BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2830z00_6383;

						BgL_list2830z00_6383 = MAKE_PAIR(BgL_arg2829z00_6381, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2830z00_6383);
					}
				}
			}
		}
	}



/* &walk0*-box-ref1947 */
	obj_t BGl_z62walk0za2zd2boxzd2ref1947zc0zzast_walkz00(obj_t BgL_envz00_7398,
		obj_t BgL_nz00_7399, obj_t BgL_pz00_7400)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4232;
				obj_t BgL_pz00_4233;

				BgL_nz00_4232 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7399);
				BgL_pz00_4233 = BgL_pz00_7400;
				{	/* Ast/walk.scm 307 */
					obj_t BgL_arg2811z00_6377;

					{	/* Ast/walk.scm 307 */
						BgL_varz00_bglt BgL_arg2818z00_6378;

						BgL_arg2818z00_6378 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4232))->BgL_varz00);
						BgL_arg2811z00_6377 =
							PROCEDURE_ENTRY(BgL_pz00_4233) (BgL_pz00_4233,
							((obj_t) BgL_arg2818z00_6378), BEOA);
					}
					{	/* Ast/walk.scm 307 */
						obj_t BgL_list2812z00_6379;

						BgL_list2812z00_6379 = MAKE_PAIR(BgL_arg2811z00_6377, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2812z00_6379);
					}
				}
			}
		}
	}



/* &walk3-box-ref1945 */
	obj_t BGl_z62walk3zd2boxzd2ref1945z62zzast_walkz00(obj_t BgL_envz00_7401,
		obj_t BgL_nz00_7402, obj_t BgL_pz00_7403, obj_t BgL_arg0z00_7404,
		obj_t BgL_arg1z00_7405, obj_t BgL_arg2z00_7406)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4222;
				obj_t BgL_pz00_4223;
				obj_t BgL_arg0z00_4224;
				obj_t BgL_arg1z00_4225;
				obj_t BgL_arg2z00_4226;

				BgL_nz00_4222 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7402);
				BgL_pz00_4223 = BgL_pz00_7403;
				BgL_arg0z00_4224 = BgL_arg0z00_7404;
				BgL_arg1z00_4225 = BgL_arg1z00_7405;
				BgL_arg2z00_4226 = BgL_arg2z00_7406;
				{	/* Ast/walk.scm 307 */
					BgL_varz00_bglt BgL_arg2810z00_6375;

					BgL_arg2810z00_6375 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4222))->BgL_varz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4223) (BgL_pz00_4223,
						((obj_t) BgL_arg2810z00_6375), BgL_arg0z00_4224, BgL_arg1z00_4225,
						BgL_arg2z00_4226, BEOA);
				}
			}
		}
	}



/* &walk2-box-ref1943 */
	obj_t BGl_z62walk2zd2boxzd2ref1943z62zzast_walkz00(obj_t BgL_envz00_7407,
		obj_t BgL_nz00_7408, obj_t BgL_pz00_7409, obj_t BgL_arg0z00_7410,
		obj_t BgL_arg1z00_7411)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4213;
				obj_t BgL_pz00_4214;
				obj_t BgL_arg0z00_4215;
				obj_t BgL_arg1z00_4216;

				BgL_nz00_4213 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7408);
				BgL_pz00_4214 = BgL_pz00_7409;
				BgL_arg0z00_4215 = BgL_arg0z00_7410;
				BgL_arg1z00_4216 = BgL_arg1z00_7411;
				{	/* Ast/walk.scm 307 */
					BgL_varz00_bglt BgL_arg2809z00_6373;

					BgL_arg2809z00_6373 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4213))->BgL_varz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4214) (BgL_pz00_4214,
						((obj_t) BgL_arg2809z00_6373), BgL_arg0z00_4215, BgL_arg1z00_4216,
						BEOA);
				}
			}
		}
	}



/* &walk1-box-ref1941 */
	obj_t BGl_z62walk1zd2boxzd2ref1941z62zzast_walkz00(obj_t BgL_envz00_7412,
		obj_t BgL_nz00_7413, obj_t BgL_pz00_7414, obj_t BgL_arg0z00_7415)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4205;
				obj_t BgL_pz00_4206;
				obj_t BgL_arg0z00_4207;

				BgL_nz00_4205 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7413);
				BgL_pz00_4206 = BgL_pz00_7414;
				BgL_arg0z00_4207 = BgL_arg0z00_7415;
				{	/* Ast/walk.scm 307 */
					BgL_varz00_bglt BgL_arg2808z00_6371;

					BgL_arg2808z00_6371 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4205))->BgL_varz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4206) (BgL_pz00_4206,
						((obj_t) BgL_arg2808z00_6371), BgL_arg0z00_4207, BEOA);
				}
			}
		}
	}



/* &walk0-box-ref1939 */
	obj_t BGl_z62walk0zd2boxzd2ref1939z62zzast_walkz00(obj_t BgL_envz00_7416,
		obj_t BgL_nz00_7417, obj_t BgL_pz00_7418)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 307 */
			{
				BgL_boxzd2refzd2_bglt BgL_nz00_4198;
				obj_t BgL_pz00_4199;

				BgL_nz00_4198 = ((BgL_boxzd2refzd2_bglt) BgL_nz00_7417);
				BgL_pz00_4199 = BgL_pz00_7418;
				{	/* Ast/walk.scm 307 */
					BgL_varz00_bglt BgL_arg2807z00_6369;

					BgL_arg2807z00_6369 =
						(((BgL_boxzd2refzd2_bglt) CREF(BgL_nz00_4198))->BgL_varz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4199) (BgL_pz00_4199,
						((obj_t) BgL_arg2807z00_6369), BEOA);
				}
			}
		}
	}



/* &walk3!-make-box1937 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2makezd2box1937z70zzast_walkz00(obj_t
		BgL_envz00_7419, obj_t BgL_nz00_7420, obj_t BgL_pz00_7421,
		obj_t BgL_arg0z00_7422, obj_t BgL_arg1z00_7423, obj_t BgL_arg2z00_7424)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4188;
				obj_t BgL_pz00_4189;
				obj_t BgL_arg0z00_4190;
				obj_t BgL_arg1z00_4191;
				obj_t BgL_arg2z00_4192;

				BgL_nz00_4188 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7420);
				BgL_pz00_4189 = BgL_pz00_7421;
				BgL_arg0z00_4190 = BgL_arg0z00_7422;
				BgL_arg1z00_4191 = BgL_arg1z00_7423;
				BgL_arg2z00_4192 = BgL_arg2z00_7424;
				{
					BgL_nodez00_bglt BgL_auxz00_10811;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2806z00_6367;

						BgL_arg2806z00_6367 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4188))->BgL_valuez00);
						BgL_auxz00_10811 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4189) (BgL_pz00_4189,
								((obj_t) BgL_arg2806z00_6367), BgL_arg0z00_4190,
								BgL_arg1z00_4191, BgL_arg2z00_4192, BEOA));
					}
					((((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4188))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10811), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4188);
			}
		}
	}



/* &walk2!-make-box1935 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2makezd2box1935z70zzast_walkz00(obj_t
		BgL_envz00_7425, obj_t BgL_nz00_7426, obj_t BgL_pz00_7427,
		obj_t BgL_arg0z00_7428, obj_t BgL_arg1z00_7429)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4179;
				obj_t BgL_pz00_4180;
				obj_t BgL_arg0z00_4181;
				obj_t BgL_arg1z00_4182;

				BgL_nz00_4179 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7426);
				BgL_pz00_4180 = BgL_pz00_7427;
				BgL_arg0z00_4181 = BgL_arg0z00_7428;
				BgL_arg1z00_4182 = BgL_arg1z00_7429;
				{
					BgL_nodez00_bglt BgL_auxz00_10825;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2805z00_6365;

						BgL_arg2805z00_6365 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4179))->BgL_valuez00);
						BgL_auxz00_10825 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4180) (BgL_pz00_4180,
								((obj_t) BgL_arg2805z00_6365), BgL_arg0z00_4181,
								BgL_arg1z00_4182, BEOA));
					}
					((((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4179))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10825), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4179);
			}
		}
	}



/* &walk1!-make-box1933 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2makezd2box1933z70zzast_walkz00(obj_t
		BgL_envz00_7430, obj_t BgL_nz00_7431, obj_t BgL_pz00_7432,
		obj_t BgL_arg0z00_7433)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4171;
				obj_t BgL_pz00_4172;
				obj_t BgL_arg0z00_4173;

				BgL_nz00_4171 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7431);
				BgL_pz00_4172 = BgL_pz00_7432;
				BgL_arg0z00_4173 = BgL_arg0z00_7433;
				{
					BgL_nodez00_bglt BgL_auxz00_10838;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2803z00_6363;

						BgL_arg2803z00_6363 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4171))->BgL_valuez00);
						BgL_auxz00_10838 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4172) (BgL_pz00_4172,
								((obj_t) BgL_arg2803z00_6363), BgL_arg0z00_4173, BEOA));
					}
					((((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4171))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10838), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4171);
			}
		}
	}



/* &walk0!-make-box1931 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2makezd2box1931z70zzast_walkz00(obj_t
		BgL_envz00_7434, obj_t BgL_nz00_7435, obj_t BgL_pz00_7436)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4164;
				obj_t BgL_pz00_4165;

				BgL_nz00_4164 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7435);
				BgL_pz00_4165 = BgL_pz00_7436;
				{
					BgL_nodez00_bglt BgL_auxz00_10850;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2802z00_6361;

						BgL_arg2802z00_6361 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4164))->BgL_valuez00);
						BgL_auxz00_10850 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4165) (BgL_pz00_4165,
								((obj_t) BgL_arg2802z00_6361), BEOA));
					}
					((((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4164))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10850), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4164);
			}
		}
	}



/* &walk3*-make-box1929 */
	obj_t BGl_z62walk3za2zd2makezd2box1929zc0zzast_walkz00(obj_t BgL_envz00_7437,
		obj_t BgL_nz00_7438, obj_t BgL_pz00_7439, obj_t BgL_arg0z00_7440,
		obj_t BgL_arg1z00_7441, obj_t BgL_arg2z00_7442)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4152;
				obj_t BgL_pz00_4153;
				obj_t BgL_arg0z00_4154;
				obj_t BgL_arg1z00_4155;
				obj_t BgL_arg2z00_4156;

				BgL_nz00_4152 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7438);
				BgL_pz00_4153 = BgL_pz00_7439;
				BgL_arg0z00_4154 = BgL_arg0z00_7440;
				BgL_arg1z00_4155 = BgL_arg1z00_7441;
				BgL_arg2z00_4156 = BgL_arg2z00_7442;
				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2798z00_6357;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2801z00_6358;

						BgL_arg2801z00_6358 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4152))->BgL_valuez00);
						BgL_arg2798z00_6357 =
							PROCEDURE_ENTRY(BgL_pz00_4153) (BgL_pz00_4153,
							((obj_t) BgL_arg2801z00_6358), BgL_arg0z00_4154, BgL_arg1z00_4155,
							BgL_arg2z00_4156, BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2799z00_6359;

						BgL_list2799z00_6359 = MAKE_PAIR(BgL_arg2798z00_6357, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2799z00_6359);
					}
				}
			}
		}
	}



/* &walk2*-make-box1927 */
	obj_t BGl_z62walk2za2zd2makezd2box1927zc0zzast_walkz00(obj_t BgL_envz00_7443,
		obj_t BgL_nz00_7444, obj_t BgL_pz00_7445, obj_t BgL_arg0z00_7446,
		obj_t BgL_arg1z00_7447)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4141;
				obj_t BgL_pz00_4142;
				obj_t BgL_arg0z00_4143;
				obj_t BgL_arg1z00_4144;

				BgL_nz00_4141 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7444);
				BgL_pz00_4142 = BgL_pz00_7445;
				BgL_arg0z00_4143 = BgL_arg0z00_7446;
				BgL_arg1z00_4144 = BgL_arg1z00_7447;
				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2794z00_6353;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2797z00_6354;

						BgL_arg2797z00_6354 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4141))->BgL_valuez00);
						BgL_arg2794z00_6353 =
							PROCEDURE_ENTRY(BgL_pz00_4142) (BgL_pz00_4142,
							((obj_t) BgL_arg2797z00_6354), BgL_arg0z00_4143, BgL_arg1z00_4144,
							BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2795z00_6355;

						BgL_list2795z00_6355 = MAKE_PAIR(BgL_arg2794z00_6353, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2795z00_6355);
					}
				}
			}
		}
	}



/* &walk1*-make-box1925 */
	obj_t BGl_z62walk1za2zd2makezd2box1925zc0zzast_walkz00(obj_t BgL_envz00_7448,
		obj_t BgL_nz00_7449, obj_t BgL_pz00_7450, obj_t BgL_arg0z00_7451)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4131;
				obj_t BgL_pz00_4132;
				obj_t BgL_arg0z00_4133;

				BgL_nz00_4131 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7449);
				BgL_pz00_4132 = BgL_pz00_7450;
				BgL_arg0z00_4133 = BgL_arg0z00_7451;
				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2790z00_6349;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2792z00_6350;

						BgL_arg2792z00_6350 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4131))->BgL_valuez00);
						BgL_arg2790z00_6349 =
							PROCEDURE_ENTRY(BgL_pz00_4132) (BgL_pz00_4132,
							((obj_t) BgL_arg2792z00_6350), BgL_arg0z00_4133, BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2791z00_6351;

						BgL_list2791z00_6351 = MAKE_PAIR(BgL_arg2790z00_6349, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2791z00_6351);
					}
				}
			}
		}
	}



/* &walk0*-make-box1923 */
	obj_t BGl_z62walk0za2zd2makezd2box1923zc0zzast_walkz00(obj_t BgL_envz00_7452,
		obj_t BgL_nz00_7453, obj_t BgL_pz00_7454)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4122;
				obj_t BgL_pz00_4123;

				BgL_nz00_4122 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7453);
				BgL_pz00_4123 = BgL_pz00_7454;
				{	/* Ast/walk.scm 306 */
					obj_t BgL_arg2785z00_6345;

					{	/* Ast/walk.scm 306 */
						BgL_nodez00_bglt BgL_arg2787z00_6346;

						BgL_arg2787z00_6346 =
							(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4122))->BgL_valuez00);
						BgL_arg2785z00_6345 =
							PROCEDURE_ENTRY(BgL_pz00_4123) (BgL_pz00_4123,
							((obj_t) BgL_arg2787z00_6346), BEOA);
					}
					{	/* Ast/walk.scm 306 */
						obj_t BgL_list2786z00_6347;

						BgL_list2786z00_6347 = MAKE_PAIR(BgL_arg2785z00_6345, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2786z00_6347);
					}
				}
			}
		}
	}



/* &walk3-make-box1921 */
	obj_t BGl_z62walk3zd2makezd2box1921z62zzast_walkz00(obj_t BgL_envz00_7455,
		obj_t BgL_nz00_7456, obj_t BgL_pz00_7457, obj_t BgL_arg0z00_7458,
		obj_t BgL_arg1z00_7459, obj_t BgL_arg2z00_7460)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4112;
				obj_t BgL_pz00_4113;
				obj_t BgL_arg0z00_4114;
				obj_t BgL_arg1z00_4115;
				obj_t BgL_arg2z00_4116;

				BgL_nz00_4112 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7456);
				BgL_pz00_4113 = BgL_pz00_7457;
				BgL_arg0z00_4114 = BgL_arg0z00_7458;
				BgL_arg1z00_4115 = BgL_arg1z00_7459;
				BgL_arg2z00_4116 = BgL_arg2z00_7460;
				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2783z00_6343;

					BgL_arg2783z00_6343 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4112))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4113) (BgL_pz00_4113,
						((obj_t) BgL_arg2783z00_6343), BgL_arg0z00_4114, BgL_arg1z00_4115,
						BgL_arg2z00_4116, BEOA);
				}
			}
		}
	}



/* &walk2-make-box1919 */
	obj_t BGl_z62walk2zd2makezd2box1919z62zzast_walkz00(obj_t BgL_envz00_7461,
		obj_t BgL_nz00_7462, obj_t BgL_pz00_7463, obj_t BgL_arg0z00_7464,
		obj_t BgL_arg1z00_7465)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4103;
				obj_t BgL_pz00_4104;
				obj_t BgL_arg0z00_4105;
				obj_t BgL_arg1z00_4106;

				BgL_nz00_4103 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7462);
				BgL_pz00_4104 = BgL_pz00_7463;
				BgL_arg0z00_4105 = BgL_arg0z00_7464;
				BgL_arg1z00_4106 = BgL_arg1z00_7465;
				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2782z00_6341;

					BgL_arg2782z00_6341 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4103))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4104) (BgL_pz00_4104,
						((obj_t) BgL_arg2782z00_6341), BgL_arg0z00_4105, BgL_arg1z00_4106,
						BEOA);
				}
			}
		}
	}



/* &walk1-make-box1917 */
	obj_t BGl_z62walk1zd2makezd2box1917z62zzast_walkz00(obj_t BgL_envz00_7466,
		obj_t BgL_nz00_7467, obj_t BgL_pz00_7468, obj_t BgL_arg0z00_7469)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4095;
				obj_t BgL_pz00_4096;
				obj_t BgL_arg0z00_4097;

				BgL_nz00_4095 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7467);
				BgL_pz00_4096 = BgL_pz00_7468;
				BgL_arg0z00_4097 = BgL_arg0z00_7469;
				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2781z00_6339;

					BgL_arg2781z00_6339 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4095))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4096) (BgL_pz00_4096,
						((obj_t) BgL_arg2781z00_6339), BgL_arg0z00_4097, BEOA);
				}
			}
		}
	}



/* &walk0-make-box1915 */
	obj_t BGl_z62walk0zd2makezd2box1915z62zzast_walkz00(obj_t BgL_envz00_7470,
		obj_t BgL_nz00_7471, obj_t BgL_pz00_7472)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 306 */
			{
				BgL_makezd2boxzd2_bglt BgL_nz00_4088;
				obj_t BgL_pz00_4089;

				BgL_nz00_4088 = ((BgL_makezd2boxzd2_bglt) BgL_nz00_7471);
				BgL_pz00_4089 = BgL_pz00_7472;
				{	/* Ast/walk.scm 306 */
					BgL_nodez00_bglt BgL_arg2779z00_6337;

					BgL_arg2779z00_6337 =
						(((BgL_makezd2boxzd2_bglt) CREF(BgL_nz00_4088))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_4089) (BgL_pz00_4089,
						((obj_t) BgL_arg2779z00_6337), BEOA);
				}
			}
		}
	}



/* &walk3!-jump-ex-it1913 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2jumpzd2exzd2it1913za2zzast_walkz00(obj_t
		BgL_envz00_7473, obj_t BgL_nz00_7474, obj_t BgL_pz00_7475,
		obj_t BgL_arg0z00_7476, obj_t BgL_arg1z00_7477, obj_t BgL_arg2z00_7478)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4077;
				obj_t BgL_pz00_4078;
				obj_t BgL_arg0z00_4079;
				obj_t BgL_arg1z00_4080;
				obj_t BgL_arg2z00_4081;

				BgL_nz00_4077 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7474);
				BgL_pz00_4078 = BgL_pz00_7475;
				BgL_arg0z00_4079 = BgL_arg0z00_7476;
				BgL_arg1z00_4080 = BgL_arg1z00_7477;
				BgL_arg2z00_4081 = BgL_arg2z00_7478;
				{
					BgL_nodez00_bglt BgL_auxz00_10937;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2777z00_6334;

						BgL_arg2777z00_6334 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4077))->BgL_exitz00);
						BgL_auxz00_10937 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4078) (BgL_pz00_4078,
								((obj_t) BgL_arg2777z00_6334), BgL_arg0z00_4079,
								BgL_arg1z00_4080, BgL_arg2z00_4081, BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4077))->BgL_exitz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10937), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10949;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2778z00_6335;

						BgL_arg2778z00_6335 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4077))->
							BgL_valuez00);
						BgL_auxz00_10949 =
							((BgL_nodez00_bglt) PROCEDURE_ENTRY(BgL_pz00_4078) (BgL_pz00_4078,
								((obj_t) BgL_arg2778z00_6335), BgL_arg0z00_4079,
								BgL_arg1z00_4080, BgL_arg2z00_4081, BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4077))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10949), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4077);
			}
		}
	}



/* &walk2!-jump-ex-it1911 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2jumpzd2exzd2it1911za2zzast_walkz00(obj_t
		BgL_envz00_7479, obj_t BgL_nz00_7480, obj_t BgL_pz00_7481,
		obj_t BgL_arg0z00_7482, obj_t BgL_arg1z00_7483)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4067;
				obj_t BgL_pz00_4068;
				obj_t BgL_arg0z00_4069;
				obj_t BgL_arg1z00_4070;

				BgL_nz00_4067 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7480);
				BgL_pz00_4068 = BgL_pz00_7481;
				BgL_arg0z00_4069 = BgL_arg0z00_7482;
				BgL_arg1z00_4070 = BgL_arg1z00_7483;
				{
					BgL_nodez00_bglt BgL_auxz00_10963;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2773z00_4074;

						BgL_arg2773z00_4074 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4067))->BgL_exitz00);
						BgL_auxz00_10963 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4068) (BgL_pz00_4068,
								((obj_t) BgL_arg2773z00_4074), BgL_arg0z00_4069,
								BgL_arg1z00_4070, BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4067))->BgL_exitz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10963), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10974;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2775z00_4075;

						BgL_arg2775z00_4075 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4067))->
							BgL_valuez00);
						BgL_auxz00_10974 =
							((BgL_nodez00_bglt) PROCEDURE_ENTRY(BgL_pz00_4068) (BgL_pz00_4068,
								((obj_t) BgL_arg2775z00_4075), BgL_arg0z00_4069,
								BgL_arg1z00_4070, BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4067))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10974), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4067);
			}
		}
	}



/* &walk1!-jump-ex-it1909 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2jumpzd2exzd2it1909za2zzast_walkz00(obj_t
		BgL_envz00_7484, obj_t BgL_nz00_7485, obj_t BgL_pz00_7486,
		obj_t BgL_arg0z00_7487)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4058;
				obj_t BgL_pz00_4059;
				obj_t BgL_arg0z00_4060;

				BgL_nz00_4058 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7485);
				BgL_pz00_4059 = BgL_pz00_7486;
				BgL_arg0z00_4060 = BgL_arg0z00_7487;
				{
					BgL_nodez00_bglt BgL_auxz00_10987;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2769z00_4064;

						BgL_arg2769z00_4064 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4058))->BgL_exitz00);
						BgL_auxz00_10987 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4059) (BgL_pz00_4059,
								((obj_t) BgL_arg2769z00_4064), BgL_arg0z00_4060, BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4058))->BgL_exitz00) =
						((BgL_nodez00_bglt) BgL_auxz00_10987), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_10997;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2772z00_4065;

						BgL_arg2772z00_4065 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4058))->
							BgL_valuez00);
						BgL_auxz00_10997 =
							((BgL_nodez00_bglt) PROCEDURE_ENTRY(BgL_pz00_4059) (BgL_pz00_4059,
								((obj_t) BgL_arg2772z00_4065), BgL_arg0z00_4060, BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4058))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_10997), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4058);
			}
		}
	}



/* &walk0!-jump-ex-it1907 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2jumpzd2exzd2it1907za2zzast_walkz00(obj_t
		BgL_envz00_7488, obj_t BgL_nz00_7489, obj_t BgL_pz00_7490)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4050;
				obj_t BgL_pz00_4051;

				BgL_nz00_4050 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7489);
				BgL_pz00_4051 = BgL_pz00_7490;
				{
					BgL_nodez00_bglt BgL_auxz00_11009;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2756z00_4055;

						BgL_arg2756z00_4055 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4050))->BgL_exitz00);
						BgL_auxz00_11009 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_4051) (BgL_pz00_4051,
								((obj_t) BgL_arg2756z00_4055), BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4050))->BgL_exitz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11009), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11018;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2759z00_4056;

						BgL_arg2759z00_4056 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4050))->
							BgL_valuez00);
						BgL_auxz00_11018 =
							((BgL_nodez00_bglt) PROCEDURE_ENTRY(BgL_pz00_4051) (BgL_pz00_4051,
								((obj_t) BgL_arg2759z00_4056), BEOA));
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4050))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11018), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_4050);
			}
		}
	}



/* &walk3*-jump-ex-it1905 */
	obj_t BGl_z62walk3za2zd2jumpzd2exzd2it1905z12zzast_walkz00(obj_t
		BgL_envz00_7491, obj_t BgL_nz00_7492, obj_t BgL_pz00_7493,
		obj_t BgL_arg0z00_7494, obj_t BgL_arg1z00_7495, obj_t BgL_arg2z00_7496)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4037;
				obj_t BgL_pz00_4038;
				obj_t BgL_arg0z00_4039;
				obj_t BgL_arg1z00_4040;
				obj_t BgL_arg2z00_4041;

				BgL_nz00_4037 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7492);
				BgL_pz00_4038 = BgL_pz00_7493;
				BgL_arg0z00_4039 = BgL_arg0z00_7494;
				BgL_arg1z00_4040 = BgL_arg1z00_7495;
				BgL_arg2z00_4041 = BgL_arg2z00_7496;
				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2750z00_6329;
					obj_t BgL_arg2752z00_6330;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2753z00_6331;

						BgL_arg2753z00_6331 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4037))->BgL_exitz00);
						BgL_arg2750z00_6329 =
							PROCEDURE_ENTRY(BgL_pz00_4038) (BgL_pz00_4038,
							((obj_t) BgL_arg2753z00_6331), BgL_arg0z00_4039, BgL_arg1z00_4040,
							BgL_arg2z00_4041, BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2755z00_6332;

						BgL_arg2755z00_6332 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4037))->
							BgL_valuez00);
						BgL_arg2752z00_6330 =
							PROCEDURE_ENTRY(BgL_pz00_4038) (BgL_pz00_4038,
							((obj_t) BgL_arg2755z00_6332), BgL_arg0z00_4039, BgL_arg1z00_4040,
							BgL_arg2z00_4041, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2750z00_6329,
						BgL_arg2752z00_6330);
				}
			}
		}
	}



/* &walk2*-jump-ex-it1903 */
	obj_t BGl_z62walk2za2zd2jumpzd2exzd2it1903z12zzast_walkz00(obj_t
		BgL_envz00_7497, obj_t BgL_nz00_7498, obj_t BgL_pz00_7499,
		obj_t BgL_arg0z00_7500, obj_t BgL_arg1z00_7501)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4025;
				obj_t BgL_pz00_4026;
				obj_t BgL_arg0z00_4027;
				obj_t BgL_arg1z00_4028;

				BgL_nz00_4025 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7498);
				BgL_pz00_4026 = BgL_pz00_7499;
				BgL_arg0z00_4027 = BgL_arg0z00_7500;
				BgL_arg1z00_4028 = BgL_arg1z00_7501;
				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2741z00_6324;
					obj_t BgL_arg2746z00_6325;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2747z00_6326;

						BgL_arg2747z00_6326 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4025))->BgL_exitz00);
						BgL_arg2741z00_6324 =
							PROCEDURE_ENTRY(BgL_pz00_4026) (BgL_pz00_4026,
							((obj_t) BgL_arg2747z00_6326), BgL_arg0z00_4027, BgL_arg1z00_4028,
							BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2749z00_6327;

						BgL_arg2749z00_6327 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4025))->
							BgL_valuez00);
						BgL_arg2746z00_6325 =
							PROCEDURE_ENTRY(BgL_pz00_4026) (BgL_pz00_4026,
							((obj_t) BgL_arg2749z00_6327), BgL_arg0z00_4027, BgL_arg1z00_4028,
							BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2741z00_6324,
						BgL_arg2746z00_6325);
				}
			}
		}
	}



/* &walk1*-jump-ex-it1901 */
	obj_t BGl_z62walk1za2zd2jumpzd2exzd2it1901z12zzast_walkz00(obj_t
		BgL_envz00_7502, obj_t BgL_nz00_7503, obj_t BgL_pz00_7504,
		obj_t BgL_arg0z00_7505)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4014;
				obj_t BgL_pz00_4015;
				obj_t BgL_arg0z00_4016;

				BgL_nz00_4014 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7503);
				BgL_pz00_4015 = BgL_pz00_7504;
				BgL_arg0z00_4016 = BgL_arg0z00_7505;
				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2736z00_4020;
					obj_t BgL_arg2737z00_4021;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2738z00_4022;

						BgL_arg2738z00_4022 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4014))->BgL_exitz00);
						BgL_arg2736z00_4020 =
							PROCEDURE_ENTRY(BgL_pz00_4015) (BgL_pz00_4015,
							((obj_t) BgL_arg2738z00_4022), BgL_arg0z00_4016, BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2739z00_4023;

						BgL_arg2739z00_4023 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4014))->
							BgL_valuez00);
						BgL_arg2737z00_4021 =
							PROCEDURE_ENTRY(BgL_pz00_4015) (BgL_pz00_4015,
							((obj_t) BgL_arg2739z00_4023), BgL_arg0z00_4016, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2736z00_4020,
						BgL_arg2737z00_4021);
				}
			}
		}
	}



/* &walk0*-jump-ex-it1899 */
	obj_t BGl_z62walk0za2zd2jumpzd2exzd2it1899z12zzast_walkz00(obj_t
		BgL_envz00_7506, obj_t BgL_nz00_7507, obj_t BgL_pz00_7508)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_4004;
				obj_t BgL_pz00_4005;

				BgL_nz00_4004 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7507);
				BgL_pz00_4005 = BgL_pz00_7508;
				{	/* Ast/walk.scm 305 */
					obj_t BgL_arg2731z00_4009;
					obj_t BgL_arg2732z00_4010;

					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2733z00_4011;

						BgL_arg2733z00_4011 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4004))->BgL_exitz00);
						BgL_arg2731z00_4009 =
							PROCEDURE_ENTRY(BgL_pz00_4005) (BgL_pz00_4005,
							((obj_t) BgL_arg2733z00_4011), BEOA);
					}
					{	/* Ast/walk.scm 305 */
						BgL_nodez00_bglt BgL_arg2735z00_4012;

						BgL_arg2735z00_4012 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_4004))->
							BgL_valuez00);
						BgL_arg2732z00_4010 =
							PROCEDURE_ENTRY(BgL_pz00_4005) (BgL_pz00_4005,
							((obj_t) BgL_arg2735z00_4012), BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2731z00_4009,
						BgL_arg2732z00_4010);
				}
			}
		}
	}



/* &walk3-jump-ex-it1897 */
	obj_t BGl_z62walk3zd2jumpzd2exzd2it1897zb0zzast_walkz00(obj_t BgL_envz00_7509,
		obj_t BgL_nz00_7510, obj_t BgL_pz00_7511, obj_t BgL_arg0z00_7512,
		obj_t BgL_arg1z00_7513, obj_t BgL_arg2z00_7514)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_3993;
				obj_t BgL_pz00_3994;
				obj_t BgL_arg0z00_3995;
				obj_t BgL_arg1z00_3996;
				obj_t BgL_arg2z00_3997;

				BgL_nz00_3993 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7510);
				BgL_pz00_3994 = BgL_pz00_7511;
				BgL_arg0z00_3995 = BgL_arg0z00_7512;
				BgL_arg1z00_3996 = BgL_arg1z00_7513;
				BgL_arg2z00_3997 = BgL_arg2z00_7514;
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2729z00_6321;

					BgL_arg2729z00_6321 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3993))->BgL_exitz00);
					PROCEDURE_ENTRY(BgL_pz00_3994) (BgL_pz00_3994,
						((obj_t) BgL_arg2729z00_6321), BgL_arg0z00_3995, BgL_arg1z00_3996,
						BgL_arg2z00_3997, BEOA);
				}
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2730z00_6322;

					BgL_arg2730z00_6322 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3993))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3994) (BgL_pz00_3994,
						((obj_t) BgL_arg2730z00_6322), BgL_arg0z00_3995, BgL_arg1z00_3996,
						BgL_arg2z00_3997, BEOA);
				}
			}
		}
	}



/* &walk2-jump-ex-it1895 */
	obj_t BGl_z62walk2zd2jumpzd2exzd2it1895zb0zzast_walkz00(obj_t BgL_envz00_7515,
		obj_t BgL_nz00_7516, obj_t BgL_pz00_7517, obj_t BgL_arg0z00_7518,
		obj_t BgL_arg1z00_7519)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_3983;
				obj_t BgL_pz00_3984;
				obj_t BgL_arg0z00_3985;
				obj_t BgL_arg1z00_3986;

				BgL_nz00_3983 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7516);
				BgL_pz00_3984 = BgL_pz00_7517;
				BgL_arg0z00_3985 = BgL_arg0z00_7518;
				BgL_arg1z00_3986 = BgL_arg1z00_7519;
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2726z00_6318;

					BgL_arg2726z00_6318 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3983))->BgL_exitz00);
					PROCEDURE_ENTRY(BgL_pz00_3984) (BgL_pz00_3984,
						((obj_t) BgL_arg2726z00_6318), BgL_arg0z00_3985, BgL_arg1z00_3986,
						BEOA);
				}
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2727z00_6319;

					BgL_arg2727z00_6319 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3983))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3984) (BgL_pz00_3984,
						((obj_t) BgL_arg2727z00_6319), BgL_arg0z00_3985, BgL_arg1z00_3986,
						BEOA);
				}
			}
		}
	}



/* &walk1-jump-ex-it1893 */
	obj_t BGl_z62walk1zd2jumpzd2exzd2it1893zb0zzast_walkz00(obj_t BgL_envz00_7520,
		obj_t BgL_nz00_7521, obj_t BgL_pz00_7522, obj_t BgL_arg0z00_7523)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_3974;
				obj_t BgL_pz00_3975;
				obj_t BgL_arg0z00_3976;

				BgL_nz00_3974 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7521);
				BgL_pz00_3975 = BgL_pz00_7522;
				BgL_arg0z00_3976 = BgL_arg0z00_7523;
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2724z00_6315;

					BgL_arg2724z00_6315 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3974))->BgL_exitz00);
					PROCEDURE_ENTRY(BgL_pz00_3975) (BgL_pz00_3975,
						((obj_t) BgL_arg2724z00_6315), BgL_arg0z00_3976, BEOA);
				}
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2725z00_6316;

					BgL_arg2725z00_6316 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3974))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3975) (BgL_pz00_3975,
						((obj_t) BgL_arg2725z00_6316), BgL_arg0z00_3976, BEOA);
				}
			}
		}
	}



/* &walk0-jump-ex-it1891 */
	obj_t BGl_z62walk0zd2jumpzd2exzd2it1891zb0zzast_walkz00(obj_t BgL_envz00_7524,
		obj_t BgL_nz00_7525, obj_t BgL_pz00_7526)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 305 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nz00_3966;
				obj_t BgL_pz00_3967;

				BgL_nz00_3966 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nz00_7525);
				BgL_pz00_3967 = BgL_pz00_7526;
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2721z00_6312;

					BgL_arg2721z00_6312 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3966))->BgL_exitz00);
					PROCEDURE_ENTRY(BgL_pz00_3967) (BgL_pz00_3967,
						((obj_t) BgL_arg2721z00_6312), BEOA);
				}
				{	/* Ast/walk.scm 305 */
					BgL_nodez00_bglt BgL_arg2723z00_6313;

					BgL_arg2723z00_6313 =
						(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nz00_3966))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3967) (BgL_pz00_3967,
						((obj_t) BgL_arg2723z00_6313), BEOA);
				}
			}
		}
	}



/* &walk3!-set-ex-it1889 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2setzd2exzd2it1889za2zzast_walkz00(obj_t
		BgL_envz00_7527, obj_t BgL_nz00_7528, obj_t BgL_pz00_7529,
		obj_t BgL_arg0z00_7530, obj_t BgL_arg1z00_7531, obj_t BgL_arg2z00_7532)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3956;
				obj_t BgL_pz00_3957;
				obj_t BgL_arg0z00_3958;
				obj_t BgL_arg1z00_3959;
				obj_t BgL_arg2z00_3960;

				BgL_nz00_3956 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7528);
				BgL_pz00_3957 = BgL_pz00_7529;
				BgL_arg0z00_3958 = BgL_arg0z00_7530;
				BgL_arg1z00_3959 = BgL_arg1z00_7531;
				BgL_arg2z00_3960 = BgL_arg2z00_7532;
				{
					BgL_nodez00_bglt BgL_auxz00_11161;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2720z00_6310;

						BgL_arg2720z00_6310 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3956))->BgL_bodyz00);
						BgL_auxz00_11161 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3957) (BgL_pz00_3957,
								((obj_t) BgL_arg2720z00_6310), BgL_arg0z00_3958,
								BgL_arg1z00_3959, BgL_arg2z00_3960, BEOA));
					}
					((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3956))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11161), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3956);
			}
		}
	}



/* &walk2!-set-ex-it1887 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2setzd2exzd2it1887za2zzast_walkz00(obj_t
		BgL_envz00_7533, obj_t BgL_nz00_7534, obj_t BgL_pz00_7535,
		obj_t BgL_arg0z00_7536, obj_t BgL_arg1z00_7537)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3947;
				obj_t BgL_pz00_3948;
				obj_t BgL_arg0z00_3949;
				obj_t BgL_arg1z00_3950;

				BgL_nz00_3947 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7534);
				BgL_pz00_3948 = BgL_pz00_7535;
				BgL_arg0z00_3949 = BgL_arg0z00_7536;
				BgL_arg1z00_3950 = BgL_arg1z00_7537;
				{
					BgL_nodez00_bglt BgL_auxz00_11175;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2719z00_6308;

						BgL_arg2719z00_6308 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3947))->BgL_bodyz00);
						BgL_auxz00_11175 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3948) (BgL_pz00_3948,
								((obj_t) BgL_arg2719z00_6308), BgL_arg0z00_3949,
								BgL_arg1z00_3950, BEOA));
					}
					((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3947))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11175), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3947);
			}
		}
	}



/* &walk1!-set-ex-it1885 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2setzd2exzd2it1885za2zzast_walkz00(obj_t
		BgL_envz00_7538, obj_t BgL_nz00_7539, obj_t BgL_pz00_7540,
		obj_t BgL_arg0z00_7541)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3939;
				obj_t BgL_pz00_3940;
				obj_t BgL_arg0z00_3941;

				BgL_nz00_3939 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7539);
				BgL_pz00_3940 = BgL_pz00_7540;
				BgL_arg0z00_3941 = BgL_arg0z00_7541;
				{
					BgL_nodez00_bglt BgL_auxz00_11188;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2718z00_6306;

						BgL_arg2718z00_6306 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3939))->BgL_bodyz00);
						BgL_auxz00_11188 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3940) (BgL_pz00_3940,
								((obj_t) BgL_arg2718z00_6306), BgL_arg0z00_3941, BEOA));
					}
					((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3939))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11188), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3939);
			}
		}
	}



/* &walk0!-set-ex-it1883 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2setzd2exzd2it1883za2zzast_walkz00(obj_t
		BgL_envz00_7542, obj_t BgL_nz00_7543, obj_t BgL_pz00_7544)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3932;
				obj_t BgL_pz00_3933;

				BgL_nz00_3932 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7543);
				BgL_pz00_3933 = BgL_pz00_7544;
				{
					BgL_nodez00_bglt BgL_auxz00_11200;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2717z00_6304;

						BgL_arg2717z00_6304 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3932))->BgL_bodyz00);
						BgL_auxz00_11200 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3933) (BgL_pz00_3933,
								((obj_t) BgL_arg2717z00_6304), BEOA));
					}
					((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3932))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11200), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3932);
			}
		}
	}



/* &walk3*-set-ex-it1881 */
	obj_t BGl_z62walk3za2zd2setzd2exzd2it1881z12zzast_walkz00(obj_t
		BgL_envz00_7545, obj_t BgL_nz00_7546, obj_t BgL_pz00_7547,
		obj_t BgL_arg0z00_7548, obj_t BgL_arg1z00_7549, obj_t BgL_arg2z00_7550)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3920;
				obj_t BgL_pz00_3921;
				obj_t BgL_arg0z00_3922;
				obj_t BgL_arg1z00_3923;
				obj_t BgL_arg2z00_3924;

				BgL_nz00_3920 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7546);
				BgL_pz00_3921 = BgL_pz00_7547;
				BgL_arg0z00_3922 = BgL_arg0z00_7548;
				BgL_arg1z00_3923 = BgL_arg1z00_7549;
				BgL_arg2z00_3924 = BgL_arg2z00_7550;
				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2714z00_6300;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2716z00_6301;

						BgL_arg2716z00_6301 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3920))->BgL_bodyz00);
						BgL_arg2714z00_6300 =
							PROCEDURE_ENTRY(BgL_pz00_3921) (BgL_pz00_3921,
							((obj_t) BgL_arg2716z00_6301), BgL_arg0z00_3922, BgL_arg1z00_3923,
							BgL_arg2z00_3924, BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2715z00_6302;

						BgL_list2715z00_6302 = MAKE_PAIR(BgL_arg2714z00_6300, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2715z00_6302);
					}
				}
			}
		}
	}



/* &walk2*-set-ex-it1879 */
	obj_t BGl_z62walk2za2zd2setzd2exzd2it1879z12zzast_walkz00(obj_t
		BgL_envz00_7551, obj_t BgL_nz00_7552, obj_t BgL_pz00_7553,
		obj_t BgL_arg0z00_7554, obj_t BgL_arg1z00_7555)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3909;
				obj_t BgL_pz00_3910;
				obj_t BgL_arg0z00_3911;
				obj_t BgL_arg1z00_3912;

				BgL_nz00_3909 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7552);
				BgL_pz00_3910 = BgL_pz00_7553;
				BgL_arg0z00_3911 = BgL_arg0z00_7554;
				BgL_arg1z00_3912 = BgL_arg1z00_7555;
				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2711z00_6296;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2713z00_6297;

						BgL_arg2713z00_6297 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3909))->BgL_bodyz00);
						BgL_arg2711z00_6296 =
							PROCEDURE_ENTRY(BgL_pz00_3910) (BgL_pz00_3910,
							((obj_t) BgL_arg2713z00_6297), BgL_arg0z00_3911, BgL_arg1z00_3912,
							BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2712z00_6298;

						BgL_list2712z00_6298 = MAKE_PAIR(BgL_arg2711z00_6296, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2712z00_6298);
					}
				}
			}
		}
	}



/* &walk1*-set-ex-it1877 */
	obj_t BGl_z62walk1za2zd2setzd2exzd2it1877z12zzast_walkz00(obj_t
		BgL_envz00_7556, obj_t BgL_nz00_7557, obj_t BgL_pz00_7558,
		obj_t BgL_arg0z00_7559)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3899;
				obj_t BgL_pz00_3900;
				obj_t BgL_arg0z00_3901;

				BgL_nz00_3899 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7557);
				BgL_pz00_3900 = BgL_pz00_7558;
				BgL_arg0z00_3901 = BgL_arg0z00_7559;
				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2708z00_6292;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2710z00_6293;

						BgL_arg2710z00_6293 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3899))->BgL_bodyz00);
						BgL_arg2708z00_6292 =
							PROCEDURE_ENTRY(BgL_pz00_3900) (BgL_pz00_3900,
							((obj_t) BgL_arg2710z00_6293), BgL_arg0z00_3901, BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2709z00_6294;

						BgL_list2709z00_6294 = MAKE_PAIR(BgL_arg2708z00_6292, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2709z00_6294);
					}
				}
			}
		}
	}



/* &walk0*-set-ex-it1875 */
	obj_t BGl_z62walk0za2zd2setzd2exzd2it1875z12zzast_walkz00(obj_t
		BgL_envz00_7560, obj_t BgL_nz00_7561, obj_t BgL_pz00_7562)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3890;
				obj_t BgL_pz00_3891;

				BgL_nz00_3890 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7561);
				BgL_pz00_3891 = BgL_pz00_7562;
				{	/* Ast/walk.scm 304 */
					obj_t BgL_arg2705z00_6288;

					{	/* Ast/walk.scm 304 */
						BgL_nodez00_bglt BgL_arg2707z00_6289;

						BgL_arg2707z00_6289 =
							(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3890))->BgL_bodyz00);
						BgL_arg2705z00_6288 =
							PROCEDURE_ENTRY(BgL_pz00_3891) (BgL_pz00_3891,
							((obj_t) BgL_arg2707z00_6289), BEOA);
					}
					{	/* Ast/walk.scm 304 */
						obj_t BgL_list2706z00_6290;

						BgL_list2706z00_6290 = MAKE_PAIR(BgL_arg2705z00_6288, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2706z00_6290);
					}
				}
			}
		}
	}



/* &walk3-set-ex-it1873 */
	obj_t BGl_z62walk3zd2setzd2exzd2it1873zb0zzast_walkz00(obj_t BgL_envz00_7563,
		obj_t BgL_nz00_7564, obj_t BgL_pz00_7565, obj_t BgL_arg0z00_7566,
		obj_t BgL_arg1z00_7567, obj_t BgL_arg2z00_7568)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3880;
				obj_t BgL_pz00_3881;
				obj_t BgL_arg0z00_3882;
				obj_t BgL_arg1z00_3883;
				obj_t BgL_arg2z00_3884;

				BgL_nz00_3880 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7564);
				BgL_pz00_3881 = BgL_pz00_7565;
				BgL_arg0z00_3882 = BgL_arg0z00_7566;
				BgL_arg1z00_3883 = BgL_arg1z00_7567;
				BgL_arg2z00_3884 = BgL_arg2z00_7568;
				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2704z00_6286;

					BgL_arg2704z00_6286 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3880))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3881) (BgL_pz00_3881,
						((obj_t) BgL_arg2704z00_6286), BgL_arg0z00_3882, BgL_arg1z00_3883,
						BgL_arg2z00_3884, BEOA);
				}
			}
		}
	}



/* &walk2-set-ex-it1871 */
	obj_t BGl_z62walk2zd2setzd2exzd2it1871zb0zzast_walkz00(obj_t BgL_envz00_7569,
		obj_t BgL_nz00_7570, obj_t BgL_pz00_7571, obj_t BgL_arg0z00_7572,
		obj_t BgL_arg1z00_7573)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3871;
				obj_t BgL_pz00_3872;
				obj_t BgL_arg0z00_3873;
				obj_t BgL_arg1z00_3874;

				BgL_nz00_3871 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7570);
				BgL_pz00_3872 = BgL_pz00_7571;
				BgL_arg0z00_3873 = BgL_arg0z00_7572;
				BgL_arg1z00_3874 = BgL_arg1z00_7573;
				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2703z00_6284;

					BgL_arg2703z00_6284 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3871))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3872) (BgL_pz00_3872,
						((obj_t) BgL_arg2703z00_6284), BgL_arg0z00_3873, BgL_arg1z00_3874,
						BEOA);
				}
			}
		}
	}



/* &walk1-set-ex-it1869 */
	obj_t BGl_z62walk1zd2setzd2exzd2it1869zb0zzast_walkz00(obj_t BgL_envz00_7574,
		obj_t BgL_nz00_7575, obj_t BgL_pz00_7576, obj_t BgL_arg0z00_7577)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3863;
				obj_t BgL_pz00_3864;
				obj_t BgL_arg0z00_3865;

				BgL_nz00_3863 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7575);
				BgL_pz00_3864 = BgL_pz00_7576;
				BgL_arg0z00_3865 = BgL_arg0z00_7577;
				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2702z00_6282;

					BgL_arg2702z00_6282 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3863))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3864) (BgL_pz00_3864,
						((obj_t) BgL_arg2702z00_6282), BgL_arg0z00_3865, BEOA);
				}
			}
		}
	}



/* &walk0-set-ex-it1867 */
	obj_t BGl_z62walk0zd2setzd2exzd2it1867zb0zzast_walkz00(obj_t BgL_envz00_7578,
		obj_t BgL_nz00_7579, obj_t BgL_pz00_7580)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 304 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nz00_3856;
				obj_t BgL_pz00_3857;

				BgL_nz00_3856 = ((BgL_setzd2exzd2itz00_bglt) BgL_nz00_7579);
				BgL_pz00_3857 = BgL_pz00_7580;
				{	/* Ast/walk.scm 304 */
					BgL_nodez00_bglt BgL_arg2701z00_6280;

					BgL_arg2701z00_6280 =
						(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nz00_3856))->BgL_bodyz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3857) (BgL_pz00_3857,
						((obj_t) BgL_arg2701z00_6280), BEOA);
				}
			}
		}
	}



/* &walk3!-fail1865 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2fail1865za2zzast_walkz00(obj_t
		BgL_envz00_7581, obj_t BgL_nz00_7582, obj_t BgL_pz00_7583,
		obj_t BgL_arg0z00_7584, obj_t BgL_arg1z00_7585, obj_t BgL_arg2z00_7586)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3844;
				obj_t BgL_pz00_3845;
				obj_t BgL_arg0z00_3846;
				obj_t BgL_arg1z00_3847;
				obj_t BgL_arg2z00_3848;

				BgL_nz00_3844 = ((BgL_failz00_bglt) BgL_nz00_7582);
				BgL_pz00_3845 = BgL_pz00_7583;
				BgL_arg0z00_3846 = BgL_arg0z00_7584;
				BgL_arg1z00_3847 = BgL_arg1z00_7585;
				BgL_arg2z00_3848 = BgL_arg2z00_7586;
				{
					BgL_nodez00_bglt BgL_auxz00_11287;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2698z00_3852;

						BgL_arg2698z00_3852 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3844))->BgL_procz00);
						BgL_auxz00_11287 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3845) (BgL_pz00_3845,
								((obj_t) BgL_arg2698z00_3852), BgL_arg0z00_3846,
								BgL_arg1z00_3847, BgL_arg2z00_3848, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3844))->BgL_procz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11287), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11299;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2699z00_3853;

						BgL_arg2699z00_3853 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3844))->BgL_msgz00);
						BgL_auxz00_11299 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3845) (BgL_pz00_3845,
								((obj_t) BgL_arg2699z00_3853), BgL_arg0z00_3846,
								BgL_arg1z00_3847, BgL_arg2z00_3848, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3844))->BgL_msgz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11299), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11311;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2700z00_3854;

						BgL_arg2700z00_3854 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3844))->BgL_objz00);
						BgL_auxz00_11311 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3845) (BgL_pz00_3845,
								((obj_t) BgL_arg2700z00_3854), BgL_arg0z00_3846,
								BgL_arg1z00_3847, BgL_arg2z00_3848, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3844))->BgL_objz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11311), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3844);
			}
		}
	}



/* &walk2!-fail1863 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2fail1863za2zzast_walkz00(obj_t
		BgL_envz00_7587, obj_t BgL_nz00_7588, obj_t BgL_pz00_7589,
		obj_t BgL_arg0z00_7590, obj_t BgL_arg1z00_7591)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3833;
				obj_t BgL_pz00_3834;
				obj_t BgL_arg0z00_3835;
				obj_t BgL_arg1z00_3836;

				BgL_nz00_3833 = ((BgL_failz00_bglt) BgL_nz00_7588);
				BgL_pz00_3834 = BgL_pz00_7589;
				BgL_arg0z00_3835 = BgL_arg0z00_7590;
				BgL_arg1z00_3836 = BgL_arg1z00_7591;
				{
					BgL_nodez00_bglt BgL_auxz00_11325;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2695z00_3840;

						BgL_arg2695z00_3840 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3833))->BgL_procz00);
						BgL_auxz00_11325 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3834) (BgL_pz00_3834,
								((obj_t) BgL_arg2695z00_3840), BgL_arg0z00_3835,
								BgL_arg1z00_3836, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3833))->BgL_procz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11325), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11336;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2696z00_3841;

						BgL_arg2696z00_3841 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3833))->BgL_msgz00);
						BgL_auxz00_11336 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3834) (BgL_pz00_3834,
								((obj_t) BgL_arg2696z00_3841), BgL_arg0z00_3835,
								BgL_arg1z00_3836, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3833))->BgL_msgz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11336), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11347;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2697z00_3842;

						BgL_arg2697z00_3842 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3833))->BgL_objz00);
						BgL_auxz00_11347 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3834) (BgL_pz00_3834,
								((obj_t) BgL_arg2697z00_3842), BgL_arg0z00_3835,
								BgL_arg1z00_3836, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3833))->BgL_objz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11347), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3833);
			}
		}
	}



/* &walk1!-fail1861 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2fail1861za2zzast_walkz00(obj_t
		BgL_envz00_7592, obj_t BgL_nz00_7593, obj_t BgL_pz00_7594,
		obj_t BgL_arg0z00_7595)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3823;
				obj_t BgL_pz00_3824;
				obj_t BgL_arg0z00_3825;

				BgL_nz00_3823 = ((BgL_failz00_bglt) BgL_nz00_7593);
				BgL_pz00_3824 = BgL_pz00_7594;
				BgL_arg0z00_3825 = BgL_arg0z00_7595;
				{
					BgL_nodez00_bglt BgL_auxz00_11360;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2692z00_3829;

						BgL_arg2692z00_3829 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3823))->BgL_procz00);
						BgL_auxz00_11360 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3824) (BgL_pz00_3824,
								((obj_t) BgL_arg2692z00_3829), BgL_arg0z00_3825, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3823))->BgL_procz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11360), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11370;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2693z00_3830;

						BgL_arg2693z00_3830 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3823))->BgL_msgz00);
						BgL_auxz00_11370 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3824) (BgL_pz00_3824,
								((obj_t) BgL_arg2693z00_3830), BgL_arg0z00_3825, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3823))->BgL_msgz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11370), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11380;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2694z00_3831;

						BgL_arg2694z00_3831 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3823))->BgL_objz00);
						BgL_auxz00_11380 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3824) (BgL_pz00_3824,
								((obj_t) BgL_arg2694z00_3831), BgL_arg0z00_3825, BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3823))->BgL_objz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11380), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3823);
			}
		}
	}



/* &walk0!-fail1859 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2fail1859za2zzast_walkz00(obj_t
		BgL_envz00_7596, obj_t BgL_nz00_7597, obj_t BgL_pz00_7598)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3814;
				obj_t BgL_pz00_3815;

				BgL_nz00_3814 = ((BgL_failz00_bglt) BgL_nz00_7597);
				BgL_pz00_3815 = BgL_pz00_7598;
				{
					BgL_nodez00_bglt BgL_auxz00_11392;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2689z00_3819;

						BgL_arg2689z00_3819 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3814))->BgL_procz00);
						BgL_auxz00_11392 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3815) (BgL_pz00_3815,
								((obj_t) BgL_arg2689z00_3819), BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3814))->BgL_procz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11392), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11401;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2690z00_3820;

						BgL_arg2690z00_3820 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3814))->BgL_msgz00);
						BgL_auxz00_11401 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3815) (BgL_pz00_3815,
								((obj_t) BgL_arg2690z00_3820), BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3814))->BgL_msgz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11401), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11410;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2691z00_3821;

						BgL_arg2691z00_3821 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3814))->BgL_objz00);
						BgL_auxz00_11410 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3815) (BgL_pz00_3815,
								((obj_t) BgL_arg2691z00_3821), BEOA));
					}
					((((BgL_failz00_bglt) CREF(BgL_nz00_3814))->BgL_objz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11410), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3814);
			}
		}
	}



/* &walk3*-fail1857 */
	obj_t BGl_z62walk3za2zd2fail1857z12zzast_walkz00(obj_t BgL_envz00_7599,
		obj_t BgL_nz00_7600, obj_t BgL_pz00_7601, obj_t BgL_arg0z00_7602,
		obj_t BgL_arg1z00_7603, obj_t BgL_arg2z00_7604)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3796;
				obj_t BgL_pz00_3797;
				obj_t BgL_arg0z00_3798;
				obj_t BgL_arg1z00_3799;
				obj_t BgL_arg2z00_3800;

				BgL_nz00_3796 = ((BgL_failz00_bglt) BgL_nz00_7600);
				BgL_pz00_3797 = BgL_pz00_7601;
				BgL_arg0z00_3798 = BgL_arg0z00_7602;
				BgL_arg1z00_3799 = BgL_arg1z00_7603;
				BgL_arg2z00_3800 = BgL_arg2z00_7604;
				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2679z00_3804;
					obj_t BgL_arg2680z00_3805;
					obj_t BgL_arg2681z00_3806;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2685z00_3810;

						BgL_arg2685z00_3810 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3796))->BgL_procz00);
						BgL_arg2679z00_3804 =
							PROCEDURE_ENTRY(BgL_pz00_3797) (BgL_pz00_3797,
							((obj_t) BgL_arg2685z00_3810), BgL_arg0z00_3798, BgL_arg1z00_3799,
							BgL_arg2z00_3800, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2686z00_3811;

						BgL_arg2686z00_3811 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3796))->BgL_msgz00);
						BgL_arg2680z00_3805 =
							PROCEDURE_ENTRY(BgL_pz00_3797) (BgL_pz00_3797,
							((obj_t) BgL_arg2686z00_3811), BgL_arg0z00_3798, BgL_arg1z00_3799,
							BgL_arg2z00_3800, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2688z00_3812;

						BgL_arg2688z00_3812 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3796))->BgL_objz00);
						BgL_arg2681z00_3806 =
							PROCEDURE_ENTRY(BgL_pz00_3797) (BgL_pz00_3797,
							((obj_t) BgL_arg2688z00_3812), BgL_arg0z00_3798, BgL_arg1z00_3799,
							BgL_arg2z00_3800, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2682z00_3807;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2683z00_3808;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2684z00_3809;

								BgL_arg2684z00_3809 = MAKE_PAIR(BgL_arg2681z00_3806, BNIL);
								BgL_arg2683z00_3808 =
									MAKE_PAIR(BgL_arg2680z00_3805, BgL_arg2684z00_3809);
							}
							BgL_list2682z00_3807 =
								MAKE_PAIR(BgL_arg2679z00_3804, BgL_arg2683z00_3808);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2682z00_3807);
					}
				}
			}
		}
	}



/* &walk2*-fail1855 */
	obj_t BGl_z62walk2za2zd2fail1855z12zzast_walkz00(obj_t BgL_envz00_7605,
		obj_t BgL_nz00_7606, obj_t BgL_pz00_7607, obj_t BgL_arg0z00_7608,
		obj_t BgL_arg1z00_7609)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3779;
				obj_t BgL_pz00_3780;
				obj_t BgL_arg0z00_3781;
				obj_t BgL_arg1z00_3782;

				BgL_nz00_3779 = ((BgL_failz00_bglt) BgL_nz00_7606);
				BgL_pz00_3780 = BgL_pz00_7607;
				BgL_arg0z00_3781 = BgL_arg0z00_7608;
				BgL_arg1z00_3782 = BgL_arg1z00_7609;
				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2670z00_3786;
					obj_t BgL_arg2671z00_3787;
					obj_t BgL_arg2672z00_3788;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2676z00_3792;

						BgL_arg2676z00_3792 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3779))->BgL_procz00);
						BgL_arg2670z00_3786 =
							PROCEDURE_ENTRY(BgL_pz00_3780) (BgL_pz00_3780,
							((obj_t) BgL_arg2676z00_3792), BgL_arg0z00_3781, BgL_arg1z00_3782,
							BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2677z00_3793;

						BgL_arg2677z00_3793 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3779))->BgL_msgz00);
						BgL_arg2671z00_3787 =
							PROCEDURE_ENTRY(BgL_pz00_3780) (BgL_pz00_3780,
							((obj_t) BgL_arg2677z00_3793), BgL_arg0z00_3781, BgL_arg1z00_3782,
							BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2678z00_3794;

						BgL_arg2678z00_3794 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3779))->BgL_objz00);
						BgL_arg2672z00_3788 =
							PROCEDURE_ENTRY(BgL_pz00_3780) (BgL_pz00_3780,
							((obj_t) BgL_arg2678z00_3794), BgL_arg0z00_3781, BgL_arg1z00_3782,
							BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2673z00_3789;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2674z00_3790;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2675z00_3791;

								BgL_arg2675z00_3791 = MAKE_PAIR(BgL_arg2672z00_3788, BNIL);
								BgL_arg2674z00_3790 =
									MAKE_PAIR(BgL_arg2671z00_3787, BgL_arg2675z00_3791);
							}
							BgL_list2673z00_3789 =
								MAKE_PAIR(BgL_arg2670z00_3786, BgL_arg2674z00_3790);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2673z00_3789);
					}
				}
			}
		}
	}



/* &walk1*-fail1853 */
	obj_t BGl_z62walk1za2zd2fail1853z12zzast_walkz00(obj_t BgL_envz00_7610,
		obj_t BgL_nz00_7611, obj_t BgL_pz00_7612, obj_t BgL_arg0z00_7613)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3763;
				obj_t BgL_pz00_3764;
				obj_t BgL_arg0z00_3765;

				BgL_nz00_3763 = ((BgL_failz00_bglt) BgL_nz00_7611);
				BgL_pz00_3764 = BgL_pz00_7612;
				BgL_arg0z00_3765 = BgL_arg0z00_7613;
				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2656z00_3769;
					obj_t BgL_arg2658z00_3770;
					obj_t BgL_arg2659z00_3771;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2665z00_3775;

						BgL_arg2665z00_3775 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3763))->BgL_procz00);
						BgL_arg2656z00_3769 =
							PROCEDURE_ENTRY(BgL_pz00_3764) (BgL_pz00_3764,
							((obj_t) BgL_arg2665z00_3775), BgL_arg0z00_3765, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2666z00_3776;

						BgL_arg2666z00_3776 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3763))->BgL_msgz00);
						BgL_arg2658z00_3770 =
							PROCEDURE_ENTRY(BgL_pz00_3764) (BgL_pz00_3764,
							((obj_t) BgL_arg2666z00_3776), BgL_arg0z00_3765, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2668z00_3777;

						BgL_arg2668z00_3777 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3763))->BgL_objz00);
						BgL_arg2659z00_3771 =
							PROCEDURE_ENTRY(BgL_pz00_3764) (BgL_pz00_3764,
							((obj_t) BgL_arg2668z00_3777), BgL_arg0z00_3765, BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2660z00_3772;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2661z00_3773;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2663z00_3774;

								BgL_arg2663z00_3774 = MAKE_PAIR(BgL_arg2659z00_3771, BNIL);
								BgL_arg2661z00_3773 =
									MAKE_PAIR(BgL_arg2658z00_3770, BgL_arg2663z00_3774);
							}
							BgL_list2660z00_3772 =
								MAKE_PAIR(BgL_arg2656z00_3769, BgL_arg2661z00_3773);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2660z00_3772);
					}
				}
			}
		}
	}



/* &walk0*-fail1851 */
	obj_t BGl_z62walk0za2zd2fail1851z12zzast_walkz00(obj_t BgL_envz00_7614,
		obj_t BgL_nz00_7615, obj_t BgL_pz00_7616)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3748;
				obj_t BgL_pz00_3749;

				BgL_nz00_3748 = ((BgL_failz00_bglt) BgL_nz00_7615);
				BgL_pz00_3749 = BgL_pz00_7616;
				{	/* Ast/walk.scm 303 */
					obj_t BgL_arg2646z00_3753;
					obj_t BgL_arg2647z00_3754;
					obj_t BgL_arg2648z00_3755;

					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2652z00_3759;

						BgL_arg2652z00_3759 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3748))->BgL_procz00);
						BgL_arg2646z00_3753 =
							PROCEDURE_ENTRY(BgL_pz00_3749) (BgL_pz00_3749,
							((obj_t) BgL_arg2652z00_3759), BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2653z00_3760;

						BgL_arg2653z00_3760 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3748))->BgL_msgz00);
						BgL_arg2647z00_3754 =
							PROCEDURE_ENTRY(BgL_pz00_3749) (BgL_pz00_3749,
							((obj_t) BgL_arg2653z00_3760), BEOA);
					}
					{	/* Ast/walk.scm 303 */
						BgL_nodez00_bglt BgL_arg2655z00_3761;

						BgL_arg2655z00_3761 =
							(((BgL_failz00_bglt) CREF(BgL_nz00_3748))->BgL_objz00);
						BgL_arg2648z00_3755 =
							PROCEDURE_ENTRY(BgL_pz00_3749) (BgL_pz00_3749,
							((obj_t) BgL_arg2655z00_3761), BEOA);
					}
					{	/* Ast/walk.scm 303 */
						obj_t BgL_list2649z00_3756;

						{	/* Ast/walk.scm 303 */
							obj_t BgL_arg2650z00_3757;

							{	/* Ast/walk.scm 303 */
								obj_t BgL_arg2651z00_3758;

								BgL_arg2651z00_3758 = MAKE_PAIR(BgL_arg2648z00_3755, BNIL);
								BgL_arg2650z00_3757 =
									MAKE_PAIR(BgL_arg2647z00_3754, BgL_arg2651z00_3758);
							}
							BgL_list2649z00_3756 =
								MAKE_PAIR(BgL_arg2646z00_3753, BgL_arg2650z00_3757);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2649z00_3756);
					}
				}
			}
		}
	}



/* &walk3-fail1849 */
	obj_t BGl_z62walk3zd2fail1849zb0zzast_walkz00(obj_t BgL_envz00_7617,
		obj_t BgL_nz00_7618, obj_t BgL_pz00_7619, obj_t BgL_arg0z00_7620,
		obj_t BgL_arg1z00_7621, obj_t BgL_arg2z00_7622)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3736;
				obj_t BgL_pz00_3737;
				obj_t BgL_arg0z00_3738;
				obj_t BgL_arg1z00_3739;
				obj_t BgL_arg2z00_3740;

				BgL_nz00_3736 = ((BgL_failz00_bglt) BgL_nz00_7618);
				BgL_pz00_3737 = BgL_pz00_7619;
				BgL_arg0z00_3738 = BgL_arg0z00_7620;
				BgL_arg1z00_3739 = BgL_arg1z00_7621;
				BgL_arg2z00_3740 = BgL_arg2z00_7622;
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2642z00_3744;

					BgL_arg2642z00_3744 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3736))->BgL_procz00);
					PROCEDURE_ENTRY(BgL_pz00_3737) (BgL_pz00_3737,
						((obj_t) BgL_arg2642z00_3744), BgL_arg0z00_3738, BgL_arg1z00_3739,
						BgL_arg2z00_3740, BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2643z00_3745;

					BgL_arg2643z00_3745 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3736))->BgL_msgz00);
					PROCEDURE_ENTRY(BgL_pz00_3737) (BgL_pz00_3737,
						((obj_t) BgL_arg2643z00_3745), BgL_arg0z00_3738, BgL_arg1z00_3739,
						BgL_arg2z00_3740, BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2644z00_3746;

					BgL_arg2644z00_3746 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3736))->BgL_objz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3737) (BgL_pz00_3737,
						((obj_t) BgL_arg2644z00_3746), BgL_arg0z00_3738, BgL_arg1z00_3739,
						BgL_arg2z00_3740, BEOA);
				}
			}
		}
	}



/* &walk2-fail1847 */
	obj_t BGl_z62walk2zd2fail1847zb0zzast_walkz00(obj_t BgL_envz00_7623,
		obj_t BgL_nz00_7624, obj_t BgL_pz00_7625, obj_t BgL_arg0z00_7626,
		obj_t BgL_arg1z00_7627)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3725;
				obj_t BgL_pz00_3726;
				obj_t BgL_arg0z00_3727;
				obj_t BgL_arg1z00_3728;

				BgL_nz00_3725 = ((BgL_failz00_bglt) BgL_nz00_7624);
				BgL_pz00_3726 = BgL_pz00_7625;
				BgL_arg0z00_3727 = BgL_arg0z00_7626;
				BgL_arg1z00_3728 = BgL_arg1z00_7627;
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2637z00_3732;

					BgL_arg2637z00_3732 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3725))->BgL_procz00);
					PROCEDURE_ENTRY(BgL_pz00_3726) (BgL_pz00_3726,
						((obj_t) BgL_arg2637z00_3732), BgL_arg0z00_3727, BgL_arg1z00_3728,
						BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2638z00_3733;

					BgL_arg2638z00_3733 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3725))->BgL_msgz00);
					PROCEDURE_ENTRY(BgL_pz00_3726) (BgL_pz00_3726,
						((obj_t) BgL_arg2638z00_3733), BgL_arg0z00_3727, BgL_arg1z00_3728,
						BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2640z00_3734;

					BgL_arg2640z00_3734 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3725))->BgL_objz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3726) (BgL_pz00_3726,
						((obj_t) BgL_arg2640z00_3734), BgL_arg0z00_3727, BgL_arg1z00_3728,
						BEOA);
				}
			}
		}
	}



/* &walk1-fail1845 */
	obj_t BGl_z62walk1zd2fail1845zb0zzast_walkz00(obj_t BgL_envz00_7628,
		obj_t BgL_nz00_7629, obj_t BgL_pz00_7630, obj_t BgL_arg0z00_7631)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3715;
				obj_t BgL_pz00_3716;
				obj_t BgL_arg0z00_3717;

				BgL_nz00_3715 = ((BgL_failz00_bglt) BgL_nz00_7629);
				BgL_pz00_3716 = BgL_pz00_7630;
				BgL_arg0z00_3717 = BgL_arg0z00_7631;
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2634z00_3721;

					BgL_arg2634z00_3721 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3715))->BgL_procz00);
					PROCEDURE_ENTRY(BgL_pz00_3716) (BgL_pz00_3716,
						((obj_t) BgL_arg2634z00_3721), BgL_arg0z00_3717, BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2635z00_3722;

					BgL_arg2635z00_3722 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3715))->BgL_msgz00);
					PROCEDURE_ENTRY(BgL_pz00_3716) (BgL_pz00_3716,
						((obj_t) BgL_arg2635z00_3722), BgL_arg0z00_3717, BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2636z00_3723;

					BgL_arg2636z00_3723 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3715))->BgL_objz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3716) (BgL_pz00_3716,
						((obj_t) BgL_arg2636z00_3723), BgL_arg0z00_3717, BEOA);
				}
			}
		}
	}



/* &walk0-fail1843 */
	obj_t BGl_z62walk0zd2fail1843zb0zzast_walkz00(obj_t BgL_envz00_7632,
		obj_t BgL_nz00_7633, obj_t BgL_pz00_7634)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 303 */
			{
				BgL_failz00_bglt BgL_nz00_3706;
				obj_t BgL_pz00_3707;

				BgL_nz00_3706 = ((BgL_failz00_bglt) BgL_nz00_7633);
				BgL_pz00_3707 = BgL_pz00_7634;
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2629z00_3711;

					BgL_arg2629z00_3711 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3706))->BgL_procz00);
					PROCEDURE_ENTRY(BgL_pz00_3707) (BgL_pz00_3707,
						((obj_t) BgL_arg2629z00_3711), BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2631z00_3712;

					BgL_arg2631z00_3712 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3706))->BgL_msgz00);
					PROCEDURE_ENTRY(BgL_pz00_3707) (BgL_pz00_3707,
						((obj_t) BgL_arg2631z00_3712), BEOA);
				}
				{	/* Ast/walk.scm 303 */
					BgL_nodez00_bglt BgL_arg2633z00_3713;

					BgL_arg2633z00_3713 =
						(((BgL_failz00_bglt) CREF(BgL_nz00_3706))->BgL_objz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3707) (BgL_pz00_3707,
						((obj_t) BgL_arg2633z00_3713), BEOA);
				}
			}
		}
	}



/* &walk3!-conditional1841 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2conditional1841za2zzast_walkz00(obj_t
		BgL_envz00_7635, obj_t BgL_nz00_7636, obj_t BgL_pz00_7637,
		obj_t BgL_arg0z00_7638, obj_t BgL_arg1z00_7639, obj_t BgL_arg2z00_7640)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3694;
				obj_t BgL_pz00_3695;
				obj_t BgL_arg0z00_3696;
				obj_t BgL_arg1z00_3697;
				obj_t BgL_arg2z00_3698;

				BgL_nz00_3694 = ((BgL_conditionalz00_bglt) BgL_nz00_7636);
				BgL_pz00_3695 = BgL_pz00_7637;
				BgL_arg0z00_3696 = BgL_arg0z00_7638;
				BgL_arg1z00_3697 = BgL_arg1z00_7639;
				BgL_arg2z00_3698 = BgL_arg2z00_7640;
				{
					BgL_nodez00_bglt BgL_auxz00_11625;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2626z00_3702;

						BgL_arg2626z00_3702 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3694))->BgL_testz00);
						BgL_auxz00_11625 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3695) (BgL_pz00_3695,
								((obj_t) BgL_arg2626z00_3702), BgL_arg0z00_3696,
								BgL_arg1z00_3697, BgL_arg2z00_3698, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3694))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11625), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11637;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2627z00_3703;

						BgL_arg2627z00_3703 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3694))->BgL_truez00);
						BgL_auxz00_11637 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3695) (BgL_pz00_3695,
								((obj_t) BgL_arg2627z00_3703), BgL_arg0z00_3696,
								BgL_arg1z00_3697, BgL_arg2z00_3698, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3694))->BgL_truez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11637), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11649;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2628z00_3704;

						BgL_arg2628z00_3704 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3694))->BgL_falsez00);
						BgL_auxz00_11649 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3695) (BgL_pz00_3695,
								((obj_t) BgL_arg2628z00_3704), BgL_arg0z00_3696,
								BgL_arg1z00_3697, BgL_arg2z00_3698, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3694))->BgL_falsez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11649), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3694);
			}
		}
	}



/* &walk2!-conditional1839 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2conditional1839za2zzast_walkz00(obj_t
		BgL_envz00_7641, obj_t BgL_nz00_7642, obj_t BgL_pz00_7643,
		obj_t BgL_arg0z00_7644, obj_t BgL_arg1z00_7645)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3683;
				obj_t BgL_pz00_3684;
				obj_t BgL_arg0z00_3685;
				obj_t BgL_arg1z00_3686;

				BgL_nz00_3683 = ((BgL_conditionalz00_bglt) BgL_nz00_7642);
				BgL_pz00_3684 = BgL_pz00_7643;
				BgL_arg0z00_3685 = BgL_arg0z00_7644;
				BgL_arg1z00_3686 = BgL_arg1z00_7645;
				{
					BgL_nodez00_bglt BgL_auxz00_11663;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2622z00_3690;

						BgL_arg2622z00_3690 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3683))->BgL_testz00);
						BgL_auxz00_11663 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3684) (BgL_pz00_3684,
								((obj_t) BgL_arg2622z00_3690), BgL_arg0z00_3685,
								BgL_arg1z00_3686, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3683))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11663), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11674;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2624z00_3691;

						BgL_arg2624z00_3691 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3683))->BgL_truez00);
						BgL_auxz00_11674 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3684) (BgL_pz00_3684,
								((obj_t) BgL_arg2624z00_3691), BgL_arg0z00_3685,
								BgL_arg1z00_3686, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3683))->BgL_truez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11674), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11685;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2625z00_3692;

						BgL_arg2625z00_3692 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3683))->BgL_falsez00);
						BgL_auxz00_11685 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3684) (BgL_pz00_3684,
								((obj_t) BgL_arg2625z00_3692), BgL_arg0z00_3685,
								BgL_arg1z00_3686, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3683))->BgL_falsez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11685), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3683);
			}
		}
	}



/* &walk1!-conditional1836 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2conditional1836za2zzast_walkz00(obj_t
		BgL_envz00_7646, obj_t BgL_nz00_7647, obj_t BgL_pz00_7648,
		obj_t BgL_arg0z00_7649)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3673;
				obj_t BgL_pz00_3674;
				obj_t BgL_arg0z00_3675;

				BgL_nz00_3673 = ((BgL_conditionalz00_bglt) BgL_nz00_7647);
				BgL_pz00_3674 = BgL_pz00_7648;
				BgL_arg0z00_3675 = BgL_arg0z00_7649;
				{
					BgL_nodez00_bglt BgL_auxz00_11698;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2619z00_3679;

						BgL_arg2619z00_3679 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3673))->BgL_testz00);
						BgL_auxz00_11698 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3674) (BgL_pz00_3674,
								((obj_t) BgL_arg2619z00_3679), BgL_arg0z00_3675, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3673))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11698), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11708;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2620z00_3680;

						BgL_arg2620z00_3680 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3673))->BgL_truez00);
						BgL_auxz00_11708 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3674) (BgL_pz00_3674,
								((obj_t) BgL_arg2620z00_3680), BgL_arg0z00_3675, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3673))->BgL_truez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11708), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11718;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2621z00_3681;

						BgL_arg2621z00_3681 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3673))->BgL_falsez00);
						BgL_auxz00_11718 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3674) (BgL_pz00_3674,
								((obj_t) BgL_arg2621z00_3681), BgL_arg0z00_3675, BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3673))->BgL_falsez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11718), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3673);
			}
		}
	}



/* &walk0!-conditional1834 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2conditional1834za2zzast_walkz00(obj_t
		BgL_envz00_7650, obj_t BgL_nz00_7651, obj_t BgL_pz00_7652)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3664;
				obj_t BgL_pz00_3665;

				BgL_nz00_3664 = ((BgL_conditionalz00_bglt) BgL_nz00_7651);
				BgL_pz00_3665 = BgL_pz00_7652;
				{
					BgL_nodez00_bglt BgL_auxz00_11730;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2616z00_3669;

						BgL_arg2616z00_3669 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3664))->BgL_testz00);
						BgL_auxz00_11730 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3665) (BgL_pz00_3665,
								((obj_t) BgL_arg2616z00_3669), BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3664))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_11730), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11739;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2617z00_3670;

						BgL_arg2617z00_3670 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3664))->BgL_truez00);
						BgL_auxz00_11739 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3665) (BgL_pz00_3665,
								((obj_t) BgL_arg2617z00_3670), BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3664))->BgL_truez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11739), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11748;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2618z00_3671;

						BgL_arg2618z00_3671 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3664))->BgL_falsez00);
						BgL_auxz00_11748 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3665) (BgL_pz00_3665,
								((obj_t) BgL_arg2618z00_3671), BEOA));
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nz00_3664))->BgL_falsez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11748), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3664);
			}
		}
	}



/* &walk3*-conditional1832 */
	obj_t BGl_z62walk3za2zd2conditional1832z12zzast_walkz00(obj_t BgL_envz00_7653,
		obj_t BgL_nz00_7654, obj_t BgL_pz00_7655, obj_t BgL_arg0z00_7656,
		obj_t BgL_arg1z00_7657, obj_t BgL_arg2z00_7658)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3646;
				obj_t BgL_pz00_3647;
				obj_t BgL_arg0z00_3648;
				obj_t BgL_arg1z00_3649;
				obj_t BgL_arg2z00_3650;

				BgL_nz00_3646 = ((BgL_conditionalz00_bglt) BgL_nz00_7654);
				BgL_pz00_3647 = BgL_pz00_7655;
				BgL_arg0z00_3648 = BgL_arg0z00_7656;
				BgL_arg1z00_3649 = BgL_arg1z00_7657;
				BgL_arg2z00_3650 = BgL_arg2z00_7658;
				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2605z00_3654;
					obj_t BgL_arg2607z00_3655;
					obj_t BgL_arg2608z00_3656;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2612z00_3660;

						BgL_arg2612z00_3660 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3646))->BgL_testz00);
						BgL_arg2605z00_3654 =
							PROCEDURE_ENTRY(BgL_pz00_3647) (BgL_pz00_3647,
							((obj_t) BgL_arg2612z00_3660), BgL_arg0z00_3648, BgL_arg1z00_3649,
							BgL_arg2z00_3650, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2613z00_3661;

						BgL_arg2613z00_3661 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3646))->BgL_truez00);
						BgL_arg2607z00_3655 =
							PROCEDURE_ENTRY(BgL_pz00_3647) (BgL_pz00_3647,
							((obj_t) BgL_arg2613z00_3661), BgL_arg0z00_3648, BgL_arg1z00_3649,
							BgL_arg2z00_3650, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2615z00_3662;

						BgL_arg2615z00_3662 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3646))->BgL_falsez00);
						BgL_arg2608z00_3656 =
							PROCEDURE_ENTRY(BgL_pz00_3647) (BgL_pz00_3647,
							((obj_t) BgL_arg2615z00_3662), BgL_arg0z00_3648, BgL_arg1z00_3649,
							BgL_arg2z00_3650, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2609z00_3657;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2610z00_3658;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2611z00_3659;

								BgL_arg2611z00_3659 = MAKE_PAIR(BgL_arg2608z00_3656, BNIL);
								BgL_arg2610z00_3658 =
									MAKE_PAIR(BgL_arg2607z00_3655, BgL_arg2611z00_3659);
							}
							BgL_list2609z00_3657 =
								MAKE_PAIR(BgL_arg2605z00_3654, BgL_arg2610z00_3658);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2609z00_3657);
					}
				}
			}
		}
	}



/* &walk2*-conditional1830 */
	obj_t BGl_z62walk2za2zd2conditional1830z12zzast_walkz00(obj_t BgL_envz00_7659,
		obj_t BgL_nz00_7660, obj_t BgL_pz00_7661, obj_t BgL_arg0z00_7662,
		obj_t BgL_arg1z00_7663)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3629;
				obj_t BgL_pz00_3630;
				obj_t BgL_arg0z00_3631;
				obj_t BgL_arg1z00_3632;

				BgL_nz00_3629 = ((BgL_conditionalz00_bglt) BgL_nz00_7660);
				BgL_pz00_3630 = BgL_pz00_7661;
				BgL_arg0z00_3631 = BgL_arg0z00_7662;
				BgL_arg1z00_3632 = BgL_arg1z00_7663;
				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2595z00_3636;
					obj_t BgL_arg2596z00_3637;
					obj_t BgL_arg2597z00_3638;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2602z00_3642;

						BgL_arg2602z00_3642 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3629))->BgL_testz00);
						BgL_arg2595z00_3636 =
							PROCEDURE_ENTRY(BgL_pz00_3630) (BgL_pz00_3630,
							((obj_t) BgL_arg2602z00_3642), BgL_arg0z00_3631, BgL_arg1z00_3632,
							BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2603z00_3643;

						BgL_arg2603z00_3643 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3629))->BgL_truez00);
						BgL_arg2596z00_3637 =
							PROCEDURE_ENTRY(BgL_pz00_3630) (BgL_pz00_3630,
							((obj_t) BgL_arg2603z00_3643), BgL_arg0z00_3631, BgL_arg1z00_3632,
							BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2604z00_3644;

						BgL_arg2604z00_3644 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3629))->BgL_falsez00);
						BgL_arg2597z00_3638 =
							PROCEDURE_ENTRY(BgL_pz00_3630) (BgL_pz00_3630,
							((obj_t) BgL_arg2604z00_3644), BgL_arg0z00_3631, BgL_arg1z00_3632,
							BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2598z00_3639;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2600z00_3640;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2601z00_3641;

								BgL_arg2601z00_3641 = MAKE_PAIR(BgL_arg2597z00_3638, BNIL);
								BgL_arg2600z00_3640 =
									MAKE_PAIR(BgL_arg2596z00_3637, BgL_arg2601z00_3641);
							}
							BgL_list2598z00_3639 =
								MAKE_PAIR(BgL_arg2595z00_3636, BgL_arg2600z00_3640);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2598z00_3639);
					}
				}
			}
		}
	}



/* &walk1*-conditional1828 */
	obj_t BGl_z62walk1za2zd2conditional1828z12zzast_walkz00(obj_t BgL_envz00_7664,
		obj_t BgL_nz00_7665, obj_t BgL_pz00_7666, obj_t BgL_arg0z00_7667)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3613;
				obj_t BgL_pz00_3614;
				obj_t BgL_arg0z00_3615;

				BgL_nz00_3613 = ((BgL_conditionalz00_bglt) BgL_nz00_7665);
				BgL_pz00_3614 = BgL_pz00_7666;
				BgL_arg0z00_3615 = BgL_arg0z00_7667;
				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2584z00_3619;
					obj_t BgL_arg2585z00_3620;
					obj_t BgL_arg2586z00_3621;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2591z00_3625;

						BgL_arg2591z00_3625 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3613))->BgL_testz00);
						BgL_arg2584z00_3619 =
							PROCEDURE_ENTRY(BgL_pz00_3614) (BgL_pz00_3614,
							((obj_t) BgL_arg2591z00_3625), BgL_arg0z00_3615, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2592z00_3626;

						BgL_arg2592z00_3626 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3613))->BgL_truez00);
						BgL_arg2585z00_3620 =
							PROCEDURE_ENTRY(BgL_pz00_3614) (BgL_pz00_3614,
							((obj_t) BgL_arg2592z00_3626), BgL_arg0z00_3615, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2593z00_3627;

						BgL_arg2593z00_3627 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3613))->BgL_falsez00);
						BgL_arg2586z00_3621 =
							PROCEDURE_ENTRY(BgL_pz00_3614) (BgL_pz00_3614,
							((obj_t) BgL_arg2593z00_3627), BgL_arg0z00_3615, BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2587z00_3622;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2588z00_3623;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2590z00_3624;

								BgL_arg2590z00_3624 = MAKE_PAIR(BgL_arg2586z00_3621, BNIL);
								BgL_arg2588z00_3623 =
									MAKE_PAIR(BgL_arg2585z00_3620, BgL_arg2590z00_3624);
							}
							BgL_list2587z00_3622 =
								MAKE_PAIR(BgL_arg2584z00_3619, BgL_arg2588z00_3623);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2587z00_3622);
					}
				}
			}
		}
	}



/* &walk0*-conditional1826 */
	obj_t BGl_z62walk0za2zd2conditional1826z12zzast_walkz00(obj_t BgL_envz00_7668,
		obj_t BgL_nz00_7669, obj_t BgL_pz00_7670)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3598;
				obj_t BgL_pz00_3599;

				BgL_nz00_3598 = ((BgL_conditionalz00_bglt) BgL_nz00_7669);
				BgL_pz00_3599 = BgL_pz00_7670;
				{	/* Ast/walk.scm 302 */
					obj_t BgL_arg2572z00_3603;
					obj_t BgL_arg2575z00_3604;
					obj_t BgL_arg2576z00_3605;

					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2580z00_3609;

						BgL_arg2580z00_3609 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3598))->BgL_testz00);
						BgL_arg2572z00_3603 =
							PROCEDURE_ENTRY(BgL_pz00_3599) (BgL_pz00_3599,
							((obj_t) BgL_arg2580z00_3609), BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2582z00_3610;

						BgL_arg2582z00_3610 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3598))->BgL_truez00);
						BgL_arg2575z00_3604 =
							PROCEDURE_ENTRY(BgL_pz00_3599) (BgL_pz00_3599,
							((obj_t) BgL_arg2582z00_3610), BEOA);
					}
					{	/* Ast/walk.scm 302 */
						BgL_nodez00_bglt BgL_arg2583z00_3611;

						BgL_arg2583z00_3611 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3598))->BgL_falsez00);
						BgL_arg2576z00_3605 =
							PROCEDURE_ENTRY(BgL_pz00_3599) (BgL_pz00_3599,
							((obj_t) BgL_arg2583z00_3611), BEOA);
					}
					{	/* Ast/walk.scm 302 */
						obj_t BgL_list2577z00_3606;

						{	/* Ast/walk.scm 302 */
							obj_t BgL_arg2578z00_3607;

							{	/* Ast/walk.scm 302 */
								obj_t BgL_arg2579z00_3608;

								BgL_arg2579z00_3608 = MAKE_PAIR(BgL_arg2576z00_3605, BNIL);
								BgL_arg2578z00_3607 =
									MAKE_PAIR(BgL_arg2575z00_3604, BgL_arg2579z00_3608);
							}
							BgL_list2577z00_3606 =
								MAKE_PAIR(BgL_arg2572z00_3603, BgL_arg2578z00_3607);
						}
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2577z00_3606);
					}
				}
			}
		}
	}



/* &walk3-conditional1824 */
	obj_t BGl_z62walk3zd2conditional1824zb0zzast_walkz00(obj_t BgL_envz00_7671,
		obj_t BgL_nz00_7672, obj_t BgL_pz00_7673, obj_t BgL_arg0z00_7674,
		obj_t BgL_arg1z00_7675, obj_t BgL_arg2z00_7676)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3586;
				obj_t BgL_pz00_3587;
				obj_t BgL_arg0z00_3588;
				obj_t BgL_arg1z00_3589;
				obj_t BgL_arg2z00_3590;

				BgL_nz00_3586 = ((BgL_conditionalz00_bglt) BgL_nz00_7672);
				BgL_pz00_3587 = BgL_pz00_7673;
				BgL_arg0z00_3588 = BgL_arg0z00_7674;
				BgL_arg1z00_3589 = BgL_arg1z00_7675;
				BgL_arg2z00_3590 = BgL_arg2z00_7676;
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2567z00_3594;

					BgL_arg2567z00_3594 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3586))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_3587) (BgL_pz00_3587,
						((obj_t) BgL_arg2567z00_3594), BgL_arg0z00_3588, BgL_arg1z00_3589,
						BgL_arg2z00_3590, BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2568z00_3595;

					BgL_arg2568z00_3595 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3586))->BgL_truez00);
					PROCEDURE_ENTRY(BgL_pz00_3587) (BgL_pz00_3587,
						((obj_t) BgL_arg2568z00_3595), BgL_arg0z00_3588, BgL_arg1z00_3589,
						BgL_arg2z00_3590, BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2571z00_3596;

					BgL_arg2571z00_3596 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3586))->BgL_falsez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3587) (BgL_pz00_3587,
						((obj_t) BgL_arg2571z00_3596), BgL_arg0z00_3588, BgL_arg1z00_3589,
						BgL_arg2z00_3590, BEOA);
				}
			}
		}
	}



/* &walk2-conditional1822 */
	obj_t BGl_z62walk2zd2conditional1822zb0zzast_walkz00(obj_t BgL_envz00_7677,
		obj_t BgL_nz00_7678, obj_t BgL_pz00_7679, obj_t BgL_arg0z00_7680,
		obj_t BgL_arg1z00_7681)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3575;
				obj_t BgL_pz00_3576;
				obj_t BgL_arg0z00_3577;
				obj_t BgL_arg1z00_3578;

				BgL_nz00_3575 = ((BgL_conditionalz00_bglt) BgL_nz00_7678);
				BgL_pz00_3576 = BgL_pz00_7679;
				BgL_arg0z00_3577 = BgL_arg0z00_7680;
				BgL_arg1z00_3578 = BgL_arg1z00_7681;
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2560z00_3582;

					BgL_arg2560z00_3582 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3575))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_3576) (BgL_pz00_3576,
						((obj_t) BgL_arg2560z00_3582), BgL_arg0z00_3577, BgL_arg1z00_3578,
						BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2563z00_3583;

					BgL_arg2563z00_3583 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3575))->BgL_truez00);
					PROCEDURE_ENTRY(BgL_pz00_3576) (BgL_pz00_3576,
						((obj_t) BgL_arg2563z00_3583), BgL_arg0z00_3577, BgL_arg1z00_3578,
						BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2564z00_3584;

					BgL_arg2564z00_3584 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3575))->BgL_falsez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3576) (BgL_pz00_3576,
						((obj_t) BgL_arg2564z00_3584), BgL_arg0z00_3577, BgL_arg1z00_3578,
						BEOA);
				}
			}
		}
	}



/* &walk1-conditional1820 */
	obj_t BGl_z62walk1zd2conditional1820zb0zzast_walkz00(obj_t BgL_envz00_7682,
		obj_t BgL_nz00_7683, obj_t BgL_pz00_7684, obj_t BgL_arg0z00_7685)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3565;
				obj_t BgL_pz00_3566;
				obj_t BgL_arg0z00_3567;

				BgL_nz00_3565 = ((BgL_conditionalz00_bglt) BgL_nz00_7683);
				BgL_pz00_3566 = BgL_pz00_7684;
				BgL_arg0z00_3567 = BgL_arg0z00_7685;
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2557z00_3571;

					BgL_arg2557z00_3571 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3565))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_3566) (BgL_pz00_3566,
						((obj_t) BgL_arg2557z00_3571), BgL_arg0z00_3567, BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2558z00_3572;

					BgL_arg2558z00_3572 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3565))->BgL_truez00);
					PROCEDURE_ENTRY(BgL_pz00_3566) (BgL_pz00_3566,
						((obj_t) BgL_arg2558z00_3572), BgL_arg0z00_3567, BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2559z00_3573;

					BgL_arg2559z00_3573 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3565))->BgL_falsez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3566) (BgL_pz00_3566,
						((obj_t) BgL_arg2559z00_3573), BgL_arg0z00_3567, BEOA);
				}
			}
		}
	}



/* &walk0-conditional1818 */
	obj_t BGl_z62walk0zd2conditional1818zb0zzast_walkz00(obj_t BgL_envz00_7686,
		obj_t BgL_nz00_7687, obj_t BgL_pz00_7688)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 302 */
			{
				BgL_conditionalz00_bglt BgL_nz00_3556;
				obj_t BgL_pz00_3557;

				BgL_nz00_3556 = ((BgL_conditionalz00_bglt) BgL_nz00_7687);
				BgL_pz00_3557 = BgL_pz00_7688;
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2553z00_3561;

					BgL_arg2553z00_3561 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3556))->BgL_testz00);
					PROCEDURE_ENTRY(BgL_pz00_3557) (BgL_pz00_3557,
						((obj_t) BgL_arg2553z00_3561), BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2555z00_3562;

					BgL_arg2555z00_3562 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3556))->BgL_truez00);
					PROCEDURE_ENTRY(BgL_pz00_3557) (BgL_pz00_3557,
						((obj_t) BgL_arg2555z00_3562), BEOA);
				}
				{	/* Ast/walk.scm 302 */
					BgL_nodez00_bglt BgL_arg2556z00_3563;

					BgL_arg2556z00_3563 =
						(((BgL_conditionalz00_bglt) CREF(BgL_nz00_3556))->BgL_falsez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3557) (BgL_pz00_3557,
						((obj_t) BgL_arg2556z00_3563), BEOA);
				}
			}
		}
	}



/* &walk3!-setq1816 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2setq1816za2zzast_walkz00(obj_t
		BgL_envz00_7689, obj_t BgL_nz00_7690, obj_t BgL_pz00_7691,
		obj_t BgL_arg0z00_7692, obj_t BgL_arg1z00_7693, obj_t BgL_arg2z00_7694)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3545;
				obj_t BgL_pz00_3546;
				obj_t BgL_arg0z00_3547;
				obj_t BgL_arg1z00_3548;
				obj_t BgL_arg2z00_3549;

				BgL_nz00_3545 = ((BgL_setqz00_bglt) BgL_nz00_7690);
				BgL_pz00_3546 = BgL_pz00_7691;
				BgL_arg0z00_3547 = BgL_arg0z00_7692;
				BgL_arg1z00_3548 = BgL_arg1z00_7693;
				BgL_arg2z00_3549 = BgL_arg2z00_7694;
				{
					BgL_varz00_bglt BgL_auxz00_11963;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2550z00_6277;

						BgL_arg2550z00_6277 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3545))->BgL_varz00);
						BgL_auxz00_11963 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3546) (BgL_pz00_3546,
								((obj_t) BgL_arg2550z00_6277), BgL_arg0z00_3547,
								BgL_arg1z00_3548, BgL_arg2z00_3549, BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3545))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_11963), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_11975;

					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2552z00_6278;

						BgL_arg2552z00_6278 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3545))->BgL_valuez00);
						BgL_auxz00_11975 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3546) (BgL_pz00_3546,
								((obj_t) BgL_arg2552z00_6278), BgL_arg0z00_3547,
								BgL_arg1z00_3548, BgL_arg2z00_3549, BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3545))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_11975), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3545);
			}
		}
	}



/* &walk2!-setq1814 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2setq1814za2zzast_walkz00(obj_t
		BgL_envz00_7695, obj_t BgL_nz00_7696, obj_t BgL_pz00_7697,
		obj_t BgL_arg0z00_7698, obj_t BgL_arg1z00_7699)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3535;
				obj_t BgL_pz00_3536;
				obj_t BgL_arg0z00_3537;
				obj_t BgL_arg1z00_3538;

				BgL_nz00_3535 = ((BgL_setqz00_bglt) BgL_nz00_7696);
				BgL_pz00_3536 = BgL_pz00_7697;
				BgL_arg0z00_3537 = BgL_arg0z00_7698;
				BgL_arg1z00_3538 = BgL_arg1z00_7699;
				{
					BgL_varz00_bglt BgL_auxz00_11989;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2548z00_3542;

						BgL_arg2548z00_3542 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3535))->BgL_varz00);
						BgL_auxz00_11989 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3536) (BgL_pz00_3536,
								((obj_t) BgL_arg2548z00_3542), BgL_arg0z00_3537,
								BgL_arg1z00_3538, BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3535))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_11989), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_12000;

					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2549z00_3543;

						BgL_arg2549z00_3543 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3535))->BgL_valuez00);
						BgL_auxz00_12000 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3536) (BgL_pz00_3536,
								((obj_t) BgL_arg2549z00_3543), BgL_arg0z00_3537,
								BgL_arg1z00_3538, BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3535))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_12000), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3535);
			}
		}
	}



/* &walk1!-setq1812 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2setq1812za2zzast_walkz00(obj_t
		BgL_envz00_7700, obj_t BgL_nz00_7701, obj_t BgL_pz00_7702,
		obj_t BgL_arg0z00_7703)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3526;
				obj_t BgL_pz00_3527;
				obj_t BgL_arg0z00_3528;

				BgL_nz00_3526 = ((BgL_setqz00_bglt) BgL_nz00_7701);
				BgL_pz00_3527 = BgL_pz00_7702;
				BgL_arg0z00_3528 = BgL_arg0z00_7703;
				{
					BgL_varz00_bglt BgL_auxz00_12013;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2544z00_3532;

						BgL_arg2544z00_3532 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3526))->BgL_varz00);
						BgL_auxz00_12013 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3527) (BgL_pz00_3527,
								((obj_t) BgL_arg2544z00_3532), BgL_arg0z00_3528, BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3526))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_12013), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_12023;

					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2545z00_3533;

						BgL_arg2545z00_3533 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3526))->BgL_valuez00);
						BgL_auxz00_12023 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3527) (BgL_pz00_3527,
								((obj_t) BgL_arg2545z00_3533), BgL_arg0z00_3528, BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3526))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_12023), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3526);
			}
		}
	}



/* &walk0!-setq1810 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2setq1810za2zzast_walkz00(obj_t
		BgL_envz00_7704, obj_t BgL_nz00_7705, obj_t BgL_pz00_7706)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3518;
				obj_t BgL_pz00_3519;

				BgL_nz00_3518 = ((BgL_setqz00_bglt) BgL_nz00_7705);
				BgL_pz00_3519 = BgL_pz00_7706;
				{
					BgL_varz00_bglt BgL_auxz00_12035;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2540z00_3523;

						BgL_arg2540z00_3523 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3518))->BgL_varz00);
						BgL_auxz00_12035 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3519) (BgL_pz00_3519,
								((obj_t) BgL_arg2540z00_3523), BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3518))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_12035), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_12044;

					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2543z00_3524;

						BgL_arg2543z00_3524 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3518))->BgL_valuez00);
						BgL_auxz00_12044 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3519) (BgL_pz00_3519,
								((obj_t) BgL_arg2543z00_3524), BEOA));
					}
					((((BgL_setqz00_bglt) CREF(BgL_nz00_3518))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_12044), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3518);
			}
		}
	}



/* &walk3*-setq1808 */
	obj_t BGl_z62walk3za2zd2setq1808z12zzast_walkz00(obj_t BgL_envz00_7707,
		obj_t BgL_nz00_7708, obj_t BgL_pz00_7709, obj_t BgL_arg0z00_7710,
		obj_t BgL_arg1z00_7711, obj_t BgL_arg2z00_7712)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3505;
				obj_t BgL_pz00_3506;
				obj_t BgL_arg0z00_3507;
				obj_t BgL_arg1z00_3508;
				obj_t BgL_arg2z00_3509;

				BgL_nz00_3505 = ((BgL_setqz00_bglt) BgL_nz00_7708);
				BgL_pz00_3506 = BgL_pz00_7709;
				BgL_arg0z00_3507 = BgL_arg0z00_7710;
				BgL_arg1z00_3508 = BgL_arg1z00_7711;
				BgL_arg2z00_3509 = BgL_arg2z00_7712;
				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2534z00_6272;
					obj_t BgL_arg2535z00_6273;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2538z00_6274;

						BgL_arg2538z00_6274 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3505))->BgL_varz00);
						BgL_arg2534z00_6272 =
							PROCEDURE_ENTRY(BgL_pz00_3506) (BgL_pz00_3506,
							((obj_t) BgL_arg2538z00_6274), BgL_arg0z00_3507, BgL_arg1z00_3508,
							BgL_arg2z00_3509, BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2539z00_6275;

						BgL_arg2539z00_6275 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3505))->BgL_valuez00);
						BgL_arg2535z00_6273 =
							PROCEDURE_ENTRY(BgL_pz00_3506) (BgL_pz00_3506,
							((obj_t) BgL_arg2539z00_6275), BgL_arg0z00_3507, BgL_arg1z00_3508,
							BgL_arg2z00_3509, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2534z00_6272,
						BgL_arg2535z00_6273);
				}
			}
		}
	}



/* &walk2*-setq1806 */
	obj_t BGl_z62walk2za2zd2setq1806z12zzast_walkz00(obj_t BgL_envz00_7713,
		obj_t BgL_nz00_7714, obj_t BgL_pz00_7715, obj_t BgL_arg0z00_7716,
		obj_t BgL_arg1z00_7717)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3493;
				obj_t BgL_pz00_3494;
				obj_t BgL_arg0z00_3495;
				obj_t BgL_arg1z00_3496;

				BgL_nz00_3493 = ((BgL_setqz00_bglt) BgL_nz00_7714);
				BgL_pz00_3494 = BgL_pz00_7715;
				BgL_arg0z00_3495 = BgL_arg0z00_7716;
				BgL_arg1z00_3496 = BgL_arg1z00_7717;
				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2522z00_6267;
					obj_t BgL_arg2524z00_6268;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2530z00_6269;

						BgL_arg2530z00_6269 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3493))->BgL_varz00);
						BgL_arg2522z00_6267 =
							PROCEDURE_ENTRY(BgL_pz00_3494) (BgL_pz00_3494,
							((obj_t) BgL_arg2530z00_6269), BgL_arg0z00_3495, BgL_arg1z00_3496,
							BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2533z00_6270;

						BgL_arg2533z00_6270 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3493))->BgL_valuez00);
						BgL_arg2524z00_6268 =
							PROCEDURE_ENTRY(BgL_pz00_3494) (BgL_pz00_3494,
							((obj_t) BgL_arg2533z00_6270), BgL_arg0z00_3495, BgL_arg1z00_3496,
							BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2522z00_6267,
						BgL_arg2524z00_6268);
				}
			}
		}
	}



/* &walk1*-setq1804 */
	obj_t BGl_z62walk1za2zd2setq1804z12zzast_walkz00(obj_t BgL_envz00_7718,
		obj_t BgL_nz00_7719, obj_t BgL_pz00_7720, obj_t BgL_arg0z00_7721)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3482;
				obj_t BgL_pz00_3483;
				obj_t BgL_arg0z00_3484;

				BgL_nz00_3482 = ((BgL_setqz00_bglt) BgL_nz00_7719);
				BgL_pz00_3483 = BgL_pz00_7720;
				BgL_arg0z00_3484 = BgL_arg0z00_7721;
				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2517z00_3488;
					obj_t BgL_arg2518z00_3489;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2519z00_3490;

						BgL_arg2519z00_3490 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3482))->BgL_varz00);
						BgL_arg2517z00_3488 =
							PROCEDURE_ENTRY(BgL_pz00_3483) (BgL_pz00_3483,
							((obj_t) BgL_arg2519z00_3490), BgL_arg0z00_3484, BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2521z00_3491;

						BgL_arg2521z00_3491 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3482))->BgL_valuez00);
						BgL_arg2518z00_3489 =
							PROCEDURE_ENTRY(BgL_pz00_3483) (BgL_pz00_3483,
							((obj_t) BgL_arg2521z00_3491), BgL_arg0z00_3484, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2517z00_3488,
						BgL_arg2518z00_3489);
				}
			}
		}
	}



/* &walk0*-setq1802 */
	obj_t BGl_z62walk0za2zd2setq1802z12zzast_walkz00(obj_t BgL_envz00_7722,
		obj_t BgL_nz00_7723, obj_t BgL_pz00_7724)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3472;
				obj_t BgL_pz00_3473;

				BgL_nz00_3472 = ((BgL_setqz00_bglt) BgL_nz00_7723);
				BgL_pz00_3473 = BgL_pz00_7724;
				{	/* Ast/walk.scm 301 */
					obj_t BgL_arg2511z00_3477;
					obj_t BgL_arg2512z00_3478;

					{	/* Ast/walk.scm 301 */
						BgL_varz00_bglt BgL_arg2514z00_3479;

						BgL_arg2514z00_3479 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3472))->BgL_varz00);
						BgL_arg2511z00_3477 =
							PROCEDURE_ENTRY(BgL_pz00_3473) (BgL_pz00_3473,
							((obj_t) BgL_arg2514z00_3479), BEOA);
					}
					{	/* Ast/walk.scm 301 */
						BgL_nodez00_bglt BgL_arg2516z00_3480;

						BgL_arg2516z00_3480 =
							(((BgL_setqz00_bglt) CREF(BgL_nz00_3472))->BgL_valuez00);
						BgL_arg2512z00_3478 =
							PROCEDURE_ENTRY(BgL_pz00_3473) (BgL_pz00_3473,
							((obj_t) BgL_arg2516z00_3480), BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2511z00_3477,
						BgL_arg2512z00_3478);
				}
			}
		}
	}



/* &walk3-setq1800 */
	obj_t BGl_z62walk3zd2setq1800zb0zzast_walkz00(obj_t BgL_envz00_7725,
		obj_t BgL_nz00_7726, obj_t BgL_pz00_7727, obj_t BgL_arg0z00_7728,
		obj_t BgL_arg1z00_7729, obj_t BgL_arg2z00_7730)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3461;
				obj_t BgL_pz00_3462;
				obj_t BgL_arg0z00_3463;
				obj_t BgL_arg1z00_3464;
				obj_t BgL_arg2z00_3465;

				BgL_nz00_3461 = ((BgL_setqz00_bglt) BgL_nz00_7726);
				BgL_pz00_3462 = BgL_pz00_7727;
				BgL_arg0z00_3463 = BgL_arg0z00_7728;
				BgL_arg1z00_3464 = BgL_arg1z00_7729;
				BgL_arg2z00_3465 = BgL_arg2z00_7730;
				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2509z00_6264;

					BgL_arg2509z00_6264 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3461))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_3462) (BgL_pz00_3462,
						((obj_t) BgL_arg2509z00_6264), BgL_arg0z00_3463, BgL_arg1z00_3464,
						BgL_arg2z00_3465, BEOA);
				}
				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2510z00_6265;

					BgL_arg2510z00_6265 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3461))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3462) (BgL_pz00_3462,
						((obj_t) BgL_arg2510z00_6265), BgL_arg0z00_3463, BgL_arg1z00_3464,
						BgL_arg2z00_3465, BEOA);
				}
			}
		}
	}



/* &walk2-setq1798 */
	obj_t BGl_z62walk2zd2setq1798zb0zzast_walkz00(obj_t BgL_envz00_7731,
		obj_t BgL_nz00_7732, obj_t BgL_pz00_7733, obj_t BgL_arg0z00_7734,
		obj_t BgL_arg1z00_7735)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3451;
				obj_t BgL_pz00_3452;
				obj_t BgL_arg0z00_3453;
				obj_t BgL_arg1z00_3454;

				BgL_nz00_3451 = ((BgL_setqz00_bglt) BgL_nz00_7732);
				BgL_pz00_3452 = BgL_pz00_7733;
				BgL_arg0z00_3453 = BgL_arg0z00_7734;
				BgL_arg1z00_3454 = BgL_arg1z00_7735;
				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2506z00_6261;

					BgL_arg2506z00_6261 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3451))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_3452) (BgL_pz00_3452,
						((obj_t) BgL_arg2506z00_6261), BgL_arg0z00_3453, BgL_arg1z00_3454,
						BEOA);
				}
				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2508z00_6262;

					BgL_arg2508z00_6262 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3451))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3452) (BgL_pz00_3452,
						((obj_t) BgL_arg2508z00_6262), BgL_arg0z00_3453, BgL_arg1z00_3454,
						BEOA);
				}
			}
		}
	}



/* &walk1-setq1795 */
	obj_t BGl_z62walk1zd2setq1795zb0zzast_walkz00(obj_t BgL_envz00_7736,
		obj_t BgL_nz00_7737, obj_t BgL_pz00_7738, obj_t BgL_arg0z00_7739)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3442;
				obj_t BgL_pz00_3443;
				obj_t BgL_arg0z00_3444;

				BgL_nz00_3442 = ((BgL_setqz00_bglt) BgL_nz00_7737);
				BgL_pz00_3443 = BgL_pz00_7738;
				BgL_arg0z00_3444 = BgL_arg0z00_7739;
				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2503z00_6258;

					BgL_arg2503z00_6258 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3442))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_3443) (BgL_pz00_3443,
						((obj_t) BgL_arg2503z00_6258), BgL_arg0z00_3444, BEOA);
				}
				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2504z00_6259;

					BgL_arg2504z00_6259 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3442))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3443) (BgL_pz00_3443,
						((obj_t) BgL_arg2504z00_6259), BgL_arg0z00_3444, BEOA);
				}
			}
		}
	}



/* &walk0-setq1793 */
	obj_t BGl_z62walk0zd2setq1793zb0zzast_walkz00(obj_t BgL_envz00_7740,
		obj_t BgL_nz00_7741, obj_t BgL_pz00_7742)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 301 */
			{
				BgL_setqz00_bglt BgL_nz00_3434;
				obj_t BgL_pz00_3435;

				BgL_nz00_3434 = ((BgL_setqz00_bglt) BgL_nz00_7741);
				BgL_pz00_3435 = BgL_pz00_7742;
				{	/* Ast/walk.scm 301 */
					BgL_varz00_bglt BgL_arg2501z00_6255;

					BgL_arg2501z00_6255 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3434))->BgL_varz00);
					PROCEDURE_ENTRY(BgL_pz00_3435) (BgL_pz00_3435,
						((obj_t) BgL_arg2501z00_6255), BEOA);
				}
				{	/* Ast/walk.scm 301 */
					BgL_nodez00_bglt BgL_arg2502z00_6256;

					BgL_arg2502z00_6256 =
						(((BgL_setqz00_bglt) CREF(BgL_nz00_3434))->BgL_valuez00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3435) (BgL_pz00_3435,
						((obj_t) BgL_arg2502z00_6256), BEOA);
				}
			}
		}
	}



/* &walk3!-cast1791 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2cast1791za2zzast_walkz00(obj_t
		BgL_envz00_7743, obj_t BgL_nz00_7744, obj_t BgL_pz00_7745,
		obj_t BgL_arg0z00_7746, obj_t BgL_arg1z00_7747, obj_t BgL_arg2z00_7748)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3424;
				obj_t BgL_pz00_3425;
				obj_t BgL_arg0z00_3426;
				obj_t BgL_arg1z00_3427;
				obj_t BgL_arg2z00_3428;

				BgL_nz00_3424 = ((BgL_castz00_bglt) BgL_nz00_7744);
				BgL_pz00_3425 = BgL_pz00_7745;
				BgL_arg0z00_3426 = BgL_arg0z00_7746;
				BgL_arg1z00_3427 = BgL_arg1z00_7747;
				BgL_arg2z00_3428 = BgL_arg2z00_7748;
				{
					BgL_nodez00_bglt BgL_auxz00_12187;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2499z00_6253;

						BgL_arg2499z00_6253 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3424))->BgL_argz00);
						BgL_auxz00_12187 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3425) (BgL_pz00_3425,
								((obj_t) BgL_arg2499z00_6253), BgL_arg0z00_3426,
								BgL_arg1z00_3427, BgL_arg2z00_3428, BEOA));
					}
					((((BgL_castz00_bglt) CREF(BgL_nz00_3424))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12187), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3424);
			}
		}
	}



/* &walk2!-cast1789 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2cast1789za2zzast_walkz00(obj_t
		BgL_envz00_7749, obj_t BgL_nz00_7750, obj_t BgL_pz00_7751,
		obj_t BgL_arg0z00_7752, obj_t BgL_arg1z00_7753)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3415;
				obj_t BgL_pz00_3416;
				obj_t BgL_arg0z00_3417;
				obj_t BgL_arg1z00_3418;

				BgL_nz00_3415 = ((BgL_castz00_bglt) BgL_nz00_7750);
				BgL_pz00_3416 = BgL_pz00_7751;
				BgL_arg0z00_3417 = BgL_arg0z00_7752;
				BgL_arg1z00_3418 = BgL_arg1z00_7753;
				{
					BgL_nodez00_bglt BgL_auxz00_12201;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2497z00_6251;

						BgL_arg2497z00_6251 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3415))->BgL_argz00);
						BgL_auxz00_12201 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3416) (BgL_pz00_3416,
								((obj_t) BgL_arg2497z00_6251), BgL_arg0z00_3417,
								BgL_arg1z00_3418, BEOA));
					}
					((((BgL_castz00_bglt) CREF(BgL_nz00_3415))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12201), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3415);
			}
		}
	}



/* &walk1!-cast1787 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2cast1787za2zzast_walkz00(obj_t
		BgL_envz00_7754, obj_t BgL_nz00_7755, obj_t BgL_pz00_7756,
		obj_t BgL_arg0z00_7757)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3407;
				obj_t BgL_pz00_3408;
				obj_t BgL_arg0z00_3409;

				BgL_nz00_3407 = ((BgL_castz00_bglt) BgL_nz00_7755);
				BgL_pz00_3408 = BgL_pz00_7756;
				BgL_arg0z00_3409 = BgL_arg0z00_7757;
				{
					BgL_nodez00_bglt BgL_auxz00_12214;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2496z00_6249;

						BgL_arg2496z00_6249 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3407))->BgL_argz00);
						BgL_auxz00_12214 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3408) (BgL_pz00_3408,
								((obj_t) BgL_arg2496z00_6249), BgL_arg0z00_3409, BEOA));
					}
					((((BgL_castz00_bglt) CREF(BgL_nz00_3407))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12214), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3407);
			}
		}
	}



/* &walk0!-cast1785 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2cast1785za2zzast_walkz00(obj_t
		BgL_envz00_7758, obj_t BgL_nz00_7759, obj_t BgL_pz00_7760)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3400;
				obj_t BgL_pz00_3401;

				BgL_nz00_3400 = ((BgL_castz00_bglt) BgL_nz00_7759);
				BgL_pz00_3401 = BgL_pz00_7760;
				{
					BgL_nodez00_bglt BgL_auxz00_12226;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2495z00_6247;

						BgL_arg2495z00_6247 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3400))->BgL_argz00);
						BgL_auxz00_12226 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3401) (BgL_pz00_3401,
								((obj_t) BgL_arg2495z00_6247), BEOA));
					}
					((((BgL_castz00_bglt) CREF(BgL_nz00_3400))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12226), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3400);
			}
		}
	}



/* &walk3*-cast1783 */
	obj_t BGl_z62walk3za2zd2cast1783z12zzast_walkz00(obj_t BgL_envz00_7761,
		obj_t BgL_nz00_7762, obj_t BgL_pz00_7763, obj_t BgL_arg0z00_7764,
		obj_t BgL_arg1z00_7765, obj_t BgL_arg2z00_7766)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3388;
				obj_t BgL_pz00_3389;
				obj_t BgL_arg0z00_3390;
				obj_t BgL_arg1z00_3391;
				obj_t BgL_arg2z00_3392;

				BgL_nz00_3388 = ((BgL_castz00_bglt) BgL_nz00_7762);
				BgL_pz00_3389 = BgL_pz00_7763;
				BgL_arg0z00_3390 = BgL_arg0z00_7764;
				BgL_arg1z00_3391 = BgL_arg1z00_7765;
				BgL_arg2z00_3392 = BgL_arg2z00_7766;
				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2491z00_6243;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2493z00_6244;

						BgL_arg2493z00_6244 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3388))->BgL_argz00);
						BgL_arg2491z00_6243 =
							PROCEDURE_ENTRY(BgL_pz00_3389) (BgL_pz00_3389,
							((obj_t) BgL_arg2493z00_6244), BgL_arg0z00_3390, BgL_arg1z00_3391,
							BgL_arg2z00_3392, BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2492z00_6245;

						BgL_list2492z00_6245 = MAKE_PAIR(BgL_arg2491z00_6243, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2492z00_6245);
					}
				}
			}
		}
	}



/* &walk2*-cast1781 */
	obj_t BGl_z62walk2za2zd2cast1781z12zzast_walkz00(obj_t BgL_envz00_7767,
		obj_t BgL_nz00_7768, obj_t BgL_pz00_7769, obj_t BgL_arg0z00_7770,
		obj_t BgL_arg1z00_7771)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3377;
				obj_t BgL_pz00_3378;
				obj_t BgL_arg0z00_3379;
				obj_t BgL_arg1z00_3380;

				BgL_nz00_3377 = ((BgL_castz00_bglt) BgL_nz00_7768);
				BgL_pz00_3378 = BgL_pz00_7769;
				BgL_arg0z00_3379 = BgL_arg0z00_7770;
				BgL_arg1z00_3380 = BgL_arg1z00_7771;
				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2488z00_6239;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2490z00_6240;

						BgL_arg2490z00_6240 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3377))->BgL_argz00);
						BgL_arg2488z00_6239 =
							PROCEDURE_ENTRY(BgL_pz00_3378) (BgL_pz00_3378,
							((obj_t) BgL_arg2490z00_6240), BgL_arg0z00_3379, BgL_arg1z00_3380,
							BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2489z00_6241;

						BgL_list2489z00_6241 = MAKE_PAIR(BgL_arg2488z00_6239, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2489z00_6241);
					}
				}
			}
		}
	}



/* &walk1*-cast1779 */
	obj_t BGl_z62walk1za2zd2cast1779z12zzast_walkz00(obj_t BgL_envz00_7772,
		obj_t BgL_nz00_7773, obj_t BgL_pz00_7774, obj_t BgL_arg0z00_7775)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3367;
				obj_t BgL_pz00_3368;
				obj_t BgL_arg0z00_3369;

				BgL_nz00_3367 = ((BgL_castz00_bglt) BgL_nz00_7773);
				BgL_pz00_3368 = BgL_pz00_7774;
				BgL_arg0z00_3369 = BgL_arg0z00_7775;
				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2485z00_6235;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2487z00_6236;

						BgL_arg2487z00_6236 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3367))->BgL_argz00);
						BgL_arg2485z00_6235 =
							PROCEDURE_ENTRY(BgL_pz00_3368) (BgL_pz00_3368,
							((obj_t) BgL_arg2487z00_6236), BgL_arg0z00_3369, BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2486z00_6237;

						BgL_list2486z00_6237 = MAKE_PAIR(BgL_arg2485z00_6235, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2486z00_6237);
					}
				}
			}
		}
	}



/* &walk0*-cast1777 */
	obj_t BGl_z62walk0za2zd2cast1777z12zzast_walkz00(obj_t BgL_envz00_7776,
		obj_t BgL_nz00_7777, obj_t BgL_pz00_7778)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3358;
				obj_t BgL_pz00_3359;

				BgL_nz00_3358 = ((BgL_castz00_bglt) BgL_nz00_7777);
				BgL_pz00_3359 = BgL_pz00_7778;
				{	/* Ast/walk.scm 300 */
					obj_t BgL_arg2482z00_6231;

					{	/* Ast/walk.scm 300 */
						BgL_nodez00_bglt BgL_arg2484z00_6232;

						BgL_arg2484z00_6232 =
							(((BgL_castz00_bglt) CREF(BgL_nz00_3358))->BgL_argz00);
						BgL_arg2482z00_6231 =
							PROCEDURE_ENTRY(BgL_pz00_3359) (BgL_pz00_3359,
							((obj_t) BgL_arg2484z00_6232), BEOA);
					}
					{	/* Ast/walk.scm 300 */
						obj_t BgL_list2483z00_6233;

						BgL_list2483z00_6233 = MAKE_PAIR(BgL_arg2482z00_6231, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2483z00_6233);
					}
				}
			}
		}
	}



/* &walk3-cast1775 */
	obj_t BGl_z62walk3zd2cast1775zb0zzast_walkz00(obj_t BgL_envz00_7779,
		obj_t BgL_nz00_7780, obj_t BgL_pz00_7781, obj_t BgL_arg0z00_7782,
		obj_t BgL_arg1z00_7783, obj_t BgL_arg2z00_7784)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3348;
				obj_t BgL_pz00_3349;
				obj_t BgL_arg0z00_3350;
				obj_t BgL_arg1z00_3351;
				obj_t BgL_arg2z00_3352;

				BgL_nz00_3348 = ((BgL_castz00_bglt) BgL_nz00_7780);
				BgL_pz00_3349 = BgL_pz00_7781;
				BgL_arg0z00_3350 = BgL_arg0z00_7782;
				BgL_arg1z00_3351 = BgL_arg1z00_7783;
				BgL_arg2z00_3352 = BgL_arg2z00_7784;
				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2481z00_6229;

					BgL_arg2481z00_6229 =
						(((BgL_castz00_bglt) CREF(BgL_nz00_3348))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3349) (BgL_pz00_3349,
						((obj_t) BgL_arg2481z00_6229), BgL_arg0z00_3350, BgL_arg1z00_3351,
						BgL_arg2z00_3352, BEOA);
				}
			}
		}
	}



/* &walk2-cast1773 */
	obj_t BGl_z62walk2zd2cast1773zb0zzast_walkz00(obj_t BgL_envz00_7785,
		obj_t BgL_nz00_7786, obj_t BgL_pz00_7787, obj_t BgL_arg0z00_7788,
		obj_t BgL_arg1z00_7789)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3339;
				obj_t BgL_pz00_3340;
				obj_t BgL_arg0z00_3341;
				obj_t BgL_arg1z00_3342;

				BgL_nz00_3339 = ((BgL_castz00_bglt) BgL_nz00_7786);
				BgL_pz00_3340 = BgL_pz00_7787;
				BgL_arg0z00_3341 = BgL_arg0z00_7788;
				BgL_arg1z00_3342 = BgL_arg1z00_7789;
				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2480z00_6227;

					BgL_arg2480z00_6227 =
						(((BgL_castz00_bglt) CREF(BgL_nz00_3339))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3340) (BgL_pz00_3340,
						((obj_t) BgL_arg2480z00_6227), BgL_arg0z00_3341, BgL_arg1z00_3342,
						BEOA);
				}
			}
		}
	}



/* &walk1-cast1771 */
	obj_t BGl_z62walk1zd2cast1771zb0zzast_walkz00(obj_t BgL_envz00_7790,
		obj_t BgL_nz00_7791, obj_t BgL_pz00_7792, obj_t BgL_arg0z00_7793)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3331;
				obj_t BgL_pz00_3332;
				obj_t BgL_arg0z00_3333;

				BgL_nz00_3331 = ((BgL_castz00_bglt) BgL_nz00_7791);
				BgL_pz00_3332 = BgL_pz00_7792;
				BgL_arg0z00_3333 = BgL_arg0z00_7793;
				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2479z00_6225;

					BgL_arg2479z00_6225 =
						(((BgL_castz00_bglt) CREF(BgL_nz00_3331))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3332) (BgL_pz00_3332,
						((obj_t) BgL_arg2479z00_6225), BgL_arg0z00_3333, BEOA);
				}
			}
		}
	}



/* &walk0-cast1769 */
	obj_t BGl_z62walk0zd2cast1769zb0zzast_walkz00(obj_t BgL_envz00_7794,
		obj_t BgL_nz00_7795, obj_t BgL_pz00_7796)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 300 */
			{
				BgL_castz00_bglt BgL_nz00_3324;
				obj_t BgL_pz00_3325;

				BgL_nz00_3324 = ((BgL_castz00_bglt) BgL_nz00_7795);
				BgL_pz00_3325 = BgL_pz00_7796;
				{	/* Ast/walk.scm 300 */
					BgL_nodez00_bglt BgL_arg2478z00_6223;

					BgL_arg2478z00_6223 =
						(((BgL_castz00_bglt) CREF(BgL_nz00_3324))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_3325) (BgL_pz00_3325,
						((obj_t) BgL_arg2478z00_6223), BEOA);
				}
			}
		}
	}



/* &walk3!-extern1767 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2extern1767za2zzast_walkz00(obj_t
		BgL_envz00_7797, obj_t BgL_nz00_7798, obj_t BgL_pz00_7799,
		obj_t BgL_arg0z00_7800, obj_t BgL_arg1z00_7801, obj_t BgL_arg2z00_7802)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3306;
				obj_t BgL_pz00_3307;
				obj_t BgL_arg0z00_3308;
				obj_t BgL_arg1z00_3309;
				obj_t BgL_arg2z00_3310;

				BgL_nz00_3306 = ((BgL_externz00_bglt) BgL_nz00_7798);
				BgL_pz00_3307 = BgL_pz00_7799;
				BgL_arg0z00_3308 = BgL_arg0z00_7800;
				BgL_arg1z00_3309 = BgL_arg1z00_7801;
				BgL_arg2z00_3310 = BgL_arg2z00_7802;
				{
					obj_t BgL_fieldsz00_3316;

					BgL_fieldsz00_3316 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3306))->BgL_exprza2za2);
				BgL_zc3anonymousza32472ze3z83_3317:
					if (NULLP(BgL_fieldsz00_3316))
						{	/* Ast/walk.scm 299 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 299 */
							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2474z00_3319;

								{	/* Ast/walk.scm 299 */
									obj_t BgL_arg2475z00_3320;

									BgL_arg2475z00_3320 = CAR(BgL_fieldsz00_3316);
									BgL_arg2474z00_3319 =
										PROCEDURE_ENTRY(BgL_pz00_3307) (BgL_pz00_3307,
										BgL_arg2475z00_3320, BgL_arg0z00_3308, BgL_arg1z00_3309,
										BgL_arg2z00_3310, BEOA);
								}
								SET_CAR(BgL_fieldsz00_3316, BgL_arg2474z00_3319);
							}
							{
								obj_t BgL_fieldsz00_12324;

								BgL_fieldsz00_12324 = CDR(BgL_fieldsz00_3316);
								BgL_fieldsz00_3316 = BgL_fieldsz00_12324;
								goto BgL_zc3anonymousza32472ze3z83_3317;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3306);
			}
		}
	}



/* &walk2!-extern1765 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2extern1765za2zzast_walkz00(obj_t
		BgL_envz00_7803, obj_t BgL_nz00_7804, obj_t BgL_pz00_7805,
		obj_t BgL_arg0z00_7806, obj_t BgL_arg1z00_7807)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3289;
				obj_t BgL_pz00_3290;
				obj_t BgL_arg0z00_3291;
				obj_t BgL_arg1z00_3292;

				BgL_nz00_3289 = ((BgL_externz00_bglt) BgL_nz00_7804);
				BgL_pz00_3290 = BgL_pz00_7805;
				BgL_arg0z00_3291 = BgL_arg0z00_7806;
				BgL_arg1z00_3292 = BgL_arg1z00_7807;
				{
					obj_t BgL_fieldsz00_3298;

					BgL_fieldsz00_3298 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3289))->BgL_exprza2za2);
				BgL_zc3anonymousza32466ze3z83_3299:
					if (NULLP(BgL_fieldsz00_3298))
						{	/* Ast/walk.scm 299 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 299 */
							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2468z00_3301;

								{	/* Ast/walk.scm 299 */
									obj_t BgL_arg2469z00_3302;

									BgL_arg2469z00_3302 = CAR(BgL_fieldsz00_3298);
									BgL_arg2468z00_3301 =
										PROCEDURE_ENTRY(BgL_pz00_3290) (BgL_pz00_3290,
										BgL_arg2469z00_3302, BgL_arg0z00_3291, BgL_arg1z00_3292,
										BEOA);
								}
								SET_CAR(BgL_fieldsz00_3298, BgL_arg2468z00_3301);
							}
							{
								obj_t BgL_fieldsz00_12339;

								BgL_fieldsz00_12339 = CDR(BgL_fieldsz00_3298);
								BgL_fieldsz00_3298 = BgL_fieldsz00_12339;
								goto BgL_zc3anonymousza32466ze3z83_3299;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3289);
			}
		}
	}



/* &walk1!-extern1763 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2extern1763za2zzast_walkz00(obj_t
		BgL_envz00_7808, obj_t BgL_nz00_7809, obj_t BgL_pz00_7810,
		obj_t BgL_arg0z00_7811)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3273;
				obj_t BgL_pz00_3274;
				obj_t BgL_arg0z00_3275;

				BgL_nz00_3273 = ((BgL_externz00_bglt) BgL_nz00_7809);
				BgL_pz00_3274 = BgL_pz00_7810;
				BgL_arg0z00_3275 = BgL_arg0z00_7811;
				{
					obj_t BgL_fieldsz00_3281;

					BgL_fieldsz00_3281 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3273))->BgL_exprza2za2);
				BgL_zc3anonymousza32460ze3z83_3282:
					if (NULLP(BgL_fieldsz00_3281))
						{	/* Ast/walk.scm 299 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 299 */
							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2462z00_3284;

								{	/* Ast/walk.scm 299 */
									obj_t BgL_arg2463z00_3285;

									BgL_arg2463z00_3285 = CAR(BgL_fieldsz00_3281);
									BgL_arg2462z00_3284 =
										PROCEDURE_ENTRY(BgL_pz00_3274) (BgL_pz00_3274,
										BgL_arg2463z00_3285, BgL_arg0z00_3275, BEOA);
								}
								SET_CAR(BgL_fieldsz00_3281, BgL_arg2462z00_3284);
							}
							{
								obj_t BgL_fieldsz00_12353;

								BgL_fieldsz00_12353 = CDR(BgL_fieldsz00_3281);
								BgL_fieldsz00_3281 = BgL_fieldsz00_12353;
								goto BgL_zc3anonymousza32460ze3z83_3282;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3273);
			}
		}
	}



/* &walk0!-extern1761 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2extern1761za2zzast_walkz00(obj_t
		BgL_envz00_7812, obj_t BgL_nz00_7813, obj_t BgL_pz00_7814)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3258;
				obj_t BgL_pz00_3259;

				BgL_nz00_3258 = ((BgL_externz00_bglt) BgL_nz00_7813);
				BgL_pz00_3259 = BgL_pz00_7814;
				{
					obj_t BgL_fieldsz00_3265;

					BgL_fieldsz00_3265 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3258))->BgL_exprza2za2);
				BgL_zc3anonymousza32453ze3z83_3266:
					if (NULLP(BgL_fieldsz00_3265))
						{	/* Ast/walk.scm 299 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 299 */
							{	/* Ast/walk.scm 299 */
								obj_t BgL_arg2455z00_3268;

								{	/* Ast/walk.scm 299 */
									obj_t BgL_arg2456z00_3269;

									BgL_arg2456z00_3269 = CAR(BgL_fieldsz00_3265);
									BgL_arg2455z00_3268 =
										PROCEDURE_ENTRY(BgL_pz00_3259) (BgL_pz00_3259,
										BgL_arg2456z00_3269, BEOA);
								}
								SET_CAR(BgL_fieldsz00_3265, BgL_arg2455z00_3268);
							}
							{
								obj_t BgL_fieldsz00_12366;

								BgL_fieldsz00_12366 = CDR(BgL_fieldsz00_3265);
								BgL_fieldsz00_3265 = BgL_fieldsz00_12366;
								goto BgL_zc3anonymousza32453ze3z83_3266;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3258);
			}
		}
	}



/* &walk3*-extern1759 */
	obj_t BGl_z62walk3za2zd2extern1759z12zzast_walkz00(obj_t BgL_envz00_7815,
		obj_t BgL_nz00_7816, obj_t BgL_pz00_7817, obj_t BgL_arg0z00_7818,
		obj_t BgL_arg1z00_7819, obj_t BgL_arg2z00_7820)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3237;
				obj_t BgL_pz00_3238;
				obj_t BgL_arg0z00_3239;
				obj_t BgL_arg1z00_3240;
				obj_t BgL_arg2z00_3241;

				BgL_nz00_3237 = ((BgL_externz00_bglt) BgL_nz00_7816);
				BgL_pz00_3238 = BgL_pz00_7817;
				BgL_arg0z00_3239 = BgL_arg0z00_7818;
				BgL_arg1z00_3240 = BgL_arg1z00_7819;
				BgL_arg2z00_3241 = BgL_arg2z00_7820;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2444z00_3245;

					BgL_arg2444z00_3245 =
						BGl_zc3anonymousza32446ze3z83zzast_walkz00(BgL_arg2z00_3241,
						BgL_arg1z00_3240, BgL_arg0z00_3239, BgL_pz00_3238,
						(((BgL_externz00_bglt) CREF(BgL_nz00_3237))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2445z00_3246;

						BgL_list2445z00_3246 = MAKE_PAIR(BgL_arg2444z00_3245, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2445z00_3246);
					}
				}
			}
		}
	}



/* <anonymous:2446> */
	obj_t BGl_zc3anonymousza32446ze3z83zzast_walkz00(obj_t BgL_arg2z00_8160,
		obj_t BgL_arg1z00_8159, obj_t BgL_arg0z00_8158, obj_t BgL_pz00_8157,
		obj_t BgL_l1517z00_3249)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1517z00_3249))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2448z00_3252;
					obj_t BgL_arg2449z00_3253;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3254;

						BgL_fz00_3254 = CAR(BgL_l1517z00_3249);
						BgL_arg2448z00_3252 =
							PROCEDURE_ENTRY(BgL_pz00_8157) (BgL_pz00_8157, BgL_fz00_3254,
							BgL_arg0z00_8158, BgL_arg1z00_8159, BgL_arg2z00_8160, BEOA);
					}
					BgL_arg2449z00_3253 =
						BGl_zc3anonymousza32446ze3z83zzast_walkz00(BgL_arg2z00_8160,
						BgL_arg1z00_8159, BgL_arg0z00_8158, BgL_pz00_8157,
						CDR(BgL_l1517z00_3249));
					return bgl_append2(BgL_arg2448z00_3252, BgL_arg2449z00_3253);
				}
		}
	}



/* &walk2*-extern1757 */
	obj_t BGl_z62walk2za2zd2extern1757z12zzast_walkz00(obj_t BgL_envz00_7821,
		obj_t BgL_nz00_7822, obj_t BgL_pz00_7823, obj_t BgL_arg0z00_7824,
		obj_t BgL_arg1z00_7825)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3217;
				obj_t BgL_pz00_3218;
				obj_t BgL_arg0z00_3219;
				obj_t BgL_arg1z00_3220;

				BgL_nz00_3217 = ((BgL_externz00_bglt) BgL_nz00_7822);
				BgL_pz00_3218 = BgL_pz00_7823;
				BgL_arg0z00_3219 = BgL_arg0z00_7824;
				BgL_arg1z00_3220 = BgL_arg1z00_7825;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2437z00_3224;

					BgL_arg2437z00_3224 =
						BGl_zc3anonymousza32439ze3z83zzast_walkz00(BgL_arg1z00_3220,
						BgL_arg0z00_3219, BgL_pz00_3218,
						(((BgL_externz00_bglt) CREF(BgL_nz00_3217))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2438z00_3225;

						BgL_list2438z00_3225 = MAKE_PAIR(BgL_arg2437z00_3224, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2438z00_3225);
					}
				}
			}
		}
	}



/* <anonymous:2439> */
	obj_t BGl_zc3anonymousza32439ze3z83zzast_walkz00(obj_t BgL_arg1z00_8156,
		obj_t BgL_arg0z00_8155, obj_t BgL_pz00_8154, obj_t BgL_l1514z00_3228)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1514z00_3228))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2441z00_3231;
					obj_t BgL_arg2442z00_3232;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3233;

						BgL_fz00_3233 = CAR(BgL_l1514z00_3228);
						BgL_arg2441z00_3231 =
							PROCEDURE_ENTRY(BgL_pz00_8154) (BgL_pz00_8154, BgL_fz00_3233,
							BgL_arg0z00_8155, BgL_arg1z00_8156, BEOA);
					}
					BgL_arg2442z00_3232 =
						BGl_zc3anonymousza32439ze3z83zzast_walkz00(BgL_arg1z00_8156,
						BgL_arg0z00_8155, BgL_pz00_8154, CDR(BgL_l1514z00_3228));
					return bgl_append2(BgL_arg2441z00_3231, BgL_arg2442z00_3232);
				}
		}
	}



/* &walk1*-extern1755 */
	obj_t BGl_z62walk1za2zd2extern1755z12zzast_walkz00(obj_t BgL_envz00_7826,
		obj_t BgL_nz00_7827, obj_t BgL_pz00_7828, obj_t BgL_arg0z00_7829)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3198;
				obj_t BgL_pz00_3199;
				obj_t BgL_arg0z00_3200;

				BgL_nz00_3198 = ((BgL_externz00_bglt) BgL_nz00_7827);
				BgL_pz00_3199 = BgL_pz00_7828;
				BgL_arg0z00_3200 = BgL_arg0z00_7829;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2429z00_3204;

					BgL_arg2429z00_3204 =
						BGl_zc3anonymousza32431ze3z83zzast_walkz00(BgL_arg0z00_3200,
						BgL_pz00_3199,
						(((BgL_externz00_bglt) CREF(BgL_nz00_3198))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2430z00_3205;

						BgL_list2430z00_3205 = MAKE_PAIR(BgL_arg2429z00_3204, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2430z00_3205);
					}
				}
			}
		}
	}



/* <anonymous:2431> */
	obj_t BGl_zc3anonymousza32431ze3z83zzast_walkz00(obj_t BgL_arg0z00_8153,
		obj_t BgL_pz00_8152, obj_t BgL_l1511z00_3208)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1511z00_3208))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2433z00_3211;
					obj_t BgL_arg2434z00_3212;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3213;

						BgL_fz00_3213 = CAR(BgL_l1511z00_3208);
						BgL_arg2433z00_3211 =
							PROCEDURE_ENTRY(BgL_pz00_8152) (BgL_pz00_8152, BgL_fz00_3213,
							BgL_arg0z00_8153, BEOA);
					}
					BgL_arg2434z00_3212 =
						BGl_zc3anonymousza32431ze3z83zzast_walkz00(BgL_arg0z00_8153,
						BgL_pz00_8152, CDR(BgL_l1511z00_3208));
					return bgl_append2(BgL_arg2433z00_3211, BgL_arg2434z00_3212);
				}
		}
	}



/* &walk0*-extern1753 */
	obj_t BGl_z62walk0za2zd2extern1753z12zzast_walkz00(obj_t BgL_envz00_7830,
		obj_t BgL_nz00_7831, obj_t BgL_pz00_7832)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3180;
				obj_t BgL_pz00_3181;

				BgL_nz00_3180 = ((BgL_externz00_bglt) BgL_nz00_7831);
				BgL_pz00_3181 = BgL_pz00_7832;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2421z00_3185;

					BgL_arg2421z00_3185 =
						BGl_zc3anonymousza32423ze3z83zzast_walkz00(BgL_pz00_3181,
						(((BgL_externz00_bglt) CREF(BgL_nz00_3180))->BgL_exprza2za2));
					{	/* Ast/walk.scm 299 */
						obj_t BgL_list2422z00_3186;

						BgL_list2422z00_3186 = MAKE_PAIR(BgL_arg2421z00_3185, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2422z00_3186);
					}
				}
			}
		}
	}



/* <anonymous:2423> */
	obj_t BGl_zc3anonymousza32423ze3z83zzast_walkz00(obj_t BgL_pz00_8151,
		obj_t BgL_l1508z00_3189)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			if (NULLP(BgL_l1508z00_3189))
				{	/* Ast/walk.scm 299 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 299 */
					obj_t BgL_arg2426z00_3192;
					obj_t BgL_arg2427z00_3193;

					{	/* Ast/walk.scm 299 */
						obj_t BgL_fz00_3194;

						BgL_fz00_3194 = CAR(BgL_l1508z00_3189);
						BgL_arg2426z00_3192 =
							PROCEDURE_ENTRY(BgL_pz00_8151) (BgL_pz00_8151, BgL_fz00_3194,
							BEOA);
					}
					BgL_arg2427z00_3193 =
						BGl_zc3anonymousza32423ze3z83zzast_walkz00(BgL_pz00_8151,
						CDR(BgL_l1508z00_3189));
					return bgl_append2(BgL_arg2426z00_3192, BgL_arg2427z00_3193);
				}
		}
	}



/* &walk3-extern1751 */
	obj_t BGl_z62walk3zd2extern1751zb0zzast_walkz00(obj_t BgL_envz00_7833,
		obj_t BgL_nz00_7834, obj_t BgL_pz00_7835, obj_t BgL_arg0z00_7836,
		obj_t BgL_arg1z00_7837, obj_t BgL_arg2z00_7838)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3163;
				obj_t BgL_pz00_3164;
				obj_t BgL_arg0z00_3165;
				obj_t BgL_arg1z00_3166;
				obj_t BgL_arg2z00_3167;

				BgL_nz00_3163 = ((BgL_externz00_bglt) BgL_nz00_7834);
				BgL_pz00_3164 = BgL_pz00_7835;
				BgL_arg0z00_3165 = BgL_arg0z00_7836;
				BgL_arg1z00_3166 = BgL_arg1z00_7837;
				BgL_arg2z00_3167 = BgL_arg2z00_7838;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_g1506z00_3171;

					BgL_g1506z00_3171 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3163))->BgL_exprza2za2);
					{
						obj_t BgL_l1504z00_3173;

						{	/* Ast/walk.scm 299 */
							bool_t BgL_auxz00_12438;

							BgL_l1504z00_3173 = BgL_g1506z00_3171;
						BgL_zc3anonymousza32418ze3z83_3174:
							if (PAIRP(BgL_l1504z00_3173))
								{	/* Ast/walk.scm 299 */
									{	/* Ast/walk.scm 299 */
										obj_t BgL_fz00_3176;

										BgL_fz00_3176 = CAR(BgL_l1504z00_3173);
										PROCEDURE_ENTRY(BgL_pz00_3164) (BgL_pz00_3164,
											BgL_fz00_3176, BgL_arg0z00_3165, BgL_arg1z00_3166,
											BgL_arg2z00_3167, BEOA);
									}
									{
										obj_t BgL_l1504z00_12449;

										BgL_l1504z00_12449 = CDR(BgL_l1504z00_3173);
										BgL_l1504z00_3173 = BgL_l1504z00_12449;
										goto BgL_zc3anonymousza32418ze3z83_3174;
									}
								}
							else
								{	/* Ast/walk.scm 299 */
									BgL_auxz00_12438 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12438);
						}
					}
				}
			}
		}
	}



/* &walk2-extern1749 */
	obj_t BGl_z62walk2zd2extern1749zb0zzast_walkz00(obj_t BgL_envz00_7839,
		obj_t BgL_nz00_7840, obj_t BgL_pz00_7841, obj_t BgL_arg0z00_7842,
		obj_t BgL_arg1z00_7843)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3147;
				obj_t BgL_pz00_3148;
				obj_t BgL_arg0z00_3149;
				obj_t BgL_arg1z00_3150;

				BgL_nz00_3147 = ((BgL_externz00_bglt) BgL_nz00_7840);
				BgL_pz00_3148 = BgL_pz00_7841;
				BgL_arg0z00_3149 = BgL_arg0z00_7842;
				BgL_arg1z00_3150 = BgL_arg1z00_7843;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_g1503z00_3154;

					BgL_g1503z00_3154 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3147))->BgL_exprza2za2);
					{
						obj_t BgL_l1501z00_3156;

						{	/* Ast/walk.scm 299 */
							bool_t BgL_auxz00_12454;

							BgL_l1501z00_3156 = BgL_g1503z00_3154;
						BgL_zc3anonymousza32415ze3z83_3157:
							if (PAIRP(BgL_l1501z00_3156))
								{	/* Ast/walk.scm 299 */
									{	/* Ast/walk.scm 299 */
										obj_t BgL_fz00_3159;

										BgL_fz00_3159 = CAR(BgL_l1501z00_3156);
										PROCEDURE_ENTRY(BgL_pz00_3148) (BgL_pz00_3148,
											BgL_fz00_3159, BgL_arg0z00_3149, BgL_arg1z00_3150, BEOA);
									}
									{
										obj_t BgL_l1501z00_12464;

										BgL_l1501z00_12464 = CDR(BgL_l1501z00_3156);
										BgL_l1501z00_3156 = BgL_l1501z00_12464;
										goto BgL_zc3anonymousza32415ze3z83_3157;
									}
								}
							else
								{	/* Ast/walk.scm 299 */
									BgL_auxz00_12454 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12454);
						}
					}
				}
			}
		}
	}



/* &walk1-extern1747 */
	obj_t BGl_z62walk1zd2extern1747zb0zzast_walkz00(obj_t BgL_envz00_7844,
		obj_t BgL_nz00_7845, obj_t BgL_pz00_7846, obj_t BgL_arg0z00_7847)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3132;
				obj_t BgL_pz00_3133;
				obj_t BgL_arg0z00_3134;

				BgL_nz00_3132 = ((BgL_externz00_bglt) BgL_nz00_7845);
				BgL_pz00_3133 = BgL_pz00_7846;
				BgL_arg0z00_3134 = BgL_arg0z00_7847;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_g1500z00_3138;

					BgL_g1500z00_3138 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3132))->BgL_exprza2za2);
					{
						obj_t BgL_l1498z00_3140;

						{	/* Ast/walk.scm 299 */
							bool_t BgL_auxz00_12469;

							BgL_l1498z00_3140 = BgL_g1500z00_3138;
						BgL_zc3anonymousza32412ze3z83_3141:
							if (PAIRP(BgL_l1498z00_3140))
								{	/* Ast/walk.scm 299 */
									{	/* Ast/walk.scm 299 */
										obj_t BgL_fz00_3143;

										BgL_fz00_3143 = CAR(BgL_l1498z00_3140);
										PROCEDURE_ENTRY(BgL_pz00_3133) (BgL_pz00_3133,
											BgL_fz00_3143, BgL_arg0z00_3134, BEOA);
									}
									{
										obj_t BgL_l1498z00_12478;

										BgL_l1498z00_12478 = CDR(BgL_l1498z00_3140);
										BgL_l1498z00_3140 = BgL_l1498z00_12478;
										goto BgL_zc3anonymousza32412ze3z83_3141;
									}
								}
							else
								{	/* Ast/walk.scm 299 */
									BgL_auxz00_12469 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12469);
						}
					}
				}
			}
		}
	}



/* &walk0-extern1745 */
	obj_t BGl_z62walk0zd2extern1745zb0zzast_walkz00(obj_t BgL_envz00_7848,
		obj_t BgL_nz00_7849, obj_t BgL_pz00_7850)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 299 */
			{
				BgL_externz00_bglt BgL_nz00_3118;
				obj_t BgL_pz00_3119;

				BgL_nz00_3118 = ((BgL_externz00_bglt) BgL_nz00_7849);
				BgL_pz00_3119 = BgL_pz00_7850;
				{	/* Ast/walk.scm 299 */
					obj_t BgL_g1497z00_3123;

					BgL_g1497z00_3123 =
						(((BgL_externz00_bglt) CREF(BgL_nz00_3118))->BgL_exprza2za2);
					{
						obj_t BgL_l1495z00_3125;

						{	/* Ast/walk.scm 299 */
							bool_t BgL_auxz00_12483;

							BgL_l1495z00_3125 = BgL_g1497z00_3123;
						BgL_zc3anonymousza32409ze3z83_3126:
							if (PAIRP(BgL_l1495z00_3125))
								{	/* Ast/walk.scm 299 */
									{	/* Ast/walk.scm 299 */
										obj_t BgL_fz00_3128;

										BgL_fz00_3128 = CAR(BgL_l1495z00_3125);
										PROCEDURE_ENTRY(BgL_pz00_3119) (BgL_pz00_3119,
											BgL_fz00_3128, BEOA);
									}
									{
										obj_t BgL_l1495z00_12491;

										BgL_l1495z00_12491 = CDR(BgL_l1495z00_3125);
										BgL_l1495z00_3125 = BgL_l1495z00_12491;
										goto BgL_zc3anonymousza32409ze3z83_3126;
									}
								}
							else
								{	/* Ast/walk.scm 299 */
									BgL_auxz00_12483 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12483);
						}
					}
				}
			}
		}
	}



/* &walk3!-funcall1743 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2funcall1743za2zzast_walkz00(obj_t
		BgL_envz00_7851, obj_t BgL_nz00_7852, obj_t BgL_pz00_7853,
		obj_t BgL_arg0z00_7854, obj_t BgL_arg1z00_7855, obj_t BgL_arg2z00_7856)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_3099;
				obj_t BgL_pz00_3100;
				obj_t BgL_arg0z00_3101;
				obj_t BgL_arg1z00_3102;
				obj_t BgL_arg2z00_3103;

				BgL_nz00_3099 = ((BgL_funcallz00_bglt) BgL_nz00_7852);
				BgL_pz00_3100 = BgL_pz00_7853;
				BgL_arg0z00_3101 = BgL_arg0z00_7854;
				BgL_arg1z00_3102 = BgL_arg1z00_7855;
				BgL_arg2z00_3103 = BgL_arg2z00_7856;
				{
					BgL_nodez00_bglt BgL_auxz00_12495;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2402z00_3107;

						BgL_arg2402z00_3107 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_3099))->BgL_funz00);
						BgL_auxz00_12495 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3100) (BgL_pz00_3100,
								((obj_t) BgL_arg2402z00_3107), BgL_arg0z00_3101,
								BgL_arg1z00_3102, BgL_arg2z00_3103, BEOA));
					}
					((((BgL_funcallz00_bglt) CREF(BgL_nz00_3099))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12495), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_3110;

					BgL_fieldsz00_3110 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_3099))->BgL_argsz00);
				BgL_zc3anonymousza32404ze3z83_3111:
					if (NULLP(BgL_fieldsz00_3110))
						{	/* Ast/walk.scm 298 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 298 */
							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2406z00_3113;

								{	/* Ast/walk.scm 298 */
									obj_t BgL_arg2407z00_3114;

									BgL_arg2407z00_3114 = CAR(BgL_fieldsz00_3110);
									BgL_arg2406z00_3113 =
										PROCEDURE_ENTRY(BgL_pz00_3100) (BgL_pz00_3100,
										BgL_arg2407z00_3114, BgL_arg0z00_3101, BgL_arg1z00_3102,
										BgL_arg2z00_3103, BEOA);
								}
								SET_CAR(BgL_fieldsz00_3110, BgL_arg2406z00_3113);
							}
							{
								obj_t BgL_fieldsz00_12518;

								BgL_fieldsz00_12518 = CDR(BgL_fieldsz00_3110);
								BgL_fieldsz00_3110 = BgL_fieldsz00_12518;
								goto BgL_zc3anonymousza32404ze3z83_3111;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3099);
			}
		}
	}



/* &walk2!-funcall1741 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2funcall1741za2zzast_walkz00(obj_t
		BgL_envz00_7857, obj_t BgL_nz00_7858, obj_t BgL_pz00_7859,
		obj_t BgL_arg0z00_7860, obj_t BgL_arg1z00_7861)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_3081;
				obj_t BgL_pz00_3082;
				obj_t BgL_arg0z00_3083;
				obj_t BgL_arg1z00_3084;

				BgL_nz00_3081 = ((BgL_funcallz00_bglt) BgL_nz00_7858);
				BgL_pz00_3082 = BgL_pz00_7859;
				BgL_arg0z00_3083 = BgL_arg0z00_7860;
				BgL_arg1z00_3084 = BgL_arg1z00_7861;
				{
					BgL_nodez00_bglt BgL_auxz00_12523;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2395z00_3088;

						BgL_arg2395z00_3088 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_3081))->BgL_funz00);
						BgL_auxz00_12523 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3082) (BgL_pz00_3082,
								((obj_t) BgL_arg2395z00_3088), BgL_arg0z00_3083,
								BgL_arg1z00_3084, BEOA));
					}
					((((BgL_funcallz00_bglt) CREF(BgL_nz00_3081))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12523), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_3091;

					BgL_fieldsz00_3091 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_3081))->BgL_argsz00);
				BgL_zc3anonymousza32397ze3z83_3092:
					if (NULLP(BgL_fieldsz00_3091))
						{	/* Ast/walk.scm 298 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 298 */
							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2399z00_3094;

								{	/* Ast/walk.scm 298 */
									obj_t BgL_arg2400z00_3095;

									BgL_arg2400z00_3095 = CAR(BgL_fieldsz00_3091);
									BgL_arg2399z00_3094 =
										PROCEDURE_ENTRY(BgL_pz00_3082) (BgL_pz00_3082,
										BgL_arg2400z00_3095, BgL_arg0z00_3083, BgL_arg1z00_3084,
										BEOA);
								}
								SET_CAR(BgL_fieldsz00_3091, BgL_arg2399z00_3094);
							}
							{
								obj_t BgL_fieldsz00_12544;

								BgL_fieldsz00_12544 = CDR(BgL_fieldsz00_3091);
								BgL_fieldsz00_3091 = BgL_fieldsz00_12544;
								goto BgL_zc3anonymousza32397ze3z83_3092;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3081);
			}
		}
	}



/* &walk1!-funcall1739 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2funcall1739za2zzast_walkz00(obj_t
		BgL_envz00_7862, obj_t BgL_nz00_7863, obj_t BgL_pz00_7864,
		obj_t BgL_arg0z00_7865)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_3064;
				obj_t BgL_pz00_3065;
				obj_t BgL_arg0z00_3066;

				BgL_nz00_3064 = ((BgL_funcallz00_bglt) BgL_nz00_7863);
				BgL_pz00_3065 = BgL_pz00_7864;
				BgL_arg0z00_3066 = BgL_arg0z00_7865;
				{
					BgL_nodez00_bglt BgL_auxz00_12549;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2388z00_3070;

						BgL_arg2388z00_3070 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_3064))->BgL_funz00);
						BgL_auxz00_12549 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3065) (BgL_pz00_3065,
								((obj_t) BgL_arg2388z00_3070), BgL_arg0z00_3066, BEOA));
					}
					((((BgL_funcallz00_bglt) CREF(BgL_nz00_3064))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12549), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_3073;

					BgL_fieldsz00_3073 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_3064))->BgL_argsz00);
				BgL_zc3anonymousza32390ze3z83_3074:
					if (NULLP(BgL_fieldsz00_3073))
						{	/* Ast/walk.scm 298 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 298 */
							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2392z00_3076;

								{	/* Ast/walk.scm 298 */
									obj_t BgL_arg2393z00_3077;

									BgL_arg2393z00_3077 = CAR(BgL_fieldsz00_3073);
									BgL_arg2392z00_3076 =
										PROCEDURE_ENTRY(BgL_pz00_3065) (BgL_pz00_3065,
										BgL_arg2393z00_3077, BgL_arg0z00_3066, BEOA);
								}
								SET_CAR(BgL_fieldsz00_3073, BgL_arg2392z00_3076);
							}
							{
								obj_t BgL_fieldsz00_12568;

								BgL_fieldsz00_12568 = CDR(BgL_fieldsz00_3073);
								BgL_fieldsz00_3073 = BgL_fieldsz00_12568;
								goto BgL_zc3anonymousza32390ze3z83_3074;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3064);
			}
		}
	}



/* &walk0!-funcall1737 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2funcall1737za2zzast_walkz00(obj_t
		BgL_envz00_7866, obj_t BgL_nz00_7867, obj_t BgL_pz00_7868)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_3048;
				obj_t BgL_pz00_3049;

				BgL_nz00_3048 = ((BgL_funcallz00_bglt) BgL_nz00_7867);
				BgL_pz00_3049 = BgL_pz00_7868;
				{
					BgL_nodez00_bglt BgL_auxz00_12573;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2380z00_3053;

						BgL_arg2380z00_3053 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_3048))->BgL_funz00);
						BgL_auxz00_12573 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_3049) (BgL_pz00_3049,
								((obj_t) BgL_arg2380z00_3053), BEOA));
					}
					((((BgL_funcallz00_bglt) CREF(BgL_nz00_3048))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12573), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_3056;

					BgL_fieldsz00_3056 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_3048))->BgL_argsz00);
				BgL_zc3anonymousza32383ze3z83_3057:
					if (NULLP(BgL_fieldsz00_3056))
						{	/* Ast/walk.scm 298 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 298 */
							{	/* Ast/walk.scm 298 */
								obj_t BgL_arg2385z00_3059;

								{	/* Ast/walk.scm 298 */
									obj_t BgL_arg2386z00_3060;

									BgL_arg2386z00_3060 = CAR(BgL_fieldsz00_3056);
									BgL_arg2385z00_3059 =
										PROCEDURE_ENTRY(BgL_pz00_3049) (BgL_pz00_3049,
										BgL_arg2386z00_3060, BEOA);
								}
								SET_CAR(BgL_fieldsz00_3056, BgL_arg2385z00_3059);
							}
							{
								obj_t BgL_fieldsz00_12590;

								BgL_fieldsz00_12590 = CDR(BgL_fieldsz00_3056);
								BgL_fieldsz00_3056 = BgL_fieldsz00_12590;
								goto BgL_zc3anonymousza32383ze3z83_3057;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_3048);
			}
		}
	}



/* &walk3*-funcall1735 */
	obj_t BGl_z62walk3za2zd2funcall1735z12zzast_walkz00(obj_t BgL_envz00_7869,
		obj_t BgL_nz00_7870, obj_t BgL_pz00_7871, obj_t BgL_arg0z00_7872,
		obj_t BgL_arg1z00_7873, obj_t BgL_arg2z00_7874)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_3026;
				obj_t BgL_pz00_3027;
				obj_t BgL_arg0z00_3028;
				obj_t BgL_arg1z00_3029;
				obj_t BgL_arg2z00_3030;

				BgL_nz00_3026 = ((BgL_funcallz00_bglt) BgL_nz00_7870);
				BgL_pz00_3027 = BgL_pz00_7871;
				BgL_arg0z00_3028 = BgL_arg0z00_7872;
				BgL_arg1z00_3029 = BgL_arg1z00_7873;
				BgL_arg2z00_3030 = BgL_arg2z00_7874;
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2371z00_3034;
					obj_t BgL_arg2372z00_3035;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2373z00_3036;

						BgL_arg2373z00_3036 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_3026))->BgL_funz00);
						BgL_arg2371z00_3034 =
							PROCEDURE_ENTRY(BgL_pz00_3027) (BgL_pz00_3027,
							((obj_t) BgL_arg2373z00_3036), BgL_arg0z00_3028, BgL_arg1z00_3029,
							BgL_arg2z00_3030, BEOA);
					}
					BgL_arg2372z00_3035 =
						BGl_zc3anonymousza32374ze3z83zzast_walkz00(BgL_arg2z00_3030,
						BgL_arg1z00_3029, BgL_arg0z00_3028, BgL_pz00_3027,
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_3026))->BgL_argsz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg2371z00_3034,
						BgL_arg2372z00_3035);
				}
			}
		}
	}



/* <anonymous:2374> */
	obj_t BGl_zc3anonymousza32374ze3z83zzast_walkz00(obj_t BgL_arg2z00_8150,
		obj_t BgL_arg1z00_8149, obj_t BgL_arg0z00_8148, obj_t BgL_pz00_8147,
		obj_t BgL_l1493z00_3039)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1493z00_3039))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2376z00_3042;
					obj_t BgL_arg2378z00_3043;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_3044;

						BgL_fz00_3044 = CAR(BgL_l1493z00_3039);
						BgL_arg2376z00_3042 =
							PROCEDURE_ENTRY(BgL_pz00_8147) (BgL_pz00_8147, BgL_fz00_3044,
							BgL_arg0z00_8148, BgL_arg1z00_8149, BgL_arg2z00_8150, BEOA);
					}
					BgL_arg2378z00_3043 =
						BGl_zc3anonymousza32374ze3z83zzast_walkz00(BgL_arg2z00_8150,
						BgL_arg1z00_8149, BgL_arg0z00_8148, BgL_pz00_8147,
						CDR(BgL_l1493z00_3039));
					return bgl_append2(BgL_arg2376z00_3042, BgL_arg2378z00_3043);
				}
		}
	}



/* &walk2*-funcall1733 */
	obj_t BGl_z62walk2za2zd2funcall1733z12zzast_walkz00(obj_t BgL_envz00_7875,
		obj_t BgL_nz00_7876, obj_t BgL_pz00_7877, obj_t BgL_arg0z00_7878,
		obj_t BgL_arg1z00_7879)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_3005;
				obj_t BgL_pz00_3006;
				obj_t BgL_arg0z00_3007;
				obj_t BgL_arg1z00_3008;

				BgL_nz00_3005 = ((BgL_funcallz00_bglt) BgL_nz00_7876);
				BgL_pz00_3006 = BgL_pz00_7877;
				BgL_arg0z00_3007 = BgL_arg0z00_7878;
				BgL_arg1z00_3008 = BgL_arg1z00_7879;
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2363z00_3012;
					obj_t BgL_arg2364z00_3013;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2365z00_3014;

						BgL_arg2365z00_3014 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_3005))->BgL_funz00);
						BgL_arg2363z00_3012 =
							PROCEDURE_ENTRY(BgL_pz00_3006) (BgL_pz00_3006,
							((obj_t) BgL_arg2365z00_3014), BgL_arg0z00_3007, BgL_arg1z00_3008,
							BEOA);
					}
					BgL_arg2364z00_3013 =
						BGl_zc3anonymousza32366ze3z83zzast_walkz00(BgL_arg1z00_3008,
						BgL_arg0z00_3007, BgL_pz00_3006,
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_3005))->BgL_argsz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg2363z00_3012,
						BgL_arg2364z00_3013);
				}
			}
		}
	}



/* <anonymous:2366> */
	obj_t BGl_zc3anonymousza32366ze3z83zzast_walkz00(obj_t BgL_arg1z00_8146,
		obj_t BgL_arg0z00_8145, obj_t BgL_pz00_8144, obj_t BgL_l1490z00_3017)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1490z00_3017))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2368z00_3020;
					obj_t BgL_arg2369z00_3021;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_3022;

						BgL_fz00_3022 = CAR(BgL_l1490z00_3017);
						BgL_arg2368z00_3020 =
							PROCEDURE_ENTRY(BgL_pz00_8144) (BgL_pz00_8144, BgL_fz00_3022,
							BgL_arg0z00_8145, BgL_arg1z00_8146, BEOA);
					}
					BgL_arg2369z00_3021 =
						BGl_zc3anonymousza32366ze3z83zzast_walkz00(BgL_arg1z00_8146,
						BgL_arg0z00_8145, BgL_pz00_8144, CDR(BgL_l1490z00_3017));
					return bgl_append2(BgL_arg2368z00_3020, BgL_arg2369z00_3021);
				}
		}
	}



/* &walk1*-funcall1731 */
	obj_t BGl_z62walk1za2zd2funcall1731z12zzast_walkz00(obj_t BgL_envz00_7880,
		obj_t BgL_nz00_7881, obj_t BgL_pz00_7882, obj_t BgL_arg0z00_7883)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_2985;
				obj_t BgL_pz00_2986;
				obj_t BgL_arg0z00_2987;

				BgL_nz00_2985 = ((BgL_funcallz00_bglt) BgL_nz00_7881);
				BgL_pz00_2986 = BgL_pz00_7882;
				BgL_arg0z00_2987 = BgL_arg0z00_7883;
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2355z00_2991;
					obj_t BgL_arg2356z00_2992;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2357z00_2993;

						BgL_arg2357z00_2993 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_2985))->BgL_funz00);
						BgL_arg2355z00_2991 =
							PROCEDURE_ENTRY(BgL_pz00_2986) (BgL_pz00_2986,
							((obj_t) BgL_arg2357z00_2993), BgL_arg0z00_2987, BEOA);
					}
					BgL_arg2356z00_2992 =
						BGl_zc3anonymousza32358ze3z83zzast_walkz00(BgL_arg0z00_2987,
						BgL_pz00_2986,
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2985))->BgL_argsz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg2355z00_2991,
						BgL_arg2356z00_2992);
				}
			}
		}
	}



/* <anonymous:2358> */
	obj_t BGl_zc3anonymousza32358ze3z83zzast_walkz00(obj_t BgL_arg0z00_8143,
		obj_t BgL_pz00_8142, obj_t BgL_l1487z00_2996)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1487z00_2996))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2360z00_2999;
					obj_t BgL_arg2361z00_3000;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_3001;

						BgL_fz00_3001 = CAR(BgL_l1487z00_2996);
						BgL_arg2360z00_2999 =
							PROCEDURE_ENTRY(BgL_pz00_8142) (BgL_pz00_8142, BgL_fz00_3001,
							BgL_arg0z00_8143, BEOA);
					}
					BgL_arg2361z00_3000 =
						BGl_zc3anonymousza32358ze3z83zzast_walkz00(BgL_arg0z00_8143,
						BgL_pz00_8142, CDR(BgL_l1487z00_2996));
					return bgl_append2(BgL_arg2360z00_2999, BgL_arg2361z00_3000);
				}
		}
	}



/* &walk0*-funcall1729 */
	obj_t BGl_z62walk0za2zd2funcall1729z12zzast_walkz00(obj_t BgL_envz00_7884,
		obj_t BgL_nz00_7885, obj_t BgL_pz00_7886)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_2966;
				obj_t BgL_pz00_2967;

				BgL_nz00_2966 = ((BgL_funcallz00_bglt) BgL_nz00_7885);
				BgL_pz00_2967 = BgL_pz00_7886;
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2346z00_2971;
					obj_t BgL_arg2347z00_2972;

					{	/* Ast/walk.scm 298 */
						BgL_nodez00_bglt BgL_arg2348z00_2973;

						BgL_arg2348z00_2973 =
							(((BgL_funcallz00_bglt) CREF(BgL_nz00_2966))->BgL_funz00);
						BgL_arg2346z00_2971 =
							PROCEDURE_ENTRY(BgL_pz00_2967) (BgL_pz00_2967,
							((obj_t) BgL_arg2348z00_2973), BEOA);
					}
					BgL_arg2347z00_2972 =
						BGl_zc3anonymousza32349ze3z83zzast_walkz00(BgL_pz00_2967,
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2966))->BgL_argsz00));
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2346z00_2971,
						BgL_arg2347z00_2972);
				}
			}
		}
	}



/* <anonymous:2349> */
	obj_t BGl_zc3anonymousza32349ze3z83zzast_walkz00(obj_t BgL_pz00_8141,
		obj_t BgL_l1484z00_2976)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			if (NULLP(BgL_l1484z00_2976))
				{	/* Ast/walk.scm 298 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 298 */
					obj_t BgL_arg2351z00_2979;
					obj_t BgL_arg2352z00_2980;

					{	/* Ast/walk.scm 298 */
						obj_t BgL_fz00_2981;

						BgL_fz00_2981 = CAR(BgL_l1484z00_2976);
						BgL_arg2351z00_2979 =
							PROCEDURE_ENTRY(BgL_pz00_8141) (BgL_pz00_8141, BgL_fz00_2981,
							BEOA);
					}
					BgL_arg2352z00_2980 =
						BGl_zc3anonymousza32349ze3z83zzast_walkz00(BgL_pz00_8141,
						CDR(BgL_l1484z00_2976));
					return bgl_append2(BgL_arg2351z00_2979, BgL_arg2352z00_2980);
				}
		}
	}



/* &walk3-funcall1727 */
	obj_t BGl_z62walk3zd2funcall1727zb0zzast_walkz00(obj_t BgL_envz00_7887,
		obj_t BgL_nz00_7888, obj_t BgL_pz00_7889, obj_t BgL_arg0z00_7890,
		obj_t BgL_arg1z00_7891, obj_t BgL_arg2z00_7892)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_2948;
				obj_t BgL_pz00_2949;
				obj_t BgL_arg0z00_2950;
				obj_t BgL_arg1z00_2951;
				obj_t BgL_arg2z00_2952;

				BgL_nz00_2948 = ((BgL_funcallz00_bglt) BgL_nz00_7888);
				BgL_pz00_2949 = BgL_pz00_7889;
				BgL_arg0z00_2950 = BgL_arg0z00_7890;
				BgL_arg1z00_2951 = BgL_arg1z00_7891;
				BgL_arg2z00_2952 = BgL_arg2z00_7892;
				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2342z00_2956;

					BgL_arg2342z00_2956 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2948))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2949) (BgL_pz00_2949,
						((obj_t) BgL_arg2342z00_2956), BgL_arg0z00_2950, BgL_arg1z00_2951,
						BgL_arg2z00_2952, BEOA);
				}
				{	/* Ast/walk.scm 298 */
					obj_t BgL_g1482z00_2957;

					BgL_g1482z00_2957 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2948))->BgL_argsz00);
					{
						obj_t BgL_l1480z00_2959;

						{	/* Ast/walk.scm 298 */
							bool_t BgL_auxz00_12697;

							BgL_l1480z00_2959 = BgL_g1482z00_2957;
						BgL_zc3anonymousza32343ze3z83_2960:
							if (PAIRP(BgL_l1480z00_2959))
								{	/* Ast/walk.scm 298 */
									{	/* Ast/walk.scm 298 */
										obj_t BgL_fz00_2962;

										BgL_fz00_2962 = CAR(BgL_l1480z00_2959);
										PROCEDURE_ENTRY(BgL_pz00_2949) (BgL_pz00_2949,
											BgL_fz00_2962, BgL_arg0z00_2950, BgL_arg1z00_2951,
											BgL_arg2z00_2952, BEOA);
									}
									{
										obj_t BgL_l1480z00_12708;

										BgL_l1480z00_12708 = CDR(BgL_l1480z00_2959);
										BgL_l1480z00_2959 = BgL_l1480z00_12708;
										goto BgL_zc3anonymousza32343ze3z83_2960;
									}
								}
							else
								{	/* Ast/walk.scm 298 */
									BgL_auxz00_12697 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12697);
						}
					}
				}
			}
		}
	}



/* &walk2-funcall1725 */
	obj_t BGl_z62walk2zd2funcall1725zb0zzast_walkz00(obj_t BgL_envz00_7893,
		obj_t BgL_nz00_7894, obj_t BgL_pz00_7895, obj_t BgL_arg0z00_7896,
		obj_t BgL_arg1z00_7897)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_2931;
				obj_t BgL_pz00_2932;
				obj_t BgL_arg0z00_2933;
				obj_t BgL_arg1z00_2934;

				BgL_nz00_2931 = ((BgL_funcallz00_bglt) BgL_nz00_7894);
				BgL_pz00_2932 = BgL_pz00_7895;
				BgL_arg0z00_2933 = BgL_arg0z00_7896;
				BgL_arg1z00_2934 = BgL_arg1z00_7897;
				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2338z00_2938;

					BgL_arg2338z00_2938 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2931))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2932) (BgL_pz00_2932,
						((obj_t) BgL_arg2338z00_2938), BgL_arg0z00_2933, BgL_arg1z00_2934,
						BEOA);
				}
				{	/* Ast/walk.scm 298 */
					obj_t BgL_g1479z00_2939;

					BgL_g1479z00_2939 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2931))->BgL_argsz00);
					{
						obj_t BgL_l1477z00_2941;

						{	/* Ast/walk.scm 298 */
							bool_t BgL_auxz00_12721;

							BgL_l1477z00_2941 = BgL_g1479z00_2939;
						BgL_zc3anonymousza32339ze3z83_2942:
							if (PAIRP(BgL_l1477z00_2941))
								{	/* Ast/walk.scm 298 */
									{	/* Ast/walk.scm 298 */
										obj_t BgL_fz00_2944;

										BgL_fz00_2944 = CAR(BgL_l1477z00_2941);
										PROCEDURE_ENTRY(BgL_pz00_2932) (BgL_pz00_2932,
											BgL_fz00_2944, BgL_arg0z00_2933, BgL_arg1z00_2934, BEOA);
									}
									{
										obj_t BgL_l1477z00_12731;

										BgL_l1477z00_12731 = CDR(BgL_l1477z00_2941);
										BgL_l1477z00_2941 = BgL_l1477z00_12731;
										goto BgL_zc3anonymousza32339ze3z83_2942;
									}
								}
							else
								{	/* Ast/walk.scm 298 */
									BgL_auxz00_12721 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12721);
						}
					}
				}
			}
		}
	}



/* &walk1-funcall1723 */
	obj_t BGl_z62walk1zd2funcall1723zb0zzast_walkz00(obj_t BgL_envz00_7898,
		obj_t BgL_nz00_7899, obj_t BgL_pz00_7900, obj_t BgL_arg0z00_7901)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_2915;
				obj_t BgL_pz00_2916;
				obj_t BgL_arg0z00_2917;

				BgL_nz00_2915 = ((BgL_funcallz00_bglt) BgL_nz00_7899);
				BgL_pz00_2916 = BgL_pz00_7900;
				BgL_arg0z00_2917 = BgL_arg0z00_7901;
				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2334z00_2921;

					BgL_arg2334z00_2921 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2915))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2916) (BgL_pz00_2916,
						((obj_t) BgL_arg2334z00_2921), BgL_arg0z00_2917, BEOA);
				}
				{	/* Ast/walk.scm 298 */
					obj_t BgL_g1476z00_2922;

					BgL_g1476z00_2922 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2915))->BgL_argsz00);
					{
						obj_t BgL_l1474z00_2924;

						{	/* Ast/walk.scm 298 */
							bool_t BgL_auxz00_12743;

							BgL_l1474z00_2924 = BgL_g1476z00_2922;
						BgL_zc3anonymousza32335ze3z83_2925:
							if (PAIRP(BgL_l1474z00_2924))
								{	/* Ast/walk.scm 298 */
									{	/* Ast/walk.scm 298 */
										obj_t BgL_fz00_2927;

										BgL_fz00_2927 = CAR(BgL_l1474z00_2924);
										PROCEDURE_ENTRY(BgL_pz00_2916) (BgL_pz00_2916,
											BgL_fz00_2927, BgL_arg0z00_2917, BEOA);
									}
									{
										obj_t BgL_l1474z00_12752;

										BgL_l1474z00_12752 = CDR(BgL_l1474z00_2924);
										BgL_l1474z00_2924 = BgL_l1474z00_12752;
										goto BgL_zc3anonymousza32335ze3z83_2925;
									}
								}
							else
								{	/* Ast/walk.scm 298 */
									BgL_auxz00_12743 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12743);
						}
					}
				}
			}
		}
	}



/* &walk0-funcall1721 */
	obj_t BGl_z62walk0zd2funcall1721zb0zzast_walkz00(obj_t BgL_envz00_7902,
		obj_t BgL_nz00_7903, obj_t BgL_pz00_7904)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 298 */
			{
				BgL_funcallz00_bglt BgL_nz00_2900;
				obj_t BgL_pz00_2901;

				BgL_nz00_2900 = ((BgL_funcallz00_bglt) BgL_nz00_7903);
				BgL_pz00_2901 = BgL_pz00_7904;
				{	/* Ast/walk.scm 298 */
					BgL_nodez00_bglt BgL_arg2330z00_2905;

					BgL_arg2330z00_2905 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2900))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2901) (BgL_pz00_2901,
						((obj_t) BgL_arg2330z00_2905), BEOA);
				}
				{	/* Ast/walk.scm 298 */
					obj_t BgL_g1473z00_2906;

					BgL_g1473z00_2906 =
						(((BgL_funcallz00_bglt) CREF(BgL_nz00_2900))->BgL_argsz00);
					{
						obj_t BgL_l1471z00_2908;

						{	/* Ast/walk.scm 298 */
							bool_t BgL_auxz00_12763;

							BgL_l1471z00_2908 = BgL_g1473z00_2906;
						BgL_zc3anonymousza32331ze3z83_2909:
							if (PAIRP(BgL_l1471z00_2908))
								{	/* Ast/walk.scm 298 */
									{	/* Ast/walk.scm 298 */
										obj_t BgL_fz00_2911;

										BgL_fz00_2911 = CAR(BgL_l1471z00_2908);
										PROCEDURE_ENTRY(BgL_pz00_2901) (BgL_pz00_2901,
											BgL_fz00_2911, BEOA);
									}
									{
										obj_t BgL_l1471z00_12771;

										BgL_l1471z00_12771 = CDR(BgL_l1471z00_2908);
										BgL_l1471z00_2908 = BgL_l1471z00_12771;
										goto BgL_zc3anonymousza32331ze3z83_2909;
									}
								}
							else
								{	/* Ast/walk.scm 298 */
									BgL_auxz00_12763 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_12763);
						}
					}
				}
			}
		}
	}



/* &walk3!-app-ly1719 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2appzd2ly1719z70zzast_walkz00(obj_t
		BgL_envz00_7905, obj_t BgL_nz00_7906, obj_t BgL_pz00_7907,
		obj_t BgL_arg0z00_7908, obj_t BgL_arg1z00_7909, obj_t BgL_arg2z00_7910)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2889;
				obj_t BgL_pz00_2890;
				obj_t BgL_arg0z00_2891;
				obj_t BgL_arg1z00_2892;
				obj_t BgL_arg2z00_2893;

				BgL_nz00_2889 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7906);
				BgL_pz00_2890 = BgL_pz00_7907;
				BgL_arg0z00_2891 = BgL_arg0z00_7908;
				BgL_arg1z00_2892 = BgL_arg1z00_7909;
				BgL_arg2z00_2893 = BgL_arg2z00_7910;
				{
					BgL_nodez00_bglt BgL_auxz00_12775;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2328z00_6108;

						BgL_arg2328z00_6108 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2889))->BgL_funz00);
						BgL_auxz00_12775 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2890) (BgL_pz00_2890,
								((obj_t) BgL_arg2328z00_6108), BgL_arg0z00_2891,
								BgL_arg1z00_2892, BgL_arg2z00_2893, BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2889))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12775), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_12787;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2329z00_6109;

						BgL_arg2329z00_6109 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2889))->BgL_argz00);
						BgL_auxz00_12787 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2890) (BgL_pz00_2890,
								((obj_t) BgL_arg2329z00_6109), BgL_arg0z00_2891,
								BgL_arg1z00_2892, BgL_arg2z00_2893, BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2889))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12787), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2889);
			}
		}
	}



/* &walk2!-app-ly1717 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2appzd2ly1717z70zzast_walkz00(obj_t
		BgL_envz00_7911, obj_t BgL_nz00_7912, obj_t BgL_pz00_7913,
		obj_t BgL_arg0z00_7914, obj_t BgL_arg1z00_7915)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2879;
				obj_t BgL_pz00_2880;
				obj_t BgL_arg0z00_2881;
				obj_t BgL_arg1z00_2882;

				BgL_nz00_2879 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7912);
				BgL_pz00_2880 = BgL_pz00_7913;
				BgL_arg0z00_2881 = BgL_arg0z00_7914;
				BgL_arg1z00_2882 = BgL_arg1z00_7915;
				{
					BgL_nodez00_bglt BgL_auxz00_12801;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2326z00_2886;

						BgL_arg2326z00_2886 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2879))->BgL_funz00);
						BgL_auxz00_12801 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2880) (BgL_pz00_2880,
								((obj_t) BgL_arg2326z00_2886), BgL_arg0z00_2881,
								BgL_arg1z00_2882, BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2879))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12801), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_12812;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2327z00_2887;

						BgL_arg2327z00_2887 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2879))->BgL_argz00);
						BgL_auxz00_12812 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2880) (BgL_pz00_2880,
								((obj_t) BgL_arg2327z00_2887), BgL_arg0z00_2881,
								BgL_arg1z00_2882, BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2879))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12812), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2879);
			}
		}
	}



/* &walk1!-app-ly1715 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2appzd2ly1715z70zzast_walkz00(obj_t
		BgL_envz00_7916, obj_t BgL_nz00_7917, obj_t BgL_pz00_7918,
		obj_t BgL_arg0z00_7919)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2870;
				obj_t BgL_pz00_2871;
				obj_t BgL_arg0z00_2872;

				BgL_nz00_2870 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7917);
				BgL_pz00_2871 = BgL_pz00_7918;
				BgL_arg0z00_2872 = BgL_arg0z00_7919;
				{
					BgL_nodez00_bglt BgL_auxz00_12825;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2324z00_2876;

						BgL_arg2324z00_2876 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2870))->BgL_funz00);
						BgL_auxz00_12825 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2871) (BgL_pz00_2871,
								((obj_t) BgL_arg2324z00_2876), BgL_arg0z00_2872, BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2870))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12825), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_12835;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2325z00_2877;

						BgL_arg2325z00_2877 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2870))->BgL_argz00);
						BgL_auxz00_12835 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2871) (BgL_pz00_2871,
								((obj_t) BgL_arg2325z00_2877), BgL_arg0z00_2872, BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2870))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12835), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2870);
			}
		}
	}



/* &walk0!-app-ly1713 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2appzd2ly1713z70zzast_walkz00(obj_t
		BgL_envz00_7920, obj_t BgL_nz00_7921, obj_t BgL_pz00_7922)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2862;
				obj_t BgL_pz00_2863;

				BgL_nz00_2862 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7921);
				BgL_pz00_2863 = BgL_pz00_7922;
				{
					BgL_nodez00_bglt BgL_auxz00_12847;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2322z00_2867;

						BgL_arg2322z00_2867 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2862))->BgL_funz00);
						BgL_auxz00_12847 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2863) (BgL_pz00_2863,
								((obj_t) BgL_arg2322z00_2867), BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2862))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12847), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_12856;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2323z00_2868;

						BgL_arg2323z00_2868 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2862))->BgL_argz00);
						BgL_auxz00_12856 =
							((BgL_nodez00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2863) (BgL_pz00_2863,
								((obj_t) BgL_arg2323z00_2868), BEOA));
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2862))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_12856), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2862);
			}
		}
	}



/* &walk3*-app-ly1711 */
	obj_t BGl_z62walk3za2zd2appzd2ly1711zc0zzast_walkz00(obj_t BgL_envz00_7923,
		obj_t BgL_nz00_7924, obj_t BgL_pz00_7925, obj_t BgL_arg0z00_7926,
		obj_t BgL_arg1z00_7927, obj_t BgL_arg2z00_7928)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2849;
				obj_t BgL_pz00_2850;
				obj_t BgL_arg0z00_2851;
				obj_t BgL_arg1z00_2852;
				obj_t BgL_arg2z00_2853;

				BgL_nz00_2849 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7924);
				BgL_pz00_2850 = BgL_pz00_7925;
				BgL_arg0z00_2851 = BgL_arg0z00_7926;
				BgL_arg1z00_2852 = BgL_arg1z00_7927;
				BgL_arg2z00_2853 = BgL_arg2z00_7928;
				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2318z00_6103;
					obj_t BgL_arg2319z00_6104;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2320z00_6105;

						BgL_arg2320z00_6105 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2849))->BgL_funz00);
						BgL_arg2318z00_6103 =
							PROCEDURE_ENTRY(BgL_pz00_2850) (BgL_pz00_2850,
							((obj_t) BgL_arg2320z00_6105), BgL_arg0z00_2851, BgL_arg1z00_2852,
							BgL_arg2z00_2853, BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2321z00_6106;

						BgL_arg2321z00_6106 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2849))->BgL_argz00);
						BgL_arg2319z00_6104 =
							PROCEDURE_ENTRY(BgL_pz00_2850) (BgL_pz00_2850,
							((obj_t) BgL_arg2321z00_6106), BgL_arg0z00_2851, BgL_arg1z00_2852,
							BgL_arg2z00_2853, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2318z00_6103,
						BgL_arg2319z00_6104);
				}
			}
		}
	}



/* &walk2*-app-ly1709 */
	obj_t BGl_z62walk2za2zd2appzd2ly1709zc0zzast_walkz00(obj_t BgL_envz00_7929,
		obj_t BgL_nz00_7930, obj_t BgL_pz00_7931, obj_t BgL_arg0z00_7932,
		obj_t BgL_arg1z00_7933)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2837;
				obj_t BgL_pz00_2838;
				obj_t BgL_arg0z00_2839;
				obj_t BgL_arg1z00_2840;

				BgL_nz00_2837 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7930);
				BgL_pz00_2838 = BgL_pz00_7931;
				BgL_arg0z00_2839 = BgL_arg0z00_7932;
				BgL_arg1z00_2840 = BgL_arg1z00_7933;
				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2314z00_6098;
					obj_t BgL_arg2315z00_6099;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2316z00_6100;

						BgL_arg2316z00_6100 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2837))->BgL_funz00);
						BgL_arg2314z00_6098 =
							PROCEDURE_ENTRY(BgL_pz00_2838) (BgL_pz00_2838,
							((obj_t) BgL_arg2316z00_6100), BgL_arg0z00_2839, BgL_arg1z00_2840,
							BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2317z00_6101;

						BgL_arg2317z00_6101 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2837))->BgL_argz00);
						BgL_arg2315z00_6099 =
							PROCEDURE_ENTRY(BgL_pz00_2838) (BgL_pz00_2838,
							((obj_t) BgL_arg2317z00_6101), BgL_arg0z00_2839, BgL_arg1z00_2840,
							BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2314z00_6098,
						BgL_arg2315z00_6099);
				}
			}
		}
	}



/* &walk1*-app-ly1707 */
	obj_t BGl_z62walk1za2zd2appzd2ly1707zc0zzast_walkz00(obj_t BgL_envz00_7934,
		obj_t BgL_nz00_7935, obj_t BgL_pz00_7936, obj_t BgL_arg0z00_7937)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2826;
				obj_t BgL_pz00_2827;
				obj_t BgL_arg0z00_2828;

				BgL_nz00_2826 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7935);
				BgL_pz00_2827 = BgL_pz00_7936;
				BgL_arg0z00_2828 = BgL_arg0z00_7937;
				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2310z00_2832;
					obj_t BgL_arg2311z00_2833;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2312z00_2834;

						BgL_arg2312z00_2834 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2826))->BgL_funz00);
						BgL_arg2310z00_2832 =
							PROCEDURE_ENTRY(BgL_pz00_2827) (BgL_pz00_2827,
							((obj_t) BgL_arg2312z00_2834), BgL_arg0z00_2828, BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2313z00_2835;

						BgL_arg2313z00_2835 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2826))->BgL_argz00);
						BgL_arg2311z00_2833 =
							PROCEDURE_ENTRY(BgL_pz00_2827) (BgL_pz00_2827,
							((obj_t) BgL_arg2313z00_2835), BgL_arg0z00_2828, BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2310z00_2832,
						BgL_arg2311z00_2833);
				}
			}
		}
	}



/* &walk0*-app-ly1705 */
	obj_t BGl_z62walk0za2zd2appzd2ly1705zc0zzast_walkz00(obj_t BgL_envz00_7938,
		obj_t BgL_nz00_7939, obj_t BgL_pz00_7940)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2816;
				obj_t BgL_pz00_2817;

				BgL_nz00_2816 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7939);
				BgL_pz00_2817 = BgL_pz00_7940;
				{	/* Ast/walk.scm 297 */
					obj_t BgL_arg2306z00_2821;
					obj_t BgL_arg2307z00_2822;

					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2308z00_2823;

						BgL_arg2308z00_2823 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2816))->BgL_funz00);
						BgL_arg2306z00_2821 =
							PROCEDURE_ENTRY(BgL_pz00_2817) (BgL_pz00_2817,
							((obj_t) BgL_arg2308z00_2823), BEOA);
					}
					{	/* Ast/walk.scm 297 */
						BgL_nodez00_bglt BgL_arg2309z00_2824;

						BgL_arg2309z00_2824 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2816))->BgL_argz00);
						BgL_arg2307z00_2822 =
							PROCEDURE_ENTRY(BgL_pz00_2817) (BgL_pz00_2817,
							((obj_t) BgL_arg2309z00_2824), BEOA);
					}
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2306z00_2821,
						BgL_arg2307z00_2822);
				}
			}
		}
	}



/* &walk3-app-ly1703 */
	obj_t BGl_z62walk3zd2appzd2ly1703z62zzast_walkz00(obj_t BgL_envz00_7941,
		obj_t BgL_nz00_7942, obj_t BgL_pz00_7943, obj_t BgL_arg0z00_7944,
		obj_t BgL_arg1z00_7945, obj_t BgL_arg2z00_7946)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2805;
				obj_t BgL_pz00_2806;
				obj_t BgL_arg0z00_2807;
				obj_t BgL_arg1z00_2808;
				obj_t BgL_arg2z00_2809;

				BgL_nz00_2805 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7942);
				BgL_pz00_2806 = BgL_pz00_7943;
				BgL_arg0z00_2807 = BgL_arg0z00_7944;
				BgL_arg1z00_2808 = BgL_arg1z00_7945;
				BgL_arg2z00_2809 = BgL_arg2z00_7946;
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2304z00_6095;

					BgL_arg2304z00_6095 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2805))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2806) (BgL_pz00_2806,
						((obj_t) BgL_arg2304z00_6095), BgL_arg0z00_2807, BgL_arg1z00_2808,
						BgL_arg2z00_2809, BEOA);
				}
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2305z00_6096;

					BgL_arg2305z00_6096 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2805))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_2806) (BgL_pz00_2806,
						((obj_t) BgL_arg2305z00_6096), BgL_arg0z00_2807, BgL_arg1z00_2808,
						BgL_arg2z00_2809, BEOA);
				}
			}
		}
	}



/* &walk2-app-ly1701 */
	obj_t BGl_z62walk2zd2appzd2ly1701z62zzast_walkz00(obj_t BgL_envz00_7947,
		obj_t BgL_nz00_7948, obj_t BgL_pz00_7949, obj_t BgL_arg0z00_7950,
		obj_t BgL_arg1z00_7951)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2795;
				obj_t BgL_pz00_2796;
				obj_t BgL_arg0z00_2797;
				obj_t BgL_arg1z00_2798;

				BgL_nz00_2795 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7948);
				BgL_pz00_2796 = BgL_pz00_7949;
				BgL_arg0z00_2797 = BgL_arg0z00_7950;
				BgL_arg1z00_2798 = BgL_arg1z00_7951;
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2302z00_6092;

					BgL_arg2302z00_6092 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2795))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2796) (BgL_pz00_2796,
						((obj_t) BgL_arg2302z00_6092), BgL_arg0z00_2797, BgL_arg1z00_2798,
						BEOA);
				}
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2303z00_6093;

					BgL_arg2303z00_6093 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2795))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_2796) (BgL_pz00_2796,
						((obj_t) BgL_arg2303z00_6093), BgL_arg0z00_2797, BgL_arg1z00_2798,
						BEOA);
				}
			}
		}
	}



/* &walk1-app-ly1699 */
	obj_t BGl_z62walk1zd2appzd2ly1699z62zzast_walkz00(obj_t BgL_envz00_7952,
		obj_t BgL_nz00_7953, obj_t BgL_pz00_7954, obj_t BgL_arg0z00_7955)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2786;
				obj_t BgL_pz00_2787;
				obj_t BgL_arg0z00_2788;

				BgL_nz00_2786 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7953);
				BgL_pz00_2787 = BgL_pz00_7954;
				BgL_arg0z00_2788 = BgL_arg0z00_7955;
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2300z00_6089;

					BgL_arg2300z00_6089 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2786))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2787) (BgL_pz00_2787,
						((obj_t) BgL_arg2300z00_6089), BgL_arg0z00_2788, BEOA);
				}
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2301z00_6090;

					BgL_arg2301z00_6090 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2786))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_2787) (BgL_pz00_2787,
						((obj_t) BgL_arg2301z00_6090), BgL_arg0z00_2788, BEOA);
				}
			}
		}
	}



/* &walk0-app-ly1697 */
	obj_t BGl_z62walk0zd2appzd2ly1697z62zzast_walkz00(obj_t BgL_envz00_7956,
		obj_t BgL_nz00_7957, obj_t BgL_pz00_7958)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 297 */
			{
				BgL_appzd2lyzd2_bglt BgL_nz00_2778;
				obj_t BgL_pz00_2779;

				BgL_nz00_2778 = ((BgL_appzd2lyzd2_bglt) BgL_nz00_7957);
				BgL_pz00_2779 = BgL_pz00_7958;
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2298z00_6086;

					BgL_arg2298z00_6086 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2778))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2779) (BgL_pz00_2779,
						((obj_t) BgL_arg2298z00_6086), BEOA);
				}
				{	/* Ast/walk.scm 297 */
					BgL_nodez00_bglt BgL_arg2299z00_6087;

					BgL_arg2299z00_6087 =
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nz00_2778))->BgL_argz00);
					return
						PROCEDURE_ENTRY(BgL_pz00_2779) (BgL_pz00_2779,
						((obj_t) BgL_arg2299z00_6087), BEOA);
				}
			}
		}
	}



/* &walk3!-app1695 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2app1695za2zzast_walkz00(obj_t
		BgL_envz00_7959, obj_t BgL_nz00_7960, obj_t BgL_pz00_7961,
		obj_t BgL_arg0z00_7962, obj_t BgL_arg1z00_7963, obj_t BgL_arg2z00_7964)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2759;
				obj_t BgL_pz00_2760;
				obj_t BgL_arg0z00_2761;
				obj_t BgL_arg1z00_2762;
				obj_t BgL_arg2z00_2763;

				BgL_nz00_2759 = ((BgL_appz00_bglt) BgL_nz00_7960);
				BgL_pz00_2760 = BgL_pz00_7961;
				BgL_arg0z00_2761 = BgL_arg0z00_7962;
				BgL_arg1z00_2762 = BgL_arg1z00_7963;
				BgL_arg2z00_2763 = BgL_arg2z00_7964;
				{
					BgL_varz00_bglt BgL_auxz00_12999;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2289z00_2767;

						BgL_arg2289z00_2767 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2759))->BgL_funz00);
						BgL_auxz00_12999 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2760) (BgL_pz00_2760,
								((obj_t) BgL_arg2289z00_2767), BgL_arg0z00_2761,
								BgL_arg1z00_2762, BgL_arg2z00_2763, BEOA));
					}
					((((BgL_appz00_bglt) CREF(BgL_nz00_2759))->BgL_funz00) =
						((BgL_varz00_bglt) BgL_auxz00_12999), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_2770;

					BgL_fieldsz00_2770 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2759))->BgL_argsz00);
				BgL_zc3anonymousza32293ze3z83_2771:
					if (NULLP(BgL_fieldsz00_2770))
						{	/* Ast/walk.scm 296 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 296 */
							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2295z00_2773;

								{	/* Ast/walk.scm 296 */
									obj_t BgL_arg2296z00_2774;

									BgL_arg2296z00_2774 = CAR(BgL_fieldsz00_2770);
									BgL_arg2295z00_2773 =
										PROCEDURE_ENTRY(BgL_pz00_2760) (BgL_pz00_2760,
										BgL_arg2296z00_2774, BgL_arg0z00_2761, BgL_arg1z00_2762,
										BgL_arg2z00_2763, BEOA);
								}
								SET_CAR(BgL_fieldsz00_2770, BgL_arg2295z00_2773);
							}
							{
								obj_t BgL_fieldsz00_13022;

								BgL_fieldsz00_13022 = CDR(BgL_fieldsz00_2770);
								BgL_fieldsz00_2770 = BgL_fieldsz00_13022;
								goto BgL_zc3anonymousza32293ze3z83_2771;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2759);
			}
		}
	}



/* &walk2!-app1693 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2app1693za2zzast_walkz00(obj_t
		BgL_envz00_7965, obj_t BgL_nz00_7966, obj_t BgL_pz00_7967,
		obj_t BgL_arg0z00_7968, obj_t BgL_arg1z00_7969)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2741;
				obj_t BgL_pz00_2742;
				obj_t BgL_arg0z00_2743;
				obj_t BgL_arg1z00_2744;

				BgL_nz00_2741 = ((BgL_appz00_bglt) BgL_nz00_7966);
				BgL_pz00_2742 = BgL_pz00_7967;
				BgL_arg0z00_2743 = BgL_arg0z00_7968;
				BgL_arg1z00_2744 = BgL_arg1z00_7969;
				{
					BgL_varz00_bglt BgL_auxz00_13027;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2282z00_2748;

						BgL_arg2282z00_2748 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2741))->BgL_funz00);
						BgL_auxz00_13027 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2742) (BgL_pz00_2742,
								((obj_t) BgL_arg2282z00_2748), BgL_arg0z00_2743,
								BgL_arg1z00_2744, BEOA));
					}
					((((BgL_appz00_bglt) CREF(BgL_nz00_2741))->BgL_funz00) =
						((BgL_varz00_bglt) BgL_auxz00_13027), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_2751;

					BgL_fieldsz00_2751 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2741))->BgL_argsz00);
				BgL_zc3anonymousza32284ze3z83_2752:
					if (NULLP(BgL_fieldsz00_2751))
						{	/* Ast/walk.scm 296 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 296 */
							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2286z00_2754;

								{	/* Ast/walk.scm 296 */
									obj_t BgL_arg2287z00_2755;

									BgL_arg2287z00_2755 = CAR(BgL_fieldsz00_2751);
									BgL_arg2286z00_2754 =
										PROCEDURE_ENTRY(BgL_pz00_2742) (BgL_pz00_2742,
										BgL_arg2287z00_2755, BgL_arg0z00_2743, BgL_arg1z00_2744,
										BEOA);
								}
								SET_CAR(BgL_fieldsz00_2751, BgL_arg2286z00_2754);
							}
							{
								obj_t BgL_fieldsz00_13048;

								BgL_fieldsz00_13048 = CDR(BgL_fieldsz00_2751);
								BgL_fieldsz00_2751 = BgL_fieldsz00_13048;
								goto BgL_zc3anonymousza32284ze3z83_2752;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2741);
			}
		}
	}



/* &walk1!-app1691 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2app1691za2zzast_walkz00(obj_t
		BgL_envz00_7970, obj_t BgL_nz00_7971, obj_t BgL_pz00_7972,
		obj_t BgL_arg0z00_7973)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2724;
				obj_t BgL_pz00_2725;
				obj_t BgL_arg0z00_2726;

				BgL_nz00_2724 = ((BgL_appz00_bglt) BgL_nz00_7971);
				BgL_pz00_2725 = BgL_pz00_7972;
				BgL_arg0z00_2726 = BgL_arg0z00_7973;
				{
					BgL_varz00_bglt BgL_auxz00_13053;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2275z00_2730;

						BgL_arg2275z00_2730 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2724))->BgL_funz00);
						BgL_auxz00_13053 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2725) (BgL_pz00_2725,
								((obj_t) BgL_arg2275z00_2730), BgL_arg0z00_2726, BEOA));
					}
					((((BgL_appz00_bglt) CREF(BgL_nz00_2724))->BgL_funz00) =
						((BgL_varz00_bglt) BgL_auxz00_13053), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_2733;

					BgL_fieldsz00_2733 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2724))->BgL_argsz00);
				BgL_zc3anonymousza32277ze3z83_2734:
					if (NULLP(BgL_fieldsz00_2733))
						{	/* Ast/walk.scm 296 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 296 */
							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2279z00_2736;

								{	/* Ast/walk.scm 296 */
									obj_t BgL_arg2280z00_2737;

									BgL_arg2280z00_2737 = CAR(BgL_fieldsz00_2733);
									BgL_arg2279z00_2736 =
										PROCEDURE_ENTRY(BgL_pz00_2725) (BgL_pz00_2725,
										BgL_arg2280z00_2737, BgL_arg0z00_2726, BEOA);
								}
								SET_CAR(BgL_fieldsz00_2733, BgL_arg2279z00_2736);
							}
							{
								obj_t BgL_fieldsz00_13072;

								BgL_fieldsz00_13072 = CDR(BgL_fieldsz00_2733);
								BgL_fieldsz00_2733 = BgL_fieldsz00_13072;
								goto BgL_zc3anonymousza32277ze3z83_2734;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2724);
			}
		}
	}



/* &walk0!-app1689 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2app1689za2zzast_walkz00(obj_t
		BgL_envz00_7974, obj_t BgL_nz00_7975, obj_t BgL_pz00_7976)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2708;
				obj_t BgL_pz00_2709;

				BgL_nz00_2708 = ((BgL_appz00_bglt) BgL_nz00_7975);
				BgL_pz00_2709 = BgL_pz00_7976;
				{
					BgL_varz00_bglt BgL_auxz00_13077;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2268z00_2713;

						BgL_arg2268z00_2713 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2708))->BgL_funz00);
						BgL_auxz00_13077 =
							((BgL_varz00_bglt)
							PROCEDURE_ENTRY(BgL_pz00_2709) (BgL_pz00_2709,
								((obj_t) BgL_arg2268z00_2713), BEOA));
					}
					((((BgL_appz00_bglt) CREF(BgL_nz00_2708))->BgL_funz00) =
						((BgL_varz00_bglt) BgL_auxz00_13077), BUNSPEC);
				}
				{
					obj_t BgL_fieldsz00_2716;

					BgL_fieldsz00_2716 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2708))->BgL_argsz00);
				BgL_zc3anonymousza32270ze3z83_2717:
					if (NULLP(BgL_fieldsz00_2716))
						{	/* Ast/walk.scm 296 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 296 */
							{	/* Ast/walk.scm 296 */
								obj_t BgL_arg2272z00_2719;

								{	/* Ast/walk.scm 296 */
									obj_t BgL_arg2273z00_2720;

									BgL_arg2273z00_2720 = CAR(BgL_fieldsz00_2716);
									BgL_arg2272z00_2719 =
										PROCEDURE_ENTRY(BgL_pz00_2709) (BgL_pz00_2709,
										BgL_arg2273z00_2720, BEOA);
								}
								SET_CAR(BgL_fieldsz00_2716, BgL_arg2272z00_2719);
							}
							{
								obj_t BgL_fieldsz00_13094;

								BgL_fieldsz00_13094 = CDR(BgL_fieldsz00_2716);
								BgL_fieldsz00_2716 = BgL_fieldsz00_13094;
								goto BgL_zc3anonymousza32270ze3z83_2717;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2708);
			}
		}
	}



/* &walk3*-app1687 */
	obj_t BGl_z62walk3za2zd2app1687z12zzast_walkz00(obj_t BgL_envz00_7977,
		obj_t BgL_nz00_7978, obj_t BgL_pz00_7979, obj_t BgL_arg0z00_7980,
		obj_t BgL_arg1z00_7981, obj_t BgL_arg2z00_7982)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2686;
				obj_t BgL_pz00_2687;
				obj_t BgL_arg0z00_2688;
				obj_t BgL_arg1z00_2689;
				obj_t BgL_arg2z00_2690;

				BgL_nz00_2686 = ((BgL_appz00_bglt) BgL_nz00_7978);
				BgL_pz00_2687 = BgL_pz00_7979;
				BgL_arg0z00_2688 = BgL_arg0z00_7980;
				BgL_arg1z00_2689 = BgL_arg1z00_7981;
				BgL_arg2z00_2690 = BgL_arg2z00_7982;
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2259z00_2694;
					obj_t BgL_arg2260z00_2695;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2261z00_2696;

						BgL_arg2261z00_2696 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2686))->BgL_funz00);
						BgL_arg2259z00_2694 =
							PROCEDURE_ENTRY(BgL_pz00_2687) (BgL_pz00_2687,
							((obj_t) BgL_arg2261z00_2696), BgL_arg0z00_2688, BgL_arg1z00_2689,
							BgL_arg2z00_2690, BEOA);
					}
					BgL_arg2260z00_2695 =
						BGl_zc3anonymousza32262ze3z83zzast_walkz00(BgL_arg2z00_2690,
						BgL_arg1z00_2689, BgL_arg0z00_2688, BgL_pz00_2687,
						(((BgL_appz00_bglt) CREF(BgL_nz00_2686))->BgL_argsz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg2259z00_2694,
						BgL_arg2260z00_2695);
				}
			}
		}
	}



/* <anonymous:2262> */
	obj_t BGl_zc3anonymousza32262ze3z83zzast_walkz00(obj_t BgL_arg2z00_8140,
		obj_t BgL_arg1z00_8139, obj_t BgL_arg0z00_8138, obj_t BgL_pz00_8137,
		obj_t BgL_l1469z00_2699)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1469z00_2699))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2264z00_2702;
					obj_t BgL_arg2265z00_2703;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2704;

						BgL_fz00_2704 = CAR(BgL_l1469z00_2699);
						BgL_arg2264z00_2702 =
							PROCEDURE_ENTRY(BgL_pz00_8137) (BgL_pz00_8137, BgL_fz00_2704,
							BgL_arg0z00_8138, BgL_arg1z00_8139, BgL_arg2z00_8140, BEOA);
					}
					BgL_arg2265z00_2703 =
						BGl_zc3anonymousza32262ze3z83zzast_walkz00(BgL_arg2z00_8140,
						BgL_arg1z00_8139, BgL_arg0z00_8138, BgL_pz00_8137,
						CDR(BgL_l1469z00_2699));
					return bgl_append2(BgL_arg2264z00_2702, BgL_arg2265z00_2703);
				}
		}
	}



/* &walk2*-app1685 */
	obj_t BGl_z62walk2za2zd2app1685z12zzast_walkz00(obj_t BgL_envz00_7983,
		obj_t BgL_nz00_7984, obj_t BgL_pz00_7985, obj_t BgL_arg0z00_7986,
		obj_t BgL_arg1z00_7987)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2665;
				obj_t BgL_pz00_2666;
				obj_t BgL_arg0z00_2667;
				obj_t BgL_arg1z00_2668;

				BgL_nz00_2665 = ((BgL_appz00_bglt) BgL_nz00_7984);
				BgL_pz00_2666 = BgL_pz00_7985;
				BgL_arg0z00_2667 = BgL_arg0z00_7986;
				BgL_arg1z00_2668 = BgL_arg1z00_7987;
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2251z00_2672;
					obj_t BgL_arg2252z00_2673;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2253z00_2674;

						BgL_arg2253z00_2674 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2665))->BgL_funz00);
						BgL_arg2251z00_2672 =
							PROCEDURE_ENTRY(BgL_pz00_2666) (BgL_pz00_2666,
							((obj_t) BgL_arg2253z00_2674), BgL_arg0z00_2667, BgL_arg1z00_2668,
							BEOA);
					}
					BgL_arg2252z00_2673 =
						BGl_zc3anonymousza32254ze3z83zzast_walkz00(BgL_arg1z00_2668,
						BgL_arg0z00_2667, BgL_pz00_2666,
						(((BgL_appz00_bglt) CREF(BgL_nz00_2665))->BgL_argsz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg2251z00_2672,
						BgL_arg2252z00_2673);
				}
			}
		}
	}



/* <anonymous:2254> */
	obj_t BGl_zc3anonymousza32254ze3z83zzast_walkz00(obj_t BgL_arg1z00_8136,
		obj_t BgL_arg0z00_8135, obj_t BgL_pz00_8134, obj_t BgL_l1466z00_2677)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1466z00_2677))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2256z00_2680;
					obj_t BgL_arg2257z00_2681;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2682;

						BgL_fz00_2682 = CAR(BgL_l1466z00_2677);
						BgL_arg2256z00_2680 =
							PROCEDURE_ENTRY(BgL_pz00_8134) (BgL_pz00_8134, BgL_fz00_2682,
							BgL_arg0z00_8135, BgL_arg1z00_8136, BEOA);
					}
					BgL_arg2257z00_2681 =
						BGl_zc3anonymousza32254ze3z83zzast_walkz00(BgL_arg1z00_8136,
						BgL_arg0z00_8135, BgL_pz00_8134, CDR(BgL_l1466z00_2677));
					return bgl_append2(BgL_arg2256z00_2680, BgL_arg2257z00_2681);
				}
		}
	}



/* &walk1*-app1683 */
	obj_t BGl_z62walk1za2zd2app1683z12zzast_walkz00(obj_t BgL_envz00_7988,
		obj_t BgL_nz00_7989, obj_t BgL_pz00_7990, obj_t BgL_arg0z00_7991)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2645;
				obj_t BgL_pz00_2646;
				obj_t BgL_arg0z00_2647;

				BgL_nz00_2645 = ((BgL_appz00_bglt) BgL_nz00_7989);
				BgL_pz00_2646 = BgL_pz00_7990;
				BgL_arg0z00_2647 = BgL_arg0z00_7991;
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2243z00_2651;
					obj_t BgL_arg2244z00_2652;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2245z00_2653;

						BgL_arg2245z00_2653 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2645))->BgL_funz00);
						BgL_arg2243z00_2651 =
							PROCEDURE_ENTRY(BgL_pz00_2646) (BgL_pz00_2646,
							((obj_t) BgL_arg2245z00_2653), BgL_arg0z00_2647, BEOA);
					}
					BgL_arg2244z00_2652 =
						BGl_zc3anonymousza32246ze3z83zzast_walkz00(BgL_arg0z00_2647,
						BgL_pz00_2646,
						(((BgL_appz00_bglt) CREF(BgL_nz00_2645))->BgL_argsz00));
					return BGl_appendzd221011zd2zzast_walkz00(BgL_arg2243z00_2651,
						BgL_arg2244z00_2652);
				}
			}
		}
	}



/* <anonymous:2246> */
	obj_t BGl_zc3anonymousza32246ze3z83zzast_walkz00(obj_t BgL_arg0z00_8133,
		obj_t BgL_pz00_8132, obj_t BgL_l1463z00_2656)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1463z00_2656))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2248z00_2659;
					obj_t BgL_arg2249z00_2660;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2661;

						BgL_fz00_2661 = CAR(BgL_l1463z00_2656);
						BgL_arg2248z00_2659 =
							PROCEDURE_ENTRY(BgL_pz00_8132) (BgL_pz00_8132, BgL_fz00_2661,
							BgL_arg0z00_8133, BEOA);
					}
					BgL_arg2249z00_2660 =
						BGl_zc3anonymousza32246ze3z83zzast_walkz00(BgL_arg0z00_8133,
						BgL_pz00_8132, CDR(BgL_l1463z00_2656));
					return bgl_append2(BgL_arg2248z00_2659, BgL_arg2249z00_2660);
				}
		}
	}



/* &walk0*-app1681 */
	obj_t BGl_z62walk0za2zd2app1681z12zzast_walkz00(obj_t BgL_envz00_7992,
		obj_t BgL_nz00_7993, obj_t BgL_pz00_7994)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2626;
				obj_t BgL_pz00_2627;

				BgL_nz00_2626 = ((BgL_appz00_bglt) BgL_nz00_7993);
				BgL_pz00_2627 = BgL_pz00_7994;
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2235z00_2631;
					obj_t BgL_arg2236z00_2632;

					{	/* Ast/walk.scm 296 */
						BgL_varz00_bglt BgL_arg2237z00_2633;

						BgL_arg2237z00_2633 =
							(((BgL_appz00_bglt) CREF(BgL_nz00_2626))->BgL_funz00);
						BgL_arg2235z00_2631 =
							PROCEDURE_ENTRY(BgL_pz00_2627) (BgL_pz00_2627,
							((obj_t) BgL_arg2237z00_2633), BEOA);
					}
					BgL_arg2236z00_2632 =
						BGl_zc3anonymousza32238ze3z83zzast_walkz00(BgL_pz00_2627,
						(((BgL_appz00_bglt) CREF(BgL_nz00_2626))->BgL_argsz00));
					return
						BGl_appendzd221011zd2zzast_walkz00(BgL_arg2235z00_2631,
						BgL_arg2236z00_2632);
				}
			}
		}
	}



/* <anonymous:2238> */
	obj_t BGl_zc3anonymousza32238ze3z83zzast_walkz00(obj_t BgL_pz00_8131,
		obj_t BgL_l1460z00_2636)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			if (NULLP(BgL_l1460z00_2636))
				{	/* Ast/walk.scm 296 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 296 */
					obj_t BgL_arg2240z00_2639;
					obj_t BgL_arg2241z00_2640;

					{	/* Ast/walk.scm 296 */
						obj_t BgL_fz00_2641;

						BgL_fz00_2641 = CAR(BgL_l1460z00_2636);
						BgL_arg2240z00_2639 =
							PROCEDURE_ENTRY(BgL_pz00_8131) (BgL_pz00_8131, BgL_fz00_2641,
							BEOA);
					}
					BgL_arg2241z00_2640 =
						BGl_zc3anonymousza32238ze3z83zzast_walkz00(BgL_pz00_8131,
						CDR(BgL_l1460z00_2636));
					return bgl_append2(BgL_arg2240z00_2639, BgL_arg2241z00_2640);
				}
		}
	}



/* &walk3-app1679 */
	obj_t BGl_z62walk3zd2app1679zb0zzast_walkz00(obj_t BgL_envz00_7995,
		obj_t BgL_nz00_7996, obj_t BgL_pz00_7997, obj_t BgL_arg0z00_7998,
		obj_t BgL_arg1z00_7999, obj_t BgL_arg2z00_8000)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2608;
				obj_t BgL_pz00_2609;
				obj_t BgL_arg0z00_2610;
				obj_t BgL_arg1z00_2611;
				obj_t BgL_arg2z00_2612;

				BgL_nz00_2608 = ((BgL_appz00_bglt) BgL_nz00_7996);
				BgL_pz00_2609 = BgL_pz00_7997;
				BgL_arg0z00_2610 = BgL_arg0z00_7998;
				BgL_arg1z00_2611 = BgL_arg1z00_7999;
				BgL_arg2z00_2612 = BgL_arg2z00_8000;
				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2231z00_2616;

					BgL_arg2231z00_2616 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2608))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2609) (BgL_pz00_2609,
						((obj_t) BgL_arg2231z00_2616), BgL_arg0z00_2610, BgL_arg1z00_2611,
						BgL_arg2z00_2612, BEOA);
				}
				{	/* Ast/walk.scm 296 */
					obj_t BgL_g1458z00_2617;

					BgL_g1458z00_2617 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2608))->BgL_argsz00);
					{
						obj_t BgL_l1456z00_2619;

						{	/* Ast/walk.scm 296 */
							bool_t BgL_auxz00_13201;

							BgL_l1456z00_2619 = BgL_g1458z00_2617;
						BgL_zc3anonymousza32232ze3z83_2620:
							if (PAIRP(BgL_l1456z00_2619))
								{	/* Ast/walk.scm 296 */
									{	/* Ast/walk.scm 296 */
										obj_t BgL_fz00_2622;

										BgL_fz00_2622 = CAR(BgL_l1456z00_2619);
										PROCEDURE_ENTRY(BgL_pz00_2609) (BgL_pz00_2609,
											BgL_fz00_2622, BgL_arg0z00_2610, BgL_arg1z00_2611,
											BgL_arg2z00_2612, BEOA);
									}
									{
										obj_t BgL_l1456z00_13212;

										BgL_l1456z00_13212 = CDR(BgL_l1456z00_2619);
										BgL_l1456z00_2619 = BgL_l1456z00_13212;
										goto BgL_zc3anonymousza32232ze3z83_2620;
									}
								}
							else
								{	/* Ast/walk.scm 296 */
									BgL_auxz00_13201 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13201);
						}
					}
				}
			}
		}
	}



/* &walk2-app1677 */
	obj_t BGl_z62walk2zd2app1677zb0zzast_walkz00(obj_t BgL_envz00_8001,
		obj_t BgL_nz00_8002, obj_t BgL_pz00_8003, obj_t BgL_arg0z00_8004,
		obj_t BgL_arg1z00_8005)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2591;
				obj_t BgL_pz00_2592;
				obj_t BgL_arg0z00_2593;
				obj_t BgL_arg1z00_2594;

				BgL_nz00_2591 = ((BgL_appz00_bglt) BgL_nz00_8002);
				BgL_pz00_2592 = BgL_pz00_8003;
				BgL_arg0z00_2593 = BgL_arg0z00_8004;
				BgL_arg1z00_2594 = BgL_arg1z00_8005;
				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2227z00_2598;

					BgL_arg2227z00_2598 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2591))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2592) (BgL_pz00_2592,
						((obj_t) BgL_arg2227z00_2598), BgL_arg0z00_2593, BgL_arg1z00_2594,
						BEOA);
				}
				{	/* Ast/walk.scm 296 */
					obj_t BgL_g1455z00_2599;

					BgL_g1455z00_2599 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2591))->BgL_argsz00);
					{
						obj_t BgL_l1453z00_2601;

						{	/* Ast/walk.scm 296 */
							bool_t BgL_auxz00_13225;

							BgL_l1453z00_2601 = BgL_g1455z00_2599;
						BgL_zc3anonymousza32228ze3z83_2602:
							if (PAIRP(BgL_l1453z00_2601))
								{	/* Ast/walk.scm 296 */
									{	/* Ast/walk.scm 296 */
										obj_t BgL_fz00_2604;

										BgL_fz00_2604 = CAR(BgL_l1453z00_2601);
										PROCEDURE_ENTRY(BgL_pz00_2592) (BgL_pz00_2592,
											BgL_fz00_2604, BgL_arg0z00_2593, BgL_arg1z00_2594, BEOA);
									}
									{
										obj_t BgL_l1453z00_13235;

										BgL_l1453z00_13235 = CDR(BgL_l1453z00_2601);
										BgL_l1453z00_2601 = BgL_l1453z00_13235;
										goto BgL_zc3anonymousza32228ze3z83_2602;
									}
								}
							else
								{	/* Ast/walk.scm 296 */
									BgL_auxz00_13225 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13225);
						}
					}
				}
			}
		}
	}



/* &walk1-app1675 */
	obj_t BGl_z62walk1zd2app1675zb0zzast_walkz00(obj_t BgL_envz00_8006,
		obj_t BgL_nz00_8007, obj_t BgL_pz00_8008, obj_t BgL_arg0z00_8009)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2575;
				obj_t BgL_pz00_2576;
				obj_t BgL_arg0z00_2577;

				BgL_nz00_2575 = ((BgL_appz00_bglt) BgL_nz00_8007);
				BgL_pz00_2576 = BgL_pz00_8008;
				BgL_arg0z00_2577 = BgL_arg0z00_8009;
				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2223z00_2581;

					BgL_arg2223z00_2581 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2575))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2576) (BgL_pz00_2576,
						((obj_t) BgL_arg2223z00_2581), BgL_arg0z00_2577, BEOA);
				}
				{	/* Ast/walk.scm 296 */
					obj_t BgL_g1452z00_2582;

					BgL_g1452z00_2582 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2575))->BgL_argsz00);
					{
						obj_t BgL_l1450z00_2584;

						{	/* Ast/walk.scm 296 */
							bool_t BgL_auxz00_13247;

							BgL_l1450z00_2584 = BgL_g1452z00_2582;
						BgL_zc3anonymousza32224ze3z83_2585:
							if (PAIRP(BgL_l1450z00_2584))
								{	/* Ast/walk.scm 296 */
									{	/* Ast/walk.scm 296 */
										obj_t BgL_fz00_2587;

										BgL_fz00_2587 = CAR(BgL_l1450z00_2584);
										PROCEDURE_ENTRY(BgL_pz00_2576) (BgL_pz00_2576,
											BgL_fz00_2587, BgL_arg0z00_2577, BEOA);
									}
									{
										obj_t BgL_l1450z00_13256;

										BgL_l1450z00_13256 = CDR(BgL_l1450z00_2584);
										BgL_l1450z00_2584 = BgL_l1450z00_13256;
										goto BgL_zc3anonymousza32224ze3z83_2585;
									}
								}
							else
								{	/* Ast/walk.scm 296 */
									BgL_auxz00_13247 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13247);
						}
					}
				}
			}
		}
	}



/* &walk0-app1673 */
	obj_t BGl_z62walk0zd2app1673zb0zzast_walkz00(obj_t BgL_envz00_8010,
		obj_t BgL_nz00_8011, obj_t BgL_pz00_8012)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 296 */
			{
				BgL_appz00_bglt BgL_nz00_2560;
				obj_t BgL_pz00_2561;

				BgL_nz00_2560 = ((BgL_appz00_bglt) BgL_nz00_8011);
				BgL_pz00_2561 = BgL_pz00_8012;
				{	/* Ast/walk.scm 296 */
					BgL_varz00_bglt BgL_arg2219z00_2565;

					BgL_arg2219z00_2565 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2560))->BgL_funz00);
					PROCEDURE_ENTRY(BgL_pz00_2561) (BgL_pz00_2561,
						((obj_t) BgL_arg2219z00_2565), BEOA);
				}
				{	/* Ast/walk.scm 296 */
					obj_t BgL_g1449z00_2566;

					BgL_g1449z00_2566 =
						(((BgL_appz00_bglt) CREF(BgL_nz00_2560))->BgL_argsz00);
					{
						obj_t BgL_l1447z00_2568;

						{	/* Ast/walk.scm 296 */
							bool_t BgL_auxz00_13267;

							BgL_l1447z00_2568 = BgL_g1449z00_2566;
						BgL_zc3anonymousza32220ze3z83_2569:
							if (PAIRP(BgL_l1447z00_2568))
								{	/* Ast/walk.scm 296 */
									{	/* Ast/walk.scm 296 */
										obj_t BgL_fz00_2571;

										BgL_fz00_2571 = CAR(BgL_l1447z00_2568);
										PROCEDURE_ENTRY(BgL_pz00_2561) (BgL_pz00_2561,
											BgL_fz00_2571, BEOA);
									}
									{
										obj_t BgL_l1447z00_13275;

										BgL_l1447z00_13275 = CDR(BgL_l1447z00_2568);
										BgL_l1447z00_2568 = BgL_l1447z00_13275;
										goto BgL_zc3anonymousza32220ze3z83_2569;
									}
								}
							else
								{	/* Ast/walk.scm 296 */
									BgL_auxz00_13267 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13267);
						}
					}
				}
			}
		}
	}



/* &walk3!-sequence1671 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2sequence1671za2zzast_walkz00(obj_t
		BgL_envz00_8013, obj_t BgL_nz00_8014, obj_t BgL_pz00_8015,
		obj_t BgL_arg0z00_8016, obj_t BgL_arg1z00_8017, obj_t BgL_arg2z00_8018)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2542;
				obj_t BgL_pz00_2543;
				obj_t BgL_arg0z00_2544;
				obj_t BgL_arg1z00_2545;
				obj_t BgL_arg2z00_2546;

				BgL_nz00_2542 = ((BgL_sequencez00_bglt) BgL_nz00_8014);
				BgL_pz00_2543 = BgL_pz00_8015;
				BgL_arg0z00_2544 = BgL_arg0z00_8016;
				BgL_arg1z00_2545 = BgL_arg1z00_8017;
				BgL_arg2z00_2546 = BgL_arg2z00_8018;
				{
					obj_t BgL_fieldsz00_2552;

					BgL_fieldsz00_2552 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2542))->BgL_nodesz00);
				BgL_zc3anonymousza32214ze3z83_2553:
					if (NULLP(BgL_fieldsz00_2552))
						{	/* Ast/walk.scm 295 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 295 */
							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2216z00_2555;

								{	/* Ast/walk.scm 295 */
									obj_t BgL_arg2217z00_2556;

									BgL_arg2217z00_2556 = CAR(BgL_fieldsz00_2552);
									BgL_arg2216z00_2555 =
										PROCEDURE_ENTRY(BgL_pz00_2543) (BgL_pz00_2543,
										BgL_arg2217z00_2556, BgL_arg0z00_2544, BgL_arg1z00_2545,
										BgL_arg2z00_2546, BEOA);
								}
								SET_CAR(BgL_fieldsz00_2552, BgL_arg2216z00_2555);
							}
							{
								obj_t BgL_fieldsz00_13290;

								BgL_fieldsz00_13290 = CDR(BgL_fieldsz00_2552);
								BgL_fieldsz00_2552 = BgL_fieldsz00_13290;
								goto BgL_zc3anonymousza32214ze3z83_2553;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2542);
			}
		}
	}



/* &walk2!-sequence1669 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2sequence1669za2zzast_walkz00(obj_t
		BgL_envz00_8019, obj_t BgL_nz00_8020, obj_t BgL_pz00_8021,
		obj_t BgL_arg0z00_8022, obj_t BgL_arg1z00_8023)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2525;
				obj_t BgL_pz00_2526;
				obj_t BgL_arg0z00_2527;
				obj_t BgL_arg1z00_2528;

				BgL_nz00_2525 = ((BgL_sequencez00_bglt) BgL_nz00_8020);
				BgL_pz00_2526 = BgL_pz00_8021;
				BgL_arg0z00_2527 = BgL_arg0z00_8022;
				BgL_arg1z00_2528 = BgL_arg1z00_8023;
				{
					obj_t BgL_fieldsz00_2534;

					BgL_fieldsz00_2534 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2525))->BgL_nodesz00);
				BgL_zc3anonymousza32208ze3z83_2535:
					if (NULLP(BgL_fieldsz00_2534))
						{	/* Ast/walk.scm 295 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 295 */
							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2210z00_2537;

								{	/* Ast/walk.scm 295 */
									obj_t BgL_arg2211z00_2538;

									BgL_arg2211z00_2538 = CAR(BgL_fieldsz00_2534);
									BgL_arg2210z00_2537 =
										PROCEDURE_ENTRY(BgL_pz00_2526) (BgL_pz00_2526,
										BgL_arg2211z00_2538, BgL_arg0z00_2527, BgL_arg1z00_2528,
										BEOA);
								}
								SET_CAR(BgL_fieldsz00_2534, BgL_arg2210z00_2537);
							}
							{
								obj_t BgL_fieldsz00_13305;

								BgL_fieldsz00_13305 = CDR(BgL_fieldsz00_2534);
								BgL_fieldsz00_2534 = BgL_fieldsz00_13305;
								goto BgL_zc3anonymousza32208ze3z83_2535;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2525);
			}
		}
	}



/* &walk1!-sequence1667 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2sequence1667za2zzast_walkz00(obj_t
		BgL_envz00_8024, obj_t BgL_nz00_8025, obj_t BgL_pz00_8026,
		obj_t BgL_arg0z00_8027)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2509;
				obj_t BgL_pz00_2510;
				obj_t BgL_arg0z00_2511;

				BgL_nz00_2509 = ((BgL_sequencez00_bglt) BgL_nz00_8025);
				BgL_pz00_2510 = BgL_pz00_8026;
				BgL_arg0z00_2511 = BgL_arg0z00_8027;
				{
					obj_t BgL_fieldsz00_2517;

					BgL_fieldsz00_2517 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2509))->BgL_nodesz00);
				BgL_zc3anonymousza32202ze3z83_2518:
					if (NULLP(BgL_fieldsz00_2517))
						{	/* Ast/walk.scm 295 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 295 */
							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2204z00_2520;

								{	/* Ast/walk.scm 295 */
									obj_t BgL_arg2205z00_2521;

									BgL_arg2205z00_2521 = CAR(BgL_fieldsz00_2517);
									BgL_arg2204z00_2520 =
										PROCEDURE_ENTRY(BgL_pz00_2510) (BgL_pz00_2510,
										BgL_arg2205z00_2521, BgL_arg0z00_2511, BEOA);
								}
								SET_CAR(BgL_fieldsz00_2517, BgL_arg2204z00_2520);
							}
							{
								obj_t BgL_fieldsz00_13319;

								BgL_fieldsz00_13319 = CDR(BgL_fieldsz00_2517);
								BgL_fieldsz00_2517 = BgL_fieldsz00_13319;
								goto BgL_zc3anonymousza32202ze3z83_2518;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2509);
			}
		}
	}



/* &walk0!-sequence1665 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2sequence1665za2zzast_walkz00(obj_t
		BgL_envz00_8028, obj_t BgL_nz00_8029, obj_t BgL_pz00_8030)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2494;
				obj_t BgL_pz00_2495;

				BgL_nz00_2494 = ((BgL_sequencez00_bglt) BgL_nz00_8029);
				BgL_pz00_2495 = BgL_pz00_8030;
				{
					obj_t BgL_fieldsz00_2501;

					BgL_fieldsz00_2501 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2494))->BgL_nodesz00);
				BgL_zc3anonymousza32196ze3z83_2502:
					if (NULLP(BgL_fieldsz00_2501))
						{	/* Ast/walk.scm 295 */
							((bool_t) 0);
						}
					else
						{	/* Ast/walk.scm 295 */
							{	/* Ast/walk.scm 295 */
								obj_t BgL_arg2198z00_2504;

								{	/* Ast/walk.scm 295 */
									obj_t BgL_arg2199z00_2505;

									BgL_arg2199z00_2505 = CAR(BgL_fieldsz00_2501);
									BgL_arg2198z00_2504 =
										PROCEDURE_ENTRY(BgL_pz00_2495) (BgL_pz00_2495,
										BgL_arg2199z00_2505, BEOA);
								}
								SET_CAR(BgL_fieldsz00_2501, BgL_arg2198z00_2504);
							}
							{
								obj_t BgL_fieldsz00_13332;

								BgL_fieldsz00_13332 = CDR(BgL_fieldsz00_2501);
								BgL_fieldsz00_2501 = BgL_fieldsz00_13332;
								goto BgL_zc3anonymousza32196ze3z83_2502;
							}
						}
				}
				return ((BgL_nodez00_bglt) BgL_nz00_2494);
			}
		}
	}



/* &walk3*-sequence1662 */
	obj_t BGl_z62walk3za2zd2sequence1662z12zzast_walkz00(obj_t BgL_envz00_8031,
		obj_t BgL_nz00_8032, obj_t BgL_pz00_8033, obj_t BgL_arg0z00_8034,
		obj_t BgL_arg1z00_8035, obj_t BgL_arg2z00_8036)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2473;
				obj_t BgL_pz00_2474;
				obj_t BgL_arg0z00_2475;
				obj_t BgL_arg1z00_2476;
				obj_t BgL_arg2z00_2477;

				BgL_nz00_2473 = ((BgL_sequencez00_bglt) BgL_nz00_8032);
				BgL_pz00_2474 = BgL_pz00_8033;
				BgL_arg0z00_2475 = BgL_arg0z00_8034;
				BgL_arg1z00_2476 = BgL_arg1z00_8035;
				BgL_arg2z00_2477 = BgL_arg2z00_8036;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2188z00_2481;

					BgL_arg2188z00_2481 =
						BGl_zc3anonymousza32190ze3z83zzast_walkz00(BgL_arg2z00_2477,
						BgL_arg1z00_2476, BgL_arg0z00_2475, BgL_pz00_2474,
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2473))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2189z00_2482;

						BgL_list2189z00_2482 = MAKE_PAIR(BgL_arg2188z00_2481, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2189z00_2482);
					}
				}
			}
		}
	}



/* <anonymous:2190> */
	obj_t BGl_zc3anonymousza32190ze3z83zzast_walkz00(obj_t BgL_arg2z00_8130,
		obj_t BgL_arg1z00_8129, obj_t BgL_arg0z00_8128, obj_t BgL_pz00_8127,
		obj_t BgL_l1445z00_2485)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1445z00_2485))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2192z00_2488;
					obj_t BgL_arg2193z00_2489;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2490;

						BgL_fz00_2490 = CAR(BgL_l1445z00_2485);
						BgL_arg2192z00_2488 =
							PROCEDURE_ENTRY(BgL_pz00_8127) (BgL_pz00_8127, BgL_fz00_2490,
							BgL_arg0z00_8128, BgL_arg1z00_8129, BgL_arg2z00_8130, BEOA);
					}
					BgL_arg2193z00_2489 =
						BGl_zc3anonymousza32190ze3z83zzast_walkz00(BgL_arg2z00_8130,
						BgL_arg1z00_8129, BgL_arg0z00_8128, BgL_pz00_8127,
						CDR(BgL_l1445z00_2485));
					return bgl_append2(BgL_arg2192z00_2488, BgL_arg2193z00_2489);
				}
		}
	}



/* &walk2*-sequence1660 */
	obj_t BGl_z62walk2za2zd2sequence1660z12zzast_walkz00(obj_t BgL_envz00_8037,
		obj_t BgL_nz00_8038, obj_t BgL_pz00_8039, obj_t BgL_arg0z00_8040,
		obj_t BgL_arg1z00_8041)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2453;
				obj_t BgL_pz00_2454;
				obj_t BgL_arg0z00_2455;
				obj_t BgL_arg1z00_2456;

				BgL_nz00_2453 = ((BgL_sequencez00_bglt) BgL_nz00_8038);
				BgL_pz00_2454 = BgL_pz00_8039;
				BgL_arg0z00_2455 = BgL_arg0z00_8040;
				BgL_arg1z00_2456 = BgL_arg1z00_8041;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2180z00_2460;

					BgL_arg2180z00_2460 =
						BGl_zc3anonymousza32182ze3z83zzast_walkz00(BgL_arg1z00_2456,
						BgL_arg0z00_2455, BgL_pz00_2454,
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2453))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2181z00_2461;

						BgL_list2181z00_2461 = MAKE_PAIR(BgL_arg2180z00_2460, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2181z00_2461);
					}
				}
			}
		}
	}



/* <anonymous:2182> */
	obj_t BGl_zc3anonymousza32182ze3z83zzast_walkz00(obj_t BgL_arg1z00_8126,
		obj_t BgL_arg0z00_8125, obj_t BgL_pz00_8124, obj_t BgL_l1442z00_2464)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1442z00_2464))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2184z00_2467;
					obj_t BgL_arg2185z00_2468;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2469;

						BgL_fz00_2469 = CAR(BgL_l1442z00_2464);
						BgL_arg2184z00_2467 =
							PROCEDURE_ENTRY(BgL_pz00_8124) (BgL_pz00_8124, BgL_fz00_2469,
							BgL_arg0z00_8125, BgL_arg1z00_8126, BEOA);
					}
					BgL_arg2185z00_2468 =
						BGl_zc3anonymousza32182ze3z83zzast_walkz00(BgL_arg1z00_8126,
						BgL_arg0z00_8125, BgL_pz00_8124, CDR(BgL_l1442z00_2464));
					return bgl_append2(BgL_arg2184z00_2467, BgL_arg2185z00_2468);
				}
		}
	}



/* &walk1*-sequence1658 */
	obj_t BGl_z62walk1za2zd2sequence1658z12zzast_walkz00(obj_t BgL_envz00_8042,
		obj_t BgL_nz00_8043, obj_t BgL_pz00_8044, obj_t BgL_arg0z00_8045)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2434;
				obj_t BgL_pz00_2435;
				obj_t BgL_arg0z00_2436;

				BgL_nz00_2434 = ((BgL_sequencez00_bglt) BgL_nz00_8043);
				BgL_pz00_2435 = BgL_pz00_8044;
				BgL_arg0z00_2436 = BgL_arg0z00_8045;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2173z00_2440;

					BgL_arg2173z00_2440 =
						BGl_zc3anonymousza32175ze3z83zzast_walkz00(BgL_arg0z00_2436,
						BgL_pz00_2435,
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2434))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2174z00_2441;

						BgL_list2174z00_2441 = MAKE_PAIR(BgL_arg2173z00_2440, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2174z00_2441);
					}
				}
			}
		}
	}



/* <anonymous:2175> */
	obj_t BGl_zc3anonymousza32175ze3z83zzast_walkz00(obj_t BgL_arg0z00_8123,
		obj_t BgL_pz00_8122, obj_t BgL_l1439z00_2444)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1439z00_2444))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2177z00_2447;
					obj_t BgL_arg2178z00_2448;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2449;

						BgL_fz00_2449 = CAR(BgL_l1439z00_2444);
						BgL_arg2177z00_2447 =
							PROCEDURE_ENTRY(BgL_pz00_8122) (BgL_pz00_8122, BgL_fz00_2449,
							BgL_arg0z00_8123, BEOA);
					}
					BgL_arg2178z00_2448 =
						BGl_zc3anonymousza32175ze3z83zzast_walkz00(BgL_arg0z00_8123,
						BgL_pz00_8122, CDR(BgL_l1439z00_2444));
					return bgl_append2(BgL_arg2177z00_2447, BgL_arg2178z00_2448);
				}
		}
	}



/* &walk0*-sequence1656 */
	obj_t BGl_z62walk0za2zd2sequence1656z12zzast_walkz00(obj_t BgL_envz00_8046,
		obj_t BgL_nz00_8047, obj_t BgL_pz00_8048)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2416;
				obj_t BgL_pz00_2417;

				BgL_nz00_2416 = ((BgL_sequencez00_bglt) BgL_nz00_8047);
				BgL_pz00_2417 = BgL_pz00_8048;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2165z00_2421;

					BgL_arg2165z00_2421 =
						BGl_zc3anonymousza32167ze3z83zzast_walkz00(BgL_pz00_2417,
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2416))->BgL_nodesz00));
					{	/* Ast/walk.scm 295 */
						obj_t BgL_list2166z00_2422;

						BgL_list2166z00_2422 = MAKE_PAIR(BgL_arg2165z00_2421, BNIL);
						return
							BGl_appendz00zz__r4_pairs_and_lists_6_3z00(BgL_list2166z00_2422);
					}
				}
			}
		}
	}



/* <anonymous:2167> */
	obj_t BGl_zc3anonymousza32167ze3z83zzast_walkz00(obj_t BgL_pz00_8121,
		obj_t BgL_l1436z00_2425)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			if (NULLP(BgL_l1436z00_2425))
				{	/* Ast/walk.scm 295 */
					return BNIL;
				}
			else
				{	/* Ast/walk.scm 295 */
					obj_t BgL_arg2169z00_2428;
					obj_t BgL_arg2171z00_2429;

					{	/* Ast/walk.scm 295 */
						obj_t BgL_fz00_2430;

						BgL_fz00_2430 = CAR(BgL_l1436z00_2425);
						BgL_arg2169z00_2428 =
							PROCEDURE_ENTRY(BgL_pz00_8121) (BgL_pz00_8121, BgL_fz00_2430,
							BEOA);
					}
					BgL_arg2171z00_2429 =
						BGl_zc3anonymousza32167ze3z83zzast_walkz00(BgL_pz00_8121,
						CDR(BgL_l1436z00_2425));
					return bgl_append2(BgL_arg2169z00_2428, BgL_arg2171z00_2429);
				}
		}
	}



/* &walk3-sequence1654 */
	obj_t BGl_z62walk3zd2sequence1654zb0zzast_walkz00(obj_t BgL_envz00_8049,
		obj_t BgL_nz00_8050, obj_t BgL_pz00_8051, obj_t BgL_arg0z00_8052,
		obj_t BgL_arg1z00_8053, obj_t BgL_arg2z00_8054)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2399;
				obj_t BgL_pz00_2400;
				obj_t BgL_arg0z00_2401;
				obj_t BgL_arg1z00_2402;
				obj_t BgL_arg2z00_2403;

				BgL_nz00_2399 = ((BgL_sequencez00_bglt) BgL_nz00_8050);
				BgL_pz00_2400 = BgL_pz00_8051;
				BgL_arg0z00_2401 = BgL_arg0z00_8052;
				BgL_arg1z00_2402 = BgL_arg1z00_8053;
				BgL_arg2z00_2403 = BgL_arg2z00_8054;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_g1434z00_2407;

					BgL_g1434z00_2407 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2399))->BgL_nodesz00);
					{
						obj_t BgL_l1432z00_2409;

						{	/* Ast/walk.scm 295 */
							bool_t BgL_auxz00_13404;

							BgL_l1432z00_2409 = BgL_g1434z00_2407;
						BgL_zc3anonymousza32162ze3z83_2410:
							if (PAIRP(BgL_l1432z00_2409))
								{	/* Ast/walk.scm 295 */
									{	/* Ast/walk.scm 295 */
										obj_t BgL_fz00_2412;

										BgL_fz00_2412 = CAR(BgL_l1432z00_2409);
										PROCEDURE_ENTRY(BgL_pz00_2400) (BgL_pz00_2400,
											BgL_fz00_2412, BgL_arg0z00_2401, BgL_arg1z00_2402,
											BgL_arg2z00_2403, BEOA);
									}
									{
										obj_t BgL_l1432z00_13415;

										BgL_l1432z00_13415 = CDR(BgL_l1432z00_2409);
										BgL_l1432z00_2409 = BgL_l1432z00_13415;
										goto BgL_zc3anonymousza32162ze3z83_2410;
									}
								}
							else
								{	/* Ast/walk.scm 295 */
									BgL_auxz00_13404 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13404);
						}
					}
				}
			}
		}
	}



/* &walk2-sequence1652 */
	obj_t BGl_z62walk2zd2sequence1652zb0zzast_walkz00(obj_t BgL_envz00_8055,
		obj_t BgL_nz00_8056, obj_t BgL_pz00_8057, obj_t BgL_arg0z00_8058,
		obj_t BgL_arg1z00_8059)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2383;
				obj_t BgL_pz00_2384;
				obj_t BgL_arg0z00_2385;
				obj_t BgL_arg1z00_2386;

				BgL_nz00_2383 = ((BgL_sequencez00_bglt) BgL_nz00_8056);
				BgL_pz00_2384 = BgL_pz00_8057;
				BgL_arg0z00_2385 = BgL_arg0z00_8058;
				BgL_arg1z00_2386 = BgL_arg1z00_8059;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_g1431z00_2390;

					BgL_g1431z00_2390 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2383))->BgL_nodesz00);
					{
						obj_t BgL_l1429z00_2392;

						{	/* Ast/walk.scm 295 */
							bool_t BgL_auxz00_13420;

							BgL_l1429z00_2392 = BgL_g1431z00_2390;
						BgL_zc3anonymousza32159ze3z83_2393:
							if (PAIRP(BgL_l1429z00_2392))
								{	/* Ast/walk.scm 295 */
									{	/* Ast/walk.scm 295 */
										obj_t BgL_fz00_2395;

										BgL_fz00_2395 = CAR(BgL_l1429z00_2392);
										PROCEDURE_ENTRY(BgL_pz00_2384) (BgL_pz00_2384,
											BgL_fz00_2395, BgL_arg0z00_2385, BgL_arg1z00_2386, BEOA);
									}
									{
										obj_t BgL_l1429z00_13430;

										BgL_l1429z00_13430 = CDR(BgL_l1429z00_2392);
										BgL_l1429z00_2392 = BgL_l1429z00_13430;
										goto BgL_zc3anonymousza32159ze3z83_2393;
									}
								}
							else
								{	/* Ast/walk.scm 295 */
									BgL_auxz00_13420 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13420);
						}
					}
				}
			}
		}
	}



/* &walk1-sequence1650 */
	obj_t BGl_z62walk1zd2sequence1650zb0zzast_walkz00(obj_t BgL_envz00_8060,
		obj_t BgL_nz00_8061, obj_t BgL_pz00_8062, obj_t BgL_arg0z00_8063)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2368;
				obj_t BgL_pz00_2369;
				obj_t BgL_arg0z00_2370;

				BgL_nz00_2368 = ((BgL_sequencez00_bglt) BgL_nz00_8061);
				BgL_pz00_2369 = BgL_pz00_8062;
				BgL_arg0z00_2370 = BgL_arg0z00_8063;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_g1428z00_2374;

					BgL_g1428z00_2374 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2368))->BgL_nodesz00);
					{
						obj_t BgL_l1426z00_2376;

						{	/* Ast/walk.scm 295 */
							bool_t BgL_auxz00_13435;

							BgL_l1426z00_2376 = BgL_g1428z00_2374;
						BgL_zc3anonymousza32156ze3z83_2377:
							if (PAIRP(BgL_l1426z00_2376))
								{	/* Ast/walk.scm 295 */
									{	/* Ast/walk.scm 295 */
										obj_t BgL_fz00_2379;

										BgL_fz00_2379 = CAR(BgL_l1426z00_2376);
										PROCEDURE_ENTRY(BgL_pz00_2369) (BgL_pz00_2369,
											BgL_fz00_2379, BgL_arg0z00_2370, BEOA);
									}
									{
										obj_t BgL_l1426z00_13444;

										BgL_l1426z00_13444 = CDR(BgL_l1426z00_2376);
										BgL_l1426z00_2376 = BgL_l1426z00_13444;
										goto BgL_zc3anonymousza32156ze3z83_2377;
									}
								}
							else
								{	/* Ast/walk.scm 295 */
									BgL_auxz00_13435 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13435);
						}
					}
				}
			}
		}
	}



/* &walk0-sequence1648 */
	obj_t BGl_z62walk0zd2sequence1648zb0zzast_walkz00(obj_t BgL_envz00_8064,
		obj_t BgL_nz00_8065, obj_t BgL_pz00_8066)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 295 */
			{
				BgL_sequencez00_bglt BgL_nz00_2354;
				obj_t BgL_pz00_2355;

				BgL_nz00_2354 = ((BgL_sequencez00_bglt) BgL_nz00_8065);
				BgL_pz00_2355 = BgL_pz00_8066;
				{	/* Ast/walk.scm 295 */
					obj_t BgL_g1425z00_2359;

					BgL_g1425z00_2359 =
						(((BgL_sequencez00_bglt) CREF(BgL_nz00_2354))->BgL_nodesz00);
					{
						obj_t BgL_l1423z00_2361;

						{	/* Ast/walk.scm 295 */
							bool_t BgL_auxz00_13449;

							BgL_l1423z00_2361 = BgL_g1425z00_2359;
						BgL_zc3anonymousza32153ze3z83_2362:
							if (PAIRP(BgL_l1423z00_2361))
								{	/* Ast/walk.scm 295 */
									{	/* Ast/walk.scm 295 */
										obj_t BgL_fz00_2364;

										BgL_fz00_2364 = CAR(BgL_l1423z00_2361);
										PROCEDURE_ENTRY(BgL_pz00_2355) (BgL_pz00_2355,
											BgL_fz00_2364, BEOA);
									}
									{
										obj_t BgL_l1423z00_13457;

										BgL_l1423z00_13457 = CDR(BgL_l1423z00_2361);
										BgL_l1423z00_2361 = BgL_l1423z00_13457;
										goto BgL_zc3anonymousza32153ze3z83_2362;
									}
								}
							else
								{	/* Ast/walk.scm 295 */
									BgL_auxz00_13449 = ((bool_t) 1);
								}
							return BBOOL(BgL_auxz00_13449);
						}
					}
				}
			}
		}
	}



/* &walk3!-node1646 */
	BgL_nodez00_bglt BGl_z62walk3z12zd2node1646za2zzast_walkz00(obj_t
		BgL_envz00_8067, obj_t BgL_nz00_8068, obj_t BgL_pz00_8069,
		obj_t BgL_arg0z00_8070, obj_t BgL_arg1z00_8071, obj_t BgL_arg2z00_8072)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8068);
		}
	}



/* &walk2!-node1644 */
	BgL_nodez00_bglt BGl_z62walk2z12zd2node1644za2zzast_walkz00(obj_t
		BgL_envz00_8073, obj_t BgL_nz00_8074, obj_t BgL_pz00_8075,
		obj_t BgL_arg0z00_8076, obj_t BgL_arg1z00_8077)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8074);
		}
	}



/* &walk1!-node1642 */
	BgL_nodez00_bglt BGl_z62walk1z12zd2node1642za2zzast_walkz00(obj_t
		BgL_envz00_8078, obj_t BgL_nz00_8079, obj_t BgL_pz00_8080,
		obj_t BgL_arg0z00_8081)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8079);
		}
	}



/* &walk0!-node1640 */
	BgL_nodez00_bglt BGl_z62walk0z12zd2node1640za2zzast_walkz00(obj_t
		BgL_envz00_8082, obj_t BgL_nz00_8083, obj_t BgL_pz00_8084)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return ((BgL_nodez00_bglt) BgL_nz00_8083);
		}
	}



/* &walk3*-node1638 */
	obj_t BGl_z62walk3za2zd2node1638z12zzast_walkz00(obj_t BgL_envz00_8085,
		obj_t BgL_nz00_8086, obj_t BgL_pz00_8087, obj_t BgL_arg0z00_8088,
		obj_t BgL_arg1z00_8089, obj_t BgL_arg2z00_8090)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}
	}



/* &walk2*-node1636 */
	obj_t BGl_z62walk2za2zd2node1636z12zzast_walkz00(obj_t BgL_envz00_8091,
		obj_t BgL_nz00_8092, obj_t BgL_pz00_8093, obj_t BgL_arg0z00_8094,
		obj_t BgL_arg1z00_8095)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}
	}



/* &walk1*-node1634 */
	obj_t BGl_z62walk1za2zd2node1634z12zzast_walkz00(obj_t BgL_envz00_8096,
		obj_t BgL_nz00_8097, obj_t BgL_pz00_8098, obj_t BgL_arg0z00_8099)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}
	}



/* &walk0*-node1632 */
	obj_t BGl_z62walk0za2zd2node1632z12zzast_walkz00(obj_t BgL_envz00_8100,
		obj_t BgL_nz00_8101, obj_t BgL_pz00_8102)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BNIL;
		}
	}



/* &walk3-node1630 */
	obj_t BGl_z62walk3zd2node1630zb0zzast_walkz00(obj_t BgL_envz00_8103,
		obj_t BgL_nz00_8104, obj_t BgL_pz00_8105, obj_t BgL_arg0z00_8106,
		obj_t BgL_arg1z00_8107, obj_t BgL_arg2z00_8108)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}
	}



/* &walk2-node1628 */
	obj_t BGl_z62walk2zd2node1628zb0zzast_walkz00(obj_t BgL_envz00_8109,
		obj_t BgL_nz00_8110, obj_t BgL_pz00_8111, obj_t BgL_arg0z00_8112,
		obj_t BgL_arg1z00_8113)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}
	}



/* &walk1-node1626 */
	obj_t BGl_z62walk1zd2node1626zb0zzast_walkz00(obj_t BgL_envz00_8114,
		obj_t BgL_nz00_8115, obj_t BgL_pz00_8116, obj_t BgL_arg0z00_8117)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}
	}



/* &walk0-node1624 */
	obj_t BGl_z62walk0zd2node1624zb0zzast_walkz00(obj_t BgL_envz00_8118,
		obj_t BgL_nz00_8119, obj_t BgL_pz00_8120)
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 294 */
			return BFALSE;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzast_walkz00()
	{
		AN_OBJECT;
		{	/* Ast/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string3935z00zzast_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string3935z00zzast_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string3935z00zzast_walkz00));
		}
	}

#ifdef __cplusplus
}
#endif
