/*===========================================================================*/
/*   (Dataflow/walk.scm)                                                     */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Dataflow/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_localz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		long BgL_keyz00;
	}               *BgL_localz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_atomz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_valuez00;
	}              *BgL_atomz00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_instanceofz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
		obj_t BgL_czd2formatzd2;
		struct BgL_typez00_bgl *BgL_classz00;
	}                    *BgL_instanceofz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_localzf2valuezf2_bgl
	{
		int BgL_stampz00;
		struct BgL_nodez00_bgl *BgL_nodez00;
	}                       *BgL_localzf2valuezf2_bglt;


	BGL_IMPORT obj_t BGl_classzd2nilzd2initz12z12zz__objectz00(obj_t);
	extern obj_t BGl_closurez00zzast_nodez00;
	extern obj_t BGl_za2pairzd2nilza2zd2zztype_cachez00;
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2appzd2l1372za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza31711ze3z83zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2selec1386z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2funca1374z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_assqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2nodez12zd2sync1368z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	static obj_t BGl_z62dataflowzd2nodez12zd2fail1384z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t
		BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(BgL_nodez00_bglt);
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_appendzd221011zd2zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zzdataflow_walkz00();
	static obj_t
		BGl_z62dataflowzd2nodez12zd2boxzd2s1400za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62abortzf3zd2letzd2fun1434z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez121359za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_zc3anonymousza31665ze3z83zzdataflow_walkz00(obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2app1370z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_za2_za2z00zztype_cachez00;
	static obj_t BGl_z62dataflowzd2testzd2envzd2ap1406zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_za2objza2z00zztype_cachez00;
	static obj_t BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	extern bool_t BGl_typezd2subclasszf3z21zzobject_classz00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2closu1364z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62abortzf3z91zzdataflow_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_registerzd2classz12zc0zz__objectz00(obj_t, obj_t, obj_t,
		long, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2testzd2envzd2co1412zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd21418zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3zd2letzd2var1432z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62lambda1611z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1612z62zzdataflow_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2sequence1428z43zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd21422zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2seque1366z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2testzd2envzd2le1417zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern bool_t BGl_bigloozd2typezf3z21zztype_typez00(BgL_typez00_bglt);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	extern obj_t BGl_selectz00zzast_nodez00;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	static obj_t BGl_requirezd2initializa7ationz75zzdataflow_walkz00 = BUNSPEC;
	extern obj_t BGl_funz00zzast_varz00;
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	BGL_IMPORT obj_t BGl_za2classesza2z00zz__objectz00;
	extern obj_t BGl_tclassz00zzobject_classz00;
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t
		BGl_z62dataflowzd2nodez12zd2setzd2e1392za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_toplevelzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2exter1376z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62dataflowzd2nodez12zd2setq1378z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_filterzd2mapzd2zz__r4_control_features_6_9z00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_makezd2classzd2fieldz00zz__objectz00(obj_t, obj_t, obj_t,
		bool_t, bool_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_za2boolza2z00zztype_cachez00;
	static obj_t BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	extern obj_t BGl_typez00zztype_typez00;
	static obj_t BGl_z62dataflowzd2nodez12zd2var1362z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2nodez12zd2condi1382z70zzdataflow_walkz00(obj_t,
		obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	static obj_t BGl_abortzf3zf3zzdataflow_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	extern obj_t BGl_varz00zzast_nodez00;
	extern BgL_typez00_bglt BGl_getzd2typezd2zztype_typeofz00(BgL_nodez00_bglt);
	static BgL_localz00_bglt
		BGl_z62zc3anonymousza31570ze3ze1zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2boxzd2r1398za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_za2pairza2z00zztype_cachez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2letzd2f1388za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62abortzf31423z91zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2testzd2envzd2in1409zb0zzdataflow_walkz00(obj_t,
		obj_t);
	static long BGl_letzd2varzd2stampz00zzdataflow_walkz00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2letzd2v1390za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t
		BGl_zc3anonymousza31692ze3z83zzdataflow_walkz00(BgL_variablez00_bglt,
		obj_t);
	static obj_t
		BGl_z62dataflowzd2nodez12zd2jumpzd21394za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t
		BGl_modulezd2initializa7ationz75zzdataflow_walkz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_feffectz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_spreadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzobject_classz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_cachez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typeofz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_tracez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62zc3anonymousza31737ze3ze1zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62dataflowzd2testzd2env1401z62zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_cnstzd2initzd2zzdataflow_walkz00();
	static obj_t BGl_z62abortzf3zd2app1438z43zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00();
	static obj_t BGl_importedzd2moduleszd2initz00zzdataflow_walkz00();
	static obj_t BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 = BUNSPEC;
	extern obj_t BGl_findzd2globalzf2modulez20zzast_envz00(obj_t, obj_t);
	static obj_t BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2bnilza2z00zztype_cachez00;
	extern obj_t BGl_instanceofz00zzast_nodez00;
	static obj_t
		BGl_z62dataflowzd2nodez12zd2makezd21396za2zzdataflow_walkz00(obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3zd2funcall1440z43zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern obj_t BGl_valuez00zzast_varz00;
	static obj_t BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(BgL_nodez00_bglt,
		obj_t);
	static BgL_localz00_bglt BGl_z62lambda1553z62zzdataflow_walkz00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_localzf2valuezf2zzdataflow_walkz00 = BUNSPEC;
	static BgL_localz00_bglt BGl_z62lambda1558z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2conditional1436z43zzdataflow_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t BGl_classzd2superzd2zz__objectz00(obj_t);
	static BgL_localz00_bglt BGl_z62lambda1571z62zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_isazd2ofzd2zztype_miscz00(BgL_nodez00_bglt);
	static obj_t BGl_z62abortzf3zd2appzd2ly1442z91zzdataflow_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62abortzf3zd2fail1426z43zzdataflow_walkz00(obj_t, obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	static obj_t BGl_z62dataflowzd2testzd2envzd2va1415zb0zzdataflow_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_globalz00zzast_varz00;
	static BgL_nodez00_bglt BGl_z62lambda1592z62zzdataflow_walkz00(obj_t, obj_t);
	static obj_t BGl_z62lambda1593z62zzdataflow_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_z62abortzf3zd2sync1430z43zzdataflow_walkz00(obj_t, obj_t);
	static obj_t __cnst[12];


	   
		 
		DEFINE_STRING(BGl_string2131z00zzdataflow_walkz00,
		BgL_bgl_string2131za700za7za7d2155za7, "dataflow-test-env", 17);
	      DEFINE_STRING(BGl_string2137z00zzdataflow_walkz00,
		BgL_bgl_string2137za700za7za7d2156za7, "dataflow-test-false-env", 23);
	      DEFINE_STRING(BGl_string2139z00zzdataflow_walkz00,
		BgL_bgl_string2139za700za7za7d2157za7, "abort?", 6);
	      DEFINE_STRING(BGl_string2148z00zzdataflow_walkz00,
		BgL_bgl_string2148za700za7za7d2158za7, "dataflow_walk", 13);
	      DEFINE_STRING(BGl_string2149z00zzdataflow_walkz00,
		BgL_bgl_string2149za700za7za7d2159za7,
		"read _ dataflow_walk local/value int stamp node $epair? $pair? foreign $null? pass-started ",
		91);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2094z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1593za7622160z00, BGl_z62lambda1593z62zzdataflow_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2095z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1592za7622161z00, BGl_z62lambda1592z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2096z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1612za7622162z00, BGl_z62lambda1612z62zzdataflow_walkz00,
		0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2097z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1611za7622163z00, BGl_z62lambda1611z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2098z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1571za7622164z00, BGl_z62lambda1571z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2099z00zzdataflow_walkz00,
		BgL_bgl_za762za7c3anonymousza72165za7,
		BGl_z62zc3anonymousza31570ze3ze1zzdataflow_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2166z00,
		BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2100z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1558za7622167z00, BGl_z62lambda1558z62zzdataflow_walkz00,
		0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2101z00zzdataflow_walkz00,
		BgL_bgl_za762lambda1553za7622168z00, BGl_z62lambda1553z62zzdataflow_walkz00,
		0L, BUNSPEC, 13);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2102z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2169z00,
		BGl_z62dataflowzd2nodez121359za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2104z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2170z00,
		BGl_z62dataflowzd2testzd2env1401z62zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2106z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2171z00,
		BGl_z62dataflowzd2testzd2falsezd21418zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2108z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f31423za72172za7,
		BGl_z62abortzf31423z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2110z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2173z00,
		BGl_z62dataflowzd2nodez12zd2var1362z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2112z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2174z00,
		BGl_z62dataflowzd2nodez12zd2closu1364z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2113z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2175z00,
		BGl_z62dataflowzd2nodez12zd2seque1366z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2114z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2176z00,
		BGl_z62dataflowzd2nodez12zd2sync1368z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2115z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2177z00,
		BGl_z62dataflowzd2nodez12zd2app1370z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2116z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2178z00,
		BGl_z62dataflowzd2nodez12zd2appzd2l1372za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2117z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2179z00,
		BGl_z62dataflowzd2nodez12zd2funca1374z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2118z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2180z00,
		BGl_z62dataflowzd2nodez12zd2exter1376z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2119z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2181z00,
		BGl_z62dataflowzd2nodez12zd2setq1378z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2120z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2182z00,
		BGl_z62dataflowzd2nodez12zd2condi1382z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2121z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2183z00,
		BGl_z62dataflowzd2nodez12zd2fail1384z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2122z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2184z00,
		BGl_z62dataflowzd2nodez12zd2selec1386z70zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2123z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2185z00,
		BGl_z62dataflowzd2nodez12zd2letzd2f1388za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2124z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2186z00,
		BGl_z62dataflowzd2nodez12zd2letzd2v1390za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2125z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2187z00,
		BGl_z62dataflowzd2nodez12zd2setzd2e1392za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2126z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2188z00,
		BGl_z62dataflowzd2nodez12zd2jumpzd21394za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2127z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2189z00,
		BGl_z62dataflowzd2nodez12zd2makezd21396za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2128z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2190z00,
		BGl_z62dataflowzd2nodez12zd2boxzd2r1398za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2129z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2191z00,
		BGl_z62dataflowzd2nodez12zd2boxzd2s1400za2zzdataflow_walkz00, 0L, BUNSPEC,
		2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2130z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2192z00,
		BGl_z62dataflowzd2testzd2envzd2ap1406zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2132z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2193z00,
		BGl_z62dataflowzd2testzd2envzd2in1409zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2133z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2194z00,
		BGl_z62dataflowzd2testzd2envzd2co1412zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2134z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2195z00,
		BGl_z62dataflowzd2testzd2envzd2va1415zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2135z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2196z00,
		BGl_z62dataflowzd2testzd2envzd2le1417zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2136z00zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2197z00,
		BGl_z62dataflowzd2testzd2falsezd21422zb0zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2138z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2fa2198za7,
		BGl_z62abortzf3zd2fail1426z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2140z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2se2199za7,
		BGl_z62abortzf3zd2sequence1428z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2141z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2sy2200za7,
		BGl_z62abortzf3zd2sync1430z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2142z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2le2201za7,
		BGl_z62abortzf3zd2letzd2var1432z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2143z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2le2202za7,
		BGl_z62abortzf3zd2letzd2fun1434z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2144z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2co2203za7,
		BGl_z62abortzf3zd2conditional1436z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2145z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2ap2204za7,
		BGl_z62abortzf3zd2app1438z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2146z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2fu2205za7,
		BGl_z62abortzf3zd2funcall1440z43zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2147z00zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za7d2ap2206za7,
		BGl_z62abortzf3zd2appzd2ly1442z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2087z00zzdataflow_walkz00,
		BgL_bgl_string2087za700za7za7d2207za7, "   . ", 5);
	      DEFINE_STRING(BGl_string2088z00zzdataflow_walkz00,
		BgL_bgl_string2088za700za7za7d2208za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string2089z00zzdataflow_walkz00,
		BgL_bgl_string2089za700za7za7d2209za7, " error", 6);
	      DEFINE_STRING(BGl_string2090z00zzdataflow_walkz00,
		BgL_bgl_string2090za700za7za7d2210za7, "s", 1);
	      DEFINE_STRING(BGl_string2091z00zzdataflow_walkz00,
		BgL_bgl_string2091za700za7za7d2211za7, "", 0);
	      DEFINE_STRING(BGl_string2092z00zzdataflow_walkz00,
		BgL_bgl_string2092za700za7za7d2212za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string2093z00zzdataflow_walkz00,
		BgL_bgl_string2093za700za7za7d2213za7, "failure during postlude hook", 28);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_dataflowzd2walkz12zd2envz12zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2wa2214z00,
		BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_GENERIC(BGl_abortzf3zd2envz21zzdataflow_walkz00,
		BgL_bgl_za762abortza7f3za791za7za72215za7,
		BGl_z62abortzf3z91zzdataflow_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2te2216z00,
		BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
		BgL_bgl_za762dataflowza7d2no2217z00,
		BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STRING(BGl_string2103z00zzdataflow_walkz00,
		BgL_bgl_string2103za700za7za7d2218za7, "dataflow-node!1359", 18);
	      DEFINE_STRING(BGl_string2105z00zzdataflow_walkz00,
		BgL_bgl_string2105za700za7za7d2219za7, "dataflow-test-env1401", 21);
	      DEFINE_STRING(BGl_string2107z00zzdataflow_walkz00,
		BgL_bgl_string2107za700za7za7d2220za7, "dataflow-test-false-1418", 24);
	      DEFINE_STRING(BGl_string2109z00zzdataflow_walkz00,
		BgL_bgl_string2109za700za7za7d2221za7, "abort?1423", 10);
	      DEFINE_STRING(BGl_string2111z00zzdataflow_walkz00,
		BgL_bgl_string2111za700za7za7d2222za7, "dataflow-node!", 14);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zzdataflow_walkz00(long
		BgL_checksumz00_3233, char *BgL_fromz00_3234)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zzdataflow_walkz00))
				{
					BGl_requirezd2initializa7ationz75zzdataflow_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00();
					BGl_cnstzd2initzd2zzdataflow_walkz00();
					BGl_importedzd2moduleszd2initz00zzdataflow_walkz00();
					BGl_objectzd2initzd2zzdataflow_walkz00();
					BGl_genericzd2initzd2zzdataflow_walkz00();
					BGl_methodzd2initzd2zzdataflow_walkz00();
					return BGl_toplevelzd2initzd2zzdataflow_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zzdataflow_walkz00()
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 17 */
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long) 0),
				"dataflow_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"dataflow_walk");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zzdataflow_walkz00()
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 17 */
			{	/* Dataflow/walk.scm 17 */
				obj_t BgL_cportz00_3202;

				{	/* Dataflow/walk.scm 17 */
					obj_t BgL_startz00_3211;

					BgL_startz00_3211 = BINT(((long) 0));
					{	/* Dataflow/walk.scm 17 */
						obj_t BgL_endz00_3212;

						BgL_endz00_3212 =
							BINT(STRING_LENGTH(BGl_string2149z00zzdataflow_walkz00));
						{	/* Dataflow/walk.scm 17 */

							BgL_cportz00_3202 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string2149z00zzdataflow_walkz00, BgL_startz00_3211,
								BgL_endz00_3212);
				}}}
				{
					long BgL_iz00_3203;

					BgL_iz00_3203 = ((long) 11);
				BgL_loopz00_3204:
					if ((BgL_iz00_3203 == ((long) -1)))
						{	/* Dataflow/walk.scm 17 */
							return BUNSPEC;
						}
					else
						{	/* Dataflow/walk.scm 17 */
							{	/* Dataflow/walk.scm 17 */
								obj_t BgL_arg2151z00_3206;

								{	/* Dataflow/walk.scm 17 */

									{	/* Dataflow/walk.scm 17 */
										obj_t BgL_locationz00_3208;

										BgL_locationz00_3208 = BBOOL(((bool_t) 0));
										{	/* Dataflow/walk.scm 17 */

											BgL_arg2151z00_3206 =
												BGl_readz00zz__readerz00(BgL_cportz00_3202,
												BgL_locationz00_3208);
										}
									}
								}
								{	/* Dataflow/walk.scm 17 */
									int BgL_auxz00_3265;

									BgL_auxz00_3265 = (int) (BgL_iz00_3203);
									CNST_TABLE_SET(BgL_auxz00_3265, BgL_arg2151z00_3206);
							}}
							{	/* Dataflow/walk.scm 17 */
								int BgL_auxz00_3209;

								BgL_auxz00_3209 = (int) ((BgL_iz00_3203 - ((long) 1)));
								{
									long BgL_iz00_3270;

									BgL_iz00_3270 = (long) (BgL_auxz00_3209);
									BgL_iz00_3203 = BgL_iz00_3270;
									goto BgL_loopz00_3204;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zzdataflow_walkz00()
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 17 */
			BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 = BFALSE;
			BGl_letzd2varzd2stampz00zzdataflow_walkz00 = ((long) 0);
			return BUNSPEC;
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zzdataflow_walkz00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_1665;

				BgL_headz00_1665 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_1666;
					obj_t BgL_tailz00_1667;

					BgL_prevz00_1666 = BgL_headz00_1665;
					BgL_tailz00_1667 = BgL_l1z00_1;
				BgL_loopz00_1668:
					if (PAIRP(BgL_tailz00_1667))
						{
							obj_t BgL_newzd2prevzd2_1670;

							BgL_newzd2prevzd2_1670 =
								MAKE_PAIR(CAR(BgL_tailz00_1667), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_1666, BgL_newzd2prevzd2_1670);
							{
								obj_t BgL_tailz00_3279;
								obj_t BgL_prevz00_3278;

								BgL_prevz00_3278 = BgL_newzd2prevzd2_1670;
								BgL_tailz00_3279 = CDR(BgL_tailz00_1667);
								BgL_tailz00_1667 = BgL_tailz00_3279;
								BgL_prevz00_1666 = BgL_prevz00_3278;
								goto BgL_loopz00_1668;
							}
						}
					else
						{
							BNIL;
						}
					return CDR(BgL_headz00_1665);
				}
			}
		}
	}



/* dataflow-walk! */
	BGL_EXPORTED_DEF obj_t BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(obj_t
		BgL_globalsz00_56, obj_t BgL_namez00_57)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 44 */
			{	/* Dataflow/walk.scm 45 */
				obj_t BgL_list1460z00_1679;

				{	/* Dataflow/walk.scm 45 */
					obj_t BgL_arg1467z00_1680;

					{	/* Dataflow/walk.scm 45 */
						obj_t BgL_arg1468z00_1681;

						BgL_arg1468z00_1681 =
							MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
						BgL_arg1467z00_1680 =
							MAKE_PAIR(BgL_namez00_57, BgL_arg1468z00_1681);
					}
					BgL_list1460z00_1679 =
						MAKE_PAIR(BGl_string2087z00zzdataflow_walkz00, BgL_arg1467z00_1680);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1460z00_1679);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 = BgL_namez00_57;
			{
				obj_t BgL_hooksz00_1685;
				obj_t BgL_hnamesz00_1686;

				BgL_hooksz00_1685 = BNIL;
				BgL_hnamesz00_1686 = BNIL;
			BgL_zc3anonymousza31469ze3z83_1687:
				if (NULLP(BgL_hooksz00_1685))
					{	/* Dataflow/walk.scm 45 */
						CNST_TABLE_REF(((long) 0));
					}
				else
					{	/* Dataflow/walk.scm 45 */
						bool_t BgL_testz00_3292;

						{	/* Dataflow/walk.scm 45 */
							obj_t BgL_fun1487z00_1693;

							BgL_fun1487z00_1693 = CAR(BgL_hooksz00_1685);
							BgL_testz00_3292 =
								CBOOL(PROCEDURE_ENTRY(BgL_fun1487z00_1693) (BgL_fun1487z00_1693,
									BEOA));
						}
						if (BgL_testz00_3292)
							{
								obj_t BgL_hnamesz00_3300;
								obj_t BgL_hooksz00_3298;

								BgL_hooksz00_3298 = CDR(BgL_hooksz00_1685);
								BgL_hnamesz00_3300 = CDR(BgL_hnamesz00_1686);
								BgL_hnamesz00_1686 = BgL_hnamesz00_3300;
								BgL_hooksz00_1685 = BgL_hooksz00_3298;
								goto BgL_zc3anonymousza31469ze3z83_1687;
							}
						else
							{	/* Dataflow/walk.scm 45 */
								BGl_internalzd2errorzd2zztools_errorz00(BgL_namez00_57,
									BGl_string2088z00zzdataflow_walkz00, CAR(BgL_hnamesz00_1686));
							}
					}
			}
			BGl_za2z42nullzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 1)),
				CNST_TABLE_REF(((long) 2)));
			BGl_za2z42pairzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 3)),
				CNST_TABLE_REF(((long) 2)));
			BGl_za2z42epairzf3za2zb1zzdataflow_walkz00 =
				BGl_findzd2globalzf2modulez20zzast_envz00(CNST_TABLE_REF(((long) 4)),
				CNST_TABLE_REF(((long) 2)));
			{
				obj_t BgL_l1315z00_1697;

				BgL_l1315z00_1697 = BgL_globalsz00_56;
			BgL_zc3anonymousza31489ze3z83_1698:
				if (PAIRP(BgL_l1315z00_1697))
					{	/* Dataflow/walk.scm 49 */
						{	/* Dataflow/walk.scm 49 */
							obj_t BgL_arg1491z00_1700;

							BgL_arg1491z00_1700 = CAR(BgL_l1315z00_1697);
							{	/* Dataflow/walk.scm 63 */
								obj_t BgL_arg1516z00_2564;

								BgL_arg1516z00_2564 =
									(((BgL_sfunz00_bglt) CREF(
											((BgL_sfunz00_bglt)
												(((BgL_variablez00_bglt) CREF(
															((BgL_variablez00_bglt)
																((BgL_globalz00_bglt) BgL_arg1491z00_1700))))->
													BgL_valuez00))))->BgL_bodyz00);
								BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(((BgL_nodez00_bglt)
										BgL_arg1516z00_2564), BNIL);
							}
						}
						{
							obj_t BgL_l1315z00_3323;

							BgL_l1315z00_3323 = CDR(BgL_l1315z00_1697);
							BgL_l1315z00_1697 = BgL_l1315z00_3323;
							goto BgL_zc3anonymousza31489ze3z83_1698;
						}
					}
				else
					{	/* Dataflow/walk.scm 49 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Dataflow/walk.scm 50 */
					{	/* Dataflow/walk.scm 50 */
						obj_t BgL_port1317z00_1705;

						{	/* Dataflow/walk.scm 50 */
							obj_t BgL_res1995z00_2573;

							{	/* Dataflow/walk.scm 50 */
								obj_t BgL_auxz00_3328;

								BgL_auxz00_3328 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1995z00_2573 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_auxz00_3328);
							}
							BgL_port1317z00_1705 = BgL_res1995z00_2573;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1317z00_1705);
						bgl_display_string(BGl_string2089z00zzdataflow_walkz00,
							BgL_port1317z00_1705);
						{	/* Dataflow/walk.scm 50 */
							obj_t BgL_arg1496z00_1706;

							{	/* Dataflow/walk.scm 50 */
								bool_t BgL_testz00_3333;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Dataflow/walk.scm 50 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Dataflow/walk.scm 50 */
												BgL_testz00_3333 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Dataflow/walk.scm 50 */
												BgL_testz00_3333 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Dataflow/walk.scm 50 */
										BgL_testz00_3333 = ((bool_t) 0);
									}
								if (BgL_testz00_3333)
									{	/* Dataflow/walk.scm 50 */
										BgL_arg1496z00_1706 = BGl_string2090z00zzdataflow_walkz00;
									}
								else
									{	/* Dataflow/walk.scm 50 */
										BgL_arg1496z00_1706 = BGl_string2091z00zzdataflow_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1496z00_1706, BgL_port1317z00_1705);
						}
						bgl_display_string(BGl_string2092z00zzdataflow_walkz00,
							BgL_port1317z00_1705);
						bgl_display_char(((unsigned char) '\n'), BgL_port1317z00_1705);
					}
					{	/* Dataflow/walk.scm 50 */
						obj_t BgL_list1501z00_1710;

						BgL_list1501z00_1710 = MAKE_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1501z00_1710);
					}
				}
			else
				{
					obj_t BgL_hooksz00_1714;
					obj_t BgL_hnamesz00_1715;

					BgL_hooksz00_1714 = BNIL;
					BgL_hnamesz00_1715 = BNIL;
				BgL_zc3anonymousza31502ze3z83_1716:
					if (NULLP(BgL_hooksz00_1714))
						{	/* Dataflow/walk.scm 50 */
							return BgL_globalsz00_56;
						}
					else
						{	/* Dataflow/walk.scm 50 */
							bool_t BgL_testz00_3350;

							{	/* Dataflow/walk.scm 50 */
								obj_t BgL_fun1512z00_1722;

								BgL_fun1512z00_1722 = CAR(BgL_hooksz00_1714);
								BgL_testz00_3350 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1512z00_1722)
									(BgL_fun1512z00_1722, BEOA));
							}
							if (BgL_testz00_3350)
								{
									obj_t BgL_hnamesz00_3358;
									obj_t BgL_hooksz00_3356;

									BgL_hooksz00_3356 = CDR(BgL_hooksz00_1714);
									BgL_hnamesz00_3358 = CDR(BgL_hnamesz00_1715);
									BgL_hnamesz00_1715 = BgL_hnamesz00_3358;
									BgL_hooksz00_1714 = BgL_hooksz00_3356;
									goto BgL_zc3anonymousza31502ze3z83_1716;
								}
							else
								{	/* Dataflow/walk.scm 50 */
									obj_t BgL_arg1511z00_1721;

									BgL_arg1511z00_1721 = CAR(BgL_hnamesz00_1715);
									return
										BGl_internalzd2errorzd2zztools_errorz00
										(BGl_za2currentzd2passza2zd2zzengine_passz00,
										BGl_string2093z00zzdataflow_walkz00, BgL_arg1511z00_1721);
								}
						}
				}
		}
	}



/* &dataflow-walk! */
	obj_t BGl_z62dataflowzd2walkz12za2zzdataflow_walkz00(obj_t BgL_envz00_3012,
		obj_t BgL_globalsz00_3013, obj_t BgL_namez00_3014)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 44 */
			return
				BGl_dataflowzd2walkz12zc0zzdataflow_walkz00(BgL_globalsz00_3013,
				BgL_namez00_3014);
		}
	}



/* dataflow-node*! */
	obj_t BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(obj_t BgL_nodeza2za2_99,
		obj_t BgL_envz00_100)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 306 */
			{
				obj_t BgL_l1339z00_1728;

				BgL_l1339z00_1728 = BgL_nodeza2za2_99;
			BgL_zc3anonymousza31520ze3z83_1729:
				if (PAIRP(BgL_l1339z00_1728))
					{	/* Dataflow/walk.scm 307 */
						{	/* Dataflow/walk.scm 307 */
							obj_t BgL_nz00_1731;

							BgL_nz00_1731 = CAR(BgL_l1339z00_1728);
							BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
								((BgL_nodez00_bglt) BgL_nz00_1731), BgL_envz00_100);
						}
						{
							obj_t BgL_l1339z00_3368;

							BgL_l1339z00_3368 = CDR(BgL_l1339z00_1728);
							BgL_l1339z00_1728 = BgL_l1339z00_3368;
							goto BgL_zc3anonymousza31520ze3z83_1729;
						}
					}
				else
					{	/* Dataflow/walk.scm 307 */
						((bool_t) 1);
					}
			}
			return BgL_envz00_100;
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zzdataflow_walkz00()
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 17 */
			{	/* Dataflow/walk.scm 36 */
				obj_t BgL_arg1549z00_1738;
				obj_t BgL_arg1552z00_1739;

				{	/* Dataflow/walk.scm 36 */
					obj_t BgL_v1357z00_1773;

					BgL_v1357z00_1773 = create_vector((int) (((long) 2)));
					{	/* Dataflow/walk.scm 36 */
						obj_t BgL_arg1583z00_1774;

						BgL_arg1583z00_1774 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									5)), BGl_proc2095z00zzdataflow_walkz00,
							BGl_proc2094z00zzdataflow_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, BGl_nodez00zzast_nodez00);
						VECTOR_SET(BgL_v1357z00_1773, (int) (((long) 1)),
							BgL_arg1583z00_1774);
					}
					{	/* Dataflow/walk.scm 36 */
						obj_t BgL_arg1595z00_1784;

						BgL_arg1595z00_1784 =
							BGl_makezd2classzd2fieldz00zz__objectz00(CNST_TABLE_REF(((long)
									6)), BGl_proc2097z00zzdataflow_walkz00,
							BGl_proc2096z00zzdataflow_walkz00, ((bool_t) 1), ((bool_t) 0),
							BFALSE, BFALSE, CNST_TABLE_REF(((long) 7)));
						VECTOR_SET(BgL_v1357z00_1773, (int) (((long) 0)),
							BgL_arg1595z00_1784);
					}
					BgL_arg1549z00_1738 = BgL_v1357z00_1773;
				}
				{	/* Dataflow/walk.scm 36 */
					obj_t BgL_v1358z00_1794;

					BgL_v1358z00_1794 = create_vector((int) (((long) 0)));
					BgL_arg1552z00_1739 = BgL_v1358z00_1794;
				}
				return (BGl_localzf2valuezf2zzdataflow_walkz00 =
					BGl_registerzd2classz12zc0zz__objectz00(CNST_TABLE_REF(((long) 8)),
						CNST_TABLE_REF(((long) 9)), BGl_localz00zzast_varz00,
						((long) 51723), BGl_proc2101z00zzdataflow_walkz00,
						BGl_proc2100z00zzdataflow_walkz00, BFALSE,
						BGl_proc2099z00zzdataflow_walkz00,
						BGl_proc2098z00zzdataflow_walkz00, BgL_arg1549z00_1738,
						BgL_arg1552z00_1739), BUNSPEC);
		}}
	}



/* &lambda1571 */
	BgL_localz00_bglt BGl_z62lambda1571z62zzdataflow_walkz00(obj_t
		BgL_envz00_3023, obj_t BgL_o1118z00_3024)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				BgL_localz00_bglt BgL_o1118z00_1767;

				BgL_o1118z00_1767 = ((BgL_localz00_bglt) BgL_o1118z00_3024);
				{	/* Dataflow/walk.scm 36 */
					long BgL_arg1572z00_1770;

					{	/* Dataflow/walk.scm 36 */
						obj_t BgL_arg1576z00_1771;

						{	/* Dataflow/walk.scm 36 */
							obj_t BgL_arg1582z00_1772;

							{	/* Dataflow/walk.scm 36 */
								long BgL_arg1667z00_2625;

								{	/* Dataflow/walk.scm 36 */
									long BgL_arg1668z00_2626;

									{	/* Dataflow/walk.scm 36 */
										long BgL_res2004z00_2628;

										BgL_res2004z00_2628 =
											BGL_OBJECT_CLASS_NUM(
											((BgL_objectz00_bglt) BgL_o1118z00_1767));
										BgL_arg1668z00_2626 = BgL_res2004z00_2628;
									}
									BgL_arg1667z00_2625 = (BgL_arg1668z00_2626 - OBJECT_TYPE);
								}
								BgL_arg1582z00_1772 =
									VECTOR_REF(BGl_za2classesza2z00zz__objectz00,
									(int) (BgL_arg1667z00_2625));
							}
							BgL_arg1576z00_1771 =
								BGl_classzd2superzd2zz__objectz00(BgL_arg1582z00_1772);
						}
						{	/* Dataflow/walk.scm 36 */
							long BgL_res2006z00_2635;

							BgL_res2006z00_2635 = BGL_CLASS_INDEX(BgL_arg1576z00_1771);
							BgL_arg1572z00_1770 = BgL_res2006z00_2635;
					}}
					BGL_OBJECT_CLASS_NUM_SET(
						((BgL_objectz00_bglt) BgL_o1118z00_1767), BgL_arg1572z00_1770);
				}
				{	/* Dataflow/walk.scm 36 */
					BgL_objectz00_bglt BgL_auxz00_3395;

					BgL_auxz00_3395 = ((BgL_objectz00_bglt) BgL_o1118z00_1767);
					BGL_OBJECT_WIDENING_SET(BgL_auxz00_3395, BFALSE);
				}
				return ((BgL_localz00_bglt) BgL_o1118z00_1767);
			}
		}
	}



/* &<anonymous:1570> */
	BgL_localz00_bglt BGl_z62zc3anonymousza31570ze3ze1zzdataflow_walkz00(obj_t
		BgL_envz00_3025, obj_t BgL_new1117z00_3026)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				BgL_localz00_bglt BgL_new1117z00_1765;

				BgL_new1117z00_1765 = ((BgL_localz00_bglt) BgL_new1117z00_3026);
				((((BgL_variablez00_bglt) CREF(
								((BgL_variablez00_bglt) BgL_new1117z00_1765)))->BgL_idz00) =
					((obj_t) CNST_TABLE_REF(((long) 10))), BUNSPEC);
				((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
									BgL_new1117z00_1765)))->BgL_namez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				{
					BgL_typez00_bglt BgL_auxz00_3405;

					{	/* Dataflow/walk.scm 36 */
						obj_t BgL_classz00_2618;

						BgL_classz00_2618 = BGl_typez00zztype_typez00;
						{	/* Dataflow/walk.scm 36 */
							obj_t BgL__ortest_1101z00_2619;

							BgL__ortest_1101z00_2619 = BGL_CLASS_NIL(BgL_classz00_2618);
							if (CBOOL(BgL__ortest_1101z00_2619))
								{	/* Dataflow/walk.scm 36 */
									BgL_auxz00_3405 =
										((BgL_typez00_bglt) BgL__ortest_1101z00_2619);
								}
							else
								{	/* Dataflow/walk.scm 36 */
									BgL_auxz00_3405 =
										((BgL_typez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2618));
								}
						}
					}
					((((BgL_variablez00_bglt) CREF(
									((BgL_variablez00_bglt) BgL_new1117z00_1765)))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_auxz00_3405), BUNSPEC);
				}
				{
					BgL_valuez00_bglt BgL_auxz00_3414;

					{	/* Dataflow/walk.scm 36 */
						obj_t BgL_classz00_2620;

						BgL_classz00_2620 = BGl_valuez00zzast_varz00;
						{	/* Dataflow/walk.scm 36 */
							obj_t BgL__ortest_1101z00_2621;

							BgL__ortest_1101z00_2621 = BGL_CLASS_NIL(BgL_classz00_2620);
							if (CBOOL(BgL__ortest_1101z00_2621))
								{	/* Dataflow/walk.scm 36 */
									BgL_auxz00_3414 =
										((BgL_valuez00_bglt) BgL__ortest_1101z00_2621);
								}
							else
								{	/* Dataflow/walk.scm 36 */
									BgL_auxz00_3414 =
										((BgL_valuez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2620));
								}
						}
					}
					((((BgL_variablez00_bglt) CREF(
									((BgL_variablez00_bglt) BgL_new1117z00_1765)))->
							BgL_valuez00) = ((BgL_valuez00_bglt) BgL_auxz00_3414), BUNSPEC);
				}
				((((BgL_variablez00_bglt) CREF(
								((BgL_variablez00_bglt) BgL_new1117z00_1765)))->BgL_accessz00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
									BgL_new1117z00_1765)))->BgL_fastzd2alphazd2) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
									BgL_new1117z00_1765)))->BgL_removablez00) =
					((obj_t) BUNSPEC), BUNSPEC);
				((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
									BgL_new1117z00_1765)))->BgL_occurrencez00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
									BgL_new1117z00_1765)))->BgL_occurrencewz00) =
					((long) ((long) 0)), BUNSPEC);
				((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
									BgL_new1117z00_1765)))->BgL_userzf3zf3) =
					((bool_t) ((bool_t) 0)), BUNSPEC);
				((((BgL_localz00_bglt) CREF(((BgL_localz00_bglt)
									BgL_new1117z00_1765)))->BgL_keyz00) =
					((long) ((long) 0)), BUNSPEC);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_3437;

					{
						obj_t BgL_auxz00_3438;

						{	/* Dataflow/walk.scm 36 */
							BgL_objectz00_bglt BgL_auxz00_3439;

							BgL_auxz00_3439 = ((BgL_objectz00_bglt) BgL_new1117z00_1765);
							BgL_auxz00_3438 = BGL_OBJECT_WIDENING(BgL_auxz00_3439);
						}
						BgL_auxz00_3437 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3438);
					}
					((((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3437))->BgL_stampz00) =
						((int) (int) (((long) 0))), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3451;
					BgL_localzf2valuezf2_bglt BgL_auxz00_3445;

					{	/* Dataflow/walk.scm 36 */
						obj_t BgL_classz00_2622;

						BgL_classz00_2622 = BGl_nodez00zzast_nodez00;
						{	/* Dataflow/walk.scm 36 */
							obj_t BgL__ortest_1101z00_2623;

							BgL__ortest_1101z00_2623 = BGL_CLASS_NIL(BgL_classz00_2622);
							if (CBOOL(BgL__ortest_1101z00_2623))
								{	/* Dataflow/walk.scm 36 */
									BgL_auxz00_3451 =
										((BgL_nodez00_bglt) BgL__ortest_1101z00_2623);
								}
							else
								{	/* Dataflow/walk.scm 36 */
									BgL_auxz00_3451 =
										((BgL_nodez00_bglt)
										BGl_classzd2nilzd2initz12z12zz__objectz00
										(BgL_classz00_2622));
								}
						}
					}
					{
						obj_t BgL_auxz00_3446;

						{	/* Dataflow/walk.scm 36 */
							BgL_objectz00_bglt BgL_auxz00_3447;

							BgL_auxz00_3447 = ((BgL_objectz00_bglt) BgL_new1117z00_1765);
							BgL_auxz00_3446 = BGL_OBJECT_WIDENING(BgL_auxz00_3447);
						}
						BgL_auxz00_3445 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3446);
					}
					((((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3445))->BgL_nodez00) =
						((BgL_nodez00_bglt) BgL_auxz00_3451), BUNSPEC);
				}
				return BgL_new1117z00_1765;
			}
		}
	}



/* &lambda1558 */
	BgL_localz00_bglt BGl_z62lambda1558z62zzdataflow_walkz00(obj_t
		BgL_envz00_3027, obj_t BgL_o1114z00_3028)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				BgL_localz00_bglt BgL_o1114z00_1760;

				BgL_o1114z00_1760 = ((BgL_localz00_bglt) BgL_o1114z00_3028);
				{	/* Dataflow/walk.scm 36 */
					BgL_localzf2valuezf2_bglt BgL_wide1116z00_1763;

					BgL_wide1116z00_1763 =
						((BgL_localzf2valuezf2_bglt) BREF(GC_MALLOC(sizeof(struct
									BgL_localzf2valuezf2_bgl))));
					{	/* Dataflow/walk.scm 36 */
						obj_t BgL_auxz00_3464;
						BgL_objectz00_bglt BgL_auxz00_3461;

						BgL_auxz00_3464 = ((obj_t) BgL_wide1116z00_1763);
						BgL_auxz00_3461 =
							((BgL_objectz00_bglt) ((BgL_localz00_bglt) BgL_o1114z00_1760));
						BGL_OBJECT_WIDENING_SET(BgL_auxz00_3461, BgL_auxz00_3464);
					}
					{	/* Dataflow/walk.scm 36 */
						long BgL_arg1569z00_1764;

						{	/* Dataflow/walk.scm 36 */
							long BgL_res2003z00_2615;

							BgL_res2003z00_2615 =
								BGL_CLASS_INDEX(BGl_localzf2valuezf2zzdataflow_walkz00);
							BgL_arg1569z00_1764 = BgL_res2003z00_2615;
						}
						((BgL_localz00_bglt)
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt)
									((BgL_localz00_bglt) BgL_o1114z00_1760)),
								BgL_arg1569z00_1764));
					}
					return ((BgL_localz00_bglt) ((BgL_localz00_bglt) BgL_o1114z00_1760));
				}
			}
		}
	}



/* &lambda1553 */
	BgL_localz00_bglt BGl_z62lambda1553z62zzdataflow_walkz00(obj_t
		BgL_envz00_3029, obj_t BgL_id1101z00_3030, obj_t BgL_name1102z00_3031,
		obj_t BgL_type1103z00_3032, obj_t BgL_value1104z00_3033,
		obj_t BgL_access1105z00_3034, obj_t BgL_fastzd2alpha1106zd2_3035,
		obj_t BgL_removable1107z00_3036, obj_t BgL_occurrence1108z00_3037,
		obj_t BgL_occurrencew1109z00_3038, obj_t BgL_userzf31110zf3_3039,
		obj_t BgL_key1111z00_3040, obj_t BgL_stamp1112z00_3041,
		obj_t BgL_node1113z00_3042)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				obj_t BgL_id1101z00_1740;
				obj_t BgL_name1102z00_1741;
				BgL_typez00_bglt BgL_type1103z00_1742;
				BgL_valuez00_bglt BgL_value1104z00_1743;
				obj_t BgL_access1105z00_1744;
				obj_t BgL_fastzd2alpha1106zd2_1745;
				obj_t BgL_removable1107z00_1746;
				long BgL_occurrence1108z00_1747;
				long BgL_occurrencew1109z00_1748;
				bool_t BgL_userzf31110zf3_1749;
				long BgL_key1111z00_1750;
				int BgL_stamp1112z00_1751;
				BgL_nodez00_bglt BgL_node1113z00_1752;

				BgL_id1101z00_1740 = BgL_id1101z00_3030;
				BgL_name1102z00_1741 = BgL_name1102z00_3031;
				BgL_type1103z00_1742 = ((BgL_typez00_bglt) BgL_type1103z00_3032);
				BgL_value1104z00_1743 = ((BgL_valuez00_bglt) BgL_value1104z00_3033);
				BgL_access1105z00_1744 = BgL_access1105z00_3034;
				BgL_fastzd2alpha1106zd2_1745 = BgL_fastzd2alpha1106zd2_3035;
				BgL_removable1107z00_1746 = BgL_removable1107z00_3036;
				BgL_occurrence1108z00_1747 = (long) CINT(BgL_occurrence1108z00_3037);
				BgL_occurrencew1109z00_1748 = (long) CINT(BgL_occurrencew1109z00_3038);
				BgL_userzf31110zf3_1749 = CBOOL(BgL_userzf31110zf3_3039);
				BgL_key1111z00_1750 = (long) CINT(BgL_key1111z00_3040);
				BgL_stamp1112z00_1751 = CINT(BgL_stamp1112z00_3041);
				BgL_node1113z00_1752 = ((BgL_nodez00_bglt) BgL_node1113z00_3042);
				{	/* Dataflow/walk.scm 36 */
					BgL_localz00_bglt BgL_new1194z00_1754;

					{	/* Dataflow/walk.scm 36 */
						BgL_localz00_bglt BgL_tmp1192z00_1755;
						BgL_localzf2valuezf2_bglt BgL_wide1193z00_1756;

						{
							BgL_localz00_bglt BgL_auxz00_3475;

							{	/* Dataflow/walk.scm 36 */
								BgL_localz00_bglt BgL_new1191z00_1758;

								BgL_new1191z00_1758 =
									((BgL_localz00_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_localz00_bgl))));
								{	/* Dataflow/walk.scm 36 */
									long BgL_arg1557z00_1759;

									{	/* Dataflow/walk.scm 36 */
										long BgL_res2001z00_2607;

										BgL_res2001z00_2607 =
											BGL_CLASS_INDEX(BGl_localz00zzast_varz00);
										BgL_arg1557z00_1759 = BgL_res2001z00_2607;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1191z00_1758),
										BgL_arg1557z00_1759);
								}
								{	/* Dataflow/walk.scm 36 */
									BgL_objectz00_bglt BgL_auxz00_3480;

									BgL_auxz00_3480 = ((BgL_objectz00_bglt) BgL_new1191z00_1758);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_3480, BFALSE);
								}
								BgL_auxz00_3475 = BgL_new1191z00_1758;
							}
							BgL_tmp1192z00_1755 = ((BgL_localz00_bglt) BgL_auxz00_3475);
						}
						BgL_wide1193z00_1756 =
							((BgL_localzf2valuezf2_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_localzf2valuezf2_bgl))));
						{	/* Dataflow/walk.scm 36 */
							obj_t BgL_auxz00_3487;
							BgL_objectz00_bglt BgL_auxz00_3485;

							BgL_auxz00_3487 = ((obj_t) BgL_wide1193z00_1756);
							BgL_auxz00_3485 = ((BgL_objectz00_bglt) BgL_tmp1192z00_1755);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_3485, BgL_auxz00_3487);
						}
						{	/* Dataflow/walk.scm 36 */
							long BgL_arg1555z00_1757;

							{	/* Dataflow/walk.scm 36 */
								long BgL_res2002z00_2611;

								BgL_res2002z00_2611 =
									BGL_CLASS_INDEX(BGl_localzf2valuezf2zzdataflow_walkz00);
								BgL_arg1555z00_1757 = BgL_res2002z00_2611;
							}
							((BgL_localz00_bglt)
								BGL_OBJECT_CLASS_NUM_SET(
									((BgL_objectz00_bglt) BgL_tmp1192z00_1755),
									BgL_arg1555z00_1757));
						}
						BgL_new1194z00_1754 = ((BgL_localz00_bglt) BgL_tmp1192z00_1755);
					}
					((((BgL_variablez00_bglt) CREF(
									((BgL_variablez00_bglt) BgL_new1194z00_1754)))->BgL_idz00) =
						((obj_t) BgL_id1101z00_1740), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_namez00) =
						((obj_t) BgL_name1102z00_1741), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_typez00) =
						((BgL_typez00_bglt) BgL_type1103z00_1742), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_valuez00) =
						((BgL_valuez00_bglt) BgL_value1104z00_1743), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_accessz00) =
						((obj_t) BgL_access1105z00_1744), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_fastzd2alphazd2) =
						((obj_t) BgL_fastzd2alpha1106zd2_1745), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_removablez00) =
						((obj_t) BgL_removable1107z00_1746), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_occurrencez00) =
						((long) BgL_occurrence1108z00_1747), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_occurrencewz00) =
						((long) BgL_occurrencew1109z00_1748), BUNSPEC);
					((((BgL_variablez00_bglt) CREF(((BgL_variablez00_bglt)
										BgL_new1194z00_1754)))->BgL_userzf3zf3) =
						((bool_t) BgL_userzf31110zf3_1749), BUNSPEC);
					((((BgL_localz00_bglt) CREF(((BgL_localz00_bglt)
										BgL_new1194z00_1754)))->BgL_keyz00) =
						((long) BgL_key1111z00_1750), BUNSPEC);
					{
						BgL_localzf2valuezf2_bglt BgL_auxz00_3517;

						{
							obj_t BgL_auxz00_3518;

							{	/* Dataflow/walk.scm 36 */
								BgL_objectz00_bglt BgL_auxz00_3519;

								BgL_auxz00_3519 = ((BgL_objectz00_bglt) BgL_new1194z00_1754);
								BgL_auxz00_3518 = BGL_OBJECT_WIDENING(BgL_auxz00_3519);
							}
							BgL_auxz00_3517 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3518);
						}
						((((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3517))->
								BgL_stampz00) = ((int) BgL_stamp1112z00_1751), BUNSPEC);
					}
					{
						BgL_localzf2valuezf2_bglt BgL_auxz00_3524;

						{
							obj_t BgL_auxz00_3525;

							{	/* Dataflow/walk.scm 36 */
								BgL_objectz00_bglt BgL_auxz00_3526;

								BgL_auxz00_3526 = ((BgL_objectz00_bglt) BgL_new1194z00_1754);
								BgL_auxz00_3525 = BGL_OBJECT_WIDENING(BgL_auxz00_3526);
							}
							BgL_auxz00_3524 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3525);
						}
						((((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3524))->
								BgL_nodez00) =
							((BgL_nodez00_bglt) BgL_node1113z00_1752), BUNSPEC);
					}
					return BgL_new1194z00_1754;
				}
			}
		}
	}



/* &lambda1612 */
	obj_t BGl_z62lambda1612z62zzdataflow_walkz00(obj_t BgL_envz00_3043,
		obj_t BgL_oz00_3044, obj_t BgL_vz00_3045)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				BgL_localz00_bglt BgL_oz00_1789;
				int BgL_vz00_1790;

				BgL_oz00_1789 = ((BgL_localz00_bglt) BgL_oz00_3044);
				BgL_vz00_1790 = CINT(BgL_vz00_3045);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_3539;

					{
						obj_t BgL_auxz00_3540;

						{	/* Dataflow/walk.scm 36 */
							BgL_objectz00_bglt BgL_auxz00_3541;

							BgL_auxz00_3541 = ((BgL_objectz00_bglt) BgL_oz00_1789);
							BgL_auxz00_3540 = BGL_OBJECT_WIDENING(BgL_auxz00_3541);
						}
						BgL_auxz00_3539 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3540);
					}
					return
						((((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3539))->
							BgL_stampz00) = ((int) BgL_vz00_1790), BUNSPEC);
		}}}
	}



/* &lambda1611 */
	obj_t BGl_z62lambda1611z62zzdataflow_walkz00(obj_t BgL_envz00_3046,
		obj_t BgL_oz00_3047)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				BgL_localz00_bglt BgL_oz00_1787;

				{	/* Dataflow/walk.scm 36 */
					int BgL_auxz00_3548;

					BgL_oz00_1787 = ((BgL_localz00_bglt) BgL_oz00_3047);
					{
						BgL_localzf2valuezf2_bglt BgL_auxz00_3549;

						{
							obj_t BgL_auxz00_3550;

							{	/* Dataflow/walk.scm 36 */
								BgL_objectz00_bglt BgL_auxz00_3551;

								BgL_auxz00_3551 = ((BgL_objectz00_bglt) BgL_oz00_1787);
								BgL_auxz00_3550 = BGL_OBJECT_WIDENING(BgL_auxz00_3551);
							}
							BgL_auxz00_3549 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3550);
						}
						BgL_auxz00_3548 =
							(((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3549))->
							BgL_stampz00);
					}
					return BINT(BgL_auxz00_3548);
				}
			}
		}
	}



/* &lambda1593 */
	obj_t BGl_z62lambda1593z62zzdataflow_walkz00(obj_t BgL_envz00_3048,
		obj_t BgL_oz00_3049, obj_t BgL_vz00_3050)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				BgL_localz00_bglt BgL_oz00_1779;
				BgL_nodez00_bglt BgL_vz00_1780;

				BgL_oz00_1779 = ((BgL_localz00_bglt) BgL_oz00_3049);
				BgL_vz00_1780 = ((BgL_nodez00_bglt) BgL_vz00_3050);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_3558;

					{
						obj_t BgL_auxz00_3559;

						{	/* Dataflow/walk.scm 36 */
							BgL_objectz00_bglt BgL_auxz00_3560;

							BgL_auxz00_3560 = ((BgL_objectz00_bglt) BgL_oz00_1779);
							BgL_auxz00_3559 = BGL_OBJECT_WIDENING(BgL_auxz00_3560);
						}
						BgL_auxz00_3558 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3559);
					}
					return
						((((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3558))->
							BgL_nodez00) = ((BgL_nodez00_bglt) BgL_vz00_1780), BUNSPEC);
				}
			}
		}
	}



/* &lambda1592 */
	BgL_nodez00_bglt BGl_z62lambda1592z62zzdataflow_walkz00(obj_t BgL_envz00_3051,
		obj_t BgL_oz00_3052)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 36 */
			{
				BgL_localz00_bglt BgL_oz00_1777;

				BgL_oz00_1777 = ((BgL_localz00_bglt) BgL_oz00_3052);
				{
					BgL_localzf2valuezf2_bglt BgL_auxz00_3567;

					{
						obj_t BgL_auxz00_3568;

						{	/* Dataflow/walk.scm 36 */
							BgL_objectz00_bglt BgL_auxz00_3569;

							BgL_auxz00_3569 = ((BgL_objectz00_bglt) BgL_oz00_1777);
							BgL_auxz00_3568 = BGL_OBJECT_WIDENING(BgL_auxz00_3569);
						}
						BgL_auxz00_3567 = ((BgL_localzf2valuezf2_bglt) BgL_auxz00_3568);
					}
					return
						(((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3567))->BgL_nodez00);
				}
			}
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zzdataflow_walkz00()
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 17 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_proc2102z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2103z00zzdataflow_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_proc2104z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2105z00zzdataflow_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
				BGl_proc2106z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2107z00zzdataflow_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00,
				BGl_proc2108z00zzdataflow_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2109z00zzdataflow_walkz00);
		}
	}



/* &abort?1423 */
	obj_t BGl_z62abortzf31423z91zzdataflow_walkz00(obj_t BgL_envz00_3057,
		obj_t BgL_nodez00_3058)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 427 */
			return BBOOL(((bool_t) 0));
		}
	}



/* &dataflow-test-false-1418 */
	obj_t BGl_z62dataflowzd2testzd2falsezd21418zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3059, obj_t BgL_nodez00_3060)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 399 */
			return BNIL;
		}
	}



/* &dataflow-test-env1401 */
	obj_t BGl_z62dataflowzd2testzd2env1401z62zzdataflow_walkz00(obj_t
		BgL_envz00_3061, obj_t BgL_nodez00_3062)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 313 */
			return BNIL;
		}
	}



/* &dataflow-node!1359 */
	obj_t BGl_z62dataflowzd2nodez121359za2zzdataflow_walkz00(obj_t
		BgL_envz00_3063, obj_t BgL_nodez00_3064, obj_t BgL_envz00_3065)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 68 */
			return BgL_envz00_3065;
		}
	}



/* dataflow-node! */
	obj_t BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_59, obj_t BgL_envz00_60)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 68 */
			{	/* Dataflow/walk.scm 68 */
				obj_t BgL_method1360z00_1816;

				{	/* Dataflow/walk.scm 68 */
					obj_t BgL_res2013z00_2666;

					{	/* Dataflow/walk.scm 68 */
						long BgL_objzd2classzd2numz00_2639;

						{	/* Dataflow/walk.scm 68 */
							long BgL_res2007z00_2642;

							BgL_res2007z00_2642 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_59));
							BgL_objzd2classzd2numz00_2639 = BgL_res2007z00_2642;
						}
						{	/* Dataflow/walk.scm 68 */
							obj_t BgL_arg1664z00_2640;

							BgL_arg1664z00_2640 =
								PROCEDURE_REF(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 68 */
								int BgL_offsetz00_2644;

								BgL_offsetz00_2644 = (int) (BgL_objzd2classzd2numz00_2639);
								{	/* Dataflow/walk.scm 68 */
									long BgL_offsetz00_2645;

									BgL_offsetz00_2645 =
										((long) (BgL_offsetz00_2644) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 68 */
										long BgL_modz00_2646;

										{	/* Dataflow/walk.scm 68 */
											int BgL_arg1666z00_2647;

											BgL_arg1666z00_2647 = (int) (((long) 16));
											{	/* Dataflow/walk.scm 68 */
												long BgL_res2010z00_2657;

												{	/* Dataflow/walk.scm 68 */
													long BgL_auxz00_3588;

													BgL_auxz00_3588 = (long) (BgL_arg1666z00_2647);
													BgL_res2010z00_2657 =
														(BgL_offsetz00_2645 / BgL_auxz00_3588);
												}
												BgL_modz00_2646 = BgL_res2010z00_2657;
										}}
										{	/* Dataflow/walk.scm 68 */
											long BgL_restz00_2648;

											{	/* Dataflow/walk.scm 68 */
												int BgL_arg1665z00_2649;

												BgL_arg1665z00_2649 = (int) (((long) 16));
												{	/* Dataflow/walk.scm 68 */
													long BgL_res2012z00_2661;

													{	/* Dataflow/walk.scm 68 */
														long BgL_auxz00_3592;

														BgL_auxz00_3592 = (long) (BgL_arg1665z00_2649);
														BgL_res2012z00_2661 =
															(BgL_offsetz00_2645 % BgL_auxz00_3592);
													}
													BgL_restz00_2648 = BgL_res2012z00_2661;
											}}
											{	/* Dataflow/walk.scm 68 */

												BgL_res2013z00_2666 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2640,
														(int) (BgL_modz00_2646)), (int) (BgL_restz00_2648));
					}}}}}}}
					BgL_method1360z00_1816 = BgL_res2013z00_2666;
				}
				return
					PROCEDURE_ENTRY(BgL_method1360z00_1816) (BgL_method1360z00_1816,
					((obj_t) BgL_nodez00_59), BgL_envz00_60, BEOA);
			}
		}
	}



/* &dataflow-node! */
	obj_t BGl_z62dataflowzd2nodez12za2zzdataflow_walkz00(obj_t BgL_envz00_3066,
		obj_t BgL_nodez00_3067, obj_t BgL_envz00_3068)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 68 */
			return
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3067), BgL_envz00_3068);
		}
	}



/* dataflow-test-env */
	obj_t BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_101)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 313 */
			{	/* Dataflow/walk.scm 313 */
				obj_t BgL_method1404z00_1817;

				{	/* Dataflow/walk.scm 313 */
					obj_t BgL_res2020z00_2695;

					{	/* Dataflow/walk.scm 313 */
						long BgL_objzd2classzd2numz00_2668;

						{	/* Dataflow/walk.scm 313 */
							long BgL_res2014z00_2671;

							BgL_res2014z00_2671 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_101));
							BgL_objzd2classzd2numz00_2668 = BgL_res2014z00_2671;
						}
						{	/* Dataflow/walk.scm 313 */
							obj_t BgL_arg1664z00_2669;

							BgL_arg1664z00_2669 =
								PROCEDURE_REF
								(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 313 */
								int BgL_offsetz00_2673;

								BgL_offsetz00_2673 = (int) (BgL_objzd2classzd2numz00_2668);
								{	/* Dataflow/walk.scm 313 */
									long BgL_offsetz00_2674;

									BgL_offsetz00_2674 =
										((long) (BgL_offsetz00_2673) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 313 */
										long BgL_modz00_2675;

										{	/* Dataflow/walk.scm 313 */
											int BgL_arg1666z00_2676;

											BgL_arg1666z00_2676 = (int) (((long) 16));
											{	/* Dataflow/walk.scm 313 */
												long BgL_res2017z00_2686;

												{	/* Dataflow/walk.scm 313 */
													long BgL_auxz00_3615;

													BgL_auxz00_3615 = (long) (BgL_arg1666z00_2676);
													BgL_res2017z00_2686 =
														(BgL_offsetz00_2674 / BgL_auxz00_3615);
												}
												BgL_modz00_2675 = BgL_res2017z00_2686;
										}}
										{	/* Dataflow/walk.scm 313 */
											long BgL_restz00_2677;

											{	/* Dataflow/walk.scm 313 */
												int BgL_arg1665z00_2678;

												BgL_arg1665z00_2678 = (int) (((long) 16));
												{	/* Dataflow/walk.scm 313 */
													long BgL_res2019z00_2690;

													{	/* Dataflow/walk.scm 313 */
														long BgL_auxz00_3619;

														BgL_auxz00_3619 = (long) (BgL_arg1665z00_2678);
														BgL_res2019z00_2690 =
															(BgL_offsetz00_2674 % BgL_auxz00_3619);
													}
													BgL_restz00_2677 = BgL_res2019z00_2690;
											}}
											{	/* Dataflow/walk.scm 313 */

												BgL_res2020z00_2695 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2669,
														(int) (BgL_modz00_2675)), (int) (BgL_restz00_2677));
					}}}}}}}
					BgL_method1404z00_1817 = BgL_res2020z00_2695;
				}
				return
					PROCEDURE_ENTRY(BgL_method1404z00_1817) (BgL_method1404z00_1817,
					((obj_t) BgL_nodez00_101), BEOA);
			}
		}
	}



/* &dataflow-test-env */
	obj_t BGl_z62dataflowzd2testzd2envz62zzdataflow_walkz00(obj_t BgL_envz00_3069,
		obj_t BgL_nodez00_3070)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 313 */
			return
				BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3070));
		}
	}



/* dataflow-test-false-env */
	obj_t BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(BgL_nodez00_bglt
		BgL_nodez00_107)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 399 */
			{	/* Dataflow/walk.scm 399 */
				obj_t BgL_method1420z00_1818;

				{	/* Dataflow/walk.scm 399 */
					obj_t BgL_res2027z00_2724;

					{	/* Dataflow/walk.scm 399 */
						long BgL_objzd2classzd2numz00_2697;

						{	/* Dataflow/walk.scm 399 */
							long BgL_res2021z00_2700;

							BgL_res2021z00_2700 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_107));
							BgL_objzd2classzd2numz00_2697 = BgL_res2021z00_2700;
						}
						{	/* Dataflow/walk.scm 399 */
							obj_t BgL_arg1664z00_2698;

							BgL_arg1664z00_2698 =
								PROCEDURE_REF
								(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 399 */
								int BgL_offsetz00_2702;

								BgL_offsetz00_2702 = (int) (BgL_objzd2classzd2numz00_2697);
								{	/* Dataflow/walk.scm 399 */
									long BgL_offsetz00_2703;

									BgL_offsetz00_2703 =
										((long) (BgL_offsetz00_2702) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 399 */
										long BgL_modz00_2704;

										{	/* Dataflow/walk.scm 399 */
											int BgL_arg1666z00_2705;

											BgL_arg1666z00_2705 = (int) (((long) 16));
											{	/* Dataflow/walk.scm 399 */
												long BgL_res2024z00_2715;

												{	/* Dataflow/walk.scm 399 */
													long BgL_auxz00_3641;

													BgL_auxz00_3641 = (long) (BgL_arg1666z00_2705);
													BgL_res2024z00_2715 =
														(BgL_offsetz00_2703 / BgL_auxz00_3641);
												}
												BgL_modz00_2704 = BgL_res2024z00_2715;
										}}
										{	/* Dataflow/walk.scm 399 */
											long BgL_restz00_2706;

											{	/* Dataflow/walk.scm 399 */
												int BgL_arg1665z00_2707;

												BgL_arg1665z00_2707 = (int) (((long) 16));
												{	/* Dataflow/walk.scm 399 */
													long BgL_res2026z00_2719;

													{	/* Dataflow/walk.scm 399 */
														long BgL_auxz00_3645;

														BgL_auxz00_3645 = (long) (BgL_arg1665z00_2707);
														BgL_res2026z00_2719 =
															(BgL_offsetz00_2703 % BgL_auxz00_3645);
													}
													BgL_restz00_2706 = BgL_res2026z00_2719;
											}}
											{	/* Dataflow/walk.scm 399 */

												BgL_res2027z00_2724 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2698,
														(int) (BgL_modz00_2704)), (int) (BgL_restz00_2706));
					}}}}}}}
					BgL_method1420z00_1818 = BgL_res2027z00_2724;
				}
				return
					PROCEDURE_ENTRY(BgL_method1420z00_1818) (BgL_method1420z00_1818,
					((obj_t) BgL_nodez00_107), BEOA);
			}
		}
	}



/* &dataflow-test-false-env */
	obj_t BGl_z62dataflowzd2testzd2falsezd2envzb0zzdataflow_walkz00(obj_t
		BgL_envz00_3071, obj_t BgL_nodez00_3072)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 399 */
			return
				BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3072));
		}
	}



/* abort? */
	obj_t BGl_abortzf3zf3zzdataflow_walkz00(BgL_nodez00_bglt BgL_nodez00_109)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 427 */
			{	/* Dataflow/walk.scm 427 */
				obj_t BgL_method1424z00_1819;

				{	/* Dataflow/walk.scm 427 */
					obj_t BgL_res2034z00_2753;

					{	/* Dataflow/walk.scm 427 */
						long BgL_objzd2classzd2numz00_2726;

						{	/* Dataflow/walk.scm 427 */
							long BgL_res2028z00_2729;

							BgL_res2028z00_2729 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_109));
							BgL_objzd2classzd2numz00_2726 = BgL_res2028z00_2729;
						}
						{	/* Dataflow/walk.scm 427 */
							obj_t BgL_arg1664z00_2727;

							BgL_arg1664z00_2727 =
								PROCEDURE_REF(BGl_abortzf3zd2envz21zzdataflow_walkz00,
								(int) (((long) 1)));
							{	/* Dataflow/walk.scm 427 */
								int BgL_offsetz00_2731;

								BgL_offsetz00_2731 = (int) (BgL_objzd2classzd2numz00_2726);
								{	/* Dataflow/walk.scm 427 */
									long BgL_offsetz00_2732;

									BgL_offsetz00_2732 =
										((long) (BgL_offsetz00_2731) - OBJECT_TYPE);
									{	/* Dataflow/walk.scm 427 */
										long BgL_modz00_2733;

										{	/* Dataflow/walk.scm 427 */
											int BgL_arg1666z00_2734;

											BgL_arg1666z00_2734 = (int) (((long) 16));
											{	/* Dataflow/walk.scm 427 */
												long BgL_res2031z00_2744;

												{	/* Dataflow/walk.scm 427 */
													long BgL_auxz00_3667;

													BgL_auxz00_3667 = (long) (BgL_arg1666z00_2734);
													BgL_res2031z00_2744 =
														(BgL_offsetz00_2732 / BgL_auxz00_3667);
												}
												BgL_modz00_2733 = BgL_res2031z00_2744;
										}}
										{	/* Dataflow/walk.scm 427 */
											long BgL_restz00_2735;

											{	/* Dataflow/walk.scm 427 */
												int BgL_arg1665z00_2736;

												BgL_arg1665z00_2736 = (int) (((long) 16));
												{	/* Dataflow/walk.scm 427 */
													long BgL_res2033z00_2748;

													{	/* Dataflow/walk.scm 427 */
														long BgL_auxz00_3671;

														BgL_auxz00_3671 = (long) (BgL_arg1665z00_2736);
														BgL_res2033z00_2748 =
															(BgL_offsetz00_2732 % BgL_auxz00_3671);
													}
													BgL_restz00_2735 = BgL_res2033z00_2748;
											}}
											{	/* Dataflow/walk.scm 427 */

												BgL_res2034z00_2753 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2727,
														(int) (BgL_modz00_2733)), (int) (BgL_restz00_2735));
					}}}}}}}
					BgL_method1424z00_1819 = BgL_res2034z00_2753;
				}
				return
					PROCEDURE_ENTRY(BgL_method1424z00_1819) (BgL_method1424z00_1819,
					((obj_t) BgL_nodez00_109), BEOA);
			}
		}
	}



/* &abort? */
	obj_t BGl_z62abortzf3z91zzdataflow_walkz00(obj_t BgL_envz00_3073,
		obj_t BgL_nodez00_3074)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 427 */
			return
				BGl_abortzf3zf3zzdataflow_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_3074));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zzdataflow_walkz00()
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 17 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_varz00zzast_nodez00, BGl_proc2110z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_closurez00zzast_nodez00, BGl_proc2112z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2113z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2114z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2115z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2116z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2117z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc2118z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2119z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2120z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc2121z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_selectz00zzast_nodez00, BGl_proc2122z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2123z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2124z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2125z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2126z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2127z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2128z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2nodez12zd2envz12zzdataflow_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2129z00zzdataflow_walkz00,
				BGl_string2111z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2130z00zzdataflow_walkz00,
				BGl_string2131z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_instanceofz00zzast_nodez00, BGl_proc2132z00zzdataflow_walkz00,
				BGl_string2131z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2133z00zzdataflow_walkz00,
				BGl_string2131z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_varz00zzast_nodez00, BGl_proc2134z00zzdataflow_walkz00,
				BGl_string2131z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2envzd2envzd2zzdataflow_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2135z00zzdataflow_walkz00,
				BGl_string2131z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_dataflowzd2testzd2falsezd2envzd2envz00zzdataflow_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2136z00zzdataflow_walkz00,
				BGl_string2137z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc2138z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc2140z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc2141z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_letzd2varzd2zzast_nodez00,
				BGl_proc2142z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_letzd2funzd2zzast_nodez00,
				BGl_proc2143z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2144z00zzdataflow_walkz00,
				BGl_string2139z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2145z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2146z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_abortzf3zd2envz21zzdataflow_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc2147z00zzdataflow_walkz00, BGl_string2139z00zzdataflow_walkz00);
		}
	}



/* &abort?-app-ly1442 */
	obj_t BGl_z62abortzf3zd2appzd2ly1442z91zzdataflow_walkz00(obj_t
		BgL_envz00_3110, obj_t BgL_nodez00_3111)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 488 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_2360;

				BgL_nodez00_2360 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_3111);
				{	/* Dataflow/walk.scm 490 */
					obj_t BgL__ortest_1190z00_2364;

					BgL__ortest_1190z00_2364 =
						BGl_abortzf3zf3zzdataflow_walkz00(
						(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_2360))->BgL_funz00));
					if (CBOOL(BgL__ortest_1190z00_2364))
						{	/* Dataflow/walk.scm 490 */
							return BgL__ortest_1190z00_2364;
						}
					else
						{	/* Dataflow/walk.scm 490 */
							return
								BGl_abortzf3zf3zzdataflow_walkz00(
								(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_2360))->BgL_argz00));
						}
				}
			}
		}
	}



/* &abort?-funcall1440 */
	obj_t BGl_z62abortzf3zd2funcall1440z43zzdataflow_walkz00(obj_t
		BgL_envz00_3112, obj_t BgL_nodez00_3113)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 481 */
			{
				BgL_funcallz00_bglt BgL_nodez00_2344;

				BgL_nodez00_2344 = ((BgL_funcallz00_bglt) BgL_nodez00_3113);
				{	/* Dataflow/walk.scm 483 */
					obj_t BgL__ortest_1188z00_2348;

					BgL__ortest_1188z00_2348 =
						BGl_abortzf3zf3zzdataflow_walkz00(
						(((BgL_funcallz00_bglt) CREF(BgL_nodez00_2344))->BgL_funz00));
					if (CBOOL(BgL__ortest_1188z00_2348))
						{	/* Dataflow/walk.scm 483 */
							return BgL__ortest_1188z00_2348;
						}
					else
						{	/* Dataflow/walk.scm 483 */
							obj_t BgL_g1355z00_2349;

							BgL_g1355z00_2349 =
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_2344))->BgL_argsz00);
							{
								obj_t BgL_l1353z00_2351;

								BgL_l1353z00_2351 = BgL_g1355z00_2349;
							BgL_zc3anonymousza31911ze3z83_2352:
								if (NULLP(BgL_l1353z00_2351))
									{	/* Dataflow/walk.scm 483 */
										return BFALSE;
									}
								else
									{	/* Dataflow/walk.scm 483 */
										obj_t BgL__ortest_1356z00_2354;

										{	/* Dataflow/walk.scm 483 */
											obj_t BgL_arg1914z00_2356;

											BgL_arg1914z00_2356 = CAR(BgL_l1353z00_2351);
											BgL__ortest_1356z00_2354 =
												BGl_abortzf3zf3zzdataflow_walkz00(
												((BgL_nodez00_bglt) BgL_arg1914z00_2356));
										}
										if (CBOOL(BgL__ortest_1356z00_2354))
											{	/* Dataflow/walk.scm 483 */
												return BgL__ortest_1356z00_2354;
											}
										else
											{
												obj_t BgL_l1353z00_3738;

												BgL_l1353z00_3738 = CDR(BgL_l1353z00_2351);
												BgL_l1353z00_2351 = BgL_l1353z00_3738;
												goto BgL_zc3anonymousza31911ze3z83_2352;
											}
									}
							}
						}
				}
			}
		}
	}



/* &abort?-app1438 */
	obj_t BGl_z62abortzf3zd2app1438z43zzdataflow_walkz00(obj_t BgL_envz00_3114,
		obj_t BgL_nodez00_3115)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 474 */
			{
				BgL_appz00_bglt BgL_nodez00_2328;

				BgL_nodez00_2328 = ((BgL_appz00_bglt) BgL_nodez00_3115);
				{	/* Dataflow/walk.scm 476 */
					obj_t BgL__ortest_1186z00_2332;

					{	/* Dataflow/walk.scm 476 */
						BgL_varz00_bglt BgL_arg1910z00_2342;

						BgL_arg1910z00_2342 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_2328))->BgL_funz00);
						BgL__ortest_1186z00_2332 =
							BGl_abortzf3zf3zzdataflow_walkz00(
							((BgL_nodez00_bglt) BgL_arg1910z00_2342));
					}
					if (CBOOL(BgL__ortest_1186z00_2332))
						{	/* Dataflow/walk.scm 476 */
							return BgL__ortest_1186z00_2332;
						}
					else
						{	/* Dataflow/walk.scm 476 */
							obj_t BgL_g1351z00_2333;

							BgL_g1351z00_2333 =
								(((BgL_appz00_bglt) CREF(BgL_nodez00_2328))->BgL_argsz00);
							{
								obj_t BgL_l1349z00_2335;

								BgL_l1349z00_2335 = BgL_g1351z00_2333;
							BgL_zc3anonymousza31906ze3z83_2336:
								if (NULLP(BgL_l1349z00_2335))
									{	/* Dataflow/walk.scm 476 */
										return BFALSE;
									}
								else
									{	/* Dataflow/walk.scm 476 */
										obj_t BgL__ortest_1352z00_2338;

										{	/* Dataflow/walk.scm 476 */
											obj_t BgL_arg1909z00_2340;

											BgL_arg1909z00_2340 = CAR(BgL_l1349z00_2335);
											BgL__ortest_1352z00_2338 =
												BGl_abortzf3zf3zzdataflow_walkz00(
												((BgL_nodez00_bglt) BgL_arg1909z00_2340));
										}
										if (CBOOL(BgL__ortest_1352z00_2338))
											{	/* Dataflow/walk.scm 476 */
												return BgL__ortest_1352z00_2338;
											}
										else
											{
												obj_t BgL_l1349z00_3754;

												BgL_l1349z00_3754 = CDR(BgL_l1349z00_2335);
												BgL_l1349z00_2335 = BgL_l1349z00_3754;
												goto BgL_zc3anonymousza31906ze3z83_2336;
											}
									}
							}
						}
				}
			}
		}
	}



/* &abort?-conditional1436 */
	obj_t BGl_z62abortzf3zd2conditional1436z43zzdataflow_walkz00(obj_t
		BgL_envz00_3116, obj_t BgL_nodez00_3117)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 467 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_2318;

				BgL_nodez00_2318 = ((BgL_conditionalz00_bglt) BgL_nodez00_3117);
				{	/* Dataflow/walk.scm 469 */
					obj_t BgL__ortest_1183z00_2322;

					BgL__ortest_1183z00_2322 =
						BGl_abortzf3zf3zzdataflow_walkz00(
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2318))->BgL_testz00));
					if (CBOOL(BgL__ortest_1183z00_2322))
						{	/* Dataflow/walk.scm 469 */
							return BgL__ortest_1183z00_2322;
						}
					else
						{	/* Dataflow/walk.scm 469 */
							obj_t BgL__andtest_1184z00_2323;

							BgL__andtest_1184z00_2323 =
								BGl_abortzf3zf3zzdataflow_walkz00(
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2318))->
									BgL_truez00));
							if (CBOOL(BgL__andtest_1184z00_2323))
								{	/* Dataflow/walk.scm 469 */
									return
										BGl_abortzf3zf3zzdataflow_walkz00(
										(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2318))->
											BgL_falsez00));
								}
							else
								{	/* Dataflow/walk.scm 469 */
									return BFALSE;
								}
						}
				}
			}
		}
	}



/* &abort?-let-fun1434 */
	obj_t BGl_z62abortzf3zd2letzd2fun1434z91zzdataflow_walkz00(obj_t
		BgL_envz00_3118, obj_t BgL_nodez00_3119)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 460 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_2312;

				BgL_nodez00_2312 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_3119);
				return
					BGl_abortzf3zf3zzdataflow_walkz00(
					(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_2312))->BgL_bodyz00));
			}
		}
	}



/* &abort?-let-var1432 */
	obj_t BGl_z62abortzf3zd2letzd2var1432z91zzdataflow_walkz00(obj_t
		BgL_envz00_3120, obj_t BgL_nodez00_3121)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 453 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_2295;

				BgL_nodez00_2295 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_3121);
				{	/* Dataflow/walk.scm 455 */
					obj_t BgL__ortest_1180z00_2299;

					{	/* Dataflow/walk.scm 455 */
						obj_t BgL_g1347z00_2301;

						BgL_g1347z00_2301 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2295))->
							BgL_bindingsz00);
						{
							obj_t BgL_l1345z00_2303;

							BgL_l1345z00_2303 = BgL_g1347z00_2301;
						BgL_zc3anonymousza31898ze3z83_2304:
							if (NULLP(BgL_l1345z00_2303))
								{	/* Dataflow/walk.scm 455 */
									BgL__ortest_1180z00_2299 = BFALSE;
								}
							else
								{	/* Dataflow/walk.scm 455 */
									obj_t BgL__ortest_1348z00_2306;

									{	/* Dataflow/walk.scm 455 */
										obj_t BgL_bz00_2308;

										BgL_bz00_2308 = CAR(BgL_l1345z00_2303);
										{	/* Dataflow/walk.scm 455 */
											obj_t BgL_arg1901z00_2309;

											BgL_arg1901z00_2309 = CDR(BgL_bz00_2308);
											BgL__ortest_1348z00_2306 =
												BGl_abortzf3zf3zzdataflow_walkz00(
												((BgL_nodez00_bglt) BgL_arg1901z00_2309));
										}
									}
									if (CBOOL(BgL__ortest_1348z00_2306))
										{	/* Dataflow/walk.scm 455 */
											BgL__ortest_1180z00_2299 = BgL__ortest_1348z00_2306;
										}
									else
										{
											obj_t BgL_l1345z00_3780;

											BgL_l1345z00_3780 = CDR(BgL_l1345z00_2303);
											BgL_l1345z00_2303 = BgL_l1345z00_3780;
											goto BgL_zc3anonymousza31898ze3z83_2304;
										}
								}
						}
					}
					if (CBOOL(BgL__ortest_1180z00_2299))
						{	/* Dataflow/walk.scm 455 */
							return BgL__ortest_1180z00_2299;
						}
					else
						{	/* Dataflow/walk.scm 455 */
							return
								BGl_abortzf3zf3zzdataflow_walkz00(
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2295))->
									BgL_bodyz00));
						}
				}
			}
		}
	}



/* &abort?-sync1430 */
	obj_t BGl_z62abortzf3zd2sync1430z43zzdataflow_walkz00(obj_t BgL_envz00_3122,
		obj_t BgL_nodez00_3123)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 445 */
			{
				BgL_syncz00_bglt BgL_nodez00_2286;

				BgL_nodez00_2286 = ((BgL_syncz00_bglt) BgL_nodez00_3123);
				{	/* Dataflow/walk.scm 446 */
					obj_t BgL__ortest_1177z00_2289;

					BgL__ortest_1177z00_2289 =
						BGl_abortzf3zf3zzdataflow_walkz00(
						(((BgL_syncz00_bglt) CREF(BgL_nodez00_2286))->BgL_mutexz00));
					if (CBOOL(BgL__ortest_1177z00_2289))
						{	/* Dataflow/walk.scm 446 */
							return BgL__ortest_1177z00_2289;
						}
					else
						{	/* Dataflow/walk.scm 447 */
							obj_t BgL__ortest_1178z00_2290;

							BgL__ortest_1178z00_2290 =
								BGl_abortzf3zf3zzdataflow_walkz00(
								(((BgL_syncz00_bglt) CREF(BgL_nodez00_2286))->BgL_prelockz00));
							if (CBOOL(BgL__ortest_1178z00_2290))
								{	/* Dataflow/walk.scm 447 */
									return BgL__ortest_1178z00_2290;
								}
							else
								{	/* Dataflow/walk.scm 447 */
									return
										BGl_abortzf3zf3zzdataflow_walkz00(
										(((BgL_syncz00_bglt) CREF(BgL_nodez00_2286))->BgL_bodyz00));
								}
						}
				}
			}
		}
	}



/* &abort?-sequence1428 */
	obj_t BGl_z62abortzf3zd2sequence1428z43zzdataflow_walkz00(obj_t
		BgL_envz00_3124, obj_t BgL_nodez00_3125)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 439 */
			{
				BgL_sequencez00_bglt BgL_nodez00_2273;

				BgL_nodez00_2273 = ((BgL_sequencez00_bglt) BgL_nodez00_3125);
				{	/* Dataflow/walk.scm 440 */
					obj_t BgL_g1343z00_2276;

					BgL_g1343z00_2276 =
						(((BgL_sequencez00_bglt) CREF(BgL_nodez00_2273))->BgL_nodesz00);
					{
						obj_t BgL_l1341z00_2278;

						BgL_l1341z00_2278 = BgL_g1343z00_2276;
					BgL_zc3anonymousza31890ze3z83_2279:
						if (NULLP(BgL_l1341z00_2278))
							{	/* Dataflow/walk.scm 440 */
								return BFALSE;
							}
						else
							{	/* Dataflow/walk.scm 440 */
								obj_t BgL__ortest_1344z00_2281;

								{	/* Dataflow/walk.scm 440 */
									obj_t BgL_arg1893z00_2283;

									BgL_arg1893z00_2283 = CAR(BgL_l1341z00_2278);
									BgL__ortest_1344z00_2281 =
										BGl_abortzf3zf3zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_arg1893z00_2283));
								}
								if (CBOOL(BgL__ortest_1344z00_2281))
									{	/* Dataflow/walk.scm 440 */
										return BgL__ortest_1344z00_2281;
									}
								else
									{
										obj_t BgL_l1341z00_3806;

										BgL_l1341z00_3806 = CDR(BgL_l1341z00_2278);
										BgL_l1341z00_2278 = BgL_l1341z00_3806;
										goto BgL_zc3anonymousza31890ze3z83_2279;
									}
							}
					}
				}
			}
		}
	}



/* &abort?-fail1426 */
	obj_t BGl_z62abortzf3zd2fail1426z43zzdataflow_walkz00(obj_t BgL_envz00_3126,
		obj_t BgL_nodez00_3127)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 433 */
			return BBOOL(((bool_t) 1));
		}
	}



/* &dataflow-test-false-1422 */
	obj_t BGl_z62dataflowzd2testzd2falsezd21422zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3128, obj_t BgL_nodez00_3129)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 405 */
			{
				BgL_appz00_bglt BgL_nodez00_2235;

				BgL_nodez00_2235 = ((BgL_appz00_bglt) BgL_nodez00_3129);
				{	/* Dataflow/walk.scm 407 */
					BgL_variablez00_bglt BgL_fz00_2239;

					BgL_fz00_2239 =
						(((BgL_varz00_bglt) CREF(
								(((BgL_appz00_bglt) CREF(BgL_nodez00_2235))->BgL_funz00)))->
						BgL_variablez00);
					{	/* Dataflow/walk.scm 408 */

						{	/* Dataflow/walk.scm 409 */
							bool_t BgL_testz00_3812;

							{	/* Dataflow/walk.scm 409 */
								bool_t BgL_testz00_3813;

								{	/* Dataflow/walk.scm 409 */
									obj_t BgL_auxz00_3814;

									BgL_auxz00_3814 =
										(((BgL_appz00_bglt) CREF(BgL_nodez00_2235))->BgL_argsz00);
									BgL_testz00_3813 = PAIRP(BgL_auxz00_3814);
								}
								if (BgL_testz00_3813)
									{	/* Dataflow/walk.scm 409 */
										if (NULLP(CDR(
													(((BgL_appz00_bglt) CREF(BgL_nodez00_2235))->
														BgL_argsz00))))
											{	/* Dataflow/walk.scm 410 */
												bool_t BgL_testz00_3821;

												{	/* Dataflow/walk.scm 410 */
													obj_t BgL_arg1884z00_2262;

													BgL_arg1884z00_2262 =
														CAR(
														(((BgL_appz00_bglt) CREF(BgL_nodez00_2235))->
															BgL_argsz00));
													BgL_testz00_3821 =
														BGl_isazf3zf3zz__objectz00(BgL_arg1884z00_2262,
														BGl_varz00zzast_nodez00);
												}
												if (BgL_testz00_3821)
													{	/* Dataflow/walk.scm 411 */
														BgL_typez00_bglt BgL_arg1880z00_2258;

														{
															BgL_variablez00_bglt BgL_auxz00_3825;

															{
																BgL_varz00_bglt BgL_auxz00_3826;

																{	/* Dataflow/walk.scm 411 */
																	obj_t BgL_pairz00_2978;

																	BgL_pairz00_2978 =
																		(((BgL_appz00_bglt)
																			CREF(BgL_nodez00_2235))->BgL_argsz00);
																	BgL_auxz00_3826 =
																		((BgL_varz00_bglt) CAR(BgL_pairz00_2978));
																}
																BgL_auxz00_3825 =
																	(((BgL_varz00_bglt) CREF(BgL_auxz00_3826))->
																	BgL_variablez00);
															}
															BgL_arg1880z00_2258 =
																(((BgL_variablez00_bglt)
																	CREF(BgL_auxz00_3825))->BgL_typez00);
														}
														BgL_testz00_3812 =
															(
															((obj_t) BgL_arg1880z00_2258) ==
															BGl_za2pairzd2nilza2zd2zztype_cachez00);
													}
												else
													{	/* Dataflow/walk.scm 410 */
														BgL_testz00_3812 = ((bool_t) 0);
													}
											}
										else
											{	/* Dataflow/walk.scm 409 */
												BgL_testz00_3812 = ((bool_t) 0);
											}
									}
								else
									{	/* Dataflow/walk.scm 409 */
										BgL_testz00_3812 = ((bool_t) 0);
									}
							}
							if (BgL_testz00_3812)
								{	/* Dataflow/walk.scm 409 */
									if (
										(((obj_t) BgL_fz00_2239) ==
											BGl_za2z42nullzf3za2zb1zzdataflow_walkz00))
										{	/* Dataflow/walk.scm 414 */
											obj_t BgL_arg1865z00_2243;

											{	/* Dataflow/walk.scm 414 */
												BgL_variablez00_bglt BgL_arg1867z00_2245;

												{
													BgL_varz00_bglt BgL_auxz00_3837;

													{	/* Dataflow/walk.scm 414 */
														obj_t BgL_pairz00_2981;

														BgL_pairz00_2981 =
															(((BgL_appz00_bglt) CREF(BgL_nodez00_2235))->
															BgL_argsz00);
														BgL_auxz00_3837 =
															((BgL_varz00_bglt) CAR(BgL_pairz00_2981));
													}
													BgL_arg1867z00_2245 =
														(((BgL_varz00_bglt) CREF(BgL_auxz00_3837))->
														BgL_variablez00);
												}
												BgL_arg1865z00_2243 =
													MAKE_PAIR(
													((obj_t) BgL_arg1867z00_2245),
													BGl_za2pairza2z00zztype_cachez00);
											}
											{	/* Dataflow/walk.scm 414 */
												obj_t BgL_list1866z00_2244;

												BgL_list1866z00_2244 =
													MAKE_PAIR(BgL_arg1865z00_2243, BNIL);
												return BgL_list1866z00_2244;
											}
										}
									else
										{	/* Dataflow/walk.scm 415 */
											bool_t BgL_testz00_3845;

											if (
												(((obj_t) BgL_fz00_2239) ==
													BGl_za2z42pairzf3za2zb1zzdataflow_walkz00))
												{	/* Dataflow/walk.scm 415 */
													BgL_testz00_3845 = ((bool_t) 1);
												}
											else
												{	/* Dataflow/walk.scm 415 */
													BgL_testz00_3845 =
														(
														((obj_t) BgL_fz00_2239) ==
														BGl_za2z42epairzf3za2zb1zzdataflow_walkz00);
												}
											if (BgL_testz00_3845)
												{	/* Dataflow/walk.scm 416 */
													obj_t BgL_arg1871z00_2249;

													{	/* Dataflow/walk.scm 416 */
														BgL_variablez00_bglt BgL_arg1873z00_2251;

														{
															BgL_varz00_bglt BgL_auxz00_3851;

															{	/* Dataflow/walk.scm 416 */
																obj_t BgL_pairz00_2985;

																BgL_pairz00_2985 =
																	(((BgL_appz00_bglt) CREF(BgL_nodez00_2235))->
																	BgL_argsz00);
																BgL_auxz00_3851 =
																	((BgL_varz00_bglt) CAR(BgL_pairz00_2985));
															}
															BgL_arg1873z00_2251 =
																(((BgL_varz00_bglt) CREF(BgL_auxz00_3851))->
																BgL_variablez00);
														}
														BgL_arg1871z00_2249 =
															MAKE_PAIR(
															((obj_t) BgL_arg1873z00_2251),
															BGl_za2bnilza2z00zztype_cachez00);
													}
													{	/* Dataflow/walk.scm 416 */
														obj_t BgL_list1872z00_2250;

														BgL_list1872z00_2250 =
															MAKE_PAIR(BgL_arg1871z00_2249, BNIL);
														return BgL_list1872z00_2250;
													}
												}
											else
												{	/* Dataflow/walk.scm 415 */
													return BNIL;
												}
										}
								}
							else
								{	/* Dataflow/walk.scm 409 */
									return BNIL;
								}
						}
					}
				}
			}
		}
	}



/* &dataflow-test-env-le1417 */
	obj_t BGl_z62dataflowzd2testzd2envzd2le1417zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3130, obj_t BgL_nodez00_3131)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 377 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_2194;

				BgL_nodez00_2194 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_3131);
				{	/* Dataflow/walk.scm 379 */
					bool_t BgL_testz00_3860;

					{	/* Dataflow/walk.scm 379 */
						bool_t BgL_testz00_3861;

						{	/* Dataflow/walk.scm 379 */
							obj_t BgL_auxz00_3862;

							BgL_auxz00_3862 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2194))->
								BgL_bindingsz00);
							BgL_testz00_3861 = PAIRP(BgL_auxz00_3862);
						}
						if (BgL_testz00_3861)
							{	/* Dataflow/walk.scm 379 */
								BgL_testz00_3860 =
									NULLP(CDR(
										(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2194))->
											BgL_bindingsz00)));
							}
						else
							{	/* Dataflow/walk.scm 379 */
								BgL_testz00_3860 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3860)
						{	/* Dataflow/walk.scm 381 */
							bool_t BgL_testz00_3868;

							{	/* Dataflow/walk.scm 381 */
								obj_t BgL_arg1857z00_2228;

								{	/* Dataflow/walk.scm 381 */
									obj_t BgL_pairz00_2922;

									BgL_pairz00_2922 =
										(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2194))->
										BgL_bindingsz00);
									BgL_arg1857z00_2228 = CDR(CAR(BgL_pairz00_2922));
								}
								BgL_testz00_3868 =
									BGl_isazf3zf3zz__objectz00(BgL_arg1857z00_2228,
									BGl_varz00zzast_nodez00);
							}
							if (BgL_testz00_3868)
								{	/* Dataflow/walk.scm 382 */
									obj_t BgL_envz00_2200;

									BgL_envz00_2200 =
										BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
										(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2194))->
											BgL_bodyz00));
									{	/* Dataflow/walk.scm 383 */
										bool_t BgL_testz00_3875;

										if (NULLP(BgL_envz00_2200))
											{	/* Dataflow/walk.scm 383 */
												BgL_testz00_3875 = ((bool_t) 0);
											}
										else
											{	/* Dataflow/walk.scm 383 */
												if (NULLP(CDR(BgL_envz00_2200)))
													{	/* Dataflow/walk.scm 385 */
														obj_t BgL_auxz00_3881;

														{	/* Dataflow/walk.scm 385 */
															obj_t BgL_pairz00_2937;

															BgL_pairz00_2937 =
																(((BgL_letzd2varzd2_bglt)
																	CREF(BgL_nodez00_2194))->BgL_bindingsz00);
															BgL_auxz00_3881 = CAR(CAR(BgL_pairz00_2937));
														}
														BgL_testz00_3875 =
															(CAR(CAR(BgL_envz00_2200)) == BgL_auxz00_3881);
													}
												else
													{	/* Dataflow/walk.scm 384 */
														BgL_testz00_3875 = ((bool_t) 0);
													}
											}
										if (BgL_testz00_3875)
											{	/* Dataflow/walk.scm 386 */
												obj_t BgL_arg1827z00_2202;

												{	/* Dataflow/walk.scm 386 */
													BgL_variablez00_bglt BgL_arg1829z00_2204;
													obj_t BgL_arg1830z00_2205;

													{
														BgL_varz00_bglt BgL_auxz00_3888;

														{
															obj_t BgL_auxz00_3889;

															{	/* Dataflow/walk.scm 386 */
																obj_t BgL_pairz00_2941;

																BgL_pairz00_2941 =
																	(((BgL_letzd2varzd2_bglt)
																		CREF(BgL_nodez00_2194))->BgL_bindingsz00);
																{	/* Dataflow/walk.scm 386 */
																	obj_t BgL_pairz00_2944;

																	BgL_pairz00_2944 = CAR(BgL_pairz00_2941);
																	BgL_auxz00_3889 = CDR(BgL_pairz00_2944);
																}
															}
															BgL_auxz00_3888 =
																((BgL_varz00_bglt) BgL_auxz00_3889);
														}
														BgL_arg1829z00_2204 =
															(((BgL_varz00_bglt) CREF(BgL_auxz00_3888))->
															BgL_variablez00);
													}
													BgL_arg1830z00_2205 = CDR(CAR(BgL_envz00_2200));
													BgL_arg1827z00_2202 =
														MAKE_PAIR(
														((obj_t) BgL_arg1829z00_2204), BgL_arg1830z00_2205);
												}
												{	/* Dataflow/walk.scm 386 */
													obj_t BgL_list1828z00_2203;

													BgL_list1828z00_2203 =
														MAKE_PAIR(BgL_arg1827z00_2202, BNIL);
													return BgL_list1828z00_2203;
												}
											}
										else
											{	/* Dataflow/walk.scm 383 */
												return BNIL;
											}
									}
								}
							else
								{	/* Dataflow/walk.scm 388 */
									bool_t BgL_testz00_3900;

									{	/* Dataflow/walk.scm 388 */
										bool_t BgL_testz00_3901;

										{	/* Dataflow/walk.scm 388 */
											BgL_nodez00_bglt BgL_arg1856z00_2227;

											BgL_arg1856z00_2227 =
												(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2194))->
												BgL_bodyz00);
											{	/* Dataflow/walk.scm 388 */
												bool_t BgL_res2077z00_2953;

												BgL_res2077z00_2953 =
													BGl_isazf3zf3zz__objectz00(
													((obj_t) BgL_arg1856z00_2227),
													BGl_varz00zzast_nodez00);
												BgL_testz00_3901 = BgL_res2077z00_2953;
											}
										}
										if (BgL_testz00_3901)
											{	/* Dataflow/walk.scm 389 */
												bool_t BgL_testz00_3905;

												{	/* Dataflow/walk.scm 389 */
													obj_t BgL_auxz00_3906;

													{	/* Dataflow/walk.scm 389 */
														obj_t BgL_pairz00_2955;

														BgL_pairz00_2955 =
															(((BgL_letzd2varzd2_bglt)
																CREF(BgL_nodez00_2194))->BgL_bindingsz00);
														BgL_auxz00_3906 = CAR(CAR(BgL_pairz00_2955));
													}
													BgL_testz00_3905 =
														(
														((obj_t)
															(((BgL_varz00_bglt) CREF(
																		((BgL_varz00_bglt)
																			(((BgL_letzd2varzd2_bglt)
																					CREF(BgL_nodez00_2194))->
																				BgL_bodyz00))))->BgL_variablez00)) ==
														BgL_auxz00_3906);
												}
												if (BgL_testz00_3905)
													{	/* Dataflow/walk.scm 390 */
														BgL_typez00_bglt BgL_arg1848z00_2220;

														{
															BgL_variablez00_bglt BgL_auxz00_3915;

															{
																obj_t BgL_auxz00_3916;

																{	/* Dataflow/walk.scm 390 */
																	obj_t BgL_pairz00_2959;

																	BgL_pairz00_2959 =
																		(((BgL_letzd2varzd2_bglt)
																			CREF(BgL_nodez00_2194))->BgL_bindingsz00);
																	{	/* Dataflow/walk.scm 390 */
																		obj_t BgL_pairz00_2962;

																		BgL_pairz00_2962 = CAR(BgL_pairz00_2959);
																		BgL_auxz00_3916 = CAR(BgL_pairz00_2962);
																	}
																}
																BgL_auxz00_3915 =
																	((BgL_variablez00_bglt) BgL_auxz00_3916);
															}
															BgL_arg1848z00_2220 =
																(((BgL_variablez00_bglt)
																	CREF(BgL_auxz00_3915))->BgL_typez00);
														}
														BgL_testz00_3900 =
															(
															((obj_t) BgL_arg1848z00_2220) ==
															BGl_za2boolza2z00zztype_cachez00);
													}
												else
													{	/* Dataflow/walk.scm 389 */
														BgL_testz00_3900 = ((bool_t) 0);
													}
											}
										else
											{	/* Dataflow/walk.scm 388 */
												BgL_testz00_3900 = ((bool_t) 0);
											}
									}
									if (BgL_testz00_3900)
										{	/* Dataflow/walk.scm 391 */
											obj_t BgL_arg1843z00_2216;

											{	/* Dataflow/walk.scm 391 */
												obj_t BgL_pairz00_2964;

												BgL_pairz00_2964 =
													(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2194))->
													BgL_bindingsz00);
												BgL_arg1843z00_2216 = CDR(CAR(BgL_pairz00_2964));
											}
											return
												BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(
												((BgL_nodez00_bglt) BgL_arg1843z00_2216));
										}
									else
										{	/* Dataflow/walk.scm 388 */
											return BNIL;
										}
								}
						}
					else
						{	/* Dataflow/walk.scm 379 */
							return BNIL;
						}
				}
			}
		}
	}



/* &dataflow-test-env-va1415 */
	obj_t BGl_z62dataflowzd2testzd2envzd2va1415zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3132, obj_t BgL_nodez00_3133)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 360 */
			{
				BgL_varz00_bglt BgL_nodez00_2185;

				BgL_nodez00_2185 = ((BgL_varz00_bglt) BgL_nodez00_3133);
				{	/* Dataflow/walk.scm 362 */
					bool_t BgL_testz00_3930;

					{	/* Dataflow/walk.scm 362 */
						BgL_variablez00_bglt BgL_arg1823z00_2192;

						BgL_arg1823z00_2192 =
							(((BgL_varz00_bglt) CREF(BgL_nodez00_2185))->BgL_variablez00);
						{	/* Dataflow/walk.scm 362 */
							bool_t BgL_res2070z00_2915;

							BgL_res2070z00_2915 =
								BGl_isazf3zf3zz__objectz00(
								((obj_t) BgL_arg1823z00_2192),
								BGl_localzf2valuezf2zzdataflow_walkz00);
							BgL_testz00_3930 = BgL_res2070z00_2915;
						}
					}
					if (BgL_testz00_3930)
						{	/* Dataflow/walk.scm 363 */
							BgL_nodez00_bglt BgL_arg1821z00_2190;

							{
								BgL_localzf2valuezf2_bglt BgL_auxz00_3934;

								{
									obj_t BgL_auxz00_3935;

									{	/* Dataflow/walk.scm 363 */
										BgL_objectz00_bglt BgL_auxz00_3936;

										BgL_auxz00_3936 =
											((BgL_objectz00_bglt)
											((BgL_localz00_bglt)
												(((BgL_varz00_bglt) CREF(BgL_nodez00_2185))->
													BgL_variablez00)));
										BgL_auxz00_3935 = BGL_OBJECT_WIDENING(BgL_auxz00_3936);
									}
									BgL_auxz00_3934 =
										((BgL_localzf2valuezf2_bglt) BgL_auxz00_3935);
								}
								BgL_arg1821z00_2190 =
									(((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_3934))->
									BgL_nodez00);
							}
							return
								BGl_dataflowzd2testzd2envz00zzdataflow_walkz00
								(BgL_arg1821z00_2190);
						}
					else
						{	/* Dataflow/walk.scm 362 */
							return BNIL;
						}
				}
			}
		}
	}



/* &dataflow-test-env-co1412 */
	obj_t BGl_z62dataflowzd2testzd2envzd2co1412zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3134, obj_t BgL_nodez00_3135)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 351 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_2171;

				BgL_nodez00_2171 = ((BgL_conditionalz00_bglt) BgL_nodez00_3135);
				{	/* Dataflow/walk.scm 353 */
					bool_t BgL_testz00_3945;

					{	/* Dataflow/walk.scm 353 */
						bool_t BgL_testz00_3946;

						{	/* Dataflow/walk.scm 353 */
							BgL_nodez00_bglt BgL_arg1819z00_2183;

							BgL_arg1819z00_2183 =
								(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2171))->
								BgL_falsez00);
							{	/* Dataflow/walk.scm 353 */
								bool_t BgL_res2069z00_2912;

								BgL_res2069z00_2912 =
									BGl_isazf3zf3zz__objectz00(
									((obj_t) BgL_arg1819z00_2183), BGl_atomz00zzast_nodez00);
								BgL_testz00_3946 = BgL_res2069z00_2912;
							}
						}
						if (BgL_testz00_3946)
							{	/* Dataflow/walk.scm 353 */
								BgL_testz00_3945 =
									(
									(((BgL_atomz00_bglt) CREF(
												((BgL_atomz00_bglt)
													(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_2171))->
														BgL_falsez00))))->BgL_valuez00) == BFALSE);
							}
						else
							{	/* Dataflow/walk.scm 353 */
								BgL_testz00_3945 = ((bool_t) 0);
							}
					}
					if (BgL_testz00_3945)
						{	/* Dataflow/walk.scm 353 */
							return
								BGl_appendzd221011zd2zzdataflow_walkz00
								(BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
											(BgL_conditionalz00_bglt) CREF(BgL_nodez00_2171))->
										BgL_testz00)),
								BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
											(BgL_conditionalz00_bglt) CREF(BgL_nodez00_2171))->
										BgL_truez00)));
						}
					else
						{	/* Dataflow/walk.scm 353 */
							return BNIL;
						}
				}
			}
		}
	}



/* &dataflow-test-env-in1409 */
	obj_t BGl_z62dataflowzd2testzd2envzd2in1409zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3136, obj_t BgL_nodez00_3137)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 342 */
			{
				BgL_instanceofz00_bglt BgL_nodez00_2157;

				BgL_nodez00_2157 = ((BgL_instanceofz00_bglt) BgL_nodez00_3137);
				{	/* Dataflow/walk.scm 344 */
					bool_t BgL_testz00_3960;

					{	/* Dataflow/walk.scm 344 */
						obj_t BgL_arg1809z00_2168;

						{	/* Dataflow/walk.scm 344 */
							obj_t BgL_pairz00_2904;

							BgL_pairz00_2904 =
								(((BgL_externz00_bglt) CREF(
										((BgL_externz00_bglt) BgL_nodez00_2157)))->BgL_exprza2za2);
							BgL_arg1809z00_2168 = CAR(BgL_pairz00_2904);
						}
						BgL_testz00_3960 =
							BGl_isazf3zf3zz__objectz00(BgL_arg1809z00_2168,
							BGl_varz00zzast_nodez00);
					}
					if (BgL_testz00_3960)
						{	/* Dataflow/walk.scm 345 */
							obj_t BgL_arg1802z00_2162;

							{	/* Dataflow/walk.scm 345 */
								BgL_variablez00_bglt BgL_arg1804z00_2164;
								BgL_typez00_bglt BgL_arg1805z00_2165;

								{
									BgL_varz00_bglt BgL_auxz00_3965;

									{	/* Dataflow/walk.scm 345 */
										obj_t BgL_pairz00_2907;

										BgL_pairz00_2907 =
											(((BgL_externz00_bglt) CREF(
													((BgL_externz00_bglt) BgL_nodez00_2157)))->
											BgL_exprza2za2);
										BgL_auxz00_3965 = ((BgL_varz00_bglt) CAR(BgL_pairz00_2907));
									}
									BgL_arg1804z00_2164 =
										(((BgL_varz00_bglt) CREF(BgL_auxz00_3965))->
										BgL_variablez00);
								}
								BgL_arg1805z00_2165 =
									(((BgL_instanceofz00_bglt) CREF(BgL_nodez00_2157))->
									BgL_classz00);
								BgL_arg1802z00_2162 =
									MAKE_PAIR(((obj_t) BgL_arg1804z00_2164),
									((obj_t) BgL_arg1805z00_2165));
							}
							{	/* Dataflow/walk.scm 345 */
								obj_t BgL_list1803z00_2163;

								BgL_list1803z00_2163 = MAKE_PAIR(BgL_arg1802z00_2162, BNIL);
								return BgL_list1803z00_2163;
							}
						}
					else
						{	/* Dataflow/walk.scm 344 */
							return BNIL;
						}
				}
			}
		}
	}



/* &dataflow-test-env-ap1406 */
	obj_t BGl_z62dataflowzd2testzd2envzd2ap1406zb0zzdataflow_walkz00(obj_t
		BgL_envz00_3138, obj_t BgL_nodez00_3139)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 319 */
			{
				BgL_appz00_bglt BgL_nodez00_2117;

				BgL_nodez00_2117 = ((BgL_appz00_bglt) BgL_nodez00_3139);
				{	/* Dataflow/walk.scm 321 */
					BgL_variablez00_bglt BgL_fz00_2121;

					BgL_fz00_2121 =
						(((BgL_varz00_bglt) CREF(
								(((BgL_appz00_bglt) CREF(BgL_nodez00_2117))->BgL_funz00)))->
						BgL_variablez00);
					{	/* Dataflow/walk.scm 321 */
						BgL_valuez00_bglt BgL_funvz00_2122;

						BgL_funvz00_2122 =
							(((BgL_variablez00_bglt) CREF(BgL_fz00_2121))->BgL_valuez00);
						{	/* Dataflow/walk.scm 322 */

							{	/* Dataflow/walk.scm 324 */
								obj_t BgL_g1170z00_2123;

								BgL_g1170z00_2123 =
									BGl_isazd2ofzd2zztype_miscz00(
									((BgL_nodez00_bglt) BgL_nodez00_2117));
								if (CBOOL(BgL_g1170z00_2123))
									{	/* Dataflow/walk.scm 327 */
										bool_t BgL_testz00_3984;

										{	/* Dataflow/walk.scm 327 */
											obj_t BgL_arg1775z00_2132;

											BgL_arg1775z00_2132 =
												CAR(
												(((BgL_appz00_bglt) CREF(BgL_nodez00_2117))->
													BgL_argsz00));
											BgL_testz00_3984 =
												BGl_isazf3zf3zz__objectz00(BgL_arg1775z00_2132,
												BGl_varz00zzast_nodez00);
										}
										if (BgL_testz00_3984)
											{	/* Dataflow/walk.scm 328 */
												obj_t BgL_arg1769z00_2127;

												{	/* Dataflow/walk.scm 328 */
													BgL_variablez00_bglt BgL_arg1771z00_2129;

													{
														BgL_varz00_bglt BgL_auxz00_3988;

														{	/* Dataflow/walk.scm 328 */
															obj_t BgL_pairz00_2881;

															BgL_pairz00_2881 =
																(((BgL_appz00_bglt) CREF(BgL_nodez00_2117))->
																BgL_argsz00);
															BgL_auxz00_3988 =
																((BgL_varz00_bglt) CAR(BgL_pairz00_2881));
														}
														BgL_arg1771z00_2129 =
															(((BgL_varz00_bglt) CREF(BgL_auxz00_3988))->
															BgL_variablez00);
													}
													BgL_arg1769z00_2127 =
														MAKE_PAIR(
														((obj_t) BgL_arg1771z00_2129), BgL_g1170z00_2123);
												}
												{	/* Dataflow/walk.scm 328 */
													obj_t BgL_list1770z00_2128;

													BgL_list1770z00_2128 =
														MAKE_PAIR(BgL_arg1769z00_2127, BNIL);
													return BgL_list1770z00_2128;
												}
											}
										else
											{	/* Dataflow/walk.scm 327 */
												return BNIL;
											}
									}
								else
									{	/* Dataflow/walk.scm 330 */
										bool_t BgL_testz00_3996;

										{	/* Dataflow/walk.scm 330 */
											bool_t BgL_testz00_3997;

											{	/* Dataflow/walk.scm 330 */
												bool_t BgL_res2062z00_2886;

												BgL_res2062z00_2886 =
													BGl_isazf3zf3zz__objectz00(
													((obj_t) BgL_funvz00_2122), BGl_funz00zzast_varz00);
												BgL_testz00_3997 = BgL_res2062z00_2886;
											}
											if (BgL_testz00_3997)
												{	/* Dataflow/walk.scm 330 */
													if (CBOOL(
															(((BgL_funz00_bglt) CREF(
																		((BgL_funz00_bglt) BgL_funvz00_2122)))->
																BgL_predicatezd2ofzd2)))
														{	/* Dataflow/walk.scm 332 */
															bool_t BgL_testz00_4004;

															{	/* Dataflow/walk.scm 332 */
																obj_t BgL_auxz00_4005;

																BgL_auxz00_4005 =
																	(((BgL_appz00_bglt) CREF(BgL_nodez00_2117))->
																	BgL_argsz00);
																BgL_testz00_4004 = PAIRP(BgL_auxz00_4005);
															}
															if (BgL_testz00_4004)
																{	/* Dataflow/walk.scm 332 */
																	if (NULLP(CDR(
																				(((BgL_appz00_bglt)
																						CREF(BgL_nodez00_2117))->
																					BgL_argsz00))))
																		{	/* Dataflow/walk.scm 333 */
																			bool_t BgL_testz00_4012;

																			{	/* Dataflow/walk.scm 333 */
																				obj_t BgL_arg1795z00_2150;

																				BgL_arg1795z00_2150 =
																					CAR(
																					(((BgL_appz00_bglt)
																							CREF(BgL_nodez00_2117))->
																						BgL_argsz00));
																				BgL_testz00_4012 =
																					BGl_isazf3zf3zz__objectz00
																					(BgL_arg1795z00_2150,
																					BGl_varz00zzast_nodez00);
																			}
																			if (BgL_testz00_4012)
																				{	/* Dataflow/walk.scm 334 */
																					BgL_typez00_bglt BgL_arg1791z00_2146;

																					{
																						BgL_variablez00_bglt
																							BgL_auxz00_4016;
																						{
																							BgL_varz00_bglt BgL_auxz00_4017;

																							{	/* Dataflow/walk.scm 334 */
																								obj_t BgL_pairz00_2896;

																								BgL_pairz00_2896 =
																									(((BgL_appz00_bglt)
																										CREF(BgL_nodez00_2117))->
																									BgL_argsz00);
																								BgL_auxz00_4017 =
																									((BgL_varz00_bglt)
																									CAR(BgL_pairz00_2896));
																							}
																							BgL_auxz00_4016 =
																								(((BgL_varz00_bglt)
																									CREF(BgL_auxz00_4017))->
																								BgL_variablez00);
																						}
																						BgL_arg1791z00_2146 =
																							(((BgL_variablez00_bglt)
																								CREF(BgL_auxz00_4016))->
																							BgL_typez00);
																					}
																					BgL_testz00_3996 =
																						BGl_bigloozd2typezf3z21zztype_typez00
																						(BgL_arg1791z00_2146);
																				}
																			else
																				{	/* Dataflow/walk.scm 333 */
																					BgL_testz00_3996 = ((bool_t) 0);
																				}
																		}
																	else
																		{	/* Dataflow/walk.scm 332 */
																			BgL_testz00_3996 = ((bool_t) 0);
																		}
																}
															else
																{	/* Dataflow/walk.scm 332 */
																	BgL_testz00_3996 = ((bool_t) 0);
																}
														}
													else
														{	/* Dataflow/walk.scm 331 */
															BgL_testz00_3996 = ((bool_t) 0);
														}
												}
											else
												{	/* Dataflow/walk.scm 330 */
													BgL_testz00_3996 = ((bool_t) 0);
												}
										}
										if (BgL_testz00_3996)
											{	/* Dataflow/walk.scm 335 */
												obj_t BgL_arg1779z00_2135;

												{	/* Dataflow/walk.scm 335 */
													BgL_variablez00_bglt BgL_arg1781z00_2137;
													obj_t BgL_arg1782z00_2138;

													{
														BgL_varz00_bglt BgL_auxz00_4024;

														{	/* Dataflow/walk.scm 335 */
															obj_t BgL_pairz00_2899;

															BgL_pairz00_2899 =
																(((BgL_appz00_bglt) CREF(BgL_nodez00_2117))->
																BgL_argsz00);
															BgL_auxz00_4024 =
																((BgL_varz00_bglt) CAR(BgL_pairz00_2899));
														}
														BgL_arg1781z00_2137 =
															(((BgL_varz00_bglt) CREF(BgL_auxz00_4024))->
															BgL_variablez00);
													}
													BgL_arg1782z00_2138 =
														(((BgL_funz00_bglt) CREF(
																((BgL_funz00_bglt) BgL_funvz00_2122)))->
														BgL_predicatezd2ofzd2);
													BgL_arg1779z00_2135 =
														MAKE_PAIR(((obj_t) BgL_arg1781z00_2137),
														BgL_arg1782z00_2138);
												}
												{	/* Dataflow/walk.scm 335 */
													obj_t BgL_list1780z00_2136;

													BgL_list1780z00_2136 =
														MAKE_PAIR(BgL_arg1779z00_2135, BNIL);
													return BgL_list1780z00_2136;
												}
											}
										else
											{	/* Dataflow/walk.scm 330 */
												return BNIL;
											}
									}
							}
						}
					}
				}
			}
		}
	}



/* &dataflow-node!-box-s1400 */
	obj_t BGl_z62dataflowzd2nodez12zd2boxzd2s1400za2zzdataflow_walkz00(obj_t
		BgL_envz00_3140, obj_t BgL_nodez00_3141, obj_t BgL_envz00_3142)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 299 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_2110;
				obj_t BgL_envz00_2111;

				BgL_nodez00_2110 = ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_3141);
				BgL_envz00_2111 = BgL_envz00_3142;
				return
					BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_2110))->BgL_valuez00),
					BgL_envz00_2111);
			}
		}
	}



/* &dataflow-node!-box-r1398 */
	obj_t BGl_z62dataflowzd2nodez12zd2boxzd2r1398za2zzdataflow_walkz00(obj_t
		BgL_envz00_3143, obj_t BgL_nodez00_3144, obj_t BgL_envz00_3145)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 292 */
			return BgL_envz00_3145;
		}
	}



/* &dataflow-node!-make-1396 */
	obj_t BGl_z62dataflowzd2nodez12zd2makezd21396za2zzdataflow_walkz00(obj_t
		BgL_envz00_3146, obj_t BgL_nodez00_3147, obj_t BgL_envz00_3148)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 286 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_2098;
				obj_t BgL_envz00_2099;

				BgL_nodez00_2098 = ((BgL_makezd2boxzd2_bglt) BgL_nodez00_3147);
				BgL_envz00_2099 = BgL_envz00_3148;
				return
					BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_2098))->BgL_valuez00),
					BgL_envz00_2099);
			}
		}
	}



/* &dataflow-node!-jump-1394 */
	obj_t BGl_z62dataflowzd2nodez12zd2jumpzd21394za2zzdataflow_walkz00(obj_t
		BgL_envz00_3149, obj_t BgL_nodez00_3150, obj_t BgL_envz00_3151)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 277 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_2090;
				obj_t BgL_envz00_2091;

				BgL_nodez00_2090 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_3150);
				BgL_envz00_2091 = BgL_envz00_3151;
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_2090))->BgL_exitz00),
					BgL_envz00_2091);
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(((
							(BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_2090))->
						BgL_valuez00), BgL_envz00_2091);
				return BNIL;
			}
		}
	}



/* &dataflow-node!-set-e1392 */
	obj_t BGl_z62dataflowzd2nodez12zd2setzd2e1392za2zzdataflow_walkz00(obj_t
		BgL_envz00_3152, obj_t BgL_nodez00_3153, obj_t BgL_envz00_3154)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 269 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_2083;
				obj_t BgL_envz00_2084;

				BgL_nodez00_2083 = ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_3153);
				BgL_envz00_2084 = BgL_envz00_3154;
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_2083))->BgL_bodyz00),
					BgL_envz00_2084);
				return BNIL;
			}
		}
	}



/* &dataflow-node!-let-v1390 */
	obj_t BGl_z62dataflowzd2nodez12zd2letzd2v1390za2zzdataflow_walkz00(obj_t
		BgL_envz00_3155, obj_t BgL_nodez00_3156, obj_t BgL_envz00_3157)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 237 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_2036;
				obj_t BgL_envz00_2037;

				BgL_nodez00_2036 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_3156);
				BgL_envz00_2037 = BgL_envz00_3157;
				BGl_letzd2varzd2stampz00zzdataflow_walkz00 =
					(((long) 1) + BGl_letzd2varzd2stampz00zzdataflow_walkz00);
				{	/* Dataflow/walk.scm 240 */
					long BgL_stampz00_2041;

					BgL_stampz00_2041 = BGl_letzd2varzd2stampz00zzdataflow_walkz00;
					{	/* Dataflow/walk.scm 240 */
						obj_t BgL_envz00_2042;

						{
							obj_t BgL_bindingsz00_2066;
							obj_t BgL_envz00_2067;

							BgL_bindingsz00_2066 =
								(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2036))->
								BgL_bindingsz00);
							BgL_envz00_2067 = BgL_envz00_2037;
						BgL_zc3anonymousza31757ze3z83_2068:
							if (NULLP(BgL_bindingsz00_2066))
								{	/* Dataflow/walk.scm 243 */
									BgL_envz00_2042 = BgL_envz00_2067;
								}
							else
								{	/* Dataflow/walk.scm 245 */
									obj_t BgL_nodez00_2070;

									BgL_nodez00_2070 = CDR(CAR(BgL_bindingsz00_2066));
									{	/* Dataflow/walk.scm 245 */
										obj_t BgL_envz00_2071;

										BgL_envz00_2071 =
											BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_nodez00_2070), BgL_envz00_2067);
										{	/* Dataflow/walk.scm 246 */

											{	/* Dataflow/walk.scm 247 */
												obj_t BgL_lz00_2072;

												BgL_lz00_2072 = CAR(CAR(BgL_bindingsz00_2066));
												if (
													((((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt) BgL_lz00_2072)))->
															BgL_accessz00) == CNST_TABLE_REF(((long) 11))))
													{	/* Dataflow/walk.scm 248 */
														{	/* Dataflow/walk.scm 249 */
															BgL_localzf2valuezf2_bglt BgL_wide1163z00_2076;

															BgL_wide1163z00_2076 =
																((BgL_localzf2valuezf2_bglt)
																BREF(GC_MALLOC(sizeof(struct
																			BgL_localzf2valuezf2_bgl))));
															{	/* Dataflow/walk.scm 249 */
																obj_t BgL_auxz00_4068;
																BgL_objectz00_bglt BgL_auxz00_4064;

																BgL_auxz00_4068 =
																	((obj_t) BgL_wide1163z00_2076);
																BgL_auxz00_4064 =
																	((BgL_objectz00_bglt)
																	((BgL_localz00_bglt)
																		((BgL_localz00_bglt) BgL_lz00_2072)));
																BGL_OBJECT_WIDENING_SET(BgL_auxz00_4064,
																	BgL_auxz00_4068);
															}
															{	/* Dataflow/walk.scm 249 */
																long BgL_arg1760z00_2077;

																{	/* Dataflow/walk.scm 249 */
																	long BgL_res2056z00_2849;

																	BgL_res2056z00_2849 =
																		BGL_CLASS_INDEX
																		(BGl_localzf2valuezf2zzdataflow_walkz00);
																	BgL_arg1760z00_2077 = BgL_res2056z00_2849;
																}
																((BgL_localz00_bglt)
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt)
																			((BgL_localz00_bglt)
																				((BgL_localz00_bglt) BgL_lz00_2072))),
																		BgL_arg1760z00_2077));
															}
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_lz00_2072));
														}
														{
															BgL_localzf2valuezf2_bglt BgL_auxz00_4079;

															{
																obj_t BgL_auxz00_4080;

																{	/* Dataflow/walk.scm 250 */
																	BgL_objectz00_bglt BgL_auxz00_4081;

																	BgL_auxz00_4081 =
																		((BgL_objectz00_bglt)
																		((BgL_localz00_bglt)
																			((BgL_localz00_bglt) BgL_lz00_2072)));
																	BgL_auxz00_4080 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_4081);
																}
																BgL_auxz00_4079 =
																	((BgL_localzf2valuezf2_bglt) BgL_auxz00_4080);
															}
															((((BgL_localzf2valuezf2_bglt)
																		CREF(BgL_auxz00_4079))->BgL_stampz00) =
																((int) (int) (BgL_stampz00_2041)), BUNSPEC);
														}
														{
															BgL_localzf2valuezf2_bglt BgL_auxz00_4089;

															{
																obj_t BgL_auxz00_4090;

																{	/* Dataflow/walk.scm 251 */
																	BgL_objectz00_bglt BgL_auxz00_4091;

																	BgL_auxz00_4091 =
																		((BgL_objectz00_bglt)
																		((BgL_localz00_bglt)
																			((BgL_localz00_bglt) BgL_lz00_2072)));
																	BgL_auxz00_4090 =
																		BGL_OBJECT_WIDENING(BgL_auxz00_4091);
																}
																BgL_auxz00_4089 =
																	((BgL_localzf2valuezf2_bglt) BgL_auxz00_4090);
															}
															((((BgL_localzf2valuezf2_bglt)
																		CREF(BgL_auxz00_4089))->BgL_nodez00) =
																((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
																		BgL_nodez00_2070)), BUNSPEC);
														}
														((obj_t)
															((BgL_localz00_bglt)
																((BgL_localz00_bglt) BgL_lz00_2072)));
													}
												else
													{	/* Dataflow/walk.scm 248 */
														BFALSE;
													}
											}
											{
												obj_t BgL_envz00_4104;
												obj_t BgL_bindingsz00_4102;

												BgL_bindingsz00_4102 = CDR(BgL_bindingsz00_2066);
												BgL_envz00_4104 = BgL_envz00_2071;
												BgL_envz00_2067 = BgL_envz00_4104;
												BgL_bindingsz00_2066 = BgL_bindingsz00_4102;
												goto BgL_zc3anonymousza31757ze3z83_2068;
											}
										}
									}
								}
						}
						{	/* Dataflow/walk.scm 241 */

							{	/* Dataflow/walk.scm 253 */
								obj_t BgL_arg1735z00_2044;

								BgL_arg1735z00_2044 =
									BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
									(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_2036))->
										BgL_bodyz00), BgL_envz00_2042);
								{	/* Dataflow/walk.scm 255 */
									obj_t BgL_zc3anonymousza31737ze3z83_3095;

									BgL_zc3anonymousza31737ze3z83_3095 =
										MAKE_FX_PROCEDURE
										(BGl_z62zc3anonymousza31737ze3ze1zzdataflow_walkz00,
										(int) (((long) 1)), (int) (((long) 1)));
									PROCEDURE_SET(BgL_zc3anonymousza31737ze3z83_3095,
										(int) (((long) 0)), BINT(BgL_stampz00_2041));
									{	/* Dataflow/walk.scm 253 */
										obj_t BgL_list1736z00_2045;

										BgL_list1736z00_2045 = MAKE_PAIR(BgL_arg1735z00_2044, BNIL);
										return
											BGl_filterzd2mapzd2zz__r4_control_features_6_9z00
											(BgL_zc3anonymousza31737ze3z83_3095,
											BgL_list1736z00_2045);
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* &<anonymous:1737> */
	obj_t BGl_z62zc3anonymousza31737ze3ze1zzdataflow_walkz00(obj_t
		BgL_envz00_3158, obj_t BgL_bz00_3160)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 253 */
			{	/* Dataflow/walk.scm 255 */
				long BgL_stampz00_3159;

				BgL_stampz00_3159 =
					(long) CINT(PROCEDURE_REF(BgL_envz00_3158, (int) (((long) 0))));
				{
					obj_t BgL_bz00_2046;

					BgL_bz00_2046 = BgL_bz00_3160;
					{	/* Dataflow/walk.scm 255 */
						bool_t BgL_testz00_4120;

						{	/* Dataflow/walk.scm 255 */
							bool_t BgL_testz00_4121;

							{	/* Dataflow/walk.scm 255 */
								obj_t BgL_arg1754z00_2061;

								BgL_arg1754z00_2061 = CAR(BgL_bz00_2046);
								BgL_testz00_4121 =
									BGl_isazf3zf3zz__objectz00(BgL_arg1754z00_2061,
									BGl_localzf2valuezf2zzdataflow_walkz00);
							}
							if (BgL_testz00_4121)
								{	/* Dataflow/walk.scm 256 */
									long BgL_auxz00_4124;

									{	/* Dataflow/walk.scm 256 */
										int BgL_auxz00_4125;

										{
											BgL_localzf2valuezf2_bglt BgL_auxz00_4126;

											{
												obj_t BgL_auxz00_4127;

												{	/* Dataflow/walk.scm 256 */
													BgL_objectz00_bglt BgL_auxz00_4128;

													BgL_auxz00_4128 =
														((BgL_objectz00_bglt)
														((BgL_localz00_bglt) CAR(BgL_bz00_2046)));
													BgL_auxz00_4127 =
														BGL_OBJECT_WIDENING(BgL_auxz00_4128);
												}
												BgL_auxz00_4126 =
													((BgL_localzf2valuezf2_bglt) BgL_auxz00_4127);
											}
											BgL_auxz00_4125 =
												(((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_4126))->
												BgL_stampz00);
										}
										BgL_auxz00_4124 = (long) (BgL_auxz00_4125);
									}
									BgL_testz00_4120 = (BgL_auxz00_4124 < BgL_stampz00_3159);
								}
							else
								{	/* Dataflow/walk.scm 255 */
									BgL_testz00_4120 = ((bool_t) 1);
								}
						}
						if (BgL_testz00_4120)
							{	/* Dataflow/walk.scm 255 */
								return BgL_bz00_2046;
							}
						else
							{	/* Dataflow/walk.scm 258 */
								bool_t BgL_testz00_4137;

								{	/* Dataflow/walk.scm 258 */
									BgL_nodez00_bglt BgL_arg1747z00_2056;

									{
										BgL_localzf2valuezf2_bglt BgL_auxz00_4138;

										{
											obj_t BgL_auxz00_4139;

											{	/* Dataflow/walk.scm 258 */
												BgL_objectz00_bglt BgL_auxz00_4140;

												BgL_auxz00_4140 =
													((BgL_objectz00_bglt)
													((BgL_localz00_bglt) CAR(BgL_bz00_2046)));
												BgL_auxz00_4139 = BGL_OBJECT_WIDENING(BgL_auxz00_4140);
											}
											BgL_auxz00_4138 =
												((BgL_localzf2valuezf2_bglt) BgL_auxz00_4139);
										}
										BgL_arg1747z00_2056 =
											(((BgL_localzf2valuezf2_bglt) CREF(BgL_auxz00_4138))->
											BgL_nodez00);
									}
									{	/* Dataflow/walk.scm 258 */
										bool_t BgL_res2059z00_2864;

										BgL_res2059z00_2864 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg1747z00_2056), BGl_varz00zzast_nodez00);
										BgL_testz00_4137 = BgL_res2059z00_2864;
									}
								}
								if (BgL_testz00_4137)
									{	/* Dataflow/walk.scm 259 */
										BgL_variablez00_bglt BgL_vz00_2050;

										{
											BgL_varz00_bglt BgL_auxz00_4149;

											{
												BgL_nodez00_bglt BgL_auxz00_4150;

												{
													BgL_localzf2valuezf2_bglt BgL_auxz00_4151;

													{
														obj_t BgL_auxz00_4152;

														{	/* Dataflow/walk.scm 259 */
															BgL_objectz00_bglt BgL_auxz00_4153;

															BgL_auxz00_4153 =
																((BgL_objectz00_bglt)
																((BgL_localz00_bglt) CAR(BgL_bz00_2046)));
															BgL_auxz00_4152 =
																BGL_OBJECT_WIDENING(BgL_auxz00_4153);
														}
														BgL_auxz00_4151 =
															((BgL_localzf2valuezf2_bglt) BgL_auxz00_4152);
													}
													BgL_auxz00_4150 =
														(((BgL_localzf2valuezf2_bglt)
															CREF(BgL_auxz00_4151))->BgL_nodez00);
												}
												BgL_auxz00_4149 = ((BgL_varz00_bglt) BgL_auxz00_4150);
											}
											BgL_vz00_2050 =
												(((BgL_varz00_bglt) CREF(BgL_auxz00_4149))->
												BgL_variablez00);
										}
										if (
											((((BgL_variablez00_bglt) CREF(BgL_vz00_2050))->
													BgL_accessz00) == CNST_TABLE_REF(((long) 11))))
											{	/* Dataflow/walk.scm 261 */
												obj_t BgL_arg1741z00_2052;

												BgL_arg1741z00_2052 = CDR(BgL_bz00_2046);
												return
													MAKE_PAIR(
													((obj_t) BgL_vz00_2050), BgL_arg1741z00_2052);
											}
										else
											{	/* Dataflow/walk.scm 260 */
												return BFALSE;
											}
									}
								else
									{	/* Dataflow/walk.scm 258 */
										return BFALSE;
									}
							}
					}
				}
			}
		}
	}



/* &dataflow-node!-let-f1388 */
	obj_t BGl_z62dataflowzd2nodez12zd2letzd2f1388za2zzdataflow_walkz00(obj_t
		BgL_envz00_3161, obj_t BgL_nodez00_3162, obj_t BgL_envz00_3163)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 222 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_2019;
				obj_t BgL_envz00_2020;

				BgL_nodez00_2019 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_3162);
				BgL_envz00_2020 = BgL_envz00_3163;
				{	/* Dataflow/walk.scm 224 */
					obj_t BgL_g1338z00_2024;

					BgL_g1338z00_2024 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_2019))->BgL_localsz00);
					{
						obj_t BgL_l1336z00_2026;

						BgL_l1336z00_2026 = BgL_g1338z00_2024;
					BgL_zc3anonymousza31725ze3z83_2027:
						if (PAIRP(BgL_l1336z00_2026))
							{	/* Dataflow/walk.scm 224 */
								{	/* Dataflow/walk.scm 225 */
									obj_t BgL_localz00_2029;

									BgL_localz00_2029 = CAR(BgL_l1336z00_2026);
									{	/* Dataflow/walk.scm 225 */
										obj_t BgL_arg1727z00_2030;

										BgL_arg1727z00_2030 =
											(((BgL_sfunz00_bglt) CREF(
													((BgL_sfunz00_bglt)
														(((BgL_variablez00_bglt) CREF(
																	((BgL_variablez00_bglt)
																		((BgL_localz00_bglt) BgL_localz00_2029))))->
															BgL_valuez00))))->BgL_bodyz00);
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((
												(BgL_nodez00_bglt) BgL_arg1727z00_2030), BNIL);
									}
								}
								{
									obj_t BgL_l1336z00_4180;

									BgL_l1336z00_4180 = CDR(BgL_l1336z00_2026);
									BgL_l1336z00_2026 = BgL_l1336z00_4180;
									goto BgL_zc3anonymousza31725ze3z83_2027;
								}
							}
						else
							{	/* Dataflow/walk.scm 224 */
								((bool_t) 1);
							}
					}
				}
				return
					BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_2019))->BgL_bodyz00),
					BgL_envz00_2020);
			}
		}
	}



/* &dataflow-node!-selec1386 */
	obj_t BGl_z62dataflowzd2nodez12zd2selec1386z70zzdataflow_walkz00(obj_t
		BgL_envz00_3164, obj_t BgL_nodez00_3165, obj_t BgL_envz00_3166)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 211 */
			{
				BgL_selectz00_bglt BgL_nodez00_2003;
				obj_t BgL_envz00_2004;

				BgL_nodez00_2003 = ((BgL_selectz00_bglt) BgL_nodez00_3165);
				BgL_envz00_2004 = BgL_envz00_3166;
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_selectz00_bglt) CREF(BgL_nodez00_2003))->BgL_testz00),
					BgL_envz00_2004);
				{	/* Dataflow/walk.scm 214 */
					obj_t BgL_g1335z00_2009;

					BgL_g1335z00_2009 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_2003))->BgL_clausesz00);
					{
						obj_t BgL_l1333z00_2011;

						BgL_l1333z00_2011 = BgL_g1335z00_2009;
					BgL_zc3anonymousza31721ze3z83_2012:
						if (PAIRP(BgL_l1333z00_2011))
							{	/* Dataflow/walk.scm 214 */
								{	/* Dataflow/walk.scm 215 */
									obj_t BgL_clausez00_2014;

									BgL_clausez00_2014 = CAR(BgL_l1333z00_2011);
									{	/* Dataflow/walk.scm 215 */
										obj_t BgL_arg1723z00_2015;

										BgL_arg1723z00_2015 = CDR(BgL_clausez00_2014);
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
											((BgL_nodez00_bglt) BgL_arg1723z00_2015),
											BgL_envz00_2004);
									}
								}
								{
									obj_t BgL_l1333z00_4194;

									BgL_l1333z00_4194 = CDR(BgL_l1333z00_2011);
									BgL_l1333z00_2011 = BgL_l1333z00_4194;
									goto BgL_zc3anonymousza31721ze3z83_2012;
								}
							}
						else
							{	/* Dataflow/walk.scm 214 */
								((bool_t) 1);
							}
					}
				}
				return BgL_envz00_2004;
			}
		}
	}



/* &dataflow-node!-fail1384 */
	obj_t BGl_z62dataflowzd2nodez12zd2fail1384z70zzdataflow_walkz00(obj_t
		BgL_envz00_3167, obj_t BgL_nodez00_3168, obj_t BgL_envz00_3169)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 201 */
			{
				BgL_failz00_bglt BgL_nodez00_1994;
				obj_t BgL_envz00_1995;

				BgL_nodez00_1994 = ((BgL_failz00_bglt) BgL_nodez00_3168);
				BgL_envz00_1995 = BgL_envz00_3169;
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1994))->BgL_procz00),
					BgL_envz00_1995);
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_failz00_bglt)
							CREF(BgL_nodez00_1994))->BgL_msgz00), BgL_envz00_1995);
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_failz00_bglt)
							CREF(BgL_nodez00_1994))->BgL_objz00), BgL_envz00_1995);
				return BgL_envz00_1995;
			}
		}
	}



/* &dataflow-node!-condi1382 */
	obj_t BGl_z62dataflowzd2nodez12zd2condi1382z70zzdataflow_walkz00(obj_t
		BgL_envz00_3170, obj_t BgL_nodez00_3171, obj_t BgL_envz00_3172)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 178 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1953;
				obj_t BgL_envz00_1954;

				BgL_nodez00_1953 = ((BgL_conditionalz00_bglt) BgL_nodez00_3171);
				BgL_envz00_1954 = BgL_envz00_3172;
				{	/* Dataflow/walk.scm 189 */
					obj_t BgL_tenvz00_1959;

					BgL_tenvz00_1959 =
						BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
						(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1953))->BgL_testz00),
						BgL_envz00_1954);
					{	/* Dataflow/walk.scm 189 */
						obj_t BgL_truezd2envzd2_1960;

						BgL_truezd2envzd2_1960 =
							BGl_appendzd221011zd2zzdataflow_walkz00
							(BGl_dataflowzd2testzd2envz00zzdataflow_walkz00(((
										(BgL_conditionalz00_bglt) CREF(BgL_nodez00_1953))->
									BgL_testz00)), BgL_tenvz00_1959);
						{	/* Dataflow/walk.scm 190 */
							obj_t BgL_falsezd2envzd2_1961;

							BgL_falsezd2envzd2_1961 =
								BGl_appendzd221011zd2zzdataflow_walkz00
								(BGl_dataflowzd2testzd2falsezd2envzd2zzdataflow_walkz00(((
											(BgL_conditionalz00_bglt) CREF(BgL_nodez00_1953))->
										BgL_testz00)), BgL_tenvz00_1959);
							{	/* Dataflow/walk.scm 191 */

								{	/* Dataflow/walk.scm 192 */
									obj_t BgL_tenvz00_1962;
									obj_t BgL_fenvz00_1963;

									BgL_tenvz00_1962 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1953))->
											BgL_falsez00), BgL_falsezd2envzd2_1961);
									BgL_fenvz00_1963 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(((
												(BgL_conditionalz00_bglt) CREF(BgL_nodez00_1953))->
											BgL_truez00), BgL_truezd2envzd2_1960);
									{	/* Dataflow/walk.scm 194 */
										bool_t BgL_testz00_4216;

										{	/* Dataflow/walk.scm 194 */
											BgL_nodez00_bglt BgL_arg1699z00_1965;

											BgL_arg1699z00_1965 =
												(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1953))->
												BgL_falsez00);
											BgL_testz00_4216 =
												CBOOL(BGl_abortzf3zf3zzdataflow_walkz00
												(BgL_arg1699z00_1965));
										}
										if (BgL_testz00_4216)
											{	/* Dataflow/walk.scm 194 */
												return BgL_tenvz00_1962;
											}
										else
											{	/* Dataflow/walk.scm 194 */
												return
													BGl_zc3anonymousza31711ze3z83zzdataflow_walkz00
													(BgL_fenvz00_1963, BgL_tenvz00_1962);
											}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* <anonymous:1711> */
	obj_t BGl_zc3anonymousza31711ze3z83zzdataflow_walkz00(obj_t BgL_env2z00_3201,
		obj_t BgL_lis1329z00_1977)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 181 */
		BGl_zc3anonymousza31711ze3z83zzdataflow_walkz00:
			if (NULLP(BgL_lis1329z00_1977))
				{	/* Dataflow/walk.scm 181 */
					return BgL_lis1329z00_1977;
				}
			else
				{	/* Dataflow/walk.scm 181 */
					obj_t BgL_head1330z00_1980;
					obj_t BgL_tail1331z00_1981;

					BgL_head1330z00_1980 = CAR(BgL_lis1329z00_1977);
					BgL_tail1331z00_1981 = CDR(BgL_lis1329z00_1977);
					{	/* Dataflow/walk.scm 181 */
						bool_t BgL_testz00_4226;

						{	/* Dataflow/walk.scm 183 */
							obj_t BgL_c2z00_1988;

							BgL_c2z00_1988 =
								BGl_assqz00zz__r4_pairs_and_lists_6_3z00(CAR
								(BgL_head1330z00_1980), BgL_env2z00_3201);
							{	/* Dataflow/walk.scm 184 */

								if (PAIRP(BgL_c2z00_1988))
									{	/* Dataflow/walk.scm 185 */
										BgL_testz00_4226 =
											(CDR(BgL_c2z00_1988) == CDR(BgL_head1330z00_1980));
									}
								else
									{	/* Dataflow/walk.scm 185 */
										BgL_testz00_4226 = ((bool_t) 0);
									}
							}
						}
						if (BgL_testz00_4226)
							{	/* Dataflow/walk.scm 181 */
								obj_t BgL_newzd2tail1332zd2_1983;

								BgL_newzd2tail1332zd2_1983 =
									BGl_zc3anonymousza31711ze3z83zzdataflow_walkz00
									(BgL_env2z00_3201, BgL_tail1331z00_1981);
								if ((BgL_tail1331z00_1981 == BgL_newzd2tail1332zd2_1983))
									{	/* Dataflow/walk.scm 181 */
										return BgL_lis1329z00_1977;
									}
								else
									{	/* Dataflow/walk.scm 181 */
										obj_t BgL_res2051z00_2822;

										BgL_res2051z00_2822 =
											MAKE_PAIR(BgL_head1330z00_1980,
											BgL_newzd2tail1332zd2_1983);
										return BgL_res2051z00_2822;
									}
							}
						else
							{
								obj_t BgL_lis1329z00_4238;

								BgL_lis1329z00_4238 = BgL_tail1331z00_1981;
								BgL_lis1329z00_1977 = BgL_lis1329z00_4238;
								goto BGl_zc3anonymousza31711ze3z83zzdataflow_walkz00;
							}
					}
				}
		}
	}



/* &dataflow-node!-setq1378 */
	obj_t BGl_z62dataflowzd2nodez12zd2setq1378z70zzdataflow_walkz00(obj_t
		BgL_envz00_3173, obj_t BgL_nodez00_3174, obj_t BgL_envz00_3175)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 158 */
			{
				BgL_setqz00_bglt BgL_nodez00_1916;
				obj_t BgL_envz00_1917;

				BgL_nodez00_1916 = ((BgL_setqz00_bglt) BgL_nodez00_3174);
				BgL_envz00_1917 = BgL_envz00_3175;
				{	/* Dataflow/walk.scm 166 */
					obj_t BgL_nenvz00_1922;

					BgL_nenvz00_1922 =
						BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1916))->BgL_valuez00),
						BgL_envz00_1917);
					{	/* Dataflow/walk.scm 167 */
						BgL_varz00_bglt BgL_i1154z00_1923;

						BgL_i1154z00_1923 =
							(((BgL_setqz00_bglt) CREF(BgL_nodez00_1916))->BgL_varz00);
						{	/* Dataflow/walk.scm 168 */
							bool_t BgL_testz00_4242;

							{	/* Dataflow/walk.scm 168 */
								BgL_variablez00_bglt BgL_arg1689z00_1933;

								BgL_arg1689z00_1933 =
									(((BgL_varz00_bglt) CREF(BgL_i1154z00_1923))->
									BgL_variablez00);
								{	/* Dataflow/walk.scm 168 */
									bool_t BgL_res2047z00_2807;

									BgL_res2047z00_2807 =
										BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_arg1689z00_1933), BGl_globalz00zzast_varz00);
									BgL_testz00_4242 = BgL_res2047z00_2807;
								}
							}
							if (BgL_testz00_4242)
								{	/* Dataflow/walk.scm 168 */
									return
										BGl_zc3anonymousza31692ze3z83zzdataflow_walkz00(
										(((BgL_varz00_bglt) CREF(BgL_i1154z00_1923))->
											BgL_variablez00), BgL_nenvz00_1922);
								}
							else
								{	/* Dataflow/walk.scm 170 */
									BgL_typez00_bglt BgL_typz00_1926;

									BgL_typz00_1926 =
										BGl_getzd2typezd2zztype_typeofz00(
										(((BgL_setqz00_bglt) CREF(BgL_nodez00_1916))->
											BgL_valuez00));
									{	/* Dataflow/walk.scm 171 */
										bool_t BgL_testz00_4250;

										if (
											(((obj_t) BgL_typz00_1926) ==
												BGl_za2_za2z00zztype_cachez00))
											{	/* Dataflow/walk.scm 171 */
												BgL_testz00_4250 = ((bool_t) 1);
											}
										else
											{	/* Dataflow/walk.scm 171 */
												BgL_testz00_4250 =
													(
													((obj_t) BgL_typz00_1926) ==
													BGl_za2objza2z00zztype_cachez00);
											}
										if (BgL_testz00_4250)
											{	/* Dataflow/walk.scm 171 */
												return
													BGl_zc3anonymousza31692ze3z83zzdataflow_walkz00(
													(((BgL_varz00_bglt) CREF(BgL_i1154z00_1923))->
														BgL_variablez00), BgL_nenvz00_1922);
											}
										else
											{	/* Dataflow/walk.scm 173 */
												obj_t BgL_arg1685z00_1929;

												{	/* Dataflow/walk.scm 173 */
													BgL_variablez00_bglt BgL_arg1686z00_1930;

													BgL_arg1686z00_1930 =
														(((BgL_varz00_bglt) CREF(BgL_i1154z00_1923))->
														BgL_variablez00);
													BgL_arg1685z00_1929 =
														MAKE_PAIR(((obj_t) BgL_arg1686z00_1930),
														((obj_t) BgL_typz00_1926));
												}
												return MAKE_PAIR(BgL_arg1685z00_1929, BgL_nenvz00_1922);
											}
									}
								}
						}
					}
				}
			}
		}
	}



/* <anonymous:1692> */
	obj_t BGl_zc3anonymousza31692ze3z83zzdataflow_walkz00(BgL_variablez00_bglt
		BgL_variablez00_3200, obj_t BgL_lis1324z00_1939)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 161 */
		BGl_zc3anonymousza31692ze3z83zzdataflow_walkz00:
			if (NULLP(BgL_lis1324z00_1939))
				{	/* Dataflow/walk.scm 161 */
					return BgL_lis1324z00_1939;
				}
			else
				{	/* Dataflow/walk.scm 161 */
					obj_t BgL_head1325z00_1942;
					obj_t BgL_tail1326z00_1943;

					BgL_head1325z00_1942 = CAR(BgL_lis1324z00_1939);
					BgL_tail1326z00_1943 = CDR(BgL_lis1324z00_1939);
					{	/* Dataflow/walk.scm 161 */
						bool_t BgL_testz00_4268;

						if ((CAR(BgL_head1325z00_1942) == ((obj_t) BgL_variablez00_3200)))
							{	/* Dataflow/walk.scm 162 */
								BgL_testz00_4268 = ((bool_t) 0);
							}
						else
							{	/* Dataflow/walk.scm 162 */
								BgL_testz00_4268 = ((bool_t) 1);
							}
						if (BgL_testz00_4268)
							{	/* Dataflow/walk.scm 161 */
								obj_t BgL_newzd2tail1327zd2_1945;

								BgL_newzd2tail1327zd2_1945 =
									BGl_zc3anonymousza31692ze3z83zzdataflow_walkz00
									(BgL_variablez00_3200, BgL_tail1326z00_1943);
								if ((BgL_tail1326z00_1943 == BgL_newzd2tail1327zd2_1945))
									{	/* Dataflow/walk.scm 161 */
										return BgL_lis1324z00_1939;
									}
								else
									{	/* Dataflow/walk.scm 161 */
										obj_t BgL_res2046z00_2805;

										BgL_res2046z00_2805 =
											MAKE_PAIR(BgL_head1325z00_1942,
											BgL_newzd2tail1327zd2_1945);
										return BgL_res2046z00_2805;
									}
							}
						else
							{
								obj_t BgL_lis1324z00_4277;

								BgL_lis1324z00_4277 = BgL_tail1326z00_1943;
								BgL_lis1324z00_1939 = BgL_lis1324z00_4277;
								goto BGl_zc3anonymousza31692ze3z83zzdataflow_walkz00;
							}
					}
				}
		}
	}



/* &dataflow-node!-exter1376 */
	obj_t BGl_z62dataflowzd2nodez12zd2exter1376z70zzdataflow_walkz00(obj_t
		BgL_envz00_3176, obj_t BgL_nodez00_3177, obj_t BgL_envz00_3178)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 151 */
			{
				BgL_externz00_bglt BgL_nodez00_1910;
				obj_t BgL_envz00_1911;

				BgL_nodez00_1910 = ((BgL_externz00_bglt) BgL_nodez00_3177);
				BgL_envz00_1911 = BgL_envz00_3178;
				return
					BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(
					(((BgL_externz00_bglt) CREF(BgL_nodez00_1910))->BgL_exprza2za2),
					BgL_envz00_1911);
			}
		}
	}



/* &dataflow-node!-funca1374 */
	obj_t BGl_z62dataflowzd2nodez12zd2funca1374z70zzdataflow_walkz00(obj_t
		BgL_envz00_3179, obj_t BgL_nodez00_3180, obj_t BgL_envz00_3181)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 143 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1902;
				obj_t BgL_envz00_1903;

				BgL_nodez00_1902 = ((BgL_funcallz00_bglt) BgL_nodez00_3180);
				BgL_envz00_1903 = BgL_envz00_3181;
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1902))->BgL_funz00),
					BgL_envz00_1903);
				return
					BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00((((BgL_funcallz00_bglt)
							CREF(BgL_nodez00_1902))->BgL_argsz00), BgL_envz00_1903);
			}
		}
	}



/* &dataflow-node!-app-l1372 */
	obj_t BGl_z62dataflowzd2nodez12zd2appzd2l1372za2zzdataflow_walkz00(obj_t
		BgL_envz00_3182, obj_t BgL_nodez00_3183, obj_t BgL_envz00_3184)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 135 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1894;
				obj_t BgL_envz00_1895;

				BgL_nodez00_1894 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_3183);
				BgL_envz00_1895 = BgL_envz00_3184;
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1894))->BgL_funz00),
					BgL_envz00_1895);
				return
					BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_appzd2lyzd2_bglt)
							CREF(BgL_nodez00_1894))->BgL_argz00), BgL_envz00_1895);
			}
		}
	}



/* &dataflow-node!-app1370 */
	obj_t BGl_z62dataflowzd2nodez12zd2app1370z70zzdataflow_walkz00(obj_t
		BgL_envz00_3185, obj_t BgL_nodez00_3186, obj_t BgL_envz00_3187)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 119 */
			{
				BgL_appz00_bglt BgL_nodez00_1867;
				obj_t BgL_envz00_1868;

				BgL_nodez00_1867 = ((BgL_appz00_bglt) BgL_nodez00_3186);
				BgL_envz00_1868 = BgL_envz00_3187;
				{	/* Dataflow/walk.scm 121 */
					obj_t BgL_aenvz00_1872;

					BgL_aenvz00_1872 =
						BGl_dataflowzd2nodeza2z12z62zzdataflow_walkz00(
						(((BgL_appz00_bglt) CREF(BgL_nodez00_1867))->BgL_argsz00),
						BgL_envz00_1868);
					{	/* Dataflow/walk.scm 122 */
						bool_t BgL_testz00_4293;

						{	/* Dataflow/walk.scm 122 */
							bool_t BgL_testz00_4294;

							{	/* Dataflow/walk.scm 122 */
								BgL_varz00_bglt BgL_arg1675z00_1891;

								BgL_arg1675z00_1891 =
									(((BgL_appz00_bglt) CREF(BgL_nodez00_1867))->BgL_funz00);
								{	/* Dataflow/walk.scm 122 */
									bool_t BgL_res2038z00_2769;

									BgL_res2038z00_2769 =
										BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_arg1675z00_1891), BGl_varz00zzast_nodez00);
									BgL_testz00_4294 = BgL_res2038z00_2769;
								}
							}
							if (BgL_testz00_4294)
								{	/* Dataflow/walk.scm 122 */
									BgL_variablez00_bglt BgL_arg1673z00_1889;

									BgL_arg1673z00_1889 =
										(((BgL_varz00_bglt) CREF(
												(((BgL_appz00_bglt) CREF(BgL_nodez00_1867))->
													BgL_funz00)))->BgL_variablez00);
									{	/* Dataflow/walk.scm 122 */
										bool_t BgL_res2039z00_2772;

										BgL_res2039z00_2772 =
											BGl_isazf3zf3zz__objectz00(
											((obj_t) BgL_arg1673z00_1889), BGl_localz00zzast_varz00);
										BgL_testz00_4293 = BgL_res2039z00_2772;
									}
								}
							else
								{	/* Dataflow/walk.scm 122 */
									BgL_testz00_4293 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_4293)
							{	/* Dataflow/walk.scm 122 */
								return
									BGl_zc3anonymousza31665ze3z83zzdataflow_walkz00
									(BgL_aenvz00_1872);
							}
						else
							{	/* Dataflow/walk.scm 122 */
								return BgL_aenvz00_1872;
							}
					}
				}
			}
		}
	}



/* <anonymous:1665> */
	obj_t BGl_zc3anonymousza31665ze3z83zzdataflow_walkz00(obj_t
		BgL_lis1319z00_1875)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 126 */
		BGl_zc3anonymousza31665ze3z83zzdataflow_walkz00:
			if (NULLP(BgL_lis1319z00_1875))
				{	/* Dataflow/walk.scm 126 */
					return BgL_lis1319z00_1875;
				}
			else
				{	/* Dataflow/walk.scm 126 */
					obj_t BgL_head1320z00_1878;
					obj_t BgL_tail1321z00_1879;

					BgL_head1320z00_1878 = CAR(BgL_lis1319z00_1875);
					BgL_tail1321z00_1879 = CDR(BgL_lis1319z00_1875);
					{	/* Dataflow/walk.scm 126 */
						bool_t BgL_testz00_4308;

						{	/* Dataflow/walk.scm 127 */
							obj_t BgL_vz00_1884;

							BgL_vz00_1884 = CAR(BgL_head1320z00_1878);
							{	/* Dataflow/walk.scm 128 */
								bool_t BgL__ortest_1150z00_1885;

								BgL__ortest_1150z00_1885 =
									BGl_isazf3zf3zz__objectz00(BgL_vz00_1884,
									BGl_globalz00zzast_varz00);
								if (BgL__ortest_1150z00_1885)
									{	/* Dataflow/walk.scm 128 */
										BgL_testz00_4308 = BgL__ortest_1150z00_1885;
									}
								else
									{	/* Dataflow/walk.scm 128 */
										BgL_testz00_4308 =
											(
											(((BgL_variablez00_bglt) CREF(
														((BgL_variablez00_bglt) BgL_vz00_1884)))->
												BgL_accessz00) == CNST_TABLE_REF(((long) 11)));
						}}}
						if (BgL_testz00_4308)
							{	/* Dataflow/walk.scm 126 */
								obj_t BgL_newzd2tail1322zd2_1881;

								BgL_newzd2tail1322zd2_1881 =
									BGl_zc3anonymousza31665ze3z83zzdataflow_walkz00
									(BgL_tail1321z00_1879);
								if ((BgL_tail1321z00_1879 == BgL_newzd2tail1322zd2_1881))
									{	/* Dataflow/walk.scm 126 */
										return BgL_lis1319z00_1875;
									}
								else
									{	/* Dataflow/walk.scm 126 */
										obj_t BgL_res2043z00_2786;

										BgL_res2043z00_2786 =
											MAKE_PAIR(BgL_head1320z00_1878,
											BgL_newzd2tail1322zd2_1881);
										return BgL_res2043z00_2786;
									}
							}
						else
							{
								obj_t BgL_lis1319z00_4320;

								BgL_lis1319z00_4320 = BgL_tail1321z00_1879;
								BgL_lis1319z00_1875 = BgL_lis1319z00_4320;
								goto BGl_zc3anonymousza31665ze3z83zzdataflow_walkz00;
							}
					}
				}
		}
	}



/* &dataflow-node!-sync1368 */
	obj_t BGl_z62dataflowzd2nodez12zd2sync1368z70zzdataflow_walkz00(obj_t
		BgL_envz00_3188, obj_t BgL_nodez00_3189, obj_t BgL_envz00_3190)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 110 */
			{
				BgL_syncz00_bglt BgL_nodez00_1859;
				obj_t BgL_envz00_1860;

				BgL_nodez00_1859 = ((BgL_syncz00_bglt) BgL_nodez00_3189);
				BgL_envz00_1860 = BgL_envz00_3190;
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1859))->BgL_mutexz00),
					BgL_envz00_1860);
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_syncz00_bglt)
							CREF(BgL_nodez00_1859))->BgL_prelockz00), BgL_envz00_1860);
				BGl_dataflowzd2nodez12zc0zzdataflow_walkz00((((BgL_syncz00_bglt)
							CREF(BgL_nodez00_1859))->BgL_bodyz00), BgL_envz00_1860);
				return BgL_envz00_1860;
			}
		}
	}



/* &dataflow-node!-seque1366 */
	obj_t BGl_z62dataflowzd2nodez12zd2seque1366z70zzdataflow_walkz00(obj_t
		BgL_envz00_3191, obj_t BgL_nodez00_3192, obj_t BgL_envz00_3193)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 100 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1844;
				obj_t BgL_envz00_1845;

				BgL_nodez00_1844 = ((BgL_sequencez00_bglt) BgL_nodez00_3192);
				BgL_envz00_1845 = BgL_envz00_3193;
				{	/* Dataflow/walk.scm 101 */
					obj_t BgL_g1148z00_1848;

					BgL_g1148z00_1848 =
						(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1844))->BgL_nodesz00);
					{
						obj_t BgL_nodeza2za2_1850;
						obj_t BgL_envz00_1851;

						BgL_nodeza2za2_1850 = BgL_g1148z00_1848;
						BgL_envz00_1851 = BgL_envz00_1845;
					BgL_zc3anonymousza31644ze3z83_1852:
						if (NULLP(BgL_nodeza2za2_1850))
							{	/* Dataflow/walk.scm 103 */
								return BgL_envz00_1851;
							}
						else
							{	/* Dataflow/walk.scm 105 */
								obj_t BgL_arg1647z00_1854;
								obj_t BgL_arg1651z00_1855;

								BgL_arg1647z00_1854 = CDR(BgL_nodeza2za2_1850);
								{	/* Dataflow/walk.scm 105 */
									obj_t BgL_arg1652z00_1856;

									BgL_arg1652z00_1856 = CAR(BgL_nodeza2za2_1850);
									BgL_arg1651z00_1855 =
										BGl_dataflowzd2nodez12zc0zzdataflow_walkz00(
										((BgL_nodez00_bglt) BgL_arg1652z00_1856), BgL_envz00_1851);
								}
								{
									obj_t BgL_envz00_4336;
									obj_t BgL_nodeza2za2_4335;

									BgL_nodeza2za2_4335 = BgL_arg1647z00_1854;
									BgL_envz00_4336 = BgL_arg1651z00_1855;
									BgL_envz00_1851 = BgL_envz00_4336;
									BgL_nodeza2za2_1850 = BgL_nodeza2za2_4335;
									goto BgL_zc3anonymousza31644ze3z83_1852;
								}
							}
					}
				}
			}
		}
	}



/* &dataflow-node!-closu1364 */
	obj_t BGl_z62dataflowzd2nodez12zd2closu1364z70zzdataflow_walkz00(obj_t
		BgL_envz00_3194, obj_t BgL_nodez00_3195, obj_t BgL_envz00_3196)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 94 */
			return BgL_envz00_3196;
		}
	}



/* &dataflow-node!-var1362 */
	obj_t BGl_z62dataflowzd2nodez12zd2var1362z70zzdataflow_walkz00(obj_t
		BgL_envz00_3197, obj_t BgL_nodez00_3198, obj_t BgL_envz00_3199)
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 80 */
			{
				BgL_varz00_bglt BgL_nodez00_1820;
				obj_t BgL_envz00_1821;

				BgL_nodez00_1820 = ((BgL_varz00_bglt) BgL_nodez00_3198);
				BgL_envz00_1821 = BgL_envz00_3199;
				{	/* Dataflow/walk.scm 82 */
					BgL_variablez00_bglt BgL_i1146z00_1825;

					BgL_i1146z00_1825 =
						(((BgL_varz00_bglt) CREF(BgL_nodez00_1820))->BgL_variablez00);
					{	/* Dataflow/walk.scm 83 */
						bool_t BgL_testz00_4339;

						if (BGl_bigloozd2typezf3z21zztype_typez00(
								(((BgL_variablez00_bglt) CREF(BgL_i1146z00_1825))->
									BgL_typez00)))
							{	/* Dataflow/walk.scm 84 */
								bool_t BgL__ortest_1147z00_1832;

								{	/* Dataflow/walk.scm 84 */
									bool_t BgL_testz00_4343;

									{	/* Dataflow/walk.scm 84 */
										BgL_typez00_bglt BgL_arg1635z00_1836;

										BgL_arg1635z00_1836 =
											(((BgL_variablez00_bglt) CREF(BgL_i1146z00_1825))->
											BgL_typez00);
										{	/* Dataflow/walk.scm 84 */
											bool_t BgL_res2035z00_2755;

											BgL_res2035z00_2755 =
												BGl_isazf3zf3zz__objectz00(
												((obj_t) BgL_arg1635z00_1836),
												BGl_tclassz00zzobject_classz00);
											BgL_testz00_4343 = BgL_res2035z00_2755;
										}
									}
									if (BgL_testz00_4343)
										{	/* Dataflow/walk.scm 84 */
											BgL__ortest_1147z00_1832 = ((bool_t) 0);
										}
									else
										{	/* Dataflow/walk.scm 84 */
											BgL__ortest_1147z00_1832 = ((bool_t) 1);
										}
								}
								if (BgL__ortest_1147z00_1832)
									{	/* Dataflow/walk.scm 84 */
										BgL_testz00_4339 = BgL__ortest_1147z00_1832;
									}
								else
									{	/* Dataflow/walk.scm 84 */
										BgL_typez00_bglt BgL_arg1631z00_1833;
										BgL_typez00_bglt BgL_arg1633z00_1834;

										BgL_arg1631z00_1833 =
											(((BgL_variablez00_bglt) CREF(BgL_i1146z00_1825))->
											BgL_typez00);
										BgL_arg1633z00_1834 =
											(((BgL_nodez00_bglt) CREF(((BgL_nodez00_bglt)
														BgL_nodez00_1820)))->BgL_typez00);
										BgL_testz00_4339 =
											BGl_typezd2subclasszf3z21zzobject_classz00
											(BgL_arg1631z00_1833, BgL_arg1633z00_1834);
									}
							}
						else
							{	/* Dataflow/walk.scm 83 */
								BgL_testz00_4339 = ((bool_t) 0);
							}
						if (BgL_testz00_4339)
							{	/* Dataflow/walk.scm 85 */
								obj_t BgL_bz00_1827;

								BgL_bz00_1827 =
									BGl_assqz00zz__r4_pairs_and_lists_6_3z00(
									((obj_t)
										(((BgL_varz00_bglt) CREF(BgL_nodez00_1820))->
											BgL_variablez00)), BgL_envz00_1821);
								if (PAIRP(BgL_bz00_1827))
									{	/* Dataflow/walk.scm 86 */
										((((BgL_nodez00_bglt) CREF(
														((BgL_nodez00_bglt) BgL_nodez00_1820)))->
												BgL_typez00) =
											((BgL_typez00_bglt) ((BgL_typez00_bglt)
													CDR(BgL_bz00_1827))), BUNSPEC);
									}
								else
									{	/* Dataflow/walk.scm 86 */
										((((BgL_nodez00_bglt) CREF(
														((BgL_nodez00_bglt) BgL_nodez00_1820)))->
												BgL_typez00) =
											((BgL_typez00_bglt) (((BgL_variablez00_bglt)
														CREF((((BgL_varz00_bglt) CREF(BgL_nodez00_1820))->
																BgL_variablez00)))->BgL_typez00)), BUNSPEC);
									}
							}
						else
							{	/* Dataflow/walk.scm 83 */
								BFALSE;
							}
					}
				}
				return BgL_envz00_1821;
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zzdataflow_walkz00()
	{
		AN_OBJECT;
		{	/* Dataflow/walk.scm 17 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_tracez00(((long) 54713316),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typeofz00(((long) 189813582),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_cachez00(((long) 216926614),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_miscz00(((long) 49975086),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzobject_classz00(((long) 481724379),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_cgraphz00(((long) 271385047),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_spreadz00(((long) 348216764),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			BGl_modulezd2initializa7ationz75zzeffect_feffectz00(((long) 516374368),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 122361728),
				BSTRING_TO_STRING(BGl_string2148z00zzdataflow_walkz00));
		}
	}

#ifdef __cplusplus
}
#endif
