/*===========================================================================*/
/*   (Trace/walk.scm)                                                        */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -q -afile .afile -fsharing -fno-reflection -cc gcc -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -unsafev -gno-error-localization -no-hello -O2 -rm -unsafe -s -indent Trace/walk.scm)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_typez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		obj_t BgL_siza7eza7;
		obj_t BgL_classz00;
		obj_t BgL_coercezd2tozd2;
		obj_t BgL_parentsz00;
		bool_t BgL_initzf3zf3;
		bool_t BgL_magiczf3zf3;
		obj_t BgL_z42z42;
		obj_t BgL_aliasz00;
		obj_t BgL_pointedzd2tozd2byz00;
		obj_t BgL_tvectorz00;
		obj_t BgL_locationz00;
		obj_t BgL_importzd2locationzd2;
		int BgL_occurrencez00;
	}              *BgL_typez00_bglt;

	typedef struct BgL_valuez00_bgl
	{
		header_t header;
		obj_t widening;
	}               *BgL_valuez00_bglt;

	typedef struct BgL_variablez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
	}                  *BgL_variablez00_bglt;

	typedef struct BgL_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_idz00;
		obj_t BgL_namez00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_valuez00_bgl *BgL_valuez00;
		obj_t BgL_accessz00;
		obj_t BgL_fastzd2alphazd2;
		obj_t BgL_removablez00;
		long BgL_occurrencez00;
		long BgL_occurrencewz00;
		bool_t BgL_userzf3zf3;
		obj_t BgL_modulez00;
		obj_t BgL_importz00;
		bool_t BgL_evaluablezf3zf3;
		bool_t BgL_evalzf3zf3;
		obj_t BgL_libraryz00;
		obj_t BgL_pragmaz00;
		obj_t BgL_srcz00;
		obj_t BgL_jvmzd2typezd2namez00;
		obj_t BgL_initz00;
		obj_t BgL_aliasz00;
	}                *BgL_globalz00_bglt;

	typedef struct BgL_funz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
	}             *BgL_funz00_bglt;

	typedef struct BgL_sfunz00_bgl
	{
		header_t header;
		obj_t widening;
		long BgL_arityz00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_predicatezd2ofzd2;
		obj_t BgL_stackzd2allocatorzd2;
		bool_t BgL_topzf3zf3;
		obj_t BgL_thezd2closurezd2;
		obj_t BgL_effectz00;
		obj_t BgL_failsafez00;
		obj_t BgL_propertyz00;
		obj_t BgL_argsz00;
		obj_t BgL_argszd2namezd2;
		obj_t BgL_bodyz00;
		obj_t BgL_classz00;
		obj_t BgL_dssslzd2keywordszd2;
		obj_t BgL_locz00;
		obj_t BgL_optionalsz00;
		obj_t BgL_keysz00;
		obj_t BgL_thezd2closurezd2globalz00;
		obj_t BgL_strengthz00;
	}              *BgL_sfunz00_bglt;

	typedef struct BgL_nodez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
	}              *BgL_nodez00_bglt;

	typedef struct BgL_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_variablez00_bgl *BgL_variablez00;
	}             *BgL_varz00_bglt;

	typedef struct BgL_sequencez00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_nodesz00;
		bool_t BgL_unsafez00;
	}                  *BgL_sequencez00_bglt;

	typedef struct BgL_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
	}             *BgL_appz00_bglt;

	typedef struct BgL_appzd2lyzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}                  *BgL_appzd2lyzd2_bglt;

	typedef struct BgL_funcallz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_strengthz00;
		obj_t BgL_functionsz00;
	}                 *BgL_funcallz00_bglt;

	typedef struct BgL_externz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_exprza2za2;
		obj_t BgL_effectz00;
	}                *BgL_externz00_bglt;

	typedef struct BgL_castz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_argz00;
	}              *BgL_castz00_bglt;

	typedef struct BgL_setqz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}              *BgL_setqz00_bglt;

	typedef struct BgL_conditionalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		struct BgL_nodez00_bgl *BgL_truez00;
		struct BgL_nodez00_bgl *BgL_falsez00;
	}                     *BgL_conditionalz00_bglt;

	typedef struct BgL_failz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_procz00;
		struct BgL_nodez00_bgl *BgL_msgz00;
		struct BgL_nodez00_bgl *BgL_objz00;
	}              *BgL_failz00_bglt;

	typedef struct BgL_selectz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_testz00;
		obj_t BgL_clausesz00;
		struct BgL_typez00_bgl *BgL_itemzd2typezd2;
	}                *BgL_selectz00_bglt;

	typedef struct BgL_letzd2funzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_localsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                   *BgL_letzd2funzd2_bglt;

	typedef struct BgL_letzd2varzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		obj_t BgL_bindingsz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
		bool_t BgL_removablezf3zf3;
	}                   *BgL_letzd2varzd2_bglt;

	typedef struct BgL_setzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}                       *BgL_setzd2exzd2itz00_bglt;

	typedef struct BgL_jumpzd2exzd2itz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_exitz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
	}                        *BgL_jumpzd2exzd2itz00_bglt;

	typedef struct BgL_makezd2boxzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                    *BgL_makezd2boxzd2_bglt;

	typedef struct BgL_boxzd2refzd2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		obj_t BgL_sidezd2effectzd2;
		obj_t BgL_keyz00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                   *BgL_boxzd2refzd2_bglt;

	typedef struct BgL_boxzd2setz12zc0_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_varz00_bgl *BgL_varz00;
		struct BgL_nodez00_bgl *BgL_valuez00;
		struct BgL_typez00_bgl *BgL_vtypez00;
	}                      *BgL_boxzd2setz12zc0_bglt;

	typedef struct BgL_syncz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_typez00_bgl *BgL_typez00;
		struct BgL_nodez00_bgl *BgL_mutexz00;
		struct BgL_nodez00_bgl *BgL_prelockz00;
		struct BgL_nodez00_bgl *BgL_bodyz00;
	}              *BgL_syncz00_bglt;

	typedef struct BgL_backendz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_languagez00;
		obj_t BgL_srfi0z00;
		obj_t BgL_namez00;
		obj_t BgL_externzd2variableszd2;
		obj_t BgL_externzd2functionszd2;
		obj_t BgL_externzd2typeszd2;
		obj_t BgL_variablesz00;
		obj_t BgL_functionsz00;
		obj_t BgL_typesz00;
		bool_t BgL_typedz00;
		obj_t BgL_heapzd2suffixzd2;
		obj_t BgL_heapzd2compatiblezd2;
		bool_t BgL_callccz00;
		bool_t BgL_qualifiedzd2typeszd2;
		bool_t BgL_effectzb2zb2;
		bool_t BgL_removezd2emptyzd2letz00;
		bool_t BgL_foreignzd2closurezd2;
		bool_t BgL_typedzd2eqzd2;
		bool_t BgL_tracezd2supportzd2;
		obj_t BgL_foreignzd2clausezd2supportz00;
		obj_t BgL_debugzd2supportzd2;
		bool_t BgL_pragmazd2supportzd2;
		bool_t BgL_tvectorzd2descrzd2supportz00;
		bool_t BgL_requirezd2tailczd2;
		obj_t BgL_registersz00;
		obj_t BgL_pregistersz00;
		bool_t BgL_boundzd2checkzd2;
		bool_t BgL_typezd2checkzd2;
		bool_t BgL_typedzd2funcallzd2;
	}                 *BgL_backendz00_bglt;


	static obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2exter1315zb0zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT obj_t bgl_display_obj(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sequence1335z62zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_syncz00zzast_nodez00;
	extern obj_t BGl_sequencez00zzast_nodez00;
	BGL_IMPORT obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2condi1319zb0zztrace_walkz00(obj_t,
		obj_t);
	BGL_IMPORT bool_t BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00(obj_t);
	extern obj_t BGl_letzd2varzd2zzast_nodez00;
	extern obj_t BGl_failz00zzast_nodez00;
	static obj_t BGl_objectzd2initzd2zztrace_walkz00();
	BGL_EXPORTED_DECL obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_memqz00zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
	BGL_IMPORT bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	extern obj_t BGl_boxzd2refzd2zzast_nodez00;
	BGL_IMPORT obj_t bstring_to_symbol(obj_t);
	extern obj_t BGl_thezd2backendzd2zzbackend_backendz00();
	BGL_IMPORT bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2condition1352z62zztrace_walkz00(obj_t, obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zztrace_walkz00();
	static obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1327z62zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_externz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1325z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt,
		BgL_typez00_bglt, obj_t, obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21331z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt,
		obj_t);
	static obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_pragmaz00zzast_nodez00;
	extern BgL_typez00_bglt
		BGl_strictzd2nodezd2typez00zzast_nodez00(BgL_typez00_bglt,
		BgL_typez00_bglt);
	static BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1364z62zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_findzd2locationzd2zztools_locationz00(obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2setq1317zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_enterzd2functionzd2zztools_errorz00(obj_t);
	extern obj_t BGl_appzd2lyzd2zzast_nodez00;
	static obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21382zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21384zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2nodezd21386zb0zztrace_walkz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2funcall1343z62zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_za2currentzd2passza2zd2zzengine_passz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2cast1348z62zztrace_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	BGL_IMPORT obj_t BGl_genericzd2addzd2methodz12z12zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_variablez00zzast_varz00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2makezd2box1366zb0zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2ref1368zb0zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121370za2zztrace_walkz00(obj_t, obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62toplevelzd2tracezd2node1371z62zztrace_walkz00(obj_t, obj_t);
	extern obj_t BGl_conditionalz00zzast_nodez00;
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setq1350z62zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00;
	extern obj_t BGl_selectz00zzast_nodez00;
	extern obj_t BGl_verbosez00zztools_speekz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1311z62zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2selec1323zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setqz00zzast_nodez00;
	extern obj_t BGl_locationzd2fullzd2fnamez00zztools_locationz00(obj_t);
	static obj_t BGl_requirezd2initializa7ationz75zztrace_walkz00 = BUNSPEC;
	extern obj_t BGl_makezd2typedzd2identz00zzast_identz00(obj_t, obj_t);
	static obj_t BGl_z62findzd2lastzd2nodezd2funca1313zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_setzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t);
	BGL_IMPORT obj_t BGl_registerzd2genericz12zc0zz__objectz00(obj_t, obj_t,
		obj_t, obj_t);
	extern obj_t BGl_atomz00zzast_nodez00;
	static bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t);
	static obj_t BGl_toplevelzd2initzd2zztrace_walkz00();
	extern obj_t BGl_internalzd2errorzd2zztools_errorz00(obj_t, obj_t, obj_t);
	static obj_t BGl_genericzd2initzd2zztrace_walkz00();
	BGL_IMPORT obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_leavezd2functionzd2zztools_errorz00();
	static obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt);
	extern obj_t BGl_castz00zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1339z62zztrace_walkz00(obj_t,
		obj_t, obj_t);
	static bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t, obj_t);
	BGL_IMPORT obj_t BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00(obj_t,
		obj_t, obj_t);
	extern obj_t BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00;
	static obj_t BGl_z62findzd2lastzd2nodezd2app1309zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_findzd2globalzd2zzast_envz00(obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2fun1358zb0zztrace_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_varz00zzast_nodez00;
	extern obj_t BGl_makezd2boxzd2zzast_nodez00;
	static BgL_nodez00_bglt BGl_z62findzd2lastzd2node1302z62zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2select1356z62zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2appzd2ly1341zb0zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_za2moduleza2z00zzmodule_modulez00;
	BGL_IMPORT obj_t BGl_exitz00zz__errorz00(obj_t);
	extern obj_t BGl_boxzd2setz12zc0zzast_nodez00;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzmodule_modulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_identz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_sexpz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzbackend_backendz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_envz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_locationz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_miscz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_shapez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_letz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_nodez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzast_varz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztype_typez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zzengine_passz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zztools_speekz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	BGL_IMPORT obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long,
		char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_appz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2sync1307zb0zztrace_walkz00(obj_t,
		obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2extern1345z62zztrace_walkz00(obj_t, obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1362z62zztrace_walkz00(obj_t, obj_t,
		obj_t);
	extern obj_t BGl_nodez00zzast_nodez00;
	extern obj_t BGl_kwotez00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2fail1321zb0zztrace_walkz00(obj_t,
		obj_t);
	extern obj_t BGl_localz00zzast_varz00;
	extern obj_t BGl_jumpzd2exzd2itz00zzast_nodez00;
	static obj_t BGl_z62findzd2lastzd2nodezd2seque1305zb0zztrace_walkz00(obj_t,
		obj_t);
	static obj_t BGl_cnstzd2initzd2zztrace_walkz00();
	static obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
	static obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00();
	static BgL_nodez00_bglt BGl_z62tracezd2node1332zb0zztrace_walkz00(obj_t,
		obj_t, obj_t);
	extern BgL_nodez00_bglt BGl_sexpzd2ze3nodez31zzast_sexpz00(obj_t, obj_t,
		obj_t, obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2letzd2var1360zb0zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_letzd2funzd2zzast_nodez00;
	extern bool_t BGl_userzd2symbolzf3z21zzast_identz00(obj_t);
	extern obj_t BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2sync1337z62zztrace_walkz00(obj_t, obj_t, obj_t);
	BGL_IMPORT obj_t BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(obj_t);
	static BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2fail1354z62zztrace_walkz00(obj_t, obj_t, obj_t);
	extern obj_t BGl_funcallz00zzast_nodez00;
	extern obj_t BGl_globalz00zzast_varz00;
	static obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1329z62zztrace_walkz00(obj_t,
		obj_t);
	static obj_t __cnst[21];


	   
		 
		DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2031z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72051za7,
		BGl_z62tracezd2nodezd2setq1350z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2032z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72052za7,
		BGl_z62tracezd2nodezd2condition1352z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2033z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72053za7,
		BGl_z62tracezd2nodezd2fail1354z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2034z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72054za7,
		BGl_z62tracezd2nodezd2select1356z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2035z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72055za7,
		BGl_z62tracezd2nodezd2letzd2fun1358zb0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2036z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72056za7,
		BGl_z62tracezd2nodezd2letzd2var1360zb0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2037z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72057za7,
		BGl_z62tracezd2nodezd2setzd2exzd2it1362z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2038z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72058za7,
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1364z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2039z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72059za7,
		BGl_z62tracezd2nodezd2makezd2box1366zb0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2040z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72060za7,
		BGl_z62tracezd2nodezd2boxzd2ref1368zb0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2041z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72061za7,
		BGl_z62tracezd2nodezd2boxzd2setz121370za2zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2042z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2062z00,
		BGl_z62toplevelzd2tracezd2nodezd21382zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2044z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2063z00,
		BGl_z62toplevelzd2tracezd2nodezd21384zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2045z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2064z00,
		BGl_z62toplevelzd2tracezd2nodezd21386zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_tracezd2walkz12zd2envz12zztrace_walkz00,
		BgL_bgl_za762traceza7d2walkza72065za7,
		BGl_z62tracezd2walkz12za2zztrace_walkz00, 0L, BUNSPEC, 1);
	     
		DEFINE_STATIC_BGL_GENERIC(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2066za7,
		BGl_z62findzd2lastzd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string2000z00zztrace_walkz00,
		BgL_bgl_string2000za700za7za7t2067za7, "%toplevel@", 10);
	      DEFINE_STRING(BGl_string2001z00zztrace_walkz00,
		BgL_bgl_string2001za700za7za7t2068za7, "%import@", 8);
	      DEFINE_STRING(BGl_string2003z00zztrace_walkz00,
		BgL_bgl_string2003za700za7za7t2069za7, "find-last-node1302", 18);
	      DEFINE_STRING(BGl_string2005z00zztrace_walkz00,
		BgL_bgl_string2005za700za7za7t2070za7, "trace-node1332", 14);
	      DEFINE_STRING(BGl_string2007z00zztrace_walkz00,
		BgL_bgl_string2007za700za7za7t2071za7, "toplevel-trace-node1371", 23);
	      DEFINE_STRING(BGl_string2009z00zztrace_walkz00,
		BgL_bgl_string2009za700za7za7t2072za7, "find-last-node", 14);
	      DEFINE_STRING(BGl_string2024z00zztrace_walkz00,
		BgL_bgl_string2024za700za7za7t2073za7, "trace-node", 10);
	      DEFINE_STRING(BGl_string2043z00zztrace_walkz00,
		BgL_bgl_string2043za700za7za7t2074za7, "toplevel-trace-node", 19);
	      DEFINE_STRING(BGl_string2046z00zztrace_walkz00,
		BgL_bgl_string2046za700za7za7t2075za7, "trace_walk", 10);
	      DEFINE_STRING(BGl_string2047z00zztrace_walkz00,
		BgL_bgl_string2047za700za7za7t2076za7,
		"value let $env-pop-trace $env-push-trace current-dynamic-env dynamic-env quote at location |:| env loc name aux generic-init method-init no-trace @ imported-modules-init toplevel-init pass-started ",
		197);
	     
		DEFINE_STATIC_BGL_GENERIC
		(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2077z00,
		BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string1992z00zztrace_walkz00,
		BgL_bgl_string1992za700za7za7t2078za7, "Trace", 5);
	      DEFINE_STRING(BGl_string1993z00zztrace_walkz00,
		BgL_bgl_string1993za700za7za7t2079za7, "   . ", 5);
	      DEFINE_STRING(BGl_string1994z00zztrace_walkz00,
		BgL_bgl_string1994za700za7za7t2080za7, "failure during prelude hook", 27);
	      DEFINE_STRING(BGl_string1995z00zztrace_walkz00,
		BgL_bgl_string1995za700za7za7t2081za7, " error", 6);
	      DEFINE_STRING(BGl_string1996z00zztrace_walkz00,
		BgL_bgl_string1996za700za7za7t2082za7, "s", 1);
	      DEFINE_STRING(BGl_string1997z00zztrace_walkz00,
		BgL_bgl_string1997za700za7za7t2083za7, "", 0);
	      DEFINE_STRING(BGl_string1998z00zztrace_walkz00,
		BgL_bgl_string1998za700za7za7t2084za7, " occured, ending ...", 20);
	      DEFINE_STRING(BGl_string1999z00zztrace_walkz00,
		BgL_bgl_string1999za700za7za7t2085za7, "failure during postlude hook", 28);
	      DEFINE_STATIC_BGL_GENERIC(BGl_tracezd2nodezd2envz00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72086za7,
		BGl_z62tracezd2nodezb0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2002z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2087za7,
		BGl_z62findzd2lastzd2node1302z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2004z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2node12088z00,
		BGl_z62tracezd2node1332zb0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2006z00zztrace_walkz00,
		BgL_bgl_za762toplevelza7d2tr2089z00,
		BGl_z62toplevelzd2tracezd2node1371z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2008z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2090za7,
		BGl_z62findzd2lastzd2nodezd2seque1305zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2010z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2091za7,
		BGl_z62findzd2lastzd2nodezd2sync1307zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2011z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2092za7,
		BGl_z62findzd2lastzd2nodezd2app1309zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2012z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2093za7,
		BGl_z62findzd2lastzd2nodezd2appzd2l1311z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2013z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2094za7,
		BGl_z62findzd2lastzd2nodezd2funca1313zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2014z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2095za7,
		BGl_z62findzd2lastzd2nodezd2exter1315zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2015z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2096za7,
		BGl_z62findzd2lastzd2nodezd2setq1317zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2016z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2097za7,
		BGl_z62findzd2lastzd2nodezd2condi1319zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2017z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2098za7,
		BGl_z62findzd2lastzd2nodezd2fail1321zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2018z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2099za7,
		BGl_z62findzd2lastzd2nodezd2selec1323zb0zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2019z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2100za7,
		BGl_z62findzd2lastzd2nodezd2letzd2v1325z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2020z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2101za7,
		BGl_z62findzd2lastzd2nodezd2letzd2f1327z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2021z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2102za7,
		BGl_z62findzd2lastzd2nodezd2setzd2e1329z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2022z00zztrace_walkz00,
		BgL_bgl_za762findza7d2lastza7d2103za7,
		BGl_z62findzd2lastzd2nodezd2jumpzd21331z62zztrace_walkz00, 0L, BUNSPEC, 1);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2023z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72104za7,
		BGl_z62tracezd2nodezd2sequence1335z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2025z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72105za7,
		BGl_z62tracezd2nodezd2sync1337z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2026z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72106za7,
		BGl_z62tracezd2nodezd2app1339z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2027z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72107za7,
		BGl_z62tracezd2nodezd2appzd2ly1341zb0zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2028z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72108za7,
		BGl_z62tracezd2nodezd2funcall1343z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2029z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72109za7,
		BGl_z62tracezd2nodezd2extern1345z62zztrace_walkz00, 0L, BUNSPEC, 2);
	      DEFINE_STATIC_BGL_PROCEDURE(BGl_proc2030z00zztrace_walkz00,
		BgL_bgl_za762traceza7d2nodeza72110za7,
		BGl_z62tracezd2nodezd2cast1348z62zztrace_walkz00, 0L, BUNSPEC, 2);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zztrace_walkz00(long
		BgL_checksumz00_2623, char *BgL_fromz00_2624)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zztrace_walkz00))
				{
					BGl_requirezd2initializa7ationz75zztrace_walkz00 =
						BBOOL(((bool_t) 0));
					BGl_libraryzd2moduleszd2initz00zztrace_walkz00();
					BGl_cnstzd2initzd2zztrace_walkz00();
					BGl_importedzd2moduleszd2initz00zztrace_walkz00();
					BGl_genericzd2initzd2zztrace_walkz00();
					BGl_methodzd2initzd2zztrace_walkz00();
					return BGl_toplevelzd2initzd2zztrace_walkz00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* library-modules-init */
	obj_t BGl_libraryzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 0), "trace_walk");
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 0),
				"trace_walk");
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 0), "trace_walk");
			return BUNSPEC;
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			{	/* Trace/walk.scm 15 */
				obj_t BgL_cportz00_2606;

				{	/* Trace/walk.scm 15 */
					obj_t BgL_startz00_2615;

					BgL_startz00_2615 = BINT(((long) 0));
					{	/* Trace/walk.scm 15 */
						obj_t BgL_endz00_2616;

						BgL_endz00_2616 =
							BINT(STRING_LENGTH(BGl_string2047z00zztrace_walkz00));
						{	/* Trace/walk.scm 15 */

							BgL_cportz00_2606 =
								BGl_openzd2inputzd2stringz12z12zz__r4_ports_6_10_1z00
								(BGl_string2047z00zztrace_walkz00, BgL_startz00_2615,
								BgL_endz00_2616);
				}}}
				{
					long BgL_iz00_2607;

					BgL_iz00_2607 = ((long) 20);
				BgL_loopz00_2608:
					if ((BgL_iz00_2607 == ((long) -1)))
						{	/* Trace/walk.scm 15 */
							return BUNSPEC;
						}
					else
						{	/* Trace/walk.scm 15 */
							{	/* Trace/walk.scm 15 */
								obj_t BgL_arg2049z00_2610;

								{	/* Trace/walk.scm 15 */

									{	/* Trace/walk.scm 15 */
										obj_t BgL_locationz00_2612;

										BgL_locationz00_2612 = BBOOL(((bool_t) 0));
										{	/* Trace/walk.scm 15 */

											BgL_arg2049z00_2610 =
												BGl_readz00zz__readerz00(BgL_cportz00_2606,
												BgL_locationz00_2612);
										}
									}
								}
								{	/* Trace/walk.scm 15 */
									int BgL_auxz00_2655;

									BgL_auxz00_2655 = (int) (BgL_iz00_2607);
									CNST_TABLE_SET(BgL_auxz00_2655, BgL_arg2049z00_2610);
							}}
							{	/* Trace/walk.scm 15 */
								int BgL_auxz00_2613;

								BgL_auxz00_2613 = (int) ((BgL_iz00_2607 - ((long) 1)));
								{
									long BgL_iz00_2660;

									BgL_iz00_2660 = (long) (BgL_auxz00_2613);
									BgL_iz00_2607 = BgL_iz00_2660;
									goto BgL_loopz00_2608;
								}
							}
						}
				}
			}
		}
	}



/* toplevel-init */
	obj_t BGl_toplevelzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}
	}



/* trace-walk! */
	BGL_EXPORTED_DEF obj_t BGl_tracezd2walkz12zc0zztrace_walkz00(obj_t
		BgL_globalsz00_17)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 38 */
			{	/* Trace/walk.scm 39 */
				obj_t BgL_list1448z00_1396;

				{	/* Trace/walk.scm 39 */
					obj_t BgL_arg1452z00_1397;

					{	/* Trace/walk.scm 39 */
						obj_t BgL_arg1454z00_1398;

						BgL_arg1454z00_1398 =
							MAKE_PAIR(BCHAR(((unsigned char) '\n')), BNIL);
						BgL_arg1452z00_1397 =
							MAKE_PAIR(BGl_string1992z00zztrace_walkz00, BgL_arg1454z00_1398);
					}
					BgL_list1448z00_1396 =
						MAKE_PAIR(BGl_string1993z00zztrace_walkz00, BgL_arg1452z00_1397);
				}
				BGl_verbosez00zztools_speekz00(BINT(((long) 1)), BgL_list1448z00_1396);
			}
			BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00 = BINT(((long) 0));
			BGl_za2currentzd2passza2zd2zzengine_passz00 =
				BGl_string1992z00zztrace_walkz00;
			{
				obj_t BgL_hooksz00_1402;
				obj_t BgL_hnamesz00_1403;

				BgL_hooksz00_1402 = BNIL;
				BgL_hnamesz00_1403 = BNIL;
			BgL_zc3anonymousza31455ze3z83_1404:
				if (NULLP(BgL_hooksz00_1402))
					{	/* Trace/walk.scm 39 */
						CNST_TABLE_REF(((long) 0));
					}
				else
					{	/* Trace/walk.scm 39 */
						bool_t BgL_testz00_2672;

						{	/* Trace/walk.scm 39 */
							obj_t BgL_fun1468z00_1410;

							BgL_fun1468z00_1410 = CAR(BgL_hooksz00_1402);
							BgL_testz00_2672 =
								CBOOL(PROCEDURE_ENTRY(BgL_fun1468z00_1410) (BgL_fun1468z00_1410,
									BEOA));
						}
						if (BgL_testz00_2672)
							{
								obj_t BgL_hnamesz00_2680;
								obj_t BgL_hooksz00_2678;

								BgL_hooksz00_2678 = CDR(BgL_hooksz00_1402);
								BgL_hnamesz00_2680 = CDR(BgL_hnamesz00_1403);
								BgL_hnamesz00_1403 = BgL_hnamesz00_2680;
								BgL_hooksz00_1402 = BgL_hooksz00_2678;
								goto BgL_zc3anonymousza31455ze3z83_1404;
							}
						else
							{	/* Trace/walk.scm 39 */
								BGl_internalzd2errorzd2zztools_errorz00
									(BGl_string1992z00zztrace_walkz00,
									BGl_string1994z00zztrace_walkz00, CAR(BgL_hnamesz00_1403));
							}
					}
			}
			{	/* Trace/walk.scm 45 */
				obj_t BgL_idz00_1413;

				BgL_idz00_1413 = CNST_TABLE_REF(((long) 1));
				{	/* Trace/walk.scm 45 */
					obj_t BgL_gloz00_1414;

					{	/* Trace/walk.scm 46 */
						obj_t BgL_list1477z00_1418;

						BgL_list1477z00_1418 =
							MAKE_PAIR(BGl_za2moduleza2z00zzmodule_modulez00, BNIL);
						BgL_gloz00_1414 =
							BGl_findzd2globalzd2zzast_envz00(BgL_idz00_1413,
							BgL_list1477z00_1418);
					}
					{	/* Trace/walk.scm 46 */

						if (BGl_isazf3zf3zz__objectz00(BgL_gloz00_1414,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 48 */
								BgL_sfunz00_bglt BgL_i1103z00_1416;

								BgL_i1103z00_1416 =
									((BgL_sfunz00_bglt)
									(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_gloz00_1414))))->
										BgL_valuez00));
								{
									obj_t BgL_auxz00_2693;

									{	/* Trace/walk.scm 49 */
										obj_t BgL_arg1476z00_1417;

										BgL_arg1476z00_1417 =
											(((BgL_sfunz00_bglt) CREF(BgL_i1103z00_1416))->
											BgL_bodyz00);
										BgL_auxz00_2693 =
											((obj_t)
											BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((
													(BgL_nodez00_bglt) BgL_arg1476z00_1417)));
									}
									((((BgL_sfunz00_bglt) CREF(BgL_i1103z00_1416))->BgL_bodyz00) =
										((obj_t) BgL_auxz00_2693), BUNSPEC);
								}
							}
						else
							{	/* Trace/walk.scm 47 */
								BFALSE;
							}
					}
				}
			}
			{
				obj_t BgL_l1290z00_1420;

				BgL_l1290z00_1420 = BgL_globalsz00_17;
			BgL_zc3anonymousza31478ze3z83_1421:
				if (PAIRP(BgL_l1290z00_1420))
					{	/* Trace/walk.scm 51 */
						BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l1290z00_1420), BNIL);
						{
							obj_t BgL_l1290z00_2703;

							BgL_l1290z00_2703 = CDR(BgL_l1290z00_1420);
							BgL_l1290z00_1420 = BgL_l1290z00_2703;
							goto BgL_zc3anonymousza31478ze3z83_1421;
						}
					}
				else
					{	/* Trace/walk.scm 51 */
						((bool_t) 1);
					}
			}
			if (
				((long) CINT(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00) >
					((long) 0)))
				{	/* Trace/walk.scm 52 */
					{	/* Trace/walk.scm 52 */
						obj_t BgL_port1292z00_1428;

						{	/* Trace/walk.scm 52 */
							obj_t BgL_res1925z00_2139;

							{	/* Trace/walk.scm 52 */
								obj_t BgL_auxz00_2708;

								BgL_auxz00_2708 = BGL_CURRENT_DYNAMIC_ENV();
								BgL_res1925z00_2139 =
									BGL_ENV_CURRENT_ERROR_PORT(BgL_auxz00_2708);
							}
							BgL_port1292z00_1428 = BgL_res1925z00_2139;
						}
						bgl_display_obj(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
							BgL_port1292z00_1428);
						bgl_display_string(BGl_string1995z00zztrace_walkz00,
							BgL_port1292z00_1428);
						{	/* Trace/walk.scm 52 */
							obj_t BgL_arg1484z00_1429;

							{	/* Trace/walk.scm 52 */
								bool_t BgL_testz00_2713;

								if (BGl_integerzf3zf3zz__r4_numbers_6_5_fixnumz00
									(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
									{	/* Trace/walk.scm 52 */
										if (INTEGERP
											(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00))
											{	/* Trace/walk.scm 52 */
												BgL_testz00_2713 =
													(
													(long)
													CINT
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00)
													> ((long) 1));
											}
										else
											{	/* Trace/walk.scm 52 */
												BgL_testz00_2713 =
													BGl_2ze3ze3zz__r4_numbers_6_5z00
													(BGl_za2nbzd2errorzd2onzd2passza2zd2zztools_errorz00,
													BINT(((long) 1)));
									}}
								else
									{	/* Trace/walk.scm 52 */
										BgL_testz00_2713 = ((bool_t) 0);
									}
								if (BgL_testz00_2713)
									{	/* Trace/walk.scm 52 */
										BgL_arg1484z00_1429 = BGl_string1996z00zztrace_walkz00;
									}
								else
									{	/* Trace/walk.scm 52 */
										BgL_arg1484z00_1429 = BGl_string1997z00zztrace_walkz00;
									}
							}
							bgl_display_obj(BgL_arg1484z00_1429, BgL_port1292z00_1428);
						}
						bgl_display_string(BGl_string1998z00zztrace_walkz00,
							BgL_port1292z00_1428);
						bgl_display_char(((unsigned char) '\n'), BgL_port1292z00_1428);
					}
					{	/* Trace/walk.scm 52 */
						obj_t BgL_list1488z00_1433;

						BgL_list1488z00_1433 = MAKE_PAIR(BINT(((long) -1)), BNIL);
						return BGl_exitz00zz__errorz00(BgL_list1488z00_1433);
					}
				}
			else
				{
					obj_t BgL_hooksz00_1437;
					obj_t BgL_hnamesz00_1438;

					BgL_hooksz00_1437 = BNIL;
					BgL_hnamesz00_1438 = BNIL;
				BgL_zc3anonymousza31489ze3z83_1439:
					if (NULLP(BgL_hooksz00_1437))
						{	/* Trace/walk.scm 52 */
							return BgL_globalsz00_17;
						}
					else
						{	/* Trace/walk.scm 52 */
							bool_t BgL_testz00_2730;

							{	/* Trace/walk.scm 52 */
								obj_t BgL_fun1497z00_1445;

								BgL_fun1497z00_1445 = CAR(BgL_hooksz00_1437);
								BgL_testz00_2730 =
									CBOOL(PROCEDURE_ENTRY(BgL_fun1497z00_1445)
									(BgL_fun1497z00_1445, BEOA));
							}
							if (BgL_testz00_2730)
								{
									obj_t BgL_hnamesz00_2738;
									obj_t BgL_hooksz00_2736;

									BgL_hooksz00_2736 = CDR(BgL_hooksz00_1437);
									BgL_hnamesz00_2738 = CDR(BgL_hnamesz00_1438);
									BgL_hnamesz00_1438 = BgL_hnamesz00_2738;
									BgL_hooksz00_1437 = BgL_hooksz00_2736;
									goto BgL_zc3anonymousza31489ze3z83_1439;
								}
							else
								{	/* Trace/walk.scm 52 */
									obj_t BgL_arg1496z00_1444;

									BgL_arg1496z00_1444 = CAR(BgL_hnamesz00_1438);
									return
										BGl_internalzd2errorzd2zztools_errorz00
										(BGl_za2currentzd2passza2zd2zzengine_passz00,
										BGl_string1999z00zztrace_walkz00, BgL_arg1496z00_1444);
								}
						}
				}
		}
	}



/* &trace-walk! */
	obj_t BGl_z62tracezd2walkz12za2zztrace_walkz00(obj_t BgL_envz00_2463,
		obj_t BgL_globalsz00_2464)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 38 */
			return BGl_tracezd2walkz12zc0zztrace_walkz00(BgL_globalsz00_2464);
		}
	}



/* trace-id */
	obj_t BGl_tracezd2idzd2zztrace_walkz00(obj_t BgL_vz00_18)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 63 */
			{	/* Trace/walk.scm 65 */
				bool_t BgL_testz00_2743;

				if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18, BGl_globalz00zzast_varz00))
					{	/* Trace/walk.scm 65 */
						BgL_testz00_2743 =
							(
							(((BgL_variablez00_bglt) CREF(
										((BgL_variablez00_bglt)
											((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
							CNST_TABLE_REF(((long) 1)));
					}
				else
					{	/* Trace/walk.scm 65 */
						BgL_testz00_2743 = ((bool_t) 0);
					}
				if (BgL_testz00_2743)
					{	/* Trace/walk.scm 66 */
						obj_t BgL_arg1500z00_1449;

						{	/* Trace/walk.scm 66 */
							obj_t BgL_arg1505z00_1450;
							obj_t BgL_arg1509z00_1451;

							{	/* Trace/walk.scm 66 */
								obj_t BgL_arg1511z00_1452;

								BgL_arg1511z00_1452 =
									bstring_to_symbol(BGl_string2000z00zztrace_walkz00);
								{	/* Trace/walk.scm 66 */
									obj_t BgL_res1932z00_2165;

									{	/* Trace/walk.scm 66 */
										obj_t BgL_arg1362z00_2164;

										BgL_arg1362z00_2164 = SYMBOL_TO_STRING(BgL_arg1511z00_1452);
										BgL_res1932z00_2165 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1362z00_2164);
									}
									BgL_arg1505z00_1450 = BgL_res1932z00_2165;
								}
							}
							{	/* Trace/walk.scm 66 */
								obj_t BgL_arg1516z00_1453;

								BgL_arg1516z00_1453 =
									(((BgL_globalz00_bglt) CREF(
											((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
								{	/* Trace/walk.scm 66 */
									obj_t BgL_res1933z00_2169;

									{	/* Trace/walk.scm 66 */
										obj_t BgL_arg1362z00_2168;

										BgL_arg1362z00_2168 = SYMBOL_TO_STRING(BgL_arg1516z00_1453);
										BgL_res1933z00_2169 =
											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
											(BgL_arg1362z00_2168);
									}
									BgL_arg1509z00_1451 = BgL_res1933z00_2169;
								}
							}
							BgL_arg1500z00_1449 =
								string_append(BgL_arg1505z00_1450, BgL_arg1509z00_1451);
						}
						return bstring_to_symbol(BgL_arg1500z00_1449);
					}
				else
					{	/* Trace/walk.scm 67 */
						bool_t BgL_testz00_2760;

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 67 */
								BgL_testz00_2760 =
									(
									(((BgL_variablez00_bglt) CREF(
												((BgL_variablez00_bglt)
													((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00) ==
									CNST_TABLE_REF(((long) 2)));
							}
						else
							{	/* Trace/walk.scm 67 */
								BgL_testz00_2760 = ((bool_t) 0);
							}
						if (BgL_testz00_2760)
							{	/* Trace/walk.scm 68 */
								obj_t BgL_arg1519z00_1455;

								{	/* Trace/walk.scm 68 */
									obj_t BgL_arg1526z00_1456;
									obj_t BgL_arg1527z00_1457;

									{	/* Trace/walk.scm 68 */
										obj_t BgL_arg1528z00_1458;

										BgL_arg1528z00_1458 =
											bstring_to_symbol(BGl_string2001z00zztrace_walkz00);
										{	/* Trace/walk.scm 68 */
											obj_t BgL_res1937z00_2179;

											{	/* Trace/walk.scm 68 */
												obj_t BgL_arg1362z00_2178;

												BgL_arg1362z00_2178 =
													SYMBOL_TO_STRING(BgL_arg1528z00_1458);
												BgL_res1937z00_2179 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1362z00_2178);
											}
											BgL_arg1526z00_1456 = BgL_res1937z00_2179;
										}
									}
									{	/* Trace/walk.scm 68 */
										obj_t BgL_arg1530z00_1459;

										BgL_arg1530z00_1459 =
											(((BgL_globalz00_bglt) CREF(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 68 */
											obj_t BgL_res1938z00_2183;

											{	/* Trace/walk.scm 68 */
												obj_t BgL_arg1362z00_2182;

												BgL_arg1362z00_2182 =
													SYMBOL_TO_STRING(BgL_arg1530z00_1459);
												BgL_res1938z00_2183 =
													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
													(BgL_arg1362z00_2182);
											}
											BgL_arg1527z00_1457 = BgL_res1938z00_2183;
										}
									}
									BgL_arg1519z00_1455 =
										string_append(BgL_arg1526z00_1456, BgL_arg1527z00_1457);
								}
								return bstring_to_symbol(BgL_arg1519z00_1455);
							}
						else
							{	/* Trace/walk.scm 67 */
								if (BGl_isazf3zf3zz__objectz00(BgL_vz00_18,
										BGl_globalz00zzast_varz00))
									{	/* Trace/walk.scm 70 */
										obj_t BgL_arg1547z00_1461;
										obj_t BgL_arg1549z00_1462;

										BgL_arg1547z00_1461 =
											(((BgL_variablez00_bglt) CREF(
													((BgL_variablez00_bglt)
														((BgL_globalz00_bglt) BgL_vz00_18))))->BgL_idz00);
										BgL_arg1549z00_1462 =
											(((BgL_globalz00_bglt) CREF(
													((BgL_globalz00_bglt) BgL_vz00_18)))->BgL_modulez00);
										{	/* Trace/walk.scm 70 */
											obj_t BgL_list1550z00_1463;

											{	/* Trace/walk.scm 70 */
												obj_t BgL_arg1552z00_1464;

												{	/* Trace/walk.scm 70 */
													obj_t BgL_arg1555z00_1465;

													BgL_arg1555z00_1465 =
														MAKE_PAIR(BgL_arg1549z00_1462, BNIL);
													BgL_arg1552z00_1464 =
														MAKE_PAIR(CNST_TABLE_REF(((long) 3)),
														BgL_arg1555z00_1465);
												}
												BgL_list1550z00_1463 =
													MAKE_PAIR(BgL_arg1547z00_1461, BgL_arg1552z00_1464);
											}
											return
												BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
												(BgL_list1550z00_1463);
										}
									}
								else
									{	/* Trace/walk.scm 69 */
										return
											(((BgL_variablez00_bglt) CREF(
													((BgL_variablez00_bglt) BgL_vz00_18)))->BgL_idz00);
									}
							}
					}
			}
		}
	}



/* trace-fun! */
	obj_t BGl_tracezd2funz12zc0zztrace_walkz00(obj_t BgL_varz00_19,
		obj_t BgL_stackz00_20)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 80 */
			{	/* Trace/walk.scm 81 */
				BgL_valuez00_bglt BgL_funz00_1470;

				BgL_funz00_1470 =
					(((BgL_variablez00_bglt) CREF(
							((BgL_variablez00_bglt) BgL_varz00_19)))->BgL_valuez00);
				{	/* Trace/walk.scm 81 */
					obj_t BgL_bodyz00_1471;

					BgL_bodyz00_1471 =
						(((BgL_sfunz00_bglt) CREF(
								((BgL_sfunz00_bglt) BgL_funz00_1470)))->BgL_bodyz00);
					{	/* Trace/walk.scm 82 */
						obj_t BgL_llocz00_1472;

						if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
								BGl_globalz00zzast_varz00))
							{	/* Trace/walk.scm 84 */
								obj_t BgL_arg1619z00_1500;

								BgL_arg1619z00_1500 =
									BGl_findzd2lastzd2sexpz00zztrace_walkz00(
									(((BgL_globalz00_bglt) CREF(
												((BgL_globalz00_bglt) BgL_varz00_19)))->BgL_srcz00));
								BgL_llocz00_1472 =
									BGl_findzd2locationzd2zztools_locationz00
									(BgL_arg1619z00_1500);
							}
						else
							{	/* Trace/walk.scm 85 */
								obj_t BgL_arg1623z00_1502;

								BgL_arg1623z00_1502 =
									BGl_findzd2lastzd2nodez00zztrace_walkz00(
									((BgL_nodez00_bglt) BgL_bodyz00_1471));
								BgL_llocz00_1472 =
									(((BgL_nodez00_bglt) CREF(
											((BgL_nodez00_bglt) BgL_arg1623z00_1502)))->BgL_locz00);
							}
						{	/* Trace/walk.scm 83 */

							{	/* Trace/walk.scm 86 */
								bool_t BgL_testz00_2805;

								if (CBOOL(
										(((BgL_funz00_bglt) CREF(
													((BgL_funz00_bglt) BgL_funz00_1470)))->
											BgL_predicatezd2ofzd2)))
									{	/* Trace/walk.scm 86 */
										BgL_testz00_2805 = ((bool_t) 0);
									}
								else
									{	/* Trace/walk.scm 86 */
										if (CBOOL(BGl_memqz00zz__r4_pairs_and_lists_6_3z00
												(CNST_TABLE_REF(((long) 4)),
													(((BgL_sfunz00_bglt) CREF(((BgL_sfunz00_bglt)
																	BgL_funz00_1470)))->BgL_propertyz00))))
											{	/* Trace/walk.scm 87 */
												BgL_testz00_2805 = ((bool_t) 0);
											}
										else
											{	/* Trace/walk.scm 88 */
												obj_t BgL_arg1613z00_1497;

												BgL_arg1613z00_1497 =
													(((BgL_variablez00_bglt) CREF(
															((BgL_variablez00_bglt) BgL_varz00_19)))->
													BgL_idz00);
												BgL_testz00_2805 =
													BGl_userzd2symbolzf3z21zzast_identz00
													(BgL_arg1613z00_1497);
											}
									}
								if (BgL_testz00_2805)
									{	/* Trace/walk.scm 86 */
										BGl_enterzd2functionzd2zztools_errorz00
											(BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19));
										{	/* Trace/walk.scm 90 */
											obj_t BgL_bdz00_1475;

											{	/* Trace/walk.scm 90 */
												bool_t BgL_testz00_2821;

												if (
													((long)
														CINT
														(BGl_za2compilerzd2debugzd2traceza2z00zzengine_paramz00)
														> ((long) 1)))
													{	/* Trace/walk.scm 90 */
														BgL_testz00_2821 = ((bool_t) 1);
													}
												else
													{	/* Trace/walk.scm 90 */
														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_globalz00zzast_varz00))
															{	/* Trace/walk.scm 92 */
																bool_t BgL__ortest_1110z00_1490;

																BgL__ortest_1110z00_1490 =
																	(
																	(((BgL_variablez00_bglt) CREF(
																				((BgL_variablez00_bglt)
																					((BgL_globalz00_bglt)
																						BgL_varz00_19))))->BgL_idz00) ==
																	CNST_TABLE_REF(((long) 1)));
																if (BgL__ortest_1110z00_1490)
																	{	/* Trace/walk.scm 92 */
																		BgL_testz00_2821 = BgL__ortest_1110z00_1490;
																	}
																else
																	{	/* Trace/walk.scm 93 */
																		bool_t BgL__ortest_1111z00_1491;

																		BgL__ortest_1111z00_1491 =
																			(
																			(((BgL_variablez00_bglt) CREF(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 5)));
																		if (BgL__ortest_1111z00_1491)
																			{	/* Trace/walk.scm 93 */
																				BgL_testz00_2821 =
																					BgL__ortest_1111z00_1491;
																			}
																		else
																			{	/* Trace/walk.scm 93 */
																				BgL_testz00_2821 =
																					(
																					(((BgL_variablez00_bglt) CREF(
																								((BgL_variablez00_bglt)
																									((BgL_globalz00_bglt)
																										BgL_varz00_19))))->
																						BgL_idz00) ==
																					CNST_TABLE_REF(((long) 6)));
															}}}
														else
															{	/* Trace/walk.scm 91 */
																BgL_testz00_2821 = ((bool_t) 0);
															}
													}
												if (BgL_testz00_2821)
													{	/* Trace/walk.scm 102 */
														bool_t BgL_testz00_2844;

														if (BGl_isazf3zf3zz__objectz00(BgL_varz00_19,
																BGl_localz00zzast_varz00))
															{	/* Trace/walk.scm 102 */
																BgL_testz00_2844 = ((bool_t) 1);
															}
														else
															{	/* Trace/walk.scm 102 */
																if (
																	((((BgL_variablez00_bglt) CREF(
																					((BgL_variablez00_bglt)
																						((BgL_globalz00_bglt)
																							BgL_varz00_19))))->BgL_idz00) ==
																		CNST_TABLE_REF(((long) 5))))
																	{	/* Trace/walk.scm 103 */
																		BgL_testz00_2844 = ((bool_t) 1);
																	}
																else
																	{	/* Trace/walk.scm 103 */
																		BgL_testz00_2844 =
																			(
																			(((BgL_variablez00_bglt) CREF(
																						((BgL_variablez00_bglt)
																							((BgL_globalz00_bglt)
																								BgL_varz00_19))))->BgL_idz00) ==
																			CNST_TABLE_REF(((long) 6)));
															}}
														if (BgL_testz00_2844)
															{	/* Trace/walk.scm 102 */
																BgL_bdz00_1475 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00(
																		((BgL_nodez00_bglt) BgL_bodyz00_1471),
																		BgL_stackz00_20));
															}
														else
															{	/* Trace/walk.scm 106 */
																obj_t BgL_arg1582z00_1483;

																BgL_arg1582z00_1483 =
																	MAKE_PAIR(BgL_varz00_19, BgL_stackz00_20);
																BgL_bdz00_1475 =
																	((obj_t)
																	BGl_tracezd2nodezd2zztrace_walkz00(
																		((BgL_nodez00_bglt) BgL_bodyz00_1471),
																		BgL_arg1582z00_1483));
															}
													}
												else
													{	/* Trace/walk.scm 90 */
														BgL_bdz00_1475 = BgL_bodyz00_1471;
													}
											}
											{	/* Trace/walk.scm 90 */
												BgL_typez00_bglt BgL_tz00_1476;

												{	/* Trace/walk.scm 108 */
													BgL_typez00_bglt BgL_arg1572z00_1479;
													BgL_typez00_bglt BgL_arg1576z00_1480;

													BgL_arg1572z00_1479 =
														(((BgL_nodez00_bglt) CREF(
																((BgL_nodez00_bglt) BgL_bodyz00_1471)))->
														BgL_typez00);
													BgL_arg1576z00_1480 =
														(((BgL_variablez00_bglt)
															CREF(((BgL_variablez00_bglt) BgL_varz00_19)))->
														BgL_typez00);
													BgL_tz00_1476 =
														BGl_strictzd2nodezd2typez00zzast_nodez00
														(BgL_arg1572z00_1479, BgL_arg1576z00_1480);
												}
												{	/* Trace/walk.scm 108 */
													obj_t BgL_idz00_1477;

													BgL_idz00_1477 =
														BGl_tracezd2idzd2zztrace_walkz00(BgL_varz00_19);
													{	/* Trace/walk.scm 109 */
														BgL_letzd2varzd2_bglt BgL_nbodyz00_1478;

														BgL_nbodyz00_1478 =
															BGl_makezd2tracedzd2nodez00zztrace_walkz00(
															((BgL_nodez00_bglt) BgL_bdz00_1475),
															BgL_tz00_1476, BgL_idz00_1477, BgL_llocz00_1472,
															BgL_stackz00_20);
														{	/* Trace/walk.scm 110 */

															((((BgL_sfunz00_bglt) CREF(
																			((BgL_sfunz00_bglt) BgL_funz00_1470)))->
																	BgL_bodyz00) =
																((obj_t) ((obj_t) BgL_nbodyz00_1478)), BUNSPEC);
															return BGl_leavezd2functionzd2zztools_errorz00();
														}
													}
												}
											}
										}
									}
								else
									{	/* Trace/walk.scm 86 */
										return BFALSE;
									}
							}
						}
					}
				}
			}
		}
	}



/* find-last-sexp */
	obj_t BGl_findzd2lastzd2sexpz00zztrace_walkz00(obj_t BgL_sexpz00_21)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 121 */
			{
				obj_t BgL_sexpz00_1504;
				obj_t BgL_resz00_1505;

				BgL_sexpz00_1504 = BgL_sexpz00_21;
				BgL_resz00_1505 = BgL_sexpz00_21;
			BgL_zc3anonymousza31624ze3z83_1506:
				if (PAIRP(BgL_sexpz00_1504))
					{	/* Trace/walk.scm 127 */
						bool_t BgL_testz00_2879;

						{	/* Trace/walk.scm 127 */
							obj_t BgL_auxz00_2880;

							BgL_auxz00_2880 = CDR(BgL_sexpz00_1504);
							BgL_testz00_2879 = PAIRP(BgL_auxz00_2880);
						}
						if (BgL_testz00_2879)
							{
								obj_t BgL_resz00_2885;
								obj_t BgL_sexpz00_2883;

								BgL_sexpz00_2883 =
									BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00
									(BgL_sexpz00_1504);
								BgL_resz00_2885 = BgL_sexpz00_1504;
								BgL_resz00_1505 = BgL_resz00_2885;
								BgL_sexpz00_1504 = BgL_sexpz00_2883;
								goto BgL_zc3anonymousza31624ze3z83_1506;
							}
						else
							{
								obj_t BgL_resz00_2888;
								obj_t BgL_sexpz00_2886;

								BgL_sexpz00_2886 = CAR(BgL_sexpz00_1504);
								BgL_resz00_2888 = BgL_sexpz00_1504;
								BgL_resz00_1505 = BgL_resz00_2888;
								BgL_sexpz00_1504 = BgL_sexpz00_2886;
								goto BgL_zc3anonymousza31624ze3z83_1506;
							}
					}
				else
					{	/* Trace/walk.scm 125 */
						return BgL_resz00_1505;
					}
			}
		}
	}



/* make-traced-node */
	BgL_letzd2varzd2_bglt
		BGl_makezd2tracedzd2nodez00zztrace_walkz00(BgL_nodez00_bglt BgL_nodez00_37,
		BgL_typez00_bglt BgL_typez00_38, obj_t BgL_symbolz00_39,
		obj_t BgL_llocz00_40, obj_t BgL_stackz00_41)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 244 */
			{	/* Trace/walk.scm 245 */
				obj_t BgL_locz00_1513;

				BgL_locz00_1513 =
					(((BgL_nodez00_bglt) CREF(BgL_nodez00_37))->BgL_locz00);
				{	/* Trace/walk.scm 245 */
					obj_t BgL_auxz00_1514;

					BgL_auxz00_1514 =
						BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
						(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long) 7))));
					{	/* Trace/walk.scm 246 */
						obj_t BgL_tauxz00_1515;

						BgL_tauxz00_1515 =
							BGl_makezd2typedzd2identz00zzast_identz00(BgL_auxz00_1514,
							(((BgL_typez00_bglt) CREF(BgL_typez00_38))->BgL_idz00));
						{	/* Trace/walk.scm 247 */
							obj_t BgL_tmp1z00_1516;

							BgL_tmp1z00_1516 =
								BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
								(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
											8))));
							{	/* Trace/walk.scm 248 */
								obj_t BgL_tmp2z00_1517;

								BgL_tmp2z00_1517 =
									BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
									(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
												9))));
								{	/* Trace/walk.scm 249 */
									obj_t BgL_tmp3z00_1518;

									BgL_tmp3z00_1518 =
										BGl_markzd2symbolzd2nonzd2userz12zc0zzast_identz00
										(BGl_gensymz00zz__r4_symbols_6_4z00(CNST_TABLE_REF(((long)
													10))));
									{	/* Trace/walk.scm 250 */
										obj_t BgL_symz00_1519;

										{	/* Trace/walk.scm 251 */
											bool_t BgL_testz00_2904;

											if (PAIRP(BgL_stackz00_41))
												{	/* Trace/walk.scm 251 */
													obj_t BgL_arg1716z00_1573;

													BgL_arg1716z00_1573 = CAR(BgL_stackz00_41);
													BgL_testz00_2904 =
														BGl_isazf3zf3zz__objectz00(BgL_arg1716z00_1573,
														BGl_variablez00zzast_varz00);
												}
											else
												{	/* Trace/walk.scm 251 */
													BgL_testz00_2904 = ((bool_t) 0);
												}
											if (BgL_testz00_2904)
												{	/* Trace/walk.scm 252 */
													obj_t BgL_arg1709z00_1567;

													BgL_arg1709z00_1567 =
														(((BgL_variablez00_bglt) CREF(
																((BgL_variablez00_bglt)
																	CAR(BgL_stackz00_41))))->BgL_idz00);
													{	/* Trace/walk.scm 252 */
														obj_t BgL_list1710z00_1568;

														{	/* Trace/walk.scm 252 */
															obj_t BgL_arg1712z00_1569;

															{	/* Trace/walk.scm 252 */
																obj_t BgL_arg1713z00_1570;

																BgL_arg1713z00_1570 =
																	MAKE_PAIR(BgL_arg1709z00_1567, BNIL);
																BgL_arg1712z00_1569 =
																	MAKE_PAIR(CNST_TABLE_REF(((long) 11)),
																	BgL_arg1713z00_1570);
															}
															BgL_list1710z00_1568 =
																MAKE_PAIR(BgL_symbolz00_39,
																BgL_arg1712z00_1569);
														}
														BgL_symz00_1519 =
															BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
															(BgL_list1710z00_1568);
												}}
											else
												{	/* Trace/walk.scm 251 */
													BgL_symz00_1519 = BgL_symbolz00_39;
												}
										}
										{	/* Trace/walk.scm 251 */
											obj_t BgL_lz00_1520;

											{	/* Trace/walk.scm 254 */
												bool_t BgL_testz00_2917;

												if (STRUCTP(BgL_locz00_1513))
													{	/* Trace/walk.scm 254 */
														BgL_testz00_2917 =
															(STRUCT_KEY(BgL_locz00_1513) ==
															CNST_TABLE_REF(((long) 12)));
													}
												else
													{	/* Trace/walk.scm 254 */
														BgL_testz00_2917 = ((bool_t) 0);
													}
												if (BgL_testz00_2917)
													{	/* Trace/walk.scm 255 */
														obj_t BgL_arg1702z00_1562;

														{	/* Trace/walk.scm 255 */
															obj_t BgL_arg1703z00_1563;
															obj_t BgL_arg1705z00_1564;

															BgL_arg1703z00_1563 =
																BGl_locationzd2fullzd2fnamez00zztools_locationz00
																(BgL_locz00_1513);
															BgL_arg1705z00_1564 =
																MAKE_PAIR(STRUCT_REF(BgL_locz00_1513,
																	(int) (((long) 1))), BNIL);
															BgL_arg1702z00_1562 =
																MAKE_PAIR(BgL_arg1703z00_1563,
																BgL_arg1705z00_1564);
														}
														BgL_lz00_1520 =
															MAKE_PAIR(CNST_TABLE_REF(((long) 13)),
															BgL_arg1702z00_1562);
													}
												else
													{	/* Trace/walk.scm 254 */
														BgL_lz00_1520 = BFALSE;
													}
											}
											{	/* Trace/walk.scm 254 */
												obj_t BgL_expz00_1521;

												{	/* Trace/walk.scm 256 */
													obj_t BgL_arg1644z00_1525;

													{	/* Trace/walk.scm 256 */
														obj_t BgL_arg1647z00_1526;
														obj_t BgL_arg1651z00_1527;

														{	/* Trace/walk.scm 256 */
															obj_t BgL_arg1652z00_1528;
															obj_t BgL_arg1656z00_1529;

															{	/* Trace/walk.scm 256 */
																obj_t BgL_arg1657z00_1530;

																{	/* Trace/walk.scm 256 */
																	obj_t BgL_arg1663z00_1531;

																	{	/* Trace/walk.scm 256 */
																		obj_t BgL_arg1669z00_1532;

																		BgL_arg1669z00_1532 =
																			MAKE_PAIR(BgL_symz00_1519, BNIL);
																		BgL_arg1663z00_1531 =
																			MAKE_PAIR(CNST_TABLE_REF(((long) 14)),
																			BgL_arg1669z00_1532);
																	}
																	BgL_arg1657z00_1530 =
																		MAKE_PAIR(BgL_arg1663z00_1531, BNIL);
																}
																BgL_arg1652z00_1528 =
																	MAKE_PAIR(BgL_tmp1z00_1516,
																	BgL_arg1657z00_1530);
															}
															{	/* Trace/walk.scm 257 */
																obj_t BgL_arg1670z00_1533;
																obj_t BgL_arg1671z00_1534;

																{	/* Trace/walk.scm 257 */
																	obj_t BgL_arg1672z00_1535;

																	{	/* Trace/walk.scm 257 */
																		obj_t BgL_arg1673z00_1536;

																		{	/* Trace/walk.scm 257 */
																			obj_t BgL_arg1674z00_1537;

																			BgL_arg1674z00_1537 =
																				MAKE_PAIR(BgL_lz00_1520, BNIL);
																			BgL_arg1673z00_1536 =
																				MAKE_PAIR(CNST_TABLE_REF(((long) 14)),
																				BgL_arg1674z00_1537);
																		}
																		BgL_arg1672z00_1535 =
																			MAKE_PAIR(BgL_arg1673z00_1536, BNIL);
																	}
																	BgL_arg1670z00_1533 =
																		MAKE_PAIR(BgL_tmp2z00_1517,
																		BgL_arg1672z00_1535);
																}
																{	/* Trace/walk.scm 258 */
																	obj_t BgL_arg1675z00_1538;

																	{	/* Trace/walk.scm 258 */
																		obj_t BgL_arg1676z00_1539;
																		obj_t BgL_arg1677z00_1540;

																		BgL_arg1676z00_1539 =
																			BGl_makezd2typedzd2identz00zzast_identz00
																			(BgL_tmp3z00_1518,
																			CNST_TABLE_REF(((long) 15)));
																		{	/* Trace/walk.scm 258 */
																			obj_t BgL_arg1678z00_1541;

																			BgL_arg1678z00_1541 =
																				MAKE_PAIR(CNST_TABLE_REF(((long) 16)),
																				BNIL);
																			BgL_arg1677z00_1540 =
																				MAKE_PAIR(BgL_arg1678z00_1541, BNIL);
																		}
																		BgL_arg1675z00_1538 =
																			MAKE_PAIR(BgL_arg1676z00_1539,
																			BgL_arg1677z00_1540);
																	}
																	BgL_arg1671z00_1534 =
																		MAKE_PAIR(BgL_arg1675z00_1538, BNIL);
																}
																BgL_arg1656z00_1529 =
																	MAKE_PAIR(BgL_arg1670z00_1533,
																	BgL_arg1671z00_1534);
															}
															BgL_arg1647z00_1526 =
																MAKE_PAIR(BgL_arg1652z00_1528,
																BgL_arg1656z00_1529);
														}
														{	/* Trace/walk.scm 260 */
															obj_t BgL_arg1679z00_1542;

															{	/* Trace/walk.scm 260 */
																obj_t BgL_arg1680z00_1543;

																{	/* Trace/walk.scm 260 */
																	obj_t BgL_arg1682z00_1544;

																	{	/* Trace/walk.scm 260 */
																		obj_t BgL_arg1683z00_1545;
																		obj_t BgL_arg1684z00_1546;

																		{	/* Trace/walk.scm 260 */
																			obj_t BgL_arg1685z00_1547;

																			{	/* Trace/walk.scm 260 */
																				obj_t BgL_arg1686z00_1548;

																				{	/* Trace/walk.scm 260 */
																					obj_t BgL_arg1687z00_1549;

																					BgL_arg1687z00_1549 =
																						MAKE_PAIR(BgL_tmp2z00_1517, BNIL);
																					BgL_arg1686z00_1548 =
																						MAKE_PAIR(BgL_tmp1z00_1516,
																						BgL_arg1687z00_1549);
																				}
																				BgL_arg1685z00_1547 =
																					MAKE_PAIR(BgL_tmp3z00_1518,
																					BgL_arg1686z00_1548);
																			}
																			BgL_arg1683z00_1545 =
																				MAKE_PAIR(CNST_TABLE_REF(((long) 17)),
																				BgL_arg1685z00_1547);
																		}
																		{	/* Trace/walk.scm 261 */
																			obj_t BgL_arg1688z00_1550;

																			{	/* Trace/walk.scm 261 */
																				obj_t BgL_arg1689z00_1551;

																				{	/* Trace/walk.scm 261 */
																					obj_t BgL_arg1690z00_1552;
																					obj_t BgL_arg1691z00_1553;

																					{	/* Trace/walk.scm 261 */
																						obj_t BgL_arg1692z00_1554;

																						{	/* Trace/walk.scm 261 */
																							obj_t BgL_arg1694z00_1555;

																							BgL_arg1694z00_1555 =
																								MAKE_PAIR(
																								((obj_t) BgL_nodez00_37), BNIL);
																							BgL_arg1692z00_1554 =
																								MAKE_PAIR(BgL_tauxz00_1515,
																								BgL_arg1694z00_1555);
																						}
																						BgL_arg1690z00_1552 =
																							MAKE_PAIR(BgL_arg1692z00_1554,
																							BNIL);
																					}
																					{	/* Trace/walk.scm 262 */
																						obj_t BgL_arg1695z00_1556;
																						obj_t BgL_arg1696z00_1557;

																						{	/* Trace/walk.scm 262 */
																							bool_t BgL_testz00_2958;

																							if (STRUCTP(BgL_llocz00_40))
																								{	/* Trace/walk.scm 262 */
																									BgL_testz00_2958 =
																										(STRUCT_KEY(BgL_llocz00_40)
																										==
																										CNST_TABLE_REF(((long)
																												12)));
																								}
																							else
																								{	/* Trace/walk.scm 262 */
																									BgL_testz00_2958 =
																										((bool_t) 0);
																								}
																							if (BgL_testz00_2958)
																								{	/* Trace/walk.scm 264 */
																									obj_t BgL_arg1698z00_1559;

																									{	/* Trace/walk.scm 264 */
																										obj_t BgL_res1953z00_2251;

																										BgL_res1953z00_2251 =
																											MAKE_EXTENDED_PAIR
																											(BgL_tmp3z00_1518, BNIL,
																											BgL_llocz00_40);
																										BgL_arg1698z00_1559 =
																											BgL_res1953z00_2251;
																									}
																									{	/* Trace/walk.scm 263 */
																										obj_t BgL_res1954z00_2255;

																										{	/* Trace/walk.scm 263 */
																											obj_t BgL_obj1z00_2252;

																											BgL_obj1z00_2252 =
																												CNST_TABLE_REF(((long)
																													18));
																											BgL_res1954z00_2255 =
																												MAKE_EXTENDED_PAIR
																												(BgL_obj1z00_2252,
																												BgL_arg1698z00_1559,
																												BgL_llocz00_40);
																										}
																										BgL_arg1695z00_1556 =
																											BgL_res1954z00_2255;
																								}}
																							else
																								{	/* Trace/walk.scm 266 */
																									obj_t BgL_arg1699z00_1560;

																									BgL_arg1699z00_1560 =
																										MAKE_PAIR(BgL_tmp3z00_1518,
																										BNIL);
																									BgL_arg1695z00_1556 =
																										MAKE_PAIR(CNST_TABLE_REF((
																												(long) 18)),
																										BgL_arg1699z00_1560);
																						}}
																						BgL_arg1696z00_1557 =
																							MAKE_PAIR(BgL_auxz00_1514, BNIL);
																						BgL_arg1691z00_1553 =
																							MAKE_PAIR(BgL_arg1695z00_1556,
																							BgL_arg1696z00_1557);
																					}
																					BgL_arg1689z00_1551 =
																						MAKE_PAIR(BgL_arg1690z00_1552,
																						BgL_arg1691z00_1553);
																				}
																				BgL_arg1688z00_1550 =
																					MAKE_PAIR(CNST_TABLE_REF(((long) 19)),
																					BgL_arg1689z00_1551);
																			}
																			BgL_arg1684z00_1546 =
																				MAKE_PAIR(BgL_arg1688z00_1550, BNIL);
																		}
																		BgL_arg1682z00_1544 =
																			MAKE_PAIR(BgL_arg1683z00_1545,
																			BgL_arg1684z00_1546);
																	}
																	BgL_arg1680z00_1543 =
																		MAKE_PAIR(BNIL, BgL_arg1682z00_1544);
																}
																BgL_arg1679z00_1542 =
																	MAKE_PAIR(CNST_TABLE_REF(((long) 19)),
																	BgL_arg1680z00_1543);
															}
															BgL_arg1651z00_1527 =
																MAKE_PAIR(BgL_arg1679z00_1542, BNIL);
														}
														BgL_arg1644z00_1525 =
															MAKE_PAIR(BgL_arg1647z00_1526,
															BgL_arg1651z00_1527);
													}
													BgL_expz00_1521 =
														MAKE_PAIR(CNST_TABLE_REF(((long) 19)),
														BgL_arg1644z00_1525);
												}
												{	/* Trace/walk.scm 256 */
													BgL_nodez00_bglt BgL_nnodez00_1522;

													BgL_nnodez00_1522 =
														BGl_sexpzd2ze3nodez31zzast_sexpz00(BgL_expz00_1521,
														BNIL, BgL_locz00_1513, CNST_TABLE_REF(((long) 20)));
													{	/* Trace/walk.scm 268 */

														{	/* Trace/walk.scm 269 */
															bool_t BgL_arg1635z00_1523;

															{	/* Trace/walk.scm 269 */
																obj_t BgL_arg1643z00_1524;

																BgL_arg1643z00_1524 =
																	BGl_thezd2backendzd2zzbackend_backendz00();
																BgL_arg1635z00_1523 =
																	(((BgL_backendz00_bglt) CREF(
																			((BgL_backendz00_bglt)
																				BgL_arg1643z00_1524)))->
																	BgL_removezd2emptyzd2letz00);
															}
															((((BgL_letzd2varzd2_bglt) CREF(
																			((BgL_letzd2varzd2_bglt)
																				BgL_nnodez00_1522)))->
																	BgL_removablezf3zf3) =
																((bool_t) BgL_arg1635z00_1523), BUNSPEC);
														}
														return ((BgL_letzd2varzd2_bglt) BgL_nnodez00_1522);
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* trace-node*! */
	bool_t BGl_tracezd2nodeza2z12z62zztrace_walkz00(obj_t BgL_nodeza2za2_80,
		obj_t BgL_stackz00_81)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 434 */
		BGl_tracezd2nodeza2z12z62zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_80))
				{	/* Trace/walk.scm 435 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 435 */
					{	/* Trace/walk.scm 436 */
						BgL_nodez00_bglt BgL_arg1727z00_1580;

						{	/* Trace/walk.scm 436 */
							obj_t BgL_arg1728z00_1581;

							BgL_arg1728z00_1581 = CAR(BgL_nodeza2za2_80);
							BgL_arg1727z00_1580 =
								BGl_tracezd2nodezd2zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1728z00_1581), BgL_stackz00_81);
						}
						{	/* Trace/walk.scm 436 */
							obj_t BgL_auxz00_2997;

							BgL_auxz00_2997 = ((obj_t) BgL_arg1727z00_1580);
							SET_CAR(BgL_nodeza2za2_80, BgL_auxz00_2997);
						}
					}
					{
						obj_t BgL_nodeza2za2_3000;

						BgL_nodeza2za2_3000 = CDR(BgL_nodeza2za2_80);
						BgL_nodeza2za2_80 = BgL_nodeza2za2_3000;
						goto BGl_tracezd2nodeza2z12z62zztrace_walkz00;
					}
				}
		}
	}



/* toplevel-trace-node*! */
	bool_t BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(obj_t
		BgL_nodeza2za2_86)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 485 */
		BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00:
			if (NULLP(BgL_nodeza2za2_86))
				{	/* Trace/walk.scm 486 */
					return ((bool_t) 0);
				}
			else
				{	/* Trace/walk.scm 486 */
					{	/* Trace/walk.scm 487 */
						BgL_nodez00_bglt BgL_arg1732z00_1584;

						{	/* Trace/walk.scm 487 */
							obj_t BgL_arg1735z00_1585;

							BgL_arg1735z00_1585 = CAR(BgL_nodeza2za2_86);
							BgL_arg1732z00_1584 =
								BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1735z00_1585));
						}
						{	/* Trace/walk.scm 487 */
							obj_t BgL_auxz00_3007;

							BgL_auxz00_3007 = ((obj_t) BgL_arg1732z00_1584);
							SET_CAR(BgL_nodeza2za2_86, BgL_auxz00_3007);
						}
					}
					{
						obj_t BgL_nodeza2za2_3010;

						BgL_nodeza2za2_3010 = CDR(BgL_nodeza2za2_86);
						BgL_nodeza2za2_86 = BgL_nodeza2za2_3010;
						goto BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00;
					}
				}
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2002z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2003z00zztrace_walkz00);
			BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_proc2004z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2005z00zztrace_walkz00);
			return
				BGl_registerzd2genericz12zc0zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_proc2006z00zztrace_walkz00, BGl_nodez00zzast_nodez00,
				BGl_string2007z00zztrace_walkz00);
		}
	}



/* &toplevel-trace-node1371 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2node1371z62zztrace_walkz00(obj_t
		BgL_envz00_2468, obj_t BgL_nodez00_2469)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 442 */
			return ((BgL_nodez00_bglt) BgL_nodez00_2469);
		}
	}



/* &trace-node1332 */
	BgL_nodez00_bglt BGl_z62tracezd2node1332zb0zztrace_walkz00(obj_t
		BgL_envz00_2470, obj_t BgL_nodez00_2471, obj_t BgL_stackz00_2472)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 275 */
			return ((BgL_nodez00_bglt) BgL_nodez00_2471);
		}
	}



/* &find-last-node1302 */
	BgL_nodez00_bglt BGl_z62findzd2lastzd2node1302z62zztrace_walkz00(obj_t
		BgL_envz00_2473, obj_t BgL_nodez00_2474)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 138 */
			return ((BgL_nodez00_bglt) BgL_nodez00_2474);
		}
	}



/* find-last-node */
	obj_t BGl_findzd2lastzd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_22)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 138 */
			{	/* Trace/walk.scm 138 */
				obj_t BgL_method1303z00_1600;

				{	/* Trace/walk.scm 138 */
					obj_t BgL_res1964z00_2301;

					{	/* Trace/walk.scm 138 */
						long BgL_objzd2classzd2numz00_2274;

						{	/* Trace/walk.scm 138 */
							long BgL_res1958z00_2277;

							BgL_res1958z00_2277 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_22));
							BgL_objzd2classzd2numz00_2274 = BgL_res1958z00_2277;
						}
						{	/* Trace/walk.scm 138 */
							obj_t BgL_arg1664z00_2275;

							BgL_arg1664z00_2275 =
								PROCEDURE_REF(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 138 */
								int BgL_offsetz00_2279;

								BgL_offsetz00_2279 = (int) (BgL_objzd2classzd2numz00_2274);
								{	/* Trace/walk.scm 138 */
									long BgL_offsetz00_2280;

									BgL_offsetz00_2280 =
										((long) (BgL_offsetz00_2279) - OBJECT_TYPE);
									{	/* Trace/walk.scm 138 */
										long BgL_modz00_2281;

										{	/* Trace/walk.scm 138 */
											int BgL_arg1666z00_2282;

											BgL_arg1666z00_2282 = (int) (((long) 16));
											{	/* Trace/walk.scm 138 */
												long BgL_res1961z00_2292;

												{	/* Trace/walk.scm 138 */
													long BgL_auxz00_3026;

													BgL_auxz00_3026 = (long) (BgL_arg1666z00_2282);
													BgL_res1961z00_2292 =
														(BgL_offsetz00_2280 / BgL_auxz00_3026);
												}
												BgL_modz00_2281 = BgL_res1961z00_2292;
										}}
										{	/* Trace/walk.scm 138 */
											long BgL_restz00_2283;

											{	/* Trace/walk.scm 138 */
												int BgL_arg1665z00_2284;

												BgL_arg1665z00_2284 = (int) (((long) 16));
												{	/* Trace/walk.scm 138 */
													long BgL_res1963z00_2296;

													{	/* Trace/walk.scm 138 */
														long BgL_auxz00_3030;

														BgL_auxz00_3030 = (long) (BgL_arg1665z00_2284);
														BgL_res1963z00_2296 =
															(BgL_offsetz00_2280 % BgL_auxz00_3030);
													}
													BgL_restz00_2283 = BgL_res1963z00_2296;
											}}
											{	/* Trace/walk.scm 138 */

												BgL_res1964z00_2301 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2275,
														(int) (BgL_modz00_2281)), (int) (BgL_restz00_2283));
					}}}}}}}
					BgL_method1303z00_1600 = BgL_res1964z00_2301;
				}
				return
					PROCEDURE_ENTRY(BgL_method1303z00_1600) (BgL_method1303z00_1600,
					((obj_t) BgL_nodez00_22), BEOA);
			}
		}
	}



/* &find-last-node */
	obj_t BGl_z62findzd2lastzd2nodez62zztrace_walkz00(obj_t BgL_envz00_2475,
		obj_t BgL_nodez00_2476)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 138 */
			return
				BGl_findzd2lastzd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2476));
		}
	}



/* trace-node */
	BgL_nodez00_bglt BGl_tracezd2nodezd2zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_42, obj_t BgL_stackz00_43)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 275 */
			{	/* Trace/walk.scm 275 */
				obj_t BgL_method1333z00_1601;

				{	/* Trace/walk.scm 275 */
					obj_t BgL_res1971z00_2330;

					{	/* Trace/walk.scm 275 */
						long BgL_objzd2classzd2numz00_2303;

						{	/* Trace/walk.scm 275 */
							long BgL_res1965z00_2306;

							BgL_res1965z00_2306 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_42));
							BgL_objzd2classzd2numz00_2303 = BgL_res1965z00_2306;
						}
						{	/* Trace/walk.scm 275 */
							obj_t BgL_arg1664z00_2304;

							BgL_arg1664z00_2304 =
								PROCEDURE_REF(BGl_tracezd2nodezd2envz00zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 275 */
								int BgL_offsetz00_2308;

								BgL_offsetz00_2308 = (int) (BgL_objzd2classzd2numz00_2303);
								{	/* Trace/walk.scm 275 */
									long BgL_offsetz00_2309;

									BgL_offsetz00_2309 =
										((long) (BgL_offsetz00_2308) - OBJECT_TYPE);
									{	/* Trace/walk.scm 275 */
										long BgL_modz00_2310;

										{	/* Trace/walk.scm 275 */
											int BgL_arg1666z00_2311;

											BgL_arg1666z00_2311 = (int) (((long) 16));
											{	/* Trace/walk.scm 275 */
												long BgL_res1968z00_2321;

												{	/* Trace/walk.scm 275 */
													long BgL_auxz00_3052;

													BgL_auxz00_3052 = (long) (BgL_arg1666z00_2311);
													BgL_res1968z00_2321 =
														(BgL_offsetz00_2309 / BgL_auxz00_3052);
												}
												BgL_modz00_2310 = BgL_res1968z00_2321;
										}}
										{	/* Trace/walk.scm 275 */
											long BgL_restz00_2312;

											{	/* Trace/walk.scm 275 */
												int BgL_arg1665z00_2313;

												BgL_arg1665z00_2313 = (int) (((long) 16));
												{	/* Trace/walk.scm 275 */
													long BgL_res1970z00_2325;

													{	/* Trace/walk.scm 275 */
														long BgL_auxz00_3056;

														BgL_auxz00_3056 = (long) (BgL_arg1665z00_2313);
														BgL_res1970z00_2325 =
															(BgL_offsetz00_2309 % BgL_auxz00_3056);
													}
													BgL_restz00_2312 = BgL_res1970z00_2325;
											}}
											{	/* Trace/walk.scm 275 */

												BgL_res1971z00_2330 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2304,
														(int) (BgL_modz00_2310)), (int) (BgL_restz00_2312));
					}}}}}}}
					BgL_method1333z00_1601 = BgL_res1971z00_2330;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1333z00_1601) (BgL_method1333z00_1601,
						((obj_t) BgL_nodez00_42), BgL_stackz00_43, BEOA));
			}
		}
	}



/* &trace-node */
	BgL_nodez00_bglt BGl_z62tracezd2nodezb0zztrace_walkz00(obj_t BgL_envz00_2477,
		obj_t BgL_nodez00_2478, obj_t BgL_stackz00_2479)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 275 */
			return
				BGl_tracezd2nodezd2zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2478), BgL_stackz00_2479);
		}
	}



/* toplevel-trace-node */
	BgL_nodez00_bglt
		BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(BgL_nodez00_bglt
		BgL_nodez00_82)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 442 */
			{	/* Trace/walk.scm 442 */
				obj_t BgL_method1378z00_1602;

				{	/* Trace/walk.scm 442 */
					obj_t BgL_res1978z00_2359;

					{	/* Trace/walk.scm 442 */
						long BgL_objzd2classzd2numz00_2332;

						{	/* Trace/walk.scm 442 */
							long BgL_res1972z00_2335;

							BgL_res1972z00_2335 =
								BGL_OBJECT_CLASS_NUM(((BgL_objectz00_bglt) BgL_nodez00_82));
							BgL_objzd2classzd2numz00_2332 = BgL_res1972z00_2335;
						}
						{	/* Trace/walk.scm 442 */
							obj_t BgL_arg1664z00_2333;

							BgL_arg1664z00_2333 =
								PROCEDURE_REF
								(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
								(int) (((long) 1)));
							{	/* Trace/walk.scm 442 */
								int BgL_offsetz00_2337;

								BgL_offsetz00_2337 = (int) (BgL_objzd2classzd2numz00_2332);
								{	/* Trace/walk.scm 442 */
									long BgL_offsetz00_2338;

									BgL_offsetz00_2338 =
										((long) (BgL_offsetz00_2337) - OBJECT_TYPE);
									{	/* Trace/walk.scm 442 */
										long BgL_modz00_2339;

										{	/* Trace/walk.scm 442 */
											int BgL_arg1666z00_2340;

											BgL_arg1666z00_2340 = (int) (((long) 16));
											{	/* Trace/walk.scm 442 */
												long BgL_res1975z00_2350;

												{	/* Trace/walk.scm 442 */
													long BgL_auxz00_3080;

													BgL_auxz00_3080 = (long) (BgL_arg1666z00_2340);
													BgL_res1975z00_2350 =
														(BgL_offsetz00_2338 / BgL_auxz00_3080);
												}
												BgL_modz00_2339 = BgL_res1975z00_2350;
										}}
										{	/* Trace/walk.scm 442 */
											long BgL_restz00_2341;

											{	/* Trace/walk.scm 442 */
												int BgL_arg1665z00_2342;

												BgL_arg1665z00_2342 = (int) (((long) 16));
												{	/* Trace/walk.scm 442 */
													long BgL_res1977z00_2354;

													{	/* Trace/walk.scm 442 */
														long BgL_auxz00_3084;

														BgL_auxz00_3084 = (long) (BgL_arg1665z00_2342);
														BgL_res1977z00_2354 =
															(BgL_offsetz00_2338 % BgL_auxz00_3084);
													}
													BgL_restz00_2341 = BgL_res1977z00_2354;
											}}
											{	/* Trace/walk.scm 442 */

												BgL_res1978z00_2359 =
													VECTOR_REF(VECTOR_REF(BgL_arg1664z00_2333,
														(int) (BgL_modz00_2339)), (int) (BgL_restz00_2341));
					}}}}}}}
					BgL_method1378z00_1602 = BgL_res1978z00_2359;
				}
				return
					((BgL_nodez00_bglt)
					PROCEDURE_ENTRY(BgL_method1378z00_1602) (BgL_method1378z00_1602,
						((obj_t) BgL_nodez00_82), BEOA));
			}
		}
	}



/* &toplevel-trace-node */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodez62zztrace_walkz00(obj_t
		BgL_envz00_2480, obj_t BgL_nodez00_2481)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 442 */
			return
				BGl_toplevelzd2tracezd2nodez00zztrace_walkz00(
				((BgL_nodez00_bglt) BgL_nodez00_2481));
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2008z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2010z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appz00zzast_nodez00, BGl_proc2011z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_appzd2lyzd2zzast_nodez00, BGl_proc2012z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_funcallz00zzast_nodez00, BGl_proc2013z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_externz00zzast_nodez00, BGl_proc2014z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2015z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2016z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_failz00zzast_nodez00, BGl_proc2017z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_selectz00zzast_nodez00, BGl_proc2018z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2019z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2020z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2021z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_findzd2lastzd2nodezd2envzd2zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2022z00zztrace_walkz00,
				BGl_string2009z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_sequencez00zzast_nodez00,
				BGl_proc2023z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_syncz00zzast_nodez00,
				BGl_proc2025z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appz00zzast_nodez00,
				BGl_proc2026z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_appzd2lyzd2zzast_nodez00,
				BGl_proc2027z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_funcallz00zzast_nodez00,
				BGl_proc2028z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_externz00zzast_nodez00,
				BGl_proc2029z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_castz00zzast_nodez00,
				BGl_proc2030z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_setqz00zzast_nodez00,
				BGl_proc2031z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_conditionalz00zzast_nodez00, BGl_proc2032z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_failz00zzast_nodez00,
				BGl_proc2033z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00, BGl_selectz00zzast_nodez00,
				BGl_proc2034z00zztrace_walkz00, BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2funzd2zzast_nodez00, BGl_proc2035z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_letzd2varzd2zzast_nodez00, BGl_proc2036z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_setzd2exzd2itz00zzast_nodez00, BGl_proc2037z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_jumpzd2exzd2itz00zzast_nodez00, BGl_proc2038z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_makezd2boxzd2zzast_nodez00, BGl_proc2039z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2refzd2zzast_nodez00, BGl_proc2040z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_tracezd2nodezd2envz00zztrace_walkz00,
				BGl_boxzd2setz12zc0zzast_nodez00, BGl_proc2041z00zztrace_walkz00,
				BGl_string2024z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_sequencez00zzast_nodez00, BGl_proc2042z00zztrace_walkz00,
				BGl_string2043z00zztrace_walkz00);
			BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_syncz00zzast_nodez00, BGl_proc2044z00zztrace_walkz00,
				BGl_string2043z00zztrace_walkz00);
			return
				BGl_genericzd2addzd2methodz12z12zz__objectz00
				(BGl_toplevelzd2tracezd2nodezd2envzd2zztrace_walkz00,
				BGl_setqz00zzast_nodez00, BGl_proc2045z00zztrace_walkz00,
				BGl_string2043z00zztrace_walkz00);
		}
	}



/* &toplevel-trace-node-1386 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21386zb0zztrace_walkz00(obj_t
		BgL_envz00_2517, obj_t BgL_nodez00_2518)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 469 */
			{
				BgL_setqz00_bglt BgL_nodez00_1876;

				BgL_nodez00_1876 = ((BgL_setqz00_bglt) BgL_nodez00_2518);
				{	/* Trace/walk.scm 471 */
					BgL_varz00_bglt BgL_i1129z00_1880;

					BgL_i1129z00_1880 =
						(((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->BgL_varz00);
					{	/* Trace/walk.scm 472 */
						bool_t BgL_testz00_3135;

						{	/* Trace/walk.scm 472 */
							bool_t BgL_testz00_3136;

							{	/* Trace/walk.scm 472 */
								BgL_variablez00_bglt BgL_arg1863z00_1901;

								BgL_arg1863z00_1901 =
									(((BgL_varz00_bglt) CREF(BgL_i1129z00_1880))->
									BgL_variablez00);
								{	/* Trace/walk.scm 472 */
									bool_t BgL_res1987z00_2451;

									BgL_res1987z00_2451 =
										BGl_isazf3zf3zz__objectz00(
										((obj_t) BgL_arg1863z00_1901), BGl_globalz00zzast_varz00);
									BgL_testz00_3136 = BgL_res1987z00_2451;
								}
							}
							if (BgL_testz00_3136)
								{	/* Trace/walk.scm 473 */
									bool_t BgL_testz00_3140;

									{	/* Trace/walk.scm 473 */
										bool_t BgL_testz00_3141;

										{	/* Trace/walk.scm 473 */
											BgL_nodez00_bglt BgL_arg1862z00_1900;

											BgL_arg1862z00_1900 =
												(((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->
												BgL_valuez00);
											{	/* Trace/walk.scm 473 */
												bool_t BgL_res1988z00_2453;

												BgL_res1988z00_2453 =
													BGl_isazf3zf3zz__objectz00(
													((obj_t) BgL_arg1862z00_1900),
													BGl_atomz00zzast_nodez00);
												BgL_testz00_3141 = BgL_res1988z00_2453;
											}
										}
										if (BgL_testz00_3141)
											{	/* Trace/walk.scm 473 */
												BgL_testz00_3140 = ((bool_t) 1);
											}
										else
											{	/* Trace/walk.scm 474 */
												bool_t BgL_testz00_3145;

												{	/* Trace/walk.scm 474 */
													BgL_nodez00_bglt BgL_arg1861z00_1899;

													BgL_arg1861z00_1899 =
														(((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->
														BgL_valuez00);
													{	/* Trace/walk.scm 474 */
														bool_t BgL_res1989z00_2455;

														BgL_res1989z00_2455 =
															BGl_isazf3zf3zz__objectz00(
															((obj_t) BgL_arg1861z00_1899),
															BGl_varz00zzast_nodez00);
														BgL_testz00_3145 = BgL_res1989z00_2455;
													}
												}
												if (BgL_testz00_3145)
													{	/* Trace/walk.scm 474 */
														BgL_testz00_3140 = ((bool_t) 1);
													}
												else
													{	/* Trace/walk.scm 475 */
														bool_t BgL_testz00_3149;

														{	/* Trace/walk.scm 475 */
															BgL_nodez00_bglt BgL_arg1860z00_1898;

															BgL_arg1860z00_1898 =
																(((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->
																BgL_valuez00);
															{	/* Trace/walk.scm 475 */
																bool_t BgL_res1990z00_2457;

																BgL_res1990z00_2457 =
																	BGl_isazf3zf3zz__objectz00(
																	((obj_t) BgL_arg1860z00_1898),
																	BGl_kwotez00zzast_nodez00);
																BgL_testz00_3149 = BgL_res1990z00_2457;
															}
														}
														if (BgL_testz00_3149)
															{	/* Trace/walk.scm 475 */
																BgL_testz00_3140 = ((bool_t) 1);
															}
														else
															{	/* Trace/walk.scm 476 */
																BgL_nodez00_bglt BgL_arg1859z00_1897;

																BgL_arg1859z00_1897 =
																	(((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->
																	BgL_valuez00);
																{	/* Trace/walk.scm 476 */
																	bool_t BgL_res1991z00_2459;

																	BgL_res1991z00_2459 =
																		BGl_isazf3zf3zz__objectz00(
																		((obj_t) BgL_arg1859z00_1897),
																		BGl_pragmaz00zzast_nodez00);
																	BgL_testz00_3140 = BgL_res1991z00_2459;
																}
															}
													}
											}
									}
									if (BgL_testz00_3140)
										{	/* Trace/walk.scm 473 */
											BgL_testz00_3135 = ((bool_t) 0);
										}
									else
										{	/* Trace/walk.scm 473 */
											BgL_testz00_3135 = ((bool_t) 1);
										}
								}
							else
								{	/* Trace/walk.scm 472 */
									BgL_testz00_3135 = ((bool_t) 0);
								}
						}
						if (BgL_testz00_3135)
							{	/* Trace/walk.scm 477 */
								BgL_typez00_bglt BgL_tz00_1882;

								{	/* Trace/walk.scm 477 */
									BgL_typez00_bglt BgL_arg1849z00_1888;
									BgL_typez00_bglt BgL_arg1850z00_1889;

									BgL_arg1849z00_1888 =
										(((BgL_nodez00_bglt) CREF(
												(((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->
													BgL_valuez00)))->BgL_typez00);
									BgL_arg1850z00_1889 =
										(((BgL_variablez00_bglt)
											CREF(((BgL_variablez00_bglt) ((BgL_globalz00_bglt) ((
																(BgL_varz00_bglt) CREF(BgL_i1129z00_1880))->
															BgL_variablez00)))))->BgL_typez00);
									BgL_tz00_1882 =
										BGl_strictzd2nodezd2typez00zzast_nodez00
										(BgL_arg1849z00_1888, BgL_arg1850z00_1889);
								}
								{	/* Trace/walk.scm 477 */
									BgL_letzd2varzd2_bglt BgL_tracez00_1883;

									{	/* Trace/walk.scm 478 */
										BgL_nodez00_bglt BgL_arg1845z00_1884;
										obj_t BgL_arg1846z00_1885;
										obj_t BgL_arg1847z00_1886;

										BgL_arg1845z00_1884 =
											(((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->
											BgL_valuez00);
										{	/* Trace/walk.scm 478 */
											BgL_variablez00_bglt BgL_arg1848z00_1887;

											BgL_arg1848z00_1887 =
												(((BgL_varz00_bglt) CREF(BgL_i1129z00_1880))->
												BgL_variablez00);
											BgL_arg1846z00_1885 =
												BGl_tracezd2idzd2zztrace_walkz00(((obj_t)
													BgL_arg1848z00_1887));
										}
										BgL_arg1847z00_1886 =
											(((BgL_nodez00_bglt) CREF(
													((BgL_nodez00_bglt) BgL_nodez00_1876)))->BgL_locz00);
										BgL_tracez00_1883 =
											BGl_makezd2tracedzd2nodez00zztrace_walkz00
											(BgL_arg1845z00_1884, BgL_tz00_1882, BgL_arg1846z00_1885,
											BgL_arg1847z00_1886, BNIL);
									}
									{	/* Trace/walk.scm 478 */

										((((BgL_setqz00_bglt) CREF(BgL_nodez00_1876))->
												BgL_valuez00) =
											((BgL_nodez00_bglt) ((BgL_nodez00_bglt)
													BgL_tracez00_1883)), BUNSPEC);
									}
								}
							}
						else
							{	/* Trace/walk.scm 472 */
								BFALSE;
							}
					}
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1876);
			}
		}
	}



/* &toplevel-trace-node-1384 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21384zb0zztrace_walkz00(obj_t
		BgL_envz00_2519, obj_t BgL_nodez00_2520)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 455 */
			{
				BgL_syncz00_bglt BgL_nodez00_1866;

				BgL_nodez00_1866 = ((BgL_syncz00_bglt) BgL_nodez00_2520);
				((((BgL_syncz00_bglt) CREF(BgL_nodez00_1866))->BgL_mutexz00) =
					((BgL_nodez00_bglt)
						BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
									CREF(BgL_nodez00_1866))->BgL_mutexz00))), BUNSPEC);
				((((BgL_syncz00_bglt) CREF(BgL_nodez00_1866))->BgL_prelockz00) =
					((BgL_nodez00_bglt)
						BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
									CREF(BgL_nodez00_1866))->BgL_prelockz00))), BUNSPEC);
				((((BgL_syncz00_bglt) CREF(BgL_nodez00_1866))->BgL_bodyz00) =
					((BgL_nodez00_bglt)
						BGl_toplevelzd2tracezd2nodez00zztrace_walkz00((((BgL_syncz00_bglt)
									CREF(BgL_nodez00_1866))->BgL_bodyz00))), BUNSPEC);
				return ((BgL_nodez00_bglt) BgL_nodez00_1866);
			}
		}
	}



/* &toplevel-trace-node-1382 */
	BgL_nodez00_bglt BGl_z62toplevelzd2tracezd2nodezd21382zb0zztrace_walkz00(obj_t
		BgL_envz00_2521, obj_t BgL_nodez00_2522)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 448 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1861;

				BgL_nodez00_1861 = ((BgL_sequencez00_bglt) BgL_nodez00_2522);
				BGl_toplevelzd2tracezd2nodeza2z12zb0zztrace_walkz00(
					(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1861))->BgL_nodesz00));
				return ((BgL_nodez00_bglt) BgL_nodez00_1861);
			}
		}
	}



/* &trace-node-box-set!1370 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2boxzd2setz121370za2zztrace_walkz00(obj_t
		BgL_envz00_2523, obj_t BgL_nodez00_2524, obj_t BgL_stackz00_2525)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 425 */
			{
				BgL_boxzd2setz12zc0_bglt BgL_nodez00_1853;
				obj_t BgL_stackz00_1854;

				BgL_nodez00_1853 = ((BgL_boxzd2setz12zc0_bglt) BgL_nodez00_2524);
				BgL_stackz00_1854 = BgL_stackz00_2525;
				{
					BgL_varz00_bglt BgL_auxz00_3189;

					{	/* Trace/walk.scm 427 */
						BgL_varz00_bglt BgL_arg1832z00_1858;

						BgL_arg1832z00_1858 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1853))->BgL_varz00);
						BgL_auxz00_3189 =
							((BgL_varz00_bglt)
							BGl_tracezd2nodezd2zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1832z00_1858), BgL_stackz00_1854));
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1853))->BgL_varz00) =
						((BgL_varz00_bglt) BgL_auxz00_3189), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3195;

					{	/* Trace/walk.scm 428 */
						BgL_nodez00_bglt BgL_arg1833z00_1859;

						BgL_arg1833z00_1859 =
							(((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1853))->
							BgL_valuez00);
						BgL_auxz00_3195 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1833z00_1859,
							BgL_stackz00_1854);
					}
					((((BgL_boxzd2setz12zc0_bglt) CREF(BgL_nodez00_1853))->BgL_valuez00) =
						((BgL_nodez00_bglt) BgL_auxz00_3195), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1853);
			}
		}
	}



/* &trace-node-box-ref1368 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2boxzd2ref1368zb0zztrace_walkz00(obj_t
		BgL_envz00_2526, obj_t BgL_nodez00_2527, obj_t BgL_stackz00_2528)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 418 */
			{
				BgL_boxzd2refzd2_bglt BgL_nodez00_1846;
				obj_t BgL_stackz00_1847;

				BgL_nodez00_1846 = ((BgL_boxzd2refzd2_bglt) BgL_nodez00_2527);
				BgL_stackz00_1847 = BgL_stackz00_2528;
				{	/* Trace/walk.scm 419 */
					BgL_nodez00_bglt BgL_arg1830z00_2434;

					{	/* Trace/walk.scm 419 */
						BgL_varz00_bglt BgL_arg1831z00_2435;

						BgL_arg1831z00_2435 =
							(((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1846))->BgL_varz00);
						BgL_arg1830z00_2434 =
							BGl_tracezd2nodezd2zztrace_walkz00(
							((BgL_nodez00_bglt) BgL_arg1831z00_2435), BgL_stackz00_1847);
					}
					((((BgL_boxzd2refzd2_bglt) CREF(BgL_nodez00_1846))->BgL_varz00) =
						((BgL_varz00_bglt) ((BgL_varz00_bglt) BgL_arg1830z00_2434)),
						BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1846);
			}
		}
	}



/* &trace-node-make-box1366 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2makezd2box1366zb0zztrace_walkz00(obj_t
		BgL_envz00_2529, obj_t BgL_nodez00_2530, obj_t BgL_stackz00_2531)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 411 */
			{
				BgL_makezd2boxzd2_bglt BgL_nodez00_1839;
				obj_t BgL_stackz00_1840;

				BgL_nodez00_1839 = ((BgL_makezd2boxzd2_bglt) BgL_nodez00_2530);
				BgL_stackz00_1840 = BgL_stackz00_2531;
				((((BgL_makezd2boxzd2_bglt) CREF(BgL_nodez00_1839))->BgL_valuez00) =
					((BgL_nodez00_bglt)
						BGl_tracezd2nodezd2zztrace_walkz00((((BgL_makezd2boxzd2_bglt)
									CREF(BgL_nodez00_1839))->BgL_valuez00), BgL_stackz00_1840)),
					BUNSPEC);
				return ((BgL_nodez00_bglt) BgL_nodez00_1839);
			}
		}
	}



/* &trace-node-jump-ex-i1364 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2jumpzd2exzd2i1364z62zztrace_walkz00(obj_t
		BgL_envz00_2532, obj_t BgL_nodez00_2533, obj_t BgL_stackz00_2534)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 402 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1831;
				obj_t BgL_stackz00_1832;

				BgL_nodez00_1831 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2533);
				BgL_stackz00_1832 = BgL_stackz00_2534;
				{
					BgL_nodez00_bglt BgL_auxz00_3213;

					{	/* Trace/walk.scm 404 */
						BgL_nodez00_bglt BgL_arg1825z00_1836;

						BgL_arg1825z00_1836 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1831))->
							BgL_exitz00);
						BgL_auxz00_3213 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1825z00_1836,
							BgL_stackz00_1832);
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1831))->
							BgL_exitz00) = ((BgL_nodez00_bglt) BgL_auxz00_3213), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3217;

					{	/* Trace/walk.scm 405 */
						BgL_nodez00_bglt BgL_arg1826z00_1837;

						BgL_arg1826z00_1837 =
							(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1831))->
							BgL_valuez00);
						BgL_auxz00_3217 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1826z00_1837,
							BgL_stackz00_1832);
					}
					((((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1831))->
							BgL_valuez00) = ((BgL_nodez00_bglt) BgL_auxz00_3217), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1831);
			}
		}
	}



/* &trace-node-set-ex-it1362 */
	BgL_nodez00_bglt
		BGl_z62tracezd2nodezd2setzd2exzd2it1362z62zztrace_walkz00(obj_t
		BgL_envz00_2535, obj_t BgL_nodez00_2536, obj_t BgL_stackz00_2537)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 395 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1824;
				obj_t BgL_stackz00_1825;

				BgL_nodez00_1824 = ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2536);
				BgL_stackz00_1825 = BgL_stackz00_2537;
				((((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1824))->BgL_bodyz00) =
					((BgL_nodez00_bglt)
						BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setzd2exzd2itz00_bglt)
									CREF(BgL_nodez00_1824))->BgL_bodyz00), BgL_stackz00_1825)),
					BUNSPEC);
				return ((BgL_nodez00_bglt) BgL_nodez00_1824);
			}
		}
	}



/* &trace-node-let-var1360 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2var1360zb0zztrace_walkz00(obj_t
		BgL_envz00_2538, obj_t BgL_nodez00_2539, obj_t BgL_stackz00_2540)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 384 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1807;
				obj_t BgL_stackz00_1808;

				BgL_nodez00_1807 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_2539);
				BgL_stackz00_1808 = BgL_stackz00_2540;
				{	/* Trace/walk.scm 386 */
					obj_t BgL_g1301z00_1812;

					BgL_g1301z00_1812 =
						(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1807))->BgL_bindingsz00);
					{
						obj_t BgL_l1299z00_1814;

						BgL_l1299z00_1814 = BgL_g1301z00_1812;
					BgL_zc3anonymousza31817ze3z83_1815:
						if (PAIRP(BgL_l1299z00_1814))
							{	/* Trace/walk.scm 386 */
								{	/* Trace/walk.scm 387 */
									obj_t BgL_bindingz00_1817;

									BgL_bindingz00_1817 = CAR(BgL_l1299z00_1814);
									{	/* Trace/walk.scm 387 */
										BgL_nodez00_bglt BgL_arg1819z00_1818;

										{	/* Trace/walk.scm 387 */
											obj_t BgL_arg1820z00_1819;

											BgL_arg1820z00_1819 = CDR(BgL_bindingz00_1817);
											BgL_arg1819z00_1818 =
												BGl_tracezd2nodezd2zztrace_walkz00(
												((BgL_nodez00_bglt) BgL_arg1820z00_1819),
												BgL_stackz00_1808);
										}
										{	/* Trace/walk.scm 387 */
											obj_t BgL_auxz00_3235;

											BgL_auxz00_3235 = ((obj_t) BgL_arg1819z00_1818);
											SET_CDR(BgL_bindingz00_1817, BgL_auxz00_3235);
										}
									}
								}
								{
									obj_t BgL_l1299z00_3238;

									BgL_l1299z00_3238 = CDR(BgL_l1299z00_1814);
									BgL_l1299z00_1814 = BgL_l1299z00_3238;
									goto BgL_zc3anonymousza31817ze3z83_1815;
								}
							}
						else
							{	/* Trace/walk.scm 386 */
								((bool_t) 1);
							}
					}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3240;

					{	/* Trace/walk.scm 389 */
						BgL_nodez00_bglt BgL_arg1822z00_1822;

						BgL_arg1822z00_1822 =
							(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1807))->BgL_bodyz00);
						BgL_auxz00_3240 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1822z00_1822,
							BgL_stackz00_1808);
					}
					((((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1807))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3240), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1807);
			}
		}
	}



/* &trace-node-let-fun1358 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2letzd2fun1358zb0zztrace_walkz00(obj_t
		BgL_envz00_2541, obj_t BgL_nodez00_2542, obj_t BgL_stackz00_2543)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 375 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1792;
				obj_t BgL_stackz00_1793;

				BgL_nodez00_1792 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_2542);
				BgL_stackz00_1793 = BgL_stackz00_2543;
				{	/* Trace/walk.scm 377 */
					obj_t BgL_g1298z00_1797;

					BgL_g1298z00_1797 =
						(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1792))->BgL_localsz00);
					{
						obj_t BgL_l1296z00_1799;

						BgL_l1296z00_1799 = BgL_g1298z00_1797;
					BgL_zc3anonymousza31813ze3z83_1800:
						if (PAIRP(BgL_l1296z00_1799))
							{	/* Trace/walk.scm 377 */
								BGl_tracezd2funz12zc0zztrace_walkz00(CAR(BgL_l1296z00_1799),
									BgL_stackz00_1793);
								{
									obj_t BgL_l1296z00_3251;

									BgL_l1296z00_3251 = CDR(BgL_l1296z00_1799);
									BgL_l1296z00_1799 = BgL_l1296z00_3251;
									goto BgL_zc3anonymousza31813ze3z83_1800;
								}
							}
						else
							{	/* Trace/walk.scm 377 */
								((bool_t) 1);
							}
					}
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3253;

					{	/* Trace/walk.scm 378 */
						BgL_nodez00_bglt BgL_arg1816z00_1805;

						BgL_arg1816z00_1805 =
							(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1792))->BgL_bodyz00);
						BgL_auxz00_3253 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1816z00_1805,
							BgL_stackz00_1793);
					}
					((((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1792))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3253), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1792);
			}
		}
	}



/* &trace-node-select1356 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2select1356z62zztrace_walkz00(obj_t
		BgL_envz00_2544, obj_t BgL_nodez00_2545, obj_t BgL_stackz00_2546)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 364 */
			{
				BgL_selectz00_bglt BgL_nodez00_1775;
				obj_t BgL_stackz00_1776;

				BgL_nodez00_1775 = ((BgL_selectz00_bglt) BgL_nodez00_2545);
				BgL_stackz00_1776 = BgL_stackz00_2546;
				{
					BgL_nodez00_bglt BgL_auxz00_3259;

					{	/* Trace/walk.scm 366 */
						BgL_nodez00_bglt BgL_arg1807z00_1780;

						BgL_arg1807z00_1780 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1775))->BgL_testz00);
						BgL_auxz00_3259 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1807z00_1780,
							BgL_stackz00_1776);
					}
					((((BgL_selectz00_bglt) CREF(BgL_nodez00_1775))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3259), BUNSPEC);
				}
				{	/* Trace/walk.scm 367 */
					obj_t BgL_g1295z00_1781;

					BgL_g1295z00_1781 =
						(((BgL_selectz00_bglt) CREF(BgL_nodez00_1775))->BgL_clausesz00);
					{
						obj_t BgL_l1293z00_1783;

						BgL_l1293z00_1783 = BgL_g1295z00_1781;
					BgL_zc3anonymousza31808ze3z83_1784:
						if (PAIRP(BgL_l1293z00_1783))
							{	/* Trace/walk.scm 367 */
								{	/* Trace/walk.scm 368 */
									obj_t BgL_clausez00_1786;

									BgL_clausez00_1786 = CAR(BgL_l1293z00_1783);
									{	/* Trace/walk.scm 368 */
										BgL_nodez00_bglt BgL_arg1810z00_1787;

										{	/* Trace/walk.scm 368 */
											obj_t BgL_arg1811z00_1788;

											BgL_arg1811z00_1788 = CDR(BgL_clausez00_1786);
											BgL_arg1810z00_1787 =
												BGl_tracezd2nodezd2zztrace_walkz00(
												((BgL_nodez00_bglt) BgL_arg1811z00_1788),
												BgL_stackz00_1776);
										}
										{	/* Trace/walk.scm 368 */
											obj_t BgL_auxz00_3270;

											BgL_auxz00_3270 = ((obj_t) BgL_arg1810z00_1787);
											SET_CDR(BgL_clausez00_1786, BgL_auxz00_3270);
										}
									}
								}
								{
									obj_t BgL_l1293z00_3273;

									BgL_l1293z00_3273 = CDR(BgL_l1293z00_1783);
									BgL_l1293z00_1783 = BgL_l1293z00_3273;
									goto BgL_zc3anonymousza31808ze3z83_1784;
								}
							}
						else
							{	/* Trace/walk.scm 367 */
								((bool_t) 1);
							}
					}
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1775);
			}
		}
	}



/* &trace-node-fail1354 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2fail1354z62zztrace_walkz00(obj_t
		BgL_envz00_2547, obj_t BgL_nodez00_2548, obj_t BgL_stackz00_2549)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 354 */
			{
				BgL_failz00_bglt BgL_nodez00_1766;
				obj_t BgL_stackz00_1767;

				BgL_nodez00_1766 = ((BgL_failz00_bglt) BgL_nodez00_2548);
				BgL_stackz00_1767 = BgL_stackz00_2549;
				{
					BgL_nodez00_bglt BgL_auxz00_3277;

					{	/* Trace/walk.scm 356 */
						BgL_nodez00_bglt BgL_arg1803z00_1771;

						BgL_arg1803z00_1771 =
							(((BgL_failz00_bglt) CREF(BgL_nodez00_1766))->BgL_procz00);
						BgL_auxz00_3277 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1803z00_1771,
							BgL_stackz00_1767);
					}
					((((BgL_failz00_bglt) CREF(BgL_nodez00_1766))->BgL_procz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3277), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3281;

					{	/* Trace/walk.scm 357 */
						BgL_nodez00_bglt BgL_arg1804z00_1772;

						BgL_arg1804z00_1772 =
							(((BgL_failz00_bglt) CREF(BgL_nodez00_1766))->BgL_msgz00);
						BgL_auxz00_3281 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1804z00_1772,
							BgL_stackz00_1767);
					}
					((((BgL_failz00_bglt) CREF(BgL_nodez00_1766))->BgL_msgz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3281), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3285;

					{	/* Trace/walk.scm 358 */
						BgL_nodez00_bglt BgL_arg1805z00_1773;

						BgL_arg1805z00_1773 =
							(((BgL_failz00_bglt) CREF(BgL_nodez00_1766))->BgL_objz00);
						BgL_auxz00_3285 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1805z00_1773,
							BgL_stackz00_1767);
					}
					((((BgL_failz00_bglt) CREF(BgL_nodez00_1766))->BgL_objz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3285), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1766);
			}
		}
	}



/* &trace-node-condition1352 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2condition1352z62zztrace_walkz00(obj_t
		BgL_envz00_2550, obj_t BgL_nodez00_2551, obj_t BgL_stackz00_2552)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 344 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1757;
				obj_t BgL_stackz00_1758;

				BgL_nodez00_1757 = ((BgL_conditionalz00_bglt) BgL_nodez00_2551);
				BgL_stackz00_1758 = BgL_stackz00_2552;
				{
					BgL_nodez00_bglt BgL_auxz00_3291;

					{	/* Trace/walk.scm 346 */
						BgL_nodez00_bglt BgL_arg1800z00_1762;

						BgL_arg1800z00_1762 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1757))->BgL_testz00);
						BgL_auxz00_3291 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1800z00_1762,
							BgL_stackz00_1758);
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1757))->BgL_testz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3291), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3295;

					{	/* Trace/walk.scm 347 */
						BgL_nodez00_bglt BgL_arg1801z00_1763;

						BgL_arg1801z00_1763 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1757))->BgL_truez00);
						BgL_auxz00_3295 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1801z00_1763,
							BgL_stackz00_1758);
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1757))->BgL_truez00) =
						((BgL_nodez00_bglt) BgL_auxz00_3295), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3299;

					{	/* Trace/walk.scm 348 */
						BgL_nodez00_bglt BgL_arg1802z00_1764;

						BgL_arg1802z00_1764 =
							(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1757))->
							BgL_falsez00);
						BgL_auxz00_3299 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1802z00_1764,
							BgL_stackz00_1758);
					}
					((((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1757))->BgL_falsez00) =
						((BgL_nodez00_bglt) BgL_auxz00_3299), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1757);
			}
		}
	}



/* &trace-node-setq1350 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2setq1350z62zztrace_walkz00(obj_t
		BgL_envz00_2553, obj_t BgL_nodez00_2554, obj_t BgL_stackz00_2555)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 337 */
			{
				BgL_setqz00_bglt BgL_nodez00_1750;
				obj_t BgL_stackz00_1751;

				BgL_nodez00_1750 = ((BgL_setqz00_bglt) BgL_nodez00_2554);
				BgL_stackz00_1751 = BgL_stackz00_2555;
				((((BgL_setqz00_bglt) CREF(BgL_nodez00_1750))->BgL_valuez00) =
					((BgL_nodez00_bglt)
						BGl_tracezd2nodezd2zztrace_walkz00((((BgL_setqz00_bglt)
									CREF(BgL_nodez00_1750))->BgL_valuez00), BgL_stackz00_1751)),
					BUNSPEC);
				return ((BgL_nodez00_bglt) BgL_nodez00_1750);
			}
		}
	}



/* &trace-node-cast1348 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2cast1348z62zztrace_walkz00(obj_t
		BgL_envz00_2556, obj_t BgL_nodez00_2557, obj_t BgL_stackz00_2558)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 330 */
			{
				BgL_castz00_bglt BgL_nodez00_1744;
				obj_t BgL_stackz00_1745;

				BgL_nodez00_1744 = ((BgL_castz00_bglt) BgL_nodez00_2557);
				BgL_stackz00_1745 = BgL_stackz00_2558;
				BGl_tracezd2nodezd2zztrace_walkz00(
					(((BgL_castz00_bglt) CREF(BgL_nodez00_1744))->BgL_argz00),
					BgL_stackz00_1745);
				return ((BgL_nodez00_bglt) BgL_nodez00_1744);
			}
		}
	}



/* &trace-node-extern1345 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2extern1345z62zztrace_walkz00(obj_t
		BgL_envz00_2559, obj_t BgL_nodez00_2560, obj_t BgL_stackz00_2561)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 323 */
			{
				BgL_externz00_bglt BgL_nodez00_1738;
				obj_t BgL_stackz00_1739;

				BgL_nodez00_1738 = ((BgL_externz00_bglt) BgL_nodez00_2560);
				BgL_stackz00_1739 = BgL_stackz00_2561;
				BGl_tracezd2nodeza2z12z62zztrace_walkz00(
					(((BgL_externz00_bglt) CREF(BgL_nodez00_1738))->BgL_exprza2za2),
					BgL_stackz00_1739);
				return ((BgL_nodez00_bglt) BgL_nodez00_1738);
			}
		}
	}



/* &trace-node-funcall1343 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2funcall1343z62zztrace_walkz00(obj_t
		BgL_envz00_2562, obj_t BgL_nodez00_2563, obj_t BgL_stackz00_2564)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 314 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1730;
				obj_t BgL_stackz00_1731;

				BgL_nodez00_1730 = ((BgL_funcallz00_bglt) BgL_nodez00_2563);
				BgL_stackz00_1731 = BgL_stackz00_2564;
				{
					BgL_nodez00_bglt BgL_auxz00_3318;

					{	/* Trace/walk.scm 316 */
						BgL_nodez00_bglt BgL_arg1794z00_1735;

						BgL_arg1794z00_1735 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1730))->BgL_funz00);
						BgL_auxz00_3318 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1794z00_1735,
							BgL_stackz00_1731);
					}
					((((BgL_funcallz00_bglt) CREF(BgL_nodez00_1730))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3318), BUNSPEC);
				}
				BGl_tracezd2nodeza2z12z62zztrace_walkz00(
					(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1730))->BgL_argsz00),
					BgL_stackz00_1731);
				return ((BgL_nodez00_bglt) BgL_nodez00_1730);
			}
		}
	}



/* &trace-node-app-ly1341 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2appzd2ly1341zb0zztrace_walkz00(obj_t
		BgL_envz00_2565, obj_t BgL_nodez00_2566, obj_t BgL_stackz00_2567)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 305 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1722;
				obj_t BgL_stackz00_1723;

				BgL_nodez00_1722 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2566);
				BgL_stackz00_1723 = BgL_stackz00_2567;
				{
					BgL_nodez00_bglt BgL_auxz00_3326;

					{	/* Trace/walk.scm 307 */
						BgL_nodez00_bglt BgL_arg1792z00_1727;

						BgL_arg1792z00_1727 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1722))->BgL_funz00);
						BgL_auxz00_3326 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1792z00_1727,
							BgL_stackz00_1723);
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1722))->BgL_funz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3326), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3330;

					{	/* Trace/walk.scm 308 */
						BgL_nodez00_bglt BgL_arg1793z00_1728;

						BgL_arg1793z00_1728 =
							(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1722))->BgL_argz00);
						BgL_auxz00_3330 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1793z00_1728,
							BgL_stackz00_1723);
					}
					((((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1722))->BgL_argz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3330), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1722);
			}
		}
	}



/* &trace-node-app1339 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2app1339z62zztrace_walkz00(obj_t
		BgL_envz00_2568, obj_t BgL_nodez00_2569, obj_t BgL_stackz00_2570)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 298 */
			{
				BgL_appz00_bglt BgL_nodez00_1716;
				obj_t BgL_stackz00_1717;

				BgL_nodez00_1716 = ((BgL_appz00_bglt) BgL_nodez00_2569);
				BgL_stackz00_1717 = BgL_stackz00_2570;
				BGl_tracezd2nodeza2z12z62zztrace_walkz00(
					(((BgL_appz00_bglt) CREF(BgL_nodez00_1716))->BgL_argsz00),
					BgL_stackz00_1717);
				return ((BgL_nodez00_bglt) BgL_nodez00_1716);
			}
		}
	}



/* &trace-node-sync1337 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sync1337z62zztrace_walkz00(obj_t
		BgL_envz00_2571, obj_t BgL_nodez00_2572, obj_t BgL_stackz00_2573)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 288 */
			{
				BgL_syncz00_bglt BgL_nodez00_1707;
				obj_t BgL_stackz00_1708;

				BgL_nodez00_1707 = ((BgL_syncz00_bglt) BgL_nodez00_2572);
				BgL_stackz00_1708 = BgL_stackz00_2573;
				{
					BgL_nodez00_bglt BgL_auxz00_3340;

					{	/* Trace/walk.scm 290 */
						BgL_nodez00_bglt BgL_arg1786z00_1712;

						BgL_arg1786z00_1712 =
							(((BgL_syncz00_bglt) CREF(BgL_nodez00_1707))->BgL_mutexz00);
						BgL_auxz00_3340 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1786z00_1712,
							BgL_stackz00_1708);
					}
					((((BgL_syncz00_bglt) CREF(BgL_nodez00_1707))->BgL_mutexz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3340), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3344;

					{	/* Trace/walk.scm 291 */
						BgL_nodez00_bglt BgL_arg1789z00_1713;

						BgL_arg1789z00_1713 =
							(((BgL_syncz00_bglt) CREF(BgL_nodez00_1707))->BgL_prelockz00);
						BgL_auxz00_3344 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1789z00_1713,
							BgL_stackz00_1708);
					}
					((((BgL_syncz00_bglt) CREF(BgL_nodez00_1707))->BgL_prelockz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3344), BUNSPEC);
				}
				{
					BgL_nodez00_bglt BgL_auxz00_3348;

					{	/* Trace/walk.scm 292 */
						BgL_nodez00_bglt BgL_arg1790z00_1714;

						BgL_arg1790z00_1714 =
							(((BgL_syncz00_bglt) CREF(BgL_nodez00_1707))->BgL_bodyz00);
						BgL_auxz00_3348 =
							BGl_tracezd2nodezd2zztrace_walkz00(BgL_arg1790z00_1714,
							BgL_stackz00_1708);
					}
					((((BgL_syncz00_bglt) CREF(BgL_nodez00_1707))->BgL_bodyz00) =
						((BgL_nodez00_bglt) BgL_auxz00_3348), BUNSPEC);
				}
				return ((BgL_nodez00_bglt) BgL_nodez00_1707);
			}
		}
	}



/* &trace-node-sequence1335 */
	BgL_nodez00_bglt BGl_z62tracezd2nodezd2sequence1335z62zztrace_walkz00(obj_t
		BgL_envz00_2574, obj_t BgL_nodez00_2575, obj_t BgL_stackz00_2576)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 281 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1701;
				obj_t BgL_stackz00_1702;

				BgL_nodez00_1701 = ((BgL_sequencez00_bglt) BgL_nodez00_2575);
				BgL_stackz00_1702 = BgL_stackz00_2576;
				BGl_tracezd2nodeza2z12z62zztrace_walkz00(
					(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1701))->BgL_nodesz00),
					BgL_stackz00_1702);
				return ((BgL_nodez00_bglt) BgL_nodez00_1701);
			}
		}
	}



/* &find-last-node-jump-1331 */
	obj_t BGl_z62findzd2lastzd2nodezd2jumpzd21331z62zztrace_walkz00(obj_t
		BgL_envz00_2577, obj_t BgL_nodez00_2578)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 238 */
			{
				BgL_jumpzd2exzd2itz00_bglt BgL_nodez00_1696;

				BgL_nodez00_1696 = ((BgL_jumpzd2exzd2itz00_bglt) BgL_nodez00_2578);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_jumpzd2exzd2itz00_bglt) CREF(BgL_nodez00_1696))->
						BgL_valuez00));
			}
		}
	}



/* &find-last-node-set-e1329 */
	obj_t BGl_z62findzd2lastzd2nodezd2setzd2e1329z62zztrace_walkz00(obj_t
		BgL_envz00_2579, obj_t BgL_nodez00_2580)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 232 */
			{
				BgL_setzd2exzd2itz00_bglt BgL_nodez00_1691;

				BgL_nodez00_1691 = ((BgL_setzd2exzd2itz00_bglt) BgL_nodez00_2580);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_setzd2exzd2itz00_bglt) CREF(BgL_nodez00_1691))->BgL_bodyz00));
			}
		}
	}



/* &find-last-node-let-f1327 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2f1327z62zztrace_walkz00(obj_t
		BgL_envz00_2581, obj_t BgL_nodez00_2582)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 226 */
			{
				BgL_letzd2funzd2_bglt BgL_nodez00_1686;

				BgL_nodez00_1686 = ((BgL_letzd2funzd2_bglt) BgL_nodez00_2582);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_letzd2funzd2_bglt) CREF(BgL_nodez00_1686))->BgL_bodyz00));
			}
		}
	}



/* &find-last-node-let-v1325 */
	obj_t BGl_z62findzd2lastzd2nodezd2letzd2v1325z62zztrace_walkz00(obj_t
		BgL_envz00_2583, obj_t BgL_nodez00_2584)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 220 */
			{
				BgL_letzd2varzd2_bglt BgL_nodez00_1681;

				BgL_nodez00_1681 = ((BgL_letzd2varzd2_bglt) BgL_nodez00_2584);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_letzd2varzd2_bglt) CREF(BgL_nodez00_1681))->BgL_bodyz00));
			}
		}
	}



/* &find-last-node-selec1323 */
	obj_t BGl_z62findzd2lastzd2nodezd2selec1323zb0zztrace_walkz00(obj_t
		BgL_envz00_2585, obj_t BgL_nodez00_2586)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 211 */
			{
				BgL_selectz00_bglt BgL_nodez00_1670;

				BgL_nodez00_1670 = ((BgL_selectz00_bglt) BgL_nodez00_2586);
				{	/* Trace/walk.scm 213 */
					bool_t BgL_testz00_3370;

					{	/* Trace/walk.scm 213 */
						obj_t BgL_auxz00_3371;

						BgL_auxz00_3371 =
							(((BgL_selectz00_bglt) CREF(BgL_nodez00_1670))->BgL_clausesz00);
						BgL_testz00_3370 = PAIRP(BgL_auxz00_3371);
					}
					if (BgL_testz00_3370)
						{	/* Trace/walk.scm 214 */
							obj_t BgL_arg1773z00_1675;

							BgL_arg1773z00_1675 =
								CDR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1670))->
										BgL_clausesz00)));
							return
								BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
									BgL_arg1773z00_1675));
						}
					else
						{	/* Trace/walk.scm 213 */
							return
								BGl_findzd2lastzd2sexpz00zztrace_walkz00(
								((obj_t)
									(((BgL_selectz00_bglt) CREF(BgL_nodez00_1670))->
										BgL_testz00)));
						}
				}
			}
		}
	}



/* &find-last-node-fail1321 */
	obj_t BGl_z62findzd2lastzd2nodezd2fail1321zb0zztrace_walkz00(obj_t
		BgL_envz00_2587, obj_t BgL_nodez00_2588)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 205 */
			{
				BgL_failz00_bglt BgL_nodez00_1665;

				BgL_nodez00_1665 = ((BgL_failz00_bglt) BgL_nodez00_2588);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_failz00_bglt) CREF(BgL_nodez00_1665))->BgL_objz00));
			}
		}
	}



/* &find-last-node-condi1319 */
	obj_t BGl_z62findzd2lastzd2nodezd2condi1319zb0zztrace_walkz00(obj_t
		BgL_envz00_2589, obj_t BgL_nodez00_2590)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 199 */
			{
				BgL_conditionalz00_bglt BgL_nodez00_1660;

				BgL_nodez00_1660 = ((BgL_conditionalz00_bglt) BgL_nodez00_2590);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_conditionalz00_bglt) CREF(BgL_nodez00_1660))->BgL_falsez00));
			}
		}
	}



/* &find-last-node-setq1317 */
	obj_t BGl_z62findzd2lastzd2nodezd2setq1317zb0zztrace_walkz00(obj_t
		BgL_envz00_2591, obj_t BgL_nodez00_2592)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 193 */
			{
				BgL_setqz00_bglt BgL_nodez00_1655;

				BgL_nodez00_1655 = ((BgL_setqz00_bglt) BgL_nodez00_2592);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_setqz00_bglt) CREF(BgL_nodez00_1655))->BgL_valuez00));
			}
		}
	}



/* &find-last-node-exter1315 */
	obj_t BGl_z62findzd2lastzd2nodezd2exter1315zb0zztrace_walkz00(obj_t
		BgL_envz00_2593, obj_t BgL_nodez00_2594)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 184 */
			{
				BgL_externz00_bglt BgL_nodez00_1645;

				BgL_nodez00_1645 = ((BgL_externz00_bglt) BgL_nodez00_2594);
				if (NULLP(
						(((BgL_externz00_bglt) CREF(BgL_nodez00_1645))->BgL_exprza2za2)))
					{	/* Trace/walk.scm 186 */
						return ((obj_t) BgL_nodez00_1645);
					}
				else
					{	/* Trace/walk.scm 187 */
						obj_t BgL_arg1764z00_1650;

						BgL_arg1764z00_1650 =
							CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
								(((BgL_externz00_bglt) CREF(BgL_nodez00_1645))->
									BgL_exprza2za2)));
						return BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
								BgL_arg1764z00_1650));
					}
			}
		}
	}



/* &find-last-node-funca1313 */
	obj_t BGl_z62findzd2lastzd2nodezd2funca1313zb0zztrace_walkz00(obj_t
		BgL_envz00_2595, obj_t BgL_nodez00_2596)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 175 */
			{
				BgL_funcallz00_bglt BgL_nodez00_1634;

				BgL_nodez00_1634 = ((BgL_funcallz00_bglt) BgL_nodez00_2596);
				{	/* Trace/walk.scm 177 */
					bool_t BgL_testz00_3402;

					{	/* Trace/walk.scm 177 */
						obj_t BgL_auxz00_3403;

						BgL_auxz00_3403 =
							(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1634))->BgL_argsz00);
						BgL_testz00_3402 = PAIRP(BgL_auxz00_3403);
					}
					if (BgL_testz00_3402)
						{	/* Trace/walk.scm 178 */
							obj_t BgL_arg1758z00_1639;

							BgL_arg1758z00_1639 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1634))->
										BgL_argsz00)));
							return
								BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
									BgL_arg1758z00_1639));
						}
					else
						{	/* Trace/walk.scm 177 */
							return
								BGl_findzd2lastzd2nodez00zztrace_walkz00(
								(((BgL_funcallz00_bglt) CREF(BgL_nodez00_1634))->BgL_funz00));
						}
				}
			}
		}
	}



/* &find-last-node-app-l1311 */
	obj_t BGl_z62findzd2lastzd2nodezd2appzd2l1311z62zztrace_walkz00(obj_t
		BgL_envz00_2597, obj_t BgL_nodez00_2598)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 169 */
			{
				BgL_appzd2lyzd2_bglt BgL_nodez00_1629;

				BgL_nodez00_1629 = ((BgL_appzd2lyzd2_bglt) BgL_nodez00_2598);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_appzd2lyzd2_bglt) CREF(BgL_nodez00_1629))->BgL_argz00));
			}
		}
	}



/* &find-last-node-app1309 */
	obj_t BGl_z62findzd2lastzd2nodezd2app1309zb0zztrace_walkz00(obj_t
		BgL_envz00_2599, obj_t BgL_nodez00_2600)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 160 */
			{
				BgL_appz00_bglt BgL_nodez00_1619;

				BgL_nodez00_1619 = ((BgL_appz00_bglt) BgL_nodez00_2600);
				{	/* Trace/walk.scm 162 */
					bool_t BgL_testz00_3417;

					{	/* Trace/walk.scm 162 */
						obj_t BgL_auxz00_3418;

						BgL_auxz00_3418 =
							(((BgL_appz00_bglt) CREF(BgL_nodez00_1619))->BgL_argsz00);
						BgL_testz00_3417 = PAIRP(BgL_auxz00_3418);
					}
					if (BgL_testz00_3417)
						{	/* Trace/walk.scm 163 */
							obj_t BgL_arg1751z00_1624;

							BgL_arg1751z00_1624 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_appz00_bglt) CREF(BgL_nodez00_1619))->BgL_argsz00)));
							return
								BGl_findzd2lastzd2nodez00zztrace_walkz00(
								((BgL_nodez00_bglt) BgL_arg1751z00_1624));
						}
					else
						{	/* Trace/walk.scm 162 */
							return ((obj_t) BgL_nodez00_1619);
						}
				}
			}
		}
	}



/* &find-last-node-sync1307 */
	obj_t BGl_z62findzd2lastzd2nodezd2sync1307zb0zztrace_walkz00(obj_t
		BgL_envz00_2601, obj_t BgL_nodez00_2602)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 153 */
			{
				BgL_syncz00_bglt BgL_nodez00_1613;

				BgL_nodez00_1613 = ((BgL_syncz00_bglt) BgL_nodez00_2602);
				return
					BGl_findzd2lastzd2nodez00zztrace_walkz00(
					(((BgL_syncz00_bglt) CREF(BgL_nodez00_1613))->BgL_bodyz00));
			}
		}
	}



/* &find-last-node-seque1305 */
	obj_t BGl_z62findzd2lastzd2nodezd2seque1305zb0zztrace_walkz00(obj_t
		BgL_envz00_2603, obj_t BgL_nodez00_2604)
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 144 */
			{
				BgL_sequencez00_bglt BgL_nodez00_1603;

				BgL_nodez00_1603 = ((BgL_sequencez00_bglt) BgL_nodez00_2604);
				{	/* Trace/walk.scm 146 */
					bool_t BgL_testz00_3431;

					{	/* Trace/walk.scm 146 */
						obj_t BgL_auxz00_3432;

						BgL_auxz00_3432 =
							(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1603))->BgL_nodesz00);
						BgL_testz00_3431 = PAIRP(BgL_auxz00_3432);
					}
					if (BgL_testz00_3431)
						{	/* Trace/walk.scm 147 */
							obj_t BgL_arg1743z00_1608;

							BgL_arg1743z00_1608 =
								CAR(BGl_lastzd2pairzd2zz__r4_pairs_and_lists_6_3z00(
									(((BgL_sequencez00_bglt) CREF(BgL_nodez00_1603))->
										BgL_nodesz00)));
							return
								BGl_findzd2lastzd2nodez00zztrace_walkz00(((BgL_nodez00_bglt)
									BgL_arg1743z00_1608));
						}
					else
						{	/* Trace/walk.scm 146 */
							return ((obj_t) BgL_nodez00_1603);
						}
				}
			}
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zztrace_walkz00()
	{
		AN_OBJECT;
		{	/* Trace/walk.scm 15 */
			BGl_modulezd2initializa7ationz75zztools_speekz00(((long) 61247943),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_errorz00(((long) 300504031),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_passz00(((long) 373082237),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_typez00(((long) 515343395),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_varz00(((long) 90839984),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_nodez00(((long) 458567972),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_letz00(((long) 469204197),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_shapez00(((long) 365925558),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_miscz00(((long) 9470071),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztools_locationz00(((long) 462333240),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zztype_envz00(((long) 296457443),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzbackend_backendz00(((long) 216206620),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_sexpz00(((long) 36886173),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzast_identz00(((long) 174885617),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzmodule_modulez00(((long) 158397907),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			BGl_modulezd2initializa7ationz75zzengine_paramz00(((long) 122361728),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
			return
				BGl_modulezd2initializa7ationz75zzast_envz00(((long) 146730773),
				BSTRING_TO_STRING(BGl_string2046z00zztrace_walkz00));
		}
	}

#ifdef __cplusplus
}
#endif
