/*===========================================================================*/
/*   (Eval/evaluate.scm)                                                     */
/*   Bigloo (4.2c)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 21 13:29:02 CET 2015        */
/*===========================================================================*/
/* COMPILATION: (/home/serrano/prgm/project/bigloo/bin/bigloo -srfi enable-gmp -srfi bigloo-unsafe -O3 -fcfa-arithmetic -q -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c +rm -lib-dir /home/serrano/prgm/project/bigloo/lib/bigloo/4.2c -mklib -cc gcc -fsharing -q -no-hello -copt -fPIC -unsafe -safee -O4 -c Eval/evaluate.scm -indent -o objs/obj_u/Eval/evaluate.c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>

#ifdef __cplusplus
extern "C"
{
#endif

/* Object type definitions */
	typedef struct BgL_ev_exprz00_bgl
	{
		header_t header;
		obj_t widening;
	}                 *BgL_ev_exprz00_bglt;

	typedef struct BgL_ev_varz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_namez00;
		obj_t BgL_effz00;
		obj_t BgL_typez00;
	}                *BgL_ev_varz00_bglt;

	typedef struct BgL_ev_globalz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                   *BgL_ev_globalz00_bglt;

	typedef struct BgL_ev_littz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_valuez00;
	}                 *BgL_ev_littz00_bglt;

	typedef struct BgL_ev_ifz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_pz00;
		struct BgL_ev_exprz00_bgl *BgL_tz00;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}               *BgL_ev_ifz00_bglt;

	typedef struct BgL_ev_listz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                 *BgL_ev_listz00_bglt;

	typedef struct BgL_ev_orz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}               *BgL_ev_orz00_bglt;

	typedef struct BgL_ev_andz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_argsz00;
	}                *BgL_ev_andz00_bglt;

	typedef struct BgL_ev_prog2z00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_e1z00;
		struct BgL_ev_exprz00_bgl *BgL_e2z00;
	}                  *BgL_ev_prog2z00_bglt;

	typedef struct BgL_ev_hookz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_hookz00_bglt;

	typedef struct BgL_ev_trapz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
	}                 *BgL_ev_trapz00_bglt;

	typedef struct BgL_ev_setlocalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_varz00_bgl *BgL_vz00;
	}                     *BgL_ev_setlocalz00_bglt;

	typedef struct BgL_ev_setglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_setglobalz00_bglt;

	typedef struct BgL_ev_defglobalz00_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		obj_t BgL_locz00;
		obj_t BgL_namez00;
		obj_t BgL_modz00;
	}                      *BgL_ev_defglobalz00_bglt;

	typedef struct BgL_ev_bindzd2exitzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_varz00_bgl *BgL_varz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                        *BgL_ev_bindzd2exitzd2_bglt;

	typedef struct BgL_ev_unwindzd2protectzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_ez00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                             *BgL_ev_unwindzd2protectzd2_bglt;

	typedef struct BgL_ev_withzd2handlerzd2_bgl
	{
		header_t header;
		obj_t widening;
		struct BgL_ev_exprz00_bgl *BgL_handlerz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                           *BgL_ev_withzd2handlerzd2_bglt;

	typedef struct BgL_ev_synchroniza7eza7_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_mutexz00;
		struct BgL_ev_exprz00_bgl *BgL_prelockz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                          *BgL_ev_synchroniza7eza7_bglt;

	typedef struct BgL_ev_binderz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_binderz00_bglt;

	typedef struct BgL_ev_letz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_letz00_bglt;

	typedef struct BgL_ev_letza2za2_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		obj_t BgL_boxesz00;
	}                   *BgL_ev_letza2za2_bglt;

	typedef struct BgL_ev_letrecz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_varsz00;
		obj_t BgL_valsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
	}                   *BgL_ev_letrecz00_bglt;

	typedef struct BgL_ev_appz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		struct BgL_ev_exprz00_bgl *BgL_funz00;
		obj_t BgL_argsz00;
		obj_t BgL_tailzf3zf3;
	}                *BgL_ev_appz00_bglt;

	typedef struct BgL_ev_absz00_bgl
	{
		header_t header;
		obj_t widening;
		obj_t BgL_locz00;
		obj_t BgL_wherez00;
		obj_t BgL_arityz00;
		obj_t BgL_varsz00;
		struct BgL_ev_exprz00_bgl *BgL_bodyz00;
		int BgL_siza7eza7;
		obj_t BgL_bindz00;
		obj_t BgL_freez00;
		obj_t BgL_innerz00;
		obj_t BgL_boxesz00;
	}                *BgL_ev_absz00_bglt;


	extern obj_t BGl_compilez00zz__evaluate_compz00(BgL_ev_exprz00_bglt);
	extern bool_t BGl_classzd2fieldzf3z21zz__objectz00(obj_t);
	extern BgL_ev_exprz00_bglt
		BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	BGL_EXPORTED_DECL obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t);
	static obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t, obj_t);
	extern obj_t BGl_ev_letrecz00zz__evaluate_typesz00;
	extern obj_t BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00(obj_t);
	extern obj_t BGl_ev_letz00zz__evaluate_typesz00;
	extern obj_t BGl_classzd2existszd2zz__objectz00(obj_t);
	static obj_t BGl_symbol2949z00zz__evaluatez00 = BUNSPEC;
	extern int BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_ev_exprz00_bglt);
	static obj_t BGl_objectzd2initzd2zz__evaluatez00();
	extern bool_t BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(obj_t);
	static obj_t BGl_symbol2957z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2959z00zz__evaluatez00 = BUNSPEC;
	extern bool_t BGl_2ze3ze3zz__r4_numbers_6_5z00(obj_t, obj_t);
	static obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t);
	static obj_t BGl_symbol2961z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2962z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2964z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2966z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2968z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ppz00zz__ppz00(obj_t, obj_t);
	static obj_t BGl_symbol2970z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2972z00zz__evaluatez00 = BUNSPEC;
	extern obj_t bstring_to_symbol(obj_t);
	static obj_t BGl_symbol2974z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2975z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2977z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2979z00zz__evaluatez00 = BUNSPEC;
	extern bool_t BGl_isazf3zf3zz__objectz00(obj_t, obj_t);
	static obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, bool_t);
	extern obj_t make_vector(int, obj_t);
	static obj_t BGl_symbol2981z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2983z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2985z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t,
		obj_t);
	static obj_t BGl_symbol2987z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2989z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_z62zc3anonymousza31348ze3ze1zz__evaluatez00(obj_t);
	static obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_methodzd2initzd2zz__evaluatez00();
	static obj_t BGl_symbol2991z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2993z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2995z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_absz00zz__evaluate_typesz00;
	static obj_t BGl_symbol2997z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol2999z00zz__evaluatez00 = BUNSPEC;
	static BgL_ev_absz00_bglt BGl_convzd2lambdazd2zz__evaluatez00(obj_t, obj_t,
		obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_classzd2fieldzd2accessorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_ifz00zz__evaluate_typesz00;
	extern obj_t BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_ev_exprz00_bglt);
	extern obj_t BGl_evmodulez00zz__evmodulez00(obj_t, obj_t);
	extern obj_t BGl_classzd2fieldzd2typez00zz__objectz00(obj_t);
	static obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t,
		obj_t);
	extern bool_t BGl_classzf3zf3zz__objectz00(obj_t);
	extern int bgl_debug();
	extern obj_t BGl_ev_orz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_varz00zz__evaluate_typesz00;
	extern obj_t BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00(obj_t,
		obj_t, obj_t, obj_t);
	extern obj_t BGl_ev_andz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_appz00zz__evaluate_typesz00;
	extern obj_t
		BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00(obj_t,
		obj_t, bool_t);
	extern obj_t c_substring(obj_t, long, long);
	extern obj_t BGl_gensymz00zz__r4_symbols_6_4z00(obj_t);
	static obj_t BGl_uconvzf2loczf2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_evcompilezd2errorzd2zz__evcompilez00(obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_loopz72z72zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
	extern obj_t BGl_exitdzd2popzd2protectz12z12zz__bexitz00(obj_t);
	extern obj_t BGl_ev_synchroniza7eza7zz__evaluate_typesz00;
	extern obj_t BGl_uncompilez00zz__evaluate_uncompz00(BgL_ev_exprz00_bglt);
	static BgL_ev_appz00_bglt
		BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_defglobalz00zz__evaluate_typesz00;
	static obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t, bool_t);
	static obj_t BGl_requirezd2initializa7ationz75zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_typezd2errorzd2zz__errorz00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_formatz00zz__r4_output_6_10_3z00(obj_t, obj_t);
	extern obj_t BGl_exitdzd2pushzd2protectz12z12zz__bexitz00(obj_t, obj_t);
	extern obj_t bgl_reverse(obj_t);
	static obj_t BGl_genericzd2initzd2zz__evaluatez00();
	extern obj_t BGl_stringzd2copyzd2zz__r4_strings_6_7z00(obj_t);
	extern obj_t BGl_ev_prog2z00zz__evaluate_typesz00;
	extern obj_t BGl_ev_bindzd2exitzd2zz__evaluate_typesz00;
	static obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t, obj_t, obj_t,
		obj_t, obj_t, obj_t, bool_t);
	extern obj_t bgl_reverse_bang(obj_t);
	extern obj_t BGl_findzd2classzd2fieldz00zz__objectz00(obj_t, obj_t);
	extern obj_t BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00;
	extern obj_t BGl_classzd2fieldzd2mutatorz00zz__objectz00(obj_t);
	extern obj_t BGl_ev_letza2za2zz__evaluate_typesz00;
	static obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t, obj_t);
	static obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	extern obj_t BGl_ev_trapz00zz__evaluate_typesz00;
	extern obj_t BGl_ev_setglobalz00zz__evaluate_typesz00;
	extern obj_t string_append(obj_t, obj_t);
	extern obj_t BGl_substringz00zz__r4_strings_6_7z00(obj_t, long, long);
	extern obj_t BGl_findzd2statezd2zz__evaluate_compz00();
	static obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t);
	static obj_t BGl_symbol3001z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_compz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evmodulez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__everrorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evcompilez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__evenvz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__expandz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__prognz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__ppz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(long,
		char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(long, char *);
	extern obj_t
		BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long,
		char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__threadz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__paramz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__dssslz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__osz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bignumz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__structurez00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__tvectorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__biglooz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
	extern obj_t BGl_modulezd2initializa7ationz75zz__typez00(long, char *);
	static obj_t BGl_symbol3003z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3005z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3007z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_expandz00zz__expandz00(obj_t);
	static obj_t BGl_symbol3009z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_globalz00zz__evaluate_typesz00;
	static obj_t BGl_symbol3011z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3013z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3015z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3017z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3019z00zz__evaluatez00 = BUNSPEC;
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t);
	static obj_t BGl_keyword3060z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_littz00zz__evaluate_typesz00;
	static obj_t BGl_symbol3021z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3023z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3027z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3029z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t);
	static obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t, obj_t, obj_t, obj_t);
	static obj_t BGl_cnstzd2initzd2zz__evaluatez00();
	static obj_t BGl_symbol3032z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3034z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3036z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3038z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00();
	static obj_t BGl_symbol3040z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3042z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3044z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_ev_withzd2handlerzd2zz__evaluate_typesz00;
	static obj_t BGl_symbol3046z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3048z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3050z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3052z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3054z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3056z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_symbol3058z00zz__evaluatez00 = BUNSPEC;
	static obj_t BGl_convzd2valszd2zz__evaluatez00(obj_t, obj_t, obj_t, obj_t,
		obj_t, obj_t);
	extern bool_t BGl_evmodulezf3zf3zz__evmodulez00(obj_t);
	static obj_t BGl_symbol3062z00zz__evaluatez00 = BUNSPEC;
	extern obj_t BGl_getzd2sourcezd2locationz00zz__readerz00(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_evaluate2z00zz__evaluatez00(obj_t, obj_t, obj_t);
	extern obj_t BGl_evalzd2findzd2modulez00zz__evmodulez00(obj_t);
	static obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t, obj_t, obj_t);
	static obj_t BGl_loopz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t);
	BGL_EXPORTED_DECL obj_t
		BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int);
	extern obj_t bstring_to_keyword(obj_t);
	BGL_EXPORTED_DECL obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
	static BgL_ev_appz00_bglt
		BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t, BgL_ev_exprz00_bglt,
		obj_t, obj_t);
	extern obj_t BGl_ev_setlocalz00zz__evaluate_typesz00;
	static obj_t BGl_convz00zz__evaluatez00(obj_t, obj_t, obj_t, obj_t, obj_t,
		obj_t, bool_t);
	static obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t,
		obj_t);
	static obj_t *__cnst;


	   
		 
		DEFINE_STRING(BGl_string3010z00zz__evaluatez00,
		BgL_bgl_string3010za700za7za7_3065za7, "isa?", 4);
	      DEFINE_STRING(BGl_string3012z00zz__evaluatez00,
		BgL_bgl_string3012za700za7za7_3066za7, "if", 2);
	      DEFINE_STRING(BGl_string3014z00zz__evaluatez00,
		BgL_bgl_string3014za700za7za7_3067za7, "let", 3);
	      DEFINE_STRING(BGl_string3016z00zz__evaluatez00,
		BgL_bgl_string3016za700za7za7_3068za7, "lambda", 6);
	      DEFINE_STRING(BGl_string3018z00zz__evaluatez00,
		BgL_bgl_string3018za700za7za7_3069za7, "bigloo-type-error/location", 26);
	      DEFINE_STRING(BGl_string3020z00zz__evaluatez00,
		BgL_bgl_string3020za700za7za7_3070za7, "bigloo-type-error", 17);
	      DEFINE_STRING(BGl_string3022z00zz__evaluatez00,
		BgL_bgl_string3022za700za7za7_3071za7, "at", 2);
	      DEFINE_STRING(BGl_string3024z00zz__evaluatez00,
		BgL_bgl_string3024za700za7za7_3072za7, "tmp", 3);
	      DEFINE_STRING(BGl_string3025z00zz__evaluatez00,
		BgL_bgl_string3025za700za7za7_3073za7, "~a::~a", 6);
	      DEFINE_STRING(BGl_string3026z00zz__evaluatez00,
		BgL_bgl_string3026za700za7za7_3074za7, "Illegal form", 12);
	      DEFINE_STRING(BGl_string3028z00zz__evaluatez00,
		BgL_bgl_string3028za700za7za7_3075za7, "begin", 5);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2bpz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r3076z00,
		BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	      DEFINE_STRING(BGl_string3030z00zz__evaluatez00,
		BgL_bgl_string3030za700za7za7_3077za7, " ", 1);
	      DEFINE_STRING(BGl_string3031z00zz__evaluatez00,
		BgL_bgl_string3031za700za7za7_3078za7,
		"Illegal non toplevel module declaration", 39);
	      DEFINE_STRING(BGl_string3033z00zz__evaluatez00,
		BgL_bgl_string3033za700za7za7_3079za7, "module", 6);
	      DEFINE_STRING(BGl_string3035z00zz__evaluatez00,
		BgL_bgl_string3035za700za7za7_3080za7, "@", 1);
	      DEFINE_STRING(BGl_string3037z00zz__evaluatez00,
		BgL_bgl_string3037za700za7za7_3081za7, "->", 2);
	      DEFINE_STRING(BGl_string3039z00zz__evaluatez00,
		BgL_bgl_string3039za700za7za7_3082za7, "trap", 4);
	      DEFINE_STRING(BGl_string3041z00zz__evaluatez00,
		BgL_bgl_string3041za700za7za7_3083za7, "or", 2);
	      DEFINE_STRING(BGl_string3043z00zz__evaluatez00,
		BgL_bgl_string3043za700za7za7_3084za7, "and", 3);
	      DEFINE_STRING(BGl_string3045z00zz__evaluatez00,
		BgL_bgl_string3045za700za7za7_3085za7, "let*", 4);
	      DEFINE_STRING(BGl_string3047z00zz__evaluatez00,
		BgL_bgl_string3047za700za7za7_3086za7, "letrec", 6);
	      DEFINE_STRING(BGl_string3049z00zz__evaluatez00,
		BgL_bgl_string3049za700za7za7_3087za7, "set!", 4);
	      DEFINE_STRING(BGl_string3051z00zz__evaluatez00,
		BgL_bgl_string3051za700za7za7_3088za7, "define", 6);
	      DEFINE_STRING(BGl_string3053z00zz__evaluatez00,
		BgL_bgl_string3053za700za7za7_3089za7, "bind-exit", 9);
	      DEFINE_STRING(BGl_string3055z00zz__evaluatez00,
		BgL_bgl_string3055za700za7za7_3090za7, "unwind-protect", 14);
	      DEFINE_STRING(BGl_string3057z00zz__evaluatez00,
		BgL_bgl_string3057za700za7za7_3091za7, "with-handler", 12);
	      DEFINE_STRING(BGl_string3059z00zz__evaluatez00,
		BgL_bgl_string3059za700za7za7_3092za7, "synchronize", 11);
	      DEFINE_STRING(BGl_string3061z00zz__evaluatez00,
		BgL_bgl_string3061za700za7za7_3093za7, "prelock", 7);
	      DEFINE_STRING(BGl_string3063z00zz__evaluatez00,
		BgL_bgl_string3063za700za7za7_3094za7, "\\@", 2);
	      DEFINE_STRING(BGl_string3064z00zz__evaluatez00,
		BgL_bgl_string3064za700za7za7_3095za7, "__evaluate", 10);
	      DEFINE_STRING(BGl_string2943z00zz__evaluatez00,
		BgL_bgl_string2943za700za7za7_3096za7, "", 0);
	      DEFINE_STRING(BGl_string2944z00zz__evaluatez00,
		BgL_bgl_string2944za700za7za7_3097za7,
		"/tmp/bigloo/runtime/Eval/evaluate.scm", 37);
	      DEFINE_STRING(BGl_string2945z00zz__evaluatez00,
		BgL_bgl_string2945za700za7za7_3098za7, "&evaluate2-restore-bp!", 22);
	      DEFINE_STRING(BGl_string2946z00zz__evaluatez00,
		BgL_bgl_string2946za700za7za7_3099za7, "bint", 4);
	      DEFINE_STRING(BGl_string2947z00zz__evaluatez00,
		BgL_bgl_string2947za700za7za7_3100za7, "&evaluate2-restore-state!", 25);
	      DEFINE_STRING(BGl_string2948z00zz__evaluatez00,
		BgL_bgl_string2948za700za7za7_3101za7, "vector", 6);
	      DEFINE_STRING(BGl_string2950z00zz__evaluatez00,
		BgL_bgl_string2950za700za7za7_3102za7, "toplevel", 8);
	      DEFINE_STRING(BGl_string2951z00zz__evaluatez00,
		BgL_bgl_string2951za700za7za7_3103za7, "eval", 4);
	      DEFINE_STRING(BGl_string2952z00zz__evaluatez00,
		BgL_bgl_string2952za700za7za7_3104za7, "bad syntax", 10);
	      DEFINE_STRING(BGl_string2953z00zz__evaluatez00,
		BgL_bgl_string2953za700za7za7_3105za7, "Class \"~a\" has no field \"~a\"",
		28);
	      DEFINE_STRING(BGl_string2954z00zz__evaluatez00,
		BgL_bgl_string2954za700za7za7_3106za7, "Static type not a class", 23);
	      DEFINE_STRING(BGl_string2955z00zz__evaluatez00,
		BgL_bgl_string2955za700za7za7_3107za7, "Variable unbound", 16);
	      DEFINE_STRING(BGl_string2956z00zz__evaluatez00,
		BgL_bgl_string2956za700za7za7_3108za7, "Field read-only", 15);
	      DEFINE_STRING(BGl_string2958z00zz__evaluatez00,
		BgL_bgl_string2958za700za7za7_3109za7, "pair", 4);
	      DEFINE_STRING(BGl_string2960z00zz__evaluatez00,
		BgL_bgl_string2960za700za7za7_3110za7, "pair?", 5);
	      DEFINE_STRING(BGl_string2963z00zz__evaluatez00,
		BgL_bgl_string2963za700za7za7_3111za7, "vector?", 7);
	      DEFINE_STRING(BGl_string2965z00zz__evaluatez00,
		BgL_bgl_string2965za700za7za7_3112za7, "symbol", 6);
	      DEFINE_STRING(BGl_string2967z00zz__evaluatez00,
		BgL_bgl_string2967za700za7za7_3113za7, "symbol?", 7);
	      DEFINE_STRING(BGl_string2969z00zz__evaluatez00,
		BgL_bgl_string2969za700za7za7_3114za7, "char", 4);
	      DEFINE_STRING(BGl_string2971z00zz__evaluatez00,
		BgL_bgl_string2971za700za7za7_3115za7, "char?", 5);
	      DEFINE_STRING(BGl_string2973z00zz__evaluatez00,
		BgL_bgl_string2973za700za7za7_3116za7, "int", 3);
	      DEFINE_STRING(BGl_string2976z00zz__evaluatez00,
		BgL_bgl_string2976za700za7za7_3117za7, "integer?", 8);
	      DEFINE_STRING(BGl_string2978z00zz__evaluatez00,
		BgL_bgl_string2978za700za7za7_3118za7, "real", 4);
	extern obj_t BGl_errorzd2envzd2zz__errorz00;
	   
		 
		DEFINE_STRING(BGl_string2980z00zz__evaluatez00,
		BgL_bgl_string2980za700za7za7_3119za7, "breal", 5);
	      DEFINE_STRING(BGl_string2982z00zz__evaluatez00,
		BgL_bgl_string2982za700za7za7_3120za7, "real?", 5);
	      DEFINE_STRING(BGl_string2984z00zz__evaluatez00,
		BgL_bgl_string2984za700za7za7_3121za7, "bool", 4);
	      DEFINE_STRING(BGl_string2986z00zz__evaluatez00,
		BgL_bgl_string2986za700za7za7_3122za7, "boolean?", 8);
	      DEFINE_STRING(BGl_string2988z00zz__evaluatez00,
		BgL_bgl_string2988za700za7za7_3123za7, "struct", 6);
	      DEFINE_STRING(BGl_string2990z00zz__evaluatez00,
		BgL_bgl_string2990za700za7za7_3124za7, "struct?", 7);
	      DEFINE_STRING(BGl_string2992z00zz__evaluatez00,
		BgL_bgl_string2992za700za7za7_3125za7, "class", 5);
	      DEFINE_STRING(BGl_string2994z00zz__evaluatez00,
		BgL_bgl_string2994za700za7za7_3126za7, "class?", 6);
	      DEFINE_STRING(BGl_string2996z00zz__evaluatez00,
		BgL_bgl_string2996za700za7za7_3127za7, "string", 6);
	      DEFINE_STRING(BGl_string2998z00zz__evaluatez00,
		BgL_bgl_string2998za700za7za7_3128za7, "bstring", 7);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_setzd2evaluationzd2contextz12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762setza7d2evaluat3129z00,
		BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_evaluate2zd2restorezd2statez12zd2envzc0zz__evaluatez00,
		BgL_bgl_za762evaluate2za7d2r3130z00,
		BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00, 0L, BUNSPEC, 1);
	     
		DEFINE_EXPORT_BGL_PROCEDURE
		(BGl_getzd2evaluationzd2contextzd2envzd2zz__evaluatez00,
		BgL_bgl_za762getza7d2evaluat3131z00,
		BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00, 0L, BUNSPEC, 0);
	      DEFINE_EXPORT_BGL_PROCEDURE(BGl_evaluate2zd2envzd2zz__evaluatez00,
		BgL_bgl_za762evaluate2za762za73132za7, BGl_z62evaluate2z62zz__evaluatez00,
		0L, BUNSPEC, 3);
	      DEFINE_STRING(BGl_string3000z00zz__evaluatez00,
		BgL_bgl_string3000za700za7za7_3133za7, "string?", 7);
	      DEFINE_STRING(BGl_string3002z00zz__evaluatez00,
		BgL_bgl_string3002za700za7za7_3134za7, "o", 1);
	      DEFINE_STRING(BGl_string3004z00zz__evaluatez00,
		BgL_bgl_string3004za700za7za7_3135za7, "quote", 5);
	      DEFINE_STRING(BGl_string3006z00zz__evaluatez00,
		BgL_bgl_string3006za700za7za7_3136za7, "class-exists", 12);
	      DEFINE_STRING(BGl_string3008z00zz__evaluatez00,
		BgL_bgl_string3008za700za7za7_3137za7, "c", 1);



/* module-initialization */
	BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__evaluatez00(long
		BgL_checksumz00_5018, char *BgL_fromz00_5019)
	{
		AN_OBJECT;
		{
			if (CBOOL(BGl_requirezd2initializa7ationz75zz__evaluatez00))
				{
					BGl_requirezd2initializa7ationz75zz__evaluatez00 =
						BBOOL(((bool_t) 0));
					BGl_cnstzd2initzd2zz__evaluatez00();
					BGl_importedzd2moduleszd2initz00zz__evaluatez00();
					return BGl_methodzd2initzd2zz__evaluatez00();
				}
			else
				{
					return BUNSPEC;
				}
		}
	}



/* cnst-init */
	obj_t BGl_cnstzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			BGl_symbol2949z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2950z00zz__evaluatez00);
			BGl_symbol2957z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2958z00zz__evaluatez00);
			BGl_symbol2959z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2960z00zz__evaluatez00);
			BGl_symbol2961z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2948z00zz__evaluatez00);
			BGl_symbol2962z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2963z00zz__evaluatez00);
			BGl_symbol2964z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2965z00zz__evaluatez00);
			BGl_symbol2966z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2967z00zz__evaluatez00);
			BGl_symbol2968z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2969z00zz__evaluatez00);
			BGl_symbol2970z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2971z00zz__evaluatez00);
			BGl_symbol2972z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2973z00zz__evaluatez00);
			BGl_symbol2974z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2946z00zz__evaluatez00);
			BGl_symbol2975z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2976z00zz__evaluatez00);
			BGl_symbol2977z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2978z00zz__evaluatez00);
			BGl_symbol2979z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2980z00zz__evaluatez00);
			BGl_symbol2981z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2982z00zz__evaluatez00);
			BGl_symbol2983z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2984z00zz__evaluatez00);
			BGl_symbol2985z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2986z00zz__evaluatez00);
			BGl_symbol2987z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2988z00zz__evaluatez00);
			BGl_symbol2989z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2990z00zz__evaluatez00);
			BGl_symbol2991z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2992z00zz__evaluatez00);
			BGl_symbol2993z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2994z00zz__evaluatez00);
			BGl_symbol2995z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2996z00zz__evaluatez00);
			BGl_symbol2997z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string2998z00zz__evaluatez00);
			BGl_symbol2999z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3000z00zz__evaluatez00);
			BGl_symbol3001z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3002z00zz__evaluatez00);
			BGl_symbol3003z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3004z00zz__evaluatez00);
			BGl_symbol3005z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3006z00zz__evaluatez00);
			BGl_symbol3007z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3008z00zz__evaluatez00);
			BGl_symbol3009z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3010z00zz__evaluatez00);
			BGl_symbol3011z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3012z00zz__evaluatez00);
			BGl_symbol3013z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3014z00zz__evaluatez00);
			BGl_symbol3015z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3016z00zz__evaluatez00);
			BGl_symbol3017z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3018z00zz__evaluatez00);
			BGl_symbol3019z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3020z00zz__evaluatez00);
			BGl_symbol3021z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3022z00zz__evaluatez00);
			BGl_symbol3023z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3024z00zz__evaluatez00);
			BGl_symbol3027z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3028z00zz__evaluatez00);
			BGl_symbol3029z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3030z00zz__evaluatez00);
			BGl_symbol3032z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3033z00zz__evaluatez00);
			BGl_symbol3034z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3035z00zz__evaluatez00);
			BGl_symbol3036z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3037z00zz__evaluatez00);
			BGl_symbol3038z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3039z00zz__evaluatez00);
			BGl_symbol3040z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3041z00zz__evaluatez00);
			BGl_symbol3042z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3043z00zz__evaluatez00);
			BGl_symbol3044z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3045z00zz__evaluatez00);
			BGl_symbol3046z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3047z00zz__evaluatez00);
			BGl_symbol3048z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3049z00zz__evaluatez00);
			BGl_symbol3050z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3051z00zz__evaluatez00);
			BGl_symbol3052z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3053z00zz__evaluatez00);
			BGl_symbol3054z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3055z00zz__evaluatez00);
			BGl_symbol3056z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3057z00zz__evaluatez00);
			BGl_symbol3058z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3059z00zz__evaluatez00);
			BGl_keyword3060z00zz__evaluatez00 =
				bstring_to_keyword(BGl_string3061z00zz__evaluatez00);
			return (BGl_symbol3062z00zz__evaluatez00 =
				bstring_to_symbol(BGl_string3063z00zz__evaluatez00), BUNSPEC);
		}
	}



/* append-21011 */
	obj_t BGl_appendzd221011zd2zz__evaluatez00(obj_t BgL_l1z00_1,
		obj_t BgL_l2z00_2)
	{
		AN_OBJECT;
		{
			{
				obj_t BgL_headz00_1084;

				BgL_headz00_1084 = MAKE_PAIR(BNIL, BgL_l2z00_2);
				{
					obj_t BgL_prevz00_2868;
					obj_t BgL_tailz00_2869;

					BgL_prevz00_2868 = BgL_headz00_1084;
					BgL_tailz00_2869 = BgL_l1z00_1;
				BgL_loopz00_2867:
					if (PAIRP(BgL_tailz00_2869))
						{
							obj_t BgL_newzd2prevzd2_2875;

							BgL_newzd2prevzd2_2875 =
								MAKE_PAIR(CAR(BgL_tailz00_2869), BgL_l2z00_2);
							SET_CDR(BgL_prevz00_2868, BgL_newzd2prevzd2_2875);
							{
								obj_t BgL_tailz00_5087;
								obj_t BgL_prevz00_5086;

								BgL_prevz00_5086 = BgL_newzd2prevzd2_2875;
								BgL_tailz00_5087 = CDR(BgL_tailz00_2869);
								BgL_tailz00_2869 = BgL_tailz00_5087;
								BgL_prevz00_2868 = BgL_prevz00_5086;
								goto BgL_loopz00_2867;
							}
						}
					else
						{
							BNIL;
						}
				}
				return CDR(BgL_headz00_1084);
			}
		}
	}



/* untype-ident */
	obj_t BGl_untypezd2identzd2zz__evaluatez00(obj_t BgL_idz00_3)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 73 */
			{	/* Eval/evaluate.scm 74 */
				obj_t BgL_stringz00_1092;

				{	/* Eval/evaluate.scm 74 */
					obj_t BgL_res2597z00_2887;

					{	/* Eval/evaluate.scm 74 */
						obj_t BgL_arg2423z00_2886;

						BgL_arg2423z00_2886 = SYMBOL_TO_STRING(BgL_idz00_3);
						BgL_res2597z00_2887 =
							BGl_stringzd2copyzd2zz__r4_strings_6_7z00(BgL_arg2423z00_2886);
					}
					BgL_stringz00_1092 = BgL_res2597z00_2887;
				}
				{	/* Eval/evaluate.scm 74 */
					long BgL_lenz00_1093;

					BgL_lenz00_1093 = STRING_LENGTH(BgL_stringz00_1092);
					{	/* Eval/evaluate.scm 75 */

						{
							long BgL_walkerz00_1095;

							BgL_walkerz00_1095 = ((long) 0);
						BgL_zc3anonymousza31317ze3z83_1096:
							if ((BgL_walkerz00_1095 == BgL_lenz00_1093))
								{	/* Eval/evaluate.scm 78 */
									return MAKE_PAIR(BgL_idz00_3, BFALSE);
								}
							else
								{	/* Eval/evaluate.scm 80 */
									bool_t BgL_testz00_5096;

									if (
										(STRING_REF(BgL_stringz00_1092,
												BgL_walkerz00_1095) == ((unsigned char) ':')))
										{	/* Eval/evaluate.scm 80 */
											if ((BgL_walkerz00_1095 < (BgL_lenz00_1093 - ((long) 1))))
												{	/* Eval/evaluate.scm 81 */
													BgL_testz00_5096 =
														(STRING_REF(BgL_stringz00_1092,
															(BgL_walkerz00_1095 + ((long) 1))) ==
														((unsigned char) ':'));
												}
											else
												{	/* Eval/evaluate.scm 81 */
													BgL_testz00_5096 = ((bool_t) 0);
												}
										}
									else
										{	/* Eval/evaluate.scm 80 */
											BgL_testz00_5096 = ((bool_t) 0);
										}
									if (BgL_testz00_5096)
										{	/* Eval/evaluate.scm 83 */
											obj_t BgL_arg1320z00_1099;
											obj_t BgL_arg1321z00_1100;

											BgL_arg1320z00_1099 =
												bstring_to_symbol(c_substring(BgL_stringz00_1092,
													((long) 0), BgL_walkerz00_1095));
											{	/* Eval/evaluate.scm 84 */
												obj_t BgL_arg1323z00_1102;

												{	/* Eval/evaluate.scm 84 */
													long BgL_arg1324z00_1103;

													BgL_arg1324z00_1103 =
														(BgL_walkerz00_1095 + ((long) 2));
													{	/* Ieee/string.scm 192 */
														long BgL_endz00_1106;

														BgL_endz00_1106 = STRING_LENGTH(BgL_stringz00_1092);
														{	/* Ieee/string.scm 192 */

															BgL_arg1323z00_1102 =
																BGl_substringz00zz__r4_strings_6_7z00
																(BgL_stringz00_1092, BgL_arg1324z00_1103,
																BgL_endz00_1106);
												}}}
												BgL_arg1321z00_1100 =
													bstring_to_symbol(BgL_arg1323z00_1102);
											}
											return
												MAKE_PAIR(BgL_arg1320z00_1099, BgL_arg1321z00_1100);
										}
									else
										{
											long BgL_walkerz00_5113;

											BgL_walkerz00_5113 = (BgL_walkerz00_1095 + ((long) 1));
											BgL_walkerz00_1095 = BgL_walkerz00_5113;
											goto BgL_zc3anonymousza31317ze3z83_1096;
										}
								}
						}
					}
				}
			}
		}
	}



/* get-evaluation-context */
	BGL_EXPORTED_DEF obj_t BGl_getzd2evaluationzd2contextz00zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 91 */
			{	/* Eval/evaluate.scm 92 */
				obj_t BgL_sz00_1115;

				BgL_sz00_1115 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 93 */
					obj_t BgL_bpz00_1116;

					BgL_bpz00_1116 = VECTOR_REF(BgL_sz00_1115, (int) (((long) 0)));
					{	/* Eval/evaluate.scm 94 */
						obj_t BgL_rz00_1117;

						BgL_rz00_1117 =
							make_vector(CINT(BgL_bpz00_1116),
							BGl_string2943z00zz__evaluatez00);
						{
							long BgL_iz00_2944;

							BgL_iz00_2944 = ((long) 0);
						BgL_recz00_2943:
							if ((BgL_iz00_2944 < (long) CINT(BgL_bpz00_1116)))
								{	/* Eval/evaluate.scm 96 */
									VECTOR_SET(BgL_rz00_1117,
										(int) (BgL_iz00_2944),
										VECTOR_REF(BgL_sz00_1115, (int) (BgL_iz00_2944)));
									{
										long BgL_iz00_5127;

										BgL_iz00_5127 = (BgL_iz00_2944 + ((long) 1));
										BgL_iz00_2944 = BgL_iz00_5127;
										goto BgL_recz00_2943;
									}
								}
							else
								{	/* Eval/evaluate.scm 96 */
									((bool_t) 0);
								}
						}
						return BgL_rz00_1117;
					}
				}
			}
		}
	}



/* &get-evaluation-context */
	obj_t BGl_z62getzd2evaluationzd2contextz62zz__evaluatez00(obj_t
		BgL_envz00_4955)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 91 */
			return BGl_getzd2evaluationzd2contextz00zz__evaluatez00();
		}
	}



/* set-evaluation-context! */
	BGL_EXPORTED_DEF obj_t
		BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(obj_t BgL_vz00_4)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 104 */
			{	/* Eval/evaluate.scm 105 */
				obj_t BgL_sz00_1125;

				BgL_sz00_1125 = BGl_findzd2statezd2zz__evaluate_compz00();
				{	/* Eval/evaluate.scm 106 */
					obj_t BgL_bpz00_1126;

					BgL_bpz00_1126 = VECTOR_REF(BgL_vz00_4, (int) (((long) 0)));
					{
						long BgL_iz00_2973;

						{	/* Eval/evaluate.scm 107 */
							bool_t BgL_auxz00_5133;

							BgL_iz00_2973 = ((long) 0);
						BgL_recz00_2972:
							if ((BgL_iz00_2973 < (long) CINT(BgL_bpz00_1126)))
								{	/* Eval/evaluate.scm 108 */
									VECTOR_SET(BgL_sz00_1125,
										(int) (BgL_iz00_2973),
										VECTOR_REF(BgL_vz00_4, (int) (BgL_iz00_2973)));
									{
										long BgL_iz00_5141;

										BgL_iz00_5141 = (BgL_iz00_2973 + ((long) 1));
										BgL_iz00_2973 = BgL_iz00_5141;
										goto BgL_recz00_2972;
									}
								}
							else
								{	/* Eval/evaluate.scm 108 */
									BgL_auxz00_5133 = ((bool_t) 0);
								}
							return BBOOL(BgL_auxz00_5133);
						}
					}
				}
			}
		}
	}



/* &set-evaluation-context! */
	obj_t BGl_z62setzd2evaluationzd2contextz12z70zz__evaluatez00(obj_t
		BgL_envz00_4956, obj_t BgL_vz00_4957)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 104 */
			return BGl_setzd2evaluationzd2contextz12z12zz__evaluatez00(BgL_vz00_4957);
		}
	}



/* evaluate2-restore-bp! */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(int
		BgL_bpz00_5)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				obj_t BgL_sz00_2988;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_auxz00_5145;

					BgL_auxz00_5145 = BGL_CURRENT_DYNAMIC_ENV();
					BgL_sz00_2988 = BGL_ENV_EVSTATE(BgL_auxz00_5145);
				}
				return VECTOR_SET(BgL_sz00_2988, (int) (((long) 0)), BINT(BgL_bpz00_5));
		}}
	}



/* &evaluate2-restore-bp! */
	obj_t BGl_z62evaluate2zd2restorezd2bpz12z70zz__evaluatez00(obj_t
		BgL_envz00_4958, obj_t BgL_bpz00_4959)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 115 */
			{	/* Eval/evaluate.scm 116 */
				int BgL_auxz00_5151;

				{	/* Eval/evaluate.scm 116 */
					obj_t BgL_auxz00_5152;

					if (INTEGERP(BgL_bpz00_4959))
						{	/* Eval/evaluate.scm 116 */
							BgL_auxz00_5152 = BgL_bpz00_4959;
						}
					else
						{
							obj_t BgL_auxz00_5155;

							BgL_auxz00_5155 =
								BGl_typezd2errorzd2zz__errorz00
								(BGl_string2944z00zz__evaluatez00, BINT(((long) 3890)),
								BGl_string2945z00zz__evaluatez00,
								BGl_string2946z00zz__evaluatez00, BgL_bpz00_4959);
							FAILURE(BgL_auxz00_5155, BFALSE, BFALSE);
						}
					BgL_auxz00_5151 = CINT(BgL_auxz00_5152);
				}
				return
					BGl_evaluate2zd2restorezd2bpz12z12zz__evaluatez00(BgL_auxz00_5151);
			}
		}
	}



/* evaluate2-restore-state! */
	BGL_EXPORTED_DEF obj_t
		BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(obj_t BgL_statez00_6)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 124 */
				obj_t BgL_auxz00_5161;

				BgL_auxz00_5161 = BGL_CURRENT_DYNAMIC_ENV();
				return BGL_ENV_EVSTATE_SET(BgL_auxz00_5161, BgL_statez00_6);
			}
		}
	}



/* &evaluate2-restore-state! */
	obj_t BGl_z62evaluate2zd2restorezd2statez12z70zz__evaluatez00(obj_t
		BgL_envz00_4960, obj_t BgL_statez00_4961)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 122 */
			{	/* Eval/evaluate.scm 123 */
				obj_t BgL_auxz00_5164;

				if (VECTORP(BgL_statez00_4961))
					{	/* Eval/evaluate.scm 123 */
						BgL_auxz00_5164 = BgL_statez00_4961;
					}
				else
					{
						obj_t BgL_auxz00_5167;

						BgL_auxz00_5167 =
							BGl_typezd2errorzd2zz__errorz00(BGl_string2944z00zz__evaluatez00,
							BINT(((long) 4240)), BGl_string2947z00zz__evaluatez00,
							BGl_string2948z00zz__evaluatez00, BgL_statez00_4961);
						FAILURE(BgL_auxz00_5167, BFALSE, BFALSE);
					}
				return
					BGl_evaluate2zd2restorezd2statez12z12zz__evaluatez00(BgL_auxz00_5164);
			}
		}
	}



/* evaluate2 */
	BGL_EXPORTED_DEF obj_t BGl_evaluate2z00zz__evaluatez00(obj_t BgL_sexpz00_7,
		obj_t BgL_envz00_8, obj_t BgL_locz00_9)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 129 */
			{	/* Eval/evaluate.scm 130 */
				BgL_ev_exprz00_bglt BgL_astz00_1137;

				{	/* Eval/evaluate.scm 130 */
					obj_t BgL_arg1349z00_1151;

					BgL_arg1349z00_1151 =
						BGl_convz00zz__evaluatez00(BgL_sexpz00_7, BNIL, BgL_envz00_8,
						BFALSE, BGl_symbol2949z00zz__evaluatez00, BgL_locz00_9,
						((bool_t) 1));
					BgL_astz00_1137 =
						BGl_extractzd2loopszd2zz__evaluate_fsiza7eza7(((BgL_ev_exprz00_bglt)
							BgL_arg1349z00_1151));
				}
				{	/* Eval/evaluate.scm 131 */
					bool_t BgL_testz00_5175;

					{	/* Eval/evaluate.scm 131 */
						int BgL_arg1347z00_1141;

						BgL_arg1347z00_1141 = bgl_debug();
						BgL_testz00_5175 =
							BGl_2ze3ze3zz__r4_numbers_6_5z00(BINT(BgL_arg1347z00_1141),
							BINT(((long) 10)));
					}
					if (BgL_testz00_5175)
						{	/* Eval/evaluate.scm 131 */
							BGl_ppz00zz__ppz00(BGl_uncompilez00zz__evaluate_uncompz00
								(BgL_astz00_1137), BNIL);
						}
					else
						{	/* Eval/evaluate.scm 131 */
							BFALSE;
						}
				}
				BGl_analysezd2varszd2zz__evaluate_avarz00(BgL_astz00_1137);
				{	/* Eval/evaluate.scm 133 */
					int BgL_nz00_1142;

					BgL_nz00_1142 =
						BGl_framezd2siza7ez75zz__evaluate_fsiza7eza7(BgL_astz00_1137);
					{	/* Eval/evaluate.scm 134 */
						obj_t BgL_fz00_1143;

						BgL_fz00_1143 = BGl_compilez00zz__evaluate_compz00(BgL_astz00_1137);
						{	/* Eval/evaluate.scm 135 */
							obj_t BgL_sz00_1144;

							BgL_sz00_1144 = BGl_findzd2statezd2zz__evaluate_compz00();
							{	/* Eval/evaluate.scm 136 */
								obj_t BgL_bpz00_1145;

								BgL_bpz00_1145 = VECTOR_REF(BgL_sz00_1144, (int) (((long) 0)));
								{	/* Eval/evaluate.scm 137 */
									obj_t BgL_exitd1064z00_1146;

									BgL_exitd1064z00_1146 = BGL_EXITD_TOP_AS_OBJ();
									{	/* Eval/evaluate.scm 139 */
										obj_t BgL_zc3anonymousza31348ze3z83_4962;

										BgL_zc3anonymousza31348ze3z83_4962 =
											MAKE_FX_PROCEDURE
											(BGl_z62zc3anonymousza31348ze3ze1zz__evaluatez00,
											(int) (((long) 0)), (int) (((long) 2)));
										PROCEDURE_SET(BgL_zc3anonymousza31348ze3z83_4962,
											(int) (((long) 0)), BgL_sz00_1144);
										PROCEDURE_SET(BgL_zc3anonymousza31348ze3z83_4962,
											(int) (((long) 1)), BgL_bpz00_1145);
										BGl_exitdzd2pushzd2protectz12z12zz__bexitz00
											(BgL_exitd1064z00_1146,
											BgL_zc3anonymousza31348ze3z83_4962);
										{	/* Eval/evaluate.scm 138 */
											obj_t BgL_tmp1066z00_1148;

											BgL_tmp1066z00_1148 =
												PROCEDURE_ENTRY(BgL_fz00_1143) (BgL_fz00_1143,
												BgL_sz00_1144, BEOA);
											BGl_exitdzd2popzd2protectz12z12zz__bexitz00
												(BgL_exitd1064z00_1146);
											VECTOR_SET(BgL_sz00_1144, (int) (((long) 0)),
												BgL_bpz00_1145);
											return BgL_tmp1066z00_1148;
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}



/* &evaluate2 */
	obj_t BGl_z62evaluate2z62zz__evaluatez00(obj_t BgL_envz00_4963,
		obj_t BgL_sexpz00_4964, obj_t BgL_envz00_4965, obj_t BgL_locz00_4966)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 129 */
			return
				BGl_evaluate2z00zz__evaluatez00(BgL_sexpz00_4964, BgL_envz00_4965,
				BgL_locz00_4966);
		}
	}



/* &<anonymous:1348> */
	obj_t BGl_z62zc3anonymousza31348ze3ze1zz__evaluatez00(obj_t BgL_envz00_4967)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 137 */
			{	/* Eval/evaluate.scm 139 */
				obj_t BgL_sz00_4968;
				obj_t BgL_bpz00_4969;

				BgL_sz00_4968 = PROCEDURE_REF(BgL_envz00_4967, (int) (((long) 0)));
				BgL_bpz00_4969 = PROCEDURE_REF(BgL_envz00_4967, (int) (((long) 1)));
				{

					return VECTOR_SET(BgL_sz00_4968, (int) (((long) 0)), BgL_bpz00_4969);
		}}}
	}



/* get-location */
	obj_t BGl_getzd2locationzd2zz__evaluatez00(obj_t BgL_expz00_10,
		obj_t BgL_locz00_11)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 144 */
			{	/* Eval/evaluate.scm 145 */
				obj_t BgL__ortest_1067z00_3007;

				BgL__ortest_1067z00_3007 =
					BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_expz00_10);
				if (CBOOL(BgL__ortest_1067z00_3007))
					{	/* Eval/evaluate.scm 145 */
						return BgL__ortest_1067z00_3007;
					}
				else
					{	/* Eval/evaluate.scm 145 */
						return BgL_locz00_11;
					}
			}
		}
	}



/* conv-var */
	obj_t BGl_convzd2varzd2zz__evaluatez00(obj_t BgL_vz00_18,
		obj_t BgL_localsz00_19)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 164 */
			{
				obj_t BgL_lz00_1156;

				BgL_lz00_1156 = BgL_localsz00_19;
			BgL_zc3anonymousza31350ze3z83_1157:
				if (NULLP(BgL_lz00_1156))
					{	/* Eval/evaluate.scm 166 */
						return BFALSE;
					}
				else
					{	/* Eval/evaluate.scm 168 */
						obj_t BgL_rvz00_1159;

						BgL_rvz00_1159 = CAR(BgL_lz00_1156);
						if (
							(BgL_vz00_18 ==
								(((BgL_ev_varz00_bglt) CREF(
											((BgL_ev_varz00_bglt) BgL_rvz00_1159)))->BgL_namez00)))
							{	/* Eval/evaluate.scm 170 */
								return BgL_rvz00_1159;
							}
						else
							{
								obj_t BgL_lz00_5221;

								BgL_lz00_5221 = CDR(BgL_lz00_1156);
								BgL_lz00_1156 = BgL_lz00_5221;
								goto BgL_zc3anonymousza31350ze3z83_1157;
							}
					}
			}
		}
	}



/* conv-begin */
	obj_t BGl_convzd2beginzd2zz__evaluatez00(obj_t BgL_lz00_20,
		obj_t BgL_localsz00_21, obj_t BgL_globalsz00_22, obj_t BgL_tailzf3zf3_23,
		obj_t BgL_wherez00_24, obj_t BgL_locz00_25, bool_t BgL_topzf3zf3_26)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 177 */
			{	/* Eval/evaluate.scm 178 */
				obj_t BgL_locz00_1165;

				{	/* Eval/evaluate.scm 145 */
					obj_t BgL__ortest_1067z00_3016;

					BgL__ortest_1067z00_3016 =
						BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_lz00_20);
					if (CBOOL(BgL__ortest_1067z00_3016))
						{	/* Eval/evaluate.scm 145 */
							BgL_locz00_1165 = BgL__ortest_1067z00_3016;
						}
					else
						{	/* Eval/evaluate.scm 145 */
							BgL_locz00_1165 = BgL_locz00_25;
						}
				}
				{
					obj_t BgL_e1z00_1169;
					obj_t BgL_rz00_1170;

					if (NULLP(BgL_lz00_20))
						{
							BgL_ev_littz00_bglt BgL_auxz00_5228;

							{	/* Eval/evaluate.scm 181 */
								BgL_ev_littz00_bglt BgL_new1072z00_1181;

								{	/* Eval/evaluate.scm 182 */
									BgL_ev_littz00_bglt BgL_new1071z00_1182;

									BgL_new1071z00_1182 =
										((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 182 */
										long BgL_arg1366z00_1183;

										{	/* Eval/evaluate.scm 182 */
											long BgL_res2620z00_3018;

											BgL_res2620z00_3018 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg1366z00_1183 = BgL_res2620z00_3018;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1071z00_1182),
											BgL_arg1366z00_1183);
									}
									{	/* Eval/evaluate.scm 182 */
										BgL_objectz00_bglt BgL_auxz00_5233;

										BgL_auxz00_5233 =
											((BgL_objectz00_bglt) BgL_new1071z00_1182);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_5233, BFALSE);
									}
									BgL_new1072z00_1181 = BgL_new1071z00_1182;
								}
								((((BgL_ev_littz00_bglt) CREF(BgL_new1072z00_1181))->
										BgL_valuez00) = ((obj_t) BUNSPEC), BUNSPEC);
								BgL_auxz00_5228 = BgL_new1072z00_1181;
							}
							return ((obj_t) BgL_auxz00_5228);
						}
					else
						{	/* Eval/evaluate.scm 179 */
							if (PAIRP(BgL_lz00_20))
								{	/* Eval/evaluate.scm 179 */
									if (NULLP(CDR(BgL_lz00_20)))
										{	/* Eval/evaluate.scm 179 */
											obj_t BgL_arg1360z00_1177;

											BgL_arg1360z00_1177 = CAR(BgL_lz00_20);
											{	/* Eval/evaluate.scm 184 */
												obj_t BgL_arg1368z00_3041;

												{	/* Eval/evaluate.scm 145 */
													obj_t BgL__ortest_1067z00_3044;

													BgL__ortest_1067z00_3044 =
														BGl_getzd2sourcezd2locationz00zz__readerz00
														(BgL_arg1360z00_1177);
													if (CBOOL(BgL__ortest_1067z00_3044))
														{	/* Eval/evaluate.scm 145 */
															BgL_arg1368z00_3041 = BgL__ortest_1067z00_3044;
														}
													else
														{	/* Eval/evaluate.scm 145 */
															BgL_arg1368z00_3041 = BgL_locz00_1165;
														}
												}
												return
													BGl_convz00zz__evaluatez00(BgL_arg1360z00_1177,
													BgL_localsz00_21, BgL_globalsz00_22,
													BgL_tailzf3zf3_23, BgL_wherez00_24,
													BgL_arg1368z00_3041, BgL_topzf3zf3_26);
											}
										}
									else
										{	/* Eval/evaluate.scm 179 */
											obj_t BgL_arg1361z00_1178;
											obj_t BgL_arg1363z00_1179;

											BgL_arg1361z00_1178 = CAR(BgL_lz00_20);
											BgL_arg1363z00_1179 = CDR(BgL_lz00_20);
											{
												BgL_ev_prog2z00_bglt BgL_auxz00_5250;

												BgL_e1z00_1169 = BgL_arg1361z00_1178;
												BgL_rz00_1170 = BgL_arg1363z00_1179;
												{	/* Eval/evaluate.scm 186 */
													BgL_ev_prog2z00_bglt BgL_new1074z00_1185;

													{	/* Eval/evaluate.scm 187 */
														BgL_ev_prog2z00_bglt BgL_new1073z00_1187;

														BgL_new1073z00_1187 =
															((BgL_ev_prog2z00_bglt)
															BREF(GC_MALLOC(sizeof(struct
																		BgL_ev_prog2z00_bgl))));
														{	/* Eval/evaluate.scm 187 */
															long BgL_arg1370z00_1188;

															{	/* Eval/evaluate.scm 187 */
																long BgL_res2621z00_3026;

																BgL_res2621z00_3026 =
																	BGL_CLASS_INDEX
																	(BGl_ev_prog2z00zz__evaluate_typesz00);
																BgL_arg1370z00_1188 = BgL_res2621z00_3026;
															}
															BGL_OBJECT_CLASS_NUM_SET(
																((BgL_objectz00_bglt) BgL_new1073z00_1187),
																BgL_arg1370z00_1188);
														}
														{	/* Eval/evaluate.scm 187 */
															BgL_objectz00_bglt BgL_auxz00_5255;

															BgL_auxz00_5255 =
																((BgL_objectz00_bglt) BgL_new1073z00_1187);
															BGL_OBJECT_WIDENING_SET(BgL_auxz00_5255, BFALSE);
														}
														BgL_new1074z00_1185 = BgL_new1073z00_1187;
													}
													{
														BgL_ev_exprz00_bglt BgL_auxz00_5258;

														{	/* Eval/evaluate.scm 187 */
															obj_t BgL_arg1369z00_1186;

															{	/* Eval/evaluate.scm 145 */
																obj_t BgL__ortest_1067z00_3031;

																BgL__ortest_1067z00_3031 =
																	BGl_getzd2sourcezd2locationz00zz__readerz00
																	(BgL_e1z00_1169);
																if (CBOOL(BgL__ortest_1067z00_3031))
																	{	/* Eval/evaluate.scm 145 */
																		BgL_arg1369z00_1186 =
																			BgL__ortest_1067z00_3031;
																	}
																else
																	{	/* Eval/evaluate.scm 145 */
																		BgL_arg1369z00_1186 = BgL_locz00_1165;
																	}
															}
															BgL_auxz00_5258 =
																((BgL_ev_exprz00_bglt)
																BGl_convz00zz__evaluatez00(BgL_e1z00_1169,
																	BgL_localsz00_21, BgL_globalsz00_22, BFALSE,
																	BgL_wherez00_24, BgL_arg1369z00_1186,
																	BgL_topzf3zf3_26));
														}
														((((BgL_ev_prog2z00_bglt)
																	CREF(BgL_new1074z00_1185))->BgL_e1z00) =
															((BgL_ev_exprz00_bglt) BgL_auxz00_5258), BUNSPEC);
													}
													((((BgL_ev_prog2z00_bglt) CREF(BgL_new1074z00_1185))->
															BgL_e2z00) =
														((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt)
																BGl_convzd2beginzd2zz__evaluatez00
																(BgL_rz00_1170, BgL_localsz00_21,
																	BgL_globalsz00_22, BgL_tailzf3zf3_23,
																	BgL_wherez00_24, BgL_locz00_1165,
																	BgL_topzf3zf3_26))), BUNSPEC);
													BgL_auxz00_5250 = BgL_new1074z00_1185;
												}
												return ((obj_t) BgL_auxz00_5250);
											}
										}
								}
							else
								{	/* Eval/evaluate.scm 179 */
									return
										BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_1165,
										BGl_string2951z00zz__evaluatez00,
										BGl_string2952z00zz__evaluatez00, BgL_lz00_20);
								}
						}
				}
			}
		}
	}



/* conv-field-ref */
	obj_t BGl_convzd2fieldzd2refz00zz__evaluatez00(obj_t BgL_ez00_30,
		obj_t BgL_localsz00_31, obj_t BgL_globalsz00_32, obj_t BgL_tailzf3zf3_33,
		obj_t BgL_wherez00_34, obj_t BgL_locz00_35, bool_t BgL_topzf3zf3_36)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 204 */
			{	/* Eval/evaluate.scm 205 */
				obj_t BgL_lz00_1193;

				BgL_lz00_1193 = CDR(BgL_ez00_30);
				{	/* Eval/evaluate.scm 205 */
					obj_t BgL_vz00_1194;

					BgL_vz00_1194 =
						BGl_convzd2varzd2zz__evaluatez00(CAR(BgL_lz00_1193),
						BgL_localsz00_31);
					{	/* Eval/evaluate.scm 206 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1194,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 209 */
								obj_t BgL_g1078z00_1197;
								obj_t BgL_g1079z00_1198;

								{	/* Eval/evaluate.scm 210 */
									obj_t BgL_arg1390z00_1221;

									BgL_arg1390z00_1221 =
										(((BgL_ev_varz00_bglt) CREF(
												((BgL_ev_varz00_bglt) BgL_vz00_1194)))->BgL_typez00);
									BgL_g1078z00_1197 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1390z00_1221);
								}
								BgL_g1079z00_1198 = CDR(BgL_lz00_1193);
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1200;
									obj_t BgL_klassz00_1201;
									obj_t BgL_fieldsz00_1202;

									BgL_nodez00_1200 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1194));
									BgL_klassz00_1201 = BgL_g1078z00_1197;
									BgL_fieldsz00_1202 = BgL_g1079z00_1198;
								BgL_zc3anonymousza31374ze3z83_1203:
									if (NULLP(BgL_fieldsz00_1202))
										{	/* Eval/evaluate.scm 213 */
											return ((obj_t) BgL_nodez00_1200);
										}
									else
										{	/* Eval/evaluate.scm 213 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1201))
												{	/* Eval/evaluate.scm 216 */
													obj_t BgL_fieldz00_1206;

													BgL_fieldz00_1206 =
														BGl_findzd2classzd2fieldz00zz__objectz00
														(BgL_klassz00_1201, CAR(BgL_fieldsz00_1202));
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1206))
														{	/* Eval/evaluate.scm 218 */
															BgL_ev_appz00_bglt BgL_nodez00_1208;

															BgL_nodez00_1208 =
																BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00
																(BgL_fieldz00_1206, BgL_nodez00_1200,
																BgL_locz00_35, BgL_tailzf3zf3_33);
															{	/* Eval/evaluate.scm 221 */
																obj_t BgL_arg1378z00_1209;
																obj_t BgL_arg1379z00_1210;

																BgL_arg1378z00_1209 =
																	BGl_classzd2fieldzd2typez00zz__objectz00
																	(BgL_fieldz00_1206);
																BgL_arg1379z00_1210 = CDR(BgL_fieldsz00_1202);
																{
																	obj_t BgL_fieldsz00_5294;
																	obj_t BgL_klassz00_5293;
																	BgL_ev_exprz00_bglt BgL_nodez00_5291;

																	BgL_nodez00_5291 =
																		((BgL_ev_exprz00_bglt) BgL_nodez00_1208);
																	BgL_klassz00_5293 = BgL_arg1378z00_1209;
																	BgL_fieldsz00_5294 = BgL_arg1379z00_1210;
																	BgL_fieldsz00_1202 = BgL_fieldsz00_5294;
																	BgL_klassz00_1201 = BgL_klassz00_5293;
																	BgL_nodez00_1200 = BgL_nodez00_5291;
																	goto BgL_zc3anonymousza31374ze3z83_1203;
																}
															}
														}
													else
														{	/* Eval/evaluate.scm 223 */
															obj_t BgL_arg1380z00_1211;
															obj_t BgL_arg1381z00_1212;

															BgL_arg1380z00_1211 =
																(((BgL_ev_varz00_bglt) CREF(
																		((BgL_ev_varz00_bglt) BgL_vz00_1194)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 224 */
																obj_t BgL_arg1384z00_1213;
																obj_t BgL_arg1385z00_1214;

																BgL_arg1384z00_1213 =
																	(((BgL_ev_varz00_bglt) CREF(
																			((BgL_ev_varz00_bglt) BgL_vz00_1194)))->
																	BgL_typez00);
																BgL_arg1385z00_1214 = CAR(BgL_fieldsz00_1202);
																{	/* Eval/evaluate.scm 224 */
																	obj_t BgL_list1386z00_1215;

																	{	/* Eval/evaluate.scm 224 */
																		obj_t BgL_arg1387z00_1216;

																		BgL_arg1387z00_1216 =
																			MAKE_PAIR(BgL_arg1385z00_1214, BNIL);
																		BgL_list1386z00_1215 =
																			MAKE_PAIR(BgL_arg1384z00_1213,
																			BgL_arg1387z00_1216);
																	}
																	BgL_arg1381z00_1212 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string2953z00zz__evaluatez00,
																		BgL_list1386z00_1215);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_35, BgL_arg1380z00_1211,
																BgL_arg1381z00_1212, BgL_ez00_30);
														}
												}
											else
												{	/* Eval/evaluate.scm 227 */
													obj_t BgL_arg1389z00_1218;

													{	/* Eval/evaluate.scm 227 */
														obj_t BgL__ortest_1080z00_1219;

														BgL__ortest_1080z00_1219 =
															(((BgL_ev_varz00_bglt) CREF(
																	((BgL_ev_varz00_bglt) BgL_vz00_1194)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1080z00_1219))
															{	/* Eval/evaluate.scm 227 */
																BgL_arg1389z00_1218 = BgL__ortest_1080z00_1219;
															}
														else
															{	/* Eval/evaluate.scm 227 */
																BgL_arg1389z00_1218 =
																	(((BgL_ev_varz00_bglt) CREF(
																			((BgL_ev_varz00_bglt) BgL_vz00_1194)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_35, BgL_arg1389z00_1218,
														BGl_string2954z00zz__evaluatez00, BgL_ez00_30);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 207 */
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_35,
									CAR(CDR(BgL_ez00_30)), BGl_string2955z00zz__evaluatez00,
									BgL_ez00_30);
							}
					}
				}
			}
		}
	}



/* conv-field-set */
	obj_t BGl_convzd2fieldzd2setz00zz__evaluatez00(obj_t BgL_lz00_37,
		obj_t BgL_e2z00_38, obj_t BgL_ez00_39, obj_t BgL_localsz00_40,
		obj_t BgL_globalsz00_41, obj_t BgL_tailzf3zf3_42, obj_t BgL_wherez00_43,
		obj_t BgL_locz00_44, bool_t BgL_topzf3zf3_45)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 234 */
			{	/* Eval/evaluate.scm 235 */
				obj_t BgL_vz00_1224;

				BgL_vz00_1224 =
					BGl_convzd2varzd2zz__evaluatez00(CAR(BgL_lz00_37), BgL_localsz00_40);
				{	/* Eval/evaluate.scm 235 */
					obj_t BgL_e2z00_1225;

					BgL_e2z00_1225 =
						BGl_convz00zz__evaluatez00(BgL_e2z00_38, BgL_localsz00_40,
						BgL_globalsz00_41, BFALSE, BgL_wherez00_43, BgL_locz00_44,
						((bool_t) 0));
					{	/* Eval/evaluate.scm 236 */

						if (BGl_isazf3zf3zz__objectz00(BgL_vz00_1224,
								BGl_ev_varz00zz__evaluate_typesz00))
							{	/* Eval/evaluate.scm 239 */
								obj_t BgL_g1082z00_1228;
								obj_t BgL_g1083z00_1229;

								{	/* Eval/evaluate.scm 240 */
									obj_t BgL_arg1415z00_1259;

									BgL_arg1415z00_1259 =
										(((BgL_ev_varz00_bglt) CREF(
												((BgL_ev_varz00_bglt) BgL_vz00_1224)))->BgL_typez00);
									BgL_g1082z00_1228 =
										BGl_classzd2existszd2zz__objectz00(BgL_arg1415z00_1259);
								}
								BgL_g1083z00_1229 = CDR(BgL_lz00_37);
								{
									BgL_ev_exprz00_bglt BgL_nodez00_1231;
									obj_t BgL_klassz00_1232;
									obj_t BgL_fieldsz00_1233;

									BgL_nodez00_1231 =
										((BgL_ev_exprz00_bglt)
										((BgL_ev_varz00_bglt) BgL_vz00_1224));
									BgL_klassz00_1232 = BgL_g1082z00_1228;
									BgL_fieldsz00_1233 = BgL_g1083z00_1229;
								BgL_zc3anonymousza31394ze3z83_1234:
									if (NULLP(BgL_fieldsz00_1233))
										{	/* Eval/evaluate.scm 243 */
											return ((obj_t) BgL_nodez00_1231);
										}
									else
										{	/* Eval/evaluate.scm 243 */
											if (BGl_classzf3zf3zz__objectz00(BgL_klassz00_1232))
												{	/* Eval/evaluate.scm 246 */
													obj_t BgL_fieldz00_1237;

													BgL_fieldz00_1237 =
														BGl_findzd2classzd2fieldz00zz__objectz00
														(BgL_klassz00_1232, CAR(BgL_fieldsz00_1233));
													if (BGl_classzd2fieldzf3z21zz__objectz00
														(BgL_fieldz00_1237))
														{	/* Eval/evaluate.scm 247 */
															if (NULLP(CDR(BgL_fieldsz00_1233)))
																{	/* Eval/evaluate.scm 248 */
																	if (BGl_classzd2fieldzd2mutablezf3zf3zz__objectz00(BgL_fieldz00_1237))
																		{	/* Eval/evaluate.scm 251 */
																			obj_t BgL_arg1400z00_1241;

																			{	/* Eval/evaluate.scm 251 */
																				obj_t BgL_list1401z00_1242;

																				{	/* Eval/evaluate.scm 251 */
																					obj_t BgL_arg1402z00_1243;

																					BgL_arg1402z00_1243 =
																						MAKE_PAIR(BgL_e2z00_1225, BNIL);
																					BgL_list1401z00_1242 =
																						MAKE_PAIR(
																						((obj_t) BgL_nodez00_1231),
																						BgL_arg1402z00_1243);
																				}
																				BgL_arg1400z00_1241 =
																					BgL_list1401z00_1242;
																			}
																			return
																				((obj_t)
																				BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00
																				(BgL_fieldz00_1237, BgL_arg1400z00_1241,
																					BgL_locz00_44, BgL_tailzf3zf3_42));
																		}
																	else
																		{	/* Eval/evaluate.scm 249 */
																			return
																				BGl_evcompilezd2errorzd2zz__evcompilez00
																				(BgL_locz00_44, CAR(BgL_fieldsz00_1233),
																				BGl_string2956z00zz__evaluatez00,
																				BgL_ez00_39);
																		}
																}
															else
																{	/* Eval/evaluate.scm 255 */
																	BgL_ev_appz00_bglt BgL_nodez00_1245;

																	BgL_nodez00_1245 =
																		BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00
																		(BgL_fieldz00_1237, BgL_nodez00_1231,
																		BgL_locz00_44, BgL_tailzf3zf3_42);
																	{	/* Eval/evaluate.scm 258 */
																		obj_t BgL_arg1404z00_1246;
																		obj_t BgL_arg1405z00_1247;

																		BgL_arg1404z00_1246 =
																			BGl_classzd2fieldzd2typez00zz__objectz00
																			(BgL_fieldz00_1237);
																		BgL_arg1405z00_1247 =
																			CDR(BgL_fieldsz00_1233);
																		{
																			obj_t BgL_fieldsz00_5352;
																			obj_t BgL_klassz00_5351;
																			BgL_ev_exprz00_bglt BgL_nodez00_5349;

																			BgL_nodez00_5349 =
																				((BgL_ev_exprz00_bglt)
																				BgL_nodez00_1245);
																			BgL_klassz00_5351 = BgL_arg1404z00_1246;
																			BgL_fieldsz00_5352 = BgL_arg1405z00_1247;
																			BgL_fieldsz00_1233 = BgL_fieldsz00_5352;
																			BgL_klassz00_1232 = BgL_klassz00_5351;
																			BgL_nodez00_1231 = BgL_nodez00_5349;
																			goto BgL_zc3anonymousza31394ze3z83_1234;
																		}
																	}
																}
														}
													else
														{	/* Eval/evaluate.scm 260 */
															obj_t BgL_arg1407z00_1249;
															obj_t BgL_arg1408z00_1250;

															BgL_arg1407z00_1249 =
																(((BgL_ev_varz00_bglt) CREF(
																		((BgL_ev_varz00_bglt) BgL_vz00_1224)))->
																BgL_typez00);
															{	/* Eval/evaluate.scm 261 */
																obj_t BgL_arg1409z00_1251;
																obj_t BgL_arg1410z00_1252;

																BgL_arg1409z00_1251 =
																	(((BgL_ev_varz00_bglt) CREF(
																			((BgL_ev_varz00_bglt) BgL_vz00_1224)))->
																	BgL_typez00);
																BgL_arg1410z00_1252 = CAR(BgL_fieldsz00_1233);
																{	/* Eval/evaluate.scm 261 */
																	obj_t BgL_list1411z00_1253;

																	{	/* Eval/evaluate.scm 261 */
																		obj_t BgL_arg1412z00_1254;

																		BgL_arg1412z00_1254 =
																			MAKE_PAIR(BgL_arg1410z00_1252, BNIL);
																		BgL_list1411z00_1253 =
																			MAKE_PAIR(BgL_arg1409z00_1251,
																			BgL_arg1412z00_1254);
																	}
																	BgL_arg1408z00_1250 =
																		BGl_formatz00zz__r4_output_6_10_3z00
																		(BGl_string2953z00zz__evaluatez00,
																		BgL_list1411z00_1253);
																}
															}
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_44, BgL_arg1407z00_1249,
																BgL_arg1408z00_1250, BgL_ez00_39);
														}
												}
											else
												{	/* Eval/evaluate.scm 265 */
													obj_t BgL_arg1414z00_1256;

													{	/* Eval/evaluate.scm 265 */
														obj_t BgL__ortest_1084z00_1257;

														BgL__ortest_1084z00_1257 =
															(((BgL_ev_varz00_bglt) CREF(
																	((BgL_ev_varz00_bglt) BgL_vz00_1224)))->
															BgL_typez00);
														if (CBOOL(BgL__ortest_1084z00_1257))
															{	/* Eval/evaluate.scm 265 */
																BgL_arg1414z00_1256 = BgL__ortest_1084z00_1257;
															}
														else
															{	/* Eval/evaluate.scm 265 */
																BgL_arg1414z00_1256 =
																	(((BgL_ev_varz00_bglt) CREF(
																			((BgL_ev_varz00_bglt) BgL_vz00_1224)))->
																	BgL_namez00);
															}
													}
													return
														BGl_evcompilezd2errorzd2zz__evcompilez00
														(BgL_locz00_44, BgL_arg1414z00_1256,
														BGl_string2954z00zz__evaluatez00, BgL_ez00_39);
												}
										}
								}
							}
						else
							{	/* Eval/evaluate.scm 237 */
								return
									BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_44,
									CAR(BgL_lz00_37), BGl_string2955z00zz__evaluatez00,
									BgL_ez00_39);
							}
					}
				}
			}
		}
	}



/* make-class-field-ref */
	BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2refzd2zz__evaluatez00(obj_t
		BgL_fieldz00_46, BgL_ev_exprz00_bglt BgL_argz00_47, obj_t BgL_locz00_48,
		obj_t BgL_tailzf3zf3_49)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 271 */
			{	/* Eval/evaluate.scm 272 */
				obj_t BgL_getz00_1262;

				BgL_getz00_1262 =
					BGl_classzd2fieldzd2accessorz00zz__objectz00(BgL_fieldz00_46);
				{	/* Eval/evaluate.scm 273 */
					BgL_ev_appz00_bglt BgL_new1086z00_1263;

					{	/* Eval/evaluate.scm 274 */
						BgL_ev_appz00_bglt BgL_new1085z00_1268;

						BgL_new1085z00_1268 =
							((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_appz00_bgl))));
						{	/* Eval/evaluate.scm 274 */
							long BgL_arg1420z00_1269;

							{	/* Eval/evaluate.scm 274 */
								long BgL_res2630z00_3082;

								BgL_res2630z00_3082 =
									BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
								BgL_arg1420z00_1269 = BgL_res2630z00_3082;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1085z00_1268),
								BgL_arg1420z00_1269);
						}
						{	/* Eval/evaluate.scm 274 */
							BgL_objectz00_bglt BgL_auxz00_5378;

							BgL_auxz00_5378 = ((BgL_objectz00_bglt) BgL_new1085z00_1268);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5378, BFALSE);
						}
						BgL_new1086z00_1263 = BgL_new1085z00_1268;
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1086z00_1263))->BgL_locz00) =
						((obj_t) BgL_locz00_48), BUNSPEC);
					{
						BgL_ev_exprz00_bglt BgL_auxz00_5382;

						{	/* Eval/evaluate.scm 275 */
							BgL_ev_littz00_bglt BgL_new1088z00_1264;

							{	/* Eval/evaluate.scm 275 */
								BgL_ev_littz00_bglt BgL_new1087z00_1265;

								BgL_new1087z00_1265 =
									((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_ev_littz00_bgl))));
								{	/* Eval/evaluate.scm 275 */
									long BgL_arg1418z00_1266;

									{	/* Eval/evaluate.scm 275 */
										long BgL_res2631z00_3086;

										{	/* Eval/evaluate.scm 275 */
											obj_t BgL_classz00_3085;

											BgL_classz00_3085 = BGl_ev_littz00zz__evaluate_typesz00;
											BgL_res2631z00_3086 = BGL_CLASS_INDEX(BgL_classz00_3085);
										}
										BgL_arg1418z00_1266 = BgL_res2631z00_3086;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1087z00_1265),
										BgL_arg1418z00_1266);
								}
								{	/* Eval/evaluate.scm 275 */
									BgL_objectz00_bglt BgL_auxz00_5387;

									BgL_auxz00_5387 = ((BgL_objectz00_bglt) BgL_new1087z00_1265);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_5387, BFALSE);
								}
								BgL_new1088z00_1264 = BgL_new1087z00_1265;
							}
							((((BgL_ev_littz00_bglt) CREF(BgL_new1088z00_1264))->
									BgL_valuez00) = ((obj_t) BgL_getz00_1262), BUNSPEC);
							BgL_auxz00_5382 = ((BgL_ev_exprz00_bglt) BgL_new1088z00_1264);
						}
						((((BgL_ev_appz00_bglt) CREF(BgL_new1086z00_1263))->BgL_funz00) =
							((BgL_ev_exprz00_bglt) BgL_auxz00_5382), BUNSPEC);
					}
					{
						obj_t BgL_auxz00_5393;

						{	/* Eval/evaluate.scm 276 */
							obj_t BgL_list1419z00_1267;

							BgL_list1419z00_1267 = MAKE_PAIR(((obj_t) BgL_argz00_47), BNIL);
							BgL_auxz00_5393 = BgL_list1419z00_1267;
						}
						((((BgL_ev_appz00_bglt) CREF(BgL_new1086z00_1263))->BgL_argsz00) =
							((obj_t) BgL_auxz00_5393), BUNSPEC);
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1086z00_1263))->BgL_tailzf3zf3) =
						((obj_t) BgL_tailzf3zf3_49), BUNSPEC);
					return BgL_new1086z00_1263;
				}
			}
		}
	}



/* make-class-field-set */
	BgL_ev_appz00_bglt BGl_makezd2classzd2fieldzd2setzd2zz__evaluatez00(obj_t
		BgL_fieldz00_50, obj_t BgL_argsz00_51, obj_t BgL_locz00_52,
		obj_t BgL_tailzf3zf3_53)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 282 */
			{	/* Eval/evaluate.scm 283 */
				obj_t BgL_setz00_1270;

				BgL_setz00_1270 =
					BGl_classzd2fieldzd2mutatorz00zz__objectz00(BgL_fieldz00_50);
				{	/* Eval/evaluate.scm 284 */
					BgL_ev_appz00_bglt BgL_new1090z00_1271;

					{	/* Eval/evaluate.scm 285 */
						BgL_ev_appz00_bglt BgL_new1089z00_1275;

						BgL_new1089z00_1275 =
							((BgL_ev_appz00_bglt) BREF(GC_MALLOC(sizeof(struct
										BgL_ev_appz00_bgl))));
						{	/* Eval/evaluate.scm 285 */
							long BgL_arg1422z00_1276;

							{	/* Eval/evaluate.scm 285 */
								long BgL_res2633z00_3092;

								BgL_res2633z00_3092 =
									BGL_CLASS_INDEX(BGl_ev_appz00zz__evaluate_typesz00);
								BgL_arg1422z00_1276 = BgL_res2633z00_3092;
							}
							BGL_OBJECT_CLASS_NUM_SET(
								((BgL_objectz00_bglt) BgL_new1089z00_1275),
								BgL_arg1422z00_1276);
						}
						{	/* Eval/evaluate.scm 285 */
							BgL_objectz00_bglt BgL_auxz00_5403;

							BgL_auxz00_5403 = ((BgL_objectz00_bglt) BgL_new1089z00_1275);
							BGL_OBJECT_WIDENING_SET(BgL_auxz00_5403, BFALSE);
						}
						BgL_new1090z00_1271 = BgL_new1089z00_1275;
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1090z00_1271))->BgL_locz00) =
						((obj_t) BgL_locz00_52), BUNSPEC);
					{
						BgL_ev_exprz00_bglt BgL_auxz00_5407;

						{	/* Eval/evaluate.scm 286 */
							BgL_ev_littz00_bglt BgL_new1092z00_1272;

							{	/* Eval/evaluate.scm 286 */
								BgL_ev_littz00_bglt BgL_new1091z00_1273;

								BgL_new1091z00_1273 =
									((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
												BgL_ev_littz00_bgl))));
								{	/* Eval/evaluate.scm 286 */
									long BgL_arg1421z00_1274;

									{	/* Eval/evaluate.scm 286 */
										long BgL_res2634z00_3096;

										{	/* Eval/evaluate.scm 286 */
											obj_t BgL_classz00_3095;

											BgL_classz00_3095 = BGl_ev_littz00zz__evaluate_typesz00;
											BgL_res2634z00_3096 = BGL_CLASS_INDEX(BgL_classz00_3095);
										}
										BgL_arg1421z00_1274 = BgL_res2634z00_3096;
									}
									BGL_OBJECT_CLASS_NUM_SET(
										((BgL_objectz00_bglt) BgL_new1091z00_1273),
										BgL_arg1421z00_1274);
								}
								{	/* Eval/evaluate.scm 286 */
									BgL_objectz00_bglt BgL_auxz00_5412;

									BgL_auxz00_5412 = ((BgL_objectz00_bglt) BgL_new1091z00_1273);
									BGL_OBJECT_WIDENING_SET(BgL_auxz00_5412, BFALSE);
								}
								BgL_new1092z00_1272 = BgL_new1091z00_1273;
							}
							((((BgL_ev_littz00_bglt) CREF(BgL_new1092z00_1272))->
									BgL_valuez00) = ((obj_t) BgL_setz00_1270), BUNSPEC);
							BgL_auxz00_5407 = ((BgL_ev_exprz00_bglt) BgL_new1092z00_1272);
						}
						((((BgL_ev_appz00_bglt) CREF(BgL_new1090z00_1271))->BgL_funz00) =
							((BgL_ev_exprz00_bglt) BgL_auxz00_5407), BUNSPEC);
					}
					((((BgL_ev_appz00_bglt) CREF(BgL_new1090z00_1271))->BgL_argsz00) =
						((obj_t) BgL_argsz00_51), BUNSPEC);
					((((BgL_ev_appz00_bglt) CREF(BgL_new1090z00_1271))->BgL_tailzf3zf3) =
						((obj_t) BgL_tailzf3zf3_53), BUNSPEC);
					return BgL_new1090z00_1271;
				}
			}
		}
	}



/* type-check */
	obj_t BGl_typezd2checkzd2zz__evaluatez00(obj_t BgL_varz00_56,
		obj_t BgL_tnamez00_57, obj_t BgL_locz00_58, obj_t BgL_procnamez00_59,
		obj_t BgL_bodyz00_60)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 299 */
			if (SYMBOLP(BgL_tnamez00_57))
				{	/* Eval/evaluate.scm 302 */
					obj_t BgL_predz00_1280;

					if ((BgL_tnamez00_57 == BGl_symbol2957z00zz__evaluatez00))
						{	/* Eval/evaluate.scm 302 */
							BgL_predz00_1280 = BGl_symbol2959z00zz__evaluatez00;
						}
					else
						{	/* Eval/evaluate.scm 302 */
							if ((BgL_tnamez00_57 == BGl_symbol2961z00zz__evaluatez00))
								{	/* Eval/evaluate.scm 302 */
									BgL_predz00_1280 = BGl_symbol2962z00zz__evaluatez00;
								}
							else
								{	/* Eval/evaluate.scm 302 */
									if ((BgL_tnamez00_57 == BGl_symbol2964z00zz__evaluatez00))
										{	/* Eval/evaluate.scm 302 */
											BgL_predz00_1280 = BGl_symbol2966z00zz__evaluatez00;
										}
									else
										{	/* Eval/evaluate.scm 302 */
											if ((BgL_tnamez00_57 == BGl_symbol2968z00zz__evaluatez00))
												{	/* Eval/evaluate.scm 302 */
													BgL_predz00_1280 = BGl_symbol2970z00zz__evaluatez00;
												}
											else
												{	/* Eval/evaluate.scm 302 */
													bool_t BgL_testz00_5430;

													{	/* Eval/evaluate.scm 302 */
														bool_t BgL__ortest_1093z00_1351;

														BgL__ortest_1093z00_1351 =
															(BgL_tnamez00_57 ==
															BGl_symbol2972z00zz__evaluatez00);
														if (BgL__ortest_1093z00_1351)
															{	/* Eval/evaluate.scm 302 */
																BgL_testz00_5430 = BgL__ortest_1093z00_1351;
															}
														else
															{	/* Eval/evaluate.scm 302 */
																BgL_testz00_5430 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol2974z00zz__evaluatez00);
															}
													}
													if (BgL_testz00_5430)
														{	/* Eval/evaluate.scm 302 */
															BgL_predz00_1280 =
																BGl_symbol2975z00zz__evaluatez00;
														}
													else
														{	/* Eval/evaluate.scm 302 */
															bool_t BgL_testz00_5434;

															{	/* Eval/evaluate.scm 302 */
																bool_t BgL__ortest_1094z00_1350;

																BgL__ortest_1094z00_1350 =
																	(BgL_tnamez00_57 ==
																	BGl_symbol2977z00zz__evaluatez00);
																if (BgL__ortest_1094z00_1350)
																	{	/* Eval/evaluate.scm 302 */
																		BgL_testz00_5434 = BgL__ortest_1094z00_1350;
																	}
																else
																	{	/* Eval/evaluate.scm 302 */
																		BgL_testz00_5434 =
																			(BgL_tnamez00_57 ==
																			BGl_symbol2979z00zz__evaluatez00);
																	}
															}
															if (BgL_testz00_5434)
																{	/* Eval/evaluate.scm 302 */
																	BgL_predz00_1280 =
																		BGl_symbol2981z00zz__evaluatez00;
																}
															else
																{	/* Eval/evaluate.scm 302 */
																	if (
																		(BgL_tnamez00_57 ==
																			BGl_symbol2983z00zz__evaluatez00))
																		{	/* Eval/evaluate.scm 302 */
																			BgL_predz00_1280 =
																				BGl_symbol2985z00zz__evaluatez00;
																		}
																	else
																		{	/* Eval/evaluate.scm 302 */
																			if (
																				(BgL_tnamez00_57 ==
																					BGl_symbol2987z00zz__evaluatez00))
																				{	/* Eval/evaluate.scm 302 */
																					BgL_predz00_1280 =
																						BGl_symbol2989z00zz__evaluatez00;
																				}
																			else
																				{	/* Eval/evaluate.scm 302 */
																					if (
																						(BgL_tnamez00_57 ==
																							BGl_symbol2991z00zz__evaluatez00))
																						{	/* Eval/evaluate.scm 302 */
																							BgL_predz00_1280 =
																								BGl_symbol2993z00zz__evaluatez00;
																						}
																					else
																						{	/* Eval/evaluate.scm 302 */
																							bool_t BgL_testz00_5444;

																							{	/* Eval/evaluate.scm 302 */
																								bool_t BgL__ortest_1095z00_1349;

																								BgL__ortest_1095z00_1349 =
																									(BgL_tnamez00_57 ==
																									BGl_symbol2995z00zz__evaluatez00);
																								if (BgL__ortest_1095z00_1349)
																									{	/* Eval/evaluate.scm 302 */
																										BgL_testz00_5444 =
																											BgL__ortest_1095z00_1349;
																									}
																								else
																									{	/* Eval/evaluate.scm 302 */
																										BgL_testz00_5444 =
																											(BgL_tnamez00_57 ==
																											BGl_symbol2997z00zz__evaluatez00);
																									}
																							}
																							if (BgL_testz00_5444)
																								{	/* Eval/evaluate.scm 302 */
																									BgL_predz00_1280 =
																										BGl_symbol2999z00zz__evaluatez00;
																								}
																							else
																								{	/* Eval/evaluate.scm 313 */
																									obj_t BgL_arg1468z00_1329;

																									{	/* Eval/evaluate.scm 313 */
																										obj_t BgL_arg1469z00_1330;
																										obj_t BgL_arg1470z00_1331;

																										BgL_arg1469z00_1330 =
																											MAKE_PAIR
																											(BGl_symbol3001z00zz__evaluatez00,
																											BNIL);
																										{	/* Eval/evaluate.scm 314 */
																											obj_t BgL_arg1471z00_1332;

																											{	/* Eval/evaluate.scm 314 */
																												obj_t
																													BgL_arg1476z00_1333;
																												{	/* Eval/evaluate.scm 314 */
																													obj_t
																														BgL_arg1477z00_1334;
																													obj_t
																														BgL_arg1478z00_1335;
																													{	/* Eval/evaluate.scm 314 */
																														obj_t
																															BgL_arg1479z00_1336;
																														{	/* Eval/evaluate.scm 314 */
																															obj_t
																																BgL_arg1481z00_1337;
																															{	/* Eval/evaluate.scm 314 */
																																obj_t
																																	BgL_arg1482z00_1338;
																																{	/* Eval/evaluate.scm 314 */
																																	obj_t
																																		BgL_arg1483z00_1339;
																																	{	/* Eval/evaluate.scm 314 */
																																		obj_t
																																			BgL_arg1484z00_1340;
																																		{	/* Eval/evaluate.scm 314 */
																																			obj_t
																																				BgL_arg1485z00_1341;
																																			BgL_arg1485z00_1341
																																				=
																																				MAKE_PAIR
																																				(BgL_tnamez00_57,
																																				BNIL);
																																			BgL_arg1484z00_1340
																																				=
																																				MAKE_PAIR
																																				(BGl_symbol3003z00zz__evaluatez00,
																																				BgL_arg1485z00_1341);
																																		}
																																		BgL_arg1483z00_1339
																																			=
																																			MAKE_PAIR
																																			(BgL_arg1484z00_1340,
																																			BNIL);
																																	}
																																	BgL_arg1482z00_1338
																																		=
																																		MAKE_PAIR
																																		(BGl_symbol3005z00zz__evaluatez00,
																																		BgL_arg1483z00_1339);
																																}
																																BgL_arg1481z00_1337
																																	=
																																	MAKE_PAIR
																																	(BgL_arg1482z00_1338,
																																	BNIL);
																															}
																															BgL_arg1479z00_1336
																																=
																																MAKE_PAIR
																																(BGl_symbol3007z00zz__evaluatez00,
																																BgL_arg1481z00_1337);
																														}
																														BgL_arg1477z00_1334
																															=
																															MAKE_PAIR
																															(BgL_arg1479z00_1336,
																															BNIL);
																													}
																													{	/* Eval/evaluate.scm 315 */
																														obj_t
																															BgL_arg1487z00_1342;
																														{	/* Eval/evaluate.scm 315 */
																															obj_t
																																BgL_arg1488z00_1343;
																															{	/* Eval/evaluate.scm 315 */
																																obj_t
																																	BgL_arg1489z00_1344;
																																{	/* Eval/evaluate.scm 315 */
																																	obj_t
																																		BgL_arg1490z00_1345;
																																	obj_t
																																		BgL_arg1491z00_1346;
																																	{	/* Eval/evaluate.scm 315 */
																																		obj_t
																																			BgL_arg1492z00_1347;
																																		{	/* Eval/evaluate.scm 315 */
																																			obj_t
																																				BgL_arg1493z00_1348;
																																			BgL_arg1493z00_1348
																																				=
																																				MAKE_PAIR
																																				(BGl_symbol3007z00zz__evaluatez00,
																																				BNIL);
																																			BgL_arg1492z00_1347
																																				=
																																				MAKE_PAIR
																																				(BGl_symbol3001z00zz__evaluatez00,
																																				BgL_arg1493z00_1348);
																																		}
																																		BgL_arg1490z00_1345
																																			=
																																			MAKE_PAIR
																																			(BGl_symbol3009z00zz__evaluatez00,
																																			BgL_arg1492z00_1347);
																																	}
																																	BgL_arg1491z00_1346
																																		=
																																		MAKE_PAIR
																																		(BTRUE,
																																		BNIL);
																																	BgL_arg1489z00_1344
																																		=
																																		MAKE_PAIR
																																		(BgL_arg1490z00_1345,
																																		BgL_arg1491z00_1346);
																																}
																																BgL_arg1488z00_1343
																																	=
																																	MAKE_PAIR
																																	(BGl_symbol3007z00zz__evaluatez00,
																																	BgL_arg1489z00_1344);
																															}
																															BgL_arg1487z00_1342
																																=
																																MAKE_PAIR
																																(BGl_symbol3011z00zz__evaluatez00,
																																BgL_arg1488z00_1343);
																														}
																														BgL_arg1478z00_1335
																															=
																															MAKE_PAIR
																															(BgL_arg1487z00_1342,
																															BNIL);
																													}
																													BgL_arg1476z00_1333 =
																														MAKE_PAIR
																														(BgL_arg1477z00_1334,
																														BgL_arg1478z00_1335);
																												}
																												BgL_arg1471z00_1332 =
																													MAKE_PAIR
																													(BGl_symbol3013z00zz__evaluatez00,
																													BgL_arg1476z00_1333);
																											}
																											BgL_arg1470z00_1331 =
																												MAKE_PAIR
																												(BgL_arg1471z00_1332,
																												BNIL);
																										}
																										BgL_arg1468z00_1329 =
																											MAKE_PAIR
																											(BgL_arg1469z00_1330,
																											BgL_arg1470z00_1331);
																									}
																									BgL_predz00_1280 =
																										MAKE_PAIR
																										(BGl_symbol3015z00zz__evaluatez00,
																										BgL_arg1468z00_1329);
																								}
																						}
																				}
																		}
																}
														}
												}
										}
								}
						}
					{	/* Eval/evaluate.scm 317 */
						obj_t BgL_arg1426z00_1281;

						{	/* Eval/evaluate.scm 317 */
							obj_t BgL_arg1427z00_1282;

							{	/* Eval/evaluate.scm 317 */
								obj_t BgL_arg1428z00_1283;
								obj_t BgL_arg1429z00_1284;

								{	/* Eval/evaluate.scm 317 */
									obj_t BgL_arg1430z00_1285;

									BgL_arg1430z00_1285 = MAKE_PAIR(BgL_varz00_56, BNIL);
									BgL_arg1428z00_1283 =
										MAKE_PAIR(BgL_predz00_1280, BgL_arg1430z00_1285);
								}
								{	/* Eval/evaluate.scm 317 */
									obj_t BgL_arg1431z00_1286;

									{	/* Eval/evaluate.scm 317 */
										obj_t BgL_arg1432z00_1287;

										{
											obj_t BgL_fnamez00_1288;
											obj_t BgL_posz00_1289;

											if (PAIRP(BgL_locz00_58))
												{	/* Eval/evaluate.scm 317 */
													obj_t BgL_cdrzd2138zd2_1294;

													BgL_cdrzd2138zd2_1294 = CDR(BgL_locz00_58);
													if (
														(CAR(BgL_locz00_58) ==
															BGl_symbol3021z00zz__evaluatez00))
														{	/* Eval/evaluate.scm 317 */
															if (PAIRP(BgL_cdrzd2138zd2_1294))
																{	/* Eval/evaluate.scm 317 */
																	obj_t BgL_cdrzd2142zd2_1297;

																	BgL_cdrzd2142zd2_1297 =
																		CDR(BgL_cdrzd2138zd2_1294);
																	if (PAIRP(BgL_cdrzd2142zd2_1297))
																		{	/* Eval/evaluate.scm 317 */
																			if (NULLP(CDR(BgL_cdrzd2142zd2_1297)))
																				{	/* Eval/evaluate.scm 317 */
																					BgL_fnamez00_1288 =
																						CAR(BgL_cdrzd2138zd2_1294);
																					BgL_posz00_1289 =
																						CAR(BgL_cdrzd2142zd2_1297);
																					{	/* Eval/evaluate.scm 322 */
																						obj_t BgL_arg1443z00_1304;

																						{	/* Eval/evaluate.scm 322 */
																							obj_t BgL_arg1444z00_1305;
																							obj_t BgL_arg1445z00_1306;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 322 */
																									obj_t BgL_res2645z00_3134;

																									{	/* Eval/evaluate.scm 322 */
																										obj_t BgL_arg2423z00_3133;

																										BgL_arg2423z00_3133 =
																											SYMBOL_TO_STRING
																											(BgL_procnamez00_59);
																										BgL_res2645z00_3134 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2423z00_3133);
																									}
																									BgL_arg1444z00_1305 =
																										BgL_res2645z00_3134;
																								}
																							else
																								{	/* Eval/evaluate.scm 322 */
																									BgL_arg1444z00_1305 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 323 */
																								obj_t BgL_arg1447z00_1308;
																								obj_t BgL_arg1448z00_1309;

																								{	/* Eval/evaluate.scm 323 */
																									obj_t BgL_res2646z00_3137;

																									{	/* Eval/evaluate.scm 323 */
																										obj_t BgL_arg2423z00_3136;

																										BgL_arg2423z00_3136 =
																											SYMBOL_TO_STRING
																											(BgL_tnamez00_57);
																										BgL_res2646z00_3137 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2423z00_3136);
																									}
																									BgL_arg1447z00_1308 =
																										BgL_res2646z00_3137;
																								}
																								{	/* Eval/evaluate.scm 321 */
																									obj_t BgL_arg1449z00_1310;

																									{	/* Eval/evaluate.scm 321 */
																										obj_t BgL_arg1450z00_1311;

																										BgL_arg1450z00_1311 =
																											MAKE_PAIR(BgL_posz00_1289,
																											BNIL);
																										BgL_arg1449z00_1310 =
																											MAKE_PAIR
																											(BgL_fnamez00_1288,
																											BgL_arg1450z00_1311);
																									}
																									BgL_arg1448z00_1309 =
																										MAKE_PAIR(BgL_varz00_56,
																										BgL_arg1449z00_1310);
																								}
																								BgL_arg1445z00_1306 =
																									MAKE_PAIR(BgL_arg1447z00_1308,
																									BgL_arg1448z00_1309);
																							}
																							BgL_arg1443z00_1304 =
																								MAKE_PAIR(BgL_arg1444z00_1305,
																								BgL_arg1445z00_1306);
																						}
																						BgL_arg1432z00_1287 =
																							MAKE_PAIR
																							(BGl_symbol3017z00zz__evaluatez00,
																							BgL_arg1443z00_1304);
																					}
																				}
																			else
																				{	/* Eval/evaluate.scm 317 */
																				BgL_tagzd2131zd2_1291:
																					{	/* Eval/evaluate.scm 327 */
																						obj_t BgL_arg1452z00_1312;

																						{	/* Eval/evaluate.scm 327 */
																							obj_t BgL_arg1453z00_1313;
																							obj_t BgL_arg1454z00_1314;

																							if (SYMBOLP(BgL_procnamez00_59))
																								{	/* Eval/evaluate.scm 327 */
																									obj_t BgL_res2648z00_3142;

																									{	/* Eval/evaluate.scm 327 */
																										obj_t BgL_arg2423z00_3141;

																										BgL_arg2423z00_3141 =
																											SYMBOL_TO_STRING
																											(BgL_procnamez00_59);
																										BgL_res2648z00_3142 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2423z00_3141);
																									}
																									BgL_arg1453z00_1313 =
																										BgL_res2648z00_3142;
																								}
																							else
																								{	/* Eval/evaluate.scm 327 */
																									BgL_arg1453z00_1313 = BFALSE;
																								}
																							{	/* Eval/evaluate.scm 328 */
																								obj_t BgL_arg1456z00_1316;
																								obj_t BgL_arg1457z00_1317;

																								{	/* Eval/evaluate.scm 328 */
																									obj_t BgL_res2649z00_3145;

																									{	/* Eval/evaluate.scm 328 */
																										obj_t BgL_arg2423z00_3144;

																										BgL_arg2423z00_3144 =
																											SYMBOL_TO_STRING
																											(BgL_tnamez00_57);
																										BgL_res2649z00_3145 =
																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																											(BgL_arg2423z00_3144);
																									}
																									BgL_arg1456z00_1316 =
																										BgL_res2649z00_3145;
																								}
																								BgL_arg1457z00_1317 =
																									MAKE_PAIR(BgL_varz00_56,
																									BNIL);
																								BgL_arg1454z00_1314 =
																									MAKE_PAIR(BgL_arg1456z00_1316,
																									BgL_arg1457z00_1317);
																							}
																							BgL_arg1452z00_1312 =
																								MAKE_PAIR(BgL_arg1453z00_1313,
																								BgL_arg1454z00_1314);
																						}
																						BgL_arg1432z00_1287 =
																							MAKE_PAIR
																							(BGl_symbol3019z00zz__evaluatez00,
																							BgL_arg1452z00_1312);
																					}
																				}
																		}
																	else
																		{	/* Eval/evaluate.scm 317 */
																			goto BgL_tagzd2131zd2_1291;
																		}
																}
															else
																{	/* Eval/evaluate.scm 317 */
																	goto BgL_tagzd2131zd2_1291;
																}
														}
													else
														{	/* Eval/evaluate.scm 317 */
															goto BgL_tagzd2131zd2_1291;
														}
												}
											else
												{	/* Eval/evaluate.scm 317 */
													goto BgL_tagzd2131zd2_1291;
												}
										}
										BgL_arg1431z00_1286 = MAKE_PAIR(BgL_arg1432z00_1287, BNIL);
									}
									BgL_arg1429z00_1284 =
										MAKE_PAIR(BgL_bodyz00_60, BgL_arg1431z00_1286);
								}
								BgL_arg1427z00_1282 =
									MAKE_PAIR(BgL_arg1428z00_1283, BgL_arg1429z00_1284);
							}
							BgL_arg1426z00_1281 =
								MAKE_PAIR(BGl_symbol3011z00zz__evaluatez00,
								BgL_arg1427z00_1282);
						}
						{	/* Eval/evaluate.scm 294 */
							obj_t BgL_arg1423z00_3162;
							obj_t BgL_arg1424z00_3163;

							BgL_arg1423z00_3162 = CAR(BgL_arg1426z00_1281);
							BgL_arg1424z00_3163 = CDR(BgL_arg1426z00_1281);
							{	/* Eval/evaluate.scm 294 */
								obj_t BgL_res2654z00_3169;

								BgL_res2654z00_3169 =
									MAKE_EXTENDED_PAIR(BgL_arg1423z00_3162, BgL_arg1424z00_3163,
									BgL_locz00_58);
								return BgL_res2654z00_3169;
							}
						}
					}
				}
			else
				{	/* Eval/evaluate.scm 301 */
					return BgL_bodyz00_60;
				}
		}
	}



/* type-checks */
	obj_t BGl_typezd2checkszd2zz__evaluatez00(obj_t BgL_varsz00_61,
		obj_t BgL_srcsz00_62, obj_t BgL_bodyz00_63, obj_t BgL_locz00_64,
		obj_t BgL_procnamez00_65)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 335 */
			{	/* Eval/evaluate.scm 336 */
				bool_t BgL_testz00_5516;

				{	/* Eval/evaluate.scm 336 */
					int BgL_arg1505z00_1369;

					BgL_arg1505z00_1369 = bgl_debug();
					BgL_testz00_5516 = ((long) (BgL_arg1505z00_1369) <= ((long) 0));
				}
				if (BgL_testz00_5516)
					{	/* Eval/evaluate.scm 336 */
						return BgL_bodyz00_63;
					}
				else
					{	/* Eval/evaluate.scm 336 */
						return
							BGl_loopz72z72zz__evaluatez00(BgL_bodyz00_63, BgL_procnamez00_65,
							BgL_locz00_64, BgL_varsz00_61, BgL_srcsz00_62);
					}
			}
		}
	}



/* loop' */
	obj_t BGl_loopz72z72zz__evaluatez00(obj_t BgL_bodyz00_4993,
		obj_t BgL_procnamez00_4992, obj_t BgL_locz00_4991, obj_t BgL_varsz00_1354,
		obj_t BgL_srcsz00_1355)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 338 */
		BGl_loopz72z72zz__evaluatez00:
			if (NULLP(BgL_varsz00_1354))
				{	/* Eval/evaluate.scm 340 */
					return BgL_bodyz00_4993;
				}
			else
				{	/* Eval/evaluate.scm 342 */
					obj_t BgL_vz00_1358;

					BgL_vz00_1358 = CAR(BgL_varsz00_1354);
					{	/* Eval/evaluate.scm 342 */
						obj_t BgL_idz00_1359;

						BgL_idz00_1359 = CAR(BgL_vz00_1358);
						{	/* Eval/evaluate.scm 343 */
							obj_t BgL_tnamez00_1360;

							BgL_tnamez00_1360 = CDR(BgL_vz00_1358);
							{	/* Eval/evaluate.scm 344 */

								if (CBOOL(BgL_tnamez00_1360))
									{	/* Eval/evaluate.scm 346 */
										obj_t BgL_locz00_1361;

										{	/* Eval/evaluate.scm 346 */
											obj_t BgL_arg1501z00_1365;

											BgL_arg1501z00_1365 = CAR(BgL_srcsz00_1355);
											{	/* Eval/evaluate.scm 151 */
												obj_t BgL__ortest_1068z00_3182;

												BgL__ortest_1068z00_3182 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_arg1501z00_1365);
												if (CBOOL(BgL__ortest_1068z00_3182))
													{	/* Eval/evaluate.scm 151 */
														BgL_locz00_1361 = BgL__ortest_1068z00_3182;
													}
												else
													{	/* Eval/evaluate.scm 152 */
														obj_t BgL__ortest_1069z00_3183;

														BgL__ortest_1069z00_3183 =
															BGl_getzd2sourcezd2locationz00zz__readerz00
															(BgL_srcsz00_1355);
														if (CBOOL(BgL__ortest_1069z00_3183))
															{	/* Eval/evaluate.scm 152 */
																BgL_locz00_1361 = BgL__ortest_1069z00_3183;
															}
														else
															{	/* Eval/evaluate.scm 152 */
																BgL_locz00_1361 = BgL_locz00_4991;
															}
													}
											}
										}
										return
											BGl_typezd2checkzd2zz__evaluatez00(BgL_idz00_1359,
											BgL_tnamez00_1360, BgL_locz00_1361, BgL_procnamez00_4992,
											BGl_loopz72z72zz__evaluatez00(BgL_bodyz00_4993,
												BgL_procnamez00_4992, BgL_locz00_4991,
												CDR(BgL_varsz00_1354), CDR(BgL_srcsz00_1355)));
									}
								else
									{
										obj_t BgL_srcsz00_5541;
										obj_t BgL_varsz00_5539;

										BgL_varsz00_5539 = CDR(BgL_varsz00_1354);
										BgL_srcsz00_5541 = CDR(BgL_srcsz00_1355);
										BgL_srcsz00_1355 = BgL_srcsz00_5541;
										BgL_varsz00_1354 = BgL_varsz00_5539;
										goto BGl_loopz72z72zz__evaluatez00;
									}
							}
						}
					}
				}
		}
	}



/* type-result */
	obj_t BGl_typezd2resultzd2zz__evaluatez00(obj_t BgL_typez00_66,
		obj_t BgL_bodyz00_67, obj_t BgL_locz00_68)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 354 */
			{	/* Eval/evaluate.scm 355 */
				bool_t BgL_testz00_5543;

				if (CBOOL(BgL_typez00_66))
					{	/* Eval/evaluate.scm 355 */
						int BgL_arg1523z00_1383;

						BgL_arg1523z00_1383 = bgl_debug();
						BgL_testz00_5543 = ((long) (BgL_arg1523z00_1383) >= ((long) 1));
					}
				else
					{	/* Eval/evaluate.scm 355 */
						BgL_testz00_5543 = ((bool_t) 0);
					}
				if (BgL_testz00_5543)
					{	/* Eval/evaluate.scm 356 */
						obj_t BgL_tmpz00_1371;

						BgL_tmpz00_1371 =
							BGl_gensymz00zz__r4_symbols_6_4z00
							(BGl_symbol3023z00zz__evaluatez00);
						{	/* Eval/evaluate.scm 358 */
							obj_t BgL_arg1508z00_1372;
							obj_t BgL_arg1509z00_1373;

							{	/* Eval/evaluate.scm 358 */
								obj_t BgL_arg1511z00_1374;

								{	/* Eval/evaluate.scm 358 */
									obj_t BgL_arg1513z00_1375;
									obj_t BgL_arg1514z00_1376;

									{	/* Eval/evaluate.scm 358 */
										obj_t BgL_arg1516z00_1377;

										{	/* Eval/evaluate.scm 358 */
											obj_t BgL_arg1517z00_1378;
											obj_t BgL_arg1519z00_1379;

											{	/* Eval/evaluate.scm 358 */
												obj_t BgL_arg1520z00_1380;

												{	/* Eval/evaluate.scm 358 */
													obj_t BgL_list1521z00_1381;

													{	/* Eval/evaluate.scm 358 */
														obj_t BgL_arg1522z00_1382;

														BgL_arg1522z00_1382 =
															MAKE_PAIR(BgL_typez00_66, BNIL);
														BgL_list1521z00_1381 =
															MAKE_PAIR(BgL_tmpz00_1371, BgL_arg1522z00_1382);
													}
													BgL_arg1520z00_1380 =
														BGl_formatz00zz__r4_output_6_10_3z00
														(BGl_string3025z00zz__evaluatez00,
														BgL_list1521z00_1381);
												}
												BgL_arg1517z00_1378 =
													bstring_to_symbol(BgL_arg1520z00_1380);
											}
											BgL_arg1519z00_1379 = MAKE_PAIR(BgL_bodyz00_67, BNIL);
											BgL_arg1516z00_1377 =
												MAKE_PAIR(BgL_arg1517z00_1378, BgL_arg1519z00_1379);
										}
										BgL_arg1513z00_1375 = MAKE_PAIR(BgL_arg1516z00_1377, BNIL);
									}
									BgL_arg1514z00_1376 = MAKE_PAIR(BgL_tmpz00_1371, BNIL);
									BgL_arg1511z00_1374 =
										MAKE_PAIR(BgL_arg1513z00_1375, BgL_arg1514z00_1376);
								}
								BgL_arg1508z00_1372 =
									MAKE_PAIR(BGl_symbol3013z00zz__evaluatez00,
									BgL_arg1511z00_1374);
							}
							{	/* Eval/evaluate.scm 145 */
								obj_t BgL__ortest_1067z00_3195;

								BgL__ortest_1067z00_3195 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_67);
								if (CBOOL(BgL__ortest_1067z00_3195))
									{	/* Eval/evaluate.scm 145 */
										BgL_arg1509z00_1373 = BgL__ortest_1067z00_3195;
									}
								else
									{	/* Eval/evaluate.scm 145 */
										BgL_arg1509z00_1373 = BgL_locz00_68;
									}
							}
							{	/* Eval/evaluate.scm 294 */
								obj_t BgL_arg1423z00_3198;
								obj_t BgL_arg1424z00_3199;

								BgL_arg1423z00_3198 = CAR(BgL_arg1508z00_1372);
								BgL_arg1424z00_3199 = CDR(BgL_arg1508z00_1372);
								{	/* Eval/evaluate.scm 294 */
									obj_t BgL_res2659z00_3205;

									BgL_res2659z00_3205 =
										MAKE_EXTENDED_PAIR(BgL_arg1423z00_3198, BgL_arg1424z00_3199,
										BgL_arg1509z00_1373);
									return BgL_res2659z00_3205;
								}
							}
						}
					}
				else
					{	/* Eval/evaluate.scm 355 */
						return BgL_bodyz00_67;
					}
			}
		}
	}



/* conv */
	obj_t BGl_convz00zz__evaluatez00(obj_t BgL_ez00_69, obj_t BgL_localsz00_70,
		obj_t BgL_globalsz00_71, obj_t BgL_tailzf3zf3_72, obj_t BgL_wherez00_73,
		obj_t BgL_locz00_74, bool_t BgL_topzf3zf3_75)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 366 */
		BGl_convz00zz__evaluatez00:
			{
				obj_t BgL_xz00_1392;
				obj_t BgL_bahz00_1394;
				obj_t BgL_lz00_1399;
				obj_t BgL_funz00_1401;
				obj_t BgL_argsz00_1402;
				obj_t BgL_ez00_1404;
				obj_t BgL_pz00_1408;
				obj_t BgL_tz00_1409;
				obj_t BgL_oz00_1410;
				obj_t BgL_pz00_1412;
				obj_t BgL_tz00_1413;
				obj_t BgL_argsz00_1415;
				obj_t BgL_argsz00_1417;
				obj_t BgL_bindsz00_1421;
				obj_t BgL_bodyz00_1422;
				obj_t BgL_bindsz00_1424;
				obj_t BgL_bodyz00_1425;
				obj_t BgL_bindsz00_1427;
				obj_t BgL_bodyz00_1428;
				obj_t BgL_lz00_1434;
				obj_t BgL_e2z00_1435;
				obj_t BgL_vz00_1437;
				obj_t BgL_ez00_1438;
				obj_t BgL_gvz00_1441;
				obj_t BgL_formalsz00_1442;
				obj_t BgL_bodyz00_1443;
				obj_t BgL_gvz00_1445;
				obj_t BgL_gez00_1446;
				obj_t BgL_vz00_1448;
				obj_t BgL_bodyz00_1449;
				obj_t BgL_ez00_1451;
				obj_t BgL_bodyz00_1452;
				obj_t BgL_hz00_1454;
				obj_t BgL_bodyz00_1455;
				obj_t BgL_mz00_1457;
				obj_t BgL_pz00_1458;
				obj_t BgL_bodyz00_1459;
				obj_t BgL_mz00_1461;
				obj_t BgL_bodyz00_1462;
				obj_t BgL_fz00_1467;
				obj_t BgL_argsz00_1468;

				if (PAIRP(BgL_ez00_69))
					{	/* Eval/evaluate.scm 425 */
						if ((CAR(BgL_ez00_69) == BGl_symbol3032z00zz__evaluatez00))
							{	/* Eval/evaluate.scm 425 */
								BgL_bahz00_1394 = CDR(BgL_ez00_69);
								if (BgL_topzf3zf3_75)
									{	/* Eval/evaluate.scm 433 */
										obj_t BgL_formsz00_2156;

										{	/* Eval/evaluate.scm 433 */
											obj_t BgL_arg2141z00_2159;

											{	/* Eval/evaluate.scm 145 */
												obj_t BgL__ortest_1067z00_3296;

												BgL__ortest_1067z00_3296 =
													BGl_getzd2sourcezd2locationz00zz__readerz00
													(BgL_ez00_69);
												if (CBOOL(BgL__ortest_1067z00_3296))
													{	/* Eval/evaluate.scm 145 */
														BgL_arg2141z00_2159 = BgL__ortest_1067z00_3296;
													}
												else
													{	/* Eval/evaluate.scm 145 */
														BgL_arg2141z00_2159 = BgL_locz00_74;
													}
											}
											BgL_formsz00_2156 =
												BGl_evmodulez00zz__evmodulez00(BgL_ez00_69,
												BgL_arg2141z00_2159);
										}
										{	/* Eval/evaluate.scm 434 */
											obj_t BgL_arg2139z00_2157;
											obj_t BgL_arg2140z00_2158;

											BgL_arg2139z00_2157 =
												BGl_expandz00zz__expandz00(BgL_formsz00_2156);
											BgL_arg2140z00_2158 = BGL_MODULE();
											{
												bool_t BgL_topzf3zf3_5582;
												obj_t BgL_wherez00_5581;
												obj_t BgL_tailzf3zf3_5580;
												obj_t BgL_globalsz00_5579;
												obj_t BgL_ez00_5578;

												BgL_ez00_5578 = BgL_arg2139z00_2157;
												BgL_globalsz00_5579 = BgL_arg2140z00_2158;
												BgL_tailzf3zf3_5580 = BgL_wherez00_73;
												BgL_wherez00_5581 = BFALSE;
												BgL_topzf3zf3_5582 = ((bool_t) 1);
												BgL_topzf3zf3_75 = BgL_topzf3zf3_5582;
												BgL_wherez00_73 = BgL_wherez00_5581;
												BgL_tailzf3zf3_72 = BgL_tailzf3zf3_5580;
												BgL_globalsz00_71 = BgL_globalsz00_5579;
												BgL_ez00_69 = BgL_ez00_5578;
												goto BGl_convz00zz__evaluatez00;
											}
										}
									}
								else
									{	/* Eval/evaluate.scm 432 */
										return
											BGl_evcompilezd2errorzd2zz__evcompilez00(BgL_locz00_74,
											BGl_string2951z00zz__evaluatez00,
											BGl_string3031z00zz__evaluatez00, BgL_ez00_69);
									}
							}
						else
							{	/* Eval/evaluate.scm 425 */
								obj_t BgL_cdrzd2249zd2_1475;

								BgL_cdrzd2249zd2_1475 = CDR(BgL_ez00_69);
								if ((CAR(BgL_ez00_69) == BGl_symbol3034z00zz__evaluatez00))
									{	/* Eval/evaluate.scm 425 */
										if (PAIRP(BgL_cdrzd2249zd2_1475))
											{	/* Eval/evaluate.scm 425 */
												obj_t BgL_carzd2252zd2_1478;
												obj_t BgL_cdrzd2253zd2_1479;

												BgL_carzd2252zd2_1478 = CAR(BgL_cdrzd2249zd2_1475);
												BgL_cdrzd2253zd2_1479 = CDR(BgL_cdrzd2249zd2_1475);
												if (SYMBOLP(BgL_carzd2252zd2_1478))
													{	/* Eval/evaluate.scm 425 */
														if (PAIRP(BgL_cdrzd2253zd2_1479))
															{	/* Eval/evaluate.scm 425 */
																obj_t BgL_carzd2257zd2_1482;

																BgL_carzd2257zd2_1482 =
																	CAR(BgL_cdrzd2253zd2_1479);
																if (SYMBOLP(BgL_carzd2257zd2_1482))
																	{	/* Eval/evaluate.scm 425 */
																		if (NULLP(CDR(BgL_cdrzd2253zd2_1479)))
																			{	/* Eval/evaluate.scm 438 */
																				BgL_ev_globalz00_bglt
																					BgL_new1105z00_3938;
																				{	/* Eval/evaluate.scm 439 */
																					BgL_ev_globalz00_bglt
																						BgL_new1104z00_3939;
																					BgL_new1104z00_3939 =
																						((BgL_ev_globalz00_bglt)
																						BREF(GC_MALLOC(sizeof(struct
																									BgL_ev_globalz00_bgl))));
																					{	/* Eval/evaluate.scm 439 */
																						long BgL_arg2142z00_3940;

																						{	/* Eval/evaluate.scm 439 */
																							long BgL_res2762z00_3942;

																							BgL_res2762z00_3942 =
																								BGL_CLASS_INDEX
																								(BGl_ev_globalz00zz__evaluate_typesz00);
																							BgL_arg2142z00_3940 =
																								BgL_res2762z00_3942;
																						}
																						BGL_OBJECT_CLASS_NUM_SET(
																							((BgL_objectz00_bglt)
																								BgL_new1104z00_3939),
																							BgL_arg2142z00_3940);
																					}
																					{	/* Eval/evaluate.scm 439 */
																						BgL_objectz00_bglt BgL_auxz00_5607;

																						BgL_auxz00_5607 =
																							((BgL_objectz00_bglt)
																							BgL_new1104z00_3939);
																						BGL_OBJECT_WIDENING_SET
																							(BgL_auxz00_5607, BFALSE);
																					}
																					BgL_new1105z00_3938 =
																						BgL_new1104z00_3939;
																				}
																				((((BgL_ev_globalz00_bglt)
																							CREF(BgL_new1105z00_3938))->
																						BgL_locz00) =
																					((obj_t) BgL_locz00_74), BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							CREF(BgL_new1105z00_3938))->
																						BgL_namez00) =
																					((obj_t) BgL_carzd2252zd2_1478),
																					BUNSPEC);
																				((((BgL_ev_globalz00_bglt)
																							CREF(BgL_new1105z00_3938))->
																						BgL_modz00) =
																					((obj_t)
																						BGl_evalzd2findzd2modulez00zz__evmodulez00
																						(BgL_carzd2257zd2_1482)), BUNSPEC);
																				return ((obj_t) BgL_new1105z00_3938);
																			}
																		else
																			{	/* Eval/evaluate.scm 425 */
																				obj_t BgL_carzd2302zd2_1485;

																				BgL_carzd2302zd2_1485 =
																					CAR(BgL_ez00_69);
																				if (SYMBOLP(BgL_carzd2302zd2_1485))
																					{	/* Eval/evaluate.scm 425 */
																						if (CBOOL
																							(BGl_convzd2varzd2zz__evaluatez00
																								(BgL_carzd2302zd2_1485,
																									BgL_localsz00_70)))
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5621;
																								BgL_funz00_1401 =
																									BgL_carzd2302zd2_1485;
																								BgL_argsz00_1402 =
																									BgL_cdrzd2249zd2_1475;
																							BgL_tagzd2152zd2_1403:
																								{	/* Eval/evaluate.scm 450 */
																									obj_t BgL_funz00_2176;
																									obj_t BgL_argsz00_2177;

																									{	/* Eval/evaluate.scm 381 */
																										obj_t BgL_arg2308z00_3316;

																										{	/* Eval/evaluate.scm 145 */
																											obj_t
																												BgL__ortest_1067z00_3319;
																											BgL__ortest_1067z00_3319 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_funz00_1401);
																											if (CBOOL
																												(BgL__ortest_1067z00_3319))
																												{	/* Eval/evaluate.scm 145 */
																													BgL_arg2308z00_3316 =
																														BgL__ortest_1067z00_3319;
																												}
																											else
																												{	/* Eval/evaluate.scm 145 */
																													BgL_arg2308z00_3316 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2176 =
																											BGl_convz00zz__evaluatez00
																											(BgL_funz00_1401,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2308z00_3316,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2177 =
																										BGl_loopz00zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1402);
																									{	/* Eval/evaluate.scm 451 */
																										BgL_ev_appz00_bglt
																											BgL_new1107z00_2178;
																										{	/* Eval/evaluate.scm 452 */
																											BgL_ev_appz00_bglt
																												BgL_new1106z00_2179;
																											BgL_new1106z00_2179 =
																												((BgL_ev_appz00_bglt)
																												BREF(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 452 */
																												long
																													BgL_arg2152z00_2180;
																												{	/* Eval/evaluate.scm 452 */
																													long
																														BgL_res2681z00_3323;
																													BgL_res2681z00_3323 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg2152z00_2180 =
																														BgL_res2681z00_3323;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1106z00_2179),
																													BgL_arg2152z00_2180);
																											}
																											{	/* Eval/evaluate.scm 452 */
																												BgL_objectz00_bglt
																													BgL_auxz00_5631;
																												BgL_auxz00_5631 =
																													((BgL_objectz00_bglt)
																													BgL_new1106z00_2179);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_auxz00_5631,
																													BFALSE);
																											}
																											BgL_new1107z00_2178 =
																												BgL_new1106z00_2179;
																										}
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_2178))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_2178))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2176)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_2178))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2177),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1107z00_2178))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5621 =
																											BgL_new1107z00_2178;
																								}}
																								return
																									((obj_t) BgL_auxz00_5621);
																							}
																						else
																							{
																								BgL_ev_appz00_bglt
																									BgL_auxz00_5640;
																								BgL_fz00_1467 =
																									BgL_carzd2302zd2_1485;
																								BgL_argsz00_1468 =
																									BgL_cdrzd2249zd2_1475;
																							BgL_tagzd2175zd2_1469:
																								{	/* Eval/evaluate.scm 598 */
																									obj_t BgL_funz00_2427;
																									obj_t BgL_argsz00_2428;

																									{	/* Eval/evaluate.scm 381 */
																										obj_t BgL_arg2308z00_3906;

																										{	/* Eval/evaluate.scm 145 */
																											obj_t
																												BgL__ortest_1067z00_3909;
																											BgL__ortest_1067z00_3909 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_fz00_1467);
																											if (CBOOL
																												(BgL__ortest_1067z00_3909))
																												{	/* Eval/evaluate.scm 145 */
																													BgL_arg2308z00_3906 =
																														BgL__ortest_1067z00_3909;
																												}
																											else
																												{	/* Eval/evaluate.scm 145 */
																													BgL_arg2308z00_3906 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_funz00_2427 =
																											BGl_convz00zz__evaluatez00
																											(BgL_fz00_1467,
																											BgL_localsz00_70,
																											BgL_globalsz00_71, BFALSE,
																											BgL_wherez00_73,
																											BgL_arg2308z00_3906,
																											((bool_t) 0));
																									}
																									BgL_argsz00_2428 =
																										BGl_loopz00zz__evaluatez00
																										(BgL_wherez00_73,
																										BgL_globalsz00_71,
																										BgL_localsz00_70,
																										BgL_locz00_74,
																										BgL_argsz00_1468);
																									{	/* Eval/evaluate.scm 599 */
																										BgL_ev_appz00_bglt
																											BgL_new1161z00_2429;
																										{	/* Eval/evaluate.scm 600 */
																											BgL_ev_appz00_bglt
																												BgL_new1160z00_2430;
																											BgL_new1160z00_2430 =
																												((BgL_ev_appz00_bglt)
																												BREF(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_appz00_bgl))));
																											{	/* Eval/evaluate.scm 600 */
																												long
																													BgL_arg2271z00_2431;
																												{	/* Eval/evaluate.scm 600 */
																													long
																														BgL_res2755z00_3913;
																													BgL_res2755z00_3913 =
																														BGL_CLASS_INDEX
																														(BGl_ev_appz00zz__evaluate_typesz00);
																													BgL_arg2271z00_2431 =
																														BgL_res2755z00_3913;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1160z00_2430),
																													BgL_arg2271z00_2431);
																											}
																											{	/* Eval/evaluate.scm 600 */
																												BgL_objectz00_bglt
																													BgL_auxz00_5650;
																												BgL_auxz00_5650 =
																													((BgL_objectz00_bglt)
																													BgL_new1160z00_2430);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_auxz00_5650,
																													BFALSE);
																											}
																											BgL_new1161z00_2429 =
																												BgL_new1160z00_2430;
																										}
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1161z00_2429))->
																												BgL_locz00) =
																											((obj_t) BgL_locz00_74),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1161z00_2429))->
																												BgL_funz00) =
																											((BgL_ev_exprz00_bglt) (
																													(BgL_ev_exprz00_bglt)
																													BgL_funz00_2427)),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1161z00_2429))->
																												BgL_argsz00) =
																											((obj_t)
																												BgL_argsz00_2428),
																											BUNSPEC);
																										((((BgL_ev_appz00_bglt)
																													CREF
																													(BgL_new1161z00_2429))->
																												BgL_tailzf3zf3) =
																											((obj_t)
																												BgL_tailzf3zf3_72),
																											BUNSPEC);
																										BgL_auxz00_5640 =
																											BgL_new1161z00_2429;
																								}}
																								return
																									((obj_t) BgL_auxz00_5640);
																							}
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5659;

																						{
																							obj_t BgL_argsz00_5661;
																							obj_t BgL_fz00_5660;

																							BgL_fz00_5660 =
																								BgL_carzd2302zd2_1485;
																							BgL_argsz00_5661 =
																								BgL_cdrzd2249zd2_1475;
																							BgL_argsz00_1468 =
																								BgL_argsz00_5661;
																							BgL_fz00_1467 = BgL_fz00_5660;
																							goto BgL_tagzd2175zd2_1469;
																						}
																						return ((obj_t) BgL_auxz00_5659);
																					}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 425 */
																		obj_t BgL_carzd21005zd2_1495;

																		BgL_carzd21005zd2_1495 = CAR(BgL_ez00_69);
																		if (SYMBOLP(BgL_carzd21005zd2_1495))
																			{	/* Eval/evaluate.scm 425 */
																				if (CBOOL
																					(BGl_convzd2varzd2zz__evaluatez00
																						(BgL_carzd21005zd2_1495,
																							BgL_localsz00_70)))
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5669;

																						{
																							obj_t BgL_argsz00_5671;
																							obj_t BgL_funz00_5670;

																							BgL_funz00_5670 =
																								BgL_carzd21005zd2_1495;
																							BgL_argsz00_5671 =
																								BgL_cdrzd2249zd2_1475;
																							BgL_argsz00_1402 =
																								BgL_argsz00_5671;
																							BgL_funz00_1401 = BgL_funz00_5670;
																							goto BgL_tagzd2152zd2_1403;
																						}
																						return ((obj_t) BgL_auxz00_5669);
																					}
																				else
																					{
																						BgL_ev_appz00_bglt BgL_auxz00_5673;

																						{
																							obj_t BgL_argsz00_5675;
																							obj_t BgL_fz00_5674;

																							BgL_fz00_5674 =
																								BgL_carzd21005zd2_1495;
																							BgL_argsz00_5675 =
																								BgL_cdrzd2249zd2_1475;
																							BgL_argsz00_1468 =
																								BgL_argsz00_5675;
																							BgL_fz00_1467 = BgL_fz00_5674;
																							goto BgL_tagzd2175zd2_1469;
																						}
																						return ((obj_t) BgL_auxz00_5673);
																					}
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5677;

																				{
																					obj_t BgL_argsz00_5679;
																					obj_t BgL_fz00_5678;

																					BgL_fz00_5678 =
																						BgL_carzd21005zd2_1495;
																					BgL_argsz00_5679 =
																						BgL_cdrzd2249zd2_1475;
																					BgL_argsz00_1468 = BgL_argsz00_5679;
																					BgL_fz00_1467 = BgL_fz00_5678;
																					goto BgL_tagzd2175zd2_1469;
																				}
																				return ((obj_t) BgL_auxz00_5677);
																			}
																	}
															}
														else
															{	/* Eval/evaluate.scm 425 */
																obj_t BgL_carzd21708zd2_1504;

																BgL_carzd21708zd2_1504 = CAR(BgL_ez00_69);
																if (SYMBOLP(BgL_carzd21708zd2_1504))
																	{	/* Eval/evaluate.scm 425 */
																		if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																				(BgL_carzd21708zd2_1504,
																					BgL_localsz00_70)))
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5687;

																				{
																					obj_t BgL_argsz00_5689;
																					obj_t BgL_funz00_5688;

																					BgL_funz00_5688 =
																						BgL_carzd21708zd2_1504;
																					BgL_argsz00_5689 =
																						BgL_cdrzd2249zd2_1475;
																					BgL_argsz00_1402 = BgL_argsz00_5689;
																					BgL_funz00_1401 = BgL_funz00_5688;
																					goto BgL_tagzd2152zd2_1403;
																				}
																				return ((obj_t) BgL_auxz00_5687);
																			}
																		else
																			{
																				BgL_ev_appz00_bglt BgL_auxz00_5691;

																				{
																					obj_t BgL_argsz00_5693;
																					obj_t BgL_fz00_5692;

																					BgL_fz00_5692 =
																						BgL_carzd21708zd2_1504;
																					BgL_argsz00_5693 =
																						BgL_cdrzd2249zd2_1475;
																					BgL_argsz00_1468 = BgL_argsz00_5693;
																					BgL_fz00_1467 = BgL_fz00_5692;
																					goto BgL_tagzd2175zd2_1469;
																				}
																				return ((obj_t) BgL_auxz00_5691);
																			}
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5695;

																		{
																			obj_t BgL_argsz00_5697;
																			obj_t BgL_fz00_5696;

																			BgL_fz00_5696 = BgL_carzd21708zd2_1504;
																			BgL_argsz00_5697 = BgL_cdrzd2249zd2_1475;
																			BgL_argsz00_1468 = BgL_argsz00_5697;
																			BgL_fz00_1467 = BgL_fz00_5696;
																			goto BgL_tagzd2175zd2_1469;
																		}
																		return ((obj_t) BgL_auxz00_5695);
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 425 */
														obj_t BgL_carzd22411zd2_1513;

														BgL_carzd22411zd2_1513 = CAR(BgL_ez00_69);
														if (SYMBOLP(BgL_carzd22411zd2_1513))
															{	/* Eval/evaluate.scm 425 */
																if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																		(BgL_carzd22411zd2_1513, BgL_localsz00_70)))
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5705;

																		{
																			obj_t BgL_argsz00_5707;
																			obj_t BgL_funz00_5706;

																			BgL_funz00_5706 = BgL_carzd22411zd2_1513;
																			BgL_argsz00_5707 = BgL_cdrzd2249zd2_1475;
																			BgL_argsz00_1402 = BgL_argsz00_5707;
																			BgL_funz00_1401 = BgL_funz00_5706;
																			goto BgL_tagzd2152zd2_1403;
																		}
																		return ((obj_t) BgL_auxz00_5705);
																	}
																else
																	{
																		BgL_ev_appz00_bglt BgL_auxz00_5709;

																		{
																			obj_t BgL_argsz00_5711;
																			obj_t BgL_fz00_5710;

																			BgL_fz00_5710 = BgL_carzd22411zd2_1513;
																			BgL_argsz00_5711 = BgL_cdrzd2249zd2_1475;
																			BgL_argsz00_1468 = BgL_argsz00_5711;
																			BgL_fz00_1467 = BgL_fz00_5710;
																			goto BgL_tagzd2175zd2_1469;
																		}
																		return ((obj_t) BgL_auxz00_5709);
																	}
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5713;

																{
																	obj_t BgL_argsz00_5715;
																	obj_t BgL_fz00_5714;

																	BgL_fz00_5714 = BgL_carzd22411zd2_1513;
																	BgL_argsz00_5715 = BgL_cdrzd2249zd2_1475;
																	BgL_argsz00_1468 = BgL_argsz00_5715;
																	BgL_fz00_1467 = BgL_fz00_5714;
																	goto BgL_tagzd2175zd2_1469;
																}
																return ((obj_t) BgL_auxz00_5713);
															}
													}
											}
										else
											{	/* Eval/evaluate.scm 425 */
												obj_t BgL_carzd23114zd2_1522;

												BgL_carzd23114zd2_1522 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23114zd2_1522))
													{	/* Eval/evaluate.scm 425 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23114zd2_1522, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5723;

																{
																	obj_t BgL_argsz00_5725;
																	obj_t BgL_funz00_5724;

																	BgL_funz00_5724 = BgL_carzd23114zd2_1522;
																	BgL_argsz00_5725 = BgL_cdrzd2249zd2_1475;
																	BgL_argsz00_1402 = BgL_argsz00_5725;
																	BgL_funz00_1401 = BgL_funz00_5724;
																	goto BgL_tagzd2152zd2_1403;
																}
																return ((obj_t) BgL_auxz00_5723);
															}
														else
															{
																BgL_ev_appz00_bglt BgL_auxz00_5727;

																{
																	obj_t BgL_argsz00_5729;
																	obj_t BgL_fz00_5728;

																	BgL_fz00_5728 = BgL_carzd23114zd2_1522;
																	BgL_argsz00_5729 = BgL_cdrzd2249zd2_1475;
																	BgL_argsz00_1468 = BgL_argsz00_5729;
																	BgL_fz00_1467 = BgL_fz00_5728;
																	goto BgL_tagzd2175zd2_1469;
																}
																return ((obj_t) BgL_auxz00_5727);
															}
													}
												else
													{
														BgL_ev_appz00_bglt BgL_auxz00_5731;

														{
															obj_t BgL_argsz00_5733;
															obj_t BgL_fz00_5732;

															BgL_fz00_5732 = BgL_carzd23114zd2_1522;
															BgL_argsz00_5733 = BgL_cdrzd2249zd2_1475;
															BgL_argsz00_1468 = BgL_argsz00_5733;
															BgL_fz00_1467 = BgL_fz00_5732;
															goto BgL_tagzd2175zd2_1469;
														}
														return ((obj_t) BgL_auxz00_5731);
													}
											}
									}
								else
									{	/* Eval/evaluate.scm 425 */
										if ((CAR(BgL_ez00_69) == BGl_symbol3036z00zz__evaluatez00))
											{	/* Eval/evaluate.scm 425 */
												BgL_lz00_1399 = BgL_cdrzd2249zd2_1475;
												{	/* Eval/evaluate.scm 443 */
													bool_t BgL_testz00_5738;

													if (PAIRP(BgL_lz00_1399))
														{	/* Eval/evaluate.scm 443 */
															bool_t BgL_testz00_5741;

															{	/* Eval/evaluate.scm 443 */
																obj_t BgL_auxz00_5742;

																BgL_auxz00_5742 = CDR(BgL_lz00_1399);
																BgL_testz00_5741 = PAIRP(BgL_auxz00_5742);
															}
															if (BgL_testz00_5741)
																{
																	obj_t BgL_l1204z00_2167;

																	BgL_l1204z00_2167 = BgL_lz00_1399;
																BgL_zc3anonymousza32146ze3z83_2168:
																	if (NULLP(BgL_l1204z00_2167))
																		{	/* Eval/evaluate.scm 443 */
																			BgL_testz00_5738 = ((bool_t) 1);
																		}
																	else
																		{	/* Eval/evaluate.scm 443 */
																			bool_t BgL_testz00_5747;

																			{	/* Eval/evaluate.scm 443 */
																				obj_t BgL_auxz00_5748;

																				BgL_auxz00_5748 =
																					CAR(BgL_l1204z00_2167);
																				BgL_testz00_5747 =
																					SYMBOLP(BgL_auxz00_5748);
																			}
																			if (BgL_testz00_5747)
																				{
																					obj_t BgL_l1204z00_5751;

																					BgL_l1204z00_5751 =
																						CDR(BgL_l1204z00_2167);
																					BgL_l1204z00_2167 = BgL_l1204z00_5751;
																					goto
																						BgL_zc3anonymousza32146ze3z83_2168;
																				}
																			else
																				{	/* Eval/evaluate.scm 443 */
																					BgL_testz00_5738 = ((bool_t) 0);
																				}
																		}
																}
															else
																{	/* Eval/evaluate.scm 443 */
																	BgL_testz00_5738 = ((bool_t) 0);
																}
														}
													else
														{	/* Eval/evaluate.scm 443 */
															BgL_testz00_5738 = ((bool_t) 0);
														}
													if (BgL_testz00_5738)
														{	/* Eval/evaluate.scm 443 */
															return
																BGl_convzd2fieldzd2refz00zz__evaluatez00
																(BgL_ez00_69, BgL_localsz00_70,
																BgL_globalsz00_71, BgL_tailzf3zf3_72,
																BgL_wherez00_73, BgL_locz00_74,
																BgL_topzf3zf3_75);
														}
													else
														{	/* Eval/evaluate.scm 443 */
															return
																BGl_evcompilezd2errorzd2zz__evcompilez00
																(BgL_locz00_74,
																BGl_string2951z00zz__evaluatez00,
																BGl_string3026z00zz__evaluatez00, BgL_ez00_69);
														}
												}
											}
										else
											{	/* Eval/evaluate.scm 425 */
												obj_t BgL_carzd23820zd2_1533;

												BgL_carzd23820zd2_1533 = CAR(BgL_ez00_69);
												if (SYMBOLP(BgL_carzd23820zd2_1533))
													{	/* Eval/evaluate.scm 425 */
														if (CBOOL(BGl_convzd2varzd2zz__evaluatez00
																(BgL_carzd23820zd2_1533, BgL_localsz00_70)))
															{
																BgL_ev_appz00_bglt BgL_auxz00_5761;

																{
																	obj_t BgL_argsz00_5763;
																	obj_t BgL_funz00_5762;

																	BgL_funz00_5762 = BgL_carzd23820zd2_1533;
																	BgL_argsz00_5763 = BgL_cdrzd2249zd2_1475;
																	BgL_argsz00_1402 = BgL_argsz00_5763;
																	BgL_funz00_1401 = BgL_funz00_5762;
																	goto BgL_tagzd2152zd2_1403;
																}
																return ((obj_t) BgL_auxz00_5761);
															}
														else
															{	/* Eval/evaluate.scm 425 */
																if (
																	(BgL_carzd23820zd2_1533 ==
																		BGl_symbol3038z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 425 */
																		if (PAIRP(BgL_cdrzd2249zd2_1475))
																			{	/* Eval/evaluate.scm 425 */
																				if (NULLP(CDR(BgL_cdrzd2249zd2_1475)))
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_arg1585z00_1541;

																						BgL_arg1585z00_1541 =
																							CAR(BgL_cdrzd2249zd2_1475);
																						{
																							BgL_ev_trapz00_bglt
																								BgL_auxz00_5773;
																							BgL_ez00_1404 =
																								BgL_arg1585z00_1541;
																						BgL_tagzd2153zd2_1405:
																							{	/* Eval/evaluate.scm 457 */
																								BgL_ev_trapz00_bglt
																									BgL_new1109z00_2181;
																								{	/* Eval/evaluate.scm 458 */
																									BgL_ev_trapz00_bglt
																										BgL_new1108z00_2182;
																									BgL_new1108z00_2182 =
																										((BgL_ev_trapz00_bglt)
																										BREF(GC_MALLOC(sizeof(struct
																													BgL_ev_trapz00_bgl))));
																									{	/* Eval/evaluate.scm 458 */
																										long BgL_arg2153z00_2183;

																										{	/* Eval/evaluate.scm 458 */
																											long BgL_res2682z00_3327;

																											BgL_res2682z00_3327 =
																												BGL_CLASS_INDEX
																												(BGl_ev_trapz00zz__evaluate_typesz00);
																											BgL_arg2153z00_2183 =
																												BgL_res2682z00_3327;
																										}
																										BGL_OBJECT_CLASS_NUM_SET(
																											((BgL_objectz00_bglt)
																												BgL_new1108z00_2182),
																											BgL_arg2153z00_2183);
																									}
																									{	/* Eval/evaluate.scm 458 */
																										BgL_objectz00_bglt
																											BgL_auxz00_5778;
																										BgL_auxz00_5778 =
																											((BgL_objectz00_bglt)
																											BgL_new1108z00_2182);
																										BGL_OBJECT_WIDENING_SET
																											(BgL_auxz00_5778, BFALSE);
																									}
																									BgL_new1109z00_2181 =
																										BgL_new1108z00_2182;
																								}
																								{
																									BgL_ev_exprz00_bglt
																										BgL_auxz00_5781;
																									{	/* Eval/evaluate.scm 381 */
																										obj_t BgL_arg2308z00_3331;

																										{	/* Eval/evaluate.scm 145 */
																											obj_t
																												BgL__ortest_1067z00_3334;
																											BgL__ortest_1067z00_3334 =
																												BGl_getzd2sourcezd2locationz00zz__readerz00
																												(BgL_ez00_1404);
																											if (CBOOL
																												(BgL__ortest_1067z00_3334))
																												{	/* Eval/evaluate.scm 145 */
																													BgL_arg2308z00_3331 =
																														BgL__ortest_1067z00_3334;
																												}
																											else
																												{	/* Eval/evaluate.scm 145 */
																													BgL_arg2308z00_3331 =
																														BgL_locz00_74;
																												}
																										}
																										BgL_auxz00_5781 =
																											((BgL_ev_exprz00_bglt)
																											BGl_convz00zz__evaluatez00
																											(BgL_ez00_1404,
																												BgL_localsz00_70,
																												BgL_globalsz00_71,
																												BFALSE, BgL_wherez00_73,
																												BgL_arg2308z00_3331,
																												((bool_t) 0)));
																									}
																									((((BgL_ev_hookz00_bglt) CREF(
																													((BgL_ev_hookz00_bglt)
																														BgL_new1109z00_2181)))->
																											BgL_ez00) =
																										((BgL_ev_exprz00_bglt)
																											BgL_auxz00_5781),
																										BUNSPEC);
																								}
																								BgL_auxz00_5773 =
																									BgL_new1109z00_2181;
																							}
																							return ((obj_t) BgL_auxz00_5773);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_arg1587z00_1542;
																						obj_t BgL_arg1591z00_1543;

																						BgL_arg1587z00_1542 =
																							CAR(BgL_ez00_69);
																						BgL_arg1591z00_1543 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5792;
																							{
																								obj_t BgL_argsz00_5794;
																								obj_t BgL_fz00_5793;

																								BgL_fz00_5793 =
																									BgL_arg1587z00_1542;
																								BgL_argsz00_5794 =
																									BgL_arg1591z00_1543;
																								BgL_argsz00_1468 =
																									BgL_argsz00_5794;
																								BgL_fz00_1467 = BgL_fz00_5793;
																								goto BgL_tagzd2175zd2_1469;
																							}
																							return ((obj_t) BgL_auxz00_5792);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 425 */
																				obj_t BgL_arg1595z00_1545;
																				obj_t BgL_arg1606z00_1546;

																				BgL_arg1595z00_1545 = CAR(BgL_ez00_69);
																				BgL_arg1606z00_1546 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_5798;

																					{
																						obj_t BgL_argsz00_5800;
																						obj_t BgL_fz00_5799;

																						BgL_fz00_5799 = BgL_arg1595z00_1545;
																						BgL_argsz00_5800 =
																							BgL_arg1606z00_1546;
																						BgL_argsz00_1468 = BgL_argsz00_5800;
																						BgL_fz00_1467 = BgL_fz00_5799;
																						goto BgL_tagzd2175zd2_1469;
																					}
																					return ((obj_t) BgL_auxz00_5798);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 425 */
																		obj_t BgL_cdrzd24489zd2_1547;

																		BgL_cdrzd24489zd2_1547 = CDR(BgL_ez00_69);
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol3003z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 425 */
																				if (PAIRP(BgL_cdrzd24489zd2_1547))
																					{	/* Eval/evaluate.scm 425 */
																						if (NULLP(CDR
																								(BgL_cdrzd24489zd2_1547)))
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_arg1610z00_1551;

																								BgL_arg1610z00_1551 =
																									CAR(BgL_cdrzd24489zd2_1547);
																								{	/* Eval/evaluate.scm 460 */
																									BgL_ev_littz00_bglt
																										BgL_new1112z00_4012;
																									{	/* Eval/evaluate.scm 461 */
																										BgL_ev_littz00_bglt
																											BgL_new1110z00_4013;
																										BgL_new1110z00_4013 =
																											((BgL_ev_littz00_bglt)
																											BREF(GC_MALLOC(sizeof
																													(struct
																														BgL_ev_littz00_bgl))));
																										{	/* Eval/evaluate.scm 461 */
																											long BgL_arg2154z00_4014;

																											{	/* Eval/evaluate.scm 461 */
																												long
																													BgL_res2773z00_4016;
																												BgL_res2773z00_4016 =
																													BGL_CLASS_INDEX
																													(BGl_ev_littz00zz__evaluate_typesz00);
																												BgL_arg2154z00_4014 =
																													BgL_res2773z00_4016;
																											}
																											BGL_OBJECT_CLASS_NUM_SET(
																												((BgL_objectz00_bglt)
																													BgL_new1110z00_4013),
																												BgL_arg2154z00_4014);
																										}
																										{	/* Eval/evaluate.scm 461 */
																											BgL_objectz00_bglt
																												BgL_auxz00_5816;
																											BgL_auxz00_5816 =
																												((BgL_objectz00_bglt)
																												BgL_new1110z00_4013);
																											BGL_OBJECT_WIDENING_SET
																												(BgL_auxz00_5816,
																												BFALSE);
																										}
																										BgL_new1112z00_4012 =
																											BgL_new1110z00_4013;
																									}
																									((((BgL_ev_littz00_bglt)
																												CREF
																												(BgL_new1112z00_4012))->
																											BgL_valuez00) =
																										((obj_t)
																											BgL_arg1610z00_1551),
																										BUNSPEC);
																									return ((obj_t)
																										BgL_new1112z00_4012);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_arg1611z00_1552;

																								BgL_arg1611z00_1552 =
																									CAR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5822;
																									{
																										obj_t BgL_argsz00_5824;
																										obj_t BgL_fz00_5823;

																										BgL_fz00_5823 =
																											BgL_arg1611z00_1552;
																										BgL_argsz00_5824 =
																											BgL_cdrzd24489zd2_1547;
																										BgL_argsz00_1468 =
																											BgL_argsz00_5824;
																										BgL_fz00_1467 =
																											BgL_fz00_5823;
																										goto BgL_tagzd2175zd2_1469;
																									}
																									return
																										((obj_t) BgL_auxz00_5822);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_arg1614z00_1555;

																						BgL_arg1614z00_1555 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_5827;
																							{
																								obj_t BgL_argsz00_5829;
																								obj_t BgL_fz00_5828;

																								BgL_fz00_5828 =
																									BgL_arg1614z00_1555;
																								BgL_argsz00_5829 =
																									BgL_cdrzd24489zd2_1547;
																								BgL_argsz00_1468 =
																									BgL_argsz00_5829;
																								BgL_fz00_1467 = BgL_fz00_5828;
																								goto BgL_tagzd2175zd2_1469;
																							}
																							return ((obj_t) BgL_auxz00_5827);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 425 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol3011z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 425 */
																						if (PAIRP(BgL_cdrzd24489zd2_1547))
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_cdrzd25099zd2_1560;

																								BgL_cdrzd25099zd2_1560 =
																									CDR(BgL_cdrzd24489zd2_1547);
																								if (PAIRP
																									(BgL_cdrzd25099zd2_1560))
																									{	/* Eval/evaluate.scm 425 */
																										obj_t
																											BgL_cdrzd25104zd2_1562;
																										BgL_cdrzd25104zd2_1562 =
																											CDR
																											(BgL_cdrzd25099zd2_1560);
																										if (PAIRP
																											(BgL_cdrzd25104zd2_1562))
																											{	/* Eval/evaluate.scm 425 */
																												if (NULLP(CDR
																														(BgL_cdrzd25104zd2_1562)))
																													{	/* Eval/evaluate.scm 425 */
																														obj_t
																															BgL_arg1621z00_1565;
																														obj_t
																															BgL_arg1623z00_1566;
																														obj_t
																															BgL_arg1624z00_1567;
																														BgL_arg1621z00_1565
																															=
																															CAR
																															(BgL_cdrzd24489zd2_1547);
																														BgL_arg1623z00_1566
																															=
																															CAR
																															(BgL_cdrzd25099zd2_1560);
																														BgL_arg1624z00_1567
																															=
																															CAR
																															(BgL_cdrzd25104zd2_1562);
																														{
																															BgL_ev_ifz00_bglt
																																BgL_auxz00_5848;
																															BgL_pz00_1408 =
																																BgL_arg1621z00_1565;
																															BgL_tz00_1409 =
																																BgL_arg1623z00_1566;
																															BgL_oz00_1410 =
																																BgL_arg1624z00_1567;
																														BgL_tagzd2155zd2_1411:
																															{	/* Eval/evaluate.scm 463 */
																																BgL_ev_ifz00_bglt
																																	BgL_new1114z00_2187;
																																{	/* Eval/evaluate.scm 464 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1113z00_2191;
																																	BgL_new1113z00_2191
																																		=
																																		(
																																		(BgL_ev_ifz00_bglt)
																																		BREF
																																		(GC_MALLOC
																																			(sizeof
																																				(struct
																																					BgL_ev_ifz00_bgl))));
																																	{	/* Eval/evaluate.scm 464 */
																																		long
																																			BgL_arg2159z00_2192;
																																		{	/* Eval/evaluate.scm 464 */
																																			long
																																				BgL_res2684z00_3345;
																																			BgL_res2684z00_3345
																																				=
																																				BGL_CLASS_INDEX
																																				(BGl_ev_ifz00zz__evaluate_typesz00);
																																			BgL_arg2159z00_2192
																																				=
																																				BgL_res2684z00_3345;
																																		}
																																		BGL_OBJECT_CLASS_NUM_SET
																																			(((BgL_objectz00_bglt) BgL_new1113z00_2191), BgL_arg2159z00_2192);
																																	}
																																	{	/* Eval/evaluate.scm 464 */
																																		BgL_objectz00_bglt
																																			BgL_auxz00_5853;
																																		BgL_auxz00_5853
																																			=
																																			(
																																			(BgL_objectz00_bglt)
																																			BgL_new1113z00_2191);
																																		BGL_OBJECT_WIDENING_SET
																																			(BgL_auxz00_5853,
																																			BFALSE);
																																	}
																																	BgL_new1114z00_2187
																																		=
																																		BgL_new1113z00_2191;
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5856;
																																	{	/* Eval/evaluate.scm 464 */
																																		obj_t
																																			BgL_arg2155z00_2188;
																																		{	/* Eval/evaluate.scm 145 */
																																			obj_t
																																				BgL__ortest_1067z00_3350;
																																			BgL__ortest_1067z00_3350
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_pz00_1408);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_3350))
																																				{	/* Eval/evaluate.scm 145 */
																																					BgL_arg2155z00_2188
																																						=
																																						BgL__ortest_1067z00_3350;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 145 */
																																					BgL_arg2155z00_2188
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5856
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_pz00_1408,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BFALSE,
																																				BgL_wherez00_73,
																																				BgL_arg2155z00_2188,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) CREF(BgL_new1114z00_2187))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5856), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5863;
																																	{	/* Eval/evaluate.scm 465 */
																																		obj_t
																																			BgL_arg2157z00_2189;
																																		{	/* Eval/evaluate.scm 145 */
																																			obj_t
																																				BgL__ortest_1067z00_3355;
																																			BgL__ortest_1067z00_3355
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_tz00_1409);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_3355))
																																				{	/* Eval/evaluate.scm 145 */
																																					BgL_arg2157z00_2189
																																						=
																																						BgL__ortest_1067z00_3355;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 145 */
																																					BgL_arg2157z00_2189
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5863
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_tz00_1409,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2157z00_2189,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) CREF(BgL_new1114z00_2187))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5863), BUNSPEC);
																																}
																																{
																																	BgL_ev_exprz00_bglt
																																		BgL_auxz00_5870;
																																	{	/* Eval/evaluate.scm 466 */
																																		obj_t
																																			BgL_arg2158z00_2190;
																																		{	/* Eval/evaluate.scm 145 */
																																			obj_t
																																				BgL__ortest_1067z00_3360;
																																			BgL__ortest_1067z00_3360
																																				=
																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																				(BgL_oz00_1410);
																																			if (CBOOL
																																				(BgL__ortest_1067z00_3360))
																																				{	/* Eval/evaluate.scm 145 */
																																					BgL_arg2158z00_2190
																																						=
																																						BgL__ortest_1067z00_3360;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 145 */
																																					BgL_arg2158z00_2190
																																						=
																																						BgL_locz00_74;
																																				}
																																		}
																																		BgL_auxz00_5870
																																			=
																																			(
																																			(BgL_ev_exprz00_bglt)
																																			BGl_convz00zz__evaluatez00
																																			(BgL_oz00_1410,
																																				BgL_localsz00_70,
																																				BgL_globalsz00_71,
																																				BgL_tailzf3zf3_72,
																																				BgL_wherez00_73,
																																				BgL_arg2158z00_2190,
																																				((bool_t) 0)));
																																	}
																																	((((BgL_ev_ifz00_bglt) CREF(BgL_new1114z00_2187))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5870), BUNSPEC);
																																}
																																BgL_auxz00_5848
																																	=
																																	BgL_new1114z00_2187;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5848);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 425 */
																														obj_t
																															BgL_arg1625z00_1568;
																														obj_t
																															BgL_arg1626z00_1569;
																														BgL_arg1625z00_1568
																															=
																															CAR(BgL_ez00_69);
																														BgL_arg1626z00_1569
																															=
																															CDR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_5880;
																															{
																																obj_t
																																	BgL_argsz00_5882;
																																obj_t
																																	BgL_fz00_5881;
																																BgL_fz00_5881 =
																																	BgL_arg1625z00_1568;
																																BgL_argsz00_5882
																																	=
																																	BgL_arg1626z00_1569;
																																BgL_argsz00_1468
																																	=
																																	BgL_argsz00_5882;
																																BgL_fz00_1467 =
																																	BgL_fz00_5881;
																																goto
																																	BgL_tagzd2175zd2_1469;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_5880);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 425 */
																												obj_t
																													BgL_cdrzd25402zd2_1571;
																												BgL_cdrzd25402zd2_1571 =
																													CDR(BgL_ez00_69);
																												{	/* Eval/evaluate.scm 425 */
																													obj_t
																														BgL_cdrzd25408zd2_1572;
																													BgL_cdrzd25408zd2_1572
																														=
																														CDR
																														(BgL_cdrzd25402zd2_1571);
																													if (NULLP(CDR
																															(BgL_cdrzd25408zd2_1572)))
																														{	/* Eval/evaluate.scm 425 */
																															obj_t
																																BgL_arg1630z00_1574;
																															obj_t
																																BgL_arg1631z00_1575;
																															BgL_arg1630z00_1574
																																=
																																CAR
																																(BgL_cdrzd25402zd2_1571);
																															BgL_arg1631z00_1575
																																=
																																CAR
																																(BgL_cdrzd25408zd2_1572);
																															{
																																BgL_ev_ifz00_bglt
																																	BgL_auxz00_5891;
																																BgL_pz00_1412 =
																																	BgL_arg1630z00_1574;
																																BgL_tz00_1413 =
																																	BgL_arg1631z00_1575;
																															BgL_tagzd2156zd2_1414:
																																{	/* Eval/evaluate.scm 468 */
																																	BgL_ev_ifz00_bglt
																																		BgL_new1116z00_2193;
																																	{	/* Eval/evaluate.scm 469 */
																																		BgL_ev_ifz00_bglt
																																			BgL_new1115z00_2197;
																																		BgL_new1115z00_2197
																																			=
																																			(
																																			(BgL_ev_ifz00_bglt)
																																			BREF
																																			(GC_MALLOC
																																				(sizeof
																																					(struct
																																						BgL_ev_ifz00_bgl))));
																																		{	/* Eval/evaluate.scm 469 */
																																			long
																																				BgL_arg2163z00_2198;
																																			{	/* Eval/evaluate.scm 469 */
																																				long
																																					BgL_res2685z00_3364;
																																				BgL_res2685z00_3364
																																					=
																																					BGL_CLASS_INDEX
																																					(BGl_ev_ifz00zz__evaluate_typesz00);
																																				BgL_arg2163z00_2198
																																					=
																																					BgL_res2685z00_3364;
																																			}
																																			BGL_OBJECT_CLASS_NUM_SET
																																				(((BgL_objectz00_bglt) BgL_new1115z00_2197), BgL_arg2163z00_2198);
																																		}
																																		{	/* Eval/evaluate.scm 469 */
																																			BgL_objectz00_bglt
																																				BgL_auxz00_5896;
																																			BgL_auxz00_5896
																																				=
																																				(
																																				(BgL_objectz00_bglt)
																																				BgL_new1115z00_2197);
																																			BGL_OBJECT_WIDENING_SET
																																				(BgL_auxz00_5896,
																																				BFALSE);
																																		}
																																		BgL_new1116z00_2193
																																			=
																																			BgL_new1115z00_2197;
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5899;
																																		{	/* Eval/evaluate.scm 469 */
																																			obj_t
																																				BgL_arg2160z00_2194;
																																			{	/* Eval/evaluate.scm 145 */
																																				obj_t
																																					BgL__ortest_1067z00_3369;
																																				BgL__ortest_1067z00_3369
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_pz00_1412);
																																				if (CBOOL(BgL__ortest_1067z00_3369))
																																					{	/* Eval/evaluate.scm 145 */
																																						BgL_arg2160z00_2194
																																							=
																																							BgL__ortest_1067z00_3369;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 145 */
																																						BgL_arg2160z00_2194
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5899
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_pz00_1412,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BFALSE,
																																					BgL_wherez00_73,
																																					BgL_arg2160z00_2194,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) CREF(BgL_new1116z00_2193))->BgL_pz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5899), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5906;
																																		{	/* Eval/evaluate.scm 470 */
																																			obj_t
																																				BgL_arg2161z00_2195;
																																			{	/* Eval/evaluate.scm 145 */
																																				obj_t
																																					BgL__ortest_1067z00_3374;
																																				BgL__ortest_1067z00_3374
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BgL_tz00_1413);
																																				if (CBOOL(BgL__ortest_1067z00_3374))
																																					{	/* Eval/evaluate.scm 145 */
																																						BgL_arg2161z00_2195
																																							=
																																							BgL__ortest_1067z00_3374;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 145 */
																																						BgL_arg2161z00_2195
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5906
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_tz00_1413,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2161z00_2195,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) CREF(BgL_new1116z00_2193))->BgL_tz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5906), BUNSPEC);
																																	}
																																	{
																																		BgL_ev_exprz00_bglt
																																			BgL_auxz00_5913;
																																		{	/* Eval/evaluate.scm 471 */
																																			obj_t
																																				BgL_arg2162z00_2196;
																																			{	/* Eval/evaluate.scm 145 */
																																				obj_t
																																					BgL__ortest_1067z00_3379;
																																				BgL__ortest_1067z00_3379
																																					=
																																					BGl_getzd2sourcezd2locationz00zz__readerz00
																																					(BFALSE);
																																				if (CBOOL(BgL__ortest_1067z00_3379))
																																					{	/* Eval/evaluate.scm 145 */
																																						BgL_arg2162z00_2196
																																							=
																																							BgL__ortest_1067z00_3379;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 145 */
																																						BgL_arg2162z00_2196
																																							=
																																							BgL_locz00_74;
																																					}
																																			}
																																			BgL_auxz00_5913
																																				=
																																				(
																																				(BgL_ev_exprz00_bglt)
																																				BGl_convz00zz__evaluatez00
																																				(BgL_ez00_69,
																																					BgL_localsz00_70,
																																					BgL_globalsz00_71,
																																					BgL_tailzf3zf3_72,
																																					BgL_wherez00_73,
																																					BgL_arg2162z00_2196,
																																					((bool_t) 0)));
																																		}
																																		((((BgL_ev_ifz00_bglt) CREF(BgL_new1116z00_2193))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_5913), BUNSPEC);
																																	}
																																	BgL_auxz00_5891
																																		=
																																		BgL_new1116z00_2193;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5891);
																															}
																														}
																													else
																														{	/* Eval/evaluate.scm 425 */
																															obj_t
																																BgL_arg1632z00_1576;
																															BgL_arg1632z00_1576
																																=
																																CAR
																																(BgL_ez00_69);
																															{
																																BgL_ev_appz00_bglt
																																	BgL_auxz00_5922;
																																{
																																	obj_t
																																		BgL_argsz00_5924;
																																	obj_t
																																		BgL_fz00_5923;
																																	BgL_fz00_5923
																																		=
																																		BgL_arg1632z00_1576;
																																	BgL_argsz00_5924
																																		=
																																		BgL_cdrzd25402zd2_1571;
																																	BgL_argsz00_1468
																																		=
																																		BgL_argsz00_5924;
																																	BgL_fz00_1467
																																		=
																																		BgL_fz00_5923;
																																	goto
																																		BgL_tagzd2175zd2_1469;
																																}
																																return
																																	((obj_t)
																																	BgL_auxz00_5922);
																															}
																														}
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 425 */
																										obj_t BgL_arg1635z00_1579;
																										obj_t BgL_arg1637z00_1580;

																										BgL_arg1635z00_1579 =
																											CAR(BgL_ez00_69);
																										BgL_arg1637z00_1580 =
																											CDR(BgL_ez00_69);
																										{
																											BgL_ev_appz00_bglt
																												BgL_auxz00_5928;
																											{
																												obj_t BgL_argsz00_5930;
																												obj_t BgL_fz00_5929;

																												BgL_fz00_5929 =
																													BgL_arg1635z00_1579;
																												BgL_argsz00_5930 =
																													BgL_arg1637z00_1580;
																												BgL_argsz00_1468 =
																													BgL_argsz00_5930;
																												BgL_fz00_1467 =
																													BgL_fz00_5929;
																												goto
																													BgL_tagzd2175zd2_1469;
																											}
																											return
																												((obj_t)
																												BgL_auxz00_5928);
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_arg1638z00_1581;
																								obj_t BgL_arg1640z00_1582;

																								BgL_arg1638z00_1581 =
																									CAR(BgL_ez00_69);
																								BgL_arg1640z00_1582 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_5934;
																									{
																										obj_t BgL_argsz00_5936;
																										obj_t BgL_fz00_5935;

																										BgL_fz00_5935 =
																											BgL_arg1638z00_1581;
																										BgL_argsz00_5936 =
																											BgL_arg1640z00_1582;
																										BgL_argsz00_1468 =
																											BgL_argsz00_5936;
																										BgL_fz00_1467 =
																											BgL_fz00_5935;
																										goto BgL_tagzd2175zd2_1469;
																									}
																									return
																										((obj_t) BgL_auxz00_5934);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 425 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol3040z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_arg1642z00_1584;

																								BgL_arg1642z00_1584 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_orz00_bglt
																										BgL_auxz00_5942;
																									BgL_argsz00_1415 =
																										BgL_arg1642z00_1584;
																								BgL_tagzd2157zd2_1416:
																									{	/* Eval/evaluate.scm 473 */
																										BgL_ev_orz00_bglt
																											BgL_new1118z00_2199;
																										{	/* Eval/evaluate.scm 474 */
																											BgL_ev_orz00_bglt
																												BgL_new1117z00_2200;
																											BgL_new1117z00_2200 =
																												((BgL_ev_orz00_bglt)
																												BREF(GC_MALLOC(sizeof
																														(struct
																															BgL_ev_orz00_bgl))));
																											{	/* Eval/evaluate.scm 474 */
																												long
																													BgL_arg2164z00_2201;
																												{	/* Eval/evaluate.scm 474 */
																													long
																														BgL_res2686z00_3383;
																													BgL_res2686z00_3383 =
																														BGL_CLASS_INDEX
																														(BGl_ev_orz00zz__evaluate_typesz00);
																													BgL_arg2164z00_2201 =
																														BgL_res2686z00_3383;
																												}
																												BGL_OBJECT_CLASS_NUM_SET
																													(((BgL_objectz00_bglt)
																														BgL_new1117z00_2200),
																													BgL_arg2164z00_2201);
																											}
																											{	/* Eval/evaluate.scm 474 */
																												BgL_objectz00_bglt
																													BgL_auxz00_5947;
																												BgL_auxz00_5947 =
																													((BgL_objectz00_bglt)
																													BgL_new1117z00_2200);
																												BGL_OBJECT_WIDENING_SET
																													(BgL_auxz00_5947,
																													BFALSE);
																											}
																											BgL_new1118z00_2199 =
																												BgL_new1117z00_2200;
																										}
																										((((BgL_ev_listz00_bglt)
																													CREF((
																															(BgL_ev_listz00_bglt)
																															BgL_new1118z00_2199)))->
																												BgL_argsz00) =
																											((obj_t)
																												BGl_loopz00zz__evaluatez00
																												(BgL_wherez00_73,
																													BgL_globalsz00_71,
																													BgL_localsz00_70,
																													BgL_locz00_74,
																													BgL_argsz00_1415)),
																											BUNSPEC);
																										BgL_auxz00_5942 =
																											BgL_new1118z00_2199;
																									}
																									return
																										((obj_t) BgL_auxz00_5942);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 425 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol3042z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 425 */
																										obj_t BgL_arg1644z00_1586;

																										BgL_arg1644z00_1586 =
																											CDR(BgL_ez00_69);
																										{
																											BgL_ev_andz00_bglt
																												BgL_auxz00_5958;
																											BgL_argsz00_1417 =
																												BgL_arg1644z00_1586;
																										BgL_tagzd2158zd2_1418:
																											{	/* Eval/evaluate.scm 476 */
																												BgL_ev_andz00_bglt
																													BgL_new1120z00_2202;
																												{	/* Eval/evaluate.scm 477 */
																													BgL_ev_andz00_bglt
																														BgL_new1119z00_2203;
																													BgL_new1119z00_2203 =
																														(
																														(BgL_ev_andz00_bglt)
																														BREF(GC_MALLOC
																															(sizeof(struct
																																	BgL_ev_andz00_bgl))));
																													{	/* Eval/evaluate.scm 477 */
																														long
																															BgL_arg2165z00_2204;
																														{	/* Eval/evaluate.scm 477 */
																															long
																																BgL_res2687z00_3387;
																															BgL_res2687z00_3387
																																=
																																BGL_CLASS_INDEX
																																(BGl_ev_andz00zz__evaluate_typesz00);
																															BgL_arg2165z00_2204
																																=
																																BgL_res2687z00_3387;
																														}
																														BGL_OBJECT_CLASS_NUM_SET
																															(((BgL_objectz00_bglt) BgL_new1119z00_2203), BgL_arg2165z00_2204);
																													}
																													{	/* Eval/evaluate.scm 477 */
																														BgL_objectz00_bglt
																															BgL_auxz00_5963;
																														BgL_auxz00_5963 =
																															(
																															(BgL_objectz00_bglt)
																															BgL_new1119z00_2203);
																														BGL_OBJECT_WIDENING_SET
																															(BgL_auxz00_5963,
																															BFALSE);
																													}
																													BgL_new1120z00_2202 =
																														BgL_new1119z00_2203;
																												}
																												((((BgL_ev_listz00_bglt)
																															CREF((
																																	(BgL_ev_listz00_bglt)
																																	BgL_new1120z00_2202)))->
																														BgL_argsz00) =
																													((obj_t)
																														BGl_loopz00zz__evaluatez00
																														(BgL_wherez00_73,
																															BgL_globalsz00_71,
																															BgL_localsz00_70,
																															BgL_locz00_74,
																															BgL_argsz00_1417)),
																													BUNSPEC);
																												BgL_auxz00_5958 =
																													BgL_new1120z00_2202;
																											}
																											return
																												((obj_t)
																												BgL_auxz00_5958);
																										}
																									}
																								else
																									{	/* Eval/evaluate.scm 425 */
																										if (
																											(CAR(BgL_ez00_69) ==
																												BGl_symbol3027z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 425 */
																												return
																													BGl_convzd2beginzd2zz__evaluatez00
																													(CDR(BgL_ez00_69),
																													BgL_localsz00_70,
																													BgL_globalsz00_71,
																													BgL_tailzf3zf3_72,
																													BgL_wherez00_73,
																													BgL_locz00_74,
																													BgL_topzf3zf3_75);
																											}
																										else
																											{	/* Eval/evaluate.scm 425 */
																												obj_t
																													BgL_cdrzd26301zd2_1589;
																												BgL_cdrzd26301zd2_1589 =
																													CDR(BgL_ez00_69);
																												if ((CAR(BgL_ez00_69) ==
																														BGl_symbol3013z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 425 */
																														if (PAIRP
																															(BgL_cdrzd26301zd2_1589))
																															{	/* Eval/evaluate.scm 425 */
																																obj_t
																																	BgL_arg1649z00_1592;
																																obj_t
																																	BgL_arg1650z00_1593;
																																BgL_arg1649z00_1592
																																	=
																																	CAR
																																	(BgL_cdrzd26301zd2_1589);
																																BgL_arg1650z00_1593
																																	=
																																	CDR
																																	(BgL_cdrzd26301zd2_1589);
																																{
																																	BgL_ev_letz00_bglt
																																		BgL_auxz00_5983;
																																	BgL_bindsz00_1421
																																		=
																																		BgL_arg1649z00_1592;
																																	BgL_bodyz00_1422
																																		=
																																		BgL_arg1650z00_1593;
																																BgL_tagzd2160zd2_1423:
																																	{	/* Eval/evaluate.scm 481 */
																																		obj_t
																																			BgL_ubindsz00_2205;
																																		if (NULLP
																																			(BgL_bindsz00_1421))
																																			{	/* Eval/evaluate.scm 481 */
																																				BgL_ubindsz00_2205
																																					=
																																					BNIL;
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 481 */
																																				obj_t
																																					BgL_head1209z00_2249;
																																				{	/* Eval/evaluate.scm 481 */
																																					obj_t
																																						BgL_res2689z00_3394;
																																					BgL_res2689z00_3394
																																						=
																																						MAKE_PAIR
																																						(BNIL,
																																						BNIL);
																																					BgL_head1209z00_2249
																																						=
																																						BgL_res2689z00_3394;
																																				}
																																				{
																																					obj_t
																																						BgL_l1207z00_3432;
																																					obj_t
																																						BgL_tail1210z00_3433;
																																					BgL_l1207z00_3432
																																						=
																																						BgL_bindsz00_1421;
																																					BgL_tail1210z00_3433
																																						=
																																						BgL_head1209z00_2249;
																																				BgL_zc3anonymousza32185ze3z83_3431:
																																					if (NULLP(BgL_l1207z00_3432))
																																						{	/* Eval/evaluate.scm 481 */
																																							BgL_ubindsz00_2205
																																								=
																																								CDR
																																								(BgL_head1209z00_2249);
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 481 */
																																							obj_t
																																								BgL_newtail1211z00_3441;
																																							{	/* Eval/evaluate.scm 481 */
																																								obj_t
																																									BgL_arg2189z00_3442;
																																								{	/* Eval/evaluate.scm 481 */
																																									obj_t
																																										BgL_bz00_3443;
																																									BgL_bz00_3443
																																										=
																																										CAR
																																										(BgL_l1207z00_3432);
																																									BgL_arg2189z00_3442
																																										=
																																										BGl_untypezd2identzd2zz__evaluatez00
																																										(CAR
																																										(BgL_bz00_3443));
																																								}
																																								{	/* Eval/evaluate.scm 481 */
																																									obj_t
																																										BgL_res2695z00_3453;
																																									BgL_res2695z00_3453
																																										=
																																										MAKE_PAIR
																																										(BgL_arg2189z00_3442,
																																										BNIL);
																																									BgL_newtail1211z00_3441
																																										=
																																										BgL_res2695z00_3453;
																																								}
																																							}
																																							SET_CDR
																																								(BgL_tail1210z00_3433,
																																								BgL_newtail1211z00_3441);
																																							{
																																								obj_t
																																									BgL_tail1210z00_5997;
																																								obj_t
																																									BgL_l1207z00_5995;
																																								BgL_l1207z00_5995
																																									=
																																									CDR
																																									(BgL_l1207z00_3432);
																																								BgL_tail1210z00_5997
																																									=
																																									BgL_newtail1211z00_3441;
																																								BgL_tail1210z00_3433
																																									=
																																									BgL_tail1210z00_5997;
																																								BgL_l1207z00_3432
																																									=
																																									BgL_l1207z00_5995;
																																								goto
																																									BgL_zc3anonymousza32185ze3z83_3431;
																																							}
																																						}
																																				}
																																			}
																																		{	/* Eval/evaluate.scm 481 */
																																			obj_t
																																				BgL_varsz00_2206;
																																			if (NULLP
																																				(BgL_ubindsz00_2205))
																																				{	/* Eval/evaluate.scm 482 */
																																					BgL_varsz00_2206
																																						=
																																						BNIL;
																																				}
																																			else
																																				{	/* Eval/evaluate.scm 482 */
																																					obj_t
																																						BgL_head1214z00_2233;
																																					{	/* Eval/evaluate.scm 482 */
																																						obj_t
																																							BgL_res2697z00_3461;
																																						BgL_res2697z00_3461
																																							=
																																							MAKE_PAIR
																																							(BNIL,
																																							BNIL);
																																						BgL_head1214z00_2233
																																							=
																																							BgL_res2697z00_3461;
																																					}
																																					{
																																						obj_t
																																							BgL_l1212z00_2235;
																																						obj_t
																																							BgL_tail1215z00_2236;
																																						BgL_l1212z00_2235
																																							=
																																							BgL_ubindsz00_2205;
																																						BgL_tail1215z00_2236
																																							=
																																							BgL_head1214z00_2233;
																																					BgL_zc3anonymousza32179ze3z83_2237:
																																						if (NULLP(BgL_l1212z00_2235))
																																							{	/* Eval/evaluate.scm 482 */
																																								BgL_varsz00_2206
																																									=
																																									CDR
																																									(BgL_head1214z00_2233);
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 482 */
																																								obj_t
																																									BgL_newtail1216z00_2239;
																																								{	/* Eval/evaluate.scm 482 */
																																									BgL_ev_varz00_bglt
																																										BgL_arg2182z00_2241;
																																									{	/* Eval/evaluate.scm 482 */
																																										obj_t
																																											BgL_iz00_2242;
																																										BgL_iz00_2242
																																											=
																																											CAR
																																											(BgL_l1212z00_2235);
																																										{	/* Eval/evaluate.scm 483 */
																																											BgL_ev_varz00_bglt
																																												BgL_new1123z00_2243;
																																											{	/* Eval/evaluate.scm 485 */
																																												BgL_ev_varz00_bglt
																																													BgL_new1122z00_2244;
																																												BgL_new1122z00_2244
																																													=
																																													(
																																													(BgL_ev_varz00_bglt)
																																													BREF
																																													(GC_MALLOC
																																														(sizeof
																																															(struct
																																																BgL_ev_varz00_bgl))));
																																												{	/* Eval/evaluate.scm 485 */
																																													long
																																														BgL_arg2183z00_2245;
																																													{	/* Eval/evaluate.scm 485 */
																																														long
																																															BgL_res2699z00_3467;
																																														BgL_res2699z00_3467
																																															=
																																															BGL_CLASS_INDEX
																																															(BGl_ev_varz00zz__evaluate_typesz00);
																																														BgL_arg2183z00_2245
																																															=
																																															BgL_res2699z00_3467;
																																													}
																																													BGL_OBJECT_CLASS_NUM_SET
																																														(
																																														((BgL_objectz00_bglt) BgL_new1122z00_2244), BgL_arg2183z00_2245);
																																												}
																																												{	/* Eval/evaluate.scm 485 */
																																													BgL_objectz00_bglt
																																														BgL_auxz00_6009;
																																													BgL_auxz00_6009
																																														=
																																														(
																																														(BgL_objectz00_bglt)
																																														BgL_new1122z00_2244);
																																													BGL_OBJECT_WIDENING_SET
																																														(BgL_auxz00_6009,
																																														BFALSE);
																																												}
																																												BgL_new1123z00_2243
																																													=
																																													BgL_new1122z00_2244;
																																											}
																																											((((BgL_ev_varz00_bglt) CREF(BgL_new1123z00_2243))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_2242)), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) CREF(BgL_new1123z00_2243))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																											((((BgL_ev_varz00_bglt) CREF(BgL_new1123z00_2243))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_2242)), BUNSPEC);
																																											BgL_arg2182z00_2241
																																												=
																																												BgL_new1123z00_2243;
																																									}}
																																									{	/* Eval/evaluate.scm 482 */
																																										obj_t
																																											BgL_res2700z00_3474;
																																										BgL_res2700z00_3474
																																											=
																																											MAKE_PAIR
																																											(
																																											((obj_t) BgL_arg2182z00_2241), BNIL);
																																										BgL_newtail1216z00_2239
																																											=
																																											BgL_res2700z00_3474;
																																								}}
																																								SET_CDR
																																									(BgL_tail1215z00_2236,
																																									BgL_newtail1216z00_2239);
																																								{
																																									obj_t
																																										BgL_tail1215z00_6022;
																																									obj_t
																																										BgL_l1212z00_6020;
																																									BgL_l1212z00_6020
																																										=
																																										CDR
																																										(BgL_l1212z00_2235);
																																									BgL_tail1215z00_6022
																																										=
																																										BgL_newtail1216z00_2239;
																																									BgL_tail1215z00_2236
																																										=
																																										BgL_tail1215z00_6022;
																																									BgL_l1212z00_2235
																																										=
																																										BgL_l1212z00_6020;
																																									goto
																																										BgL_zc3anonymousza32179ze3z83_2237;
																																								}
																																							}
																																					}
																																				}
																																			{	/* Eval/evaluate.scm 482 */
																																				obj_t
																																					BgL_bodyz00_2207;
																																				{	/* Eval/evaluate.scm 487 */
																																					bool_t
																																						BgL_testz00_6023;
																																					{	/* Eval/evaluate.scm 487 */
																																						obj_t
																																							BgL_auxz00_6024;
																																						BgL_auxz00_6024
																																							=
																																							CDR
																																							(BgL_bodyz00_1422);
																																						BgL_testz00_6023
																																							=
																																							PAIRP
																																							(BgL_auxz00_6024);
																																					}
																																					if (BgL_testz00_6023)
																																						{	/* Eval/evaluate.scm 487 */
																																							obj_t
																																								BgL_res2702z00_3484;
																																							BgL_res2702z00_3484
																																								=
																																								MAKE_EXTENDED_PAIR
																																								(BGl_symbol3027z00zz__evaluatez00,
																																								BgL_bodyz00_1422,
																																								BgL_locz00_74);
																																							BgL_bodyz00_2207
																																								=
																																								BgL_res2702z00_3484;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 487 */
																																							BgL_bodyz00_2207
																																								=
																																								CAR
																																								(BgL_bodyz00_1422);
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 487 */
																																					obj_t
																																						BgL_tbodyz00_2208;
																																					BgL_tbodyz00_2208
																																						=
																																						BGl_typezd2checkszd2zz__evaluatez00
																																						(BgL_ubindsz00_2205,
																																						BgL_bindsz00_1421,
																																						BgL_bodyz00_2207,
																																						BgL_locz00_74,
																																						BgL_wherez00_73);
																																					{	/* Eval/evaluate.scm 488 */

																																						{	/* Eval/evaluate.scm 489 */
																																							obj_t
																																								BgL_blocz00_2209;
																																							{	/* Eval/evaluate.scm 145 */
																																								obj_t
																																									BgL__ortest_1067z00_3488;
																																								BgL__ortest_1067z00_3488
																																									=
																																									BGl_getzd2sourcezd2locationz00zz__readerz00
																																									(BgL_bindsz00_1421);
																																								if (CBOOL(BgL__ortest_1067z00_3488))
																																									{	/* Eval/evaluate.scm 145 */
																																										BgL_blocz00_2209
																																											=
																																											BgL__ortest_1067z00_3488;
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 145 */
																																										BgL_blocz00_2209
																																											=
																																											BgL_locz00_74;
																																									}
																																							}
																																							{	/* Eval/evaluate.scm 490 */
																																								BgL_ev_letz00_bglt
																																									BgL_new1125z00_2210;
																																								{	/* Eval/evaluate.scm 491 */
																																									BgL_ev_letz00_bglt
																																										BgL_new1124z00_2227;
																																									BgL_new1124z00_2227
																																										=
																																										(
																																										(BgL_ev_letz00_bglt)
																																										BREF
																																										(GC_MALLOC
																																											(sizeof
																																												(struct
																																													BgL_ev_letz00_bgl))));
																																									{	/* Eval/evaluate.scm 491 */
																																										long
																																											BgL_arg2175z00_2228;
																																										{	/* Eval/evaluate.scm 491 */
																																											long
																																												BgL_res2703z00_3490;
																																											BgL_res2703z00_3490
																																												=
																																												BGL_CLASS_INDEX
																																												(BGl_ev_letz00zz__evaluate_typesz00);
																																											BgL_arg2175z00_2228
																																												=
																																												BgL_res2703z00_3490;
																																										}
																																										BGL_OBJECT_CLASS_NUM_SET
																																											(
																																											((BgL_objectz00_bglt) BgL_new1124z00_2227), BgL_arg2175z00_2228);
																																									}
																																									{	/* Eval/evaluate.scm 491 */
																																										BgL_objectz00_bglt
																																											BgL_auxz00_6037;
																																										BgL_auxz00_6037
																																											=
																																											(
																																											(BgL_objectz00_bglt)
																																											BgL_new1124z00_2227);
																																										BGL_OBJECT_WIDENING_SET
																																											(BgL_auxz00_6037,
																																											BFALSE);
																																									}
																																									BgL_new1125z00_2210
																																										=
																																										BgL_new1124z00_2227;
																																								}
																																								((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1125z00_2210)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2206), BUNSPEC);
																																								{
																																									obj_t
																																										BgL_auxz00_6042;
																																									if (NULLP(BgL_bindsz00_1421))
																																										{	/* Eval/evaluate.scm 492 */
																																											BgL_auxz00_6042
																																												=
																																												BNIL;
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 492 */
																																											obj_t
																																												BgL_head1219z00_2213;
																																											{	/* Eval/evaluate.scm 492 */
																																												obj_t
																																													BgL_res2705z00_3497;
																																												BgL_res2705z00_3497
																																													=
																																													MAKE_PAIR
																																													(BNIL,
																																													BNIL);
																																												BgL_head1219z00_2213
																																													=
																																													BgL_res2705z00_3497;
																																											}
																																											{
																																												obj_t
																																													BgL_l1217z00_2215;
																																												obj_t
																																													BgL_tail1220z00_2216;
																																												BgL_l1217z00_2215
																																													=
																																													BgL_bindsz00_1421;
																																												BgL_tail1220z00_2216
																																													=
																																													BgL_head1219z00_2213;
																																											BgL_zc3anonymousza32167ze3z83_2217:
																																												if (NULLP(BgL_l1217z00_2215))
																																													{	/* Eval/evaluate.scm 492 */
																																														BgL_auxz00_6042
																																															=
																																															CDR
																																															(BgL_head1219z00_2213);
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 492 */
																																														obj_t
																																															BgL_newtail1221z00_2219;
																																														{	/* Eval/evaluate.scm 492 */
																																															obj_t
																																																BgL_arg2171z00_2221;
																																															{	/* Eval/evaluate.scm 492 */
																																																obj_t
																																																	BgL_bz00_2222;
																																																BgL_bz00_2222
																																																	=
																																																	CAR
																																																	(BgL_l1217z00_2215);
																																																{	/* Eval/evaluate.scm 493 */
																																																	obj_t
																																																		BgL_locz00_2223;
																																																	{	/* Eval/evaluate.scm 145 */
																																																		obj_t
																																																			BgL__ortest_1067z00_3504;
																																																		BgL__ortest_1067z00_3504
																																																			=
																																																			BGl_getzd2sourcezd2locationz00zz__readerz00
																																																			(BgL_bz00_2222);
																																																		if (CBOOL(BgL__ortest_1067z00_3504))
																																																			{	/* Eval/evaluate.scm 145 */
																																																				BgL_locz00_2223
																																																					=
																																																					BgL__ortest_1067z00_3504;
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 145 */
																																																				BgL_locz00_2223
																																																					=
																																																					BgL_blocz00_2209;
																																																			}
																																																	}
																																																	{	/* Eval/evaluate.scm 494 */
																																																		obj_t
																																																			BgL_arg2172z00_2224;
																																																		{	/* Eval/evaluate.scm 494 */
																																																			obj_t
																																																				BgL_pairz00_3508;
																																																			BgL_pairz00_3508
																																																				=
																																																				CDR
																																																				(BgL_bz00_2222);
																																																			BgL_arg2172z00_2224
																																																				=
																																																				CAR
																																																				(BgL_pairz00_3508);
																																																		}
																																																		BgL_arg2171z00_2221
																																																			=
																																																			BGl_convz00zz__evaluatez00
																																																			(BgL_arg2172z00_2224,
																																																			BgL_localsz00_70,
																																																			BgL_globalsz00_71,
																																																			BFALSE,
																																																			BgL_wherez00_73,
																																																			BgL_locz00_2223,
																																																			((bool_t) 0));
																																																	}
																																																}
																																															}
																																															{	/* Eval/evaluate.scm 492 */
																																																obj_t
																																																	BgL_res2707z00_3513;
																																																BgL_res2707z00_3513
																																																	=
																																																	MAKE_PAIR
																																																	(BgL_arg2171z00_2221,
																																																	BNIL);
																																																BgL_newtail1221z00_2219
																																																	=
																																																	BgL_res2707z00_3513;
																																															}
																																														}
																																														SET_CDR
																																															(BgL_tail1220z00_2216,
																																															BgL_newtail1221z00_2219);
																																														{	/* Eval/evaluate.scm 492 */
																																															obj_t
																																																BgL_arg2169z00_2220;
																																															BgL_arg2169z00_2220
																																																=
																																																CDR
																																																(BgL_l1217z00_2215);
																																															{
																																																obj_t
																																																	BgL_tail1220z00_6061;
																																																obj_t
																																																	BgL_l1217z00_6060;
																																																BgL_l1217z00_6060
																																																	=
																																																	BgL_arg2169z00_2220;
																																																BgL_tail1220z00_6061
																																																	=
																																																	BgL_newtail1221z00_2219;
																																																BgL_tail1220z00_2216
																																																	=
																																																	BgL_tail1220z00_6061;
																																																BgL_l1217z00_2215
																																																	=
																																																	BgL_l1217z00_6060;
																																																goto
																																																	BgL_zc3anonymousza32167ze3z83_2217;
																																															}
																																														}
																																													}
																																											}
																																										}
																																									((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1125z00_2210)))->BgL_valsz00) = ((obj_t) BgL_auxz00_6042), BUNSPEC);
																																								}
																																								{
																																									BgL_ev_exprz00_bglt
																																										BgL_auxz00_6063;
																																									{	/* Eval/evaluate.scm 496 */
																																										obj_t
																																											BgL_arg2173z00_2226;
																																										BgL_arg2173z00_2226
																																											=
																																											BGl_appendzd221011zd2zz__evaluatez00
																																											(BgL_varsz00_2206,
																																											BgL_localsz00_70);
																																										BgL_auxz00_6063
																																											=
																																											(
																																											(BgL_ev_exprz00_bglt)
																																											BGl_convz00zz__evaluatez00
																																											(BgL_tbodyz00_2208,
																																												BgL_arg2173z00_2226,
																																												BgL_globalsz00_71,
																																												BgL_tailzf3zf3_72,
																																												BgL_wherez00_73,
																																												BgL_locz00_74,
																																												((bool_t) 0)));
																																									}
																																									((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1125z00_2210)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6063), BUNSPEC);
																																								}
																																								((((BgL_ev_letz00_bglt) CREF(BgL_new1125z00_2210))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																								BgL_auxz00_5983
																																									=
																																									BgL_new1125z00_2210;
																																							}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_5983);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 425 */
																																obj_t
																																	BgL_arg1651z00_1594;
																																BgL_arg1651z00_1594
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_6072;
																																	{
																																		obj_t
																																			BgL_argsz00_6074;
																																		obj_t
																																			BgL_fz00_6073;
																																		BgL_fz00_6073
																																			=
																																			BgL_arg1651z00_1594;
																																		BgL_argsz00_6074
																																			=
																																			BgL_cdrzd26301zd2_1589;
																																		BgL_argsz00_1468
																																			=
																																			BgL_argsz00_6074;
																																		BgL_fz00_1467
																																			=
																																			BgL_fz00_6073;
																																		goto
																																			BgL_tagzd2175zd2_1469;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_6072);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 425 */
																														if (
																															(CAR(BgL_ez00_69)
																																==
																																BGl_symbol3044z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 425 */
																																if (PAIRP
																																	(BgL_cdrzd26301zd2_1589))
																																	{	/* Eval/evaluate.scm 425 */
																																		obj_t
																																			BgL_arg1655z00_1599;
																																		obj_t
																																			BgL_arg1656z00_1600;
																																		BgL_arg1655z00_1599
																																			=
																																			CAR
																																			(BgL_cdrzd26301zd2_1589);
																																		BgL_arg1656z00_1600
																																			=
																																			CDR
																																			(BgL_cdrzd26301zd2_1589);
																																		{
																																			BgL_ev_letza2za2_bglt
																																				BgL_auxz00_6083;
																																			BgL_bindsz00_1424
																																				=
																																				BgL_arg1655z00_1599;
																																			BgL_bodyz00_1425
																																				=
																																				BgL_arg1656z00_1600;
																																		BgL_tagzd2161zd2_1426:
																																			{	/* Eval/evaluate.scm 504 */
																																				obj_t
																																					BgL_varsz00_2262;
																																				obj_t
																																					BgL_blocz00_2263;
																																				if (NULLP(BgL_bindsz00_1424))
																																					{	/* Eval/evaluate.scm 504 */
																																						BgL_varsz00_2262
																																							=
																																							BNIL;
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 504 */
																																						obj_t
																																							BgL_head1224z00_2271;
																																						{	/* Eval/evaluate.scm 504 */
																																							obj_t
																																								BgL_res2711z00_3575;
																																							BgL_res2711z00_3575
																																								=
																																								MAKE_PAIR
																																								(BNIL,
																																								BNIL);
																																							BgL_head1224z00_2271
																																								=
																																								BgL_res2711z00_3575;
																																						}
																																						{
																																							obj_t
																																								BgL_l1222z00_2273;
																																							obj_t
																																								BgL_tail1225z00_2274;
																																							BgL_l1222z00_2273
																																								=
																																								BgL_bindsz00_1424;
																																							BgL_tail1225z00_2274
																																								=
																																								BgL_head1224z00_2271;
																																						BgL_zc3anonymousza32195ze3z83_2275:
																																							if (NULLP(BgL_l1222z00_2273))
																																								{	/* Eval/evaluate.scm 504 */
																																									BgL_varsz00_2262
																																										=
																																										CDR
																																										(BgL_head1224z00_2271);
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 504 */
																																									obj_t
																																										BgL_newtail1226z00_2277;
																																									{	/* Eval/evaluate.scm 504 */
																																										BgL_ev_varz00_bglt
																																											BgL_arg2198z00_2279;
																																										{	/* Eval/evaluate.scm 504 */
																																											obj_t
																																												BgL_bz00_2280;
																																											BgL_bz00_2280
																																												=
																																												CAR
																																												(BgL_l1222z00_2273);
																																											{	/* Eval/evaluate.scm 505 */
																																												obj_t
																																													BgL_iz00_2281;
																																												BgL_iz00_2281
																																													=
																																													BGl_untypezd2identzd2zz__evaluatez00
																																													(CAR
																																													(BgL_bz00_2280));
																																												{	/* Eval/evaluate.scm 506 */
																																													BgL_ev_varz00_bglt
																																														BgL_new1128z00_2282;
																																													{	/* Eval/evaluate.scm 508 */
																																														BgL_ev_varz00_bglt
																																															BgL_new1126z00_2283;
																																														BgL_new1126z00_2283
																																															=
																																															(
																																															(BgL_ev_varz00_bglt)
																																															BREF
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_varz00_bgl))));
																																														{	/* Eval/evaluate.scm 508 */
																																															long
																																																BgL_arg2199z00_2284;
																																															{	/* Eval/evaluate.scm 508 */
																																																long
																																																	BgL_res2713z00_3582;
																																																BgL_res2713z00_3582
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_varz00zz__evaluate_typesz00);
																																																BgL_arg2199z00_2284
																																																	=
																																																	BgL_res2713z00_3582;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1126z00_2283), BgL_arg2199z00_2284);
																																														}
																																														{	/* Eval/evaluate.scm 508 */
																																															BgL_objectz00_bglt
																																																BgL_auxz00_6097;
																																															BgL_auxz00_6097
																																																=
																																																(
																																																(BgL_objectz00_bglt)
																																																BgL_new1126z00_2283);
																																															BGL_OBJECT_WIDENING_SET
																																																(BgL_auxz00_6097,
																																																BFALSE);
																																														}
																																														BgL_new1128z00_2282
																																															=
																																															BgL_new1126z00_2283;
																																													}
																																													((((BgL_ev_varz00_bglt) CREF(BgL_new1128z00_2282))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_2281)), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) CREF(BgL_new1128z00_2282))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																													((((BgL_ev_varz00_bglt) CREF(BgL_new1128z00_2282))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_2281)), BUNSPEC);
																																													BgL_arg2198z00_2279
																																														=
																																														BgL_new1128z00_2282;
																																										}}}
																																										{	/* Eval/evaluate.scm 504 */
																																											obj_t
																																												BgL_res2714z00_3589;
																																											BgL_res2714z00_3589
																																												=
																																												MAKE_PAIR
																																												(
																																												((obj_t) BgL_arg2198z00_2279), BNIL);
																																											BgL_newtail1226z00_2277
																																												=
																																												BgL_res2714z00_3589;
																																									}}
																																									SET_CDR
																																										(BgL_tail1225z00_2274,
																																										BgL_newtail1226z00_2277);
																																									{
																																										obj_t
																																											BgL_tail1225z00_6110;
																																										obj_t
																																											BgL_l1222z00_6108;
																																										BgL_l1222z00_6108
																																											=
																																											CDR
																																											(BgL_l1222z00_2273);
																																										BgL_tail1225z00_6110
																																											=
																																											BgL_newtail1226z00_2277;
																																										BgL_tail1225z00_2274
																																											=
																																											BgL_tail1225z00_6110;
																																										BgL_l1222z00_2273
																																											=
																																											BgL_l1222z00_6108;
																																										goto
																																											BgL_zc3anonymousza32195ze3z83_2275;
																																									}
																																								}
																																						}
																																					}
																																				{	/* Eval/evaluate.scm 145 */
																																					obj_t
																																						BgL__ortest_1067z00_3595;
																																					BgL__ortest_1067z00_3595
																																						=
																																						BGl_getzd2sourcezd2locationz00zz__readerz00
																																						(BgL_bindsz00_1424);
																																					if (CBOOL(BgL__ortest_1067z00_3595))
																																						{	/* Eval/evaluate.scm 145 */
																																							BgL_blocz00_2263
																																								=
																																								BgL__ortest_1067z00_3595;
																																						}
																																					else
																																						{	/* Eval/evaluate.scm 145 */
																																							BgL_blocz00_2263
																																								=
																																								BgL_locz00_74;
																																						}
																																				}
																																				{	/* Eval/evaluate.scm 511 */
																																					BgL_ev_letza2za2_bglt
																																						BgL_new1131z00_2264;
																																					{	/* Eval/evaluate.scm 512 */
																																						BgL_ev_letza2za2_bglt
																																							BgL_new1129z00_2267;
																																						BgL_new1129z00_2267
																																							=
																																							(
																																							(BgL_ev_letza2za2_bglt)
																																							BREF
																																							(GC_MALLOC
																																								(sizeof
																																									(struct
																																										BgL_ev_letza2za2_bgl))));
																																						{	/* Eval/evaluate.scm 512 */
																																							long
																																								BgL_arg2193z00_2268;
																																							{	/* Eval/evaluate.scm 512 */
																																								long
																																									BgL_res2715z00_3597;
																																								BgL_res2715z00_3597
																																									=
																																									BGL_CLASS_INDEX
																																									(BGl_ev_letza2za2zz__evaluate_typesz00);
																																								BgL_arg2193z00_2268
																																									=
																																									BgL_res2715z00_3597;
																																							}
																																							BGL_OBJECT_CLASS_NUM_SET
																																								(
																																								((BgL_objectz00_bglt) BgL_new1129z00_2267), BgL_arg2193z00_2268);
																																						}
																																						{	/* Eval/evaluate.scm 512 */
																																							BgL_objectz00_bglt
																																								BgL_auxz00_6118;
																																							BgL_auxz00_6118
																																								=
																																								(
																																								(BgL_objectz00_bglt)
																																								BgL_new1129z00_2267);
																																							BGL_OBJECT_WIDENING_SET
																																								(BgL_auxz00_6118,
																																								BFALSE);
																																						}
																																						BgL_new1131z00_2264
																																							=
																																							BgL_new1129z00_2267;
																																					}
																																					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1131z00_2264)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2262), BUNSPEC);
																																					((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1131z00_2264)))->BgL_valsz00) = ((obj_t) BGl_convzd2valszd2zz__evaluatez00(BgL_wherez00_73, BgL_globalsz00_71, BgL_bindsz00_1424, BgL_varsz00_2262, BgL_localsz00_70, BgL_blocz00_2263)), BUNSPEC);
																																					{
																																						BgL_ev_exprz00_bglt
																																							BgL_auxz00_6126;
																																						{	/* Eval/evaluate.scm 514 */
																																							obj_t
																																								BgL_arg2191z00_2265;
																																							{	/* Eval/evaluate.scm 514 */
																																								obj_t
																																									BgL_arg2192z00_2266;
																																								BgL_arg2192z00_2266
																																									=
																																									bgl_reverse
																																									(BgL_varsz00_2262);
																																								BgL_arg2191z00_2265
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_arg2192z00_2266,
																																									BgL_localsz00_70);
																																							}
																																							BgL_auxz00_6126
																																								=
																																								(
																																								(BgL_ev_exprz00_bglt)
																																								BGl_convzd2beginzd2zz__evaluatez00
																																								(BgL_bodyz00_1425,
																																									BgL_arg2191z00_2265,
																																									BgL_globalsz00_71,
																																									BgL_tailzf3zf3_72,
																																									BgL_wherez00_73,
																																									BgL_locz00_74,
																																									((bool_t) 0)));
																																						}
																																						((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1131z00_2264)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6126), BUNSPEC);
																																					}
																																					((((BgL_ev_letza2za2_bglt) CREF(BgL_new1131z00_2264))->BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
																																					BgL_auxz00_6083
																																						=
																																						BgL_new1131z00_2264;
																																			}}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6083);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 425 */
																																		obj_t
																																			BgL_arg1657z00_1601;
																																		obj_t
																																			BgL_arg1658z00_1602;
																																		BgL_arg1657z00_1601
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		BgL_arg1658z00_1602
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_6137;
																																			{
																																				obj_t
																																					BgL_argsz00_6139;
																																				obj_t
																																					BgL_fz00_6138;
																																				BgL_fz00_6138
																																					=
																																					BgL_arg1657z00_1601;
																																				BgL_argsz00_6139
																																					=
																																					BgL_arg1658z00_1602;
																																				BgL_argsz00_1468
																																					=
																																					BgL_argsz00_6139;
																																				BgL_fz00_1467
																																					=
																																					BgL_fz00_6138;
																																				goto
																																					BgL_tagzd2175zd2_1469;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_6137);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 425 */
																																obj_t
																																	BgL_cdrzd26695zd2_1603;
																																BgL_cdrzd26695zd2_1603
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																if ((CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol3046z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 425 */
																																		if (PAIRP
																																			(BgL_cdrzd26695zd2_1603))
																																			{	/* Eval/evaluate.scm 425 */
																																				obj_t
																																					BgL_arg1661z00_1606;
																																				obj_t
																																					BgL_arg1662z00_1607;
																																				BgL_arg1661z00_1606
																																					=
																																					CAR
																																					(BgL_cdrzd26695zd2_1603);
																																				BgL_arg1662z00_1607
																																					=
																																					CDR
																																					(BgL_cdrzd26695zd2_1603);
																																				{
																																					BgL_ev_letrecz00_bglt
																																						BgL_auxz00_6149;
																																					BgL_bindsz00_1427
																																						=
																																						BgL_arg1661z00_1606;
																																					BgL_bodyz00_1428
																																						=
																																						BgL_arg1662z00_1607;
																																				BgL_tagzd2162zd2_1429:
																																					{	/* Eval/evaluate.scm 516 */
																																						obj_t
																																							BgL_ubindsz00_2303;
																																						if (NULLP(BgL_bindsz00_1427))
																																							{	/* Eval/evaluate.scm 516 */
																																								BgL_ubindsz00_2303
																																									=
																																									BNIL;
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 516 */
																																								obj_t
																																									BgL_head1229z00_2352;
																																								{	/* Eval/evaluate.scm 516 */
																																									obj_t
																																										BgL_res2718z00_3644;
																																									BgL_res2718z00_3644
																																										=
																																										MAKE_PAIR
																																										(BNIL,
																																										BNIL);
																																									BgL_head1229z00_2352
																																										=
																																										BgL_res2718z00_3644;
																																								}
																																								{
																																									obj_t
																																										BgL_l1227z00_3682;
																																									obj_t
																																										BgL_tail1230z00_3683;
																																									BgL_l1227z00_3682
																																										=
																																										BgL_bindsz00_1427;
																																									BgL_tail1230z00_3683
																																										=
																																										BgL_head1229z00_2352;
																																								BgL_zc3anonymousza32234ze3z83_3681:
																																									if (NULLP(BgL_l1227z00_3682))
																																										{	/* Eval/evaluate.scm 516 */
																																											BgL_ubindsz00_2303
																																												=
																																												CDR
																																												(BgL_head1229z00_2352);
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 516 */
																																											obj_t
																																												BgL_newtail1231z00_3691;
																																											{	/* Eval/evaluate.scm 516 */
																																												obj_t
																																													BgL_arg2237z00_3692;
																																												{	/* Eval/evaluate.scm 516 */
																																													obj_t
																																														BgL_bz00_3693;
																																													BgL_bz00_3693
																																														=
																																														CAR
																																														(BgL_l1227z00_3682);
																																													BgL_arg2237z00_3692
																																														=
																																														BGl_untypezd2identzd2zz__evaluatez00
																																														(CAR
																																														(BgL_bz00_3693));
																																												}
																																												{	/* Eval/evaluate.scm 516 */
																																													obj_t
																																														BgL_res2724z00_3703;
																																													BgL_res2724z00_3703
																																														=
																																														MAKE_PAIR
																																														(BgL_arg2237z00_3692,
																																														BNIL);
																																													BgL_newtail1231z00_3691
																																														=
																																														BgL_res2724z00_3703;
																																												}
																																											}
																																											SET_CDR
																																												(BgL_tail1230z00_3683,
																																												BgL_newtail1231z00_3691);
																																											{
																																												obj_t
																																													BgL_tail1230z00_6163;
																																												obj_t
																																													BgL_l1227z00_6161;
																																												BgL_l1227z00_6161
																																													=
																																													CDR
																																													(BgL_l1227z00_3682);
																																												BgL_tail1230z00_6163
																																													=
																																													BgL_newtail1231z00_3691;
																																												BgL_tail1230z00_3683
																																													=
																																													BgL_tail1230z00_6163;
																																												BgL_l1227z00_3682
																																													=
																																													BgL_l1227z00_6161;
																																												goto
																																													BgL_zc3anonymousza32234ze3z83_3681;
																																											}
																																										}
																																								}
																																							}
																																						{	/* Eval/evaluate.scm 516 */
																																							obj_t
																																								BgL_varsz00_2304;
																																							if (NULLP(BgL_ubindsz00_2303))
																																								{	/* Eval/evaluate.scm 517 */
																																									BgL_varsz00_2304
																																										=
																																										BNIL;
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 517 */
																																									obj_t
																																										BgL_head1234z00_2336;
																																									{	/* Eval/evaluate.scm 517 */
																																										obj_t
																																											BgL_res2726z00_3711;
																																										BgL_res2726z00_3711
																																											=
																																											MAKE_PAIR
																																											(BNIL,
																																											BNIL);
																																										BgL_head1234z00_2336
																																											=
																																											BgL_res2726z00_3711;
																																									}
																																									{
																																										obj_t
																																											BgL_l1232z00_2338;
																																										obj_t
																																											BgL_tail1235z00_2339;
																																										BgL_l1232z00_2338
																																											=
																																											BgL_ubindsz00_2303;
																																										BgL_tail1235z00_2339
																																											=
																																											BgL_head1234z00_2336;
																																									BgL_zc3anonymousza32228ze3z83_2340:
																																										if (NULLP(BgL_l1232z00_2338))
																																											{	/* Eval/evaluate.scm 517 */
																																												BgL_varsz00_2304
																																													=
																																													CDR
																																													(BgL_head1234z00_2336);
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 517 */
																																												obj_t
																																													BgL_newtail1236z00_2342;
																																												{	/* Eval/evaluate.scm 517 */
																																													BgL_ev_varz00_bglt
																																														BgL_arg2231z00_2344;
																																													{	/* Eval/evaluate.scm 517 */
																																														obj_t
																																															BgL_iz00_2345;
																																														BgL_iz00_2345
																																															=
																																															CAR
																																															(BgL_l1232z00_2338);
																																														{	/* Eval/evaluate.scm 518 */
																																															BgL_ev_varz00_bglt
																																																BgL_new1133z00_2346;
																																															{	/* Eval/evaluate.scm 520 */
																																																BgL_ev_varz00_bglt
																																																	BgL_new1132z00_2347;
																																																BgL_new1132z00_2347
																																																	=
																																																	(
																																																	(BgL_ev_varz00_bglt)
																																																	BREF
																																																	(GC_MALLOC
																																																		(sizeof
																																																			(struct
																																																				BgL_ev_varz00_bgl))));
																																																{	/* Eval/evaluate.scm 520 */
																																																	long
																																																		BgL_arg2232z00_2348;
																																																	{	/* Eval/evaluate.scm 520 */
																																																		long
																																																			BgL_res2728z00_3717;
																																																		BgL_res2728z00_3717
																																																			=
																																																			BGL_CLASS_INDEX
																																																			(BGl_ev_varz00zz__evaluate_typesz00);
																																																		BgL_arg2232z00_2348
																																																			=
																																																			BgL_res2728z00_3717;
																																																	}
																																																	BGL_OBJECT_CLASS_NUM_SET
																																																		(
																																																		((BgL_objectz00_bglt) BgL_new1132z00_2347), BgL_arg2232z00_2348);
																																																}
																																																{	/* Eval/evaluate.scm 520 */
																																																	BgL_objectz00_bglt
																																																		BgL_auxz00_6175;
																																																	BgL_auxz00_6175
																																																		=
																																																		(
																																																		(BgL_objectz00_bglt)
																																																		BgL_new1132z00_2347);
																																																	BGL_OBJECT_WIDENING_SET
																																																		(BgL_auxz00_6175,
																																																		BFALSE);
																																																}
																																																BgL_new1133z00_2346
																																																	=
																																																	BgL_new1132z00_2347;
																																															}
																																															((((BgL_ev_varz00_bglt) CREF(BgL_new1133z00_2346))->BgL_namez00) = ((obj_t) CAR(BgL_iz00_2345)), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) CREF(BgL_new1133z00_2346))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																															((((BgL_ev_varz00_bglt) CREF(BgL_new1133z00_2346))->BgL_typez00) = ((obj_t) CDR(BgL_iz00_2345)), BUNSPEC);
																																															BgL_arg2231z00_2344
																																																=
																																																BgL_new1133z00_2346;
																																													}}
																																													{	/* Eval/evaluate.scm 517 */
																																														obj_t
																																															BgL_res2729z00_3724;
																																														BgL_res2729z00_3724
																																															=
																																															MAKE_PAIR
																																															(
																																															((obj_t) BgL_arg2231z00_2344), BNIL);
																																														BgL_newtail1236z00_2342
																																															=
																																															BgL_res2729z00_3724;
																																												}}
																																												SET_CDR
																																													(BgL_tail1235z00_2339,
																																													BgL_newtail1236z00_2342);
																																												{
																																													obj_t
																																														BgL_tail1235z00_6188;
																																													obj_t
																																														BgL_l1232z00_6186;
																																													BgL_l1232z00_6186
																																														=
																																														CDR
																																														(BgL_l1232z00_2338);
																																													BgL_tail1235z00_6188
																																														=
																																														BgL_newtail1236z00_2342;
																																													BgL_tail1235z00_2339
																																														=
																																														BgL_tail1235z00_6188;
																																													BgL_l1232z00_2338
																																														=
																																														BgL_l1232z00_6186;
																																													goto
																																														BgL_zc3anonymousza32228ze3z83_2340;
																																												}
																																											}
																																									}
																																								}
																																							{	/* Eval/evaluate.scm 517 */
																																								obj_t
																																									BgL_localsz00_2305;
																																								BgL_localsz00_2305
																																									=
																																									BGl_appendzd221011zd2zz__evaluatez00
																																									(BgL_varsz00_2304,
																																									BgL_localsz00_70);
																																								{	/* Eval/evaluate.scm 522 */
																																									obj_t
																																										BgL_bodyz00_2306;
																																									{	/* Eval/evaluate.scm 523 */
																																										bool_t
																																											BgL_testz00_6190;
																																										{	/* Eval/evaluate.scm 523 */
																																											obj_t
																																												BgL_auxz00_6191;
																																											BgL_auxz00_6191
																																												=
																																												CDR
																																												(BgL_bodyz00_1428);
																																											BgL_testz00_6190
																																												=
																																												PAIRP
																																												(BgL_auxz00_6191);
																																										}
																																										if (BgL_testz00_6190)
																																											{	/* Eval/evaluate.scm 523 */
																																												obj_t
																																													BgL_res2731z00_3734;
																																												BgL_res2731z00_3734
																																													=
																																													MAKE_EXTENDED_PAIR
																																													(BGl_symbol3027z00zz__evaluatez00,
																																													BgL_bodyz00_1428,
																																													BgL_locz00_74);
																																												BgL_bodyz00_2306
																																													=
																																													BgL_res2731z00_3734;
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 523 */
																																												BgL_bodyz00_2306
																																													=
																																													CAR
																																													(BgL_bodyz00_1428);
																																											}
																																									}
																																									{	/* Eval/evaluate.scm 523 */
																																										obj_t
																																											BgL_tbodyz00_2307;
																																										BgL_tbodyz00_2307
																																											=
																																											BGl_typezd2checkszd2zz__evaluatez00
																																											(BgL_ubindsz00_2303,
																																											BgL_bindsz00_1427,
																																											BgL_bodyz00_2306,
																																											BgL_locz00_74,
																																											BgL_wherez00_73);
																																										{	/* Eval/evaluate.scm 524 */
																																											obj_t
																																												BgL_blocz00_2308;
																																											{	/* Eval/evaluate.scm 145 */
																																												obj_t
																																													BgL__ortest_1067z00_3738;
																																												BgL__ortest_1067z00_3738
																																													=
																																													BGl_getzd2sourcezd2locationz00zz__readerz00
																																													(BgL_bindsz00_1427);
																																												if (CBOOL(BgL__ortest_1067z00_3738))
																																													{	/* Eval/evaluate.scm 145 */
																																														BgL_blocz00_2308
																																															=
																																															BgL__ortest_1067z00_3738;
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 145 */
																																														BgL_blocz00_2308
																																															=
																																															BgL_locz00_74;
																																													}
																																											}
																																											{	/* Eval/evaluate.scm 525 */

																																												{	/* Eval/evaluate.scm 526 */
																																													BgL_ev_letrecz00_bglt
																																														BgL_new1135z00_2309;
																																													{	/* Eval/evaluate.scm 527 */
																																														BgL_ev_letrecz00_bglt
																																															BgL_new1134z00_2330;
																																														BgL_new1134z00_2330
																																															=
																																															(
																																															(BgL_ev_letrecz00_bglt)
																																															BREF
																																															(GC_MALLOC
																																																(sizeof
																																																	(struct
																																																		BgL_ev_letrecz00_bgl))));
																																														{	/* Eval/evaluate.scm 527 */
																																															long
																																																BgL_arg2224z00_2331;
																																															{	/* Eval/evaluate.scm 527 */
																																																long
																																																	BgL_res2732z00_3740;
																																																BgL_res2732z00_3740
																																																	=
																																																	BGL_CLASS_INDEX
																																																	(BGl_ev_letrecz00zz__evaluate_typesz00);
																																																BgL_arg2224z00_2331
																																																	=
																																																	BgL_res2732z00_3740;
																																															}
																																															BGL_OBJECT_CLASS_NUM_SET
																																																(
																																																((BgL_objectz00_bglt) BgL_new1134z00_2330), BgL_arg2224z00_2331);
																																														}
																																														{	/* Eval/evaluate.scm 527 */
																																															BgL_objectz00_bglt
																																																BgL_auxz00_6204;
																																															BgL_auxz00_6204
																																																=
																																																(
																																																(BgL_objectz00_bglt)
																																																BgL_new1134z00_2330);
																																															BGL_OBJECT_WIDENING_SET
																																																(BgL_auxz00_6204,
																																																BFALSE);
																																														}
																																														BgL_new1135z00_2309
																																															=
																																															BgL_new1134z00_2330;
																																													}
																																													((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1135z00_2309)))->BgL_varsz00) = ((obj_t) BgL_varsz00_2304), BUNSPEC);
																																													{
																																														obj_t
																																															BgL_auxz00_6209;
																																														if (NULLP(BgL_bindsz00_1427))
																																															{	/* Eval/evaluate.scm 528 */
																																																BgL_auxz00_6209
																																																	=
																																																	BNIL;
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 528 */
																																																obj_t
																																																	BgL_head1239z00_2312;
																																																{	/* Eval/evaluate.scm 528 */
																																																	obj_t
																																																		BgL_res2734z00_3747;
																																																	BgL_res2734z00_3747
																																																		=
																																																		MAKE_PAIR
																																																		(BNIL,
																																																		BNIL);
																																																	BgL_head1239z00_2312
																																																		=
																																																		BgL_res2734z00_3747;
																																																}
																																																{
																																																	obj_t
																																																		BgL_l1237z00_2314;
																																																	obj_t
																																																		BgL_tail1240z00_2315;
																																																	BgL_l1237z00_2314
																																																		=
																																																		BgL_bindsz00_1427;
																																																	BgL_tail1240z00_2315
																																																		=
																																																		BgL_head1239z00_2312;
																																																BgL_zc3anonymousza32213ze3z83_2316:
																																																	if (NULLP(BgL_l1237z00_2314))
																																																		{	/* Eval/evaluate.scm 528 */
																																																			BgL_auxz00_6209
																																																				=
																																																				CDR
																																																				(BgL_head1239z00_2312);
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 528 */
																																																			obj_t
																																																				BgL_newtail1241z00_2318;
																																																			{	/* Eval/evaluate.scm 528 */
																																																				obj_t
																																																					BgL_arg2216z00_2320;
																																																				{	/* Eval/evaluate.scm 528 */
																																																					obj_t
																																																						BgL_bz00_2321;
																																																					BgL_bz00_2321
																																																						=
																																																						CAR
																																																						(BgL_l1237z00_2314);
																																																					{	/* Eval/evaluate.scm 529 */
																																																						obj_t
																																																							BgL_arg2217z00_2322;
																																																						obj_t
																																																							BgL_arg2218z00_2323;
																																																						obj_t
																																																							BgL_arg2219z00_2324;
																																																						{	/* Eval/evaluate.scm 529 */
																																																							obj_t
																																																								BgL_pairz00_3755;
																																																							BgL_pairz00_3755
																																																								=
																																																								CDR
																																																								(BgL_bz00_2321);
																																																							BgL_arg2217z00_2322
																																																								=
																																																								CAR
																																																								(BgL_pairz00_3755);
																																																						}
																																																						{	/* Eval/evaluate.scm 529 */
																																																							obj_t
																																																								BgL_arg2220z00_2325;
																																																							BgL_arg2220z00_2325
																																																								=
																																																								CAR
																																																								(BgL_bz00_2321);
																																																							{	/* Eval/evaluate.scm 529 */
																																																								obj_t
																																																									BgL_list2221z00_2326;
																																																								{	/* Eval/evaluate.scm 529 */
																																																									obj_t
																																																										BgL_arg2222z00_2327;
																																																									{	/* Eval/evaluate.scm 529 */
																																																										obj_t
																																																											BgL_arg2223z00_2328;
																																																										BgL_arg2223z00_2328
																																																											=
																																																											MAKE_PAIR
																																																											(BgL_wherez00_73,
																																																											BNIL);
																																																										BgL_arg2222z00_2327
																																																											=
																																																											MAKE_PAIR
																																																											(BGl_symbol3029z00zz__evaluatez00,
																																																											BgL_arg2223z00_2328);
																																																									}
																																																									BgL_list2221z00_2326
																																																										=
																																																										MAKE_PAIR
																																																										(BgL_arg2220z00_2325,
																																																										BgL_arg2222z00_2327);
																																																								}
																																																								BgL_arg2218z00_2323
																																																									=
																																																									BGl_symbolzd2appendzd2zz__r4_symbols_6_4z00
																																																									(BgL_list2221z00_2326);
																																																							}
																																																						}
																																																						{	/* Eval/evaluate.scm 145 */
																																																							obj_t
																																																								BgL__ortest_1067z00_3759;
																																																							BgL__ortest_1067z00_3759
																																																								=
																																																								BGl_getzd2sourcezd2locationz00zz__readerz00
																																																								(BgL_bz00_2321);
																																																							if (CBOOL(BgL__ortest_1067z00_3759))
																																																								{	/* Eval/evaluate.scm 145 */
																																																									BgL_arg2219z00_2324
																																																										=
																																																										BgL__ortest_1067z00_3759;
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 145 */
																																																									BgL_arg2219z00_2324
																																																										=
																																																										BgL_blocz00_2308;
																																																								}
																																																						}
																																																						BgL_arg2216z00_2320
																																																							=
																																																							BGl_convz00zz__evaluatez00
																																																							(BgL_arg2217z00_2322,
																																																							BgL_localsz00_2305,
																																																							BgL_globalsz00_71,
																																																							BFALSE,
																																																							BgL_arg2218z00_2323,
																																																							BgL_arg2219z00_2324,
																																																							((bool_t) 0));
																																																					}
																																																				}
																																																				{	/* Eval/evaluate.scm 528 */
																																																					obj_t
																																																						BgL_res2736z00_3762;
																																																					BgL_res2736z00_3762
																																																						=
																																																						MAKE_PAIR
																																																						(BgL_arg2216z00_2320,
																																																						BNIL);
																																																					BgL_newtail1241z00_2318
																																																						=
																																																						BgL_res2736z00_3762;
																																																				}
																																																			}
																																																			SET_CDR
																																																				(BgL_tail1240z00_2315,
																																																				BgL_newtail1241z00_2318);
																																																			{	/* Eval/evaluate.scm 528 */
																																																				obj_t
																																																					BgL_arg2215z00_2319;
																																																				BgL_arg2215z00_2319
																																																					=
																																																					CDR
																																																					(BgL_l1237z00_2314);
																																																				{
																																																					obj_t
																																																						BgL_tail1240z00_6233;
																																																					obj_t
																																																						BgL_l1237z00_6232;
																																																					BgL_l1237z00_6232
																																																						=
																																																						BgL_arg2215z00_2319;
																																																					BgL_tail1240z00_6233
																																																						=
																																																						BgL_newtail1241z00_2318;
																																																					BgL_tail1240z00_2315
																																																						=
																																																						BgL_tail1240z00_6233;
																																																					BgL_l1237z00_2314
																																																						=
																																																						BgL_l1237z00_6232;
																																																					goto
																																																						BgL_zc3anonymousza32213ze3z83_2316;
																																																				}
																																																			}
																																																		}
																																																}
																																															}
																																														((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1135z00_2309)))->BgL_valsz00) = ((obj_t) BgL_auxz00_6209), BUNSPEC);
																																													}
																																													((((BgL_ev_binderz00_bglt) CREF(((BgL_ev_binderz00_bglt) BgL_new1135z00_2309)))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convz00zz__evaluatez00(BgL_tbodyz00_2307, BgL_localsz00_2305, BgL_globalsz00_71, BgL_tailzf3zf3_72, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																													BgL_auxz00_6149
																																														=
																																														BgL_new1135z00_2309;
																																												}
																																											}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_6149);
																																				}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 425 */
																																				obj_t
																																					BgL_arg1663z00_1608;
																																				BgL_arg1663z00_1608
																																					=
																																					CAR
																																					(BgL_ez00_69);
																																				{
																																					BgL_ev_appz00_bglt
																																						BgL_auxz00_6241;
																																					{
																																						obj_t
																																							BgL_argsz00_6243;
																																						obj_t
																																							BgL_fz00_6242;
																																						BgL_fz00_6242
																																							=
																																							BgL_arg1663z00_1608;
																																						BgL_argsz00_6243
																																							=
																																							BgL_cdrzd26695zd2_1603;
																																						BgL_argsz00_1468
																																							=
																																							BgL_argsz00_6243;
																																						BgL_fz00_1467
																																							=
																																							BgL_fz00_6242;
																																						goto
																																							BgL_tagzd2175zd2_1469;
																																					}
																																					return
																																						(
																																						(obj_t)
																																						BgL_auxz00_6241);
																																				}
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 425 */
																																		if (
																																			(CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol3048z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 425 */
																																				if (PAIRP(BgL_cdrzd26695zd2_1603))
																																					{	/* Eval/evaluate.scm 425 */
																																						obj_t
																																							BgL_carzd26869zd2_1613;
																																						obj_t
																																							BgL_cdrzd26870zd2_1614;
																																						BgL_carzd26869zd2_1613
																																							=
																																							CAR
																																							(BgL_cdrzd26695zd2_1603);
																																						BgL_cdrzd26870zd2_1614
																																							=
																																							CDR
																																							(BgL_cdrzd26695zd2_1603);
																																						if (PAIRP(BgL_carzd26869zd2_1613))
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_cdrzd26874zd2_1616;
																																								BgL_cdrzd26874zd2_1616
																																									=
																																									CDR
																																									(BgL_carzd26869zd2_1613);
																																								if ((CAR(BgL_carzd26869zd2_1613) == BGl_symbol3034z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 425 */
																																										if (PAIRP(BgL_cdrzd26874zd2_1616))
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_carzd26877zd2_1619;
																																												obj_t
																																													BgL_cdrzd26878zd2_1620;
																																												BgL_carzd26877zd2_1619
																																													=
																																													CAR
																																													(BgL_cdrzd26874zd2_1616);
																																												BgL_cdrzd26878zd2_1620
																																													=
																																													CDR
																																													(BgL_cdrzd26874zd2_1616);
																																												if (SYMBOLP(BgL_carzd26877zd2_1619))
																																													{	/* Eval/evaluate.scm 425 */
																																														if (PAIRP(BgL_cdrzd26878zd2_1620))
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_carzd26882zd2_1623;
																																																BgL_carzd26882zd2_1623
																																																	=
																																																	CAR
																																																	(BgL_cdrzd26878zd2_1620);
																																																if (SYMBOLP(BgL_carzd26882zd2_1623))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		if (NULLP(CDR(BgL_cdrzd26878zd2_1620)))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				if (PAIRP(BgL_cdrzd26870zd2_1614))
																																																					{	/* Eval/evaluate.scm 425 */
																																																						if (NULLP(CDR(BgL_cdrzd26870zd2_1614)))
																																																							{	/* Eval/evaluate.scm 425 */
																																																								obj_t
																																																									BgL_arg1676z00_1628;
																																																								BgL_arg1676z00_1628
																																																									=
																																																									CAR
																																																									(BgL_cdrzd26870zd2_1614);
																																																								{	/* Eval/evaluate.scm 532 */
																																																									BgL_ev_setglobalz00_bglt
																																																										BgL_new1138z00_4118;
																																																									{	/* Eval/evaluate.scm 536 */
																																																										BgL_ev_setglobalz00_bglt
																																																											BgL_new1137z00_4119;
																																																										BgL_new1137z00_4119
																																																											=
																																																											(
																																																											(BgL_ev_setglobalz00_bglt)
																																																											BREF
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_setglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 536 */
																																																											long
																																																												BgL_arg2239z00_4120;
																																																											{	/* Eval/evaluate.scm 536 */
																																																												long
																																																													BgL_res2791z00_4122;
																																																												BgL_res2791z00_4122
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2239z00_4120
																																																													=
																																																													BgL_res2791z00_4122;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1137z00_4119), BgL_arg2239z00_4120);
																																																										}
																																																										{	/* Eval/evaluate.scm 536 */
																																																											BgL_objectz00_bglt
																																																												BgL_auxz00_6282;
																																																											BgL_auxz00_6282
																																																												=
																																																												(
																																																												(BgL_objectz00_bglt)
																																																												BgL_new1137z00_4119);
																																																											BGL_OBJECT_WIDENING_SET
																																																												(BgL_auxz00_6282,
																																																												BFALSE);
																																																										}
																																																										BgL_new1138z00_4118
																																																											=
																																																											BgL_new1137z00_4119;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6285;
																																																										{	/* Eval/evaluate.scm 381 */
																																																											obj_t
																																																												BgL_arg2308z00_4126;
																																																											BgL_arg2308z00_4126
																																																												=
																																																												BGl_getzd2locationzd2zz__evaluatez00
																																																												(BgL_arg1676z00_1628,
																																																												BgL_locz00_74);
																																																											BgL_auxz00_6285
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_uconvzf2loczf2zz__evaluatez00
																																																												(BgL_wherez00_73,
																																																													BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_arg1676z00_1628,
																																																													BgL_arg2308z00_4126));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1138z00_4118)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6285), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1138z00_4118))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1138z00_4118))->BgL_namez00) = ((obj_t) BgL_carzd26877zd2_1619), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1138z00_4118))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd26882zd2_1623)), BUNSPEC);
																																																									return
																																																										(
																																																										(obj_t)
																																																										BgL_new1138z00_4118);
																																																								}
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 425 */
																																																								return
																																																									BGl_evcompilezd2errorzd2zz__evcompilez00
																																																									(BgL_locz00_74,
																																																									BGl_string2951z00zz__evaluatez00,
																																																									BGl_string3026z00zz__evaluatez00,
																																																									BgL_ez00_69);
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 425 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string2951z00zz__evaluatez00,
																																																							BGl_string3026z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_cdrzd26998zd2_1630;
																																																				BgL_cdrzd26998zd2_1630
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{	/* Eval/evaluate.scm 425 */
																																																					obj_t
																																																						BgL_cdrzd27002zd2_1631;
																																																					BgL_cdrzd27002zd2_1631
																																																						=
																																																						CDR
																																																						(BgL_cdrzd26998zd2_1630);
																																																					if (PAIRP(BgL_cdrzd27002zd2_1631))
																																																						{	/* Eval/evaluate.scm 425 */
																																																							if (NULLP(CDR(BgL_cdrzd27002zd2_1631)))
																																																								{	/* Eval/evaluate.scm 425 */
																																																									obj_t
																																																										BgL_arg1680z00_1634;
																																																									obj_t
																																																										BgL_arg1682z00_1635;
																																																									BgL_arg1680z00_1634
																																																										=
																																																										CAR
																																																										(BgL_cdrzd26998zd2_1630);
																																																									BgL_arg1682z00_1635
																																																										=
																																																										CAR
																																																										(BgL_cdrzd27002zd2_1631);
																																																									{
																																																										BgL_ev_hookz00_bglt
																																																											BgL_auxz00_6307;
																																																										BgL_vz00_1437
																																																											=
																																																											BgL_arg1680z00_1634;
																																																										BgL_ez00_1438
																																																											=
																																																											BgL_arg1682z00_1635;
																																																									BgL_tagzd2165zd2_1439:
																																																										{	/* Eval/evaluate.scm 542 */
																																																											obj_t
																																																												BgL_cvz00_2380;
																																																											obj_t
																																																												BgL_ez00_2381;
																																																											BgL_cvz00_2380
																																																												=
																																																												BGl_convzd2varzd2zz__evaluatez00
																																																												(BgL_vz00_1437,
																																																												BgL_localsz00_70);
																																																											{	/* Eval/evaluate.scm 381 */
																																																												obj_t
																																																													BgL_arg2308z00_3792;
																																																												{	/* Eval/evaluate.scm 145 */
																																																													obj_t
																																																														BgL__ortest_1067z00_3795;
																																																													BgL__ortest_1067z00_3795
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_ez00_1438);
																																																													if (CBOOL(BgL__ortest_1067z00_3795))
																																																														{	/* Eval/evaluate.scm 145 */
																																																															BgL_arg2308z00_3792
																																																																=
																																																																BgL__ortest_1067z00_3795;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 145 */
																																																															BgL_arg2308z00_3792
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												BgL_ez00_2381
																																																													=
																																																													BGl_convz00zz__evaluatez00
																																																													(BgL_ez00_1438,
																																																													BgL_localsz00_70,
																																																													BgL_globalsz00_71,
																																																													BFALSE,
																																																													BgL_wherez00_73,
																																																													BgL_arg2308z00_3792,
																																																													((bool_t) 0));
																																																											}
																																																											if (CBOOL(BgL_cvz00_2380))
																																																												{	/* Eval/evaluate.scm 544 */
																																																													BgL_ev_setlocalz00_bglt
																																																														BgL_new1140z00_2382;
																																																													{	/* Eval/evaluate.scm 546 */
																																																														BgL_ev_setlocalz00_bglt
																																																															BgL_new1139z00_2383;
																																																														BgL_new1139z00_2383
																																																															=
																																																															(
																																																															(BgL_ev_setlocalz00_bglt)
																																																															BREF
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setlocalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 546 */
																																																															long
																																																																BgL_arg2248z00_2384;
																																																															{	/* Eval/evaluate.scm 546 */
																																																																long
																																																																	BgL_res2742z00_3799;
																																																																BgL_res2742z00_3799
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setlocalz00zz__evaluate_typesz00);
																																																																BgL_arg2248z00_2384
																																																																	=
																																																																	BgL_res2742z00_3799;
																																																															}
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1139z00_2383), BgL_arg2248z00_2384);
																																																														}
																																																														{	/* Eval/evaluate.scm 546 */
																																																															BgL_objectz00_bglt
																																																																BgL_auxz00_6319;
																																																															BgL_auxz00_6319
																																																																=
																																																																(
																																																																(BgL_objectz00_bglt)
																																																																BgL_new1139z00_2383);
																																																															BGL_OBJECT_WIDENING_SET
																																																																(BgL_auxz00_6319,
																																																																BFALSE);
																																																														}
																																																														BgL_new1140z00_2382
																																																															=
																																																															BgL_new1139z00_2383;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1140z00_2382)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2381)), BUNSPEC);
																																																													((((BgL_ev_setlocalz00_bglt) CREF(BgL_new1140z00_2382))->BgL_vz00) = ((BgL_ev_varz00_bglt) ((BgL_ev_varz00_bglt) BgL_cvz00_2380)), BUNSPEC);
																																																													BgL_auxz00_6307
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1140z00_2382);
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 547 */
																																																													BgL_ev_setglobalz00_bglt
																																																														BgL_new1142z00_2385;
																																																													{	/* Eval/evaluate.scm 551 */
																																																														BgL_ev_setglobalz00_bglt
																																																															BgL_new1141z00_2387;
																																																														BgL_new1141z00_2387
																																																															=
																																																															(
																																																															(BgL_ev_setglobalz00_bglt)
																																																															BREF
																																																															(GC_MALLOC
																																																																(sizeof
																																																																	(struct
																																																																		BgL_ev_setglobalz00_bgl))));
																																																														{	/* Eval/evaluate.scm 551 */
																																																															long
																																																																BgL_arg2250z00_2388;
																																																															{	/* Eval/evaluate.scm 551 */
																																																																long
																																																																	BgL_res2743z00_3803;
																																																																BgL_res2743z00_3803
																																																																	=
																																																																	BGL_CLASS_INDEX
																																																																	(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																																BgL_arg2250z00_2388
																																																																	=
																																																																	BgL_res2743z00_3803;
																																																															}
																																																															BGL_OBJECT_CLASS_NUM_SET
																																																																(
																																																																((BgL_objectz00_bglt) BgL_new1141z00_2387), BgL_arg2250z00_2388);
																																																														}
																																																														{	/* Eval/evaluate.scm 551 */
																																																															BgL_objectz00_bglt
																																																																BgL_auxz00_6332;
																																																															BgL_auxz00_6332
																																																																=
																																																																(
																																																																(BgL_objectz00_bglt)
																																																																BgL_new1141z00_2387);
																																																															BGL_OBJECT_WIDENING_SET
																																																																(BgL_auxz00_6332,
																																																																BFALSE);
																																																														}
																																																														BgL_new1142z00_2385
																																																															=
																																																															BgL_new1141z00_2387;
																																																													}
																																																													((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1142z00_2385)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BgL_ez00_2381)), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1142z00_2385))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																													((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1142z00_2385))->BgL_namez00) = ((obj_t) BgL_vz00_1437), BUNSPEC);
																																																													{
																																																														obj_t
																																																															BgL_auxz00_6340;
																																																														if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																															{	/* Eval/evaluate.scm 550 */
																																																																BgL_auxz00_6340
																																																																	=
																																																																	BgL_globalsz00_71;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 550 */
																																																																BgL_auxz00_6340
																																																																	=
																																																																	BGL_MODULE
																																																																	();
																																																															}
																																																														((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1142z00_2385))->BgL_modz00) = ((obj_t) BgL_auxz00_6340), BUNSPEC);
																																																													}
																																																													BgL_auxz00_6307
																																																														=
																																																														(
																																																														(BgL_ev_hookz00_bglt)
																																																														BgL_new1142z00_2385);
																																																												}
																																																										}
																																																										return
																																																											(
																																																											(obj_t)
																																																											BgL_auxz00_6307);
																																																									}
																																																								}
																																																							else
																																																								{	/* Eval/evaluate.scm 425 */
																																																									return
																																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																																										(BgL_locz00_74,
																																																										BGl_string2951z00zz__evaluatez00,
																																																										BGl_string3026z00zz__evaluatez00,
																																																										BgL_ez00_69);
																																																								}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 425 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string2951z00zz__evaluatez00,
																																																								BGl_string3026z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_cdrzd27059zd2_1638;
																																																		BgL_cdrzd27059zd2_1638
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 425 */
																																																			obj_t
																																																				BgL_cdrzd27063zd2_1639;
																																																			BgL_cdrzd27063zd2_1639
																																																				=
																																																				CDR
																																																				(BgL_cdrzd27059zd2_1638);
																																																			if (PAIRP(BgL_cdrzd27063zd2_1639))
																																																				{	/* Eval/evaluate.scm 425 */
																																																					if (NULLP(CDR(BgL_cdrzd27063zd2_1639)))
																																																						{	/* Eval/evaluate.scm 425 */
																																																							obj_t
																																																								BgL_arg1687z00_1642;
																																																							obj_t
																																																								BgL_arg1688z00_1643;
																																																							BgL_arg1687z00_1642
																																																								=
																																																								CAR
																																																								(BgL_cdrzd27059zd2_1638);
																																																							BgL_arg1688z00_1643
																																																								=
																																																								CAR
																																																								(BgL_cdrzd27063zd2_1639);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_6358;
																																																								{
																																																									obj_t
																																																										BgL_ez00_6360;
																																																									obj_t
																																																										BgL_vz00_6359;
																																																									BgL_vz00_6359
																																																										=
																																																										BgL_arg1687z00_1642;
																																																									BgL_ez00_6360
																																																										=
																																																										BgL_arg1688z00_1643;
																																																									BgL_ez00_1438
																																																										=
																																																										BgL_ez00_6360;
																																																									BgL_vz00_1437
																																																										=
																																																										BgL_vz00_6359;
																																																									goto
																																																										BgL_tagzd2165zd2_1439;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_6358);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 425 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string2951z00zz__evaluatez00,
																																																								BGl_string3026z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 425 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2951z00zz__evaluatez00,
																																																						BGl_string3026z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd27120zd2_1645;
																																																BgL_cdrzd27120zd2_1645
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 425 */
																																																	obj_t
																																																		BgL_cdrzd27124zd2_1646;
																																																	BgL_cdrzd27124zd2_1646
																																																		=
																																																		CDR
																																																		(BgL_cdrzd27120zd2_1645);
																																																	if (PAIRP(BgL_cdrzd27124zd2_1646))
																																																		{	/* Eval/evaluate.scm 425 */
																																																			if (NULLP(CDR(BgL_cdrzd27124zd2_1646)))
																																																				{	/* Eval/evaluate.scm 425 */
																																																					obj_t
																																																						BgL_arg1692z00_1649;
																																																					obj_t
																																																						BgL_arg1694z00_1650;
																																																					BgL_arg1692z00_1649
																																																						=
																																																						CAR
																																																						(BgL_cdrzd27120zd2_1645);
																																																					BgL_arg1694z00_1650
																																																						=
																																																						CAR
																																																						(BgL_cdrzd27124zd2_1646);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_6373;
																																																						{
																																																							obj_t
																																																								BgL_ez00_6375;
																																																							obj_t
																																																								BgL_vz00_6374;
																																																							BgL_vz00_6374
																																																								=
																																																								BgL_arg1692z00_1649;
																																																							BgL_ez00_6375
																																																								=
																																																								BgL_arg1694z00_1650;
																																																							BgL_ez00_1438
																																																								=
																																																								BgL_ez00_6375;
																																																							BgL_vz00_1437
																																																								=
																																																								BgL_vz00_6374;
																																																							goto
																																																								BgL_tagzd2165zd2_1439;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_6373);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 425 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2951z00zz__evaluatez00,
																																																						BGl_string3026z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 425 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2951z00zz__evaluatez00,
																																																				BGl_string3026z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_cdrzd27181zd2_1652;
																																														BgL_cdrzd27181zd2_1652
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 425 */
																																															obj_t
																																																BgL_cdrzd27185zd2_1653;
																																															BgL_cdrzd27185zd2_1653
																																																=
																																																CDR
																																																(BgL_cdrzd27181zd2_1652);
																																															if (PAIRP(BgL_cdrzd27185zd2_1653))
																																																{	/* Eval/evaluate.scm 425 */
																																																	if (NULLP(CDR(BgL_cdrzd27185zd2_1653)))
																																																		{	/* Eval/evaluate.scm 425 */
																																																			obj_t
																																																				BgL_arg1698z00_1656;
																																																			obj_t
																																																				BgL_arg1699z00_1657;
																																																			BgL_arg1698z00_1656
																																																				=
																																																				CAR
																																																				(BgL_cdrzd27181zd2_1652);
																																																			BgL_arg1699z00_1657
																																																				=
																																																				CAR
																																																				(BgL_cdrzd27185zd2_1653);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_6388;
																																																				{
																																																					obj_t
																																																						BgL_ez00_6390;
																																																					obj_t
																																																						BgL_vz00_6389;
																																																					BgL_vz00_6389
																																																						=
																																																						BgL_arg1698z00_1656;
																																																					BgL_ez00_6390
																																																						=
																																																						BgL_arg1699z00_1657;
																																																					BgL_ez00_1438
																																																						=
																																																						BgL_ez00_6390;
																																																					BgL_vz00_1437
																																																						=
																																																						BgL_vz00_6389;
																																																					goto
																																																						BgL_tagzd2165zd2_1439;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_6388);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 425 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2951z00zz__evaluatez00,
																																																				BGl_string3026z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 425 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2951z00zz__evaluatez00,
																																																		BGl_string3026z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_cdrzd27242zd2_1659;
																																												BgL_cdrzd27242zd2_1659
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 425 */
																																													obj_t
																																														BgL_cdrzd27246zd2_1660;
																																													BgL_cdrzd27246zd2_1660
																																														=
																																														CDR
																																														(BgL_cdrzd27242zd2_1659);
																																													if (PAIRP(BgL_cdrzd27246zd2_1660))
																																														{	/* Eval/evaluate.scm 425 */
																																															if (NULLP(CDR(BgL_cdrzd27246zd2_1660)))
																																																{	/* Eval/evaluate.scm 425 */
																																																	obj_t
																																																		BgL_arg1703z00_1663;
																																																	obj_t
																																																		BgL_arg1705z00_1664;
																																																	BgL_arg1703z00_1663
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27242zd2_1659);
																																																	BgL_arg1705z00_1664
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27246zd2_1660);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6403;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6405;
																																																			obj_t
																																																				BgL_vz00_6404;
																																																			BgL_vz00_6404
																																																				=
																																																				BgL_arg1703z00_1663;
																																																			BgL_ez00_6405
																																																				=
																																																				BgL_arg1705z00_1664;
																																																			BgL_ez00_1438
																																																				=
																																																				BgL_ez00_6405;
																																																			BgL_vz00_1437
																																																				=
																																																				BgL_vz00_6404;
																																																			goto
																																																				BgL_tagzd2165zd2_1439;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6403);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 425 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2951z00zz__evaluatez00,
																																																		BGl_string3026z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 425 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2951z00zz__evaluatez00,
																																																BGl_string3026z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_cdrzd27290zd2_1666;
																																										BgL_cdrzd27290zd2_1666
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 425 */
																																											obj_t
																																												BgL_carzd27293zd2_1667;
																																											obj_t
																																												BgL_cdrzd27294zd2_1668;
																																											BgL_carzd27293zd2_1667
																																												=
																																												CAR
																																												(BgL_cdrzd27290zd2_1666);
																																											BgL_cdrzd27294zd2_1668
																																												=
																																												CDR
																																												(BgL_cdrzd27290zd2_1666);
																																											if ((CAR(BgL_carzd27293zd2_1667) == BGl_symbol3036z00zz__evaluatez00))
																																												{	/* Eval/evaluate.scm 425 */
																																													if (PAIRP(BgL_cdrzd27294zd2_1668))
																																														{	/* Eval/evaluate.scm 425 */
																																															if (NULLP(CDR(BgL_cdrzd27294zd2_1668)))
																																																{	/* Eval/evaluate.scm 425 */
																																																	BgL_lz00_1434
																																																		=
																																																		CDR
																																																		(BgL_carzd27293zd2_1667);
																																																	BgL_e2z00_1435
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27294zd2_1668);
																																																BgL_tagzd2164zd2_1436:
																																																	{	/* Eval/evaluate.scm 538 */
																																																		bool_t
																																																			BgL_testz00_6420;
																																																		if (PAIRP(BgL_lz00_1434))
																																																			{	/* Eval/evaluate.scm 538 */
																																																				bool_t
																																																					BgL_testz00_6423;
																																																				{	/* Eval/evaluate.scm 538 */
																																																					obj_t
																																																						BgL_auxz00_6424;
																																																					BgL_auxz00_6424
																																																						=
																																																						CDR
																																																						(BgL_lz00_1434);
																																																					BgL_testz00_6423
																																																						=
																																																						PAIRP
																																																						(BgL_auxz00_6424);
																																																				}
																																																				if (BgL_testz00_6423)
																																																					{
																																																						obj_t
																																																							BgL_l1242z00_2371;
																																																						BgL_l1242z00_2371
																																																							=
																																																							BgL_lz00_1434;
																																																					BgL_zc3anonymousza32243ze3z83_2372:
																																																						if (NULLP(BgL_l1242z00_2371))
																																																							{	/* Eval/evaluate.scm 538 */
																																																								BgL_testz00_6420
																																																									=
																																																									(
																																																									(bool_t)
																																																									1);
																																																							}
																																																						else
																																																							{	/* Eval/evaluate.scm 538 */
																																																								bool_t
																																																									BgL_testz00_6429;
																																																								{	/* Eval/evaluate.scm 538 */
																																																									obj_t
																																																										BgL_auxz00_6430;
																																																									BgL_auxz00_6430
																																																										=
																																																										CAR
																																																										(BgL_l1242z00_2371);
																																																									BgL_testz00_6429
																																																										=
																																																										SYMBOLP
																																																										(BgL_auxz00_6430);
																																																								}
																																																								if (BgL_testz00_6429)
																																																									{
																																																										obj_t
																																																											BgL_l1242z00_6433;
																																																										BgL_l1242z00_6433
																																																											=
																																																											CDR
																																																											(BgL_l1242z00_2371);
																																																										BgL_l1242z00_2371
																																																											=
																																																											BgL_l1242z00_6433;
																																																										goto
																																																											BgL_zc3anonymousza32243ze3z83_2372;
																																																									}
																																																								else
																																																									{	/* Eval/evaluate.scm 538 */
																																																										BgL_testz00_6420
																																																											=
																																																											(
																																																											(bool_t)
																																																											0);
																																																									}
																																																							}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 538 */
																																																						BgL_testz00_6420
																																																							=
																																																							(
																																																							(bool_t)
																																																							0);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 538 */
																																																				BgL_testz00_6420
																																																					=
																																																					(
																																																					(bool_t)
																																																					0);
																																																			}
																																																		if (BgL_testz00_6420)
																																																			{	/* Eval/evaluate.scm 538 */
																																																				return
																																																					BGl_convzd2fieldzd2setz00zz__evaluatez00
																																																					(BgL_lz00_1434,
																																																					BgL_e2z00_1435,
																																																					BgL_ez00_69,
																																																					BgL_localsz00_70,
																																																					BgL_globalsz00_71,
																																																					BgL_tailzf3zf3_72,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					BgL_topzf3zf3_75);
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 538 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string2951z00zz__evaluatez00,
																																																					BGl_string3026z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 425 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2951z00zz__evaluatez00,
																																																		BGl_string3026z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 425 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2951z00zz__evaluatez00,
																																																BGl_string3026z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 425 */
																																													obj_t
																																														BgL_cdrzd27370zd2_1676;
																																													BgL_cdrzd27370zd2_1676
																																														=
																																														CDR
																																														(BgL_cdrzd27290zd2_1666);
																																													if (PAIRP(BgL_cdrzd27370zd2_1676))
																																														{	/* Eval/evaluate.scm 425 */
																																															if (NULLP(CDR(BgL_cdrzd27370zd2_1676)))
																																																{	/* Eval/evaluate.scm 425 */
																																																	obj_t
																																																		BgL_arg1718z00_1679;
																																																	obj_t
																																																		BgL_arg1719z00_1680;
																																																	BgL_arg1718z00_1679
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27290zd2_1666);
																																																	BgL_arg1719z00_1680
																																																		=
																																																		CAR
																																																		(BgL_cdrzd27370zd2_1676);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_6449;
																																																		{
																																																			obj_t
																																																				BgL_ez00_6451;
																																																			obj_t
																																																				BgL_vz00_6450;
																																																			BgL_vz00_6450
																																																				=
																																																				BgL_arg1718z00_1679;
																																																			BgL_ez00_6451
																																																				=
																																																				BgL_arg1719z00_1680;
																																																			BgL_ez00_1438
																																																				=
																																																				BgL_ez00_6451;
																																																			BgL_vz00_1437
																																																				=
																																																				BgL_vz00_6450;
																																																			goto
																																																				BgL_tagzd2165zd2_1439;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_6449);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 425 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2951z00zz__evaluatez00,
																																																		BGl_string3026z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 425 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2951z00zz__evaluatez00,
																																																BGl_string3026z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_cdrzd27427zd2_1684;
																																								BgL_cdrzd27427zd2_1684
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 425 */
																																									obj_t
																																										BgL_cdrzd27431zd2_1685;
																																									BgL_cdrzd27431zd2_1685
																																										=
																																										CDR
																																										(BgL_cdrzd27427zd2_1684);
																																									if (PAIRP(BgL_cdrzd27431zd2_1685))
																																										{	/* Eval/evaluate.scm 425 */
																																											if (NULLP(CDR(BgL_cdrzd27431zd2_1685)))
																																												{	/* Eval/evaluate.scm 425 */
																																													obj_t
																																														BgL_arg1727z00_1688;
																																													obj_t
																																														BgL_arg1728z00_1689;
																																													BgL_arg1727z00_1688
																																														=
																																														CAR
																																														(BgL_cdrzd27427zd2_1684);
																																													BgL_arg1728z00_1689
																																														=
																																														CAR
																																														(BgL_cdrzd27431zd2_1685);
																																													{
																																														BgL_ev_hookz00_bglt
																																															BgL_auxz00_6464;
																																														{
																																															obj_t
																																																BgL_ez00_6466;
																																															obj_t
																																																BgL_vz00_6465;
																																															BgL_vz00_6465
																																																=
																																																BgL_arg1727z00_1688;
																																															BgL_ez00_6466
																																																=
																																																BgL_arg1728z00_1689;
																																															BgL_ez00_1438
																																																=
																																																BgL_ez00_6466;
																																															BgL_vz00_1437
																																																=
																																																BgL_vz00_6465;
																																															goto
																																																BgL_tagzd2165zd2_1439;
																																														}
																																														return
																																															(
																																															(obj_t)
																																															BgL_auxz00_6464);
																																													}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 425 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2951z00zz__evaluatez00,
																																														BGl_string3026z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 425 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string2951z00zz__evaluatez00,
																																												BGl_string3026z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 425 */
																																						return
																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																							(BgL_locz00_74,
																																							BGl_string2951z00zz__evaluatez00,
																																							BGl_string3026z00zz__evaluatez00,
																																							BgL_ez00_69);
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 425 */
																																				obj_t
																																					BgL_cdrzd27552zd2_1691;
																																				BgL_cdrzd27552zd2_1691
																																					=
																																					CDR
																																					(BgL_ez00_69);
																																				if ((CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol3050z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 425 */
																																						if (PAIRP(BgL_cdrzd27552zd2_1691))
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_cdrzd27557zd2_1694;
																																								BgL_cdrzd27557zd2_1694
																																									=
																																									CDR
																																									(BgL_cdrzd27552zd2_1691);
																																								if (PAIRP(BgL_cdrzd27557zd2_1694))
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_carzd27561zd2_1696;
																																										BgL_carzd27561zd2_1696
																																											=
																																											CAR
																																											(BgL_cdrzd27557zd2_1694);
																																										if (PAIRP(BgL_carzd27561zd2_1696))
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_cdrzd27566zd2_1698;
																																												BgL_cdrzd27566zd2_1698
																																													=
																																													CDR
																																													(BgL_carzd27561zd2_1696);
																																												if ((CAR(BgL_carzd27561zd2_1696) == BGl_symbol3015z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 425 */
																																														if (PAIRP(BgL_cdrzd27566zd2_1698))
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd27570zd2_1701;
																																																BgL_cdrzd27570zd2_1701
																																																	=
																																																	CDR
																																																	(BgL_cdrzd27566zd2_1698);
																																																if (PAIRP(BgL_cdrzd27570zd2_1701))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		if (NULLP(CDR(BgL_cdrzd27570zd2_1701)))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				if (NULLP(CDR(BgL_cdrzd27557zd2_1694)))
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1741z00_1705;
																																																						obj_t
																																																							BgL_arg1743z00_1706;
																																																						obj_t
																																																							BgL_arg1744z00_1707;
																																																						BgL_arg1741z00_1705
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27552zd2_1691);
																																																						BgL_arg1743z00_1706
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27566zd2_1698);
																																																						BgL_arg1744z00_1707
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27570zd2_1701);
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6501;
																																																							BgL_gvz00_1441
																																																								=
																																																								BgL_arg1741z00_1705;
																																																							BgL_formalsz00_1442
																																																								=
																																																								BgL_arg1743z00_1706;
																																																							BgL_bodyz00_1443
																																																								=
																																																								BgL_arg1744z00_1707;
																																																						BgL_tagzd2167zd2_1444:
																																																							{	/* Eval/evaluate.scm 555 */
																																																								obj_t
																																																									BgL_tidz00_2389;
																																																								BgL_tidz00_2389
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1441);
																																																								{	/* Eval/evaluate.scm 556 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1144z00_2390;
																																																									{	/* Eval/evaluate.scm 560 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1143z00_2393;
																																																										BgL_new1143z00_2393
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BREF
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 560 */
																																																											long
																																																												BgL_arg2253z00_2394;
																																																											{	/* Eval/evaluate.scm 560 */
																																																												long
																																																													BgL_res2744z00_3807;
																																																												BgL_res2744z00_3807
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2253z00_2394
																																																													=
																																																													BgL_res2744z00_3807;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1143z00_2393), BgL_arg2253z00_2394);
																																																										}
																																																										{	/* Eval/evaluate.scm 560 */
																																																											BgL_objectz00_bglt
																																																												BgL_auxz00_6507;
																																																											BgL_auxz00_6507
																																																												=
																																																												(
																																																												(BgL_objectz00_bglt)
																																																												BgL_new1143z00_2393);
																																																											BGL_OBJECT_WIDENING_SET
																																																												(BgL_auxz00_6507,
																																																												BFALSE);
																																																										}
																																																										BgL_new1144z00_2390
																																																											=
																																																											BgL_new1143z00_2393;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6510;
																																																										{	/* Eval/evaluate.scm 560 */
																																																											obj_t
																																																												BgL_arg2251z00_2391;
																																																											BgL_arg2251z00_2391
																																																												=
																																																												CDR
																																																												(BgL_tidz00_2389);
																																																											BgL_auxz00_6510
																																																												=
																																																												(
																																																												(BgL_ev_exprz00_bglt)
																																																												BGl_convzd2lambdazd2zz__evaluatez00
																																																												(BgL_globalsz00_71,
																																																													BgL_localsz00_70,
																																																													BgL_ez00_69,
																																																													BgL_locz00_74,
																																																													BgL_formalsz00_1442,
																																																													BgL_bodyz00_1443,
																																																													BgL_gvz00_1441,
																																																													BgL_arg2251z00_2391));
																																																										}
																																																										((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1144z00_2390)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6510), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_2390)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_2390)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2389)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6521;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 559 */
																																																												BgL_auxz00_6521
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 559 */
																																																												BgL_auxz00_6521
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1144z00_2390)))->BgL_modz00) = ((obj_t) BgL_auxz00_6521), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6501
																																																										=
																																																										BgL_new1144z00_2390;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6501);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1745z00_1708;
																																																						BgL_arg1745z00_1708
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6529;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6531;
																																																								obj_t
																																																									BgL_fz00_6530;
																																																								BgL_fz00_6530
																																																									=
																																																									BgL_arg1745z00_1708;
																																																								BgL_argsz00_6531
																																																									=
																																																									BgL_cdrzd27552zd2_1691;
																																																								BgL_argsz00_1468
																																																									=
																																																									BgL_argsz00_6531;
																																																								BgL_fz00_1467
																																																									=
																																																									BgL_fz00_6530;
																																																								goto
																																																									BgL_tagzd2175zd2_1469;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6529);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_cdrzd27670zd2_1712;
																																																				BgL_cdrzd27670zd2_1712
																																																					=
																																																					CDR
																																																					(BgL_cdrzd27552zd2_1691);
																																																				if (NULLP(CDR(BgL_cdrzd27670zd2_1712)))
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1751z00_1714;
																																																						obj_t
																																																							BgL_arg1752z00_1715;
																																																						BgL_arg1751z00_1714
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27552zd2_1691);
																																																						BgL_arg1752z00_1715
																																																							=
																																																							CAR
																																																							(BgL_cdrzd27670zd2_1712);
																																																						{
																																																							BgL_ev_defglobalz00_bglt
																																																								BgL_auxz00_6539;
																																																							BgL_gvz00_1445
																																																								=
																																																								BgL_arg1751z00_1714;
																																																							BgL_gez00_1446
																																																								=
																																																								BgL_arg1752z00_1715;
																																																						BgL_tagzd2168zd2_1447:
																																																							{	/* Eval/evaluate.scm 562 */
																																																								obj_t
																																																									BgL_tidz00_2395;
																																																								BgL_tidz00_2395
																																																									=
																																																									BGl_untypezd2identzd2zz__evaluatez00
																																																									(BgL_gvz00_1445);
																																																								{	/* Eval/evaluate.scm 563 */
																																																									BgL_ev_defglobalz00_bglt
																																																										BgL_new1146z00_2396;
																																																									{	/* Eval/evaluate.scm 567 */
																																																										BgL_ev_defglobalz00_bglt
																																																											BgL_new1145z00_2401;
																																																										BgL_new1145z00_2401
																																																											=
																																																											(
																																																											(BgL_ev_defglobalz00_bglt)
																																																											BREF
																																																											(GC_MALLOC
																																																												(sizeof
																																																													(struct
																																																														BgL_ev_defglobalz00_bgl))));
																																																										{	/* Eval/evaluate.scm 567 */
																																																											long
																																																												BgL_arg2258z00_2402;
																																																											{	/* Eval/evaluate.scm 567 */
																																																												long
																																																													BgL_res2745z00_3813;
																																																												BgL_res2745z00_3813
																																																													=
																																																													BGL_CLASS_INDEX
																																																													(BGl_ev_defglobalz00zz__evaluate_typesz00);
																																																												BgL_arg2258z00_2402
																																																													=
																																																													BgL_res2745z00_3813;
																																																											}
																																																											BGL_OBJECT_CLASS_NUM_SET
																																																												(
																																																												((BgL_objectz00_bglt) BgL_new1145z00_2401), BgL_arg2258z00_2402);
																																																										}
																																																										{	/* Eval/evaluate.scm 567 */
																																																											BgL_objectz00_bglt
																																																												BgL_auxz00_6545;
																																																											BgL_auxz00_6545
																																																												=
																																																												(
																																																												(BgL_objectz00_bglt)
																																																												BgL_new1145z00_2401);
																																																											BGL_OBJECT_WIDENING_SET
																																																												(BgL_auxz00_6545,
																																																												BFALSE);
																																																										}
																																																										BgL_new1146z00_2396
																																																											=
																																																											BgL_new1145z00_2401;
																																																									}
																																																									{
																																																										BgL_ev_exprz00_bglt
																																																											BgL_auxz00_6548;
																																																										{	/* Eval/evaluate.scm 568 */
																																																											obj_t
																																																												BgL_arg2254z00_2397;
																																																											{	/* Eval/evaluate.scm 568 */
																																																												obj_t
																																																													BgL_arg2256z00_2399;
																																																												BgL_arg2256z00_2399
																																																													=
																																																													CDR
																																																													(BgL_tidz00_2395);
																																																												BgL_arg2254z00_2397
																																																													=
																																																													BGl_typezd2resultzd2zz__evaluatez00
																																																													(BgL_arg2256z00_2399,
																																																													BgL_gez00_1446,
																																																													BgL_locz00_74);
																																																											}
																																																											{	/* Eval/evaluate.scm 384 */
																																																												obj_t
																																																													BgL_arg2306z00_3819;
																																																												{	/* Eval/evaluate.scm 145 */
																																																													obj_t
																																																														BgL__ortest_1067z00_3822;
																																																													BgL__ortest_1067z00_3822
																																																														=
																																																														BGl_getzd2sourcezd2locationz00zz__readerz00
																																																														(BgL_arg2254z00_2397);
																																																													if (CBOOL(BgL__ortest_1067z00_3822))
																																																														{	/* Eval/evaluate.scm 145 */
																																																															BgL_arg2306z00_3819
																																																																=
																																																																BgL__ortest_1067z00_3822;
																																																														}
																																																													else
																																																														{	/* Eval/evaluate.scm 145 */
																																																															BgL_arg2306z00_3819
																																																																=
																																																																BgL_locz00_74;
																																																														}
																																																												}
																																																												{
																																																													obj_t
																																																														BgL_auxz00_6555;
																																																													{	/* Eval/evaluate.scm 375 */
																																																														obj_t
																																																															BgL_auxz00_6556;
																																																														if (BgL_topzf3zf3_75)
																																																															{	/* Eval/evaluate.scm 569 */
																																																																BgL_auxz00_6556
																																																																	=
																																																																	BgL_gvz00_1445;
																																																															}
																																																														else
																																																															{	/* Eval/evaluate.scm 569 */
																																																																BgL_auxz00_6556
																																																																	=
																																																																	BgL_wherez00_73;
																																																															}
																																																														BgL_auxz00_6555
																																																															=
																																																															BGl_convz00zz__evaluatez00
																																																															(BgL_arg2254z00_2397,
																																																															BgL_localsz00_70,
																																																															BgL_globalsz00_71,
																																																															BFALSE,
																																																															BgL_auxz00_6556,
																																																															BgL_arg2306z00_3819,
																																																															((bool_t) 0));
																																																													}
																																																													BgL_auxz00_6548
																																																														=
																																																														(
																																																														(BgL_ev_exprz00_bglt)
																																																														BgL_auxz00_6555);
																																																												}
																																																											}
																																																										}
																																																										((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1146z00_2396)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6548), BUNSPEC);
																																																									}
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2396)))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																									((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2396)))->BgL_namez00) = ((obj_t) CAR(BgL_tidz00_2395)), BUNSPEC);
																																																									{
																																																										obj_t
																																																											BgL_auxz00_6566;
																																																										if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
																																																											{	/* Eval/evaluate.scm 566 */
																																																												BgL_auxz00_6566
																																																													=
																																																													BgL_globalsz00_71;
																																																											}
																																																										else
																																																											{	/* Eval/evaluate.scm 566 */
																																																												BgL_auxz00_6566
																																																													=
																																																													BGL_MODULE
																																																													();
																																																											}
																																																										((((BgL_ev_setglobalz00_bglt) CREF(((BgL_ev_setglobalz00_bglt) BgL_new1146z00_2396)))->BgL_modz00) = ((obj_t) BgL_auxz00_6566), BUNSPEC);
																																																									}
																																																									BgL_auxz00_6539
																																																										=
																																																										BgL_new1146z00_2396;
																																																								}
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6539);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1754z00_1716;
																																																						obj_t
																																																							BgL_arg1755z00_1717;
																																																						BgL_arg1754z00_1716
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1755z00_1717
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6575;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6577;
																																																								obj_t
																																																									BgL_fz00_6576;
																																																								BgL_fz00_6576
																																																									=
																																																									BgL_arg1754z00_1716;
																																																								BgL_argsz00_6577
																																																									=
																																																									BgL_arg1755z00_1717;
																																																								BgL_argsz00_1468
																																																									=
																																																									BgL_argsz00_6577;
																																																								BgL_fz00_1467
																																																									=
																																																									BgL_fz00_6576;
																																																								goto
																																																									BgL_tagzd2175zd2_1469;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6575);
																																																						}
																																																					}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_cdrzd27757zd2_1721;
																																																		BgL_cdrzd27757zd2_1721
																																																			=
																																																			CDR
																																																			(BgL_cdrzd27552zd2_1691);
																																																		if (NULLP(CDR(BgL_cdrzd27757zd2_1721)))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg1759z00_1723;
																																																				obj_t
																																																					BgL_arg1760z00_1724;
																																																				BgL_arg1759z00_1723
																																																					=
																																																					CAR
																																																					(BgL_cdrzd27552zd2_1691);
																																																				BgL_arg1760z00_1724
																																																					=
																																																					CAR
																																																					(BgL_cdrzd27757zd2_1721);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_6585;
																																																					{
																																																						obj_t
																																																							BgL_gez00_6587;
																																																						obj_t
																																																							BgL_gvz00_6586;
																																																						BgL_gvz00_6586
																																																							=
																																																							BgL_arg1759z00_1723;
																																																						BgL_gez00_6587
																																																							=
																																																							BgL_arg1760z00_1724;
																																																						BgL_gez00_1446
																																																							=
																																																							BgL_gez00_6587;
																																																						BgL_gvz00_1445
																																																							=
																																																							BgL_gvz00_6586;
																																																						goto
																																																							BgL_tagzd2168zd2_1447;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6585);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg1761z00_1725;
																																																				obj_t
																																																					BgL_arg1762z00_1726;
																																																				BgL_arg1761z00_1725
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1762z00_1726
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6591;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6593;
																																																						obj_t
																																																							BgL_fz00_6592;
																																																						BgL_fz00_6592
																																																							=
																																																							BgL_arg1761z00_1725;
																																																						BgL_argsz00_6593
																																																							=
																																																							BgL_arg1762z00_1726;
																																																						BgL_argsz00_1468
																																																							=
																																																							BgL_argsz00_6593;
																																																						BgL_fz00_1467
																																																							=
																																																							BgL_fz00_6592;
																																																						goto
																																																							BgL_tagzd2175zd2_1469;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6591);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd27844zd2_1729;
																																																BgL_cdrzd27844zd2_1729
																																																	=
																																																	CDR
																																																	(BgL_cdrzd27552zd2_1691);
																																																if (NULLP(CDR(BgL_cdrzd27844zd2_1729)))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg1765z00_1731;
																																																		obj_t
																																																			BgL_arg1766z00_1732;
																																																		BgL_arg1765z00_1731
																																																			=
																																																			CAR
																																																			(BgL_cdrzd27552zd2_1691);
																																																		BgL_arg1766z00_1732
																																																			=
																																																			CAR
																																																			(BgL_cdrzd27844zd2_1729);
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_6601;
																																																			{
																																																				obj_t
																																																					BgL_gez00_6603;
																																																				obj_t
																																																					BgL_gvz00_6602;
																																																				BgL_gvz00_6602
																																																					=
																																																					BgL_arg1765z00_1731;
																																																				BgL_gez00_6603
																																																					=
																																																					BgL_arg1766z00_1732;
																																																				BgL_gez00_1446
																																																					=
																																																					BgL_gez00_6603;
																																																				BgL_gvz00_1445
																																																					=
																																																					BgL_gvz00_6602;
																																																				goto
																																																					BgL_tagzd2168zd2_1447;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6601);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg1767z00_1733;
																																																		obj_t
																																																			BgL_arg1769z00_1734;
																																																		BgL_arg1767z00_1733
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1769z00_1734
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6607;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6609;
																																																				obj_t
																																																					BgL_fz00_6608;
																																																				BgL_fz00_6608
																																																					=
																																																					BgL_arg1767z00_1733;
																																																				BgL_argsz00_6609
																																																					=
																																																					BgL_arg1769z00_1734;
																																																				BgL_argsz00_1468
																																																					=
																																																					BgL_argsz00_6609;
																																																				BgL_fz00_1467
																																																					=
																																																					BgL_fz00_6608;
																																																				goto
																																																					BgL_tagzd2175zd2_1469;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6607);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_cdrzd27931zd2_1737;
																																														BgL_cdrzd27931zd2_1737
																																															=
																																															CDR
																																															(BgL_cdrzd27552zd2_1691);
																																														if (NULLP(CDR(BgL_cdrzd27931zd2_1737)))
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg1773z00_1739;
																																																obj_t
																																																	BgL_arg1774z00_1740;
																																																BgL_arg1773z00_1739
																																																	=
																																																	CAR
																																																	(BgL_cdrzd27552zd2_1691);
																																																BgL_arg1774z00_1740
																																																	=
																																																	CAR
																																																	(BgL_cdrzd27931zd2_1737);
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_6617;
																																																	{
																																																		obj_t
																																																			BgL_gez00_6619;
																																																		obj_t
																																																			BgL_gvz00_6618;
																																																		BgL_gvz00_6618
																																																			=
																																																			BgL_arg1773z00_1739;
																																																		BgL_gez00_6619
																																																			=
																																																			BgL_arg1774z00_1740;
																																																		BgL_gez00_1446
																																																			=
																																																			BgL_gez00_6619;
																																																		BgL_gvz00_1445
																																																			=
																																																			BgL_gvz00_6618;
																																																		goto
																																																			BgL_tagzd2168zd2_1447;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6617);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg1775z00_1741;
																																																obj_t
																																																	BgL_arg1776z00_1742;
																																																BgL_arg1775z00_1741
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg1776z00_1742
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6623;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6625;
																																																		obj_t
																																																			BgL_fz00_6624;
																																																		BgL_fz00_6624
																																																			=
																																																			BgL_arg1775z00_1741;
																																																		BgL_argsz00_6625
																																																			=
																																																			BgL_arg1776z00_1742;
																																																		BgL_argsz00_1468
																																																			=
																																																			BgL_argsz00_6625;
																																																		BgL_fz00_1467
																																																			=
																																																			BgL_fz00_6624;
																																																		goto
																																																			BgL_tagzd2175zd2_1469;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6623);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_cdrzd28018zd2_1746;
																																												BgL_cdrzd28018zd2_1746
																																													=
																																													CDR
																																													(BgL_cdrzd27552zd2_1691);
																																												if (NULLP(CDR(BgL_cdrzd28018zd2_1746)))
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg1782z00_1748;
																																														obj_t
																																															BgL_arg1784z00_1749;
																																														BgL_arg1782z00_1748
																																															=
																																															CAR
																																															(BgL_cdrzd27552zd2_1691);
																																														BgL_arg1784z00_1749
																																															=
																																															CAR
																																															(BgL_cdrzd28018zd2_1746);
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_6633;
																																															{
																																																obj_t
																																																	BgL_gez00_6635;
																																																obj_t
																																																	BgL_gvz00_6634;
																																																BgL_gvz00_6634
																																																	=
																																																	BgL_arg1782z00_1748;
																																																BgL_gez00_6635
																																																	=
																																																	BgL_arg1784z00_1749;
																																																BgL_gez00_1446
																																																	=
																																																	BgL_gez00_6635;
																																																BgL_gvz00_1445
																																																	=
																																																	BgL_gvz00_6634;
																																																goto
																																																	BgL_tagzd2168zd2_1447;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6633);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg1785z00_1750;
																																														obj_t
																																															BgL_arg1786z00_1751;
																																														BgL_arg1785z00_1750
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1786z00_1751
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6639;
																																															{
																																																obj_t
																																																	BgL_argsz00_6641;
																																																obj_t
																																																	BgL_fz00_6640;
																																																BgL_fz00_6640
																																																	=
																																																	BgL_arg1785z00_1750;
																																																BgL_argsz00_6641
																																																	=
																																																	BgL_arg1786z00_1751;
																																																BgL_argsz00_1468
																																																	=
																																																	BgL_argsz00_6641;
																																																BgL_fz00_1467
																																																	=
																																																	BgL_fz00_6640;
																																																goto
																																																	BgL_tagzd2175zd2_1469;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6639);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_arg1790z00_1753;
																																										BgL_arg1790z00_1753
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6644;
																																											{
																																												obj_t
																																													BgL_argsz00_6646;
																																												obj_t
																																													BgL_fz00_6645;
																																												BgL_fz00_6645
																																													=
																																													BgL_arg1790z00_1753;
																																												BgL_argsz00_6646
																																													=
																																													BgL_cdrzd27552zd2_1691;
																																												BgL_argsz00_1468
																																													=
																																													BgL_argsz00_6646;
																																												BgL_fz00_1467
																																													=
																																													BgL_fz00_6645;
																																												goto
																																													BgL_tagzd2175zd2_1469;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6644);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_arg1792z00_1755;
																																								BgL_arg1792z00_1755
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_6649;
																																									{
																																										obj_t
																																											BgL_argsz00_6651;
																																										obj_t
																																											BgL_fz00_6650;
																																										BgL_fz00_6650
																																											=
																																											BgL_arg1792z00_1755;
																																										BgL_argsz00_6651
																																											=
																																											BgL_cdrzd27552zd2_1691;
																																										BgL_argsz00_1468
																																											=
																																											BgL_argsz00_6651;
																																										BgL_fz00_1467
																																											=
																																											BgL_fz00_6650;
																																										goto
																																											BgL_tagzd2175zd2_1469;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_6649);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 425 */
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol3052z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 425 */
																																								if (PAIRP(BgL_cdrzd27552zd2_1691))
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_carzd28260zd2_1760;
																																										BgL_carzd28260zd2_1760
																																											=
																																											CAR
																																											(BgL_cdrzd27552zd2_1691);
																																										if (PAIRP(BgL_carzd28260zd2_1760))
																																											{	/* Eval/evaluate.scm 425 */
																																												if (NULLP(CDR(BgL_carzd28260zd2_1760)))
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg1798z00_1763;
																																														obj_t
																																															BgL_arg1799z00_1764;
																																														BgL_arg1798z00_1763
																																															=
																																															CAR
																																															(BgL_carzd28260zd2_1760);
																																														BgL_arg1799z00_1764
																																															=
																																															CDR
																																															(BgL_cdrzd27552zd2_1691);
																																														{
																																															BgL_ev_bindzd2exitzd2_bglt
																																																BgL_auxz00_6666;
																																															BgL_vz00_1448
																																																=
																																																BgL_arg1798z00_1763;
																																															BgL_bodyz00_1449
																																																=
																																																BgL_arg1799z00_1764;
																																														BgL_tagzd2169zd2_1450:
																																															{	/* Eval/evaluate.scm 571 */
																																																BgL_ev_varz00_bglt
																																																	BgL_varz00_2403;
																																																{	/* Eval/evaluate.scm 571 */
																																																	BgL_ev_varz00_bglt
																																																		BgL_new1148z00_2408;
																																																	{	/* Eval/evaluate.scm 571 */
																																																		BgL_ev_varz00_bglt
																																																			BgL_new1147z00_2409;
																																																		BgL_new1147z00_2409
																																																			=
																																																			(
																																																			(BgL_ev_varz00_bglt)
																																																			BREF
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_varz00_bgl))));
																																																		{	/* Eval/evaluate.scm 571 */
																																																			long
																																																				BgL_arg2261z00_2410;
																																																			{	/* Eval/evaluate.scm 571 */
																																																				long
																																																					BgL_res2746z00_3828;
																																																				BgL_res2746z00_3828
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_varz00zz__evaluate_typesz00);
																																																				BgL_arg2261z00_2410
																																																					=
																																																					BgL_res2746z00_3828;
																																																			}
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1147z00_2409), BgL_arg2261z00_2410);
																																																		}
																																																		{	/* Eval/evaluate.scm 571 */
																																																			BgL_objectz00_bglt
																																																				BgL_auxz00_6671;
																																																			BgL_auxz00_6671
																																																				=
																																																				(
																																																				(BgL_objectz00_bglt)
																																																				BgL_new1147z00_2409);
																																																			BGL_OBJECT_WIDENING_SET
																																																				(BgL_auxz00_6671,
																																																				BFALSE);
																																																		}
																																																		BgL_new1148z00_2408
																																																			=
																																																			BgL_new1147z00_2409;
																																																	}
																																																	((((BgL_ev_varz00_bglt) CREF(BgL_new1148z00_2408))->BgL_namez00) = ((obj_t) BgL_vz00_1448), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) CREF(BgL_new1148z00_2408))->BgL_effz00) = ((obj_t) BFALSE), BUNSPEC);
																																																	((((BgL_ev_varz00_bglt) CREF(BgL_new1148z00_2408))->BgL_typez00) = ((obj_t) BFALSE), BUNSPEC);
																																																	BgL_varz00_2403
																																																		=
																																																		BgL_new1148z00_2408;
																																																}
																																																{	/* Eval/evaluate.scm 572 */
																																																	BgL_ev_bindzd2exitzd2_bglt
																																																		BgL_new1150z00_2404;
																																																	{	/* Eval/evaluate.scm 573 */
																																																		BgL_ev_bindzd2exitzd2_bglt
																																																			BgL_new1149z00_2406;
																																																		BgL_new1149z00_2406
																																																			=
																																																			(
																																																			(BgL_ev_bindzd2exitzd2_bglt)
																																																			BREF
																																																			(GC_MALLOC
																																																				(sizeof
																																																					(struct
																																																						BgL_ev_bindzd2exitzd2_bgl))));
																																																		{	/* Eval/evaluate.scm 573 */
																																																			long
																																																				BgL_arg2260z00_2407;
																																																			{	/* Eval/evaluate.scm 573 */
																																																				long
																																																					BgL_res2747z00_3832;
																																																				BgL_res2747z00_3832
																																																					=
																																																					BGL_CLASS_INDEX
																																																					(BGl_ev_bindzd2exitzd2zz__evaluate_typesz00);
																																																				BgL_arg2260z00_2407
																																																					=
																																																					BgL_res2747z00_3832;
																																																			}
																																																			BGL_OBJECT_CLASS_NUM_SET
																																																				(
																																																				((BgL_objectz00_bglt) BgL_new1149z00_2406), BgL_arg2260z00_2407);
																																																		}
																																																		{	/* Eval/evaluate.scm 573 */
																																																			BgL_objectz00_bglt
																																																				BgL_auxz00_6681;
																																																			BgL_auxz00_6681
																																																				=
																																																				(
																																																				(BgL_objectz00_bglt)
																																																				BgL_new1149z00_2406);
																																																			BGL_OBJECT_WIDENING_SET
																																																				(BgL_auxz00_6681,
																																																				BFALSE);
																																																		}
																																																		BgL_new1150z00_2404
																																																			=
																																																			BgL_new1149z00_2406;
																																																	}
																																																	((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1150z00_2404))->BgL_varz00) = ((BgL_ev_varz00_bglt) BgL_varz00_2403), BUNSPEC);
																																																	{
																																																		BgL_ev_exprz00_bglt
																																																			BgL_auxz00_6685;
																																																		{	/* Eval/evaluate.scm 574 */
																																																			obj_t
																																																				BgL_arg2259z00_2405;
																																																			BgL_arg2259z00_2405
																																																				=
																																																				MAKE_PAIR
																																																				(
																																																				((obj_t) BgL_varz00_2403), BgL_localsz00_70);
																																																			BgL_auxz00_6685
																																																				=
																																																				(
																																																				(BgL_ev_exprz00_bglt)
																																																				BGl_convzd2beginzd2zz__evaluatez00
																																																				(BgL_bodyz00_1449,
																																																					BgL_arg2259z00_2405,
																																																					BgL_globalsz00_71,
																																																					BFALSE,
																																																					BgL_wherez00_73,
																																																					BgL_locz00_74,
																																																					((bool_t) 0)));
																																																		}
																																																		((((BgL_ev_bindzd2exitzd2_bglt) CREF(BgL_new1150z00_2404))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6685), BUNSPEC);
																																																	}
																																																	BgL_auxz00_6666
																																																		=
																																																		BgL_new1150z00_2404;
																																															}}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6666);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg1800z00_1765;
																																														obj_t
																																															BgL_arg1801z00_1766;
																																														BgL_arg1800z00_1765
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1801z00_1766
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6694;
																																															{
																																																obj_t
																																																	BgL_argsz00_6696;
																																																obj_t
																																																	BgL_fz00_6695;
																																																BgL_fz00_6695
																																																	=
																																																	BgL_arg1800z00_1765;
																																																BgL_argsz00_6696
																																																	=
																																																	BgL_arg1801z00_1766;
																																																BgL_argsz00_1468
																																																	=
																																																	BgL_argsz00_6696;
																																																BgL_fz00_1467
																																																	=
																																																	BgL_fz00_6695;
																																																goto
																																																	BgL_tagzd2175zd2_1469;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6694);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg1803z00_1768;
																																												obj_t
																																													BgL_arg1804z00_1769;
																																												BgL_arg1803z00_1768
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg1804z00_1769
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6700;
																																													{
																																														obj_t
																																															BgL_argsz00_6702;
																																														obj_t
																																															BgL_fz00_6701;
																																														BgL_fz00_6701
																																															=
																																															BgL_arg1803z00_1768;
																																														BgL_argsz00_6702
																																															=
																																															BgL_arg1804z00_1769;
																																														BgL_argsz00_1468
																																															=
																																															BgL_argsz00_6702;
																																														BgL_fz00_1467
																																															=
																																															BgL_fz00_6701;
																																														goto
																																															BgL_tagzd2175zd2_1469;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6700);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_arg1805z00_1770;
																																										obj_t
																																											BgL_arg1807z00_1771;
																																										BgL_arg1805z00_1770
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg1807z00_1771
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_6706;
																																											{
																																												obj_t
																																													BgL_argsz00_6708;
																																												obj_t
																																													BgL_fz00_6707;
																																												BgL_fz00_6707
																																													=
																																													BgL_arg1805z00_1770;
																																												BgL_argsz00_6708
																																													=
																																													BgL_arg1807z00_1771;
																																												BgL_argsz00_1468
																																													=
																																													BgL_argsz00_6708;
																																												BgL_fz00_1467
																																													=
																																													BgL_fz00_6707;
																																												goto
																																													BgL_tagzd2175zd2_1469;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_6706);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_cdrzd28425zd2_1772;
																																								BgL_cdrzd28425zd2_1772
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								if ((CAR(BgL_ez00_69) == BGl_symbol3054z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 425 */
																																										if (PAIRP(BgL_cdrzd28425zd2_1772))
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg1810z00_1775;
																																												obj_t
																																													BgL_arg1811z00_1776;
																																												BgL_arg1810z00_1775
																																													=
																																													CAR
																																													(BgL_cdrzd28425zd2_1772);
																																												BgL_arg1811z00_1776
																																													=
																																													CDR
																																													(BgL_cdrzd28425zd2_1772);
																																												{
																																													BgL_ev_unwindzd2protectzd2_bglt
																																														BgL_auxz00_6718;
																																													BgL_ez00_1451
																																														=
																																														BgL_arg1810z00_1775;
																																													BgL_bodyz00_1452
																																														=
																																														BgL_arg1811z00_1776;
																																												BgL_tagzd2170zd2_1453:
																																													{	/* Eval/evaluate.scm 576 */
																																														BgL_ev_unwindzd2protectzd2_bglt
																																															BgL_new1152z00_2411;
																																														{	/* Eval/evaluate.scm 577 */
																																															BgL_ev_unwindzd2protectzd2_bglt
																																																BgL_new1151z00_2412;
																																															BgL_new1151z00_2412
																																																=
																																																(
																																																(BgL_ev_unwindzd2protectzd2_bglt)
																																																BREF
																																																(GC_MALLOC
																																																	(sizeof
																																																		(struct
																																																			BgL_ev_unwindzd2protectzd2_bgl))));
																																															{	/* Eval/evaluate.scm 577 */
																																																long
																																																	BgL_arg2262z00_2413;
																																																{	/* Eval/evaluate.scm 577 */
																																																	long
																																																		BgL_res2748z00_3836;
																																																	BgL_res2748z00_3836
																																																		=
																																																		BGL_CLASS_INDEX
																																																		(BGl_ev_unwindzd2protectzd2zz__evaluate_typesz00);
																																																	BgL_arg2262z00_2413
																																																		=
																																																		BgL_res2748z00_3836;
																																																}
																																																BGL_OBJECT_CLASS_NUM_SET
																																																	(
																																																	((BgL_objectz00_bglt) BgL_new1151z00_2412), BgL_arg2262z00_2413);
																																															}
																																															{	/* Eval/evaluate.scm 577 */
																																																BgL_objectz00_bglt
																																																	BgL_auxz00_6723;
																																																BgL_auxz00_6723
																																																	=
																																																	(
																																																	(BgL_objectz00_bglt)
																																																	BgL_new1151z00_2412);
																																																BGL_OBJECT_WIDENING_SET
																																																	(BgL_auxz00_6723,
																																																	BFALSE);
																																															}
																																															BgL_new1152z00_2411
																																																=
																																																BgL_new1151z00_2412;
																																														}
																																														{
																																															BgL_ev_exprz00_bglt
																																																BgL_auxz00_6726;
																																															{	/* Eval/evaluate.scm 381 */
																																																obj_t
																																																	BgL_arg2308z00_3840;
																																																{	/* Eval/evaluate.scm 145 */
																																																	obj_t
																																																		BgL__ortest_1067z00_3843;
																																																	BgL__ortest_1067z00_3843
																																																		=
																																																		BGl_getzd2sourcezd2locationz00zz__readerz00
																																																		(BgL_ez00_1451);
																																																	if (CBOOL(BgL__ortest_1067z00_3843))
																																																		{	/* Eval/evaluate.scm 145 */
																																																			BgL_arg2308z00_3840
																																																				=
																																																				BgL__ortest_1067z00_3843;
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 145 */
																																																			BgL_arg2308z00_3840
																																																				=
																																																				BgL_locz00_74;
																																																		}
																																																}
																																																BgL_auxz00_6726
																																																	=
																																																	(
																																																	(BgL_ev_exprz00_bglt)
																																																	BGl_convz00zz__evaluatez00
																																																	(BgL_ez00_1451,
																																																		BgL_localsz00_70,
																																																		BgL_globalsz00_71,
																																																		BFALSE,
																																																		BgL_wherez00_73,
																																																		BgL_arg2308z00_3840,
																																																		((bool_t) 0)));
																																															}
																																															((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1152z00_2411))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6726), BUNSPEC);
																																														}
																																														((((BgL_ev_unwindzd2protectzd2_bglt) CREF(BgL_new1152z00_2411))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1452, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																														BgL_auxz00_6718
																																															=
																																															BgL_new1152z00_2411;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6718);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg1812z00_1777;
																																												BgL_arg1812z00_1777
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_6738;
																																													{
																																														obj_t
																																															BgL_argsz00_6740;
																																														obj_t
																																															BgL_fz00_6739;
																																														BgL_fz00_6739
																																															=
																																															BgL_arg1812z00_1777;
																																														BgL_argsz00_6740
																																															=
																																															BgL_cdrzd28425zd2_1772;
																																														BgL_argsz00_1468
																																															=
																																															BgL_argsz00_6740;
																																														BgL_fz00_1467
																																															=
																																															BgL_fz00_6739;
																																														goto
																																															BgL_tagzd2175zd2_1469;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_6738);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										if ((CAR(BgL_ez00_69) == BGl_symbol3056z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 425 */
																																												if (PAIRP(BgL_cdrzd28425zd2_1772))
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg1816z00_1782;
																																														obj_t
																																															BgL_arg1817z00_1783;
																																														BgL_arg1816z00_1782
																																															=
																																															CAR
																																															(BgL_cdrzd28425zd2_1772);
																																														BgL_arg1817z00_1783
																																															=
																																															CDR
																																															(BgL_cdrzd28425zd2_1772);
																																														{
																																															BgL_ev_withzd2handlerzd2_bglt
																																																BgL_auxz00_6749;
																																															BgL_hz00_1454
																																																=
																																																BgL_arg1816z00_1782;
																																															BgL_bodyz00_1455
																																																=
																																																BgL_arg1817z00_1783;
																																														BgL_tagzd2171zd2_1456:
																																															{	/* Eval/evaluate.scm 580 */
																																																BgL_ev_withzd2handlerzd2_bglt
																																																	BgL_new1154z00_2414;
																																																{	/* Eval/evaluate.scm 581 */
																																																	BgL_ev_withzd2handlerzd2_bglt
																																																		BgL_new1153z00_2415;
																																																	BgL_new1153z00_2415
																																																		=
																																																		(
																																																		(BgL_ev_withzd2handlerzd2_bglt)
																																																		BREF
																																																		(GC_MALLOC
																																																			(sizeof
																																																				(struct
																																																					BgL_ev_withzd2handlerzd2_bgl))));
																																																	{	/* Eval/evaluate.scm 581 */
																																																		long
																																																			BgL_arg2263z00_2416;
																																																		{	/* Eval/evaluate.scm 581 */
																																																			long
																																																				BgL_res2749z00_3847;
																																																			BgL_res2749z00_3847
																																																				=
																																																				BGL_CLASS_INDEX
																																																				(BGl_ev_withzd2handlerzd2zz__evaluate_typesz00);
																																																			BgL_arg2263z00_2416
																																																				=
																																																				BgL_res2749z00_3847;
																																																		}
																																																		BGL_OBJECT_CLASS_NUM_SET
																																																			(
																																																			((BgL_objectz00_bglt) BgL_new1153z00_2415), BgL_arg2263z00_2416);
																																																	}
																																																	{	/* Eval/evaluate.scm 581 */
																																																		BgL_objectz00_bglt
																																																			BgL_auxz00_6754;
																																																		BgL_auxz00_6754
																																																			=
																																																			(
																																																			(BgL_objectz00_bglt)
																																																			BgL_new1153z00_2415);
																																																		BGL_OBJECT_WIDENING_SET
																																																			(BgL_auxz00_6754,
																																																			BFALSE);
																																																	}
																																																	BgL_new1154z00_2414
																																																		=
																																																		BgL_new1153z00_2415;
																																																}
																																																{
																																																	BgL_ev_exprz00_bglt
																																																		BgL_auxz00_6757;
																																																	{	/* Eval/evaluate.scm 381 */
																																																		obj_t
																																																			BgL_arg2308z00_3851;
																																																		{	/* Eval/evaluate.scm 145 */
																																																			obj_t
																																																				BgL__ortest_1067z00_3854;
																																																			BgL__ortest_1067z00_3854
																																																				=
																																																				BGl_getzd2sourcezd2locationz00zz__readerz00
																																																				(BgL_hz00_1454);
																																																			if (CBOOL(BgL__ortest_1067z00_3854))
																																																				{	/* Eval/evaluate.scm 145 */
																																																					BgL_arg2308z00_3851
																																																						=
																																																						BgL__ortest_1067z00_3854;
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 145 */
																																																					BgL_arg2308z00_3851
																																																						=
																																																						BgL_locz00_74;
																																																				}
																																																		}
																																																		BgL_auxz00_6757
																																																			=
																																																			(
																																																			(BgL_ev_exprz00_bglt)
																																																			BGl_convz00zz__evaluatez00
																																																			(BgL_hz00_1454,
																																																				BgL_localsz00_70,
																																																				BgL_globalsz00_71,
																																																				BFALSE,
																																																				BgL_wherez00_73,
																																																				BgL_arg2308z00_3851,
																																																				((bool_t) 0)));
																																																	}
																																																	((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1154z00_2414))->BgL_handlerz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6757), BUNSPEC);
																																																}
																																																((((BgL_ev_withzd2handlerzd2_bglt) CREF(BgL_new1154z00_2414))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1455, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																BgL_auxz00_6749
																																																	=
																																																	BgL_new1154z00_2414;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6749);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg1818z00_1784;
																																														obj_t
																																															BgL_arg1819z00_1785;
																																														BgL_arg1818z00_1784
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg1819z00_1785
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_6770;
																																															{
																																																obj_t
																																																	BgL_argsz00_6772;
																																																obj_t
																																																	BgL_fz00_6771;
																																																BgL_fz00_6771
																																																	=
																																																	BgL_arg1818z00_1784;
																																																BgL_argsz00_6772
																																																	=
																																																	BgL_arg1819z00_1785;
																																																BgL_argsz00_1468
																																																	=
																																																	BgL_argsz00_6772;
																																																BgL_fz00_1467
																																																	=
																																																	BgL_fz00_6771;
																																																goto
																																																	BgL_tagzd2175zd2_1469;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_6770);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_cdrzd28528zd2_1786;
																																												BgL_cdrzd28528zd2_1786
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												if ((CAR(BgL_ez00_69) == BGl_symbol3058z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 425 */
																																														if (PAIRP(BgL_cdrzd28528zd2_1786))
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd28533zd2_1789;
																																																BgL_cdrzd28533zd2_1789
																																																	=
																																																	CDR
																																																	(BgL_cdrzd28528zd2_1786);
																																																if (PAIRP(BgL_cdrzd28533zd2_1789))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_cdrzd28538zd2_1791;
																																																		BgL_cdrzd28538zd2_1791
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28533zd2_1789);
																																																		if ((CAR(BgL_cdrzd28533zd2_1789) == BGl_keyword3060z00zz__evaluatez00))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				if (PAIRP(BgL_cdrzd28538zd2_1791))
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1825z00_1794;
																																																						obj_t
																																																							BgL_arg1826z00_1795;
																																																						obj_t
																																																							BgL_arg1827z00_1796;
																																																						BgL_arg1825z00_1794
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28528zd2_1786);
																																																						BgL_arg1826z00_1795
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28538zd2_1791);
																																																						BgL_arg1827z00_1796
																																																							=
																																																							CDR
																																																							(BgL_cdrzd28538zd2_1791);
																																																						{
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_auxz00_6792;
																																																							BgL_mz00_1457
																																																								=
																																																								BgL_arg1825z00_1794;
																																																							BgL_pz00_1458
																																																								=
																																																								BgL_arg1826z00_1795;
																																																							BgL_bodyz00_1459
																																																								=
																																																								BgL_arg1827z00_1796;
																																																						BgL_tagzd2172zd2_1460:
																																																							{	/* Eval/evaluate.scm 584 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1156z00_2417;
																																																								{	/* Eval/evaluate.scm 585 */
																																																									BgL_ev_synchroniza7eza7_bglt
																																																										BgL_new1155z00_2418;
																																																									BgL_new1155z00_2418
																																																										=
																																																										(
																																																										(BgL_ev_synchroniza7eza7_bglt)
																																																										BREF
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_synchroniza7eza7_bgl))));
																																																									{	/* Eval/evaluate.scm 585 */
																																																										long
																																																											BgL_arg2264z00_2419;
																																																										{	/* Eval/evaluate.scm 585 */
																																																											long
																																																												BgL_res2750z00_3858;
																																																											BgL_res2750z00_3858
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																											BgL_arg2264z00_2419
																																																												=
																																																												BgL_res2750z00_3858;
																																																										}
																																																										BGL_OBJECT_CLASS_NUM_SET
																																																											(
																																																											((BgL_objectz00_bglt) BgL_new1155z00_2418), BgL_arg2264z00_2419);
																																																									}
																																																									{	/* Eval/evaluate.scm 585 */
																																																										BgL_objectz00_bglt
																																																											BgL_auxz00_6797;
																																																										BgL_auxz00_6797
																																																											=
																																																											(
																																																											(BgL_objectz00_bglt)
																																																											BgL_new1155z00_2418);
																																																										BGL_OBJECT_WIDENING_SET
																																																											(BgL_auxz00_6797,
																																																											BFALSE);
																																																									}
																																																									BgL_new1156z00_2417
																																																										=
																																																										BgL_new1155z00_2418;
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1156z00_2417))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6801;
																																																									{	/* Eval/evaluate.scm 381 */
																																																										obj_t
																																																											BgL_arg2308z00_3862;
																																																										{	/* Eval/evaluate.scm 145 */
																																																											obj_t
																																																												BgL__ortest_1067z00_3865;
																																																											BgL__ortest_1067z00_3865
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_mz00_1457);
																																																											if (CBOOL(BgL__ortest_1067z00_3865))
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3862
																																																														=
																																																														BgL__ortest_1067z00_3865;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3862
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6801
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_mz00_1457,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2308z00_3862,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1156z00_2417))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6801), BUNSPEC);
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6808;
																																																									{	/* Eval/evaluate.scm 381 */
																																																										obj_t
																																																											BgL_arg2308z00_3869;
																																																										{	/* Eval/evaluate.scm 145 */
																																																											obj_t
																																																												BgL__ortest_1067z00_3872;
																																																											BgL__ortest_1067z00_3872
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_pz00_1458);
																																																											if (CBOOL(BgL__ortest_1067z00_3872))
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3869
																																																														=
																																																														BgL__ortest_1067z00_3872;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3869
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6808
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_pz00_1458,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2308z00_3869,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1156z00_2417))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6808), BUNSPEC);
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1156z00_2417))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1459, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																								BgL_auxz00_6792
																																																									=
																																																									BgL_new1156z00_2417;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6792);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1829z00_1798;
																																																						obj_t
																																																							BgL_arg1830z00_1799;
																																																						BgL_arg1829z00_1798
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28528zd2_1786);
																																																						BgL_arg1830z00_1799
																																																							=
																																																							CDR
																																																							(BgL_cdrzd28528zd2_1786);
																																																						{
																																																							BgL_ev_synchroniza7eza7_bglt
																																																								BgL_auxz00_6821;
																																																							BgL_mz00_1461
																																																								=
																																																								BgL_arg1829z00_1798;
																																																							BgL_bodyz00_1462
																																																								=
																																																								BgL_arg1830z00_1799;
																																																						BgL_tagzd2173zd2_1463:
																																																							{	/* Eval/evaluate.scm 590 */
																																																								BgL_ev_synchroniza7eza7_bglt
																																																									BgL_new1158z00_2420;
																																																								{	/* Eval/evaluate.scm 591 */
																																																									BgL_ev_synchroniza7eza7_bglt
																																																										BgL_new1157z00_2421;
																																																									BgL_new1157z00_2421
																																																										=
																																																										(
																																																										(BgL_ev_synchroniza7eza7_bglt)
																																																										BREF
																																																										(GC_MALLOC
																																																											(sizeof
																																																												(struct
																																																													BgL_ev_synchroniza7eza7_bgl))));
																																																									{	/* Eval/evaluate.scm 591 */
																																																										long
																																																											BgL_arg2265z00_2422;
																																																										{	/* Eval/evaluate.scm 591 */
																																																											long
																																																												BgL_res2751z00_3876;
																																																											BgL_res2751z00_3876
																																																												=
																																																												BGL_CLASS_INDEX
																																																												(BGl_ev_synchroniza7eza7zz__evaluate_typesz00);
																																																											BgL_arg2265z00_2422
																																																												=
																																																												BgL_res2751z00_3876;
																																																										}
																																																										BGL_OBJECT_CLASS_NUM_SET
																																																											(
																																																											((BgL_objectz00_bglt) BgL_new1157z00_2421), BgL_arg2265z00_2422);
																																																									}
																																																									{	/* Eval/evaluate.scm 591 */
																																																										BgL_objectz00_bglt
																																																											BgL_auxz00_6826;
																																																										BgL_auxz00_6826
																																																											=
																																																											(
																																																											(BgL_objectz00_bglt)
																																																											BgL_new1157z00_2421);
																																																										BGL_OBJECT_WIDENING_SET
																																																											(BgL_auxz00_6826,
																																																											BFALSE);
																																																									}
																																																									BgL_new1158z00_2420
																																																										=
																																																										BgL_new1157z00_2421;
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1158z00_2420))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6830;
																																																									{	/* Eval/evaluate.scm 381 */
																																																										obj_t
																																																											BgL_arg2308z00_3880;
																																																										{	/* Eval/evaluate.scm 145 */
																																																											obj_t
																																																												BgL__ortest_1067z00_3883;
																																																											BgL__ortest_1067z00_3883
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BgL_mz00_1461);
																																																											if (CBOOL(BgL__ortest_1067z00_3883))
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3880
																																																														=
																																																														BgL__ortest_1067z00_3883;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3880
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6830
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BgL_mz00_1461,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2308z00_3880,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1158z00_2420))->BgL_mutexz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6830), BUNSPEC);
																																																								}
																																																								{
																																																									BgL_ev_exprz00_bglt
																																																										BgL_auxz00_6837;
																																																									{	/* Eval/evaluate.scm 381 */
																																																										obj_t
																																																											BgL_arg2308z00_3887;
																																																										{	/* Eval/evaluate.scm 145 */
																																																											obj_t
																																																												BgL__ortest_1067z00_3890;
																																																											BgL__ortest_1067z00_3890
																																																												=
																																																												BGl_getzd2sourcezd2locationz00zz__readerz00
																																																												(BNIL);
																																																											if (CBOOL(BgL__ortest_1067z00_3890))
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3887
																																																														=
																																																														BgL__ortest_1067z00_3890;
																																																												}
																																																											else
																																																												{	/* Eval/evaluate.scm 145 */
																																																													BgL_arg2308z00_3887
																																																														=
																																																														BgL_locz00_74;
																																																												}
																																																										}
																																																										BgL_auxz00_6837
																																																											=
																																																											(
																																																											(BgL_ev_exprz00_bglt)
																																																											BGl_convz00zz__evaluatez00
																																																											(BNIL,
																																																												BgL_localsz00_70,
																																																												BgL_globalsz00_71,
																																																												BFALSE,
																																																												BgL_wherez00_73,
																																																												BgL_arg2308z00_3887,
																																																												((bool_t) 0)));
																																																									}
																																																									((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1158z00_2420))->BgL_prelockz00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_6837), BUNSPEC);
																																																								}
																																																								((((BgL_ev_synchroniza7eza7_bglt) CREF(BgL_new1158z00_2420))->BgL_bodyz00) = ((BgL_ev_exprz00_bglt) ((BgL_ev_exprz00_bglt) BGl_convzd2beginzd2zz__evaluatez00(BgL_bodyz00_1462, BgL_localsz00_70, BgL_globalsz00_71, BFALSE, BgL_wherez00_73, BgL_locz00_74, ((bool_t) 0)))), BUNSPEC);
																																																								BgL_auxz00_6821
																																																									=
																																																									BgL_new1158z00_2420;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6821);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg1831z00_1801;
																																																				obj_t
																																																					BgL_arg1832z00_1802;
																																																				BgL_arg1831z00_1801
																																																					=
																																																					CAR
																																																					(BgL_cdrzd28528zd2_1786);
																																																				BgL_arg1832z00_1802
																																																					=
																																																					CDR
																																																					(BgL_cdrzd28528zd2_1786);
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_6850;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_6852;
																																																						obj_t
																																																							BgL_mz00_6851;
																																																						BgL_mz00_6851
																																																							=
																																																							BgL_arg1831z00_1801;
																																																						BgL_bodyz00_6852
																																																							=
																																																							BgL_arg1832z00_1802;
																																																						BgL_bodyz00_1462
																																																							=
																																																							BgL_bodyz00_6852;
																																																						BgL_mz00_1461
																																																							=
																																																							BgL_mz00_6851;
																																																						goto
																																																							BgL_tagzd2173zd2_1463;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6850);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg1834z00_1805;
																																																		obj_t
																																																			BgL_arg1835z00_1806;
																																																		BgL_arg1834z00_1805
																																																			=
																																																			CAR
																																																			(BgL_cdrzd28528zd2_1786);
																																																		BgL_arg1835z00_1806
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28528zd2_1786);
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_6856;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_6858;
																																																				obj_t
																																																					BgL_mz00_6857;
																																																				BgL_mz00_6857
																																																					=
																																																					BgL_arg1834z00_1805;
																																																				BgL_bodyz00_6858
																																																					=
																																																					BgL_arg1835z00_1806;
																																																				BgL_bodyz00_1462
																																																					=
																																																					BgL_bodyz00_6858;
																																																				BgL_mz00_1461
																																																					=
																																																					BgL_mz00_6857;
																																																				goto
																																																					BgL_tagzd2173zd2_1463;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6856);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg1836z00_1807;
																																																BgL_arg1836z00_1807
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6861;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6863;
																																																		obj_t
																																																			BgL_fz00_6862;
																																																		BgL_fz00_6862
																																																			=
																																																			BgL_arg1836z00_1807;
																																																		BgL_argsz00_6863
																																																			=
																																																			BgL_cdrzd28528zd2_1786;
																																																		BgL_argsz00_1468
																																																			=
																																																			BgL_argsz00_6863;
																																																		BgL_fz00_1467
																																																			=
																																																			BgL_fz00_6862;
																																																		goto
																																																			BgL_tagzd2175zd2_1469;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6861);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														if ((CAR(BgL_ez00_69) == BGl_symbol3015z00zz__evaluatez00))
																																															{	/* Eval/evaluate.scm 425 */
																																																if (PAIRP(BgL_cdrzd28528zd2_1786))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_cdrzd28638zd2_1812;
																																																		BgL_cdrzd28638zd2_1812
																																																			=
																																																			CDR
																																																			(BgL_cdrzd28528zd2_1786);
																																																		if (PAIRP(BgL_cdrzd28638zd2_1812))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				if (NULLP(CDR(BgL_cdrzd28638zd2_1812)))
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1842z00_1815;
																																																						obj_t
																																																							BgL_arg1843z00_1816;
																																																						BgL_arg1842z00_1815
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28528zd2_1786);
																																																						BgL_arg1843z00_1816
																																																							=
																																																							CAR
																																																							(BgL_cdrzd28638zd2_1812);
																																																						{	/* Eval/evaluate.scm 596 */
																																																							obj_t
																																																								BgL_arg2267z00_4351;
																																																							{	/* Eval/evaluate.scm 596 */
																																																								obj_t
																																																									BgL_arg2268z00_4352;
																																																								{	/* Eval/evaluate.scm 596 */
																																																									obj_t
																																																										BgL_arg2269z00_4353;
																																																									obj_t
																																																										BgL_arg2270z00_4354;
																																																									{	/* Eval/evaluate.scm 596 */
																																																										obj_t
																																																											BgL_res2831z00_4357;
																																																										{	/* Eval/evaluate.scm 596 */
																																																											obj_t
																																																												BgL_symbolz00_4355;
																																																											BgL_symbolz00_4355
																																																												=
																																																												BGl_symbol3062z00zz__evaluatez00;
																																																											{	/* Eval/evaluate.scm 596 */
																																																												obj_t
																																																													BgL_arg2423z00_4356;
																																																												BgL_arg2423z00_4356
																																																													=
																																																													SYMBOL_TO_STRING
																																																													(BgL_symbolz00_4355);
																																																												BgL_res2831z00_4357
																																																													=
																																																													BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																													(BgL_arg2423z00_4356);
																																																											}
																																																										}
																																																										BgL_arg2269z00_4353
																																																											=
																																																											BgL_res2831z00_4357;
																																																									}
																																																									{	/* Eval/evaluate.scm 596 */
																																																										obj_t
																																																											BgL_res2832z00_4360;
																																																										{	/* Eval/evaluate.scm 596 */
																																																											obj_t
																																																												BgL_arg2423z00_4359;
																																																											BgL_arg2423z00_4359
																																																												=
																																																												SYMBOL_TO_STRING
																																																												(BgL_wherez00_73);
																																																											BgL_res2832z00_4360
																																																												=
																																																												BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																												(BgL_arg2423z00_4359);
																																																										}
																																																										BgL_arg2270z00_4354
																																																											=
																																																											BgL_res2832z00_4360;
																																																									}
																																																									BgL_arg2268z00_4352
																																																										=
																																																										string_append
																																																										(BgL_arg2269z00_4353,
																																																										BgL_arg2270z00_4354);
																																																								}
																																																								BgL_arg2267z00_4351
																																																									=
																																																									bstring_to_symbol
																																																									(BgL_arg2268z00_4352);
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BGl_convzd2lambdazd2zz__evaluatez00
																																																								(BgL_globalsz00_71,
																																																									BgL_localsz00_70,
																																																									BgL_ez00_69,
																																																									BgL_locz00_74,
																																																									BgL_arg1842z00_1815,
																																																									BgL_arg1843z00_1816,
																																																									BgL_arg2267z00_4351,
																																																									BFALSE));
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1845z00_1817;
																																																						obj_t
																																																							BgL_arg1846z00_1818;
																																																						BgL_arg1845z00_1817
																																																							=
																																																							CAR
																																																							(BgL_ez00_69);
																																																						BgL_arg1846z00_1818
																																																							=
																																																							CDR
																																																							(BgL_ez00_69);
																																																						{
																																																							BgL_ev_appz00_bglt
																																																								BgL_auxz00_6888;
																																																							{
																																																								obj_t
																																																									BgL_argsz00_6890;
																																																								obj_t
																																																									BgL_fz00_6889;
																																																								BgL_fz00_6889
																																																									=
																																																									BgL_arg1845z00_1817;
																																																								BgL_argsz00_6890
																																																									=
																																																									BgL_arg1846z00_1818;
																																																								BgL_argsz00_1468
																																																									=
																																																									BgL_argsz00_6890;
																																																								BgL_fz00_1467
																																																									=
																																																									BgL_fz00_6889;
																																																								goto
																																																									BgL_tagzd2175zd2_1469;
																																																							}
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_auxz00_6888);
																																																						}
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg1848z00_1820;
																																																				obj_t
																																																					BgL_arg1849z00_1821;
																																																				BgL_arg1848z00_1820
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg1849z00_1821
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_6894;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_6896;
																																																						obj_t
																																																							BgL_fz00_6895;
																																																						BgL_fz00_6895
																																																							=
																																																							BgL_arg1848z00_1820;
																																																						BgL_argsz00_6896
																																																							=
																																																							BgL_arg1849z00_1821;
																																																						BgL_argsz00_1468
																																																							=
																																																							BgL_argsz00_6896;
																																																						BgL_fz00_1467
																																																							=
																																																							BgL_fz00_6895;
																																																						goto
																																																							BgL_tagzd2175zd2_1469;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_6894);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg1850z00_1822;
																																																		obj_t
																																																			BgL_arg1851z00_1823;
																																																		BgL_arg1850z00_1822
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg1851z00_1823
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_6900;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_6902;
																																																				obj_t
																																																					BgL_fz00_6901;
																																																				BgL_fz00_6901
																																																					=
																																																					BgL_arg1850z00_1822;
																																																				BgL_argsz00_6902
																																																					=
																																																					BgL_arg1851z00_1823;
																																																				BgL_argsz00_1468
																																																					=
																																																					BgL_argsz00_6902;
																																																				BgL_fz00_1467
																																																					=
																																																					BgL_fz00_6901;
																																																				goto
																																																					BgL_tagzd2175zd2_1469;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_6900);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg1853z00_1824;
																																																obj_t
																																																	BgL_arg1854z00_1825;
																																																BgL_arg1853z00_1824
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg1854z00_1825
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_6906;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_6908;
																																																		obj_t
																																																			BgL_fz00_6907;
																																																		BgL_fz00_6907
																																																			=
																																																			BgL_arg1853z00_1824;
																																																		BgL_argsz00_6908
																																																			=
																																																			BgL_arg1854z00_1825;
																																																		BgL_argsz00_1468
																																																			=
																																																			BgL_argsz00_6908;
																																																		BgL_fz00_1467
																																																			=
																																																			BgL_fz00_6907;
																																																		goto
																																																			BgL_tagzd2175zd2_1469;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_6906);
																																																}
																																															}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
												else
													{	/* Eval/evaluate.scm 425 */
														if (
															(BgL_carzd23820zd2_1533 ==
																BGl_symbol3038z00zz__evaluatez00))
															{	/* Eval/evaluate.scm 425 */
																if (PAIRP(BgL_cdrzd2249zd2_1475))
																	{	/* Eval/evaluate.scm 425 */
																		if (NULLP(CDR(BgL_cdrzd2249zd2_1475)))
																			{	/* Eval/evaluate.scm 425 */
																				obj_t BgL_arg1874z00_1847;

																				BgL_arg1874z00_1847 =
																					CAR(BgL_cdrzd2249zd2_1475);
																				{
																					BgL_ev_trapz00_bglt BgL_auxz00_6918;

																					{
																						obj_t BgL_ez00_6919;

																						BgL_ez00_6919 = BgL_arg1874z00_1847;
																						BgL_ez00_1404 = BgL_ez00_6919;
																						goto BgL_tagzd2153zd2_1405;
																					}
																					return ((obj_t) BgL_auxz00_6918);
																				}
																			}
																		else
																			{	/* Eval/evaluate.scm 425 */
																				obj_t BgL_arg1875z00_1848;
																				obj_t BgL_arg1876z00_1849;

																				BgL_arg1875z00_1848 = CAR(BgL_ez00_69);
																				BgL_arg1876z00_1849 = CDR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6923;

																					{
																						obj_t BgL_argsz00_6925;
																						obj_t BgL_fz00_6924;

																						BgL_fz00_6924 = BgL_arg1875z00_1848;
																						BgL_argsz00_6925 =
																							BgL_arg1876z00_1849;
																						BgL_argsz00_1468 = BgL_argsz00_6925;
																						BgL_fz00_1467 = BgL_fz00_6924;
																						goto BgL_tagzd2175zd2_1469;
																					}
																					return ((obj_t) BgL_auxz00_6923);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 425 */
																		obj_t BgL_arg1878z00_1851;
																		obj_t BgL_arg1879z00_1852;

																		BgL_arg1878z00_1851 = CAR(BgL_ez00_69);
																		BgL_arg1879z00_1852 = CDR(BgL_ez00_69);
																		{
																			BgL_ev_appz00_bglt BgL_auxz00_6929;

																			{
																				obj_t BgL_argsz00_6931;
																				obj_t BgL_fz00_6930;

																				BgL_fz00_6930 = BgL_arg1878z00_1851;
																				BgL_argsz00_6931 = BgL_arg1879z00_1852;
																				BgL_argsz00_1468 = BgL_argsz00_6931;
																				BgL_fz00_1467 = BgL_fz00_6930;
																				goto BgL_tagzd2175zd2_1469;
																			}
																			return ((obj_t) BgL_auxz00_6929);
																		}
																	}
															}
														else
															{	/* Eval/evaluate.scm 425 */
																obj_t BgL_cdrzd29337zd2_1853;

																BgL_cdrzd29337zd2_1853 = CDR(BgL_ez00_69);
																if (
																	(CAR(BgL_ez00_69) ==
																		BGl_symbol3003z00zz__evaluatez00))
																	{	/* Eval/evaluate.scm 425 */
																		if (PAIRP(BgL_cdrzd29337zd2_1853))
																			{	/* Eval/evaluate.scm 425 */
																				if (NULLP(CDR(BgL_cdrzd29337zd2_1853)))
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_arg1883z00_1857;

																						BgL_arg1883z00_1857 =
																							CAR(BgL_cdrzd29337zd2_1853);
																						{	/* Eval/evaluate.scm 460 */
																							BgL_ev_littz00_bglt
																								BgL_new1112z00_4392;
																							{	/* Eval/evaluate.scm 461 */
																								BgL_ev_littz00_bglt
																									BgL_new1110z00_4393;
																								BgL_new1110z00_4393 =
																									((BgL_ev_littz00_bglt)
																									BREF(GC_MALLOC(sizeof(struct
																												BgL_ev_littz00_bgl))));
																								{	/* Eval/evaluate.scm 461 */
																									long BgL_arg2154z00_4394;

																									{	/* Eval/evaluate.scm 461 */
																										long BgL_res2838z00_4396;

																										BgL_res2838z00_4396 =
																											BGL_CLASS_INDEX
																											(BGl_ev_littz00zz__evaluate_typesz00);
																										BgL_arg2154z00_4394 =
																											BgL_res2838z00_4396;
																									}
																									BGL_OBJECT_CLASS_NUM_SET(
																										((BgL_objectz00_bglt)
																											BgL_new1110z00_4393),
																										BgL_arg2154z00_4394);
																								}
																								{	/* Eval/evaluate.scm 461 */
																									BgL_objectz00_bglt
																										BgL_auxz00_6947;
																									BgL_auxz00_6947 =
																										((BgL_objectz00_bglt)
																										BgL_new1110z00_4393);
																									BGL_OBJECT_WIDENING_SET
																										(BgL_auxz00_6947, BFALSE);
																								}
																								BgL_new1112z00_4392 =
																									BgL_new1110z00_4393;
																							}
																							((((BgL_ev_littz00_bglt)
																										CREF(BgL_new1112z00_4392))->
																									BgL_valuez00) =
																								((obj_t) BgL_arg1883z00_1857),
																								BUNSPEC);
																							return ((obj_t)
																								BgL_new1112z00_4392);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_arg1884z00_1858;

																						BgL_arg1884z00_1858 =
																							CAR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_6953;
																							{
																								obj_t BgL_argsz00_6955;
																								obj_t BgL_fz00_6954;

																								BgL_fz00_6954 =
																									BgL_arg1884z00_1858;
																								BgL_argsz00_6955 =
																									BgL_cdrzd29337zd2_1853;
																								BgL_argsz00_1468 =
																									BgL_argsz00_6955;
																								BgL_fz00_1467 = BgL_fz00_6954;
																								goto BgL_tagzd2175zd2_1469;
																							}
																							return ((obj_t) BgL_auxz00_6953);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 425 */
																				obj_t BgL_arg1887z00_1861;

																				BgL_arg1887z00_1861 = CAR(BgL_ez00_69);
																				{
																					BgL_ev_appz00_bglt BgL_auxz00_6958;

																					{
																						obj_t BgL_argsz00_6960;
																						obj_t BgL_fz00_6959;

																						BgL_fz00_6959 = BgL_arg1887z00_1861;
																						BgL_argsz00_6960 =
																							BgL_cdrzd29337zd2_1853;
																						BgL_argsz00_1468 = BgL_argsz00_6960;
																						BgL_fz00_1467 = BgL_fz00_6959;
																						goto BgL_tagzd2175zd2_1469;
																					}
																					return ((obj_t) BgL_auxz00_6958);
																				}
																			}
																	}
																else
																	{	/* Eval/evaluate.scm 425 */
																		if (
																			(CAR(BgL_ez00_69) ==
																				BGl_symbol3011z00zz__evaluatez00))
																			{	/* Eval/evaluate.scm 425 */
																				if (PAIRP(BgL_cdrzd29337zd2_1853))
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_cdrzd29947zd2_1866;

																						BgL_cdrzd29947zd2_1866 =
																							CDR(BgL_cdrzd29337zd2_1853);
																						if (PAIRP(BgL_cdrzd29947zd2_1866))
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_cdrzd29952zd2_1868;

																								BgL_cdrzd29952zd2_1868 =
																									CDR(BgL_cdrzd29947zd2_1866);
																								if (PAIRP
																									(BgL_cdrzd29952zd2_1868))
																									{	/* Eval/evaluate.scm 425 */
																										if (NULLP(CDR
																												(BgL_cdrzd29952zd2_1868)))
																											{	/* Eval/evaluate.scm 425 */
																												obj_t
																													BgL_arg1894z00_1871;
																												obj_t
																													BgL_arg1895z00_1872;
																												obj_t
																													BgL_arg1896z00_1873;
																												BgL_arg1894z00_1871 =
																													CAR
																													(BgL_cdrzd29337zd2_1853);
																												BgL_arg1895z00_1872 =
																													CAR
																													(BgL_cdrzd29947zd2_1866);
																												BgL_arg1896z00_1873 =
																													CAR
																													(BgL_cdrzd29952zd2_1868);
																												{
																													BgL_ev_ifz00_bglt
																														BgL_auxz00_6979;
																													{
																														obj_t BgL_oz00_6982;
																														obj_t BgL_tz00_6981;
																														obj_t BgL_pz00_6980;

																														BgL_pz00_6980 =
																															BgL_arg1894z00_1871;
																														BgL_tz00_6981 =
																															BgL_arg1895z00_1872;
																														BgL_oz00_6982 =
																															BgL_arg1896z00_1873;
																														BgL_oz00_1410 =
																															BgL_oz00_6982;
																														BgL_tz00_1409 =
																															BgL_tz00_6981;
																														BgL_pz00_1408 =
																															BgL_pz00_6980;
																														goto
																															BgL_tagzd2155zd2_1411;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6979);
																												}
																											}
																										else
																											{	/* Eval/evaluate.scm 425 */
																												obj_t
																													BgL_arg1897z00_1874;
																												obj_t
																													BgL_arg1898z00_1875;
																												BgL_arg1897z00_1874 =
																													CAR(BgL_ez00_69);
																												BgL_arg1898z00_1875 =
																													CDR(BgL_ez00_69);
																												{
																													BgL_ev_appz00_bglt
																														BgL_auxz00_6986;
																													{
																														obj_t
																															BgL_argsz00_6988;
																														obj_t BgL_fz00_6987;

																														BgL_fz00_6987 =
																															BgL_arg1897z00_1874;
																														BgL_argsz00_6988 =
																															BgL_arg1898z00_1875;
																														BgL_argsz00_1468 =
																															BgL_argsz00_6988;
																														BgL_fz00_1467 =
																															BgL_fz00_6987;
																														goto
																															BgL_tagzd2175zd2_1469;
																													}
																													return
																														((obj_t)
																														BgL_auxz00_6986);
																												}
																											}
																									}
																								else
																									{	/* Eval/evaluate.scm 425 */
																										obj_t
																											BgL_cdrzd210250zd2_1877;
																										BgL_cdrzd210250zd2_1877 =
																											CDR(BgL_ez00_69);
																										{	/* Eval/evaluate.scm 425 */
																											obj_t
																												BgL_cdrzd210256zd2_1878;
																											BgL_cdrzd210256zd2_1878 =
																												CDR
																												(BgL_cdrzd210250zd2_1877);
																											if (NULLP(CDR
																													(BgL_cdrzd210256zd2_1878)))
																												{	/* Eval/evaluate.scm 425 */
																													obj_t
																														BgL_arg1902z00_1880;
																													obj_t
																														BgL_arg1903z00_1881;
																													BgL_arg1902z00_1880 =
																														CAR
																														(BgL_cdrzd210250zd2_1877);
																													BgL_arg1903z00_1881 =
																														CAR
																														(BgL_cdrzd210256zd2_1878);
																													{
																														BgL_ev_ifz00_bglt
																															BgL_auxz00_6997;
																														{
																															obj_t
																																BgL_tz00_6999;
																															obj_t
																																BgL_pz00_6998;
																															BgL_pz00_6998 =
																																BgL_arg1902z00_1880;
																															BgL_tz00_6999 =
																																BgL_arg1903z00_1881;
																															BgL_tz00_1413 =
																																BgL_tz00_6999;
																															BgL_pz00_1412 =
																																BgL_pz00_6998;
																															goto
																																BgL_tagzd2156zd2_1414;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_6997);
																													}
																												}
																											else
																												{	/* Eval/evaluate.scm 425 */
																													obj_t
																														BgL_arg1904z00_1882;
																													BgL_arg1904z00_1882 =
																														CAR(BgL_ez00_69);
																													{
																														BgL_ev_appz00_bglt
																															BgL_auxz00_7002;
																														{
																															obj_t
																																BgL_argsz00_7004;
																															obj_t
																																BgL_fz00_7003;
																															BgL_fz00_7003 =
																																BgL_arg1904z00_1882;
																															BgL_argsz00_7004 =
																																BgL_cdrzd210250zd2_1877;
																															BgL_argsz00_1468 =
																																BgL_argsz00_7004;
																															BgL_fz00_1467 =
																																BgL_fz00_7003;
																															goto
																																BgL_tagzd2175zd2_1469;
																														}
																														return
																															((obj_t)
																															BgL_auxz00_7002);
																													}
																												}
																										}
																									}
																							}
																						else
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_arg1907z00_1885;
																								obj_t BgL_arg1908z00_1886;

																								BgL_arg1907z00_1885 =
																									CAR(BgL_ez00_69);
																								BgL_arg1908z00_1886 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_appz00_bglt
																										BgL_auxz00_7008;
																									{
																										obj_t BgL_argsz00_7010;
																										obj_t BgL_fz00_7009;

																										BgL_fz00_7009 =
																											BgL_arg1907z00_1885;
																										BgL_argsz00_7010 =
																											BgL_arg1908z00_1886;
																										BgL_argsz00_1468 =
																											BgL_argsz00_7010;
																										BgL_fz00_1467 =
																											BgL_fz00_7009;
																										goto BgL_tagzd2175zd2_1469;
																									}
																									return
																										((obj_t) BgL_auxz00_7008);
																								}
																							}
																					}
																				else
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_arg1909z00_1887;
																						obj_t BgL_arg1910z00_1888;

																						BgL_arg1909z00_1887 =
																							CAR(BgL_ez00_69);
																						BgL_arg1910z00_1888 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_appz00_bglt
																								BgL_auxz00_7014;
																							{
																								obj_t BgL_argsz00_7016;
																								obj_t BgL_fz00_7015;

																								BgL_fz00_7015 =
																									BgL_arg1909z00_1887;
																								BgL_argsz00_7016 =
																									BgL_arg1910z00_1888;
																								BgL_argsz00_1468 =
																									BgL_argsz00_7016;
																								BgL_fz00_1467 = BgL_fz00_7015;
																								goto BgL_tagzd2175zd2_1469;
																							}
																							return ((obj_t) BgL_auxz00_7014);
																						}
																					}
																			}
																		else
																			{	/* Eval/evaluate.scm 425 */
																				if (
																					(CAR(BgL_ez00_69) ==
																						BGl_symbol3040z00zz__evaluatez00))
																					{	/* Eval/evaluate.scm 425 */
																						obj_t BgL_arg1912z00_1890;

																						BgL_arg1912z00_1890 =
																							CDR(BgL_ez00_69);
																						{
																							BgL_ev_orz00_bglt BgL_auxz00_7022;

																							{
																								obj_t BgL_argsz00_7023;

																								BgL_argsz00_7023 =
																									BgL_arg1912z00_1890;
																								BgL_argsz00_1415 =
																									BgL_argsz00_7023;
																								goto BgL_tagzd2157zd2_1416;
																							}
																							return ((obj_t) BgL_auxz00_7022);
																						}
																					}
																				else
																					{	/* Eval/evaluate.scm 425 */
																						if (
																							(CAR(BgL_ez00_69) ==
																								BGl_symbol3042z00zz__evaluatez00))
																							{	/* Eval/evaluate.scm 425 */
																								obj_t BgL_arg1914z00_1892;

																								BgL_arg1914z00_1892 =
																									CDR(BgL_ez00_69);
																								{
																									BgL_ev_andz00_bglt
																										BgL_auxz00_7029;
																									{
																										obj_t BgL_argsz00_7030;

																										BgL_argsz00_7030 =
																											BgL_arg1914z00_1892;
																										BgL_argsz00_1417 =
																											BgL_argsz00_7030;
																										goto BgL_tagzd2158zd2_1418;
																									}
																									return
																										((obj_t) BgL_auxz00_7029);
																								}
																							}
																						else
																							{	/* Eval/evaluate.scm 425 */
																								if (
																									(CAR(BgL_ez00_69) ==
																										BGl_symbol3027z00zz__evaluatez00))
																									{	/* Eval/evaluate.scm 425 */
																										return
																											BGl_convzd2beginzd2zz__evaluatez00
																											(CDR(BgL_ez00_69),
																											BgL_localsz00_70,
																											BgL_globalsz00_71,
																											BgL_tailzf3zf3_72,
																											BgL_wherez00_73,
																											BgL_locz00_74,
																											BgL_topzf3zf3_75);
																									}
																								else
																									{	/* Eval/evaluate.scm 425 */
																										obj_t
																											BgL_cdrzd211149zd2_1895;
																										BgL_cdrzd211149zd2_1895 =
																											CDR(BgL_ez00_69);
																										if ((CAR(BgL_ez00_69) ==
																												BGl_symbol3013z00zz__evaluatez00))
																											{	/* Eval/evaluate.scm 425 */
																												if (PAIRP
																													(BgL_cdrzd211149zd2_1895))
																													{	/* Eval/evaluate.scm 425 */
																														obj_t
																															BgL_arg1919z00_1898;
																														obj_t
																															BgL_arg1920z00_1899;
																														BgL_arg1919z00_1898
																															=
																															CAR
																															(BgL_cdrzd211149zd2_1895);
																														BgL_arg1920z00_1899
																															=
																															CDR
																															(BgL_cdrzd211149zd2_1895);
																														{
																															BgL_ev_letz00_bglt
																																BgL_auxz00_7045;
																															{
																																obj_t
																																	BgL_bodyz00_7047;
																																obj_t
																																	BgL_bindsz00_7046;
																																BgL_bindsz00_7046
																																	=
																																	BgL_arg1919z00_1898;
																																BgL_bodyz00_7047
																																	=
																																	BgL_arg1920z00_1899;
																																BgL_bodyz00_1422
																																	=
																																	BgL_bodyz00_7047;
																																BgL_bindsz00_1421
																																	=
																																	BgL_bindsz00_7046;
																																goto
																																	BgL_tagzd2160zd2_1423;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_7045);
																														}
																													}
																												else
																													{	/* Eval/evaluate.scm 425 */
																														obj_t
																															BgL_arg1921z00_1900;
																														BgL_arg1921z00_1900
																															=
																															CAR(BgL_ez00_69);
																														{
																															BgL_ev_appz00_bglt
																																BgL_auxz00_7050;
																															{
																																obj_t
																																	BgL_argsz00_7052;
																																obj_t
																																	BgL_fz00_7051;
																																BgL_fz00_7051 =
																																	BgL_arg1921z00_1900;
																																BgL_argsz00_7052
																																	=
																																	BgL_cdrzd211149zd2_1895;
																																BgL_argsz00_1468
																																	=
																																	BgL_argsz00_7052;
																																BgL_fz00_1467 =
																																	BgL_fz00_7051;
																																goto
																																	BgL_tagzd2175zd2_1469;
																															}
																															return
																																((obj_t)
																																BgL_auxz00_7050);
																														}
																													}
																											}
																										else
																											{	/* Eval/evaluate.scm 425 */
																												if (
																													(CAR(BgL_ez00_69) ==
																														BGl_symbol3044z00zz__evaluatez00))
																													{	/* Eval/evaluate.scm 425 */
																														if (PAIRP
																															(BgL_cdrzd211149zd2_1895))
																															{	/* Eval/evaluate.scm 425 */
																																obj_t
																																	BgL_arg1926z00_1905;
																																obj_t
																																	BgL_arg1927z00_1906;
																																BgL_arg1926z00_1905
																																	=
																																	CAR
																																	(BgL_cdrzd211149zd2_1895);
																																BgL_arg1927z00_1906
																																	=
																																	CDR
																																	(BgL_cdrzd211149zd2_1895);
																																{
																																	BgL_ev_letza2za2_bglt
																																		BgL_auxz00_7061;
																																	{
																																		obj_t
																																			BgL_bodyz00_7063;
																																		obj_t
																																			BgL_bindsz00_7062;
																																		BgL_bindsz00_7062
																																			=
																																			BgL_arg1926z00_1905;
																																		BgL_bodyz00_7063
																																			=
																																			BgL_arg1927z00_1906;
																																		BgL_bodyz00_1425
																																			=
																																			BgL_bodyz00_7063;
																																		BgL_bindsz00_1424
																																			=
																																			BgL_bindsz00_7062;
																																		goto
																																			BgL_tagzd2161zd2_1426;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_7061);
																																}
																															}
																														else
																															{	/* Eval/evaluate.scm 425 */
																																obj_t
																																	BgL_arg1928z00_1907;
																																obj_t
																																	BgL_arg1929z00_1908;
																																BgL_arg1928z00_1907
																																	=
																																	CAR
																																	(BgL_ez00_69);
																																BgL_arg1929z00_1908
																																	=
																																	CDR
																																	(BgL_ez00_69);
																																{
																																	BgL_ev_appz00_bglt
																																		BgL_auxz00_7067;
																																	{
																																		obj_t
																																			BgL_argsz00_7069;
																																		obj_t
																																			BgL_fz00_7068;
																																		BgL_fz00_7068
																																			=
																																			BgL_arg1928z00_1907;
																																		BgL_argsz00_7069
																																			=
																																			BgL_arg1929z00_1908;
																																		BgL_argsz00_1468
																																			=
																																			BgL_argsz00_7069;
																																		BgL_fz00_1467
																																			=
																																			BgL_fz00_7068;
																																		goto
																																			BgL_tagzd2175zd2_1469;
																																	}
																																	return
																																		((obj_t)
																																		BgL_auxz00_7067);
																																}
																															}
																													}
																												else
																													{	/* Eval/evaluate.scm 425 */
																														obj_t
																															BgL_cdrzd211543zd2_1909;
																														BgL_cdrzd211543zd2_1909
																															=
																															CDR(BgL_ez00_69);
																														if ((CAR
																																(BgL_ez00_69) ==
																																BGl_symbol3046z00zz__evaluatez00))
																															{	/* Eval/evaluate.scm 425 */
																																if (PAIRP
																																	(BgL_cdrzd211543zd2_1909))
																																	{	/* Eval/evaluate.scm 425 */
																																		obj_t
																																			BgL_arg1932z00_1912;
																																		obj_t
																																			BgL_arg1933z00_1913;
																																		BgL_arg1932z00_1912
																																			=
																																			CAR
																																			(BgL_cdrzd211543zd2_1909);
																																		BgL_arg1933z00_1913
																																			=
																																			CDR
																																			(BgL_cdrzd211543zd2_1909);
																																		{
																																			BgL_ev_letrecz00_bglt
																																				BgL_auxz00_7079;
																																			{
																																				obj_t
																																					BgL_bodyz00_7081;
																																				obj_t
																																					BgL_bindsz00_7080;
																																				BgL_bindsz00_7080
																																					=
																																					BgL_arg1932z00_1912;
																																				BgL_bodyz00_7081
																																					=
																																					BgL_arg1933z00_1913;
																																				BgL_bodyz00_1428
																																					=
																																					BgL_bodyz00_7081;
																																				BgL_bindsz00_1427
																																					=
																																					BgL_bindsz00_7080;
																																				goto
																																					BgL_tagzd2162zd2_1429;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_7079);
																																		}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 425 */
																																		obj_t
																																			BgL_arg1934z00_1914;
																																		BgL_arg1934z00_1914
																																			=
																																			CAR
																																			(BgL_ez00_69);
																																		{
																																			BgL_ev_appz00_bglt
																																				BgL_auxz00_7084;
																																			{
																																				obj_t
																																					BgL_argsz00_7086;
																																				obj_t
																																					BgL_fz00_7085;
																																				BgL_fz00_7085
																																					=
																																					BgL_arg1934z00_1914;
																																				BgL_argsz00_7086
																																					=
																																					BgL_cdrzd211543zd2_1909;
																																				BgL_argsz00_1468
																																					=
																																					BgL_argsz00_7086;
																																				BgL_fz00_1467
																																					=
																																					BgL_fz00_7085;
																																				goto
																																					BgL_tagzd2175zd2_1469;
																																			}
																																			return
																																				((obj_t)
																																				BgL_auxz00_7084);
																																		}
																																	}
																															}
																														else
																															{	/* Eval/evaluate.scm 425 */
																																if (
																																	(CAR
																																		(BgL_ez00_69)
																																		==
																																		BGl_symbol3048z00zz__evaluatez00))
																																	{	/* Eval/evaluate.scm 425 */
																																		if (PAIRP
																																			(BgL_cdrzd211543zd2_1909))
																																			{	/* Eval/evaluate.scm 425 */
																																				obj_t
																																					BgL_carzd211717zd2_1919;
																																				obj_t
																																					BgL_cdrzd211718zd2_1920;
																																				BgL_carzd211717zd2_1919
																																					=
																																					CAR
																																					(BgL_cdrzd211543zd2_1909);
																																				BgL_cdrzd211718zd2_1920
																																					=
																																					CDR
																																					(BgL_cdrzd211543zd2_1909);
																																				if (PAIRP(BgL_carzd211717zd2_1919))
																																					{	/* Eval/evaluate.scm 425 */
																																						obj_t
																																							BgL_cdrzd211722zd2_1922;
																																						BgL_cdrzd211722zd2_1922
																																							=
																																							CDR
																																							(BgL_carzd211717zd2_1919);
																																						if (
																																							(CAR
																																								(BgL_carzd211717zd2_1919)
																																								==
																																								BGl_symbol3034z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 425 */
																																								if (PAIRP(BgL_cdrzd211722zd2_1922))
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_carzd211725zd2_1925;
																																										obj_t
																																											BgL_cdrzd211726zd2_1926;
																																										BgL_carzd211725zd2_1925
																																											=
																																											CAR
																																											(BgL_cdrzd211722zd2_1922);
																																										BgL_cdrzd211726zd2_1926
																																											=
																																											CDR
																																											(BgL_cdrzd211722zd2_1922);
																																										if (SYMBOLP(BgL_carzd211725zd2_1925))
																																											{	/* Eval/evaluate.scm 425 */
																																												if (PAIRP(BgL_cdrzd211726zd2_1926))
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_carzd211730zd2_1929;
																																														BgL_carzd211730zd2_1929
																																															=
																																															CAR
																																															(BgL_cdrzd211726zd2_1926);
																																														if (SYMBOLP(BgL_carzd211730zd2_1929))
																																															{	/* Eval/evaluate.scm 425 */
																																																if (NULLP(CDR(BgL_cdrzd211726zd2_1926)))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		if (PAIRP(BgL_cdrzd211718zd2_1920))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				if (NULLP(CDR(BgL_cdrzd211718zd2_1920)))
																																																					{	/* Eval/evaluate.scm 425 */
																																																						obj_t
																																																							BgL_arg1947z00_1934;
																																																						BgL_arg1947z00_1934
																																																							=
																																																							CAR
																																																							(BgL_cdrzd211718zd2_1920);
																																																						{	/* Eval/evaluate.scm 532 */
																																																							BgL_ev_setglobalz00_bglt
																																																								BgL_new1138z00_4498;
																																																							{	/* Eval/evaluate.scm 536 */
																																																								BgL_ev_setglobalz00_bglt
																																																									BgL_new1137z00_4499;
																																																								BgL_new1137z00_4499
																																																									=
																																																									(
																																																									(BgL_ev_setglobalz00_bglt)
																																																									BREF
																																																									(GC_MALLOC
																																																										(sizeof
																																																											(struct
																																																												BgL_ev_setglobalz00_bgl))));
																																																								{	/* Eval/evaluate.scm 536 */
																																																									long
																																																										BgL_arg2239z00_4500;
																																																									{	/* Eval/evaluate.scm 536 */
																																																										long
																																																											BgL_res2856z00_4502;
																																																										BgL_res2856z00_4502
																																																											=
																																																											BGL_CLASS_INDEX
																																																											(BGl_ev_setglobalz00zz__evaluate_typesz00);
																																																										BgL_arg2239z00_4500
																																																											=
																																																											BgL_res2856z00_4502;
																																																									}
																																																									BGL_OBJECT_CLASS_NUM_SET
																																																										(
																																																										((BgL_objectz00_bglt) BgL_new1137z00_4499), BgL_arg2239z00_4500);
																																																								}
																																																								{	/* Eval/evaluate.scm 536 */
																																																									BgL_objectz00_bglt
																																																										BgL_auxz00_7125;
																																																									BgL_auxz00_7125
																																																										=
																																																										(
																																																										(BgL_objectz00_bglt)
																																																										BgL_new1137z00_4499);
																																																									BGL_OBJECT_WIDENING_SET
																																																										(BgL_auxz00_7125,
																																																										BFALSE);
																																																								}
																																																								BgL_new1138z00_4498
																																																									=
																																																									BgL_new1137z00_4499;
																																																							}
																																																							{
																																																								BgL_ev_exprz00_bglt
																																																									BgL_auxz00_7128;
																																																								{	/* Eval/evaluate.scm 381 */
																																																									obj_t
																																																										BgL_arg2308z00_4506;
																																																									BgL_arg2308z00_4506
																																																										=
																																																										BGl_getzd2locationzd2zz__evaluatez00
																																																										(BgL_arg1947z00_1934,
																																																										BgL_locz00_74);
																																																									BgL_auxz00_7128
																																																										=
																																																										(
																																																										(BgL_ev_exprz00_bglt)
																																																										BGl_uconvzf2loczf2zz__evaluatez00
																																																										(BgL_wherez00_73,
																																																											BgL_globalsz00_71,
																																																											BgL_localsz00_70,
																																																											BgL_arg1947z00_1934,
																																																											BgL_arg2308z00_4506));
																																																								}
																																																								((((BgL_ev_hookz00_bglt) CREF(((BgL_ev_hookz00_bglt) BgL_new1138z00_4498)))->BgL_ez00) = ((BgL_ev_exprz00_bglt) BgL_auxz00_7128), BUNSPEC);
																																																							}
																																																							((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1138z00_4498))->BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1138z00_4498))->BgL_namez00) = ((obj_t) BgL_carzd211725zd2_1925), BUNSPEC);
																																																							((((BgL_ev_setglobalz00_bglt) CREF(BgL_new1138z00_4498))->BgL_modz00) = ((obj_t) BGl_evalzd2findzd2modulez00zz__evmodulez00(BgL_carzd211730zd2_1929)), BUNSPEC);
																																																							return
																																																								(
																																																								(obj_t)
																																																								BgL_new1138z00_4498);
																																																						}
																																																					}
																																																				else
																																																					{	/* Eval/evaluate.scm 425 */
																																																						return
																																																							BGl_evcompilezd2errorzd2zz__evcompilez00
																																																							(BgL_locz00_74,
																																																							BGl_string2951z00zz__evaluatez00,
																																																							BGl_string3026z00zz__evaluatez00,
																																																							BgL_ez00_69);
																																																					}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				return
																																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																																					(BgL_locz00_74,
																																																					BGl_string2951z00zz__evaluatez00,
																																																					BGl_string3026z00zz__evaluatez00,
																																																					BgL_ez00_69);
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_cdrzd211846zd2_1936;
																																																		BgL_cdrzd211846zd2_1936
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{	/* Eval/evaluate.scm 425 */
																																																			obj_t
																																																				BgL_cdrzd211850zd2_1937;
																																																			BgL_cdrzd211850zd2_1937
																																																				=
																																																				CDR
																																																				(BgL_cdrzd211846zd2_1936);
																																																			if (PAIRP(BgL_cdrzd211850zd2_1937))
																																																				{	/* Eval/evaluate.scm 425 */
																																																					if (NULLP(CDR(BgL_cdrzd211850zd2_1937)))
																																																						{	/* Eval/evaluate.scm 425 */
																																																							obj_t
																																																								BgL_arg1951z00_1940;
																																																							obj_t
																																																								BgL_arg1952z00_1941;
																																																							BgL_arg1951z00_1940
																																																								=
																																																								CAR
																																																								(BgL_cdrzd211846zd2_1936);
																																																							BgL_arg1952z00_1941
																																																								=
																																																								CAR
																																																								(BgL_cdrzd211850zd2_1937);
																																																							{
																																																								BgL_ev_hookz00_bglt
																																																									BgL_auxz00_7150;
																																																								{
																																																									obj_t
																																																										BgL_ez00_7152;
																																																									obj_t
																																																										BgL_vz00_7151;
																																																									BgL_vz00_7151
																																																										=
																																																										BgL_arg1951z00_1940;
																																																									BgL_ez00_7152
																																																										=
																																																										BgL_arg1952z00_1941;
																																																									BgL_ez00_1438
																																																										=
																																																										BgL_ez00_7152;
																																																									BgL_vz00_1437
																																																										=
																																																										BgL_vz00_7151;
																																																									goto
																																																										BgL_tagzd2165zd2_1439;
																																																								}
																																																								return
																																																									(
																																																									(obj_t)
																																																									BgL_auxz00_7150);
																																																							}
																																																						}
																																																					else
																																																						{	/* Eval/evaluate.scm 425 */
																																																							return
																																																								BGl_evcompilezd2errorzd2zz__evcompilez00
																																																								(BgL_locz00_74,
																																																								BGl_string2951z00zz__evaluatez00,
																																																								BGl_string3026z00zz__evaluatez00,
																																																								BgL_ez00_69);
																																																						}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 425 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2951z00zz__evaluatez00,
																																																						BGl_string3026z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd211907zd2_1944;
																																																BgL_cdrzd211907zd2_1944
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{	/* Eval/evaluate.scm 425 */
																																																	obj_t
																																																		BgL_cdrzd211911zd2_1945;
																																																	BgL_cdrzd211911zd2_1945
																																																		=
																																																		CDR
																																																		(BgL_cdrzd211907zd2_1944);
																																																	if (PAIRP(BgL_cdrzd211911zd2_1945))
																																																		{	/* Eval/evaluate.scm 425 */
																																																			if (NULLP(CDR(BgL_cdrzd211911zd2_1945)))
																																																				{	/* Eval/evaluate.scm 425 */
																																																					obj_t
																																																						BgL_arg1958z00_1948;
																																																					obj_t
																																																						BgL_arg1960z00_1949;
																																																					BgL_arg1958z00_1948
																																																						=
																																																						CAR
																																																						(BgL_cdrzd211907zd2_1944);
																																																					BgL_arg1960z00_1949
																																																						=
																																																						CAR
																																																						(BgL_cdrzd211911zd2_1945);
																																																					{
																																																						BgL_ev_hookz00_bglt
																																																							BgL_auxz00_7165;
																																																						{
																																																							obj_t
																																																								BgL_ez00_7167;
																																																							obj_t
																																																								BgL_vz00_7166;
																																																							BgL_vz00_7166
																																																								=
																																																								BgL_arg1958z00_1948;
																																																							BgL_ez00_7167
																																																								=
																																																								BgL_arg1960z00_1949;
																																																							BgL_ez00_1438
																																																								=
																																																								BgL_ez00_7167;
																																																							BgL_vz00_1437
																																																								=
																																																								BgL_vz00_7166;
																																																							goto
																																																								BgL_tagzd2165zd2_1439;
																																																						}
																																																						return
																																																							(
																																																							(obj_t)
																																																							BgL_auxz00_7165);
																																																					}
																																																				}
																																																			else
																																																				{	/* Eval/evaluate.scm 425 */
																																																					return
																																																						BGl_evcompilezd2errorzd2zz__evcompilez00
																																																						(BgL_locz00_74,
																																																						BGl_string2951z00zz__evaluatez00,
																																																						BGl_string3026z00zz__evaluatez00,
																																																						BgL_ez00_69);
																																																				}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 425 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2951z00zz__evaluatez00,
																																																				BGl_string3026z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_cdrzd211968zd2_1951;
																																														BgL_cdrzd211968zd2_1951
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{	/* Eval/evaluate.scm 425 */
																																															obj_t
																																																BgL_cdrzd211972zd2_1952;
																																															BgL_cdrzd211972zd2_1952
																																																=
																																																CDR
																																																(BgL_cdrzd211968zd2_1951);
																																															if (PAIRP(BgL_cdrzd211972zd2_1952))
																																																{	/* Eval/evaluate.scm 425 */
																																																	if (NULLP(CDR(BgL_cdrzd211972zd2_1952)))
																																																		{	/* Eval/evaluate.scm 425 */
																																																			obj_t
																																																				BgL_arg1964z00_1955;
																																																			obj_t
																																																				BgL_arg1965z00_1956;
																																																			BgL_arg1964z00_1955
																																																				=
																																																				CAR
																																																				(BgL_cdrzd211968zd2_1951);
																																																			BgL_arg1965z00_1956
																																																				=
																																																				CAR
																																																				(BgL_cdrzd211972zd2_1952);
																																																			{
																																																				BgL_ev_hookz00_bglt
																																																					BgL_auxz00_7180;
																																																				{
																																																					obj_t
																																																						BgL_ez00_7182;
																																																					obj_t
																																																						BgL_vz00_7181;
																																																					BgL_vz00_7181
																																																						=
																																																						BgL_arg1964z00_1955;
																																																					BgL_ez00_7182
																																																						=
																																																						BgL_arg1965z00_1956;
																																																					BgL_ez00_1438
																																																						=
																																																						BgL_ez00_7182;
																																																					BgL_vz00_1437
																																																						=
																																																						BgL_vz00_7181;
																																																					goto
																																																						BgL_tagzd2165zd2_1439;
																																																				}
																																																				return
																																																					(
																																																					(obj_t)
																																																					BgL_auxz00_7180);
																																																			}
																																																		}
																																																	else
																																																		{	/* Eval/evaluate.scm 425 */
																																																			return
																																																				BGl_evcompilezd2errorzd2zz__evcompilez00
																																																				(BgL_locz00_74,
																																																				BGl_string2951z00zz__evaluatez00,
																																																				BGl_string3026z00zz__evaluatez00,
																																																				BgL_ez00_69);
																																																		}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 425 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2951z00zz__evaluatez00,
																																																		BGl_string3026z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_cdrzd212029zd2_1958;
																																												BgL_cdrzd212029zd2_1958
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{	/* Eval/evaluate.scm 425 */
																																													obj_t
																																														BgL_cdrzd212033zd2_1959;
																																													BgL_cdrzd212033zd2_1959
																																														=
																																														CDR
																																														(BgL_cdrzd212029zd2_1958);
																																													if (PAIRP(BgL_cdrzd212033zd2_1959))
																																														{	/* Eval/evaluate.scm 425 */
																																															if (NULLP(CDR(BgL_cdrzd212033zd2_1959)))
																																																{	/* Eval/evaluate.scm 425 */
																																																	obj_t
																																																		BgL_arg1969z00_1962;
																																																	obj_t
																																																		BgL_arg1970z00_1963;
																																																	BgL_arg1969z00_1962
																																																		=
																																																		CAR
																																																		(BgL_cdrzd212029zd2_1958);
																																																	BgL_arg1970z00_1963
																																																		=
																																																		CAR
																																																		(BgL_cdrzd212033zd2_1959);
																																																	{
																																																		BgL_ev_hookz00_bglt
																																																			BgL_auxz00_7195;
																																																		{
																																																			obj_t
																																																				BgL_ez00_7197;
																																																			obj_t
																																																				BgL_vz00_7196;
																																																			BgL_vz00_7196
																																																				=
																																																				BgL_arg1969z00_1962;
																																																			BgL_ez00_7197
																																																				=
																																																				BgL_arg1970z00_1963;
																																																			BgL_ez00_1438
																																																				=
																																																				BgL_ez00_7197;
																																																			BgL_vz00_1437
																																																				=
																																																				BgL_vz00_7196;
																																																			goto
																																																				BgL_tagzd2165zd2_1439;
																																																		}
																																																		return
																																																			(
																																																			(obj_t)
																																																			BgL_auxz00_7195);
																																																	}
																																																}
																																															else
																																																{	/* Eval/evaluate.scm 425 */
																																																	return
																																																		BGl_evcompilezd2errorzd2zz__evcompilez00
																																																		(BgL_locz00_74,
																																																		BGl_string2951z00zz__evaluatez00,
																																																		BGl_string3026z00zz__evaluatez00,
																																																		BgL_ez00_69);
																																																}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 425 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2951z00zz__evaluatez00,
																																																BGl_string3026z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_cdrzd212090zd2_1965;
																																										BgL_cdrzd212090zd2_1965
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{	/* Eval/evaluate.scm 425 */
																																											obj_t
																																												BgL_cdrzd212094zd2_1966;
																																											BgL_cdrzd212094zd2_1966
																																												=
																																												CDR
																																												(BgL_cdrzd212090zd2_1965);
																																											if (PAIRP(BgL_cdrzd212094zd2_1966))
																																												{	/* Eval/evaluate.scm 425 */
																																													if (NULLP(CDR(BgL_cdrzd212094zd2_1966)))
																																														{	/* Eval/evaluate.scm 425 */
																																															obj_t
																																																BgL_arg1975z00_1969;
																																															obj_t
																																																BgL_arg1976z00_1970;
																																															BgL_arg1975z00_1969
																																																=
																																																CAR
																																																(BgL_cdrzd212090zd2_1965);
																																															BgL_arg1976z00_1970
																																																=
																																																CAR
																																																(BgL_cdrzd212094zd2_1966);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_7210;
																																																{
																																																	obj_t
																																																		BgL_ez00_7212;
																																																	obj_t
																																																		BgL_vz00_7211;
																																																	BgL_vz00_7211
																																																		=
																																																		BgL_arg1975z00_1969;
																																																	BgL_ez00_7212
																																																		=
																																																		BgL_arg1976z00_1970;
																																																	BgL_ez00_1438
																																																		=
																																																		BgL_ez00_7212;
																																																	BgL_vz00_1437
																																																		=
																																																		BgL_vz00_7211;
																																																	goto
																																																		BgL_tagzd2165zd2_1439;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_7210);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 425 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2951z00zz__evaluatez00,
																																																BGl_string3026z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 425 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2951z00zz__evaluatez00,
																																														BGl_string3026z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_cdrzd212138zd2_1972;
																																								BgL_cdrzd212138zd2_1972
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{	/* Eval/evaluate.scm 425 */
																																									obj_t
																																										BgL_carzd212141zd2_1973;
																																									obj_t
																																										BgL_cdrzd212142zd2_1974;
																																									BgL_carzd212141zd2_1973
																																										=
																																										CAR
																																										(BgL_cdrzd212138zd2_1972);
																																									BgL_cdrzd212142zd2_1974
																																										=
																																										CDR
																																										(BgL_cdrzd212138zd2_1972);
																																									if ((CAR(BgL_carzd212141zd2_1973) == BGl_symbol3036z00zz__evaluatez00))
																																										{	/* Eval/evaluate.scm 425 */
																																											if (PAIRP(BgL_cdrzd212142zd2_1974))
																																												{	/* Eval/evaluate.scm 425 */
																																													if (NULLP(CDR(BgL_cdrzd212142zd2_1974)))
																																														{
																																															obj_t
																																																BgL_e2z00_7229;
																																															obj_t
																																																BgL_lz00_7227;
																																															BgL_lz00_7227
																																																=
																																																CDR
																																																(BgL_carzd212141zd2_1973);
																																															BgL_e2z00_7229
																																																=
																																																CAR
																																																(BgL_cdrzd212142zd2_1974);
																																															BgL_e2z00_1435
																																																=
																																																BgL_e2z00_7229;
																																															BgL_lz00_1434
																																																=
																																																BgL_lz00_7227;
																																															goto
																																																BgL_tagzd2164zd2_1436;
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 425 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2951z00zz__evaluatez00,
																																																BGl_string3026z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 425 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2951z00zz__evaluatez00,
																																														BGl_string3026z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 425 */
																																											obj_t
																																												BgL_cdrzd212218zd2_1982;
																																											BgL_cdrzd212218zd2_1982
																																												=
																																												CDR
																																												(BgL_cdrzd212138zd2_1972);
																																											if (PAIRP(BgL_cdrzd212218zd2_1982))
																																												{	/* Eval/evaluate.scm 425 */
																																													if (NULLP(CDR(BgL_cdrzd212218zd2_1982)))
																																														{	/* Eval/evaluate.scm 425 */
																																															obj_t
																																																BgL_arg1988z00_1985;
																																															obj_t
																																																BgL_arg1989z00_1986;
																																															BgL_arg1988z00_1985
																																																=
																																																CAR
																																																(BgL_cdrzd212138zd2_1972);
																																															BgL_arg1989z00_1986
																																																=
																																																CAR
																																																(BgL_cdrzd212218zd2_1982);
																																															{
																																																BgL_ev_hookz00_bglt
																																																	BgL_auxz00_7241;
																																																{
																																																	obj_t
																																																		BgL_ez00_7243;
																																																	obj_t
																																																		BgL_vz00_7242;
																																																	BgL_vz00_7242
																																																		=
																																																		BgL_arg1988z00_1985;
																																																	BgL_ez00_7243
																																																		=
																																																		BgL_arg1989z00_1986;
																																																	BgL_ez00_1438
																																																		=
																																																		BgL_ez00_7243;
																																																	BgL_vz00_1437
																																																		=
																																																		BgL_vz00_7242;
																																																	goto
																																																		BgL_tagzd2165zd2_1439;
																																																}
																																																return
																																																	(
																																																	(obj_t)
																																																	BgL_auxz00_7241);
																																															}
																																														}
																																													else
																																														{	/* Eval/evaluate.scm 425 */
																																															return
																																																BGl_evcompilezd2errorzd2zz__evcompilez00
																																																(BgL_locz00_74,
																																																BGl_string2951z00zz__evaluatez00,
																																																BGl_string3026z00zz__evaluatez00,
																																																BgL_ez00_69);
																																														}
																																												}
																																											else
																																												{	/* Eval/evaluate.scm 425 */
																																													return
																																														BGl_evcompilezd2errorzd2zz__evcompilez00
																																														(BgL_locz00_74,
																																														BGl_string2951z00zz__evaluatez00,
																																														BGl_string3026z00zz__evaluatez00,
																																														BgL_ez00_69);
																																												}
																																										}
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 425 */
																																						obj_t
																																							BgL_cdrzd212275zd2_1990;
																																						BgL_cdrzd212275zd2_1990
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						{	/* Eval/evaluate.scm 425 */
																																							obj_t
																																								BgL_cdrzd212279zd2_1991;
																																							BgL_cdrzd212279zd2_1991
																																								=
																																								CDR
																																								(BgL_cdrzd212275zd2_1990);
																																							if (PAIRP(BgL_cdrzd212279zd2_1991))
																																								{	/* Eval/evaluate.scm 425 */
																																									if (NULLP(CDR(BgL_cdrzd212279zd2_1991)))
																																										{	/* Eval/evaluate.scm 425 */
																																											obj_t
																																												BgL_arg1996z00_1994;
																																											obj_t
																																												BgL_arg1997z00_1995;
																																											BgL_arg1996z00_1994
																																												=
																																												CAR
																																												(BgL_cdrzd212275zd2_1990);
																																											BgL_arg1997z00_1995
																																												=
																																												CAR
																																												(BgL_cdrzd212279zd2_1991);
																																											{
																																												BgL_ev_hookz00_bglt
																																													BgL_auxz00_7256;
																																												{
																																													obj_t
																																														BgL_ez00_7258;
																																													obj_t
																																														BgL_vz00_7257;
																																													BgL_vz00_7257
																																														=
																																														BgL_arg1996z00_1994;
																																													BgL_ez00_7258
																																														=
																																														BgL_arg1997z00_1995;
																																													BgL_ez00_1438
																																														=
																																														BgL_ez00_7258;
																																													BgL_vz00_1437
																																														=
																																														BgL_vz00_7257;
																																													goto
																																														BgL_tagzd2165zd2_1439;
																																												}
																																												return
																																													(
																																													(obj_t)
																																													BgL_auxz00_7256);
																																											}
																																										}
																																									else
																																										{	/* Eval/evaluate.scm 425 */
																																											return
																																												BGl_evcompilezd2errorzd2zz__evcompilez00
																																												(BgL_locz00_74,
																																												BGl_string2951z00zz__evaluatez00,
																																												BGl_string3026z00zz__evaluatez00,
																																												BgL_ez00_69);
																																										}
																																								}
																																							else
																																								{	/* Eval/evaluate.scm 425 */
																																									return
																																										BGl_evcompilezd2errorzd2zz__evcompilez00
																																										(BgL_locz00_74,
																																										BGl_string2951z00zz__evaluatez00,
																																										BGl_string3026z00zz__evaluatez00,
																																										BgL_ez00_69);
																																								}
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 425 */
																																				return
																																					BGl_evcompilezd2errorzd2zz__evcompilez00
																																					(BgL_locz00_74,
																																					BGl_string2951z00zz__evaluatez00,
																																					BGl_string3026z00zz__evaluatez00,
																																					BgL_ez00_69);
																																			}
																																	}
																																else
																																	{	/* Eval/evaluate.scm 425 */
																																		obj_t
																																			BgL_cdrzd212400zd2_1997;
																																		BgL_cdrzd212400zd2_1997
																																			=
																																			CDR
																																			(BgL_ez00_69);
																																		if ((CAR
																																				(BgL_ez00_69)
																																				==
																																				BGl_symbol3050z00zz__evaluatez00))
																																			{	/* Eval/evaluate.scm 425 */
																																				if (PAIRP(BgL_cdrzd212400zd2_1997))
																																					{	/* Eval/evaluate.scm 425 */
																																						obj_t
																																							BgL_cdrzd212405zd2_2000;
																																						BgL_cdrzd212405zd2_2000
																																							=
																																							CDR
																																							(BgL_cdrzd212400zd2_1997);
																																						if (PAIRP(BgL_cdrzd212405zd2_2000))
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_carzd212409zd2_2002;
																																								BgL_carzd212409zd2_2002
																																									=
																																									CAR
																																									(BgL_cdrzd212405zd2_2000);
																																								if (PAIRP(BgL_carzd212409zd2_2002))
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_cdrzd212414zd2_2004;
																																										BgL_cdrzd212414zd2_2004
																																											=
																																											CDR
																																											(BgL_carzd212409zd2_2002);
																																										if ((CAR(BgL_carzd212409zd2_2002) == BGl_symbol3015z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 425 */
																																												if (PAIRP(BgL_cdrzd212414zd2_2004))
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_cdrzd212418zd2_2007;
																																														BgL_cdrzd212418zd2_2007
																																															=
																																															CDR
																																															(BgL_cdrzd212414zd2_2004);
																																														if (PAIRP(BgL_cdrzd212418zd2_2007))
																																															{	/* Eval/evaluate.scm 425 */
																																																if (NULLP(CDR(BgL_cdrzd212418zd2_2007)))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		if (NULLP(CDR(BgL_cdrzd212405zd2_2000)))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2009z00_2011;
																																																				obj_t
																																																					BgL_arg2010z00_2012;
																																																				obj_t
																																																					BgL_arg2011z00_2013;
																																																				BgL_arg2009z00_2011
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212400zd2_1997);
																																																				BgL_arg2010z00_2012
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212414zd2_2004);
																																																				BgL_arg2011z00_2013
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212418zd2_2007);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_7293;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7296;
																																																						obj_t
																																																							BgL_formalsz00_7295;
																																																						obj_t
																																																							BgL_gvz00_7294;
																																																						BgL_gvz00_7294
																																																							=
																																																							BgL_arg2009z00_2011;
																																																						BgL_formalsz00_7295
																																																							=
																																																							BgL_arg2010z00_2012;
																																																						BgL_bodyz00_7296
																																																							=
																																																							BgL_arg2011z00_2013;
																																																						BgL_bodyz00_1443
																																																							=
																																																							BgL_bodyz00_7296;
																																																						BgL_formalsz00_1442
																																																							=
																																																							BgL_formalsz00_7295;
																																																						BgL_gvz00_1441
																																																							=
																																																							BgL_gvz00_7294;
																																																						goto
																																																							BgL_tagzd2167zd2_1444;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7293);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2012z00_2014;
																																																				BgL_arg2012z00_2014
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7299;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7301;
																																																						obj_t
																																																							BgL_fz00_7300;
																																																						BgL_fz00_7300
																																																							=
																																																							BgL_arg2012z00_2014;
																																																						BgL_argsz00_7301
																																																							=
																																																							BgL_cdrzd212400zd2_1997;
																																																						BgL_argsz00_1468
																																																							=
																																																							BgL_argsz00_7301;
																																																						BgL_fz00_1467
																																																							=
																																																							BgL_fz00_7300;
																																																						goto
																																																							BgL_tagzd2175zd2_1469;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7299);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_cdrzd212518zd2_2018;
																																																		BgL_cdrzd212518zd2_2018
																																																			=
																																																			CDR
																																																			(BgL_cdrzd212400zd2_1997);
																																																		if (NULLP(CDR(BgL_cdrzd212518zd2_2018)))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2017z00_2020;
																																																				obj_t
																																																					BgL_arg2018z00_2021;
																																																				BgL_arg2017z00_2020
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212400zd2_1997);
																																																				BgL_arg2018z00_2021
																																																					=
																																																					CAR
																																																					(BgL_cdrzd212518zd2_2018);
																																																				{
																																																					BgL_ev_defglobalz00_bglt
																																																						BgL_auxz00_7309;
																																																					{
																																																						obj_t
																																																							BgL_gez00_7311;
																																																						obj_t
																																																							BgL_gvz00_7310;
																																																						BgL_gvz00_7310
																																																							=
																																																							BgL_arg2017z00_2020;
																																																						BgL_gez00_7311
																																																							=
																																																							BgL_arg2018z00_2021;
																																																						BgL_gez00_1446
																																																							=
																																																							BgL_gez00_7311;
																																																						BgL_gvz00_1445
																																																							=
																																																							BgL_gvz00_7310;
																																																						goto
																																																							BgL_tagzd2168zd2_1447;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7309);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2019z00_2022;
																																																				obj_t
																																																					BgL_arg2020z00_2023;
																																																				BgL_arg2019z00_2022
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2020z00_2023
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7315;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7317;
																																																						obj_t
																																																							BgL_fz00_7316;
																																																						BgL_fz00_7316
																																																							=
																																																							BgL_arg2019z00_2022;
																																																						BgL_argsz00_7317
																																																							=
																																																							BgL_arg2020z00_2023;
																																																						BgL_argsz00_1468
																																																							=
																																																							BgL_argsz00_7317;
																																																						BgL_fz00_1467
																																																							=
																																																							BgL_fz00_7316;
																																																						goto
																																																							BgL_tagzd2175zd2_1469;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7315);
																																																				}
																																																			}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd212605zd2_2027;
																																																BgL_cdrzd212605zd2_2027
																																																	=
																																																	CDR
																																																	(BgL_cdrzd212400zd2_1997);
																																																if (NULLP(CDR(BgL_cdrzd212605zd2_2027)))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg2024z00_2029;
																																																		obj_t
																																																			BgL_arg2025z00_2030;
																																																		BgL_arg2024z00_2029
																																																			=
																																																			CAR
																																																			(BgL_cdrzd212400zd2_1997);
																																																		BgL_arg2025z00_2030
																																																			=
																																																			CAR
																																																			(BgL_cdrzd212605zd2_2027);
																																																		{
																																																			BgL_ev_defglobalz00_bglt
																																																				BgL_auxz00_7325;
																																																			{
																																																				obj_t
																																																					BgL_gez00_7327;
																																																				obj_t
																																																					BgL_gvz00_7326;
																																																				BgL_gvz00_7326
																																																					=
																																																					BgL_arg2024z00_2029;
																																																				BgL_gez00_7327
																																																					=
																																																					BgL_arg2025z00_2030;
																																																				BgL_gez00_1446
																																																					=
																																																					BgL_gez00_7327;
																																																				BgL_gvz00_1445
																																																					=
																																																					BgL_gvz00_7326;
																																																				goto
																																																					BgL_tagzd2168zd2_1447;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7325);
																																																		}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg2027z00_2031;
																																																		obj_t
																																																			BgL_arg2028z00_2032;
																																																		BgL_arg2027z00_2031
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2028z00_2032
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_7331;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_7333;
																																																				obj_t
																																																					BgL_fz00_7332;
																																																				BgL_fz00_7332
																																																					=
																																																					BgL_arg2027z00_2031;
																																																				BgL_argsz00_7333
																																																					=
																																																					BgL_arg2028z00_2032;
																																																				BgL_argsz00_1468
																																																					=
																																																					BgL_argsz00_7333;
																																																				BgL_fz00_1467
																																																					=
																																																					BgL_fz00_7332;
																																																				goto
																																																					BgL_tagzd2175zd2_1469;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7331);
																																																		}
																																																	}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_cdrzd212692zd2_2035;
																																														BgL_cdrzd212692zd2_2035
																																															=
																																															CDR
																																															(BgL_cdrzd212400zd2_1997);
																																														if (NULLP(CDR(BgL_cdrzd212692zd2_2035)))
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg2031z00_2037;
																																																obj_t
																																																	BgL_arg2032z00_2038;
																																																BgL_arg2031z00_2037
																																																	=
																																																	CAR
																																																	(BgL_cdrzd212400zd2_1997);
																																																BgL_arg2032z00_2038
																																																	=
																																																	CAR
																																																	(BgL_cdrzd212692zd2_2035);
																																																{
																																																	BgL_ev_defglobalz00_bglt
																																																		BgL_auxz00_7341;
																																																	{
																																																		obj_t
																																																			BgL_gez00_7343;
																																																		obj_t
																																																			BgL_gvz00_7342;
																																																		BgL_gvz00_7342
																																																			=
																																																			BgL_arg2031z00_2037;
																																																		BgL_gez00_7343
																																																			=
																																																			BgL_arg2032z00_2038;
																																																		BgL_gez00_1446
																																																			=
																																																			BgL_gez00_7343;
																																																		BgL_gvz00_1445
																																																			=
																																																			BgL_gvz00_7342;
																																																		goto
																																																			BgL_tagzd2168zd2_1447;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7341);
																																																}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg2033z00_2039;
																																																obj_t
																																																	BgL_arg2034z00_2040;
																																																BgL_arg2033z00_2039
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2034z00_2040
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7347;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7349;
																																																		obj_t
																																																			BgL_fz00_7348;
																																																		BgL_fz00_7348
																																																			=
																																																			BgL_arg2033z00_2039;
																																																		BgL_argsz00_7349
																																																			=
																																																			BgL_arg2034z00_2040;
																																																		BgL_argsz00_1468
																																																			=
																																																			BgL_argsz00_7349;
																																																		BgL_fz00_1467
																																																			=
																																																			BgL_fz00_7348;
																																																		goto
																																																			BgL_tagzd2175zd2_1469;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7347);
																																																}
																																															}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_cdrzd212779zd2_2043;
																																												BgL_cdrzd212779zd2_2043
																																													=
																																													CDR
																																													(BgL_cdrzd212400zd2_1997);
																																												if (NULLP(CDR(BgL_cdrzd212779zd2_2043)))
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg2037z00_2045;
																																														obj_t
																																															BgL_arg2038z00_2046;
																																														BgL_arg2037z00_2045
																																															=
																																															CAR
																																															(BgL_cdrzd212400zd2_1997);
																																														BgL_arg2038z00_2046
																																															=
																																															CAR
																																															(BgL_cdrzd212779zd2_2043);
																																														{
																																															BgL_ev_defglobalz00_bglt
																																																BgL_auxz00_7357;
																																															{
																																																obj_t
																																																	BgL_gez00_7359;
																																																obj_t
																																																	BgL_gvz00_7358;
																																																BgL_gvz00_7358
																																																	=
																																																	BgL_arg2037z00_2045;
																																																BgL_gez00_7359
																																																	=
																																																	BgL_arg2038z00_2046;
																																																BgL_gez00_1446
																																																	=
																																																	BgL_gez00_7359;
																																																BgL_gvz00_1445
																																																	=
																																																	BgL_gvz00_7358;
																																																goto
																																																	BgL_tagzd2168zd2_1447;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7357);
																																														}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg2039z00_2047;
																																														obj_t
																																															BgL_arg2041z00_2048;
																																														BgL_arg2039z00_2047
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg2041z00_2048
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7363;
																																															{
																																																obj_t
																																																	BgL_argsz00_7365;
																																																obj_t
																																																	BgL_fz00_7364;
																																																BgL_fz00_7364
																																																	=
																																																	BgL_arg2039z00_2047;
																																																BgL_argsz00_7365
																																																	=
																																																	BgL_arg2041z00_2048;
																																																BgL_argsz00_1468
																																																	=
																																																	BgL_argsz00_7365;
																																																BgL_fz00_1467
																																																	=
																																																	BgL_fz00_7364;
																																																goto
																																																	BgL_tagzd2175zd2_1469;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7363);
																																														}
																																													}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_cdrzd212866zd2_2052;
																																										BgL_cdrzd212866zd2_2052
																																											=
																																											CDR
																																											(BgL_cdrzd212400zd2_1997);
																																										if (NULLP(CDR(BgL_cdrzd212866zd2_2052)))
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg2045z00_2054;
																																												obj_t
																																													BgL_arg2046z00_2055;
																																												BgL_arg2045z00_2054
																																													=
																																													CAR
																																													(BgL_cdrzd212400zd2_1997);
																																												BgL_arg2046z00_2055
																																													=
																																													CAR
																																													(BgL_cdrzd212866zd2_2052);
																																												{
																																													BgL_ev_defglobalz00_bglt
																																														BgL_auxz00_7373;
																																													{
																																														obj_t
																																															BgL_gez00_7375;
																																														obj_t
																																															BgL_gvz00_7374;
																																														BgL_gvz00_7374
																																															=
																																															BgL_arg2045z00_2054;
																																														BgL_gez00_7375
																																															=
																																															BgL_arg2046z00_2055;
																																														BgL_gez00_1446
																																															=
																																															BgL_gez00_7375;
																																														BgL_gvz00_1445
																																															=
																																															BgL_gvz00_7374;
																																														goto
																																															BgL_tagzd2168zd2_1447;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7373);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg2047z00_2056;
																																												obj_t
																																													BgL_arg2048z00_2057;
																																												BgL_arg2047z00_2056
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2048z00_2057
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7379;
																																													{
																																														obj_t
																																															BgL_argsz00_7381;
																																														obj_t
																																															BgL_fz00_7380;
																																														BgL_fz00_7380
																																															=
																																															BgL_arg2047z00_2056;
																																														BgL_argsz00_7381
																																															=
																																															BgL_arg2048z00_2057;
																																														BgL_argsz00_1468
																																															=
																																															BgL_argsz00_7381;
																																														BgL_fz00_1467
																																															=
																																															BgL_fz00_7380;
																																														goto
																																															BgL_tagzd2175zd2_1469;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7379);
																																												}
																																											}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_arg2050z00_2059;
																																								BgL_arg2050z00_2059
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7384;
																																									{
																																										obj_t
																																											BgL_argsz00_7386;
																																										obj_t
																																											BgL_fz00_7385;
																																										BgL_fz00_7385
																																											=
																																											BgL_arg2050z00_2059;
																																										BgL_argsz00_7386
																																											=
																																											BgL_cdrzd212400zd2_1997;
																																										BgL_argsz00_1468
																																											=
																																											BgL_argsz00_7386;
																																										BgL_fz00_1467
																																											=
																																											BgL_fz00_7385;
																																										goto
																																											BgL_tagzd2175zd2_1469;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7384);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 425 */
																																						obj_t
																																							BgL_arg2052z00_2061;
																																						BgL_arg2052z00_2061
																																							=
																																							CAR
																																							(BgL_ez00_69);
																																						{
																																							BgL_ev_appz00_bglt
																																								BgL_auxz00_7389;
																																							{
																																								obj_t
																																									BgL_argsz00_7391;
																																								obj_t
																																									BgL_fz00_7390;
																																								BgL_fz00_7390
																																									=
																																									BgL_arg2052z00_2061;
																																								BgL_argsz00_7391
																																									=
																																									BgL_cdrzd212400zd2_1997;
																																								BgL_argsz00_1468
																																									=
																																									BgL_argsz00_7391;
																																								BgL_fz00_1467
																																									=
																																									BgL_fz00_7390;
																																								goto
																																									BgL_tagzd2175zd2_1469;
																																							}
																																							return
																																								(
																																								(obj_t)
																																								BgL_auxz00_7389);
																																						}
																																					}
																																			}
																																		else
																																			{	/* Eval/evaluate.scm 425 */
																																				if (
																																					(CAR
																																						(BgL_ez00_69)
																																						==
																																						BGl_symbol3052z00zz__evaluatez00))
																																					{	/* Eval/evaluate.scm 425 */
																																						if (PAIRP(BgL_cdrzd212400zd2_1997))
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_carzd213108zd2_2066;
																																								BgL_carzd213108zd2_2066
																																									=
																																									CAR
																																									(BgL_cdrzd212400zd2_1997);
																																								if (PAIRP(BgL_carzd213108zd2_2066))
																																									{	/* Eval/evaluate.scm 425 */
																																										if (NULLP(CDR(BgL_carzd213108zd2_2066)))
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg2058z00_2069;
																																												obj_t
																																													BgL_arg2060z00_2070;
																																												BgL_arg2058z00_2069
																																													=
																																													CAR
																																													(BgL_carzd213108zd2_2066);
																																												BgL_arg2060z00_2070
																																													=
																																													CDR
																																													(BgL_cdrzd212400zd2_1997);
																																												{
																																													BgL_ev_bindzd2exitzd2_bglt
																																														BgL_auxz00_7406;
																																													{
																																														obj_t
																																															BgL_bodyz00_7408;
																																														obj_t
																																															BgL_vz00_7407;
																																														BgL_vz00_7407
																																															=
																																															BgL_arg2058z00_2069;
																																														BgL_bodyz00_7408
																																															=
																																															BgL_arg2060z00_2070;
																																														BgL_bodyz00_1449
																																															=
																																															BgL_bodyz00_7408;
																																														BgL_vz00_1448
																																															=
																																															BgL_vz00_7407;
																																														goto
																																															BgL_tagzd2169zd2_1450;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7406);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg2062z00_2071;
																																												obj_t
																																													BgL_arg2063z00_2072;
																																												BgL_arg2062z00_2071
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2063z00_2072
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7412;
																																													{
																																														obj_t
																																															BgL_argsz00_7414;
																																														obj_t
																																															BgL_fz00_7413;
																																														BgL_fz00_7413
																																															=
																																															BgL_arg2062z00_2071;
																																														BgL_argsz00_7414
																																															=
																																															BgL_arg2063z00_2072;
																																														BgL_argsz00_1468
																																															=
																																															BgL_argsz00_7414;
																																														BgL_fz00_1467
																																															=
																																															BgL_fz00_7413;
																																														goto
																																															BgL_tagzd2175zd2_1469;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7412);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_arg2065z00_2074;
																																										obj_t
																																											BgL_arg2066z00_2075;
																																										BgL_arg2065z00_2074
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										BgL_arg2066z00_2075
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7418;
																																											{
																																												obj_t
																																													BgL_argsz00_7420;
																																												obj_t
																																													BgL_fz00_7419;
																																												BgL_fz00_7419
																																													=
																																													BgL_arg2065z00_2074;
																																												BgL_argsz00_7420
																																													=
																																													BgL_arg2066z00_2075;
																																												BgL_argsz00_1468
																																													=
																																													BgL_argsz00_7420;
																																												BgL_fz00_1467
																																													=
																																													BgL_fz00_7419;
																																												goto
																																													BgL_tagzd2175zd2_1469;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7418);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 425 */
																																								obj_t
																																									BgL_arg2068z00_2076;
																																								obj_t
																																									BgL_arg2069z00_2077;
																																								BgL_arg2068z00_2076
																																									=
																																									CAR
																																									(BgL_ez00_69);
																																								BgL_arg2069z00_2077
																																									=
																																									CDR
																																									(BgL_ez00_69);
																																								{
																																									BgL_ev_appz00_bglt
																																										BgL_auxz00_7424;
																																									{
																																										obj_t
																																											BgL_argsz00_7426;
																																										obj_t
																																											BgL_fz00_7425;
																																										BgL_fz00_7425
																																											=
																																											BgL_arg2068z00_2076;
																																										BgL_argsz00_7426
																																											=
																																											BgL_arg2069z00_2077;
																																										BgL_argsz00_1468
																																											=
																																											BgL_argsz00_7426;
																																										BgL_fz00_1467
																																											=
																																											BgL_fz00_7425;
																																										goto
																																											BgL_tagzd2175zd2_1469;
																																									}
																																									return
																																										(
																																										(obj_t)
																																										BgL_auxz00_7424);
																																								}
																																							}
																																					}
																																				else
																																					{	/* Eval/evaluate.scm 425 */
																																						obj_t
																																							BgL_cdrzd213273zd2_2078;
																																						BgL_cdrzd213273zd2_2078
																																							=
																																							CDR
																																							(BgL_ez00_69);
																																						if (
																																							(CAR
																																								(BgL_ez00_69)
																																								==
																																								BGl_symbol3054z00zz__evaluatez00))
																																							{	/* Eval/evaluate.scm 425 */
																																								if (PAIRP(BgL_cdrzd213273zd2_2078))
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_arg2072z00_2081;
																																										obj_t
																																											BgL_arg2073z00_2082;
																																										BgL_arg2072z00_2081
																																											=
																																											CAR
																																											(BgL_cdrzd213273zd2_2078);
																																										BgL_arg2073z00_2082
																																											=
																																											CDR
																																											(BgL_cdrzd213273zd2_2078);
																																										{
																																											BgL_ev_unwindzd2protectzd2_bglt
																																												BgL_auxz00_7436;
																																											{
																																												obj_t
																																													BgL_bodyz00_7438;
																																												obj_t
																																													BgL_ez00_7437;
																																												BgL_ez00_7437
																																													=
																																													BgL_arg2072z00_2081;
																																												BgL_bodyz00_7438
																																													=
																																													BgL_arg2073z00_2082;
																																												BgL_bodyz00_1452
																																													=
																																													BgL_bodyz00_7438;
																																												BgL_ez00_1451
																																													=
																																													BgL_ez00_7437;
																																												goto
																																													BgL_tagzd2170zd2_1453;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7436);
																																										}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_arg2074z00_2083;
																																										BgL_arg2074z00_2083
																																											=
																																											CAR
																																											(BgL_ez00_69);
																																										{
																																											BgL_ev_appz00_bglt
																																												BgL_auxz00_7441;
																																											{
																																												obj_t
																																													BgL_argsz00_7443;
																																												obj_t
																																													BgL_fz00_7442;
																																												BgL_fz00_7442
																																													=
																																													BgL_arg2074z00_2083;
																																												BgL_argsz00_7443
																																													=
																																													BgL_cdrzd213273zd2_2078;
																																												BgL_argsz00_1468
																																													=
																																													BgL_argsz00_7443;
																																												BgL_fz00_1467
																																													=
																																													BgL_fz00_7442;
																																												goto
																																													BgL_tagzd2175zd2_1469;
																																											}
																																											return
																																												(
																																												(obj_t)
																																												BgL_auxz00_7441);
																																										}
																																									}
																																							}
																																						else
																																							{	/* Eval/evaluate.scm 425 */
																																								if ((CAR(BgL_ez00_69) == BGl_symbol3056z00zz__evaluatez00))
																																									{	/* Eval/evaluate.scm 425 */
																																										if (PAIRP(BgL_cdrzd213273zd2_2078))
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg2078z00_2088;
																																												obj_t
																																													BgL_arg2079z00_2089;
																																												BgL_arg2078z00_2088
																																													=
																																													CAR
																																													(BgL_cdrzd213273zd2_2078);
																																												BgL_arg2079z00_2089
																																													=
																																													CDR
																																													(BgL_cdrzd213273zd2_2078);
																																												{
																																													BgL_ev_withzd2handlerzd2_bglt
																																														BgL_auxz00_7452;
																																													{
																																														obj_t
																																															BgL_bodyz00_7454;
																																														obj_t
																																															BgL_hz00_7453;
																																														BgL_hz00_7453
																																															=
																																															BgL_arg2078z00_2088;
																																														BgL_bodyz00_7454
																																															=
																																															BgL_arg2079z00_2089;
																																														BgL_bodyz00_1455
																																															=
																																															BgL_bodyz00_7454;
																																														BgL_hz00_1454
																																															=
																																															BgL_hz00_7453;
																																														goto
																																															BgL_tagzd2171zd2_1456;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7452);
																																												}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												obj_t
																																													BgL_arg2080z00_2090;
																																												obj_t
																																													BgL_arg2081z00_2091;
																																												BgL_arg2080z00_2090
																																													=
																																													CAR
																																													(BgL_ez00_69);
																																												BgL_arg2081z00_2091
																																													=
																																													CDR
																																													(BgL_ez00_69);
																																												{
																																													BgL_ev_appz00_bglt
																																														BgL_auxz00_7458;
																																													{
																																														obj_t
																																															BgL_argsz00_7460;
																																														obj_t
																																															BgL_fz00_7459;
																																														BgL_fz00_7459
																																															=
																																															BgL_arg2080z00_2090;
																																														BgL_argsz00_7460
																																															=
																																															BgL_arg2081z00_2091;
																																														BgL_argsz00_1468
																																															=
																																															BgL_argsz00_7460;
																																														BgL_fz00_1467
																																															=
																																															BgL_fz00_7459;
																																														goto
																																															BgL_tagzd2175zd2_1469;
																																													}
																																													return
																																														(
																																														(obj_t)
																																														BgL_auxz00_7458);
																																												}
																																											}
																																									}
																																								else
																																									{	/* Eval/evaluate.scm 425 */
																																										obj_t
																																											BgL_cdrzd213376zd2_2092;
																																										BgL_cdrzd213376zd2_2092
																																											=
																																											CDR
																																											(BgL_ez00_69);
																																										if ((CAR(BgL_ez00_69) == BGl_symbol3058z00zz__evaluatez00))
																																											{	/* Eval/evaluate.scm 425 */
																																												if (PAIRP(BgL_cdrzd213376zd2_2092))
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_cdrzd213381zd2_2095;
																																														BgL_cdrzd213381zd2_2095
																																															=
																																															CDR
																																															(BgL_cdrzd213376zd2_2092);
																																														if (PAIRP(BgL_cdrzd213381zd2_2095))
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd213386zd2_2097;
																																																BgL_cdrzd213386zd2_2097
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213381zd2_2095);
																																																if ((CAR(BgL_cdrzd213381zd2_2095) == BGl_keyword3060z00zz__evaluatez00))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		if (PAIRP(BgL_cdrzd213386zd2_2097))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2087z00_2100;
																																																				obj_t
																																																					BgL_arg2088z00_2101;
																																																				obj_t
																																																					BgL_arg2089z00_2102;
																																																				BgL_arg2087z00_2100
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213376zd2_2092);
																																																				BgL_arg2088z00_2101
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213386zd2_2097);
																																																				BgL_arg2089z00_2102
																																																					=
																																																					CDR
																																																					(BgL_cdrzd213386zd2_2097);
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_7480;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7483;
																																																						obj_t
																																																							BgL_pz00_7482;
																																																						obj_t
																																																							BgL_mz00_7481;
																																																						BgL_mz00_7481
																																																							=
																																																							BgL_arg2087z00_2100;
																																																						BgL_pz00_7482
																																																							=
																																																							BgL_arg2088z00_2101;
																																																						BgL_bodyz00_7483
																																																							=
																																																							BgL_arg2089z00_2102;
																																																						BgL_bodyz00_1459
																																																							=
																																																							BgL_bodyz00_7483;
																																																						BgL_pz00_1458
																																																							=
																																																							BgL_pz00_7482;
																																																						BgL_mz00_1457
																																																							=
																																																							BgL_mz00_7481;
																																																						goto
																																																							BgL_tagzd2172zd2_1460;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7480);
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2090z00_2104;
																																																				obj_t
																																																					BgL_arg2092z00_2105;
																																																				BgL_arg2090z00_2104
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213376zd2_2092);
																																																				BgL_arg2092z00_2105
																																																					=
																																																					CDR
																																																					(BgL_cdrzd213376zd2_2092);
																																																				{
																																																					BgL_ev_synchroniza7eza7_bglt
																																																						BgL_auxz00_7487;
																																																					{
																																																						obj_t
																																																							BgL_bodyz00_7489;
																																																						obj_t
																																																							BgL_mz00_7488;
																																																						BgL_mz00_7488
																																																							=
																																																							BgL_arg2090z00_2104;
																																																						BgL_bodyz00_7489
																																																							=
																																																							BgL_arg2092z00_2105;
																																																						BgL_bodyz00_1462
																																																							=
																																																							BgL_bodyz00_7489;
																																																						BgL_mz00_1461
																																																							=
																																																							BgL_mz00_7488;
																																																						goto
																																																							BgL_tagzd2173zd2_1463;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7487);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg2093z00_2107;
																																																		obj_t
																																																			BgL_arg2095z00_2108;
																																																		BgL_arg2093z00_2107
																																																			=
																																																			CAR
																																																			(BgL_cdrzd213376zd2_2092);
																																																		BgL_arg2095z00_2108
																																																			=
																																																			CDR
																																																			(BgL_cdrzd213376zd2_2092);
																																																		{
																																																			BgL_ev_synchroniza7eza7_bglt
																																																				BgL_auxz00_7493;
																																																			{
																																																				obj_t
																																																					BgL_bodyz00_7495;
																																																				obj_t
																																																					BgL_mz00_7494;
																																																				BgL_mz00_7494
																																																					=
																																																					BgL_arg2093z00_2107;
																																																				BgL_bodyz00_7495
																																																					=
																																																					BgL_arg2095z00_2108;
																																																				BgL_bodyz00_1462
																																																					=
																																																					BgL_bodyz00_7495;
																																																				BgL_mz00_1461
																																																					=
																																																					BgL_mz00_7494;
																																																				goto
																																																					BgL_tagzd2173zd2_1463;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7493);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg2097z00_2111;
																																																obj_t
																																																	BgL_arg2098z00_2112;
																																																BgL_arg2097z00_2111
																																																	=
																																																	CAR
																																																	(BgL_cdrzd213376zd2_2092);
																																																BgL_arg2098z00_2112
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213376zd2_2092);
																																																{
																																																	BgL_ev_synchroniza7eza7_bglt
																																																		BgL_auxz00_7499;
																																																	{
																																																		obj_t
																																																			BgL_bodyz00_7501;
																																																		obj_t
																																																			BgL_mz00_7500;
																																																		BgL_mz00_7500
																																																			=
																																																			BgL_arg2097z00_2111;
																																																		BgL_bodyz00_7501
																																																			=
																																																			BgL_arg2098z00_2112;
																																																		BgL_bodyz00_1462
																																																			=
																																																			BgL_bodyz00_7501;
																																																		BgL_mz00_1461
																																																			=
																																																			BgL_mz00_7500;
																																																		goto
																																																			BgL_tagzd2173zd2_1463;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7499);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg2099z00_2113;
																																														BgL_arg2099z00_2113
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7504;
																																															{
																																																obj_t
																																																	BgL_argsz00_7506;
																																																obj_t
																																																	BgL_fz00_7505;
																																																BgL_fz00_7505
																																																	=
																																																	BgL_arg2099z00_2113;
																																																BgL_argsz00_7506
																																																	=
																																																	BgL_cdrzd213376zd2_2092;
																																																BgL_argsz00_1468
																																																	=
																																																	BgL_argsz00_7506;
																																																BgL_fz00_1467
																																																	=
																																																	BgL_fz00_7505;
																																																goto
																																																	BgL_tagzd2175zd2_1469;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7504);
																																														}
																																													}
																																											}
																																										else
																																											{	/* Eval/evaluate.scm 425 */
																																												if ((CAR(BgL_ez00_69) == BGl_symbol3015z00zz__evaluatez00))
																																													{	/* Eval/evaluate.scm 425 */
																																														if (PAIRP(BgL_cdrzd213376zd2_2092))
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_cdrzd213486zd2_2118;
																																																BgL_cdrzd213486zd2_2118
																																																	=
																																																	CDR
																																																	(BgL_cdrzd213376zd2_2092);
																																																if (PAIRP(BgL_cdrzd213486zd2_2118))
																																																	{	/* Eval/evaluate.scm 425 */
																																																		if (NULLP(CDR(BgL_cdrzd213486zd2_2118)))
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2105z00_2121;
																																																				obj_t
																																																					BgL_arg2106z00_2122;
																																																				BgL_arg2105z00_2121
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213376zd2_2092);
																																																				BgL_arg2106z00_2122
																																																					=
																																																					CAR
																																																					(BgL_cdrzd213486zd2_2118);
																																																				{	/* Eval/evaluate.scm 596 */
																																																					obj_t
																																																						BgL_arg2267z00_4731;
																																																					{	/* Eval/evaluate.scm 596 */
																																																						obj_t
																																																							BgL_arg2268z00_4732;
																																																						{	/* Eval/evaluate.scm 596 */
																																																							obj_t
																																																								BgL_arg2269z00_4733;
																																																							obj_t
																																																								BgL_arg2270z00_4734;
																																																							{	/* Eval/evaluate.scm 596 */
																																																								obj_t
																																																									BgL_res2896z00_4737;
																																																								{	/* Eval/evaluate.scm 596 */
																																																									obj_t
																																																										BgL_symbolz00_4735;
																																																									BgL_symbolz00_4735
																																																										=
																																																										BGl_symbol3062z00zz__evaluatez00;
																																																									{	/* Eval/evaluate.scm 596 */
																																																										obj_t
																																																											BgL_arg2423z00_4736;
																																																										BgL_arg2423z00_4736
																																																											=
																																																											SYMBOL_TO_STRING
																																																											(BgL_symbolz00_4735);
																																																										BgL_res2896z00_4737
																																																											=
																																																											BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																											(BgL_arg2423z00_4736);
																																																									}
																																																								}
																																																								BgL_arg2269z00_4733
																																																									=
																																																									BgL_res2896z00_4737;
																																																							}
																																																							{	/* Eval/evaluate.scm 596 */
																																																								obj_t
																																																									BgL_res2897z00_4740;
																																																								{	/* Eval/evaluate.scm 596 */
																																																									obj_t
																																																										BgL_arg2423z00_4739;
																																																									BgL_arg2423z00_4739
																																																										=
																																																										SYMBOL_TO_STRING
																																																										(BgL_wherez00_73);
																																																									BgL_res2897z00_4740
																																																										=
																																																										BGl_stringzd2copyzd2zz__r4_strings_6_7z00
																																																										(BgL_arg2423z00_4739);
																																																								}
																																																								BgL_arg2270z00_4734
																																																									=
																																																									BgL_res2897z00_4740;
																																																							}
																																																							BgL_arg2268z00_4732
																																																								=
																																																								string_append
																																																								(BgL_arg2269z00_4733,
																																																								BgL_arg2270z00_4734);
																																																						}
																																																						BgL_arg2267z00_4731
																																																							=
																																																							bstring_to_symbol
																																																							(BgL_arg2268z00_4732);
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BGl_convzd2lambdazd2zz__evaluatez00
																																																						(BgL_globalsz00_71,
																																																							BgL_localsz00_70,
																																																							BgL_ez00_69,
																																																							BgL_locz00_74,
																																																							BgL_arg2105z00_2121,
																																																							BgL_arg2106z00_2122,
																																																							BgL_arg2267z00_4731,
																																																							BFALSE));
																																																				}
																																																			}
																																																		else
																																																			{	/* Eval/evaluate.scm 425 */
																																																				obj_t
																																																					BgL_arg2107z00_2123;
																																																				obj_t
																																																					BgL_arg2108z00_2124;
																																																				BgL_arg2107z00_2123
																																																					=
																																																					CAR
																																																					(BgL_ez00_69);
																																																				BgL_arg2108z00_2124
																																																					=
																																																					CDR
																																																					(BgL_ez00_69);
																																																				{
																																																					BgL_ev_appz00_bglt
																																																						BgL_auxz00_7531;
																																																					{
																																																						obj_t
																																																							BgL_argsz00_7533;
																																																						obj_t
																																																							BgL_fz00_7532;
																																																						BgL_fz00_7532
																																																							=
																																																							BgL_arg2107z00_2123;
																																																						BgL_argsz00_7533
																																																							=
																																																							BgL_arg2108z00_2124;
																																																						BgL_argsz00_1468
																																																							=
																																																							BgL_argsz00_7533;
																																																						BgL_fz00_1467
																																																							=
																																																							BgL_fz00_7532;
																																																						goto
																																																							BgL_tagzd2175zd2_1469;
																																																					}
																																																					return
																																																						(
																																																						(obj_t)
																																																						BgL_auxz00_7531);
																																																				}
																																																			}
																																																	}
																																																else
																																																	{	/* Eval/evaluate.scm 425 */
																																																		obj_t
																																																			BgL_arg2110z00_2126;
																																																		obj_t
																																																			BgL_arg2111z00_2127;
																																																		BgL_arg2110z00_2126
																																																			=
																																																			CAR
																																																			(BgL_ez00_69);
																																																		BgL_arg2111z00_2127
																																																			=
																																																			CDR
																																																			(BgL_ez00_69);
																																																		{
																																																			BgL_ev_appz00_bglt
																																																				BgL_auxz00_7537;
																																																			{
																																																				obj_t
																																																					BgL_argsz00_7539;
																																																				obj_t
																																																					BgL_fz00_7538;
																																																				BgL_fz00_7538
																																																					=
																																																					BgL_arg2110z00_2126;
																																																				BgL_argsz00_7539
																																																					=
																																																					BgL_arg2111z00_2127;
																																																				BgL_argsz00_1468
																																																					=
																																																					BgL_argsz00_7539;
																																																				BgL_fz00_1467
																																																					=
																																																					BgL_fz00_7538;
																																																				goto
																																																					BgL_tagzd2175zd2_1469;
																																																			}
																																																			return
																																																				(
																																																				(obj_t)
																																																				BgL_auxz00_7537);
																																																		}
																																																	}
																																															}
																																														else
																																															{	/* Eval/evaluate.scm 425 */
																																																obj_t
																																																	BgL_arg2112z00_2128;
																																																obj_t
																																																	BgL_arg2113z00_2129;
																																																BgL_arg2112z00_2128
																																																	=
																																																	CAR
																																																	(BgL_ez00_69);
																																																BgL_arg2113z00_2129
																																																	=
																																																	CDR
																																																	(BgL_ez00_69);
																																																{
																																																	BgL_ev_appz00_bglt
																																																		BgL_auxz00_7543;
																																																	{
																																																		obj_t
																																																			BgL_argsz00_7545;
																																																		obj_t
																																																			BgL_fz00_7544;
																																																		BgL_fz00_7544
																																																			=
																																																			BgL_arg2112z00_2128;
																																																		BgL_argsz00_7545
																																																			=
																																																			BgL_arg2113z00_2129;
																																																		BgL_argsz00_1468
																																																			=
																																																			BgL_argsz00_7545;
																																																		BgL_fz00_1467
																																																			=
																																																			BgL_fz00_7544;
																																																		goto
																																																			BgL_tagzd2175zd2_1469;
																																																	}
																																																	return
																																																		(
																																																		(obj_t)
																																																		BgL_auxz00_7543);
																																																}
																																															}
																																													}
																																												else
																																													{	/* Eval/evaluate.scm 425 */
																																														obj_t
																																															BgL_arg2114z00_2130;
																																														obj_t
																																															BgL_arg2116z00_2131;
																																														BgL_arg2114z00_2130
																																															=
																																															CAR
																																															(BgL_ez00_69);
																																														BgL_arg2116z00_2131
																																															=
																																															CDR
																																															(BgL_ez00_69);
																																														{
																																															BgL_ev_appz00_bglt
																																																BgL_auxz00_7549;
																																															{
																																																obj_t
																																																	BgL_argsz00_7551;
																																																obj_t
																																																	BgL_fz00_7550;
																																																BgL_fz00_7550
																																																	=
																																																	BgL_arg2114z00_2130;
																																																BgL_argsz00_7551
																																																	=
																																																	BgL_arg2116z00_2131;
																																																BgL_argsz00_1468
																																																	=
																																																	BgL_argsz00_7551;
																																																BgL_fz00_1467
																																																	=
																																																	BgL_fz00_7550;
																																																goto
																																																	BgL_tagzd2175zd2_1469;
																																															}
																																															return
																																																(
																																																(obj_t)
																																																BgL_auxz00_7549);
																																														}
																																													}
																																											}
																																									}
																																							}
																																					}
																																			}
																																	}
																															}
																													}
																											}
																									}
																							}
																					}
																			}
																	}
															}
													}
											}
									}
							}
					}
				else
					{	/* Eval/evaluate.scm 425 */
						BgL_xz00_1392 = BgL_ez00_69;
						if (SYMBOLP(BgL_xz00_1392))
							{	/* Eval/evaluate.scm 428 */
								obj_t BgL__ortest_1101z00_2152;

								BgL__ortest_1101z00_2152 =
									BGl_convzd2varzd2zz__evaluatez00(BgL_xz00_1392,
									BgL_localsz00_70);
								if (CBOOL(BgL__ortest_1101z00_2152))
									{	/* Eval/evaluate.scm 428 */
										return BgL__ortest_1101z00_2152;
									}
								else
									{	/* Eval/evaluate.scm 196 */
										BgL_ev_globalz00_bglt BgL_new1076z00_3282;

										{	/* Eval/evaluate.scm 197 */
											BgL_ev_globalz00_bglt BgL_new1075z00_3283;

											BgL_new1075z00_3283 =
												((BgL_ev_globalz00_bglt) BREF(GC_MALLOC(sizeof(struct
															BgL_ev_globalz00_bgl))));
											{	/* Eval/evaluate.scm 197 */
												long BgL_arg1372z00_3284;

												{	/* Eval/evaluate.scm 197 */
													long BgL_res2674z00_3287;

													BgL_res2674z00_3287 =
														BGL_CLASS_INDEX
														(BGl_ev_globalz00zz__evaluate_typesz00);
													BgL_arg1372z00_3284 = BgL_res2674z00_3287;
												}
												BGL_OBJECT_CLASS_NUM_SET(
													((BgL_objectz00_bglt) BgL_new1075z00_3283),
													BgL_arg1372z00_3284);
											}
											{	/* Eval/evaluate.scm 197 */
												BgL_objectz00_bglt BgL_auxz00_7562;

												BgL_auxz00_7562 =
													((BgL_objectz00_bglt) BgL_new1075z00_3283);
												BGL_OBJECT_WIDENING_SET(BgL_auxz00_7562, BFALSE);
											}
											BgL_new1076z00_3282 = BgL_new1075z00_3283;
										}
										((((BgL_ev_globalz00_bglt) CREF(BgL_new1076z00_3282))->
												BgL_locz00) = ((obj_t) BgL_locz00_74), BUNSPEC);
										((((BgL_ev_globalz00_bglt) CREF(BgL_new1076z00_3282))->
												BgL_namez00) = ((obj_t) BgL_xz00_1392), BUNSPEC);
										{
											obj_t BgL_auxz00_7567;

											if (BGl_evmodulezf3zf3zz__evmodulez00(BgL_globalsz00_71))
												{	/* Eval/evaluate.scm 199 */
													BgL_auxz00_7567 = BgL_globalsz00_71;
												}
											else
												{	/* Eval/evaluate.scm 199 */
													BgL_auxz00_7567 = BGL_MODULE();
												}
											((((BgL_ev_globalz00_bglt) CREF(BgL_new1076z00_3282))->
													BgL_modz00) = ((obj_t) BgL_auxz00_7567), BUNSPEC);
										}
										return ((obj_t) BgL_new1076z00_3282);
									}
							}
						else
							{	/* Eval/evaluate.scm 429 */
								BgL_ev_littz00_bglt BgL_new1103z00_2153;

								{	/* Eval/evaluate.scm 430 */
									BgL_ev_littz00_bglt BgL_new1102z00_2154;

									BgL_new1102z00_2154 =
										((BgL_ev_littz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_ev_littz00_bgl))));
									{	/* Eval/evaluate.scm 430 */
										long BgL_arg2138z00_2155;

										{	/* Eval/evaluate.scm 430 */
											long BgL_res2675z00_3291;

											BgL_res2675z00_3291 =
												BGL_CLASS_INDEX(BGl_ev_littz00zz__evaluate_typesz00);
											BgL_arg2138z00_2155 = BgL_res2675z00_3291;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1102z00_2154),
											BgL_arg2138z00_2155);
									}
									{	/* Eval/evaluate.scm 430 */
										BgL_objectz00_bglt BgL_auxz00_7577;

										BgL_auxz00_7577 =
											((BgL_objectz00_bglt) BgL_new1102z00_2154);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_7577, BFALSE);
									}
									BgL_new1103z00_2153 = BgL_new1102z00_2154;
								}
								((((BgL_ev_littz00_bglt) CREF(BgL_new1103z00_2153))->
										BgL_valuez00) = ((obj_t) BgL_xz00_1392), BUNSPEC);
								return ((obj_t) BgL_new1103z00_2153);
							}
					}
			}
		}
	}



/* loop */
	obj_t BGl_loopz00zz__evaluatez00(obj_t BgL_wherez00_4977,
		obj_t BgL_globalsz00_4976, obj_t BgL_localsz00_4975, obj_t BgL_locz00_4974,
		obj_t BgL_esz00_2493)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 387 */
			if (NULLP(BgL_esz00_2493))
				{	/* Eval/evaluate.scm 388 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 390 */
					obj_t BgL_ez00_2496;

					BgL_ez00_2496 = CAR(BgL_esz00_2493);
					{	/* Eval/evaluate.scm 391 */
						obj_t BgL_arg2301z00_2497;
						obj_t BgL_arg2302z00_2498;

						{	/* Eval/evaluate.scm 391 */
							obj_t BgL_arg2303z00_2499;

							{	/* Eval/evaluate.scm 151 */
								obj_t BgL__ortest_1068z00_3225;

								BgL__ortest_1068z00_3225 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_ez00_2496);
								if (CBOOL(BgL__ortest_1068z00_3225))
									{	/* Eval/evaluate.scm 151 */
										BgL_arg2303z00_2499 = BgL__ortest_1068z00_3225;
									}
								else
									{	/* Eval/evaluate.scm 152 */
										obj_t BgL__ortest_1069z00_3226;

										BgL__ortest_1069z00_3226 =
											BGl_getzd2sourcezd2locationz00zz__readerz00
											(BgL_esz00_2493);
										if (CBOOL(BgL__ortest_1069z00_3226))
											{	/* Eval/evaluate.scm 152 */
												BgL_arg2303z00_2499 = BgL__ortest_1069z00_3226;
											}
										else
											{	/* Eval/evaluate.scm 152 */
												BgL_arg2303z00_2499 = BgL_locz00_4974;
											}
									}
							}
							BgL_arg2301z00_2497 =
								BGl_convz00zz__evaluatez00(BgL_ez00_2496, BgL_localsz00_4975,
								BgL_globalsz00_4976, BFALSE, BgL_wherez00_4977,
								BgL_arg2303z00_2499, ((bool_t) 0));
						}
						BgL_arg2302z00_2498 =
							BGl_loopz00zz__evaluatez00(BgL_wherez00_4977, BgL_globalsz00_4976,
							BgL_localsz00_4975, BgL_locz00_4974, CDR(BgL_esz00_2493));
						return MAKE_PAIR(BgL_arg2301z00_2497, BgL_arg2302z00_2498);
					}
				}
		}
	}



/* conv-vals */
	obj_t BGl_convzd2valszd2zz__evaluatez00(obj_t BgL_wherez00_4979,
		obj_t BgL_globalsz00_4978, obj_t BgL_lz00_3601, obj_t BgL_varsz00_3602,
		obj_t BgL_localsz00_3603, obj_t BgL_locz00_3604)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 503 */
			if (NULLP(BgL_lz00_3601))
				{	/* Eval/evaluate.scm 499 */
					return BNIL;
				}
			else
				{	/* Eval/evaluate.scm 501 */
					obj_t BgL_locz00_3616;

					{	/* Eval/evaluate.scm 501 */
						obj_t BgL_arg2211z00_3617;

						BgL_arg2211z00_3617 = CAR(BgL_lz00_3601);
						{	/* Eval/evaluate.scm 145 */
							obj_t BgL__ortest_1067z00_3630;

							BgL__ortest_1067z00_3630 =
								BGl_getzd2sourcezd2locationz00zz__readerz00
								(BgL_arg2211z00_3617);
							if (CBOOL(BgL__ortest_1067z00_3630))
								{	/* Eval/evaluate.scm 145 */
									BgL_locz00_3616 = BgL__ortest_1067z00_3630;
								}
							else
								{	/* Eval/evaluate.scm 145 */
									BgL_locz00_3616 = BgL_locz00_3604;
								}
						}
					}
					{	/* Eval/evaluate.scm 502 */
						obj_t BgL_arg2203z00_3618;
						obj_t BgL_arg2204z00_3619;

						BgL_arg2203z00_3618 =
							BGl_convz00zz__evaluatez00(CAR(CDR(CAR(BgL_lz00_3601))),
							BgL_localsz00_3603, BgL_globalsz00_4978, BFALSE,
							BgL_wherez00_4979, BgL_locz00_3616, ((bool_t) 0));
						{	/* Eval/evaluate.scm 503 */
							obj_t BgL_arg2206z00_3621;
							obj_t BgL_arg2207z00_3622;
							obj_t BgL_arg2209z00_3623;

							BgL_arg2206z00_3621 = CDR(BgL_lz00_3601);
							BgL_arg2207z00_3622 = CDR(BgL_varsz00_3602);
							BgL_arg2209z00_3623 =
								MAKE_PAIR(CAR(BgL_varsz00_3602), BgL_localsz00_3603);
							BgL_arg2204z00_3619 =
								BGl_convzd2valszd2zz__evaluatez00(BgL_wherez00_4979,
								BgL_globalsz00_4978, BgL_arg2206z00_3621, BgL_arg2207z00_3622,
								BgL_arg2209z00_3623, BgL_locz00_3616);
						}
						return MAKE_PAIR(BgL_arg2203z00_3618, BgL_arg2204z00_3619);
					}
				}
		}
	}



/* conv-lambda */
	BgL_ev_absz00_bglt BGl_convzd2lambdazd2zz__evaluatez00(obj_t
		BgL_globalsz00_4983, obj_t BgL_localsz00_4982, obj_t BgL_ez00_4981,
		obj_t BgL_locz00_4980, obj_t BgL_formalsz00_2432, obj_t BgL_bodyz00_2433,
		obj_t BgL_wherez00_2434, obj_t BgL_typez00_2435)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 405 */
			{
				obj_t BgL_lz00_2466;

				{	/* Eval/evaluate.scm 407 */
					obj_t BgL_argsz00_2438;

					BgL_lz00_2466 =
						BGl_dssslzd2formalszd2ze3schemezd2typedzd2formalsze3zz__dssslz00
						(BgL_formalsz00_2432, BGl_errorzd2envzd2zz__errorz00, ((bool_t) 1));
					{
						obj_t BgL_rz00_2470;
						obj_t BgL_flatz00_2471;
						long BgL_arityz00_2472;

						BgL_rz00_2470 = BgL_lz00_2466;
						BgL_flatz00_2471 = BNIL;
						BgL_arityz00_2472 = ((long) 0);
					BgL_zc3anonymousza32286ze3z83_2473:
						if (NULLP(BgL_rz00_2470))
							{	/* Eval/evaluate.scm 400 */
								obj_t BgL_val0_1195z00_2475;

								BgL_val0_1195z00_2475 = bgl_reverse_bang(BgL_flatz00_2471);
								{	/* Eval/evaluate.scm 400 */
									int BgL_res2662z00_3231;

									{	/* Eval/evaluate.scm 400 */
										int BgL_auxz00_7614;

										BgL_auxz00_7614 = (int) (((long) 2));
										BgL_res2662z00_3231 =
											BGL_MVALUES_NUMBER_SET(BgL_auxz00_7614);
									} BgL_res2662z00_3231;
								}
								{	/* Eval/evaluate.scm 400 */
									obj_t BgL_auxz00_7619;
									int BgL_auxz00_7617;

									BgL_auxz00_7619 = BINT(BgL_arityz00_2472);
									BgL_auxz00_7617 = (int) (((long) 1));
									BGL_MVALUES_VAL_SET(BgL_auxz00_7617, BgL_auxz00_7619);
								}
								BgL_argsz00_2438 = BgL_val0_1195z00_2475;
							}
						else
							{	/* Eval/evaluate.scm 399 */
								if (PAIRP(BgL_rz00_2470))
									{	/* Eval/evaluate.scm 404 */
										obj_t BgL_arg2289z00_2478;
										obj_t BgL_arg2292z00_2479;
										long BgL_arg2293z00_2480;

										BgL_arg2289z00_2478 = CDR(BgL_rz00_2470);
										BgL_arg2292z00_2479 =
											MAKE_PAIR(BGl_untypezd2identzd2zz__evaluatez00(CAR
												(BgL_rz00_2470)), BgL_flatz00_2471);
										BgL_arg2293z00_2480 = (BgL_arityz00_2472 + ((long) 1));
										{
											long BgL_arityz00_7631;
											obj_t BgL_flatz00_7630;
											obj_t BgL_rz00_7629;

											BgL_rz00_7629 = BgL_arg2289z00_2478;
											BgL_flatz00_7630 = BgL_arg2292z00_2479;
											BgL_arityz00_7631 = BgL_arg2293z00_2480;
											BgL_arityz00_2472 = BgL_arityz00_7631;
											BgL_flatz00_2471 = BgL_flatz00_7630;
											BgL_rz00_2470 = BgL_rz00_7629;
											goto BgL_zc3anonymousza32286ze3z83_2473;
										}
									}
								else
									{	/* Eval/evaluate.scm 402 */
										obj_t BgL_val0_1197z00_2483;
										long BgL_val1_1198z00_2484;

										{	/* Eval/evaluate.scm 402 */
											obj_t BgL_arg2296z00_2485;

											BgL_arg2296z00_2485 =
												MAKE_PAIR(BGl_untypezd2identzd2zz__evaluatez00
												(BgL_rz00_2470), BgL_flatz00_2471);
											BgL_val0_1197z00_2483 =
												bgl_reverse_bang(BgL_arg2296z00_2485);
										}
										BgL_val1_1198z00_2484 = (((long) -1) - BgL_arityz00_2472);
										{	/* Eval/evaluate.scm 402 */
											int BgL_res2666z00_3245;

											{	/* Eval/evaluate.scm 402 */
												int BgL_auxz00_7636;

												BgL_auxz00_7636 = (int) (((long) 2));
												BgL_res2666z00_3245 =
													BGL_MVALUES_NUMBER_SET(BgL_auxz00_7636);
											} BgL_res2666z00_3245;
										}
										{	/* Eval/evaluate.scm 402 */
											obj_t BgL_auxz00_7641;
											int BgL_auxz00_7639;

											BgL_auxz00_7641 = BINT(BgL_val1_1198z00_2484);
											BgL_auxz00_7639 = (int) (((long) 1));
											BGL_MVALUES_VAL_SET(BgL_auxz00_7639, BgL_auxz00_7641);
										}
										BgL_argsz00_2438 = BgL_val0_1197z00_2483;
					}}}
					{	/* Eval/evaluate.scm 408 */
						obj_t BgL_arityz00_2439;

						{	/* Eval/evaluate.scm 409 */
							int BgL_auxz00_7645;

							BgL_auxz00_7645 = (int) (((long) 1));
							BgL_arityz00_2439 = BGL_MVALUES_VAL(BgL_auxz00_7645);
						}
						{	/* Eval/evaluate.scm 409 */
							obj_t BgL_varsz00_2440;
							obj_t BgL_bodyz00_2441;
							obj_t BgL_nlocz00_2442;

							if (NULLP(BgL_argsz00_2438))
								{	/* Eval/evaluate.scm 409 */
									BgL_varsz00_2440 = BNIL;
								}
							else
								{	/* Eval/evaluate.scm 409 */
									obj_t BgL_head1201z00_2449;

									{	/* Eval/evaluate.scm 409 */
										obj_t BgL_res2668z00_3253;

										BgL_res2668z00_3253 = MAKE_PAIR(BNIL, BNIL);
										BgL_head1201z00_2449 = BgL_res2668z00_3253;
									}
									{
										obj_t BgL_l1199z00_2451;
										obj_t BgL_tail1202z00_2452;

										BgL_l1199z00_2451 = BgL_argsz00_2438;
										BgL_tail1202z00_2452 = BgL_head1201z00_2449;
									BgL_zc3anonymousza32276ze3z83_2453:
										if (NULLP(BgL_l1199z00_2451))
											{	/* Eval/evaluate.scm 409 */
												BgL_varsz00_2440 = CDR(BgL_head1201z00_2449);
											}
										else
											{	/* Eval/evaluate.scm 409 */
												obj_t BgL_newtail1203z00_2455;

												{	/* Eval/evaluate.scm 409 */
													BgL_ev_varz00_bglt BgL_arg2280z00_2457;

													{	/* Eval/evaluate.scm 409 */
														obj_t BgL_vz00_2458;

														BgL_vz00_2458 = CAR(BgL_l1199z00_2451);
														{	/* Eval/evaluate.scm 410 */
															BgL_ev_varz00_bglt BgL_new1098z00_2459;

															{	/* Eval/evaluate.scm 412 */
																BgL_ev_varz00_bglt BgL_new1097z00_2460;

																BgL_new1097z00_2460 =
																	((BgL_ev_varz00_bglt)
																	BREF(GC_MALLOC(sizeof(struct
																				BgL_ev_varz00_bgl))));
																{	/* Eval/evaluate.scm 412 */
																	long BgL_arg2281z00_2461;

																	{	/* Eval/evaluate.scm 412 */
																		long BgL_res2670z00_3259;

																		BgL_res2670z00_3259 =
																			BGL_CLASS_INDEX
																			(BGl_ev_varz00zz__evaluate_typesz00);
																		BgL_arg2281z00_2461 = BgL_res2670z00_3259;
																	}
																	BGL_OBJECT_CLASS_NUM_SET(
																		((BgL_objectz00_bglt) BgL_new1097z00_2460),
																		BgL_arg2281z00_2461);
																}
																{	/* Eval/evaluate.scm 412 */
																	BgL_objectz00_bglt BgL_auxz00_7659;

																	BgL_auxz00_7659 =
																		((BgL_objectz00_bglt) BgL_new1097z00_2460);
																	BGL_OBJECT_WIDENING_SET(BgL_auxz00_7659,
																		BFALSE);
																}
																BgL_new1098z00_2459 = BgL_new1097z00_2460;
															}
															((((BgL_ev_varz00_bglt)
																		CREF(BgL_new1098z00_2459))->BgL_namez00) =
																((obj_t) CAR(BgL_vz00_2458)), BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		CREF(BgL_new1098z00_2459))->BgL_effz00) =
																((obj_t) BFALSE), BUNSPEC);
															((((BgL_ev_varz00_bglt)
																		CREF(BgL_new1098z00_2459))->BgL_typez00) =
																((obj_t) CDR(BgL_vz00_2458)), BUNSPEC);
															BgL_arg2280z00_2457 = BgL_new1098z00_2459;
													}}
													{	/* Eval/evaluate.scm 409 */
														obj_t BgL_res2671z00_3266;

														BgL_res2671z00_3266 =
															MAKE_PAIR(((obj_t) BgL_arg2280z00_2457), BNIL);
														BgL_newtail1203z00_2455 = BgL_res2671z00_3266;
												}}
												SET_CDR(BgL_tail1202z00_2452, BgL_newtail1203z00_2455);
												{
													obj_t BgL_tail1202z00_7672;
													obj_t BgL_l1199z00_7670;

													BgL_l1199z00_7670 = CDR(BgL_l1199z00_2451);
													BgL_tail1202z00_7672 = BgL_newtail1203z00_2455;
													BgL_tail1202z00_2452 = BgL_tail1202z00_7672;
													BgL_l1199z00_2451 = BgL_l1199z00_7670;
													goto BgL_zc3anonymousza32276ze3z83_2453;
												}
											}
									}
								}
							BgL_bodyz00_2441 =
								BGl_makezd2dssslzd2functionzd2preludezd2zz__dssslz00
								(BgL_ez00_4981, BgL_formalsz00_2432,
								BGl_typezd2checkszd2zz__evaluatez00(BgL_argsz00_2438,
									BgL_argsz00_2438,
									BGl_typezd2resultzd2zz__evaluatez00(BgL_typez00_2435,
										BgL_bodyz00_2433, BgL_locz00_4980), BgL_locz00_4980,
									BgL_wherez00_2434), BGl_errorzd2envzd2zz__errorz00);
							{	/* Eval/evaluate.scm 145 */
								obj_t BgL__ortest_1067z00_3272;

								BgL__ortest_1067z00_3272 =
									BGl_getzd2sourcezd2locationz00zz__readerz00(BgL_bodyz00_2433);
								if (CBOOL(BgL__ortest_1067z00_3272))
									{	/* Eval/evaluate.scm 145 */
										BgL_nlocz00_2442 = BgL__ortest_1067z00_3272;
									}
								else
									{	/* Eval/evaluate.scm 145 */
										BgL_nlocz00_2442 = BgL_locz00_4980;
									}
							}
							{	/* Eval/evaluate.scm 418 */
								BgL_ev_absz00_bglt BgL_new1100z00_2443;

								{	/* Eval/evaluate.scm 419 */
									BgL_ev_absz00_bglt BgL_new1099z00_2445;

									BgL_new1099z00_2445 =
										((BgL_ev_absz00_bglt) BREF(GC_MALLOC(sizeof(struct
													BgL_ev_absz00_bgl))));
									{	/* Eval/evaluate.scm 419 */
										long BgL_arg2274z00_2446;

										{	/* Eval/evaluate.scm 419 */
											long BgL_res2672z00_3274;

											BgL_res2672z00_3274 =
												BGL_CLASS_INDEX(BGl_ev_absz00zz__evaluate_typesz00);
											BgL_arg2274z00_2446 = BgL_res2672z00_3274;
										}
										BGL_OBJECT_CLASS_NUM_SET(
											((BgL_objectz00_bglt) BgL_new1099z00_2445),
											BgL_arg2274z00_2446);
									}
									{	/* Eval/evaluate.scm 419 */
										BgL_objectz00_bglt BgL_auxz00_7683;

										BgL_auxz00_7683 =
											((BgL_objectz00_bglt) BgL_new1099z00_2445);
										BGL_OBJECT_WIDENING_SET(BgL_auxz00_7683, BFALSE);
									}
									BgL_new1100z00_2443 = BgL_new1099z00_2445;
								}
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_locz00) = ((obj_t) BgL_locz00_4980), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_wherez00) = ((obj_t) BgL_wherez00_2434), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_arityz00) = ((obj_t) BgL_arityz00_2439), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_varsz00) = ((obj_t) BgL_varsz00_2440), BUNSPEC);
								{
									BgL_ev_exprz00_bglt BgL_auxz00_7690;

									{	/* Eval/evaluate.scm 423 */
										obj_t BgL_arg2273z00_2444;

										BgL_arg2273z00_2444 =
											BGl_appendzd221011zd2zz__evaluatez00(BgL_varsz00_2440,
											BgL_localsz00_4982);
										BgL_auxz00_7690 =
											((BgL_ev_exprz00_bglt)
											BGl_convz00zz__evaluatez00(BgL_bodyz00_2441,
												BgL_arg2273z00_2444, BgL_globalsz00_4983, BTRUE,
												BgL_wherez00_2434, BgL_nlocz00_2442, ((bool_t) 0)));
									}
									((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
											BgL_bodyz00) =
										((BgL_ev_exprz00_bglt) BgL_auxz00_7690), BUNSPEC);
								}
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_siza7eza7) = ((int) (int) (((long) 0))), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_bindz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_freez00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_innerz00) = ((obj_t) BNIL), BUNSPEC);
								((((BgL_ev_absz00_bglt) CREF(BgL_new1100z00_2443))->
										BgL_boxesz00) = ((obj_t) BNIL), BUNSPEC);
								return BgL_new1100z00_2443;
							}
						}
					}
				}
			}
		}
	}



/* uconv/loc */
	obj_t BGl_uconvzf2loczf2zz__evaluatez00(obj_t BgL_wherez00_4990,
		obj_t BgL_globalsz00_4989, obj_t BgL_localsz00_4988, obj_t BgL_ez00_2512,
		obj_t BgL_locz00_2513)
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 378 */
			return
				BGl_convz00zz__evaluatez00(BgL_ez00_2512, BgL_localsz00_4988,
				BgL_globalsz00_4989, BFALSE, BgL_wherez00_4990, BgL_locz00_2513,
				((bool_t) 0));
		}
	}



/* object-init */
	obj_t BGl_objectzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
	}



/* generic-init */
	obj_t BGl_genericzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
	}



/* method-init */
	obj_t BGl_methodzd2initzd2zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			return BUNSPEC;
		}
	}



/* imported-modules-init */
	obj_t BGl_importedzd2moduleszd2initz00zz__evaluatez00()
	{
		AN_OBJECT;
		{	/* Eval/evaluate.scm 15 */
			BGl_modulezd2initializa7ationz75zz__typez00(((long) 477830603),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__errorz00(((long) 430898742),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__biglooz00(((long) 171970731),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__tvectorz00(((long) 135276775),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__structurez00(((long) 128218210),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bexitz00(((long) 340267792),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bignumz00(((long) 6519932),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__osz00(((long) 515402798),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__dssslz00(((long) 443936801),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__bitz00(((long) 15272113),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__paramz00(((long) 453939141),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__objectz00(((long) 1047446),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__threadz00(((long) 316564000),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long) 454272164),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_fixnumz00(((long)
					381113196), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonumz00(((long)
					231310901), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5_flonum_dtoaz00(((long)
					268155843), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_characters_6_6z00(((long)
					198620800), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)
					473309430), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_booleans_6_1z00(((long) 459519430),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long) 460263214),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_strings_6_7z00(((long) 482314420),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)
					47127928), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)
					376927882), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long) 434147503),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long) 261215800),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)
					116655667), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__r5_control_features_6_4z00(((long)
					228151370), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__ppz00(((long) 233942021),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__readerz00(((long) 220648206),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__prognz00(((long) 177147622),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__expandz00(((long) 414007149),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evenvz00(((long) 23062368),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evcompilez00(((long) 492754569),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__everrorz00(((long) 375872221),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evmodulez00(((long) 6183155),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_typesz00(((long) 0),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_avarz00(((long) 483789130),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_fsiza7eza7(((long)
					121298760), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			BGl_modulezd2initializa7ationz75zz__evaluate_uncompz00(((long) 193509656),
				BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
			return BGl_modulezd2initializa7ationz75zz__evaluate_compz00(((long)
					444000678), BSTRING_TO_STRING(BGl_string3064z00zz__evaluatez00));
		}
	}

#ifdef __cplusplus
}
#endif
